#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2634
#define SYMBOL_COUNT 297
#define ALIAS_COUNT 8
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_await = 25,
  anon_sym_in = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_instanceof = 86,
  anon_sym_BANG = 87,
  anon_sym_TILDE = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_string_token1 = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_string_token2 = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  anon_sym_target = 105,
  sym_this = 106,
  sym_super = 107,
  sym_true = 108,
  sym_false = 109,
  sym_null = 110,
  sym_undefined = 111,
  anon_sym_AT = 112,
  anon_sym_static = 113,
  anon_sym_abstract = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  anon_sym_declare = 117,
  anon_sym_public = 118,
  anon_sym_private = 119,
  anon_sym_protected = 120,
  anon_sym_module = 121,
  anon_sym_any = 122,
  anon_sym_number = 123,
  anon_sym_boolean = 124,
  anon_sym_string = 125,
  anon_sym_symbol = 126,
  anon_sym_require = 127,
  anon_sym_implements = 128,
  anon_sym_global = 129,
  anon_sym_interface = 130,
  anon_sym_extends = 131,
  anon_sym_enum = 132,
  sym_readonly = 133,
  anon_sym_is = 134,
  anon_sym_keyof = 135,
  anon_sym_LBRACE_PIPE = 136,
  anon_sym_PIPE_RBRACE = 137,
  sym__automatic_semicolon = 138,
  sym__template_chars = 139,
  sym_program = 140,
  sym_export_statement = 141,
  sym_export_clause = 142,
  sym__import_export_specifier = 143,
  sym__declaration = 144,
  sym_import = 145,
  sym_import_statement = 146,
  sym_import_clause = 147,
  sym__from_clause = 148,
  sym_namespace_import = 149,
  sym_named_imports = 150,
  sym_expression_statement = 151,
  sym_variable_declaration = 152,
  sym_lexical_declaration = 153,
  sym_variable_declarator = 154,
  sym_statement_block = 155,
  sym_if_statement = 156,
  sym_switch_statement = 157,
  sym_for_statement = 158,
  sym_for_in_statement = 159,
  sym__for_header = 160,
  sym_while_statement = 161,
  sym_do_statement = 162,
  sym_try_statement = 163,
  sym_with_statement = 164,
  sym_break_statement = 165,
  sym_continue_statement = 166,
  sym_debugger_statement = 167,
  sym_return_statement = 168,
  sym_throw_statement = 169,
  sym_empty_statement = 170,
  sym_labeled_statement = 171,
  sym_switch_body = 172,
  sym_switch_case = 173,
  sym_switch_default = 174,
  sym_catch_clause = 175,
  sym_finally_clause = 176,
  sym_parenthesized_expression = 177,
  sym__expression = 178,
  sym_yield_expression = 179,
  sym_object = 180,
  sym_assignment_pattern = 181,
  sym_array = 182,
  sym_nested_identifier = 183,
  sym_class = 184,
  sym_class_declaration = 185,
  sym_class_heritage = 186,
  sym_function = 187,
  sym_function_declaration = 188,
  sym_generator_function = 189,
  sym_generator_function_declaration = 190,
  sym_arrow_function = 191,
  sym__call_signature = 192,
  sym_call_expression = 193,
  sym_new_expression = 194,
  sym_await_expression = 195,
  sym_member_expression = 196,
  sym_subscript_expression = 197,
  sym_assignment_expression = 198,
  sym_augmented_assignment_expression = 199,
  sym__initializer = 200,
  sym_spread_element = 201,
  sym_ternary_expression = 202,
  sym_binary_expression = 203,
  sym_unary_expression = 204,
  sym_update_expression = 205,
  sym_sequence_expression = 206,
  sym_string = 207,
  sym_template_string = 208,
  sym_template_substitution = 209,
  sym_regex = 210,
  sym_meta_property = 211,
  sym_arguments = 212,
  sym_decorator = 213,
  sym_decorator_member_expression = 214,
  sym_decorator_call_expression = 215,
  sym_class_body = 216,
  sym_public_field_definition = 217,
  sym_formal_parameters = 218,
  sym_rest_parameter = 219,
  sym_method_definition = 220,
  sym_pair = 221,
  sym__property_name = 222,
  sym_computed_property_name = 223,
  sym_non_null_expression = 224,
  sym_method_signature = 225,
  sym_abstract_method_signature = 226,
  sym_function_signature = 227,
  sym_type_assertion = 228,
  sym_as_expression = 229,
  sym_import_require_clause = 230,
  sym_implements_clause = 231,
  sym_ambient_declaration = 232,
  sym_abstract_class_declaration = 233,
  sym_module = 234,
  sym_internal_module = 235,
  sym__module = 236,
  sym_import_alias = 237,
  sym_nested_type_identifier = 238,
  sym_interface_declaration = 239,
  sym_extends_clause = 240,
  sym_enum_declaration = 241,
  sym_enum_body = 242,
  sym_enum_assignment = 243,
  sym_type_alias_declaration = 244,
  sym_accessibility_modifier = 245,
  sym_required_parameter = 246,
  sym_optional_parameter = 247,
  sym__parameter_name = 248,
  sym_type_annotation = 249,
  sym__type = 250,
  sym_constructor_type = 251,
  sym__primary_type = 252,
  sym_generic_type = 253,
  sym_type_predicate = 254,
  sym_type_query = 255,
  sym_index_type_query = 256,
  sym_lookup_type = 257,
  sym_mapped_type_clause = 258,
  sym_literal_type = 259,
  sym__number = 260,
  sym_existential_type = 261,
  sym_flow_maybe_type = 262,
  sym_parenthesized_type = 263,
  sym_predefined_type = 264,
  sym_type_arguments = 265,
  sym_object_type = 266,
  sym_property_signature = 267,
  sym_type_parameters = 268,
  sym_type_parameter = 269,
  sym_default_type = 270,
  sym_constraint = 271,
  sym_construct_signature = 272,
  sym_index_signature = 273,
  sym_array_type = 274,
  sym_tuple_type = 275,
  sym_union_type = 276,
  sym_intersection_type = 277,
  sym_function_type = 278,
  aux_sym_program_repeat1 = 279,
  aux_sym_export_statement_repeat1 = 280,
  aux_sym_export_clause_repeat1 = 281,
  aux_sym_named_imports_repeat1 = 282,
  aux_sym_variable_declaration_repeat1 = 283,
  aux_sym_switch_body_repeat1 = 284,
  aux_sym_object_repeat1 = 285,
  aux_sym_array_repeat1 = 286,
  aux_sym_string_repeat1 = 287,
  aux_sym_string_repeat2 = 288,
  aux_sym_template_string_repeat1 = 289,
  aux_sym_class_body_repeat1 = 290,
  aux_sym_formal_parameters_repeat1 = 291,
  aux_sym_implements_clause_repeat1 = 292,
  aux_sym_extends_clause_repeat1 = 293,
  aux_sym_enum_body_repeat1 = 294,
  aux_sym_object_type_repeat1 = 295,
  aux_sym_type_parameters_repeat1 = 296,
  alias_sym_type_identifier = 297,
  alias_sym_array_pattern = 298,
  alias_sym_shorthand_property_identifier = 299,
  alias_sym_property_identifier = 300,
  alias_sym_object_pattern = 301,
  alias_sym_import_specifier = 302,
  alias_sym_export_specifier = 303,
  alias_sym_statement_identifier = 304,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_condition = 6,
  field_consequence = 7,
  field_constructor = 8,
  field_declaration = 9,
  field_decorator = 10,
  field_finalizer = 11,
  field_flags = 12,
  field_function = 13,
  field_handler = 14,
  field_increment = 15,
  field_index = 16,
  field_initializer = 17,
  field_key = 18,
  field_label = 19,
  field_left = 20,
  field_module = 21,
  field_name = 22,
  field_object = 23,
  field_operator = 24,
  field_parameter = 25,
  field_parameters = 26,
  field_pattern = 27,
  field_property = 28,
  field_return_type = 29,
  field_right = 30,
  field_source = 31,
  field_type = 32,
  field_type_arguments = 33,
  field_type_parameters = 34,
  field_value = 35,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 2},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 4, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 1},
  [16] = {.index = 10, .length = 1},
  [17] = {.index = 10, .length = 1},
  [18] = {.index = 11, .length = 1},
  [19] = {.index = 12, .length = 2},
  [20] = {.index = 14, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 20, .length = 2},
  [28] = {.index = 22, .length = 2},
  [29] = {.index = 25, .length = 2},
  [30] = {.index = 5, .length = 2},
  [31] = {.index = 27, .length = 1},
  [32] = {.index = 28, .length = 2},
  [33] = {.index = 30, .length = 2},
  [34] = {.index = 28, .length = 2},
  [35] = {.index = 30, .length = 2},
  [36] = {.index = 28, .length = 2},
  [37] = {.index = 30, .length = 2},
  [38] = {.index = 32, .length = 3},
  [39] = {.index = 35, .length = 2},
  [40] = {.index = 35, .length = 2},
  [41] = {.index = 37, .length = 2},
  [42] = {.index = 39, .length = 2},
  [43] = {.index = 41, .length = 3},
  [45] = {.index = 44, .length = 1},
  [46] = {.index = 45, .length = 2},
  [48] = {.index = 47, .length = 2},
  [51] = {.index = 49, .length = 1},
  [52] = {.index = 50, .length = 2},
  [53] = {.index = 52, .length = 2},
  [54] = {.index = 54, .length = 2},
  [55] = {.index = 56, .length = 1},
  [56] = {.index = 57, .length = 4},
  [57] = {.index = 61, .length = 2},
  [58] = {.index = 61, .length = 2},
  [59] = {.index = 63, .length = 2},
  [60] = {.index = 65, .length = 3},
  [61] = {.index = 22, .length = 2},
  [62] = {.index = 68, .length = 4},
  [63] = {.index = 72, .length = 3},
  [64] = {.index = 22, .length = 2},
  [65] = {.index = 75, .length = 2},
  [66] = {.index = 77, .length = 1},
  [67] = {.index = 78, .length = 3},
  [68] = {.index = 81, .length = 2},
  [69] = {.index = 78, .length = 3},
  [70] = {.index = 78, .length = 3},
  [71] = {.index = 83, .length = 2},
  [72] = {.index = 85, .length = 2},
  [73] = {.index = 87, .length = 3},
  [74] = {.index = 81, .length = 2},
  [75] = {.index = 90, .length = 1},
  [76] = {.index = 91, .length = 2},
  [77] = {.index = 93, .length = 1},
  [78] = {.index = 94, .length = 3},
  [79] = {.index = 97, .length = 4},
  [80] = {.index = 101, .length = 2},
  [81] = {.index = 22, .length = 2},
  [82] = {.index = 103, .length = 2},
  [83] = {.index = 105, .length = 5},
  [84] = {.index = 110, .length = 1},
  [88] = {.index = 111, .length = 2},
  [89] = {.index = 111, .length = 2},
  [90] = {.index = 113, .length = 4},
  [91] = {.index = 117, .length = 4},
  [92] = {.index = 121, .length = 3},
  [93] = {.index = 124, .length = 2},
  [94] = {.index = 126, .length = 2},
  [95] = {.index = 128, .length = 4},
  [96] = {.index = 132, .length = 5},
  [97] = {.index = 137, .length = 1},
  [98] = {.index = 91, .length = 2},
  [99] = {.index = 138, .length = 1},
  [100] = {.index = 139, .length = 3},
  [101] = {.index = 142, .length = 2},
  [102] = {.index = 144, .length = 3},
  [103] = {.index = 147, .length = 3},
  [104] = {.index = 150, .length = 3},
  [105] = {.index = 153, .length = 2},
  [106] = {.index = 155, .length = 3},
  [107] = {.index = 158, .length = 2},
  [108] = {.index = 160, .length = 1},
  [109] = {.index = 161, .length = 2},
  [110] = {.index = 163, .length = 1},
  [111] = {.index = 164, .length = 2},
  [112] = {.index = 166, .length = 2},
  [113] = {.index = 168, .length = 4},
  [114] = {.index = 172, .length = 2},
  [115] = {.index = 174, .length = 2},
  [116] = {.index = 176, .length = 5},
  [117] = {.index = 181, .length = 1},
  [118] = {.index = 182, .length = 1},
  [119] = {.index = 183, .length = 1},
  [120] = {.index = 184, .length = 4},
  [121] = {.index = 188, .length = 5},
  [122] = {.index = 193, .length = 4},
  [123] = {.index = 197, .length = 6},
  [124] = {.index = 203, .length = 2},
  [125] = {.index = 205, .length = 3},
  [126] = {.index = 208, .length = 2},
  [127] = {.index = 210, .length = 3},
  [128] = {.index = 213, .length = 4},
  [129] = {.index = 217, .length = 3},
  [130] = {.index = 220, .length = 3},
  [131] = {.index = 223, .length = 3},
  [132] = {.index = 226, .length = 2},
  [133] = {.index = 228, .length = 2},
  [134] = {.index = 228, .length = 2},
  [135] = {.index = 230, .length = 3},
  [136] = {.index = 228, .length = 2},
  [137] = {.index = 228, .length = 2},
  [138] = {.index = 233, .length = 4},
  [139] = {.index = 237, .length = 2},
  [140] = {.index = 239, .length = 2},
  [141] = {.index = 241, .length = 2},
  [142] = {.index = 243, .length = 2},
  [143] = {.index = 245, .length = 3},
  [144] = {.index = 248, .length = 1},
  [145] = {.index = 249, .length = 3},
  [147] = {.index = 252, .length = 5},
  [148] = {.index = 257, .length = 2},
  [149] = {.index = 259, .length = 5},
  [150] = {.index = 264, .length = 4},
  [151] = {.index = 268, .length = 2},
  [152] = {.index = 268, .length = 2},
  [153] = {.index = 268, .length = 2},
  [154] = {.index = 268, .length = 2},
  [155] = {.index = 270, .length = 4},
  [156] = {.index = 274, .length = 4},
  [157] = {.index = 278, .length = 2},
  [158] = {.index = 280, .length = 2},
  [159] = {.index = 282, .length = 3},
  [160] = {.index = 285, .length = 3},
  [161] = {.index = 288, .length = 4},
  [162] = {.index = 292, .length = 2},
  [163] = {.index = 294, .length = 2},
  [164] = {.index = 296, .length = 5},
  [165] = {.index = 301, .length = 2},
  [166] = {.index = 301, .length = 2},
  [167] = {.index = 301, .length = 2},
  [168] = {.index = 303, .length = 3},
  [169] = {.index = 306, .length = 3},
  [170] = {.index = 309, .length = 4},
  [171] = {.index = 313, .length = 4},
  [172] = {.index = 317, .length = 2},
  [173] = {.index = 319, .length = 2},
  [174] = {.index = 321, .length = 3},
  [175] = {.index = 324, .length = 5},
  [176] = {.index = 329, .length = 5},
  [177] = {.index = 334, .length = 4},
  [178] = {.index = 338, .length = 4},
  [179] = {.index = 342, .length = 3},
  [180] = {.index = 345, .length = 5},
  [181] = {.index = 350, .length = 5},
  [182] = {.index = 355, .length = 4},
  [183] = {.index = 359, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0},
  [1] =
    {field_decorator, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_name, 0},
  [5] =
    {field_arguments, 1},
    {field_function, 0},
  [7] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [9] =
    {field_body, 1},
  [10] =
    {field_constructor, 1},
  [11] =
    {field_declaration, 1},
  [12] =
    {field_argument, 0},
    {field_operator, 1},
  [14] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [16] =
    {field_parameters, 0},
    {field_return_type, 1},
  [18] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [20] =
    {field_body, 2},
    {field_parameter, 0},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_label, 0},
  [25] =
    {field_object, 0},
    {field_property, 2},
  [27] =
    {field_label, 1},
  [28] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [30] =
    {field_name, 0},
    {field_type, 1},
  [32] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [35] =
    {field_body, 2},
    {field_name, 1},
  [37] =
    {field_condition, 1},
    {field_consequence, 2},
  [39] =
    {field_body, 1},
    {field_name, 0},
  [41] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [44] =
    {field_body, 2},
  [45] =
    {field_body, 2},
    {field_type_parameters, 1},
  [47] =
    {field_body, 2},
    {field_value, 1},
  [49] =
    {field_value, 1, .inherited = true},
  [50] =
    {field_body, 2},
    {field_condition, 1},
  [52] =
    {field_body, 1},
    {field_handler, 2},
  [54] =
    {field_body, 1},
    {field_finalizer, 2},
  [56] =
    {field_pattern, 1},
  [57] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [61] =
    {field_arguments, 2},
    {field_constructor, 1},
  [63] =
    {field_body, 2},
    {field_object, 1},
  [65] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [68] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [72] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [75] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [77] =
    {field_value, 1},
  [78] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [81] =
    {field_body, 3},
    {field_name, 2},
  [83] =
    {field_index, 2},
    {field_object, 0},
  [85] =
    {field_body, 3},
    {field_name, 1},
  [87] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [90] =
    {field_name, 1},
  [91] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [93] =
    {field_source, 1},
  [94] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [97] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [101] =
    {field_body, 3},
    {field_type_parameters, 1},
  [103] =
    {field_key, 0},
    {field_value, 2},
  [105] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [110] =
    {field_value, 2, .inherited = true},
  [111] =
    {field_body, 3},
    {field_parameter, 1},
  [113] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [117] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [121] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [124] =
    {field_module, 0},
    {field_name, 2},
  [126] =
    {field_flags, 3},
    {field_pattern, 1},
  [128] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [132] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [137] =
    {field_source, 2, .inherited = true},
  [138] =
    {field_value, 2},
  [139] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [142] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [144] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [147] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [150] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [153] =
    {field_body, 4},
    {field_name, 2},
  [155] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [158] =
    {field_name, 1},
    {field_value, 3},
  [160] =
    {field_source, 3, .inherited = true},
  [161] =
    {field_alias, 2},
    {field_name, 0},
  [163] =
    {field_name, 2},
  [164] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [166] =
    {field_name, 1},
    {field_type, 2},
  [168] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [172] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [174] =
    {field_name, 0},
    {field_type, 2},
  [176] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [181] =
    {field_decorator, 1, .inherited = true},
  [182] =
    {field_decorator, 2, .inherited = true},
  [183] =
    {field_value, 3, .inherited = true},
  [184] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [188] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [193] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [197] =
    {field_parameters, 0, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [203] =
    {field_body, 1},
    {field_condition, 3},
  [205] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [208] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [210] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [213] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [217] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [220] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [223] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [226] =
    {field_alias, 3},
    {field_name, 1},
  [228] =
    {field_left, 1},
    {field_right, 3},
  [230] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [233] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [237] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [239] =
    {field_name, 2},
    {field_type, 3},
  [241] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [243] =
    {field_name, 1},
    {field_type, 3},
  [245] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [248] =
    {field_name, 3},
  [249] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [252] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [257] =
    {field_decorator, 1, .inherited = true},
    {field_decorator, 3, .inherited = true},
  [259] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [264] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [268] =
    {field_left, 2},
    {field_right, 4},
  [270] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [274] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [278] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [280] =
    {field_name, 2},
    {field_type, 4},
  [282] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [285] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [288] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [292] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [294] =
    {field_name, 3},
    {field_type, 4},
  [296] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [301] =
    {field_body, 4},
    {field_parameter, 2},
  [303] =
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [306] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [309] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [313] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [317] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [319] =
    {field_name, 3},
    {field_type, 5},
  [321] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [324] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [329] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [334] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [338] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [342] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [345] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [350] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [355] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [359] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
};

static TSSymbol ts_alias_sequences[184][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_identifier,
  },
  [4] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_object_pattern,
  },
  [8] = {
    [0] = alias_sym_array_pattern,
  },
  [12] = {
    [0] = alias_sym_property_identifier,
  },
  [13] = {
    [0] = alias_sym_object_pattern,
  },
  [14] = {
    [0] = alias_sym_array_pattern,
  },
  [15] = {
    [0] = alias_sym_type_identifier,
  },
  [17] = {
    [1] = sym_identifier,
  },
  [25] = {
    [0] = alias_sym_statement_identifier,
  },
  [26] = {
    [2] = alias_sym_property_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [28] = {
    [0] = sym_identifier,
  },
  [29] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [30] = {
    [0] = sym_identifier,
  },
  [31] = {
    [1] = alias_sym_statement_identifier,
  },
  [34] = {
    [0] = alias_sym_object_pattern,
  },
  [35] = {
    [0] = alias_sym_object_pattern,
  },
  [36] = {
    [0] = alias_sym_array_pattern,
  },
  [37] = {
    [0] = alias_sym_array_pattern,
  },
  [39] = {
    [1] = alias_sym_type_identifier,
  },
  [44] = {
    [1] = alias_sym_type_identifier,
  },
  [47] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [49] = {
    [1] = alias_sym_object_pattern,
  },
  [50] = {
    [1] = alias_sym_array_pattern,
  },
  [58] = {
    [1] = sym_identifier,
  },
  [61] = {
    [0] = alias_sym_array_pattern,
  },
  [64] = {
    [0] = alias_sym_object_pattern,
  },
  [69] = {
    [0] = alias_sym_object_pattern,
  },
  [70] = {
    [0] = alias_sym_array_pattern,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
  },
  [73] = {
    [1] = alias_sym_type_identifier,
  },
  [74] = {
    [2] = alias_sym_type_identifier,
  },
  [76] = {
    [1] = alias_sym_import_specifier,
  },
  [81] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [85] = {
    [2] = sym_identifier,
  },
  [86] = {
    [2] = alias_sym_object_pattern,
  },
  [87] = {
    [2] = alias_sym_array_pattern,
  },
  [89] = {
    [1] = sym_identifier,
  },
  [93] = {
    [2] = alias_sym_type_identifier,
  },
  [98] = {
    [1] = alias_sym_export_specifier,
  },
  [100] = {
    [2] = alias_sym_type_identifier,
  },
  [103] = {
    [1] = alias_sym_type_identifier,
  },
  [105] = {
    [2] = alias_sym_type_identifier,
  },
  [106] = {
    [2] = alias_sym_type_identifier,
  },
  [107] = {
    [1] = alias_sym_type_identifier,
  },
  [127] = {
    [2] = alias_sym_type_identifier,
  },
  [128] = {
    [2] = alias_sym_type_identifier,
  },
  [130] = {
    [2] = alias_sym_type_identifier,
  },
  [131] = {
    [1] = alias_sym_type_identifier,
  },
  [134] = {
    [1] = sym_identifier,
  },
  [136] = {
    [1] = alias_sym_object_pattern,
  },
  [137] = {
    [1] = alias_sym_array_pattern,
  },
  [146] = {
    [3] = alias_sym_property_identifier,
  },
  [150] = {
    [2] = alias_sym_type_identifier,
  },
  [152] = {
    [2] = sym_identifier,
  },
  [153] = {
    [2] = alias_sym_object_pattern,
  },
  [154] = {
    [2] = alias_sym_array_pattern,
  },
  [166] = {
    [2] = alias_sym_object_pattern,
  },
  [167] = {
    [2] = alias_sym_array_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0) ADVANCE(58);
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '$') ADVANCE(177);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '=') ADVANCE(63);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 1:
      if (lookahead == 0) ADVANCE(58);
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '$') ADVANCE(177);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '=') ADVANCE(63);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 2:
      if (lookahead == 0) ADVANCE(58);
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '%') ADVANCE(124);
      if (lookahead == '&') ADVANCE(109);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(84);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(63);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(111);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(178);
      END_STATE();
    case 3:
      if (lookahead == 0) ADVANCE(58);
      if (lookahead == '!') ADVANCE(134);
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '#') ADVANCE(12);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(83);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(74);
      if (lookahead == '=') ADVANCE(64);
      if (lookahead == '>') ADVANCE(77);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(117);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(178);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(144);
      if (lookahead != 0) ADVANCE(145);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(140);
      if (lookahead == '\r') ADVANCE(154);
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(158);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '/') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(7);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(151);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r') ADVANCE(155);
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(158);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(164);
      if (lookahead != 0) ADVANCE(165);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(120);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(84);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(75);
      if (lookahead == '=') ADVANCE(63);
      if (lookahead == '>') ADVANCE(78);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(112);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(114);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '~') ADVANCE(136);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '#') ADVANCE(178);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '%') ADVANCE(124);
      if (lookahead == '&') ADVANCE(109);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(111);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(178);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(135);
      if (lookahead == '%') ADVANCE(124);
      if (lookahead == '&') ADVANCE(109);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(119);
      if (lookahead == ',') ADVANCE(66);
      if (lookahead == '-') ADVANCE(122);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == '/') ADVANCE(80);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(70);
      if (lookahead == '<') ADVANCE(76);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(79);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(111);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(178);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(59);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '&') ADVANCE(108);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '0') ADVANCE(168);
      if (lookahead == '<') ADVANCE(74);
      if (lookahead == '>') ADVANCE(77);
      if (lookahead == '?') ADVANCE(99);
      if (lookahead == '@') ADVANCE(179);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '{') ADVANCE(65);
      if (lookahead == '|') ADVANCE(113);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '=' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(178);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(139);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 16:
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '`') ADVANCE(161);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      END_STATE();
    case 17:
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead != 0) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(98);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 25:
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == 'u') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(158);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 27:
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(158);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 29:
      if (lookahead == '{') ADVANCE(162);
      END_STATE();
    case 30:
      if (lookahead == '{') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 31:
      if (lookahead == '{') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(174);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(170);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(171);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(169);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(173);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(174);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(153);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(165);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(127);
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(126);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(129);
      if (lookahead == '>') ADVANCE(85);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(85);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(180);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(106);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '>') ADVANCE(102);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '=') ADVANCE(89);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(94);
      if (lookahead == '>') ADVANCE(105);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(100);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '=') ADVANCE(92);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(181);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(101);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(101);
      if (lookahead == '}') ADVANCE(181);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(181);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(137);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == '=') ADVANCE(86);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(138);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(138);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(143);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(145);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(144);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(140);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(147);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(178);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(153);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(157);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(160);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(18);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(165);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(27);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(178);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(176);
      if (lookahead == '0') ADVANCE(173);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(37);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(45);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(167);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(169);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(176);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(169);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(167);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == '_') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(175);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '{') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 't') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'w') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'r') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(69);
      if (lookahead == 'i') ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(82);
      if (lookahead == 'c') ADVANCE(83);
      if (lookahead == 'f') ADVANCE(84);
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(88);
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(98);
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd') ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w') ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(105);
      if (lookahead == 'm') ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b') ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'q') ADVANCE(111);
      if (lookahead == 't') ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'y') ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c') ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(139);
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm') ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's') ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b') ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v') ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l') ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd') ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h') ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c') ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k') ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h') ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's') ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g') ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f') ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l') ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i') ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o') ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w') ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f') ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e') ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd') ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a') ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g') ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm') ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n') ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f') ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e') ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p') ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c') ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r') ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f') ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n') ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u') ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's') ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y') ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e') ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n') ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't') ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r') ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c') ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't') ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e') ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's') ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f') ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 3},
  [2] = {.lex_state = 9, .external_lex_state = 2},
  [3] = {.lex_state = 15, .external_lex_state = 3},
  [4] = {.lex_state = 0, .external_lex_state = 2},
  [5] = {.lex_state = 9, .external_lex_state = 2},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 9, .external_lex_state = 2},
  [9] = {.lex_state = 3, .external_lex_state = 2},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 2, .external_lex_state = 2},
  [12] = {.lex_state = 3, .external_lex_state = 2},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3, .external_lex_state = 2},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 2, .external_lex_state = 2},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 9, .external_lex_state = 2},
  [23] = {.lex_state = 2, .external_lex_state = 2},
  [24] = {.lex_state = 9, .external_lex_state = 2},
  [25] = {.lex_state = 4},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 9, .external_lex_state = 2},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 9, .external_lex_state = 2},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 9, .external_lex_state = 2},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 6},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 13},
  [43] = {.lex_state = 8},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 9, .external_lex_state = 2},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 0},
  [50] = {.lex_state = 3},
  [51] = {.lex_state = 2, .external_lex_state = 2},
  [52] = {.lex_state = 2, .external_lex_state = 2},
  [53] = {.lex_state = 9, .external_lex_state = 2},
  [54] = {.lex_state = 2, .external_lex_state = 2},
  [55] = {.lex_state = 2, .external_lex_state = 2},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 0, .external_lex_state = 2},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 2, .external_lex_state = 2},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 3},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 2, .external_lex_state = 2},
  [73] = {.lex_state = 15, .external_lex_state = 3},
  [74] = {.lex_state = 3},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 3},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 3},
  [82] = {.lex_state = 9, .external_lex_state = 2},
  [83] = {.lex_state = 9, .external_lex_state = 2},
  [84] = {.lex_state = 3},
  [85] = {.lex_state = 3},
  [86] = {.lex_state = 9, .external_lex_state = 2},
  [87] = {.lex_state = 9, .external_lex_state = 2},
  [88] = {.lex_state = 3},
  [89] = {.lex_state = 2, .external_lex_state = 2},
  [90] = {.lex_state = 9, .external_lex_state = 2},
  [91] = {.lex_state = 2, .external_lex_state = 2},
  [92] = {.lex_state = 3},
  [93] = {.lex_state = 2, .external_lex_state = 2},
  [94] = {.lex_state = 3},
  [95] = {.lex_state = 0, .external_lex_state = 2},
  [96] = {.lex_state = 0, .external_lex_state = 2},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 0, .external_lex_state = 2},
  [99] = {.lex_state = 0, .external_lex_state = 2},
  [100] = {.lex_state = 0, .external_lex_state = 2},
  [101] = {.lex_state = 3},
  [102] = {.lex_state = 13},
  [103] = {.lex_state = 3},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 2, .external_lex_state = 2},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 0, .external_lex_state = 2},
  [108] = {.lex_state = 2, .external_lex_state = 2},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 3},
  [112] = {.lex_state = 0, .external_lex_state = 2},
  [113] = {.lex_state = 2, .external_lex_state = 2},
  [114] = {.lex_state = 3},
  [115] = {.lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 2, .external_lex_state = 2},
  [118] = {.lex_state = 0, .external_lex_state = 2},
  [119] = {.lex_state = 2, .external_lex_state = 2},
  [120] = {.lex_state = 3},
  [121] = {.lex_state = 3},
  [122] = {.lex_state = 3},
  [123] = {.lex_state = 3},
  [124] = {.lex_state = 3},
  [125] = {.lex_state = 3},
  [126] = {.lex_state = 3},
  [127] = {.lex_state = 0, .external_lex_state = 2},
  [128] = {.lex_state = 3},
  [129] = {.lex_state = 2, .external_lex_state = 2},
  [130] = {.lex_state = 2, .external_lex_state = 2},
  [131] = {.lex_state = 2, .external_lex_state = 2},
  [132] = {.lex_state = 2, .external_lex_state = 2},
  [133] = {.lex_state = 4},
  [134] = {.lex_state = 2, .external_lex_state = 2},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 0},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 2, .external_lex_state = 2},
  [141] = {.lex_state = 2},
  [142] = {.lex_state = 0},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 13},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 0},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 2, .external_lex_state = 2},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 0},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 9, .external_lex_state = 2},
  [167] = {.lex_state = 9, .external_lex_state = 2},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 9, .external_lex_state = 2},
  [171] = {.lex_state = 9, .external_lex_state = 2},
  [172] = {.lex_state = 9, .external_lex_state = 2},
  [173] = {.lex_state = 9, .external_lex_state = 2},
  [174] = {.lex_state = 2, .external_lex_state = 2},
  [175] = {.lex_state = 9, .external_lex_state = 2},
  [176] = {.lex_state = 9, .external_lex_state = 2},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 9, .external_lex_state = 2},
  [180] = {.lex_state = 9, .external_lex_state = 2},
  [181] = {.lex_state = 9, .external_lex_state = 2},
  [182] = {.lex_state = 2, .external_lex_state = 2},
  [183] = {.lex_state = 9, .external_lex_state = 2},
  [184] = {.lex_state = 0},
  [185] = {.lex_state = 2, .external_lex_state = 2},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 2, .external_lex_state = 2},
  [189] = {.lex_state = 0},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 0},
  [192] = {.lex_state = 9},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 9},
  [195] = {.lex_state = 3},
  [196] = {.lex_state = 9},
  [197] = {.lex_state = 9},
  [198] = {.lex_state = 9},
  [199] = {.lex_state = 0},
  [200] = {.lex_state = 2},
  [201] = {.lex_state = 9},
  [202] = {.lex_state = 0},
  [203] = {.lex_state = 0},
  [204] = {.lex_state = 0},
  [205] = {.lex_state = 2},
  [206] = {.lex_state = 2},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 2},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 0},
  [212] = {.lex_state = 3},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 0},
  [215] = {.lex_state = 0, .external_lex_state = 2},
  [216] = {.lex_state = 3},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 13},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 13},
  [226] = {.lex_state = 13},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 0},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 13},
  [234] = {.lex_state = 13},
  [235] = {.lex_state = 0},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 0},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 0},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 15},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 9, .external_lex_state = 2},
  [247] = {.lex_state = 2, .external_lex_state = 2},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 9, .external_lex_state = 2},
  [250] = {.lex_state = 9, .external_lex_state = 2},
  [251] = {.lex_state = 9, .external_lex_state = 2},
  [252] = {.lex_state = 9, .external_lex_state = 2},
  [253] = {.lex_state = 9, .external_lex_state = 2},
  [254] = {.lex_state = 2},
  [255] = {.lex_state = 2, .external_lex_state = 2},
  [256] = {.lex_state = 2, .external_lex_state = 2},
  [257] = {.lex_state = 2, .external_lex_state = 2},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3, .external_lex_state = 2},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 2, .external_lex_state = 2},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 13},
  [278] = {.lex_state = 2, .external_lex_state = 2},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 2, .external_lex_state = 2},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 2, .external_lex_state = 2},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 0},
  [286] = {.lex_state = 13},
  [287] = {.lex_state = 0},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 2, .external_lex_state = 2},
  [294] = {.lex_state = 2, .external_lex_state = 2},
  [295] = {.lex_state = 2, .external_lex_state = 2},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 2, .external_lex_state = 2},
  [298] = {.lex_state = 9, .external_lex_state = 2},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 2},
  [301] = {.lex_state = 2, .external_lex_state = 2},
  [302] = {.lex_state = 15, .external_lex_state = 3},
  [303] = {.lex_state = 2, .external_lex_state = 2},
  [304] = {.lex_state = 2, .external_lex_state = 2},
  [305] = {.lex_state = 2, .external_lex_state = 2},
  [306] = {.lex_state = 2, .external_lex_state = 2},
  [307] = {.lex_state = 9, .external_lex_state = 2},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 3},
  [317] = {.lex_state = 3},
  [318] = {.lex_state = 2, .external_lex_state = 2},
  [319] = {.lex_state = 0},
  [320] = {.lex_state = 0},
  [321] = {.lex_state = 3},
  [322] = {.lex_state = 3},
  [323] = {.lex_state = 3},
  [324] = {.lex_state = 3},
  [325] = {.lex_state = 3},
  [326] = {.lex_state = 3},
  [327] = {.lex_state = 0, .external_lex_state = 2},
  [328] = {.lex_state = 0, .external_lex_state = 2},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0, .external_lex_state = 2},
  [331] = {.lex_state = 0, .external_lex_state = 2},
  [332] = {.lex_state = 3},
  [333] = {.lex_state = 3},
  [334] = {.lex_state = 0, .external_lex_state = 2},
  [335] = {.lex_state = 0, .external_lex_state = 2},
  [336] = {.lex_state = 0, .external_lex_state = 2},
  [337] = {.lex_state = 0},
  [338] = {.lex_state = 2},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 2, .external_lex_state = 2},
  [341] = {.lex_state = 2},
  [342] = {.lex_state = 0},
  [343] = {.lex_state = 0},
  [344] = {.lex_state = 2, .external_lex_state = 2},
  [345] = {.lex_state = 3},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 0},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 3},
  [352] = {.lex_state = 3},
  [353] = {.lex_state = 2, .external_lex_state = 2},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 13},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 0, .external_lex_state = 2},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 2, .external_lex_state = 2},
  [373] = {.lex_state = 2, .external_lex_state = 2},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 9, .external_lex_state = 2},
  [376] = {.lex_state = 9, .external_lex_state = 2},
  [377] = {.lex_state = 9, .external_lex_state = 2},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 9, .external_lex_state = 2},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 9, .external_lex_state = 2},
  [382] = {.lex_state = 9, .external_lex_state = 2},
  [383] = {.lex_state = 3},
  [384] = {.lex_state = 2, .external_lex_state = 2},
  [385] = {.lex_state = 2, .external_lex_state = 2},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 3},
  [388] = {.lex_state = 3},
  [389] = {.lex_state = 2},
  [390] = {.lex_state = 2},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 2, .external_lex_state = 2},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 2},
  [398] = {.lex_state = 3},
  [399] = {.lex_state = 3},
  [400] = {.lex_state = 2, .external_lex_state = 2},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 3, .external_lex_state = 2},
  [405] = {.lex_state = 3, .external_lex_state = 2},
  [406] = {.lex_state = 3, .external_lex_state = 2},
  [407] = {.lex_state = 3},
  [408] = {.lex_state = 2, .external_lex_state = 2},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 3},
  [411] = {.lex_state = 3},
  [412] = {.lex_state = 3, .external_lex_state = 2},
  [413] = {.lex_state = 3, .external_lex_state = 2},
  [414] = {.lex_state = 0, .external_lex_state = 2},
  [415] = {.lex_state = 3},
  [416] = {.lex_state = 3, .external_lex_state = 2},
  [417] = {.lex_state = 3},
  [418] = {.lex_state = 3, .external_lex_state = 2},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 2, .external_lex_state = 2},
  [421] = {.lex_state = 2, .external_lex_state = 2},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 3},
  [424] = {.lex_state = 3},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 3},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 2, .external_lex_state = 2},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 3},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 3},
  [443] = {.lex_state = 3},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 3},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 3},
  [448] = {.lex_state = 2},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 3},
  [451] = {.lex_state = 3},
  [452] = {.lex_state = 3},
  [453] = {.lex_state = 2, .external_lex_state = 2},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 3},
  [456] = {.lex_state = 3},
  [457] = {.lex_state = 3},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 3, .external_lex_state = 2},
  [460] = {.lex_state = 3},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 3},
  [463] = {.lex_state = 3},
  [464] = {.lex_state = 3},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 3},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 9, .external_lex_state = 2},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 3},
  [479] = {.lex_state = 0},
  [480] = {.lex_state = 3},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 3},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 3},
  [487] = {.lex_state = 3},
  [488] = {.lex_state = 3},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 0, .external_lex_state = 2},
  [493] = {.lex_state = 3},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 3, .external_lex_state = 2},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 3},
  [499] = {.lex_state = 3},
  [500] = {.lex_state = 13},
  [501] = {.lex_state = 13},
  [502] = {.lex_state = 3},
  [503] = {.lex_state = 13},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 13},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 3, .external_lex_state = 2},
  [512] = {.lex_state = 3, .external_lex_state = 2},
  [513] = {.lex_state = 3, .external_lex_state = 2},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 3, .external_lex_state = 2},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 0, .external_lex_state = 2},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 3},
  [521] = {.lex_state = 3, .external_lex_state = 2},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 3},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 13},
  [538] = {.lex_state = 13},
  [539] = {.lex_state = 3},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 13},
  [545] = {.lex_state = 13},
  [546] = {.lex_state = 13},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 10, .external_lex_state = 2},
  [550] = {.lex_state = 0, .external_lex_state = 2},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 2, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 2, .external_lex_state = 2},
  [557] = {.lex_state = 2, .external_lex_state = 2},
  [558] = {.lex_state = 0, .external_lex_state = 2},
  [559] = {.lex_state = 3, .external_lex_state = 2},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 9, .external_lex_state = 2},
  [563] = {.lex_state = 2, .external_lex_state = 2},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 3},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 2, .external_lex_state = 2},
  [569] = {.lex_state = 2, .external_lex_state = 2},
  [570] = {.lex_state = 2, .external_lex_state = 2},
  [571] = {.lex_state = 2, .external_lex_state = 2},
  [572] = {.lex_state = 2, .external_lex_state = 2},
  [573] = {.lex_state = 0, .external_lex_state = 2},
  [574] = {.lex_state = 2, .external_lex_state = 2},
  [575] = {.lex_state = 2},
  [576] = {.lex_state = 2, .external_lex_state = 2},
  [577] = {.lex_state = 2, .external_lex_state = 2},
  [578] = {.lex_state = 9, .external_lex_state = 2},
  [579] = {.lex_state = 2, .external_lex_state = 2},
  [580] = {.lex_state = 9, .external_lex_state = 2},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 9, .external_lex_state = 2},
  [584] = {.lex_state = 3},
  [585] = {.lex_state = 2, .external_lex_state = 2},
  [586] = {.lex_state = 3},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 2, .external_lex_state = 2},
  [590] = {.lex_state = 2, .external_lex_state = 2},
  [591] = {.lex_state = 2, .external_lex_state = 2},
  [592] = {.lex_state = 2, .external_lex_state = 2},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 3},
  [595] = {.lex_state = 2, .external_lex_state = 2},
  [596] = {.lex_state = 3},
  [597] = {.lex_state = 3},
  [598] = {.lex_state = 3},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 15, .external_lex_state = 3},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 3},
  [604] = {.lex_state = 2, .external_lex_state = 2},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 3},
  [607] = {.lex_state = 3},
  [608] = {.lex_state = 3},
  [609] = {.lex_state = 3},
  [610] = {.lex_state = 3},
  [611] = {.lex_state = 3},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 3},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 2, .external_lex_state = 2},
  [616] = {.lex_state = 0, .external_lex_state = 2},
  [617] = {.lex_state = 3},
  [618] = {.lex_state = 0, .external_lex_state = 2},
  [619] = {.lex_state = 0, .external_lex_state = 2},
  [620] = {.lex_state = 3},
  [621] = {.lex_state = 0, .external_lex_state = 2},
  [622] = {.lex_state = 0, .external_lex_state = 2},
  [623] = {.lex_state = 9, .external_lex_state = 2},
  [624] = {.lex_state = 2, .external_lex_state = 2},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 3},
  [627] = {.lex_state = 3},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 3},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 3},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 3},
  [636] = {.lex_state = 3, .external_lex_state = 2},
  [637] = {.lex_state = 13},
  [638] = {.lex_state = 3},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0, .external_lex_state = 2},
  [641] = {.lex_state = 3},
  [642] = {.lex_state = 3},
  [643] = {.lex_state = 0, .external_lex_state = 2},
  [644] = {.lex_state = 3},
  [645] = {.lex_state = 3},
  [646] = {.lex_state = 3},
  [647] = {.lex_state = 3},
  [648] = {.lex_state = 3},
  [649] = {.lex_state = 3},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0, .external_lex_state = 2},
  [652] = {.lex_state = 2, .external_lex_state = 2},
  [653] = {.lex_state = 3},
  [654] = {.lex_state = 3},
  [655] = {.lex_state = 9, .external_lex_state = 2},
  [656] = {.lex_state = 9},
  [657] = {.lex_state = 9},
  [658] = {.lex_state = 9},
  [659] = {.lex_state = 9},
  [660] = {.lex_state = 9},
  [661] = {.lex_state = 2, .external_lex_state = 2},
  [662] = {.lex_state = 2, .external_lex_state = 2},
  [663] = {.lex_state = 3},
  [664] = {.lex_state = 3},
  [665] = {.lex_state = 3},
  [666] = {.lex_state = 3},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 2, .external_lex_state = 2},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 3},
  [671] = {.lex_state = 3},
  [672] = {.lex_state = 3},
  [673] = {.lex_state = 13},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 3},
  [676] = {.lex_state = 2, .external_lex_state = 2},
  [677] = {.lex_state = 2, .external_lex_state = 2},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 3},
  [680] = {.lex_state = 9},
  [681] = {.lex_state = 9},
  [682] = {.lex_state = 9},
  [683] = {.lex_state = 9},
  [684] = {.lex_state = 9},
  [685] = {.lex_state = 2},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 3, .external_lex_state = 2},
  [688] = {.lex_state = 3},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 3, .external_lex_state = 2},
  [691] = {.lex_state = 3, .external_lex_state = 2},
  [692] = {.lex_state = 3},
  [693] = {.lex_state = 3, .external_lex_state = 2},
  [694] = {.lex_state = 3, .external_lex_state = 2},
  [695] = {.lex_state = 3},
  [696] = {.lex_state = 3},
  [697] = {.lex_state = 2, .external_lex_state = 2},
  [698] = {.lex_state = 3},
  [699] = {.lex_state = 3, .external_lex_state = 2},
  [700] = {.lex_state = 3},
  [701] = {.lex_state = 3},
  [702] = {.lex_state = 3, .external_lex_state = 2},
  [703] = {.lex_state = 0, .external_lex_state = 2},
  [704] = {.lex_state = 0, .external_lex_state = 2},
  [705] = {.lex_state = 0, .external_lex_state = 2},
  [706] = {.lex_state = 0, .external_lex_state = 2},
  [707] = {.lex_state = 2, .external_lex_state = 2},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 3, .external_lex_state = 2},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 3},
  [712] = {.lex_state = 3},
  [713] = {.lex_state = 3},
  [714] = {.lex_state = 0, .external_lex_state = 2},
  [715] = {.lex_state = 3},
  [716] = {.lex_state = 3},
  [717] = {.lex_state = 3},
  [718] = {.lex_state = 2, .external_lex_state = 2},
  [719] = {.lex_state = 2, .external_lex_state = 2},
  [720] = {.lex_state = 2, .external_lex_state = 2},
  [721] = {.lex_state = 3},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 3},
  [724] = {.lex_state = 3},
  [725] = {.lex_state = 3},
  [726] = {.lex_state = 3},
  [727] = {.lex_state = 2, .external_lex_state = 2},
  [728] = {.lex_state = 2, .external_lex_state = 2},
  [729] = {.lex_state = 2, .external_lex_state = 2},
  [730] = {.lex_state = 2},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 3},
  [734] = {.lex_state = 2, .external_lex_state = 2},
  [735] = {.lex_state = 3},
  [736] = {.lex_state = 3},
  [737] = {.lex_state = 3},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 3},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 3},
  [744] = {.lex_state = 3},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 9, .external_lex_state = 2},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 2, .external_lex_state = 2},
  [756] = {.lex_state = 2, .external_lex_state = 2},
  [757] = {.lex_state = 2, .external_lex_state = 2},
  [758] = {.lex_state = 2, .external_lex_state = 2},
  [759] = {.lex_state = 0, .external_lex_state = 2},
  [760] = {.lex_state = 3},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 2, .external_lex_state = 2},
  [763] = {.lex_state = 2, .external_lex_state = 2},
  [764] = {.lex_state = 2, .external_lex_state = 2},
  [765] = {.lex_state = 3},
  [766] = {.lex_state = 3},
  [767] = {.lex_state = 3},
  [768] = {.lex_state = 3},
  [769] = {.lex_state = 3},
  [770] = {.lex_state = 3},
  [771] = {.lex_state = 3},
  [772] = {.lex_state = 3},
  [773] = {.lex_state = 3},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0, .external_lex_state = 2},
  [776] = {.lex_state = 3},
  [777] = {.lex_state = 3},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 3, .external_lex_state = 2},
  [781] = {.lex_state = 3, .external_lex_state = 2},
  [782] = {.lex_state = 0, .external_lex_state = 2},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 3},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 3},
  [787] = {.lex_state = 0, .external_lex_state = 2},
  [788] = {.lex_state = 3, .external_lex_state = 2},
  [789] = {.lex_state = 3, .external_lex_state = 2},
  [790] = {.lex_state = 0, .external_lex_state = 2},
  [791] = {.lex_state = 0, .external_lex_state = 2},
  [792] = {.lex_state = 3},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 13},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 3},
  [797] = {.lex_state = 3},
  [798] = {.lex_state = 3, .external_lex_state = 2},
  [799] = {.lex_state = 3, .external_lex_state = 2},
  [800] = {.lex_state = 3, .external_lex_state = 2},
  [801] = {.lex_state = 3},
  [802] = {.lex_state = 3, .external_lex_state = 2},
  [803] = {.lex_state = 3},
  [804] = {.lex_state = 3},
  [805] = {.lex_state = 3, .external_lex_state = 2},
  [806] = {.lex_state = 3},
  [807] = {.lex_state = 3},
  [808] = {.lex_state = 3},
  [809] = {.lex_state = 3},
  [810] = {.lex_state = 3},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 3},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 3},
  [815] = {.lex_state = 3},
  [816] = {.lex_state = 3},
  [817] = {.lex_state = 3},
  [818] = {.lex_state = 13},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 13},
  [821] = {.lex_state = 2, .external_lex_state = 2},
  [822] = {.lex_state = 3},
  [823] = {.lex_state = 2, .external_lex_state = 2},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 2, .external_lex_state = 2},
  [826] = {.lex_state = 3},
  [827] = {.lex_state = 2, .external_lex_state = 2},
  [828] = {.lex_state = 2},
  [829] = {.lex_state = 3},
  [830] = {.lex_state = 3, .external_lex_state = 2},
  [831] = {.lex_state = 3},
  [832] = {.lex_state = 3, .external_lex_state = 2},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 3},
  [835] = {.lex_state = 0, .external_lex_state = 2},
  [836] = {.lex_state = 0, .external_lex_state = 2},
  [837] = {.lex_state = 3},
  [838] = {.lex_state = 9, .external_lex_state = 2},
  [839] = {.lex_state = 2, .external_lex_state = 2},
  [840] = {.lex_state = 9},
  [841] = {.lex_state = 9},
  [842] = {.lex_state = 9},
  [843] = {.lex_state = 2},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 2, .external_lex_state = 2},
  [848] = {.lex_state = 2, .external_lex_state = 2},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 3},
  [851] = {.lex_state = 2, .external_lex_state = 2},
  [852] = {.lex_state = 2, .external_lex_state = 2},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 2, .external_lex_state = 2},
  [855] = {.lex_state = 2, .external_lex_state = 2},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 2},
  [858] = {.lex_state = 2},
  [859] = {.lex_state = 2},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 3},
  [862] = {.lex_state = 2, .external_lex_state = 2},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 2, .external_lex_state = 2},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 3},
  [867] = {.lex_state = 2, .external_lex_state = 2},
  [868] = {.lex_state = 3},
  [869] = {.lex_state = 3},
  [870] = {.lex_state = 3},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 3},
  [874] = {.lex_state = 3},
  [875] = {.lex_state = 3},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 3},
  [878] = {.lex_state = 3, .external_lex_state = 2},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 3},
  [881] = {.lex_state = 3},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 3},
  [884] = {.lex_state = 3},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 3},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 2},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 2},
  [892] = {.lex_state = 3},
  [893] = {.lex_state = 3},
  [894] = {.lex_state = 3},
  [895] = {.lex_state = 3},
  [896] = {.lex_state = 3},
  [897] = {.lex_state = 3},
  [898] = {.lex_state = 3},
  [899] = {.lex_state = 3},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 2},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 2},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 2},
  [906] = {.lex_state = 9},
  [907] = {.lex_state = 2},
  [908] = {.lex_state = 2},
  [909] = {.lex_state = 9},
  [910] = {.lex_state = 3},
  [911] = {.lex_state = 2},
  [912] = {.lex_state = 3},
  [913] = {.lex_state = 9},
  [914] = {.lex_state = 3},
  [915] = {.lex_state = 3},
  [916] = {.lex_state = 3},
  [917] = {.lex_state = 2, .external_lex_state = 2},
  [918] = {.lex_state = 3},
  [919] = {.lex_state = 0, .external_lex_state = 2},
  [920] = {.lex_state = 3},
  [921] = {.lex_state = 13},
  [922] = {.lex_state = 3},
  [923] = {.lex_state = 3, .external_lex_state = 2},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 3},
  [926] = {.lex_state = 0, .external_lex_state = 2},
  [927] = {.lex_state = 3, .external_lex_state = 2},
  [928] = {.lex_state = 0, .external_lex_state = 2},
  [929] = {.lex_state = 0, .external_lex_state = 2},
  [930] = {.lex_state = 0, .external_lex_state = 2},
  [931] = {.lex_state = 0, .external_lex_state = 2},
  [932] = {.lex_state = 3},
  [933] = {.lex_state = 3},
  [934] = {.lex_state = 3},
  [935] = {.lex_state = 3, .external_lex_state = 2},
  [936] = {.lex_state = 3, .external_lex_state = 2},
  [937] = {.lex_state = 3, .external_lex_state = 2},
  [938] = {.lex_state = 3},
  [939] = {.lex_state = 3},
  [940] = {.lex_state = 3, .external_lex_state = 2},
  [941] = {.lex_state = 3},
  [942] = {.lex_state = 3, .external_lex_state = 2},
  [943] = {.lex_state = 0, .external_lex_state = 2},
  [944] = {.lex_state = 0, .external_lex_state = 2},
  [945] = {.lex_state = 0, .external_lex_state = 2},
  [946] = {.lex_state = 0, .external_lex_state = 2},
  [947] = {.lex_state = 13},
  [948] = {.lex_state = 3, .external_lex_state = 2},
  [949] = {.lex_state = 3, .external_lex_state = 2},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0, .external_lex_state = 2},
  [952] = {.lex_state = 3},
  [953] = {.lex_state = 3, .external_lex_state = 2},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 3, .external_lex_state = 2},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 3},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 3},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 3},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 2},
  [969] = {.lex_state = 3},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 3},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 3},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 3},
  [978] = {.lex_state = 2, .external_lex_state = 2},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 2, .external_lex_state = 2},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 3},
  [985] = {.lex_state = 3},
  [986] = {.lex_state = 0, .external_lex_state = 2},
  [987] = {.lex_state = 3},
  [988] = {.lex_state = 0, .external_lex_state = 2},
  [989] = {.lex_state = 3},
  [990] = {.lex_state = 3, .external_lex_state = 2},
  [991] = {.lex_state = 3},
  [992] = {.lex_state = 3, .external_lex_state = 2},
  [993] = {.lex_state = 3, .external_lex_state = 2},
  [994] = {.lex_state = 3, .external_lex_state = 2},
  [995] = {.lex_state = 0, .external_lex_state = 2},
  [996] = {.lex_state = 0, .external_lex_state = 2},
  [997] = {.lex_state = 0, .external_lex_state = 2},
  [998] = {.lex_state = 0, .external_lex_state = 2},
  [999] = {.lex_state = 0, .external_lex_state = 2},
  [1000] = {.lex_state = 3},
  [1001] = {.lex_state = 0, .external_lex_state = 2},
  [1002] = {.lex_state = 0, .external_lex_state = 2},
  [1003] = {.lex_state = 3},
  [1004] = {.lex_state = 3},
  [1005] = {.lex_state = 13},
  [1006] = {.lex_state = 3, .external_lex_state = 2},
  [1007] = {.lex_state = 3, .external_lex_state = 2},
  [1008] = {.lex_state = 3, .external_lex_state = 2},
  [1009] = {.lex_state = 3, .external_lex_state = 2},
  [1010] = {.lex_state = 3},
  [1011] = {.lex_state = 3, .external_lex_state = 2},
  [1012] = {.lex_state = 3},
  [1013] = {.lex_state = 3, .external_lex_state = 2},
  [1014] = {.lex_state = 3},
  [1015] = {.lex_state = 3, .external_lex_state = 2},
  [1016] = {.lex_state = 3},
  [1017] = {.lex_state = 3},
  [1018] = {.lex_state = 3},
  [1019] = {.lex_state = 3},
  [1020] = {.lex_state = 3},
  [1021] = {.lex_state = 3},
  [1022] = {.lex_state = 2, .external_lex_state = 2},
  [1023] = {.lex_state = 9},
  [1024] = {.lex_state = 3},
  [1025] = {.lex_state = 9, .external_lex_state = 2},
  [1026] = {.lex_state = 3, .external_lex_state = 2},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 3},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 3},
  [1031] = {.lex_state = 3},
  [1032] = {.lex_state = 2, .external_lex_state = 2},
  [1033] = {.lex_state = 3},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 3},
  [1036] = {.lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 2},
  [1038] = {.lex_state = 2, .external_lex_state = 2},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 2, .external_lex_state = 2},
  [1041] = {.lex_state = 2, .external_lex_state = 2},
  [1042] = {.lex_state = 2, .external_lex_state = 2},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 2, .external_lex_state = 2},
  [1045] = {.lex_state = 2, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 2},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 3},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 3},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 3},
  [1054] = {.lex_state = 3},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 3},
  [1058] = {.lex_state = 3},
  [1059] = {.lex_state = 3},
  [1060] = {.lex_state = 3},
  [1061] = {.lex_state = 2, .external_lex_state = 2},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 2},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 2},
  [1066] = {.lex_state = 2, .external_lex_state = 2},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 2},
  [1069] = {.lex_state = 2, .external_lex_state = 2},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 2},
  [1072] = {.lex_state = 3},
  [1073] = {.lex_state = 3},
  [1074] = {.lex_state = 3},
  [1075] = {.lex_state = 3},
  [1076] = {.lex_state = 3},
  [1077] = {.lex_state = 0, .external_lex_state = 2},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 3},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0, .external_lex_state = 2},
  [1082] = {.lex_state = 3},
  [1083] = {.lex_state = 0, .external_lex_state = 2},
  [1084] = {.lex_state = 0, .external_lex_state = 2},
  [1085] = {.lex_state = 0, .external_lex_state = 2},
  [1086] = {.lex_state = 0, .external_lex_state = 2},
  [1087] = {.lex_state = 0, .external_lex_state = 2},
  [1088] = {.lex_state = 0, .external_lex_state = 2},
  [1089] = {.lex_state = 0, .external_lex_state = 2},
  [1090] = {.lex_state = 0, .external_lex_state = 2},
  [1091] = {.lex_state = 3},
  [1092] = {.lex_state = 0, .external_lex_state = 2},
  [1093] = {.lex_state = 3},
  [1094] = {.lex_state = 3},
  [1095] = {.lex_state = 3},
  [1096] = {.lex_state = 3, .external_lex_state = 2},
  [1097] = {.lex_state = 3, .external_lex_state = 2},
  [1098] = {.lex_state = 3, .external_lex_state = 2},
  [1099] = {.lex_state = 0, .external_lex_state = 2},
  [1100] = {.lex_state = 3},
  [1101] = {.lex_state = 3, .external_lex_state = 2},
  [1102] = {.lex_state = 0, .external_lex_state = 2},
  [1103] = {.lex_state = 3},
  [1104] = {.lex_state = 3, .external_lex_state = 2},
  [1105] = {.lex_state = 3, .external_lex_state = 2},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 3, .external_lex_state = 2},
  [1108] = {.lex_state = 3, .external_lex_state = 2},
  [1109] = {.lex_state = 3, .external_lex_state = 2},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 3},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 3},
  [1117] = {.lex_state = 3},
  [1118] = {.lex_state = 3},
  [1119] = {.lex_state = 3},
  [1120] = {.lex_state = 3},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 3},
  [1123] = {.lex_state = 2, .external_lex_state = 2},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 3},
  [1128] = {.lex_state = 3},
  [1129] = {.lex_state = 0, .external_lex_state = 2},
  [1130] = {.lex_state = 3},
  [1131] = {.lex_state = 0, .external_lex_state = 2},
  [1132] = {.lex_state = 3},
  [1133] = {.lex_state = 3},
  [1134] = {.lex_state = 3},
  [1135] = {.lex_state = 3, .external_lex_state = 2},
  [1136] = {.lex_state = 0, .external_lex_state = 2},
  [1137] = {.lex_state = 0, .external_lex_state = 2},
  [1138] = {.lex_state = 0, .external_lex_state = 2},
  [1139] = {.lex_state = 3},
  [1140] = {.lex_state = 3, .external_lex_state = 2},
  [1141] = {.lex_state = 3, .external_lex_state = 2},
  [1142] = {.lex_state = 3},
  [1143] = {.lex_state = 3, .external_lex_state = 2},
  [1144] = {.lex_state = 3, .external_lex_state = 2},
  [1145] = {.lex_state = 3},
  [1146] = {.lex_state = 3},
  [1147] = {.lex_state = 2},
  [1148] = {.lex_state = 3, .external_lex_state = 2},
  [1149] = {.lex_state = 3},
  [1150] = {.lex_state = 9, .external_lex_state = 2},
  [1151] = {.lex_state = 3},
  [1152] = {.lex_state = 3},
  [1153] = {.lex_state = 2, .external_lex_state = 2},
  [1154] = {.lex_state = 2, .external_lex_state = 2},
  [1155] = {.lex_state = 2, .external_lex_state = 2},
  [1156] = {.lex_state = 3},
  [1157] = {.lex_state = 3},
  [1158] = {.lex_state = 0, .external_lex_state = 2},
  [1159] = {.lex_state = 3},
  [1160] = {.lex_state = 3},
  [1161] = {.lex_state = 3},
  [1162] = {.lex_state = 3},
  [1163] = {.lex_state = 3},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0, .external_lex_state = 2},
  [1167] = {.lex_state = 0, .external_lex_state = 2},
  [1168] = {.lex_state = 0, .external_lex_state = 2},
  [1169] = {.lex_state = 0, .external_lex_state = 2},
  [1170] = {.lex_state = 0, .external_lex_state = 2},
  [1171] = {.lex_state = 0, .external_lex_state = 2},
  [1172] = {.lex_state = 3},
  [1173] = {.lex_state = 0, .external_lex_state = 2},
  [1174] = {.lex_state = 3},
  [1175] = {.lex_state = 3},
  [1176] = {.lex_state = 3},
  [1177] = {.lex_state = 3, .external_lex_state = 2},
  [1178] = {.lex_state = 0, .external_lex_state = 2},
  [1179] = {.lex_state = 0, .external_lex_state = 2},
  [1180] = {.lex_state = 0, .external_lex_state = 2},
  [1181] = {.lex_state = 3},
  [1182] = {.lex_state = 0, .external_lex_state = 2},
  [1183] = {.lex_state = 3, .external_lex_state = 2},
  [1184] = {.lex_state = 3, .external_lex_state = 2},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 3},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 3},
  [1191] = {.lex_state = 3},
  [1192] = {.lex_state = 3},
  [1193] = {.lex_state = 3},
  [1194] = {.lex_state = 3},
  [1195] = {.lex_state = 3},
  [1196] = {.lex_state = 3},
  [1197] = {.lex_state = 0, .external_lex_state = 2},
  [1198] = {.lex_state = 3},
  [1199] = {.lex_state = 0, .external_lex_state = 2},
  [1200] = {.lex_state = 3},
  [1201] = {.lex_state = 0, .external_lex_state = 2},
  [1202] = {.lex_state = 3},
  [1203] = {.lex_state = 3},
  [1204] = {.lex_state = 3, .external_lex_state = 2},
  [1205] = {.lex_state = 0, .external_lex_state = 2},
  [1206] = {.lex_state = 3, .external_lex_state = 2},
  [1207] = {.lex_state = 3, .external_lex_state = 2},
  [1208] = {.lex_state = 3},
  [1209] = {.lex_state = 0, .external_lex_state = 2},
  [1210] = {.lex_state = 0, .external_lex_state = 2},
  [1211] = {.lex_state = 0, .external_lex_state = 2},
  [1212] = {.lex_state = 0, .external_lex_state = 2},
  [1213] = {.lex_state = 3},
  [1214] = {.lex_state = 0, .external_lex_state = 2},
  [1215] = {.lex_state = 3},
  [1216] = {.lex_state = 0, .external_lex_state = 2},
  [1217] = {.lex_state = 0, .external_lex_state = 2},
  [1218] = {.lex_state = 0, .external_lex_state = 2},
  [1219] = {.lex_state = 0, .external_lex_state = 2},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 3},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0, .external_lex_state = 2},
  [1226] = {.lex_state = 3},
  [1227] = {.lex_state = 0, .external_lex_state = 2},
  [1228] = {.lex_state = 3},
  [1229] = {.lex_state = 0, .external_lex_state = 2},
  [1230] = {.lex_state = 3, .external_lex_state = 2},
  [1231] = {.lex_state = 0, .external_lex_state = 2},
  [1232] = {.lex_state = 3},
  [1233] = {.lex_state = 0, .external_lex_state = 2},
  [1234] = {.lex_state = 0, .external_lex_state = 2},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0, .external_lex_state = 2},
  [1239] = {.lex_state = 3},
  [1240] = {.lex_state = 0, .external_lex_state = 2},
  [1241] = {.lex_state = 0, .external_lex_state = 2},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0, .external_lex_state = 2},
  [1244] = {.lex_state = 2},
  [1245] = {.lex_state = 3},
  [1246] = {.lex_state = 3},
  [1247] = {.lex_state = 2},
  [1248] = {.lex_state = 3},
  [1249] = {.lex_state = 3},
  [1250] = {.lex_state = 2},
  [1251] = {.lex_state = 9},
  [1252] = {.lex_state = 2},
  [1253] = {.lex_state = 2, .external_lex_state = 2},
  [1254] = {.lex_state = 3},
  [1255] = {.lex_state = 0, .external_lex_state = 2},
  [1256] = {.lex_state = 2},
  [1257] = {.lex_state = 3},
  [1258] = {.lex_state = 3},
  [1259] = {.lex_state = 3},
  [1260] = {.lex_state = 2},
  [1261] = {.lex_state = 3},
  [1262] = {.lex_state = 3},
  [1263] = {.lex_state = 3},
  [1264] = {.lex_state = 9},
  [1265] = {.lex_state = 9},
  [1266] = {.lex_state = 9},
  [1267] = {.lex_state = 9},
  [1268] = {.lex_state = 2},
  [1269] = {.lex_state = 9},
  [1270] = {.lex_state = 2},
  [1271] = {.lex_state = 2},
  [1272] = {.lex_state = 2},
  [1273] = {.lex_state = 2},
  [1274] = {.lex_state = 3},
  [1275] = {.lex_state = 2},
  [1276] = {.lex_state = 3},
  [1277] = {.lex_state = 3},
  [1278] = {.lex_state = 2, .external_lex_state = 2},
  [1279] = {.lex_state = 2, .external_lex_state = 2},
  [1280] = {.lex_state = 2},
  [1281] = {.lex_state = 2},
  [1282] = {.lex_state = 0, .external_lex_state = 2},
  [1283] = {.lex_state = 2},
  [1284] = {.lex_state = 3},
  [1285] = {.lex_state = 3},
  [1286] = {.lex_state = 3},
  [1287] = {.lex_state = 0, .external_lex_state = 2},
  [1288] = {.lex_state = 2, .external_lex_state = 2},
  [1289] = {.lex_state = 3},
  [1290] = {.lex_state = 9},
  [1291] = {.lex_state = 9},
  [1292] = {.lex_state = 9},
  [1293] = {.lex_state = 9},
  [1294] = {.lex_state = 9},
  [1295] = {.lex_state = 0, .external_lex_state = 2},
  [1296] = {.lex_state = 2},
  [1297] = {.lex_state = 9},
  [1298] = {.lex_state = 2},
  [1299] = {.lex_state = 2},
  [1300] = {.lex_state = 3},
  [1301] = {.lex_state = 2, .external_lex_state = 2},
  [1302] = {.lex_state = 13},
  [1303] = {.lex_state = 13},
  [1304] = {.lex_state = 2, .external_lex_state = 2},
  [1305] = {.lex_state = 2, .external_lex_state = 2},
  [1306] = {.lex_state = 13},
  [1307] = {.lex_state = 2, .external_lex_state = 2},
  [1308] = {.lex_state = 2, .external_lex_state = 2},
  [1309] = {.lex_state = 9},
  [1310] = {.lex_state = 2},
  [1311] = {.lex_state = 9},
  [1312] = {.lex_state = 9},
  [1313] = {.lex_state = 9},
  [1314] = {.lex_state = 9},
  [1315] = {.lex_state = 9},
  [1316] = {.lex_state = 2},
  [1317] = {.lex_state = 2},
  [1318] = {.lex_state = 2},
  [1319] = {.lex_state = 3},
  [1320] = {.lex_state = 0, .external_lex_state = 2},
  [1321] = {.lex_state = 2},
  [1322] = {.lex_state = 3},
  [1323] = {.lex_state = 3},
  [1324] = {.lex_state = 3},
  [1325] = {.lex_state = 3},
  [1326] = {.lex_state = 3},
  [1327] = {.lex_state = 3},
  [1328] = {.lex_state = 2},
  [1329] = {.lex_state = 3},
  [1330] = {.lex_state = 3},
  [1331] = {.lex_state = 2},
  [1332] = {.lex_state = 3},
  [1333] = {.lex_state = 2},
  [1334] = {.lex_state = 3},
  [1335] = {.lex_state = 0, .external_lex_state = 2},
  [1336] = {.lex_state = 13},
  [1337] = {.lex_state = 0, .external_lex_state = 2},
  [1338] = {.lex_state = 3},
  [1339] = {.lex_state = 3},
  [1340] = {.lex_state = 2},
  [1341] = {.lex_state = 2},
  [1342] = {.lex_state = 2},
  [1343] = {.lex_state = 2},
  [1344] = {.lex_state = 9},
  [1345] = {.lex_state = 2},
  [1346] = {.lex_state = 2},
  [1347] = {.lex_state = 2},
  [1348] = {.lex_state = 2},
  [1349] = {.lex_state = 2},
  [1350] = {.lex_state = 9},
  [1351] = {.lex_state = 3, .external_lex_state = 2},
  [1352] = {.lex_state = 3, .external_lex_state = 2},
  [1353] = {.lex_state = 2},
  [1354] = {.lex_state = 3},
  [1355] = {.lex_state = 0, .external_lex_state = 2},
  [1356] = {.lex_state = 2, .external_lex_state = 2},
  [1357] = {.lex_state = 2},
  [1358] = {.lex_state = 2},
  [1359] = {.lex_state = 0, .external_lex_state = 2},
  [1360] = {.lex_state = 0, .external_lex_state = 2},
  [1361] = {.lex_state = 2},
  [1362] = {.lex_state = 3},
  [1363] = {.lex_state = 2, .external_lex_state = 2},
  [1364] = {.lex_state = 9},
  [1365] = {.lex_state = 9},
  [1366] = {.lex_state = 9},
  [1367] = {.lex_state = 9},
  [1368] = {.lex_state = 9},
  [1369] = {.lex_state = 9},
  [1370] = {.lex_state = 2},
  [1371] = {.lex_state = 2},
  [1372] = {.lex_state = 2},
  [1373] = {.lex_state = 2, .external_lex_state = 2},
  [1374] = {.lex_state = 3},
  [1375] = {.lex_state = 2},
  [1376] = {.lex_state = 2},
  [1377] = {.lex_state = 2},
  [1378] = {.lex_state = 0, .external_lex_state = 2},
  [1379] = {.lex_state = 2},
  [1380] = {.lex_state = 3, .external_lex_state = 2},
  [1381] = {.lex_state = 3, .external_lex_state = 2},
  [1382] = {.lex_state = 2, .external_lex_state = 2},
  [1383] = {.lex_state = 2},
  [1384] = {.lex_state = 2, .external_lex_state = 2},
  [1385] = {.lex_state = 0, .external_lex_state = 2},
  [1386] = {.lex_state = 3},
  [1387] = {.lex_state = 3},
  [1388] = {.lex_state = 3},
  [1389] = {.lex_state = 3},
  [1390] = {.lex_state = 0, .external_lex_state = 2},
  [1391] = {.lex_state = 2, .external_lex_state = 2},
  [1392] = {.lex_state = 13},
  [1393] = {.lex_state = 2, .external_lex_state = 2},
  [1394] = {.lex_state = 2, .external_lex_state = 2},
  [1395] = {.lex_state = 2, .external_lex_state = 2},
  [1396] = {.lex_state = 2, .external_lex_state = 2},
  [1397] = {.lex_state = 2, .external_lex_state = 2},
  [1398] = {.lex_state = 2, .external_lex_state = 2},
  [1399] = {.lex_state = 2, .external_lex_state = 2},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 3},
  [1402] = {.lex_state = 3},
  [1403] = {.lex_state = 2, .external_lex_state = 2},
  [1404] = {.lex_state = 13},
  [1405] = {.lex_state = 2, .external_lex_state = 2},
  [1406] = {.lex_state = 2, .external_lex_state = 2},
  [1407] = {.lex_state = 13},
  [1408] = {.lex_state = 13},
  [1409] = {.lex_state = 10},
  [1410] = {.lex_state = 2},
  [1411] = {.lex_state = 2},
  [1412] = {.lex_state = 2},
  [1413] = {.lex_state = 2},
  [1414] = {.lex_state = 2},
  [1415] = {.lex_state = 9, .external_lex_state = 2},
  [1416] = {.lex_state = 0, .external_lex_state = 2},
  [1417] = {.lex_state = 2},
  [1418] = {.lex_state = 2},
  [1419] = {.lex_state = 2},
  [1420] = {.lex_state = 2},
  [1421] = {.lex_state = 2},
  [1422] = {.lex_state = 0},
  [1423] = {.lex_state = 2},
  [1424] = {.lex_state = 2},
  [1425] = {.lex_state = 2},
  [1426] = {.lex_state = 9},
  [1427] = {.lex_state = 2},
  [1428] = {.lex_state = 9},
  [1429] = {.lex_state = 3},
  [1430] = {.lex_state = 3},
  [1431] = {.lex_state = 9},
  [1432] = {.lex_state = 2},
  [1433] = {.lex_state = 3},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 2},
  [1436] = {.lex_state = 2},
  [1437] = {.lex_state = 2},
  [1438] = {.lex_state = 2},
  [1439] = {.lex_state = 0, .external_lex_state = 2},
  [1440] = {.lex_state = 3, .external_lex_state = 2},
  [1441] = {.lex_state = 2},
  [1442] = {.lex_state = 0, .external_lex_state = 2},
  [1443] = {.lex_state = 2},
  [1444] = {.lex_state = 2},
  [1445] = {.lex_state = 0, .external_lex_state = 2},
  [1446] = {.lex_state = 0, .external_lex_state = 2},
  [1447] = {.lex_state = 9},
  [1448] = {.lex_state = 2},
  [1449] = {.lex_state = 0, .external_lex_state = 2},
  [1450] = {.lex_state = 0, .external_lex_state = 2},
  [1451] = {.lex_state = 0, .external_lex_state = 2},
  [1452] = {.lex_state = 0, .external_lex_state = 2},
  [1453] = {.lex_state = 3},
  [1454] = {.lex_state = 2},
  [1455] = {.lex_state = 2, .external_lex_state = 2},
  [1456] = {.lex_state = 2, .external_lex_state = 2},
  [1457] = {.lex_state = 3},
  [1458] = {.lex_state = 2},
  [1459] = {.lex_state = 2},
  [1460] = {.lex_state = 0, .external_lex_state = 2},
  [1461] = {.lex_state = 2},
  [1462] = {.lex_state = 3},
  [1463] = {.lex_state = 2},
  [1464] = {.lex_state = 3, .external_lex_state = 2},
  [1465] = {.lex_state = 2, .external_lex_state = 2},
  [1466] = {.lex_state = 0, .external_lex_state = 2},
  [1467] = {.lex_state = 3},
  [1468] = {.lex_state = 2},
  [1469] = {.lex_state = 2},
  [1470] = {.lex_state = 2},
  [1471] = {.lex_state = 2},
  [1472] = {.lex_state = 2},
  [1473] = {.lex_state = 2},
  [1474] = {.lex_state = 2},
  [1475] = {.lex_state = 0, .external_lex_state = 2},
  [1476] = {.lex_state = 2, .external_lex_state = 2},
  [1477] = {.lex_state = 2, .external_lex_state = 2},
  [1478] = {.lex_state = 3, .external_lex_state = 2},
  [1479] = {.lex_state = 2, .external_lex_state = 2},
  [1480] = {.lex_state = 2, .external_lex_state = 2},
  [1481] = {.lex_state = 13},
  [1482] = {.lex_state = 2, .external_lex_state = 2},
  [1483] = {.lex_state = 2, .external_lex_state = 2},
  [1484] = {.lex_state = 2, .external_lex_state = 2},
  [1485] = {.lex_state = 2, .external_lex_state = 2},
  [1486] = {.lex_state = 2, .external_lex_state = 2},
  [1487] = {.lex_state = 2, .external_lex_state = 2},
  [1488] = {.lex_state = 2, .external_lex_state = 2},
  [1489] = {.lex_state = 13},
  [1490] = {.lex_state = 2},
  [1491] = {.lex_state = 0, .external_lex_state = 2},
  [1492] = {.lex_state = 2, .external_lex_state = 2},
  [1493] = {.lex_state = 2},
  [1494] = {.lex_state = 2},
  [1495] = {.lex_state = 0, .external_lex_state = 2},
  [1496] = {.lex_state = 0, .external_lex_state = 2},
  [1497] = {.lex_state = 3},
  [1498] = {.lex_state = 9},
  [1499] = {.lex_state = 2},
  [1500] = {.lex_state = 0},
  [1501] = {.lex_state = 0},
  [1502] = {.lex_state = 2, .external_lex_state = 2},
  [1503] = {.lex_state = 2},
  [1504] = {.lex_state = 2},
  [1505] = {.lex_state = 2},
  [1506] = {.lex_state = 2},
  [1507] = {.lex_state = 2},
  [1508] = {.lex_state = 2},
  [1509] = {.lex_state = 2},
  [1510] = {.lex_state = 0, .external_lex_state = 2},
  [1511] = {.lex_state = 0, .external_lex_state = 2},
  [1512] = {.lex_state = 0, .external_lex_state = 2},
  [1513] = {.lex_state = 0, .external_lex_state = 2},
  [1514] = {.lex_state = 0, .external_lex_state = 2},
  [1515] = {.lex_state = 0, .external_lex_state = 2},
  [1516] = {.lex_state = 9, .external_lex_state = 2},
  [1517] = {.lex_state = 2, .external_lex_state = 2},
  [1518] = {.lex_state = 3},
  [1519] = {.lex_state = 3, .external_lex_state = 2},
  [1520] = {.lex_state = 13},
  [1521] = {.lex_state = 0, .external_lex_state = 2},
  [1522] = {.lex_state = 0, .external_lex_state = 2},
  [1523] = {.lex_state = 0, .external_lex_state = 2},
  [1524] = {.lex_state = 3, .external_lex_state = 2},
  [1525] = {.lex_state = 3, .external_lex_state = 2},
  [1526] = {.lex_state = 0, .external_lex_state = 2},
  [1527] = {.lex_state = 0, .external_lex_state = 2},
  [1528] = {.lex_state = 2, .external_lex_state = 2},
  [1529] = {.lex_state = 2},
  [1530] = {.lex_state = 2, .external_lex_state = 2},
  [1531] = {.lex_state = 3},
  [1532] = {.lex_state = 2, .external_lex_state = 2},
  [1533] = {.lex_state = 2, .external_lex_state = 2},
  [1534] = {.lex_state = 13},
  [1535] = {.lex_state = 2, .external_lex_state = 2},
  [1536] = {.lex_state = 2, .external_lex_state = 2},
  [1537] = {.lex_state = 2, .external_lex_state = 2},
  [1538] = {.lex_state = 0, .external_lex_state = 2},
  [1539] = {.lex_state = 2, .external_lex_state = 2},
  [1540] = {.lex_state = 9},
  [1541] = {.lex_state = 0, .external_lex_state = 2},
  [1542] = {.lex_state = 2},
  [1543] = {.lex_state = 0},
  [1544] = {.lex_state = 0, .external_lex_state = 2},
  [1545] = {.lex_state = 2, .external_lex_state = 2},
  [1546] = {.lex_state = 2, .external_lex_state = 2},
  [1547] = {.lex_state = 2},
  [1548] = {.lex_state = 2},
  [1549] = {.lex_state = 2},
  [1550] = {.lex_state = 2},
  [1551] = {.lex_state = 2},
  [1552] = {.lex_state = 2},
  [1553] = {.lex_state = 0, .external_lex_state = 2},
  [1554] = {.lex_state = 0, .external_lex_state = 2},
  [1555] = {.lex_state = 0, .external_lex_state = 2},
  [1556] = {.lex_state = 3, .external_lex_state = 2},
  [1557] = {.lex_state = 3},
  [1558] = {.lex_state = 0, .external_lex_state = 2},
  [1559] = {.lex_state = 0, .external_lex_state = 2},
  [1560] = {.lex_state = 0, .external_lex_state = 2},
  [1561] = {.lex_state = 3, .external_lex_state = 2},
  [1562] = {.lex_state = 3, .external_lex_state = 2},
  [1563] = {.lex_state = 0, .external_lex_state = 2},
  [1564] = {.lex_state = 0, .external_lex_state = 2},
  [1565] = {.lex_state = 2, .external_lex_state = 2},
  [1566] = {.lex_state = 2, .external_lex_state = 2},
  [1567] = {.lex_state = 3, .external_lex_state = 2},
  [1568] = {.lex_state = 2, .external_lex_state = 2},
  [1569] = {.lex_state = 0, .external_lex_state = 2},
  [1570] = {.lex_state = 9},
  [1571] = {.lex_state = 2, .external_lex_state = 2},
  [1572] = {.lex_state = 2},
  [1573] = {.lex_state = 2},
  [1574] = {.lex_state = 0, .external_lex_state = 2},
  [1575] = {.lex_state = 0, .external_lex_state = 2},
  [1576] = {.lex_state = 3, .external_lex_state = 2},
  [1577] = {.lex_state = 3, .external_lex_state = 2},
  [1578] = {.lex_state = 0, .external_lex_state = 2},
  [1579] = {.lex_state = 2, .external_lex_state = 2},
  [1580] = {.lex_state = 3, .external_lex_state = 2},
  [1581] = {.lex_state = 3, .external_lex_state = 2},
  [1582] = {.lex_state = 3, .external_lex_state = 2},
  [1583] = {.lex_state = 3, .external_lex_state = 2},
  [1584] = {.lex_state = 3, .external_lex_state = 2},
  [1585] = {.lex_state = 2, .external_lex_state = 2},
  [1586] = {.lex_state = 2, .external_lex_state = 2},
  [1587] = {.lex_state = 2},
  [1588] = {.lex_state = 2},
  [1589] = {.lex_state = 2, .external_lex_state = 2},
  [1590] = {.lex_state = 3, .external_lex_state = 2},
  [1591] = {.lex_state = 13},
  [1592] = {.lex_state = 13},
  [1593] = {.lex_state = 3, .external_lex_state = 2},
  [1594] = {.lex_state = 3, .external_lex_state = 2},
  [1595] = {.lex_state = 13},
  [1596] = {.lex_state = 3, .external_lex_state = 2},
  [1597] = {.lex_state = 3, .external_lex_state = 2},
  [1598] = {.lex_state = 9},
  [1599] = {.lex_state = 3, .external_lex_state = 2},
  [1600] = {.lex_state = 3},
  [1601] = {.lex_state = 2, .external_lex_state = 2},
  [1602] = {.lex_state = 2},
  [1603] = {.lex_state = 2, .external_lex_state = 2},
  [1604] = {.lex_state = 2, .external_lex_state = 2},
  [1605] = {.lex_state = 2, .external_lex_state = 2},
  [1606] = {.lex_state = 9},
  [1607] = {.lex_state = 2, .external_lex_state = 2},
  [1608] = {.lex_state = 13},
  [1609] = {.lex_state = 3, .external_lex_state = 2},
  [1610] = {.lex_state = 3, .external_lex_state = 2},
  [1611] = {.lex_state = 3, .external_lex_state = 2},
  [1612] = {.lex_state = 3, .external_lex_state = 2},
  [1613] = {.lex_state = 3, .external_lex_state = 2},
  [1614] = {.lex_state = 3, .external_lex_state = 2},
  [1615] = {.lex_state = 3, .external_lex_state = 2},
  [1616] = {.lex_state = 3, .external_lex_state = 2},
  [1617] = {.lex_state = 3, .external_lex_state = 2},
  [1618] = {.lex_state = 13},
  [1619] = {.lex_state = 3, .external_lex_state = 2},
  [1620] = {.lex_state = 3, .external_lex_state = 2},
  [1621] = {.lex_state = 13},
  [1622] = {.lex_state = 13},
  [1623] = {.lex_state = 10},
  [1624] = {.lex_state = 9},
  [1625] = {.lex_state = 2},
  [1626] = {.lex_state = 9},
  [1627] = {.lex_state = 9},
  [1628] = {.lex_state = 2},
  [1629] = {.lex_state = 3},
  [1630] = {.lex_state = 3},
  [1631] = {.lex_state = 2, .external_lex_state = 2},
  [1632] = {.lex_state = 2, .external_lex_state = 2},
  [1633] = {.lex_state = 3, .external_lex_state = 2},
  [1634] = {.lex_state = 2, .external_lex_state = 2},
  [1635] = {.lex_state = 9},
  [1636] = {.lex_state = 3, .external_lex_state = 2},
  [1637] = {.lex_state = 3, .external_lex_state = 2},
  [1638] = {.lex_state = 3, .external_lex_state = 2},
  [1639] = {.lex_state = 3, .external_lex_state = 2},
  [1640] = {.lex_state = 13},
  [1641] = {.lex_state = 2},
  [1642] = {.lex_state = 3, .external_lex_state = 2},
  [1643] = {.lex_state = 3, .external_lex_state = 2},
  [1644] = {.lex_state = 3, .external_lex_state = 2},
  [1645] = {.lex_state = 3, .external_lex_state = 2},
  [1646] = {.lex_state = 3, .external_lex_state = 2},
  [1647] = {.lex_state = 3, .external_lex_state = 2},
  [1648] = {.lex_state = 13},
  [1649] = {.lex_state = 2},
  [1650] = {.lex_state = 9},
  [1651] = {.lex_state = 2},
  [1652] = {.lex_state = 3},
  [1653] = {.lex_state = 9},
  [1654] = {.lex_state = 13},
  [1655] = {.lex_state = 3, .external_lex_state = 2},
  [1656] = {.lex_state = 3, .external_lex_state = 2},
  [1657] = {.lex_state = 3, .external_lex_state = 2},
  [1658] = {.lex_state = 13},
  [1659] = {.lex_state = 3, .external_lex_state = 2},
  [1660] = {.lex_state = 3, .external_lex_state = 2},
  [1661] = {.lex_state = 3, .external_lex_state = 2},
  [1662] = {.lex_state = 3, .external_lex_state = 2},
  [1663] = {.lex_state = 3, .external_lex_state = 2},
  [1664] = {.lex_state = 3, .external_lex_state = 2},
  [1665] = {.lex_state = 9},
  [1666] = {.lex_state = 3, .external_lex_state = 2},
  [1667] = {.lex_state = 2},
  [1668] = {.lex_state = 2},
  [1669] = {.lex_state = 3},
  [1670] = {.lex_state = 3},
  [1671] = {.lex_state = 2, .external_lex_state = 2},
  [1672] = {.lex_state = 2},
  [1673] = {.lex_state = 13},
  [1674] = {.lex_state = 13},
  [1675] = {.lex_state = 2},
  [1676] = {.lex_state = 2},
  [1677] = {.lex_state = 13},
  [1678] = {.lex_state = 2},
  [1679] = {.lex_state = 2},
  [1680] = {.lex_state = 2},
  [1681] = {.lex_state = 2},
  [1682] = {.lex_state = 3},
  [1683] = {.lex_state = 3},
  [1684] = {.lex_state = 2},
  [1685] = {.lex_state = 3, .external_lex_state = 2},
  [1686] = {.lex_state = 2, .external_lex_state = 2},
  [1687] = {.lex_state = 13},
  [1688] = {.lex_state = 2},
  [1689] = {.lex_state = 2},
  [1690] = {.lex_state = 2},
  [1691] = {.lex_state = 2},
  [1692] = {.lex_state = 2},
  [1693] = {.lex_state = 2},
  [1694] = {.lex_state = 2},
  [1695] = {.lex_state = 2},
  [1696] = {.lex_state = 2},
  [1697] = {.lex_state = 13},
  [1698] = {.lex_state = 2},
  [1699] = {.lex_state = 2},
  [1700] = {.lex_state = 13},
  [1701] = {.lex_state = 13},
  [1702] = {.lex_state = 9},
  [1703] = {.lex_state = 2},
  [1704] = {.lex_state = 9},
  [1705] = {.lex_state = 9},
  [1706] = {.lex_state = 2},
  [1707] = {.lex_state = 2},
  [1708] = {.lex_state = 3},
  [1709] = {.lex_state = 2},
  [1710] = {.lex_state = 2},
  [1711] = {.lex_state = 2},
  [1712] = {.lex_state = 2},
  [1713] = {.lex_state = 2},
  [1714] = {.lex_state = 13},
  [1715] = {.lex_state = 2},
  [1716] = {.lex_state = 2},
  [1717] = {.lex_state = 2},
  [1718] = {.lex_state = 2},
  [1719] = {.lex_state = 2},
  [1720] = {.lex_state = 2},
  [1721] = {.lex_state = 2},
  [1722] = {.lex_state = 13},
  [1723] = {.lex_state = 9},
  [1724] = {.lex_state = 2},
  [1725] = {.lex_state = 9},
  [1726] = {.lex_state = 2},
  [1727] = {.lex_state = 2},
  [1728] = {.lex_state = 2},
  [1729] = {.lex_state = 13},
  [1730] = {.lex_state = 2},
  [1731] = {.lex_state = 2},
  [1732] = {.lex_state = 2},
  [1733] = {.lex_state = 2},
  [1734] = {.lex_state = 2},
  [1735] = {.lex_state = 9},
  [1736] = {.lex_state = 2},
  [1737] = {.lex_state = 3, .external_lex_state = 2},
  [1738] = {.lex_state = 3},
  [1739] = {.lex_state = 3},
  [1740] = {.lex_state = 3, .external_lex_state = 2},
  [1741] = {.lex_state = 3, .external_lex_state = 2},
  [1742] = {.lex_state = 3, .external_lex_state = 2},
  [1743] = {.lex_state = 3, .external_lex_state = 2},
  [1744] = {.lex_state = 13},
  [1745] = {.lex_state = 13},
  [1746] = {.lex_state = 13},
  [1747] = {.lex_state = 13},
  [1748] = {.lex_state = 9, .external_lex_state = 2},
  [1749] = {.lex_state = 2},
  [1750] = {.lex_state = 9, .external_lex_state = 2},
  [1751] = {.lex_state = 9, .external_lex_state = 2},
  [1752] = {.lex_state = 2, .external_lex_state = 2},
  [1753] = {.lex_state = 3, .external_lex_state = 2},
  [1754] = {.lex_state = 3, .external_lex_state = 2},
  [1755] = {.lex_state = 3, .external_lex_state = 2},
  [1756] = {.lex_state = 3},
  [1757] = {.lex_state = 13},
  [1758] = {.lex_state = 2},
  [1759] = {.lex_state = 3},
  [1760] = {.lex_state = 13},
  [1761] = {.lex_state = 9, .external_lex_state = 2},
  [1762] = {.lex_state = 2, .external_lex_state = 2},
  [1763] = {.lex_state = 9},
  [1764] = {.lex_state = 3},
  [1765] = {.lex_state = 13},
  [1766] = {.lex_state = 3},
  [1767] = {.lex_state = 3},
  [1768] = {.lex_state = 9},
  [1769] = {.lex_state = 3, .external_lex_state = 2},
  [1770] = {.lex_state = 3, .external_lex_state = 2},
  [1771] = {.lex_state = 9, .external_lex_state = 2},
  [1772] = {.lex_state = 2, .external_lex_state = 2},
  [1773] = {.lex_state = 9, .external_lex_state = 2},
  [1774] = {.lex_state = 9, .external_lex_state = 2},
  [1775] = {.lex_state = 2, .external_lex_state = 2},
  [1776] = {.lex_state = 3, .external_lex_state = 2},
  [1777] = {.lex_state = 2, .external_lex_state = 2},
  [1778] = {.lex_state = 9},
  [1779] = {.lex_state = 9, .external_lex_state = 2},
  [1780] = {.lex_state = 2, .external_lex_state = 2},
  [1781] = {.lex_state = 9, .external_lex_state = 2},
  [1782] = {.lex_state = 9, .external_lex_state = 2},
  [1783] = {.lex_state = 9, .external_lex_state = 2},
  [1784] = {.lex_state = 15, .external_lex_state = 3},
  [1785] = {.lex_state = 3},
  [1786] = {.lex_state = 9, .external_lex_state = 2},
  [1787] = {.lex_state = 4},
  [1788] = {.lex_state = 3},
  [1789] = {.lex_state = 3},
  [1790] = {.lex_state = 6},
  [1791] = {.lex_state = 3},
  [1792] = {.lex_state = 0},
  [1793] = {.lex_state = 0},
  [1794] = {.lex_state = 3},
  [1795] = {.lex_state = 3},
  [1796] = {.lex_state = 15, .external_lex_state = 3},
  [1797] = {.lex_state = 3},
  [1798] = {.lex_state = 3},
  [1799] = {.lex_state = 3},
  [1800] = {.lex_state = 0, .external_lex_state = 2},
  [1801] = {.lex_state = 3},
  [1802] = {.lex_state = 0},
  [1803] = {.lex_state = 3},
  [1804] = {.lex_state = 0},
  [1805] = {.lex_state = 3},
  [1806] = {.lex_state = 4},
  [1807] = {.lex_state = 3},
  [1808] = {.lex_state = 2},
  [1809] = {.lex_state = 0},
  [1810] = {.lex_state = 0},
  [1811] = {.lex_state = 3},
  [1812] = {.lex_state = 3},
  [1813] = {.lex_state = 0},
  [1814] = {.lex_state = 3},
  [1815] = {.lex_state = 0},
  [1816] = {.lex_state = 3},
  [1817] = {.lex_state = 9, .external_lex_state = 2},
  [1818] = {.lex_state = 9, .external_lex_state = 2},
  [1819] = {.lex_state = 9, .external_lex_state = 2},
  [1820] = {.lex_state = 9, .external_lex_state = 2},
  [1821] = {.lex_state = 9, .external_lex_state = 2},
  [1822] = {.lex_state = 9, .external_lex_state = 2},
  [1823] = {.lex_state = 9, .external_lex_state = 2},
  [1824] = {.lex_state = 9, .external_lex_state = 2},
  [1825] = {.lex_state = 9, .external_lex_state = 2},
  [1826] = {.lex_state = 9, .external_lex_state = 2},
  [1827] = {.lex_state = 9, .external_lex_state = 2},
  [1828] = {.lex_state = 9, .external_lex_state = 2},
  [1829] = {.lex_state = 0},
  [1830] = {.lex_state = 3},
  [1831] = {.lex_state = 0},
  [1832] = {.lex_state = 0},
  [1833] = {.lex_state = 0},
  [1834] = {.lex_state = 2},
  [1835] = {.lex_state = 0},
  [1836] = {.lex_state = 0},
  [1837] = {.lex_state = 0},
  [1838] = {.lex_state = 0, .external_lex_state = 2},
  [1839] = {.lex_state = 3},
  [1840] = {.lex_state = 6},
  [1841] = {.lex_state = 3},
  [1842] = {.lex_state = 13},
  [1843] = {.lex_state = 3},
  [1844] = {.lex_state = 13},
  [1845] = {.lex_state = 3},
  [1846] = {.lex_state = 0},
  [1847] = {.lex_state = 3},
  [1848] = {.lex_state = 13},
  [1849] = {.lex_state = 0},
  [1850] = {.lex_state = 3},
  [1851] = {.lex_state = 15},
  [1852] = {.lex_state = 0},
  [1853] = {.lex_state = 3},
  [1854] = {.lex_state = 2},
  [1855] = {.lex_state = 3, .external_lex_state = 2},
  [1856] = {.lex_state = 3},
  [1857] = {.lex_state = 13},
  [1858] = {.lex_state = 3},
  [1859] = {.lex_state = 3},
  [1860] = {.lex_state = 2, .external_lex_state = 2},
  [1861] = {.lex_state = 2, .external_lex_state = 2},
  [1862] = {.lex_state = 2, .external_lex_state = 2},
  [1863] = {.lex_state = 2, .external_lex_state = 2},
  [1864] = {.lex_state = 2, .external_lex_state = 2},
  [1865] = {.lex_state = 2, .external_lex_state = 2},
  [1866] = {.lex_state = 3},
  [1867] = {.lex_state = 3},
  [1868] = {.lex_state = 3},
  [1869] = {.lex_state = 3},
  [1870] = {.lex_state = 3},
  [1871] = {.lex_state = 3},
  [1872] = {.lex_state = 3},
  [1873] = {.lex_state = 0},
  [1874] = {.lex_state = 0, .external_lex_state = 2},
  [1875] = {.lex_state = 0},
  [1876] = {.lex_state = 2},
  [1877] = {.lex_state = 2},
  [1878] = {.lex_state = 0},
  [1879] = {.lex_state = 0},
  [1880] = {.lex_state = 0},
  [1881] = {.lex_state = 3},
  [1882] = {.lex_state = 3},
  [1883] = {.lex_state = 2, .external_lex_state = 2},
  [1884] = {.lex_state = 3},
  [1885] = {.lex_state = 3},
  [1886] = {.lex_state = 3},
  [1887] = {.lex_state = 0},
  [1888] = {.lex_state = 0},
  [1889] = {.lex_state = 3},
  [1890] = {.lex_state = 3},
  [1891] = {.lex_state = 0},
  [1892] = {.lex_state = 3},
  [1893] = {.lex_state = 0},
  [1894] = {.lex_state = 2},
  [1895] = {.lex_state = 0},
  [1896] = {.lex_state = 3, .external_lex_state = 2},
  [1897] = {.lex_state = 3},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 0},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 3},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0, .external_lex_state = 2},
  [1904] = {.lex_state = 3},
  [1905] = {.lex_state = 0, .external_lex_state = 2},
  [1906] = {.lex_state = 3},
  [1907] = {.lex_state = 0},
  [1908] = {.lex_state = 3},
  [1909] = {.lex_state = 3},
  [1910] = {.lex_state = 3},
  [1911] = {.lex_state = 13},
  [1912] = {.lex_state = 13},
  [1913] = {.lex_state = 0},
  [1914] = {.lex_state = 0},
  [1915] = {.lex_state = 0, .external_lex_state = 2},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 0, .external_lex_state = 2},
  [1918] = {.lex_state = 2, .external_lex_state = 2},
  [1919] = {.lex_state = 2, .external_lex_state = 2},
  [1920] = {.lex_state = 2, .external_lex_state = 2},
  [1921] = {.lex_state = 2, .external_lex_state = 2},
  [1922] = {.lex_state = 2, .external_lex_state = 2},
  [1923] = {.lex_state = 2, .external_lex_state = 2},
  [1924] = {.lex_state = 2},
  [1925] = {.lex_state = 3},
  [1926] = {.lex_state = 0},
  [1927] = {.lex_state = 2, .external_lex_state = 2},
  [1928] = {.lex_state = 2, .external_lex_state = 2},
  [1929] = {.lex_state = 2, .external_lex_state = 2},
  [1930] = {.lex_state = 2, .external_lex_state = 2},
  [1931] = {.lex_state = 3},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 3},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 3},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 3},
  [1938] = {.lex_state = 0},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 3},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 3},
  [1945] = {.lex_state = 3, .external_lex_state = 2},
  [1946] = {.lex_state = 0, .external_lex_state = 2},
  [1947] = {.lex_state = 3},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 2},
  [1950] = {.lex_state = 0, .external_lex_state = 2},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 0},
  [1953] = {.lex_state = 3},
  [1954] = {.lex_state = 0, .external_lex_state = 2},
  [1955] = {.lex_state = 3},
  [1956] = {.lex_state = 3},
  [1957] = {.lex_state = 3},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 2, .external_lex_state = 2},
  [1960] = {.lex_state = 2, .external_lex_state = 2},
  [1961] = {.lex_state = 0, .external_lex_state = 2},
  [1962] = {.lex_state = 0},
  [1963] = {.lex_state = 2, .external_lex_state = 2},
  [1964] = {.lex_state = 0, .external_lex_state = 2},
  [1965] = {.lex_state = 3},
  [1966] = {.lex_state = 0, .external_lex_state = 2},
  [1967] = {.lex_state = 0},
  [1968] = {.lex_state = 0},
  [1969] = {.lex_state = 3},
  [1970] = {.lex_state = 3, .external_lex_state = 2},
  [1971] = {.lex_state = 3, .external_lex_state = 2},
  [1972] = {.lex_state = 3, .external_lex_state = 2},
  [1973] = {.lex_state = 3, .external_lex_state = 2},
  [1974] = {.lex_state = 3},
  [1975] = {.lex_state = 13},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 2},
  [1978] = {.lex_state = 0, .external_lex_state = 2},
  [1979] = {.lex_state = 0},
  [1980] = {.lex_state = 2, .external_lex_state = 2},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 3},
  [1983] = {.lex_state = 0},
  [1984] = {.lex_state = 0},
  [1985] = {.lex_state = 0},
  [1986] = {.lex_state = 0},
  [1987] = {.lex_state = 0},
  [1988] = {.lex_state = 3},
  [1989] = {.lex_state = 3},
  [1990] = {.lex_state = 0},
  [1991] = {.lex_state = 0},
  [1992] = {.lex_state = 3, .external_lex_state = 2},
  [1993] = {.lex_state = 3},
  [1994] = {.lex_state = 0, .external_lex_state = 2},
  [1995] = {.lex_state = 0, .external_lex_state = 2},
  [1996] = {.lex_state = 0},
  [1997] = {.lex_state = 0, .external_lex_state = 2},
  [1998] = {.lex_state = 0, .external_lex_state = 2},
  [1999] = {.lex_state = 0},
  [2000] = {.lex_state = 3},
  [2001] = {.lex_state = 3},
  [2002] = {.lex_state = 0},
  [2003] = {.lex_state = 3},
  [2004] = {.lex_state = 0, .external_lex_state = 2},
  [2005] = {.lex_state = 2, .external_lex_state = 2},
  [2006] = {.lex_state = 3},
  [2007] = {.lex_state = 0},
  [2008] = {.lex_state = 0},
  [2009] = {.lex_state = 0},
  [2010] = {.lex_state = 3},
  [2011] = {.lex_state = 3},
  [2012] = {.lex_state = 0, .external_lex_state = 2},
  [2013] = {.lex_state = 0, .external_lex_state = 2},
  [2014] = {.lex_state = 0, .external_lex_state = 2},
  [2015] = {.lex_state = 0, .external_lex_state = 2},
  [2016] = {.lex_state = 0},
  [2017] = {.lex_state = 3},
  [2018] = {.lex_state = 0, .external_lex_state = 2},
  [2019] = {.lex_state = 0, .external_lex_state = 2},
  [2020] = {.lex_state = 0, .external_lex_state = 2},
  [2021] = {.lex_state = 0, .external_lex_state = 2},
  [2022] = {.lex_state = 0, .external_lex_state = 2},
  [2023] = {.lex_state = 0, .external_lex_state = 2},
  [2024] = {.lex_state = 0, .external_lex_state = 2},
  [2025] = {.lex_state = 0, .external_lex_state = 2},
  [2026] = {.lex_state = 2},
  [2027] = {.lex_state = 3},
  [2028] = {.lex_state = 2},
  [2029] = {.lex_state = 2},
  [2030] = {.lex_state = 2},
  [2031] = {.lex_state = 2},
  [2032] = {.lex_state = 2},
  [2033] = {.lex_state = 2},
  [2034] = {.lex_state = 3, .external_lex_state = 2},
  [2035] = {.lex_state = 3, .external_lex_state = 2},
  [2036] = {.lex_state = 2},
  [2037] = {.lex_state = 2, .external_lex_state = 2},
  [2038] = {.lex_state = 2},
  [2039] = {.lex_state = 2},
  [2040] = {.lex_state = 2},
  [2041] = {.lex_state = 2},
  [2042] = {.lex_state = 2},
  [2043] = {.lex_state = 3},
  [2044] = {.lex_state = 3},
  [2045] = {.lex_state = 3},
  [2046] = {.lex_state = 2},
  [2047] = {.lex_state = 2},
  [2048] = {.lex_state = 2},
  [2049] = {.lex_state = 2},
  [2050] = {.lex_state = 2},
  [2051] = {.lex_state = 2},
  [2052] = {.lex_state = 2},
  [2053] = {.lex_state = 2},
  [2054] = {.lex_state = 4},
  [2055] = {.lex_state = 3},
  [2056] = {.lex_state = 6},
  [2057] = {.lex_state = 3},
  [2058] = {.lex_state = 3},
  [2059] = {.lex_state = 4},
  [2060] = {.lex_state = 3},
  [2061] = {.lex_state = 3},
  [2062] = {.lex_state = 0},
  [2063] = {.lex_state = 2},
  [2064] = {.lex_state = 6},
  [2065] = {.lex_state = 3},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 3},
  [2068] = {.lex_state = 0},
  [2069] = {.lex_state = 3},
  [2070] = {.lex_state = 0},
  [2071] = {.lex_state = 3},
  [2072] = {.lex_state = 15},
  [2073] = {.lex_state = 2},
  [2074] = {.lex_state = 0},
  [2075] = {.lex_state = 0},
  [2076] = {.lex_state = 3},
  [2077] = {.lex_state = 3},
  [2078] = {.lex_state = 3},
  [2079] = {.lex_state = 2},
  [2080] = {.lex_state = 3, .external_lex_state = 2},
  [2081] = {.lex_state = 0},
  [2082] = {.lex_state = 3},
  [2083] = {.lex_state = 0, .external_lex_state = 2},
  [2084] = {.lex_state = 3},
  [2085] = {.lex_state = 0},
  [2086] = {.lex_state = 3},
  [2087] = {.lex_state = 3},
  [2088] = {.lex_state = 13},
  [2089] = {.lex_state = 13},
  [2090] = {.lex_state = 0},
  [2091] = {.lex_state = 0},
  [2092] = {.lex_state = 3},
  [2093] = {.lex_state = 0},
  [2094] = {.lex_state = 3},
  [2095] = {.lex_state = 0},
  [2096] = {.lex_state = 0},
  [2097] = {.lex_state = 3},
  [2098] = {.lex_state = 3},
  [2099] = {.lex_state = 0, .external_lex_state = 2},
  [2100] = {.lex_state = 3},
  [2101] = {.lex_state = 0, .external_lex_state = 2},
  [2102] = {.lex_state = 0},
  [2103] = {.lex_state = 0},
  [2104] = {.lex_state = 3},
  [2105] = {.lex_state = 13},
  [2106] = {.lex_state = 0},
  [2107] = {.lex_state = 0},
  [2108] = {.lex_state = 3},
  [2109] = {.lex_state = 3},
  [2110] = {.lex_state = 0, .external_lex_state = 2},
  [2111] = {.lex_state = 3},
  [2112] = {.lex_state = 0},
  [2113] = {.lex_state = 3},
  [2114] = {.lex_state = 3},
  [2115] = {.lex_state = 2},
  [2116] = {.lex_state = 2},
  [2117] = {.lex_state = 2},
  [2118] = {.lex_state = 2},
  [2119] = {.lex_state = 2},
  [2120] = {.lex_state = 2},
  [2121] = {.lex_state = 2},
  [2122] = {.lex_state = 2},
  [2123] = {.lex_state = 2},
  [2124] = {.lex_state = 2},
  [2125] = {.lex_state = 2},
  [2126] = {.lex_state = 2},
  [2127] = {.lex_state = 3},
  [2128] = {.lex_state = 3},
  [2129] = {.lex_state = 2},
  [2130] = {.lex_state = 2},
  [2131] = {.lex_state = 2},
  [2132] = {.lex_state = 2},
  [2133] = {.lex_state = 2},
  [2134] = {.lex_state = 2},
  [2135] = {.lex_state = 2},
  [2136] = {.lex_state = 2},
  [2137] = {.lex_state = 4},
  [2138] = {.lex_state = 3},
  [2139] = {.lex_state = 6},
  [2140] = {.lex_state = 4},
  [2141] = {.lex_state = 3},
  [2142] = {.lex_state = 3},
  [2143] = {.lex_state = 6},
  [2144] = {.lex_state = 3},
  [2145] = {.lex_state = 3},
  [2146] = {.lex_state = 3},
  [2147] = {.lex_state = 0},
  [2148] = {.lex_state = 3},
  [2149] = {.lex_state = 0},
  [2150] = {.lex_state = 3},
  [2151] = {.lex_state = 3},
  [2152] = {.lex_state = 3},
  [2153] = {.lex_state = 3},
  [2154] = {.lex_state = 0, .external_lex_state = 2},
  [2155] = {.lex_state = 3},
  [2156] = {.lex_state = 0},
  [2157] = {.lex_state = 3},
  [2158] = {.lex_state = 3},
  [2159] = {.lex_state = 13},
  [2160] = {.lex_state = 13},
  [2161] = {.lex_state = 0},
  [2162] = {.lex_state = 0},
  [2163] = {.lex_state = 3},
  [2164] = {.lex_state = 0, .external_lex_state = 2},
  [2165] = {.lex_state = 3},
  [2166] = {.lex_state = 0, .external_lex_state = 2},
  [2167] = {.lex_state = 0},
  [2168] = {.lex_state = 0},
  [2169] = {.lex_state = 3},
  [2170] = {.lex_state = 13},
  [2171] = {.lex_state = 3},
  [2172] = {.lex_state = 0, .external_lex_state = 2},
  [2173] = {.lex_state = 3},
  [2174] = {.lex_state = 3},
  [2175] = {.lex_state = 3},
  [2176] = {.lex_state = 3},
  [2177] = {.lex_state = 4},
  [2178] = {.lex_state = 6},
  [2179] = {.lex_state = 4},
  [2180] = {.lex_state = 3},
  [2181] = {.lex_state = 3},
  [2182] = {.lex_state = 6},
  [2183] = {.lex_state = 3},
  [2184] = {.lex_state = 0},
  [2185] = {.lex_state = 3},
  [2186] = {.lex_state = 3},
  [2187] = {.lex_state = 0},
  [2188] = {.lex_state = 3},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 3},
  [2191] = {.lex_state = 0},
  [2192] = {.lex_state = 3},
  [2193] = {.lex_state = 3},
  [2194] = {.lex_state = 3},
  [2195] = {.lex_state = 3},
  [2196] = {.lex_state = 3},
  [2197] = {.lex_state = 3},
  [2198] = {.lex_state = 3},
  [2199] = {.lex_state = 3},
  [2200] = {.lex_state = 9, .external_lex_state = 2},
  [2201] = {.lex_state = 9, .external_lex_state = 2},
  [2202] = {.lex_state = 9, .external_lex_state = 2},
  [2203] = {.lex_state = 3},
  [2204] = {.lex_state = 3},
  [2205] = {.lex_state = 3},
  [2206] = {.lex_state = 0},
  [2207] = {.lex_state = 9, .external_lex_state = 2},
  [2208] = {.lex_state = 3},
  [2209] = {.lex_state = 9, .external_lex_state = 2},
  [2210] = {.lex_state = 3},
  [2211] = {.lex_state = 9, .external_lex_state = 2},
  [2212] = {.lex_state = 3},
  [2213] = {.lex_state = 9, .external_lex_state = 2},
  [2214] = {.lex_state = 3},
  [2215] = {.lex_state = 0},
  [2216] = {.lex_state = 8},
  [2217] = {.lex_state = 3},
  [2218] = {.lex_state = 9, .external_lex_state = 2},
  [2219] = {.lex_state = 0},
  [2220] = {.lex_state = 3},
  [2221] = {.lex_state = 3},
  [2222] = {.lex_state = 3},
  [2223] = {.lex_state = 3},
  [2224] = {.lex_state = 3},
  [2225] = {.lex_state = 3},
  [2226] = {.lex_state = 3},
  [2227] = {.lex_state = 3},
  [2228] = {.lex_state = 3},
  [2229] = {.lex_state = 9, .external_lex_state = 2},
  [2230] = {.lex_state = 9, .external_lex_state = 2},
  [2231] = {.lex_state = 9, .external_lex_state = 2},
  [2232] = {.lex_state = 9, .external_lex_state = 2},
  [2233] = {.lex_state = 3},
  [2234] = {.lex_state = 9, .external_lex_state = 2},
  [2235] = {.lex_state = 2, .external_lex_state = 2},
  [2236] = {.lex_state = 3},
  [2237] = {.lex_state = 2, .external_lex_state = 2},
  [2238] = {.lex_state = 3},
  [2239] = {.lex_state = 3},
  [2240] = {.lex_state = 13},
  [2241] = {.lex_state = 3},
  [2242] = {.lex_state = 3},
  [2243] = {.lex_state = 2, .external_lex_state = 2},
  [2244] = {.lex_state = 3},
  [2245] = {.lex_state = 0, .external_lex_state = 2},
  [2246] = {.lex_state = 0, .external_lex_state = 2},
  [2247] = {.lex_state = 2, .external_lex_state = 2},
  [2248] = {.lex_state = 0},
  [2249] = {.lex_state = 3},
  [2250] = {.lex_state = 3},
  [2251] = {.lex_state = 3},
  [2252] = {.lex_state = 3},
  [2253] = {.lex_state = 13},
  [2254] = {.lex_state = 3},
  [2255] = {.lex_state = 13},
  [2256] = {.lex_state = 0},
  [2257] = {.lex_state = 0},
  [2258] = {.lex_state = 3},
  [2259] = {.lex_state = 9, .external_lex_state = 2},
  [2260] = {.lex_state = 9, .external_lex_state = 2},
  [2261] = {.lex_state = 9, .external_lex_state = 2},
  [2262] = {.lex_state = 9, .external_lex_state = 2},
  [2263] = {.lex_state = 9, .external_lex_state = 2},
  [2264] = {.lex_state = 3},
  [2265] = {.lex_state = 3},
  [2266] = {.lex_state = 3},
  [2267] = {.lex_state = 2, .external_lex_state = 2},
  [2268] = {.lex_state = 3},
  [2269] = {.lex_state = 3},
  [2270] = {.lex_state = 3},
  [2271] = {.lex_state = 3},
  [2272] = {.lex_state = 3},
  [2273] = {.lex_state = 3},
  [2274] = {.lex_state = 3},
  [2275] = {.lex_state = 3},
  [2276] = {.lex_state = 3},
  [2277] = {.lex_state = 3},
  [2278] = {.lex_state = 3},
  [2279] = {.lex_state = 3},
  [2280] = {.lex_state = 3},
  [2281] = {.lex_state = 3},
  [2282] = {.lex_state = 3},
  [2283] = {.lex_state = 3},
  [2284] = {.lex_state = 13},
  [2285] = {.lex_state = 3},
  [2286] = {.lex_state = 3},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 3},
  [2289] = {.lex_state = 3},
  [2290] = {.lex_state = 3},
  [2291] = {.lex_state = 3},
  [2292] = {.lex_state = 3},
  [2293] = {.lex_state = 3},
  [2294] = {.lex_state = 13},
  [2295] = {.lex_state = 3},
  [2296] = {.lex_state = 0},
  [2297] = {.lex_state = 3},
  [2298] = {.lex_state = 3},
  [2299] = {.lex_state = 3},
  [2300] = {.lex_state = 3},
  [2301] = {.lex_state = 3},
  [2302] = {.lex_state = 3},
  [2303] = {.lex_state = 3},
  [2304] = {.lex_state = 3},
  [2305] = {.lex_state = 3},
  [2306] = {.lex_state = 0},
  [2307] = {.lex_state = 3},
  [2308] = {.lex_state = 13},
  [2309] = {.lex_state = 3},
  [2310] = {.lex_state = 3},
  [2311] = {.lex_state = 3},
  [2312] = {.lex_state = 0, .external_lex_state = 2},
  [2313] = {.lex_state = 3},
  [2314] = {.lex_state = 3},
  [2315] = {.lex_state = 9, .external_lex_state = 2},
  [2316] = {.lex_state = 3},
  [2317] = {.lex_state = 0},
  [2318] = {.lex_state = 0},
  [2319] = {.lex_state = 2},
  [2320] = {.lex_state = 3},
  [2321] = {.lex_state = 3},
  [2322] = {.lex_state = 0, .external_lex_state = 2},
  [2323] = {.lex_state = 0},
  [2324] = {.lex_state = 3},
  [2325] = {.lex_state = 3},
  [2326] = {.lex_state = 0},
  [2327] = {.lex_state = 3},
  [2328] = {.lex_state = 3},
  [2329] = {.lex_state = 3},
  [2330] = {.lex_state = 3},
  [2331] = {.lex_state = 3},
  [2332] = {.lex_state = 3},
  [2333] = {.lex_state = 3},
  [2334] = {.lex_state = 2},
  [2335] = {.lex_state = 3},
  [2336] = {.lex_state = 3},
  [2337] = {.lex_state = 3},
  [2338] = {.lex_state = 3},
  [2339] = {.lex_state = 3},
  [2340] = {.lex_state = 3},
  [2341] = {.lex_state = 3},
  [2342] = {.lex_state = 3},
  [2343] = {.lex_state = 3},
  [2344] = {.lex_state = 9},
  [2345] = {.lex_state = 9},
  [2346] = {.lex_state = 9},
  [2347] = {.lex_state = 9},
  [2348] = {.lex_state = 9},
  [2349] = {.lex_state = 2},
  [2350] = {.lex_state = 2},
  [2351] = {.lex_state = 3},
  [2352] = {.lex_state = 2},
  [2353] = {.lex_state = 2},
  [2354] = {.lex_state = 9},
  [2355] = {.lex_state = 9},
  [2356] = {.lex_state = 9},
  [2357] = {.lex_state = 9},
  [2358] = {.lex_state = 9},
  [2359] = {.lex_state = 2},
  [2360] = {.lex_state = 3},
  [2361] = {.lex_state = 3},
  [2362] = {.lex_state = 3},
  [2363] = {.lex_state = 3},
  [2364] = {.lex_state = 3},
  [2365] = {.lex_state = 3},
  [2366] = {.lex_state = 3},
  [2367] = {.lex_state = 3},
  [2368] = {.lex_state = 3},
  [2369] = {.lex_state = 3},
  [2370] = {.lex_state = 3},
  [2371] = {.lex_state = 3},
  [2372] = {.lex_state = 9},
  [2373] = {.lex_state = 9},
  [2374] = {.lex_state = 3},
  [2375] = {.lex_state = 3},
  [2376] = {.lex_state = 9},
  [2377] = {.lex_state = 3},
  [2378] = {.lex_state = 3},
  [2379] = {.lex_state = 3},
  [2380] = {.lex_state = 9},
  [2381] = {.lex_state = 3, .external_lex_state = 2},
  [2382] = {.lex_state = 3, .external_lex_state = 2},
  [2383] = {.lex_state = 3},
  [2384] = {.lex_state = 3},
  [2385] = {.lex_state = 0},
  [2386] = {.lex_state = 0},
  [2387] = {.lex_state = 0},
  [2388] = {.lex_state = 0},
  [2389] = {.lex_state = 2},
  [2390] = {.lex_state = 8},
  [2391] = {.lex_state = 13},
  [2392] = {.lex_state = 3},
  [2393] = {.lex_state = 3},
  [2394] = {.lex_state = 13},
  [2395] = {.lex_state = 3},
  [2396] = {.lex_state = 13},
  [2397] = {.lex_state = 0},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 3},
  [2400] = {.lex_state = 3},
  [2401] = {.lex_state = 3},
  [2402] = {.lex_state = 13},
  [2403] = {.lex_state = 3},
  [2404] = {.lex_state = 0},
  [2405] = {.lex_state = 0},
  [2406] = {.lex_state = 0},
  [2407] = {.lex_state = 3},
  [2408] = {.lex_state = 3},
  [2409] = {.lex_state = 2},
  [2410] = {.lex_state = 3},
  [2411] = {.lex_state = 3},
  [2412] = {.lex_state = 3},
  [2413] = {.lex_state = 3},
  [2414] = {.lex_state = 3},
  [2415] = {.lex_state = 3},
  [2416] = {.lex_state = 3},
  [2417] = {.lex_state = 3},
  [2418] = {.lex_state = 3},
  [2419] = {.lex_state = 9},
  [2420] = {.lex_state = 9},
  [2421] = {.lex_state = 9},
  [2422] = {.lex_state = 9},
  [2423] = {.lex_state = 9},
  [2424] = {.lex_state = 2},
  [2425] = {.lex_state = 2},
  [2426] = {.lex_state = 3},
  [2427] = {.lex_state = 2},
  [2428] = {.lex_state = 2},
  [2429] = {.lex_state = 9},
  [2430] = {.lex_state = 9},
  [2431] = {.lex_state = 9},
  [2432] = {.lex_state = 9},
  [2433] = {.lex_state = 2},
  [2434] = {.lex_state = 3},
  [2435] = {.lex_state = 3},
  [2436] = {.lex_state = 3},
  [2437] = {.lex_state = 3},
  [2438] = {.lex_state = 3},
  [2439] = {.lex_state = 3},
  [2440] = {.lex_state = 3},
  [2441] = {.lex_state = 3},
  [2442] = {.lex_state = 3},
  [2443] = {.lex_state = 3},
  [2444] = {.lex_state = 3},
  [2445] = {.lex_state = 3},
  [2446] = {.lex_state = 9},
  [2447] = {.lex_state = 9},
  [2448] = {.lex_state = 3},
  [2449] = {.lex_state = 3},
  [2450] = {.lex_state = 9},
  [2451] = {.lex_state = 3},
  [2452] = {.lex_state = 9},
  [2453] = {.lex_state = 3},
  [2454] = {.lex_state = 0},
  [2455] = {.lex_state = 0},
  [2456] = {.lex_state = 0},
  [2457] = {.lex_state = 0},
  [2458] = {.lex_state = 2},
  [2459] = {.lex_state = 13},
  [2460] = {.lex_state = 13},
  [2461] = {.lex_state = 3},
  [2462] = {.lex_state = 13},
  [2463] = {.lex_state = 0},
  [2464] = {.lex_state = 0},
  [2465] = {.lex_state = 3},
  [2466] = {.lex_state = 13},
  [2467] = {.lex_state = 3},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 3},
  [2470] = {.lex_state = 3},
  [2471] = {.lex_state = 3},
  [2472] = {.lex_state = 3},
  [2473] = {.lex_state = 3},
  [2474] = {.lex_state = 3},
  [2475] = {.lex_state = 9},
  [2476] = {.lex_state = 9},
  [2477] = {.lex_state = 9},
  [2478] = {.lex_state = 9},
  [2479] = {.lex_state = 9},
  [2480] = {.lex_state = 3},
  [2481] = {.lex_state = 9},
  [2482] = {.lex_state = 9},
  [2483] = {.lex_state = 9},
  [2484] = {.lex_state = 9},
  [2485] = {.lex_state = 3},
  [2486] = {.lex_state = 3},
  [2487] = {.lex_state = 3},
  [2488] = {.lex_state = 3},
  [2489] = {.lex_state = 3},
  [2490] = {.lex_state = 3},
  [2491] = {.lex_state = 3},
  [2492] = {.lex_state = 3},
  [2493] = {.lex_state = 3},
  [2494] = {.lex_state = 3},
  [2495] = {.lex_state = 3},
  [2496] = {.lex_state = 3},
  [2497] = {.lex_state = 3},
  [2498] = {.lex_state = 3},
  [2499] = {.lex_state = 3},
  [2500] = {.lex_state = 9},
  [2501] = {.lex_state = 3},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 0},
  [2506] = {.lex_state = 2},
  [2507] = {.lex_state = 3},
  [2508] = {.lex_state = 0},
  [2509] = {.lex_state = 3},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 3},
  [2512] = {.lex_state = 3},
  [2513] = {.lex_state = 3},
  [2514] = {.lex_state = 3},
  [2515] = {.lex_state = 2, .external_lex_state = 2},
  [2516] = {.lex_state = 3},
  [2517] = {.lex_state = 3},
  [2518] = {.lex_state = 3},
  [2519] = {.lex_state = 3},
  [2520] = {.lex_state = 3},
  [2521] = {.lex_state = 9, .external_lex_state = 2},
  [2522] = {.lex_state = 2, .external_lex_state = 2},
  [2523] = {.lex_state = 3},
  [2524] = {.lex_state = 0},
  [2525] = {.lex_state = 2, .external_lex_state = 2},
  [2526] = {.lex_state = 3},
  [2527] = {.lex_state = 3},
  [2528] = {.lex_state = 3},
  [2529] = {.lex_state = 3},
  [2530] = {.lex_state = 3},
  [2531] = {.lex_state = 3},
  [2532] = {.lex_state = 3},
  [2533] = {.lex_state = 0},
  [2534] = {.lex_state = 0},
  [2535] = {.lex_state = 3},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 3},
  [2538] = {.lex_state = 3},
  [2539] = {.lex_state = 3},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 3},
  [2542] = {.lex_state = 9},
  [2543] = {.lex_state = 2},
  [2544] = {.lex_state = 3},
  [2545] = {.lex_state = 3},
  [2546] = {.lex_state = 3},
  [2547] = {.lex_state = 3},
  [2548] = {.lex_state = 2},
  [2549] = {.lex_state = 3},
  [2550] = {.lex_state = 0},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 9},
  [2553] = {.lex_state = 9},
  [2554] = {.lex_state = 9},
  [2555] = {.lex_state = 9},
  [2556] = {.lex_state = 9},
  [2557] = {.lex_state = 3, .external_lex_state = 2},
  [2558] = {.lex_state = 3},
  [2559] = {.lex_state = 3, .external_lex_state = 2},
  [2560] = {.lex_state = 3},
  [2561] = {.lex_state = 3},
  [2562] = {.lex_state = 9},
  [2563] = {.lex_state = 2},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 3},
  [2566] = {.lex_state = 3},
  [2567] = {.lex_state = 3, .external_lex_state = 2},
  [2568] = {.lex_state = 3},
  [2569] = {.lex_state = 3},
  [2570] = {.lex_state = 3},
  [2571] = {.lex_state = 3, .external_lex_state = 2},
  [2572] = {.lex_state = 3},
  [2573] = {.lex_state = 3},
  [2574] = {.lex_state = 3},
  [2575] = {.lex_state = 3},
  [2576] = {.lex_state = 2},
  [2577] = {.lex_state = 3},
  [2578] = {.lex_state = 3},
  [2579] = {.lex_state = 9},
  [2580] = {.lex_state = 2},
  [2581] = {.lex_state = 3},
  [2582] = {.lex_state = 2},
  [2583] = {.lex_state = 9},
  [2584] = {.lex_state = 3},
  [2585] = {.lex_state = 2},
  [2586] = {.lex_state = 2},
  [2587] = {.lex_state = 2},
  [2588] = {.lex_state = 2},
  [2589] = {.lex_state = 2},
  [2590] = {.lex_state = 2},
  [2591] = {.lex_state = 3},
  [2592] = {.lex_state = 3},
  [2593] = {.lex_state = 2},
  [2594] = {.lex_state = 2},
  [2595] = {.lex_state = 2},
  [2596] = {.lex_state = 2},
  [2597] = {.lex_state = 2},
  [2598] = {.lex_state = 2},
  [2599] = {.lex_state = 2},
  [2600] = {.lex_state = 2},
  [2601] = {.lex_state = 2},
  [2602] = {.lex_state = 2},
  [2603] = {.lex_state = 2},
  [2604] = {.lex_state = 2},
  [2605] = {.lex_state = 2},
  [2606] = {.lex_state = 2},
  [2607] = {.lex_state = 2},
  [2608] = {.lex_state = 2},
  [2609] = {.lex_state = 2},
  [2610] = {.lex_state = 2},
  [2611] = {.lex_state = 2},
  [2612] = {.lex_state = 3},
  [2613] = {.lex_state = 3},
  [2614] = {.lex_state = 3},
  [2615] = {.lex_state = 9},
  [2616] = {.lex_state = 2},
  [2617] = {.lex_state = 2},
  [2618] = {.lex_state = 9},
  [2619] = {.lex_state = 2},
  [2620] = {.lex_state = 2},
  [2621] = {.lex_state = 3},
  [2622] = {.lex_state = 3},
  [2623] = {.lex_state = 3},
  [2624] = {.lex_state = 3},
  [2625] = {.lex_state = 3},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 3},
  [2628] = {.lex_state = 3},
  [2629] = {.lex_state = 3},
  [2630] = {.lex_state = 3},
  [2631] = {.lex_state = 3},
  [2632] = {.lex_state = 3},
  [2633] = {.lex_state = 3},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
  },
  [1] = {
    [sym_generator_function_declaration] = STATE(62),
    [sym__declaration] = STATE(62),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(62),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(62),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(62),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(62),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(62),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(62),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(62),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(62),
    [sym_function_declaration] = STATE(62),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(62),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(62),
    [sym_break_statement] = STATE(62),
    [sym_labeled_statement] = STATE(62),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(62),
    [sym_class_declaration] = STATE(62),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(62),
    [sym_ambient_declaration] = STATE(62),
    [sym_type_alias_declaration] = STATE(62),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(62),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(62),
    [sym_program] = STATE(59),
    [sym_switch_statement] = STATE(62),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(62),
    [sym_throw_statement] = STATE(62),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(62),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(62),
    [sym_abstract_class_declaration] = STATE(62),
    [sym_interface_declaration] = STATE(62),
    [sym_export_statement] = STATE(62),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(62),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(62),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(62),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(62),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [sym_hash_bang_line] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(93),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [3] = {
    [aux_sym_template_string_repeat1] = STATE(73),
    [sym_template_substitution] = STATE(73),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(125),
    [sym__template_chars] = ACTIONS(127),
    [sym_escape_sequence] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__automatic_semicolon] = ACTIONS(129),
    [anon_sym_SEMI] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [6] = {
    [sym_decorator_member_expression] = STATE(80),
    [sym_decorator_call_expression] = STATE(81),
    [sym_identifier] = ACTIONS(143),
    [anon_sym_module] = ACTIONS(145),
    [anon_sym_symbol] = ACTIONS(145),
    [anon_sym_number] = ACTIONS(145),
    [anon_sym_declare] = ACTIONS(145),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_any] = ACTIONS(145),
    [anon_sym_private] = ACTIONS(145),
    [anon_sym_boolean] = ACTIONS(145),
    [anon_sym_async] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(145),
    [anon_sym_get] = ACTIONS(145),
    [anon_sym_static] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(145),
    [anon_sym_string] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_type] = ACTIONS(145),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_namespace] = ACTIONS(145),
  },
  [7] = {
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_function] = STATE(52),
    [sym_import] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(91),
    [sym_string] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(91),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_new_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(91),
    [sym_class] = STATE(91),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(153),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(153),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(153),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(153),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(165),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [8] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [9] = {
    [sym__automatic_semicolon] = ACTIONS(179),
    [sym_identifier] = ACTIONS(181),
    [anon_sym_SEMI] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(99),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [11] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [12] = {
    [sym_arrow_function] = STATE(108),
    [sym_await_expression] = STATE(108),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(107),
    [sym_meta_property] = STATE(108),
    [sym_update_expression] = STATE(108),
    [sym__expression] = STATE(108),
    [sym_function] = STATE(52),
    [sym_import] = STATE(108),
    [sym_call_expression] = STATE(108),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(108),
    [sym_string] = STATE(108),
    [sym_template_string] = STATE(108),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(108),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(108),
    [sym_generator_function] = STATE(108),
    [sym_new_expression] = STATE(108),
    [sym_assignment_expression] = STATE(108),
    [sym_augmented_assignment_expression] = STATE(108),
    [sym_binary_expression] = STATE(108),
    [sym_unary_expression] = STATE(108),
    [sym_regex] = STATE(108),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(108),
    [sym_as_expression] = STATE(108),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(108),
    [sym_class] = STATE(108),
    [sym__automatic_semicolon] = ACTIONS(193),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(195),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(197),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [13] = {
    [sym_identifier] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_identifier] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [16] = {
    [sym__automatic_semicolon] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_SEMI] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_arrow_function] = STATE(113),
    [sym_await_expression] = STATE(113),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(113),
    [sym_meta_property] = STATE(113),
    [sym__expression] = STATE(113),
    [sym_function] = STATE(52),
    [sym_import] = STATE(113),
    [sym_call_expression] = STATE(113),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(113),
    [sym_string] = STATE(113),
    [sym_template_string] = STATE(113),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(113),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(113),
    [sym_generator_function] = STATE(113),
    [sym_new_expression] = STATE(113),
    [sym_assignment_expression] = STATE(113),
    [sym_augmented_assignment_expression] = STATE(113),
    [sym_binary_expression] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_regex] = STATE(113),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(113),
    [sym_as_expression] = STATE(113),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(113),
    [sym_class] = STATE(113),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(207),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(207),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(207),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [18] = {
    [sym_parenthesized_expression] = STATE(115),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_arrow_function] = STATE(117),
    [sym_await_expression] = STATE(117),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(117),
    [sym_meta_property] = STATE(117),
    [sym__expression] = STATE(117),
    [sym_function] = STATE(52),
    [sym_import] = STATE(117),
    [sym_call_expression] = STATE(117),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(117),
    [sym_string] = STATE(117),
    [sym_template_string] = STATE(117),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(117),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(117),
    [sym_generator_function] = STATE(117),
    [sym_new_expression] = STATE(117),
    [sym_assignment_expression] = STATE(117),
    [sym_augmented_assignment_expression] = STATE(117),
    [sym_binary_expression] = STATE(117),
    [sym_unary_expression] = STATE(117),
    [sym_regex] = STATE(117),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(117),
    [sym_as_expression] = STATE(117),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(117),
    [sym_class] = STATE(117),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(217),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(219),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [sym_null] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(219),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(219),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(221),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [20] = {
    [sym_arrow_function] = STATE(119),
    [sym_await_expression] = STATE(119),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(118),
    [sym_meta_property] = STATE(119),
    [sym_update_expression] = STATE(119),
    [sym__expression] = STATE(119),
    [sym_function] = STATE(52),
    [sym_import] = STATE(119),
    [sym_call_expression] = STATE(119),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(119),
    [sym_string] = STATE(119),
    [sym_template_string] = STATE(119),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(119),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(119),
    [sym_generator_function] = STATE(119),
    [sym_new_expression] = STATE(119),
    [sym_assignment_expression] = STATE(119),
    [sym_augmented_assignment_expression] = STATE(119),
    [sym_binary_expression] = STATE(119),
    [sym_unary_expression] = STATE(119),
    [sym_regex] = STATE(119),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(119),
    [sym_as_expression] = STATE(119),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(119),
    [sym_class] = STATE(119),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(223),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(223),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(223),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(223),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(225),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(223),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [21] = {
    [anon_sym_class] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [23] = {
    [sym_namespace_import] = STATE(126),
    [sym_named_imports] = STATE(126),
    [sym_import_require_clause] = STATE(127),
    [sym_string] = STATE(127),
    [sym_import_clause] = STATE(128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [sym__automatic_semicolon] = ACTIONS(231),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(235),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_instanceof] = ACTIONS(235),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_type] = ACTIONS(239),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_typeof] = ACTIONS(239),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
  },
  [24] = {
    [sym_nested_identifier] = STATE(129),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [25] = {
    [aux_sym_string_repeat1] = STATE(133),
    [sym_escape_sequence] = ACTIONS(249),
    [aux_sym_string_token1] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(253),
    [sym_comment] = ACTIONS(255),
  },
  [26] = {
    [sym_arrow_function] = STATE(134),
    [sym_await_expression] = STATE(134),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(134),
    [sym_meta_property] = STATE(134),
    [sym__expression] = STATE(134),
    [sym_function] = STATE(52),
    [sym_import] = STATE(134),
    [sym_call_expression] = STATE(134),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(134),
    [sym_string] = STATE(134),
    [sym_template_string] = STATE(134),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(134),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(134),
    [sym_generator_function] = STATE(134),
    [sym_new_expression] = STATE(134),
    [sym_assignment_expression] = STATE(134),
    [sym_augmented_assignment_expression] = STATE(134),
    [sym_binary_expression] = STATE(134),
    [sym_unary_expression] = STATE(134),
    [sym_regex] = STATE(134),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(134),
    [sym_as_expression] = STATE(134),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(134),
    [sym_class] = STATE(134),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(257),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(257),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(257),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(257),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(259),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(257),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [27] = {
    [sym__for_header] = STATE(137),
    [anon_sym_LPAREN] = ACTIONS(261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(263),
  },
  [28] = {
    [sym_arrow_function] = STATE(141),
    [sym_await_expression] = STATE(141),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(141),
    [sym_meta_property] = STATE(141),
    [sym__expression] = STATE(141),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(141),
    [sym_call_expression] = STATE(141),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(142),
    [sym_ternary_expression] = STATE(141),
    [sym_string] = STATE(141),
    [sym_template_string] = STATE(141),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(141),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(141),
    [sym_generator_function] = STATE(141),
    [sym_new_expression] = STATE(141),
    [sym_assignment_expression] = STATE(141),
    [sym_augmented_assignment_expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_unary_expression] = STATE(141),
    [sym_regex] = STATE(141),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(141),
    [sym_as_expression] = STATE(141),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(141),
    [sym_class] = STATE(141),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(283),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(283),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(283),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(311),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(283),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [29] = {
    [sym_identifier] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [anon_sym_debugger] = ACTIONS(321),
    [anon_sym_symbol] = ACTIONS(321),
    [anon_sym_AT] = ACTIONS(323),
    [anon_sym_DASH] = ACTIONS(321),
    [anon_sym_void] = ACTIONS(321),
    [anon_sym_break] = ACTIONS(321),
    [anon_sym_const] = ACTIONS(321),
    [sym_super] = ACTIONS(321),
    [anon_sym_return] = ACTIONS(321),
    [anon_sym_private] = ACTIONS(321),
    [anon_sym_static] = ACTIONS(321),
    [anon_sym_get] = ACTIONS(321),
    [anon_sym_RBRACE] = ACTIONS(323),
    [anon_sym_interface] = ACTIONS(321),
    [anon_sym_default] = ACTIONS(321),
    [anon_sym_enum] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(321),
    [anon_sym_continue] = ACTIONS(321),
    [anon_sym_DASH_DASH] = ACTIONS(323),
    [anon_sym_if] = ACTIONS(321),
    [sym_this] = ACTIONS(321),
    [anon_sym_yield] = ACTIONS(321),
    [sym_true] = ACTIONS(321),
    [anon_sym_throw] = ACTIONS(321),
    [anon_sym_protected] = ACTIONS(321),
    [anon_sym_abstract] = ACTIONS(321),
    [anon_sym_set] = ACTIONS(321),
    [anon_sym_type] = ACTIONS(321),
    [anon_sym_import] = ACTIONS(321),
    [anon_sym_namespace] = ACTIONS(321),
    [anon_sym_PLUS_PLUS] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_else] = ACTIONS(321),
    [anon_sym_BANG] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LBRACK] = ACTIONS(323),
    [sym_false] = ACTIONS(321),
    [anon_sym_SEMI] = ACTIONS(323),
    [anon_sym_case] = ACTIONS(321),
    [anon_sym_module] = ACTIONS(321),
    [anon_sym_number] = ACTIONS(321),
    [anon_sym_class] = ACTIONS(321),
    [anon_sym_declare] = ACTIONS(321),
    [anon_sym_typeof] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(323),
    [anon_sym_switch] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(323),
    [sym_null] = ACTIONS(321),
    [anon_sym_any] = ACTIONS(321),
    [anon_sym_boolean] = ACTIONS(321),
    [anon_sym_async] = ACTIONS(321),
    [anon_sym_public] = ACTIONS(321),
    [anon_sym_var] = ACTIONS(321),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_SQUOTE] = ACTIONS(323),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(323),
    [sym_number] = ACTIONS(323),
    [anon_sym_SLASH] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(321),
    [anon_sym_function] = ACTIONS(321),
    [sym_undefined] = ACTIONS(321),
    [anon_sym_new] = ACTIONS(321),
    [ts_builtin_sym_end] = ACTIONS(323),
    [anon_sym_let] = ACTIONS(321),
    [anon_sym_PLUS] = ACTIONS(321),
    [anon_sym_export] = ACTIONS(321),
    [anon_sym_do] = ACTIONS(321),
    [anon_sym_TILDE] = ACTIONS(323),
    [anon_sym_with] = ACTIONS(321),
    [anon_sym_await] = ACTIONS(321),
  },
  [30] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [31] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(333),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [32] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [33] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_enum_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_type_arguments] = STATE(56),
    [sym_continue_statement] = STATE(187),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_internal_module] = STATE(55),
    [sym_class_declaration] = STATE(187),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(187),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(373),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_void] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_static] = ACTIONS(383),
    [anon_sym_get] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(389),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(391),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(395),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_number] = ACTIONS(373),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(399),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(373),
    [anon_sym_boolean] = ACTIONS(373),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_public] = ACTIONS(381),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(373),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(405),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [34] = {
    [sym_parenthesized_expression] = STATE(191),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(205),
    [sym_update_expression] = STATE(205),
    [sym_meta_property] = STATE(205),
    [sym__expression] = STATE(205),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_ternary_expression] = STATE(205),
    [sym_template_string] = STATE(205),
    [sym_yield_expression] = STATE(205),
    [sym_type_assertion] = STATE(205),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(205),
    [sym_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(205),
    [sym_internal_module] = STATE(205),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(205),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(204),
    [sym__call_signature] = STATE(1792),
    [sym_subscript_expression] = STATE(1251),
    [sym_string] = STATE(205),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(205),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(205),
    [sym_class] = STATE(205),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(409),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(413),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(409),
    [anon_sym_get] = ACTIONS(409),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(417),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(419),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_set] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(409),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(423),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(409),
    [anon_sym_number] = ACTIONS(409),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(419),
    [anon_sym_any] = ACTIONS(409),
    [anon_sym_boolean] = ACTIONS(409),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(431),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(409),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [36] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(435),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [37] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(215),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [38] = {
    [sym_generator_function_declaration] = STATE(216),
    [sym__declaration] = STATE(216),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(216),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(216),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(216),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(216),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(216),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(216),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(216),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(216),
    [sym_function_declaration] = STATE(216),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(216),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(216),
    [sym_break_statement] = STATE(216),
    [sym_labeled_statement] = STATE(216),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(216),
    [sym_class_declaration] = STATE(216),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(216),
    [sym_ambient_declaration] = STATE(216),
    [sym_type_alias_declaration] = STATE(216),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(216),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(216),
    [sym_switch_statement] = STATE(216),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(216),
    [sym_throw_statement] = STATE(216),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(216),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(216),
    [sym_abstract_class_declaration] = STATE(216),
    [sym_interface_declaration] = STATE(216),
    [sym_export_statement] = STATE(216),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(216),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(216),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(216),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(216),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(447),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [39] = {
    [sym_parenthesized_expression] = STATE(217),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [aux_sym_string_repeat2] = STATE(218),
    [sym_escape_sequence] = ACTIONS(449),
    [aux_sym_string_token2] = ACTIONS(451),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(253),
  },
  [41] = {
    [sym_statement_block] = STATE(220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [42] = {
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(240),
    [sym_function_type] = STATE(240),
    [sym_constructor_type] = STATE(240),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(236),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_type_parameter] = STATE(239),
    [sym__type] = STATE(240),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_identifier] = ACTIONS(455),
    [sym_false] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_symbol] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [sym_true] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_keyof] = ACTIONS(477),
    [sym_number] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(467),
  },
  [43] = {
    [sym_regex_pattern] = ACTIONS(489),
    [sym_comment] = ACTIONS(255),
  },
  [44] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(245),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(495),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_arrow_function] = STATE(247),
    [sym_await_expression] = STATE(254),
    [sym_member_expression] = STATE(253),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(254),
    [sym_meta_property] = STATE(247),
    [sym__expression] = STATE(254),
    [sym_function] = STATE(255),
    [sym_import] = STATE(247),
    [sym_call_expression] = STATE(254),
    [sym_subscript_expression] = STATE(253),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(254),
    [sym_string] = STATE(247),
    [sym_template_string] = STATE(247),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(254),
    [sym_object] = STATE(256),
    [sym_type_assertion] = STATE(254),
    [sym_generator_function] = STATE(247),
    [sym_new_expression] = STATE(247),
    [sym_assignment_expression] = STATE(254),
    [sym_augmented_assignment_expression] = STATE(254),
    [sym_binary_expression] = STATE(254),
    [sym_unary_expression] = STATE(254),
    [sym_regex] = STATE(247),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(253),
    [sym_non_null_expression] = STATE(254),
    [sym_as_expression] = STATE(254),
    [sym_array] = STATE(257),
    [sym_internal_module] = STATE(254),
    [sym_class] = STATE(247),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(499),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(503),
    [sym_super] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_get] = ACTIONS(499),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(511),
    [anon_sym_protected] = ACTIONS(499),
    [anon_sym_DOT] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(499),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(511),
    [anon_sym_module] = ACTIONS(499),
    [anon_sym_number] = ACTIONS(499),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(499),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(511),
    [anon_sym_any] = ACTIONS(499),
    [anon_sym_boolean] = ACTIONS(499),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_public] = ACTIONS(499),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(499),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [46] = {
    [sym_array] = STATE(100),
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(99),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [47] = {
    [sym_class_declaration] = STATE(264),
    [sym_generator_function_declaration] = STATE(264),
    [sym__declaration] = STATE(264),
    [sym_enum_declaration] = STATE(264),
    [sym_function_signature] = STATE(264),
    [sym_abstract_class_declaration] = STATE(264),
    [sym_module] = STATE(264),
    [sym_interface_declaration] = STATE(264),
    [sym_function_declaration] = STATE(264),
    [sym_export_clause] = STATE(265),
    [sym_variable_declaration] = STATE(264),
    [sym_lexical_declaration] = STATE(264),
    [sym_ambient_declaration] = STATE(264),
    [sym_import_alias] = STATE(264),
    [sym_type_alias_declaration] = STATE(264),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(264),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(531),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(117),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(535),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [48] = {
    [sym_generator_function_declaration] = STATE(266),
    [sym__declaration] = STATE(266),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(266),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(266),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(266),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(266),
    [sym_function_declaration] = STATE(266),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(266),
    [sym_class_declaration] = STATE(266),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(266),
    [sym_ambient_declaration] = STATE(266),
    [sym_type_alias_declaration] = STATE(266),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(266),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(266),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(266),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class_declaration] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_export_statement] = STATE(266),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(266),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(266),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [49] = {
    [sym_parenthesized_expression] = STATE(267),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_arrow_function] = STATE(268),
    [sym_await_expression] = STATE(268),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(268),
    [sym_meta_property] = STATE(268),
    [sym__expression] = STATE(268),
    [sym_function] = STATE(52),
    [sym_import] = STATE(268),
    [sym_call_expression] = STATE(268),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(268),
    [sym_string] = STATE(268),
    [sym_template_string] = STATE(268),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(268),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(268),
    [sym_generator_function] = STATE(268),
    [sym_new_expression] = STATE(268),
    [sym_assignment_expression] = STATE(268),
    [sym_augmented_assignment_expression] = STATE(268),
    [sym_binary_expression] = STATE(268),
    [sym_unary_expression] = STATE(268),
    [sym_regex] = STATE(268),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(268),
    [sym_as_expression] = STATE(268),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(268),
    [sym_class] = STATE(268),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(573),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(573),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(573),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(573),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(573),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [51] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(577),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(577),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [52] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [53] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [54] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(611),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [55] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(613),
    [anon_sym_symbol] = ACTIONS(615),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_break] = ACTIONS(615),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_static] = ACTIONS(615),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_interface] = ACTIONS(615),
    [anon_sym_as] = ACTIONS(113),
    [anon_sym_delete] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(615),
    [anon_sym_instanceof] = ACTIONS(113),
    [anon_sym_yield] = ACTIONS(615),
    [sym_true] = ACTIONS(615),
    [anon_sym_protected] = ACTIONS(615),
    [anon_sym_DOT] = ACTIONS(113),
    [anon_sym_set] = ACTIONS(615),
    [anon_sym_import] = ACTIONS(615),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_DQUOTE] = ACTIONS(613),
    [anon_sym_for] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(613),
    [anon_sym_number] = ACTIONS(615),
    [anon_sym_typeof] = ACTIONS(615),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_switch] = ACTIONS(615),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [sym_null] = ACTIONS(615),
    [anon_sym_any] = ACTIONS(615),
    [anon_sym_async] = ACTIONS(615),
    [anon_sym_public] = ACTIONS(615),
    [anon_sym_var] = ACTIONS(615),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(615),
    [anon_sym_SQUOTE] = ACTIONS(613),
    [anon_sym_SLASH] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(615),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_export] = ACTIONS(615),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_with] = ACTIONS(615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [sym_identifier] = ACTIONS(615),
    [anon_sym_debugger] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_void] = ACTIONS(615),
    [anon_sym_const] = ACTIONS(615),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [sym_super] = ACTIONS(615),
    [anon_sym_private] = ACTIONS(615),
    [anon_sym_get] = ACTIONS(615),
    [anon_sym_default] = ACTIONS(615),
    [anon_sym_enum] = ACTIONS(615),
    [anon_sym_continue] = ACTIONS(615),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [anon_sym_throw] = ACTIONS(615),
    [anon_sym_abstract] = ACTIONS(615),
    [anon_sym_type] = ACTIONS(615),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_namespace] = ACTIONS(615),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_else] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(615),
    [anon_sym_LBRACK] = ACTIONS(613),
    [sym_false] = ACTIONS(615),
    [anon_sym_case] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_class] = ACTIONS(615),
    [anon_sym_declare] = ACTIONS(615),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_boolean] = ACTIONS(615),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_try] = ACTIONS(615),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(615),
    [sym_number] = ACTIONS(613),
    [ts_builtin_sym_end] = ACTIONS(613),
    [anon_sym_function] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_let] = ACTIONS(615),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_do] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(613),
    [anon_sym_await] = ACTIONS(615),
  },
  [56] = {
    [sym_arrow_function] = STATE(283),
    [sym_await_expression] = STATE(283),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(283),
    [sym_meta_property] = STATE(283),
    [sym__expression] = STATE(283),
    [sym_function] = STATE(52),
    [sym_import] = STATE(283),
    [sym_call_expression] = STATE(283),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(283),
    [sym_string] = STATE(283),
    [sym_template_string] = STATE(283),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(283),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(283),
    [sym_generator_function] = STATE(283),
    [sym_new_expression] = STATE(283),
    [sym_assignment_expression] = STATE(283),
    [sym_augmented_assignment_expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_regex] = STATE(283),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(283),
    [sym_as_expression] = STATE(283),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(283),
    [sym_class] = STATE(283),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(617),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(617),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(617),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(617),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(619),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(617),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [57] = {
    [sym__automatic_semicolon] = ACTIONS(577),
    [anon_sym_SEMI] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [anon_sym_EQ_GT] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_formal_parameters] = STATE(285),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_type_annotation] = STATE(287),
    [anon_sym_EQ_GT] = ACTIONS(625),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(625),
  },
  [62] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(447),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [63] = {
    [anon_sym_LBRACK] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_symbol] = ACTIONS(631),
    [anon_sym_number] = ACTIONS(631),
    [anon_sym_class] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(629),
    [anon_sym_declare] = ACTIONS(631),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(629),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_void] = ACTIONS(631),
    [anon_sym_any] = ACTIONS(631),
    [anon_sym_private] = ACTIONS(631),
    [anon_sym_boolean] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(631),
    [anon_sym_async] = ACTIONS(631),
    [anon_sym_get] = ACTIONS(631),
    [anon_sym_public] = ACTIONS(631),
    [sym_this] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [anon_sym_set] = ACTIONS(631),
    [anon_sym_type] = ACTIONS(631),
    [anon_sym_export] = ACTIONS(631),
    [sym_readonly] = ACTIONS(631),
    [anon_sym_namespace] = ACTIONS(631),
  },
  [64] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(633),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [65] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(635),
    [anon_sym_class] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_arrow_function] = STATE(294),
    [sym_await_expression] = STATE(294),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(293),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(294),
    [sym_meta_property] = STATE(294),
    [sym__expression] = STATE(294),
    [sym_function] = STATE(52),
    [sym_import] = STATE(294),
    [sym_call_expression] = STATE(294),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(294),
    [sym_string] = STATE(294),
    [sym_template_string] = STATE(294),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(294),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(294),
    [sym_generator_function] = STATE(294),
    [sym_new_expression] = STATE(294),
    [sym_assignment_expression] = STATE(294),
    [sym_augmented_assignment_expression] = STATE(294),
    [sym_binary_expression] = STATE(294),
    [sym_unary_expression] = STATE(294),
    [sym_regex] = STATE(294),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(294),
    [sym_as_expression] = STATE(294),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(294),
    [sym_class] = STATE(294),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(639),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(639),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(639),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(643),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(639),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [67] = {
    [sym_arrow_function] = STATE(295),
    [sym_await_expression] = STATE(295),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(295),
    [sym_meta_property] = STATE(295),
    [sym__expression] = STATE(295),
    [sym_function] = STATE(52),
    [sym_import] = STATE(295),
    [sym_call_expression] = STATE(295),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(295),
    [sym_string] = STATE(295),
    [sym_template_string] = STATE(295),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(295),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(295),
    [sym_generator_function] = STATE(295),
    [sym_new_expression] = STATE(295),
    [sym_assignment_expression] = STATE(295),
    [sym_augmented_assignment_expression] = STATE(295),
    [sym_binary_expression] = STATE(295),
    [sym_unary_expression] = STATE(295),
    [sym_regex] = STATE(295),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(295),
    [sym_as_expression] = STATE(295),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(295),
    [sym_class] = STATE(295),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(645),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(645),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(645),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(645),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(647),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [68] = {
    [sym_generator_function_declaration] = STATE(296),
    [sym__declaration] = STATE(296),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(296),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(296),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(296),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(296),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(296),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(296),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(296),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(296),
    [sym_function_declaration] = STATE(296),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(296),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(296),
    [sym_break_statement] = STATE(296),
    [sym_labeled_statement] = STATE(296),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(296),
    [sym_class_declaration] = STATE(296),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(296),
    [sym_ambient_declaration] = STATE(296),
    [sym_type_alias_declaration] = STATE(296),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(296),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(296),
    [sym_switch_statement] = STATE(296),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(296),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(296),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(296),
    [sym_abstract_class_declaration] = STATE(296),
    [sym_interface_declaration] = STATE(296),
    [sym_export_statement] = STATE(296),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(296),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(296),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(296),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(296),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [69] = {
    [sym_arrow_function] = STATE(297),
    [sym_await_expression] = STATE(297),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(297),
    [sym_meta_property] = STATE(297),
    [sym__expression] = STATE(297),
    [sym_function] = STATE(52),
    [sym_import] = STATE(297),
    [sym_call_expression] = STATE(297),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(297),
    [sym_string] = STATE(297),
    [sym_template_string] = STATE(297),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(297),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(297),
    [sym_generator_function] = STATE(297),
    [sym_new_expression] = STATE(297),
    [sym_assignment_expression] = STATE(297),
    [sym_augmented_assignment_expression] = STATE(297),
    [sym_binary_expression] = STATE(297),
    [sym_unary_expression] = STATE(297),
    [sym_regex] = STATE(297),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(297),
    [sym_as_expression] = STATE(297),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(297),
    [sym_class] = STATE(297),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(649),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(649),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(649),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(649),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(651),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(649),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [70] = {
    [sym_identifier] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_arrow_function] = STATE(300),
    [sym_await_expression] = STATE(300),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(299),
    [sym_meta_property] = STATE(300),
    [sym_update_expression] = STATE(300),
    [sym__expression] = STATE(300),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(300),
    [sym_call_expression] = STATE(300),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(300),
    [sym_string] = STATE(300),
    [sym_template_string] = STATE(300),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(300),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_new_expression] = STATE(300),
    [sym_assignment_expression] = STATE(300),
    [sym_augmented_assignment_expression] = STATE(300),
    [sym_binary_expression] = STATE(300),
    [sym_unary_expression] = STATE(300),
    [sym_regex] = STATE(300),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(300),
    [sym_as_expression] = STATE(300),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(300),
    [sym_class] = STATE(300),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(655),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(655),
    [sym_number] = ACTIONS(657),
    [sym_true] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(655),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [72] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(659),
    [sym__automatic_semicolon] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(659),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_GT_GT_GT] = ACTIONS(659),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_PERCENT] = ACTIONS(659),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_as] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_DASH_DASH] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(661),
    [anon_sym_instanceof] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(659),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(661),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(661),
  },
  [73] = {
    [aux_sym_template_string_repeat1] = STATE(302),
    [sym_template_substitution] = STATE(302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(663),
    [sym__template_chars] = ACTIONS(665),
    [sym_escape_sequence] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(667),
    [anon_sym_BQUOTE] = ACTIONS(669),
    [anon_sym_debugger] = ACTIONS(667),
    [anon_sym_symbol] = ACTIONS(667),
    [anon_sym_AT] = ACTIONS(669),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_void] = ACTIONS(667),
    [anon_sym_break] = ACTIONS(667),
    [anon_sym_const] = ACTIONS(667),
    [sym_super] = ACTIONS(667),
    [anon_sym_return] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_get] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_interface] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(667),
    [anon_sym_enum] = ACTIONS(667),
    [anon_sym_delete] = ACTIONS(667),
    [anon_sym_continue] = ACTIONS(667),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_if] = ACTIONS(667),
    [sym_this] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(667),
    [sym_true] = ACTIONS(667),
    [anon_sym_throw] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_abstract] = ACTIONS(667),
    [anon_sym_set] = ACTIONS(667),
    [anon_sym_type] = ACTIONS(667),
    [anon_sym_import] = ACTIONS(667),
    [anon_sym_namespace] = ACTIONS(667),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DQUOTE] = ACTIONS(669),
    [anon_sym_else] = ACTIONS(667),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_for] = ACTIONS(667),
    [anon_sym_LBRACK] = ACTIONS(669),
    [sym_false] = ACTIONS(667),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_number] = ACTIONS(667),
    [anon_sym_class] = ACTIONS(667),
    [anon_sym_declare] = ACTIONS(667),
    [anon_sym_typeof] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_switch] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [sym_null] = ACTIONS(667),
    [anon_sym_any] = ACTIONS(667),
    [anon_sym_boolean] = ACTIONS(667),
    [anon_sym_async] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_var] = ACTIONS(667),
    [anon_sym_while] = ACTIONS(667),
    [anon_sym_SQUOTE] = ACTIONS(669),
    [anon_sym_try] = ACTIONS(667),
    [anon_sym_LT] = ACTIONS(669),
    [sym_number] = ACTIONS(669),
    [anon_sym_SLASH] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(667),
    [anon_sym_function] = ACTIONS(667),
    [sym_undefined] = ACTIONS(667),
    [anon_sym_new] = ACTIONS(667),
    [ts_builtin_sym_end] = ACTIONS(669),
    [anon_sym_let] = ACTIONS(667),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_with] = ACTIONS(667),
    [anon_sym_await] = ACTIONS(667),
  },
  [75] = {
    [sym_arrow_function] = STATE(304),
    [sym_await_expression] = STATE(304),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(303),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(304),
    [sym_meta_property] = STATE(304),
    [sym__expression] = STATE(304),
    [sym_function] = STATE(52),
    [sym_import] = STATE(304),
    [sym_call_expression] = STATE(304),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(304),
    [sym_string] = STATE(304),
    [sym_template_string] = STATE(304),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(304),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(304),
    [sym_generator_function] = STATE(304),
    [sym_new_expression] = STATE(304),
    [sym_assignment_expression] = STATE(304),
    [sym_augmented_assignment_expression] = STATE(304),
    [sym_binary_expression] = STATE(304),
    [sym_unary_expression] = STATE(304),
    [sym_regex] = STATE(304),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(304),
    [sym_as_expression] = STATE(304),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(304),
    [sym_class] = STATE(304),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(671),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(671),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [76] = {
    [sym_arrow_function] = STATE(305),
    [sym_await_expression] = STATE(305),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(305),
    [sym_meta_property] = STATE(305),
    [sym__expression] = STATE(305),
    [sym_function] = STATE(52),
    [sym_import] = STATE(305),
    [sym_call_expression] = STATE(305),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(305),
    [sym_string] = STATE(305),
    [sym_template_string] = STATE(305),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(305),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(305),
    [sym_generator_function] = STATE(305),
    [sym_new_expression] = STATE(305),
    [sym_assignment_expression] = STATE(305),
    [sym_augmented_assignment_expression] = STATE(305),
    [sym_binary_expression] = STATE(305),
    [sym_unary_expression] = STATE(305),
    [sym_regex] = STATE(305),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(305),
    [sym_as_expression] = STATE(305),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(305),
    [sym_class] = STATE(305),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(675),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(675),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(675),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(677),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(675),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [77] = {
    [sym_arrow_function] = STATE(306),
    [sym_await_expression] = STATE(306),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(306),
    [sym_meta_property] = STATE(306),
    [sym__expression] = STATE(306),
    [sym_function] = STATE(52),
    [sym_import] = STATE(306),
    [sym_call_expression] = STATE(306),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(306),
    [sym_string] = STATE(306),
    [sym_template_string] = STATE(306),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(306),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(306),
    [sym_generator_function] = STATE(306),
    [sym_new_expression] = STATE(306),
    [sym_assignment_expression] = STATE(306),
    [sym_augmented_assignment_expression] = STATE(306),
    [sym_binary_expression] = STATE(306),
    [sym_unary_expression] = STATE(306),
    [sym_regex] = STATE(306),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(306),
    [sym_as_expression] = STATE(306),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(306),
    [sym_class] = STATE(306),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(679),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(679),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(681),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(679),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [78] = {
    [sym_identifier] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_arguments] = STATE(309),
    [anon_sym_DOT] = ACTIONS(685),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_export] = ACTIONS(689),
    [anon_sym_class] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_arguments] = STATE(311),
    [anon_sym_DOT] = ACTIONS(691),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_export] = ACTIONS(693),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [anon_sym_LBRACK] = ACTIONS(693),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(695),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_void] = ACTIONS(695),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [sym_this] = ACTIONS(695),
    [sym_number] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(695),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_export] = ACTIONS(695),
    [sym_readonly] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(693),
  },
  [82] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [83] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [84] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(697),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [85] = {
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_object] = STATE(319),
    [sym_accessibility_modifier] = STATE(190),
    [sym_pair] = STATE(184),
    [sym__property_name] = STATE(186),
    [sym_method_definition] = STATE(184),
    [sym_assignment_pattern] = STATE(184),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(184),
    [sym_string] = STATE(186),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(699),
    [anon_sym_symbol] = ACTIONS(699),
    [anon_sym_number] = ACTIONS(699),
    [anon_sym_declare] = ACTIONS(699),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(699),
    [anon_sym_any] = ACTIONS(699),
    [anon_sym_private] = ACTIONS(703),
    [anon_sym_boolean] = ACTIONS(699),
    [anon_sym_async] = ACTIONS(705),
    [anon_sym_public] = ACTIONS(703),
    [anon_sym_get] = ACTIONS(707),
    [anon_sym_RBRACE] = ACTIONS(709),
    [anon_sym_static] = ACTIONS(711),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_number] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(703),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_set] = ACTIONS(707),
    [anon_sym_type] = ACTIONS(699),
    [anon_sym_export] = ACTIONS(699),
    [anon_sym_namespace] = ACTIONS(699),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [86] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [87] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(435),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [88] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(245),
    [sym_identifier] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym__automatic_semicolon] = ACTIONS(231),
    [anon_sym_SEMI] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_instanceof] = ACTIONS(231),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
    [anon_sym_BANG] = ACTIONS(235),
  },
  [90] = {
    [sym_nested_identifier] = STATE(1585),
    [sym_string] = STATE(1586),
    [sym__module] = STATE(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(721),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [91] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(725),
  },
  [92] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [94] = {
    [sym_identifier] = ACTIONS(732),
    [anon_sym_BQUOTE] = ACTIONS(734),
    [anon_sym_debugger] = ACTIONS(732),
    [anon_sym_symbol] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(734),
    [anon_sym_DASH] = ACTIONS(732),
    [anon_sym_void] = ACTIONS(732),
    [anon_sym_break] = ACTIONS(732),
    [anon_sym_const] = ACTIONS(732),
    [sym_super] = ACTIONS(732),
    [anon_sym_return] = ACTIONS(732),
    [anon_sym_private] = ACTIONS(732),
    [anon_sym_static] = ACTIONS(732),
    [anon_sym_get] = ACTIONS(732),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_interface] = ACTIONS(732),
    [anon_sym_default] = ACTIONS(732),
    [anon_sym_enum] = ACTIONS(732),
    [anon_sym_delete] = ACTIONS(732),
    [anon_sym_continue] = ACTIONS(732),
    [anon_sym_DASH_DASH] = ACTIONS(734),
    [anon_sym_if] = ACTIONS(732),
    [sym_this] = ACTIONS(732),
    [anon_sym_yield] = ACTIONS(732),
    [sym_true] = ACTIONS(732),
    [anon_sym_throw] = ACTIONS(732),
    [anon_sym_protected] = ACTIONS(732),
    [anon_sym_abstract] = ACTIONS(732),
    [anon_sym_set] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(732),
    [anon_sym_import] = ACTIONS(732),
    [anon_sym_namespace] = ACTIONS(732),
    [anon_sym_PLUS_PLUS] = ACTIONS(734),
    [anon_sym_DQUOTE] = ACTIONS(734),
    [anon_sym_else] = ACTIONS(732),
    [anon_sym_BANG] = ACTIONS(734),
    [anon_sym_for] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(734),
    [sym_false] = ACTIONS(732),
    [anon_sym_SEMI] = ACTIONS(734),
    [anon_sym_case] = ACTIONS(732),
    [anon_sym_module] = ACTIONS(732),
    [anon_sym_number] = ACTIONS(732),
    [anon_sym_class] = ACTIONS(732),
    [anon_sym_declare] = ACTIONS(732),
    [anon_sym_typeof] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(734),
    [anon_sym_switch] = ACTIONS(732),
    [anon_sym_LPAREN] = ACTIONS(734),
    [sym_null] = ACTIONS(732),
    [anon_sym_any] = ACTIONS(732),
    [anon_sym_boolean] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(732),
    [anon_sym_public] = ACTIONS(732),
    [anon_sym_var] = ACTIONS(732),
    [anon_sym_while] = ACTIONS(732),
    [anon_sym_SQUOTE] = ACTIONS(734),
    [anon_sym_try] = ACTIONS(732),
    [anon_sym_LT] = ACTIONS(734),
    [sym_number] = ACTIONS(734),
    [anon_sym_SLASH] = ACTIONS(732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(732),
    [anon_sym_function] = ACTIONS(732),
    [sym_undefined] = ACTIONS(732),
    [anon_sym_new] = ACTIONS(732),
    [ts_builtin_sym_end] = ACTIONS(734),
    [anon_sym_let] = ACTIONS(732),
    [anon_sym_PLUS] = ACTIONS(732),
    [anon_sym_export] = ACTIONS(732),
    [anon_sym_do] = ACTIONS(732),
    [anon_sym_TILDE] = ACTIONS(734),
    [anon_sym_with] = ACTIONS(732),
    [anon_sym_await] = ACTIONS(732),
  },
  [95] = {
    [sym__automatic_semicolon] = ACTIONS(736),
    [anon_sym_SEMI] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym__initializer] = STATE(327),
    [sym_type_annotation] = STATE(328),
    [sym__automatic_semicolon] = ACTIONS(738),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_COMMA] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_identifier] = ACTIONS(744),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__initializer] = STATE(330),
    [sym_type_annotation] = STATE(331),
    [sym__automatic_semicolon] = ACTIONS(746),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(746),
    [anon_sym_COMMA] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [aux_sym_variable_declaration_repeat1] = STATE(334),
    [sym__automatic_semicolon] = ACTIONS(748),
    [anon_sym_SEMI] = ACTIONS(748),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym__initializer] = STATE(335),
    [sym_type_annotation] = STATE(336),
    [sym__automatic_semicolon] = ACTIONS(752),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(752),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_arrow_function] = STATE(338),
    [sym_await_expression] = STATE(338),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(337),
    [sym_meta_property] = STATE(338),
    [sym_update_expression] = STATE(338),
    [sym__expression] = STATE(338),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(338),
    [sym_call_expression] = STATE(338),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(338),
    [sym_string] = STATE(338),
    [sym_template_string] = STATE(338),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(338),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(338),
    [sym_generator_function] = STATE(338),
    [sym_new_expression] = STATE(338),
    [sym_assignment_expression] = STATE(338),
    [sym_augmented_assignment_expression] = STATE(338),
    [sym_binary_expression] = STATE(338),
    [sym_unary_expression] = STATE(338),
    [sym_regex] = STATE(338),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(338),
    [sym_as_expression] = STATE(338),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(338),
    [sym_class] = STATE(338),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(754),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(754),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(754),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(754),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(756),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(754),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [102] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(240),
    [sym_function_type] = STATE(240),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(240),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(240),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [103] = {
    [sym_arrow_function] = STATE(341),
    [sym_await_expression] = STATE(341),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(341),
    [sym_meta_property] = STATE(341),
    [sym__expression] = STATE(341),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(341),
    [sym_call_expression] = STATE(341),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(342),
    [sym_ternary_expression] = STATE(341),
    [sym_string] = STATE(341),
    [sym_template_string] = STATE(341),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(341),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(341),
    [sym_generator_function] = STATE(341),
    [sym_new_expression] = STATE(341),
    [sym_assignment_expression] = STATE(341),
    [sym_augmented_assignment_expression] = STATE(341),
    [sym_binary_expression] = STATE(341),
    [sym_unary_expression] = STATE(341),
    [sym_regex] = STATE(341),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(343),
    [sym_non_null_expression] = STATE(341),
    [sym_as_expression] = STATE(341),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(341),
    [sym_class] = STATE(341),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(760),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(760),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(760),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(760),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(764),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(760),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [104] = {
    [sym_template_string] = STATE(344),
    [sym_arguments] = STATE(344),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(766),
    [sym__automatic_semicolon] = ACTIONS(766),
    [anon_sym_SEMI] = ACTIONS(766),
    [anon_sym_BQUOTE] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT_GT] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_QMARK] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(766),
    [anon_sym_DASH_DASH] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_instanceof] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_GT_GT] = ACTIONS(768),
    [anon_sym_PLUS_PLUS] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG] = ACTIONS(768),
  },
  [106] = {
    [sym_identifier] = ACTIONS(770),
    [anon_sym_BQUOTE] = ACTIONS(772),
    [anon_sym_debugger] = ACTIONS(770),
    [anon_sym_symbol] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_DASH] = ACTIONS(770),
    [anon_sym_void] = ACTIONS(770),
    [anon_sym_break] = ACTIONS(770),
    [anon_sym_const] = ACTIONS(770),
    [sym_super] = ACTIONS(770),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_private] = ACTIONS(770),
    [anon_sym_static] = ACTIONS(770),
    [anon_sym_get] = ACTIONS(770),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_interface] = ACTIONS(770),
    [anon_sym_default] = ACTIONS(770),
    [anon_sym_enum] = ACTIONS(770),
    [anon_sym_delete] = ACTIONS(770),
    [anon_sym_continue] = ACTIONS(770),
    [anon_sym_DASH_DASH] = ACTIONS(772),
    [anon_sym_if] = ACTIONS(770),
    [sym_this] = ACTIONS(770),
    [anon_sym_yield] = ACTIONS(770),
    [sym_true] = ACTIONS(770),
    [anon_sym_throw] = ACTIONS(770),
    [anon_sym_protected] = ACTIONS(770),
    [anon_sym_abstract] = ACTIONS(770),
    [anon_sym_set] = ACTIONS(770),
    [anon_sym_type] = ACTIONS(770),
    [anon_sym_import] = ACTIONS(770),
    [anon_sym_namespace] = ACTIONS(770),
    [anon_sym_PLUS_PLUS] = ACTIONS(772),
    [anon_sym_DQUOTE] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(770),
    [anon_sym_BANG] = ACTIONS(772),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(772),
    [sym_false] = ACTIONS(770),
    [anon_sym_SEMI] = ACTIONS(772),
    [anon_sym_case] = ACTIONS(770),
    [anon_sym_module] = ACTIONS(770),
    [anon_sym_number] = ACTIONS(770),
    [anon_sym_class] = ACTIONS(770),
    [anon_sym_declare] = ACTIONS(770),
    [anon_sym_typeof] = ACTIONS(770),
    [anon_sym_LBRACE] = ACTIONS(772),
    [anon_sym_switch] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(772),
    [sym_null] = ACTIONS(770),
    [anon_sym_any] = ACTIONS(770),
    [anon_sym_boolean] = ACTIONS(770),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_public] = ACTIONS(770),
    [anon_sym_var] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_SQUOTE] = ACTIONS(772),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_LT] = ACTIONS(772),
    [sym_number] = ACTIONS(772),
    [anon_sym_SLASH] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(770),
    [anon_sym_function] = ACTIONS(770),
    [sym_undefined] = ACTIONS(770),
    [anon_sym_new] = ACTIONS(770),
    [ts_builtin_sym_end] = ACTIONS(772),
    [anon_sym_let] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(770),
    [anon_sym_export] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(770),
    [anon_sym_TILDE] = ACTIONS(772),
    [anon_sym_with] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(770),
  },
  [107] = {
    [sym__automatic_semicolon] = ACTIONS(774),
    [anon_sym_SEMI] = ACTIONS(774),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(774),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(774),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [109] = {
    [sym_object_type] = STATE(346),
    [sym_extends_clause] = STATE(347),
    [sym_type_parameters] = STATE(348),
    [anon_sym_extends] = ACTIONS(776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(481),
  },
  [110] = {
    [sym_enum_body] = STATE(350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(778),
  },
  [111] = {
    [sym_identifier] = ACTIONS(780),
    [anon_sym_BQUOTE] = ACTIONS(782),
    [anon_sym_debugger] = ACTIONS(780),
    [anon_sym_symbol] = ACTIONS(780),
    [anon_sym_AT] = ACTIONS(782),
    [anon_sym_DASH] = ACTIONS(780),
    [anon_sym_void] = ACTIONS(780),
    [anon_sym_break] = ACTIONS(780),
    [anon_sym_const] = ACTIONS(780),
    [sym_super] = ACTIONS(780),
    [anon_sym_return] = ACTIONS(780),
    [anon_sym_private] = ACTIONS(780),
    [anon_sym_static] = ACTIONS(780),
    [anon_sym_get] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_interface] = ACTIONS(780),
    [anon_sym_default] = ACTIONS(780),
    [anon_sym_enum] = ACTIONS(780),
    [anon_sym_delete] = ACTIONS(780),
    [anon_sym_continue] = ACTIONS(780),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_if] = ACTIONS(780),
    [sym_this] = ACTIONS(780),
    [anon_sym_yield] = ACTIONS(780),
    [sym_true] = ACTIONS(780),
    [anon_sym_throw] = ACTIONS(780),
    [anon_sym_protected] = ACTIONS(780),
    [anon_sym_abstract] = ACTIONS(780),
    [anon_sym_set] = ACTIONS(780),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_import] = ACTIONS(780),
    [anon_sym_namespace] = ACTIONS(780),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(782),
    [anon_sym_else] = ACTIONS(780),
    [anon_sym_BANG] = ACTIONS(782),
    [anon_sym_for] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [sym_false] = ACTIONS(780),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_case] = ACTIONS(780),
    [anon_sym_module] = ACTIONS(780),
    [anon_sym_number] = ACTIONS(780),
    [anon_sym_class] = ACTIONS(780),
    [anon_sym_declare] = ACTIONS(780),
    [anon_sym_typeof] = ACTIONS(780),
    [anon_sym_LBRACE] = ACTIONS(782),
    [anon_sym_switch] = ACTIONS(780),
    [anon_sym_LPAREN] = ACTIONS(782),
    [sym_null] = ACTIONS(780),
    [anon_sym_any] = ACTIONS(780),
    [anon_sym_boolean] = ACTIONS(780),
    [anon_sym_async] = ACTIONS(780),
    [anon_sym_public] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_while] = ACTIONS(780),
    [anon_sym_SQUOTE] = ACTIONS(782),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_LT] = ACTIONS(782),
    [sym_number] = ACTIONS(782),
    [anon_sym_SLASH] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(780),
    [anon_sym_function] = ACTIONS(780),
    [sym_undefined] = ACTIONS(780),
    [anon_sym_new] = ACTIONS(780),
    [ts_builtin_sym_end] = ACTIONS(782),
    [anon_sym_let] = ACTIONS(780),
    [anon_sym_PLUS] = ACTIONS(780),
    [anon_sym_export] = ACTIONS(780),
    [anon_sym_do] = ACTIONS(780),
    [anon_sym_TILDE] = ACTIONS(782),
    [anon_sym_with] = ACTIONS(780),
    [anon_sym_await] = ACTIONS(780),
  },
  [112] = {
    [sym__automatic_semicolon] = ACTIONS(784),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(786),
    [anon_sym_BQUOTE] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_STAR] = ACTIONS(788),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_QMARK] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_DASH_DASH] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_instanceof] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_PLUS_PLUS] = ACTIONS(786),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(786),
    [anon_sym_BANG] = ACTIONS(788),
  },
  [114] = {
    [sym_arrow_function] = STATE(1834),
    [sym_await_expression] = STATE(1834),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1833),
    [sym_meta_property] = STATE(1834),
    [sym_update_expression] = STATE(1834),
    [sym__expression] = STATE(1834),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1834),
    [sym_call_expression] = STATE(1834),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1834),
    [sym_string] = STATE(1834),
    [sym_template_string] = STATE(1834),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1834),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1834),
    [sym_generator_function] = STATE(1834),
    [sym_new_expression] = STATE(1834),
    [sym_assignment_expression] = STATE(1834),
    [sym_augmented_assignment_expression] = STATE(1834),
    [sym_binary_expression] = STATE(1834),
    [sym_unary_expression] = STATE(1834),
    [sym_regex] = STATE(1834),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1834),
    [sym_as_expression] = STATE(1834),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1834),
    [sym_class] = STATE(1834),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(790),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(790),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(790),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(792),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(790),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [115] = {
    [sym_generator_function_declaration] = STATE(352),
    [sym__declaration] = STATE(352),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(352),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(352),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(352),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(352),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(352),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(352),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(352),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(352),
    [sym_function_declaration] = STATE(352),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(352),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(352),
    [sym_break_statement] = STATE(352),
    [sym_labeled_statement] = STATE(352),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(352),
    [sym_class_declaration] = STATE(352),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(352),
    [sym_ambient_declaration] = STATE(352),
    [sym_type_alias_declaration] = STATE(352),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(352),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(352),
    [sym_switch_statement] = STATE(352),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(352),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(352),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(352),
    [sym_abstract_class_declaration] = STATE(352),
    [sym_interface_declaration] = STATE(352),
    [sym_export_statement] = STATE(352),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(352),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(352),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(352),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(352),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [116] = {
    [sym_arrow_function] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym__expression] = STATE(353),
    [sym_function] = STATE(52),
    [sym_import] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(353),
    [sym_string] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(353),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(353),
    [sym_generator_function] = STATE(353),
    [sym_new_expression] = STATE(353),
    [sym_assignment_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_regex] = STATE(353),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(353),
    [sym_as_expression] = STATE(353),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(353),
    [sym_class] = STATE(353),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(794),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(794),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(794),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(794),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(796),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(794),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [117] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(798),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [118] = {
    [sym__automatic_semicolon] = ACTIONS(800),
    [anon_sym_SEMI] = ACTIONS(800),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(800),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(800),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [120] = {
    [sym_identifier] = ACTIONS(802),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_type_parameters] = STATE(357),
    [anon_sym_EQ] = ACTIONS(804),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [anon_sym_EQ] = ACTIONS(806),
    [anon_sym_COMMA] = ACTIONS(808),
    [anon_sym_from] = ACTIONS(810),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_namespace_import] = STATE(126),
    [sym_named_imports] = STATE(126),
    [sym_import_require_clause] = STATE(361),
    [sym_string] = STATE(361),
    [sym_import_clause] = STATE(362),
    [anon_sym_STAR] = ACTIONS(812),
    [sym_identifier] = ACTIONS(814),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(241),
  },
  [124] = {
    [anon_sym_as] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym__import_export_specifier] = STATE(368),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(824),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [anon_sym_from] = ACTIONS(810),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym__automatic_semicolon] = ACTIONS(826),
    [anon_sym_SEMI] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym__from_clause] = STATE(361),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_statement_block] = STATE(372),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_symbol] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_break] = ACTIONS(832),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(832),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_interface] = ACTIONS(832),
    [anon_sym_as] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(832),
    [anon_sym_if] = ACTIONS(832),
    [anon_sym_instanceof] = ACTIONS(832),
    [anon_sym_yield] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [anon_sym_protected] = ACTIONS(832),
    [anon_sym_DOT] = ACTIONS(834),
    [anon_sym_set] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(832),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_number] = ACTIONS(832),
    [anon_sym_typeof] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [sym_null] = ACTIONS(832),
    [anon_sym_any] = ACTIONS(832),
    [anon_sym_async] = ACTIONS(832),
    [anon_sym_public] = ACTIONS(832),
    [anon_sym_var] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(832),
    [anon_sym_SQUOTE] = ACTIONS(830),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(832),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_export] = ACTIONS(832),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_with] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_debugger] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_const] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [sym_super] = ACTIONS(832),
    [anon_sym_private] = ACTIONS(832),
    [anon_sym_get] = ACTIONS(832),
    [anon_sym_default] = ACTIONS(832),
    [anon_sym_enum] = ACTIONS(832),
    [anon_sym_continue] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [sym_this] = ACTIONS(832),
    [anon_sym_throw] = ACTIONS(832),
    [anon_sym_abstract] = ACTIONS(832),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [sym_false] = ACTIONS(832),
    [anon_sym_case] = ACTIONS(832),
    [anon_sym_module] = ACTIONS(832),
    [anon_sym_class] = ACTIONS(832),
    [anon_sym_declare] = ACTIONS(832),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_boolean] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(832),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(832),
    [sym_number] = ACTIONS(830),
    [ts_builtin_sym_end] = ACTIONS(830),
    [anon_sym_function] = ACTIONS(832),
    [sym_undefined] = ACTIONS(832),
    [anon_sym_let] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
  },
  [130] = {
    [sym_statement_block] = STATE(372),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_symbol] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_break] = ACTIONS(832),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(832),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_interface] = ACTIONS(832),
    [anon_sym_as] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(832),
    [anon_sym_if] = ACTIONS(832),
    [anon_sym_instanceof] = ACTIONS(832),
    [anon_sym_yield] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [anon_sym_protected] = ACTIONS(832),
    [anon_sym_DOT] = ACTIONS(832),
    [anon_sym_set] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(832),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_number] = ACTIONS(832),
    [anon_sym_typeof] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [sym_null] = ACTIONS(832),
    [anon_sym_any] = ACTIONS(832),
    [anon_sym_async] = ACTIONS(832),
    [anon_sym_public] = ACTIONS(832),
    [anon_sym_var] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(832),
    [anon_sym_SQUOTE] = ACTIONS(830),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(832),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_export] = ACTIONS(832),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_with] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_debugger] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_const] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [sym_super] = ACTIONS(832),
    [anon_sym_private] = ACTIONS(832),
    [anon_sym_get] = ACTIONS(832),
    [anon_sym_default] = ACTIONS(832),
    [anon_sym_enum] = ACTIONS(832),
    [anon_sym_continue] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [sym_this] = ACTIONS(832),
    [anon_sym_throw] = ACTIONS(832),
    [anon_sym_abstract] = ACTIONS(832),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [sym_false] = ACTIONS(832),
    [anon_sym_case] = ACTIONS(832),
    [anon_sym_module] = ACTIONS(832),
    [anon_sym_class] = ACTIONS(832),
    [anon_sym_declare] = ACTIONS(832),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_boolean] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(832),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(832),
    [sym_number] = ACTIONS(830),
    [ts_builtin_sym_end] = ACTIONS(830),
    [anon_sym_function] = ACTIONS(832),
    [sym_undefined] = ACTIONS(832),
    [anon_sym_let] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
  },
  [131] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_as] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_if] = ACTIONS(840),
    [anon_sym_instanceof] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_DOT] = ACTIONS(840),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_PIPE_RBRACE] = ACTIONS(838),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [sym_super] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [sym_this] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [sym_number] = ACTIONS(838),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_await] = ACTIONS(840),
  },
  [132] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(842),
    [sym__automatic_semicolon] = ACTIONS(842),
    [anon_sym_BQUOTE] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_GT_GT_GT] = ACTIONS(842),
    [anon_sym_EQ] = ACTIONS(844),
    [anon_sym_BANG_EQ] = ACTIONS(844),
    [anon_sym_GT_EQ] = ACTIONS(842),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_PERCENT] = ACTIONS(842),
    [anon_sym_as] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(842),
    [anon_sym_instanceof] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(842),
    [anon_sym_DOT] = ACTIONS(842),
    [anon_sym_PIPE_RBRACE] = ACTIONS(842),
    [anon_sym_STAR_STAR] = ACTIONS(842),
    [anon_sym_PLUS_PLUS] = ACTIONS(842),
    [anon_sym_in] = ACTIONS(844),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(842),
    [anon_sym_LT_LT] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(842),
    [anon_sym_AMP_AMP] = ACTIONS(842),
    [anon_sym_LT_EQ] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_AMP] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(842),
    [anon_sym_PIPE_PIPE] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_EQ_EQ] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_SLASH] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(842),
  },
  [133] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(846),
    [aux_sym_string_token1] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(850),
    [sym_comment] = ACTIONS(255),
  },
  [134] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [135] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(383),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(382),
    [sym_array] = STATE(385),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(382),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(382),
    [sym_expression_statement] = STATE(383),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(384),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(383),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(383),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(856),
    [anon_sym_const] = ACTIONS(858),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(854),
    [anon_sym_static] = ACTIONS(854),
    [anon_sym_get] = ACTIONS(854),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(854),
    [anon_sym_set] = ACTIONS(854),
    [anon_sym_type] = ACTIONS(854),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(854),
    [anon_sym_number] = ACTIONS(854),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(854),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(854),
    [anon_sym_boolean] = ACTIONS(854),
    [anon_sym_async] = ACTIONS(862),
    [anon_sym_public] = ACTIONS(854),
    [anon_sym_var] = ACTIONS(864),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(854),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(858),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [136] = {
    [sym__for_header] = STATE(387),
    [anon_sym_LPAREN] = ACTIONS(866),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_generator_function_declaration] = STATE(388),
    [sym__declaration] = STATE(388),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(388),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(388),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(388),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(388),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(388),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(388),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(388),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(388),
    [sym_function_declaration] = STATE(388),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(388),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(388),
    [sym_break_statement] = STATE(388),
    [sym_labeled_statement] = STATE(388),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(388),
    [sym_class_declaration] = STATE(388),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(388),
    [sym_ambient_declaration] = STATE(388),
    [sym_type_alias_declaration] = STATE(388),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(388),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(388),
    [sym_switch_statement] = STATE(388),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(388),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(388),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(388),
    [sym_abstract_class_declaration] = STATE(388),
    [sym_interface_declaration] = STATE(388),
    [sym_export_statement] = STATE(388),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(388),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(388),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(388),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [138] = {
    [sym_arrow_function] = STATE(389),
    [sym_await_expression] = STATE(389),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(389),
    [sym_meta_property] = STATE(389),
    [sym__expression] = STATE(389),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(389),
    [sym_call_expression] = STATE(389),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(389),
    [sym_string] = STATE(389),
    [sym_template_string] = STATE(389),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(389),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(389),
    [sym_generator_function] = STATE(389),
    [sym_new_expression] = STATE(389),
    [sym_assignment_expression] = STATE(389),
    [sym_augmented_assignment_expression] = STATE(389),
    [sym_binary_expression] = STATE(389),
    [sym_unary_expression] = STATE(389),
    [sym_regex] = STATE(389),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(389),
    [sym_as_expression] = STATE(389),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(389),
    [sym_class] = STATE(389),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(868),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(868),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(868),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(870),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(868),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [139] = {
    [sym_arrow_function] = STATE(390),
    [sym_await_expression] = STATE(390),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(390),
    [sym_meta_property] = STATE(390),
    [sym__expression] = STATE(390),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(391),
    [sym_ternary_expression] = STATE(390),
    [sym_string] = STATE(390),
    [sym_template_string] = STATE(390),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(390),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(390),
    [sym_generator_function] = STATE(390),
    [sym_new_expression] = STATE(390),
    [sym_assignment_expression] = STATE(390),
    [sym_augmented_assignment_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_regex] = STATE(390),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(390),
    [sym_as_expression] = STATE(390),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(390),
    [sym_class] = STATE(390),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(872),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(874),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(874),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(874),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(872),
    [sym_null] = ACTIONS(874),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(872),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(876),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(874),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [140] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(878),
    [sym__automatic_semicolon] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(878),
    [anon_sym_PIPE] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(880),
    [anon_sym_GT_GT_GT] = ACTIONS(878),
    [anon_sym_EQ] = ACTIONS(880),
    [anon_sym_BANG_EQ] = ACTIONS(880),
    [anon_sym_GT_EQ] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_PERCENT] = ACTIONS(878),
    [anon_sym_as] = ACTIONS(878),
    [anon_sym_DASH_DASH] = ACTIONS(878),
    [anon_sym_instanceof] = ACTIONS(878),
    [anon_sym_COLON] = ACTIONS(878),
    [anon_sym_DOT] = ACTIONS(878),
    [anon_sym_STAR_STAR] = ACTIONS(878),
    [anon_sym_PLUS_PLUS] = ACTIONS(878),
    [anon_sym_in] = ACTIONS(880),
    [anon_sym_BANG] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_SEMI] = ACTIONS(878),
    [anon_sym_LT_LT] = ACTIONS(878),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_of] = ACTIONS(878),
    [anon_sym_LT_EQ] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_GT] = ACTIONS(880),
    [anon_sym_AMP] = ACTIONS(880),
    [anon_sym_QMARK] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_EQ_EQ] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(880),
    [anon_sym_SLASH] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(878),
    [anon_sym_PLUS] = ACTIONS(880),
    [anon_sym_GT_GT] = ACTIONS(880),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(878),
  },
  [141] = {
    [aux_sym_array_repeat1] = STATE(393),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(898),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [142] = {
    [aux_sym_array_repeat1] = STATE(393),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(898),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_identifier] = ACTIONS(918),
    [anon_sym_BQUOTE] = ACTIONS(920),
    [anon_sym_debugger] = ACTIONS(918),
    [anon_sym_symbol] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_void] = ACTIONS(918),
    [anon_sym_break] = ACTIONS(918),
    [anon_sym_const] = ACTIONS(918),
    [sym_super] = ACTIONS(918),
    [anon_sym_return] = ACTIONS(918),
    [anon_sym_private] = ACTIONS(918),
    [anon_sym_static] = ACTIONS(918),
    [anon_sym_get] = ACTIONS(918),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_interface] = ACTIONS(918),
    [anon_sym_default] = ACTIONS(918),
    [anon_sym_enum] = ACTIONS(918),
    [anon_sym_delete] = ACTIONS(918),
    [anon_sym_continue] = ACTIONS(918),
    [anon_sym_DASH_DASH] = ACTIONS(920),
    [anon_sym_if] = ACTIONS(918),
    [sym_this] = ACTIONS(918),
    [anon_sym_yield] = ACTIONS(918),
    [sym_true] = ACTIONS(918),
    [anon_sym_throw] = ACTIONS(918),
    [anon_sym_protected] = ACTIONS(918),
    [anon_sym_abstract] = ACTIONS(918),
    [anon_sym_set] = ACTIONS(918),
    [anon_sym_type] = ACTIONS(918),
    [anon_sym_import] = ACTIONS(918),
    [anon_sym_namespace] = ACTIONS(918),
    [anon_sym_PLUS_PLUS] = ACTIONS(920),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [anon_sym_else] = ACTIONS(918),
    [anon_sym_BANG] = ACTIONS(920),
    [anon_sym_for] = ACTIONS(918),
    [anon_sym_LBRACK] = ACTIONS(920),
    [sym_false] = ACTIONS(918),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_case] = ACTIONS(918),
    [anon_sym_module] = ACTIONS(918),
    [anon_sym_number] = ACTIONS(918),
    [anon_sym_class] = ACTIONS(918),
    [anon_sym_declare] = ACTIONS(918),
    [anon_sym_typeof] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(920),
    [anon_sym_switch] = ACTIONS(918),
    [anon_sym_LPAREN] = ACTIONS(920),
    [sym_null] = ACTIONS(918),
    [anon_sym_any] = ACTIONS(918),
    [anon_sym_boolean] = ACTIONS(918),
    [anon_sym_async] = ACTIONS(918),
    [anon_sym_public] = ACTIONS(918),
    [anon_sym_var] = ACTIONS(918),
    [anon_sym_while] = ACTIONS(918),
    [anon_sym_SQUOTE] = ACTIONS(920),
    [anon_sym_try] = ACTIONS(918),
    [anon_sym_LT] = ACTIONS(920),
    [sym_number] = ACTIONS(920),
    [anon_sym_SLASH] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(918),
    [anon_sym_function] = ACTIONS(918),
    [sym_undefined] = ACTIONS(918),
    [anon_sym_new] = ACTIONS(918),
    [ts_builtin_sym_end] = ACTIONS(920),
    [anon_sym_let] = ACTIONS(918),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_export] = ACTIONS(918),
    [anon_sym_do] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_with] = ACTIONS(918),
    [anon_sym_await] = ACTIONS(918),
  },
  [145] = {
    [sym_arrow_function] = STATE(397),
    [sym_await_expression] = STATE(397),
    [sym_member_expression] = STATE(2579),
    [sym_generic_type] = STATE(396),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(397),
    [sym_meta_property] = STATE(397),
    [sym__expression] = STATE(397),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(398),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(397),
    [sym_call_expression] = STATE(397),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(397),
    [sym_string] = STATE(397),
    [sym_template_string] = STATE(397),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(397),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(397),
    [sym_generator_function] = STATE(397),
    [sym_new_expression] = STATE(397),
    [sym_assignment_expression] = STATE(397),
    [sym_augmented_assignment_expression] = STATE(397),
    [sym_binary_expression] = STATE(397),
    [sym_unary_expression] = STATE(397),
    [sym_regex] = STATE(397),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(397),
    [sym_as_expression] = STATE(397),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(397),
    [sym_class] = STATE(397),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(924),
    [sym_false] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(926),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(926),
    [sym_number] = ACTIONS(940),
    [sym_true] = ACTIONS(926),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(926),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [146] = {
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(399),
    [sym_function_type] = STATE(399),
    [sym_constructor_type] = STATE(399),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(236),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(399),
    [sym__type] = STATE(399),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_symbol] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [sym_true] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_keyof] = ACTIONS(477),
    [sym_number] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(467),
  },
  [147] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(401),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(400),
    [sym_type_parameters] = STATE(402),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [148] = {
    [sym_type_parameter] = STATE(239),
    [sym_identifier] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_decorator] = STATE(415),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(415),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [150] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(986),
  },
  [151] = {
    [sym_implements_clause] = STATE(419),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(986),
  },
  [152] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(988),
    [anon_sym_LBRACK] = ACTIONS(988),
    [sym__automatic_semicolon] = ACTIONS(988),
    [anon_sym_SEMI] = ACTIONS(988),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(990),
    [anon_sym_COMMA] = ACTIONS(988),
    [anon_sym_LT_LT] = ACTIONS(988),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_GT_GT_GT] = ACTIONS(988),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_LT_EQ] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT_EQ] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_PERCENT] = ACTIONS(988),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_RBRACE] = ACTIONS(988),
    [anon_sym_as] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(988),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_instanceof] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(990),
    [anon_sym_SLASH] = ACTIONS(990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(988),
    [anon_sym_CARET] = ACTIONS(988),
    [anon_sym_STAR_STAR] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_GT_GT] = ACTIONS(990),
    [anon_sym_PLUS_PLUS] = ACTIONS(988),
    [anon_sym_in] = ACTIONS(990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(988),
    [anon_sym_BANG] = ACTIONS(990),
  },
  [153] = {
    [sym_class_body] = STATE(420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [154] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(421),
    [sym_class_heritage] = STATE(422),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [155] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(994),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(996),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_global] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_async] = ACTIONS(363),
  },
  [158] = {
    [sym_statement_block] = STATE(425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [159] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(998),
  },
  [160] = {
    [sym_identifier] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1002),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1004),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1006),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(1669),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(329),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1008),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_debugger] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_AT] = ACTIONS(1010),
    [anon_sym_DASH] = ACTIONS(1008),
    [anon_sym_void] = ACTIONS(1008),
    [anon_sym_break] = ACTIONS(1008),
    [anon_sym_const] = ACTIONS(1008),
    [sym_super] = ACTIONS(1008),
    [anon_sym_return] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_interface] = ACTIONS(1008),
    [anon_sym_default] = ACTIONS(1008),
    [anon_sym_enum] = ACTIONS(1008),
    [anon_sym_delete] = ACTIONS(1008),
    [anon_sym_continue] = ACTIONS(1008),
    [anon_sym_DASH_DASH] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1008),
    [sym_this] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1008),
    [sym_true] = ACTIONS(1008),
    [anon_sym_throw] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_abstract] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_import] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1008),
    [anon_sym_PLUS_PLUS] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_else] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1010),
    [anon_sym_for] = ACTIONS(1008),
    [anon_sym_LBRACK] = ACTIONS(1010),
    [sym_false] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_class] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_typeof] = ACTIONS(1008),
    [anon_sym_LBRACE] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [sym_null] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_async] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_var] = ACTIONS(1008),
    [anon_sym_while] = ACTIONS(1008),
    [anon_sym_SQUOTE] = ACTIONS(1010),
    [anon_sym_try] = ACTIONS(1008),
    [anon_sym_LT] = ACTIONS(1010),
    [sym_number] = ACTIONS(1010),
    [anon_sym_SLASH] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_function] = ACTIONS(1008),
    [sym_undefined] = ACTIONS(1008),
    [anon_sym_new] = ACTIONS(1008),
    [ts_builtin_sym_end] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1008),
    [anon_sym_PLUS] = ACTIONS(1008),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_do] = ACTIONS(1008),
    [anon_sym_TILDE] = ACTIONS(1010),
    [anon_sym_with] = ACTIONS(1008),
    [anon_sym_await] = ACTIONS(1008),
  },
  [165] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1014),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(1024),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [167] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [168] = {
    [sym_computed_property_name] = STATE(186),
    [sym_object] = STATE(319),
    [sym_method_definition] = STATE(440),
    [sym_assignment_pattern] = STATE(440),
    [sym_array] = STATE(320),
    [sym_accessibility_modifier] = STATE(190),
    [sym_spread_element] = STATE(440),
    [sym_string] = STATE(186),
    [sym__property_name] = STATE(186),
    [sym_pair] = STATE(440),
    [sym_identifier] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(1035),
    [anon_sym_symbol] = ACTIONS(1035),
    [anon_sym_number] = ACTIONS(1035),
    [anon_sym_declare] = ACTIONS(1035),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_void] = ACTIONS(1035),
    [anon_sym_any] = ACTIONS(1035),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_boolean] = ACTIONS(1035),
    [anon_sym_static] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_get] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_number] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_string] = ACTIONS(1035),
    [anon_sym_set] = ACTIONS(1045),
    [anon_sym_type] = ACTIONS(1035),
    [anon_sym_export] = ACTIONS(1035),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_namespace] = ACTIONS(1035),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [169] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [170] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [171] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [172] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [173] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [174] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_as] = ACTIONS(1077),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_instanceof] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1077),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [sym_null] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_with] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [sym_super] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_false] = ACTIONS(1075),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1075),
    [sym_number] = ACTIONS(1073),
    [ts_builtin_sym_end] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1075),
  },
  [175] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [176] = {
    [sym_nested_identifier] = STATE(129),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [177] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [anon_sym_get] = ACTIONS(1060),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [178] = {
    [sym_arrow_function] = STATE(448),
    [sym_await_expression] = STATE(448),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(448),
    [sym_meta_property] = STATE(448),
    [sym__expression] = STATE(448),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(448),
    [sym_call_expression] = STATE(448),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(142),
    [sym_ternary_expression] = STATE(448),
    [sym_string] = STATE(448),
    [sym_template_string] = STATE(448),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(448),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(448),
    [sym_generator_function] = STATE(448),
    [sym_new_expression] = STATE(448),
    [sym_assignment_expression] = STATE(448),
    [sym_augmented_assignment_expression] = STATE(448),
    [sym_binary_expression] = STATE(448),
    [sym_unary_expression] = STATE(448),
    [sym_regex] = STATE(448),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(448),
    [sym_as_expression] = STATE(448),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(448),
    [sym_class] = STATE(448),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(1081),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1081),
    [sym_number] = ACTIONS(1083),
    [sym_true] = ACTIONS(1081),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1081),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [179] = {
    [sym_nested_identifier] = STATE(1276),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [180] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [181] = {
    [sym_formal_parameters] = STATE(61),
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym__call_signature] = STATE(214),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_type_parameters] = STATE(60),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1085),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1085),
    [anon_sym_async] = ACTIONS(1085),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1085),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1085),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1085),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1085),
    [anon_sym_declare] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1095),
    [sym_number] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [182] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1099),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1099),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(1102),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [183] = {
    [sym_class_declaration] = STATE(264),
    [sym_generator_function_declaration] = STATE(264),
    [sym__declaration] = STATE(264),
    [sym_ambient_declaration] = STATE(264),
    [sym_import_alias] = STATE(264),
    [sym_type_alias_declaration] = STATE(264),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_function_signature] = STATE(264),
    [sym_abstract_class_declaration] = STATE(264),
    [sym_module] = STATE(264),
    [sym_interface_declaration] = STATE(264),
    [sym_function_declaration] = STATE(264),
    [sym_export_clause] = STATE(265),
    [sym_variable_declaration] = STATE(264),
    [sym_lexical_declaration] = STATE(264),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(264),
    [sym_enum_declaration] = STATE(264),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(531),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(535),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [184] = {
    [aux_sym_object_repeat1] = STATE(454),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1111),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [186] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(458),
    [anon_sym_COLON] = ACTIONS(1113),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(1115),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [188] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [189] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [anon_sym_get] = ACTIONS(1060),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(1051),
    [anon_sym_STAR] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1121),
    [anon_sym_private] = ACTIONS(1047),
  },
  [191] = {
    [sym_switch_body] = STATE(464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1123),
  },
  [192] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [193] = {
    [sym_object] = STATE(467),
    [sym_array] = STATE(468),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_static] = ACTIONS(1135),
  },
  [194] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [195] = {
    [sym_identifier] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [197] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [198] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1837),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [199] = {
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1167),
  },
  [200] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [201] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [202] = {
    [aux_sym_formal_parameters_repeat1] = STATE(472),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [anon_sym_COMMA] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__initializer] = STATE(474),
    [sym_type_annotation] = STATE(475),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(1179),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [anon_sym_RPAREN] = ACTIONS(1183),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_type_arguments] = STATE(1802),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_annotation] = STATE(477),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [206] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [207] = {
    [sym_object] = STATE(467),
    [sym_array] = STATE(468),
    [anon_sym_get] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_public] = ACTIONS(1135),
    [anon_sym_module] = ACTIONS(1135),
    [anon_sym_symbol] = ACTIONS(1135),
    [anon_sym_number] = ACTIONS(1135),
    [anon_sym_declare] = ACTIONS(1135),
    [sym_this] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1135),
    [anon_sym_protected] = ACTIONS(1135),
    [anon_sym_string] = ACTIONS(1135),
    [anon_sym_set] = ACTIONS(1135),
    [anon_sym_type] = ACTIONS(1135),
    [anon_sym_export] = ACTIONS(1135),
    [sym_readonly] = ACTIONS(1193),
    [anon_sym_namespace] = ACTIONS(1135),
    [anon_sym_any] = ACTIONS(1135),
    [anon_sym_private] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1135),
    [anon_sym_boolean] = ACTIONS(1135),
  },
  [208] = {
    [sym_optional_parameter] = STATE(481),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(481),
    [aux_sym_export_statement_repeat1] = STATE(2539),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(481),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_class] = ACTIONS(1199),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [209] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [210] = {
    [anon_sym_EQ_GT] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(202),
    [aux_sym_export_statement_repeat1] = STATE(486),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(429),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [213] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(489),
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [anon_sym_EQ_GT] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [aux_sym_variable_declaration_repeat1] = STATE(492),
    [sym__automatic_semicolon] = ACTIONS(1219),
    [anon_sym_SEMI] = ACTIONS(1219),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1221),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [217] = {
    [sym_generator_function_declaration] = STATE(493),
    [sym__declaration] = STATE(493),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(493),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(493),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(493),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(493),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(493),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(493),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(493),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(493),
    [sym_function_declaration] = STATE(493),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(493),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(493),
    [sym_break_statement] = STATE(493),
    [sym_labeled_statement] = STATE(493),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(493),
    [sym_class_declaration] = STATE(493),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(493),
    [sym_ambient_declaration] = STATE(493),
    [sym_type_alias_declaration] = STATE(493),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(493),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(493),
    [sym_switch_statement] = STATE(493),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(493),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(493),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(493),
    [sym_abstract_class_declaration] = STATE(493),
    [sym_interface_declaration] = STATE(493),
    [sym_export_statement] = STATE(493),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(493),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(493),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(493),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(493),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [218] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(1223),
    [aux_sym_string_token2] = ACTIONS(1225),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(850),
  },
  [219] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_break_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(187),
    [sym_class_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(187),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(187),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(187),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(187),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1227),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [220] = {
    [sym_catch_clause] = STATE(498),
    [sym_finally_clause] = STATE(499),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [anon_sym_symbol] = ACTIONS(1231),
    [anon_sym_break] = ACTIONS(1231),
    [anon_sym_return] = ACTIONS(1231),
    [anon_sym_static] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_interface] = ACTIONS(1231),
    [anon_sym_delete] = ACTIONS(1231),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_yield] = ACTIONS(1231),
    [sym_true] = ACTIONS(1231),
    [anon_sym_protected] = ACTIONS(1231),
    [anon_sym_set] = ACTIONS(1231),
    [anon_sym_import] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_number] = ACTIONS(1231),
    [anon_sym_typeof] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1231),
    [sym_null] = ACTIONS(1231),
    [anon_sym_catch] = ACTIONS(1233),
    [anon_sym_any] = ACTIONS(1231),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_public] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_with] = ACTIONS(1231),
    [sym_identifier] = ACTIONS(1231),
    [anon_sym_debugger] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_void] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [sym_super] = ACTIONS(1231),
    [anon_sym_private] = ACTIONS(1231),
    [anon_sym_get] = ACTIONS(1231),
    [anon_sym_default] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [anon_sym_continue] = ACTIONS(1231),
    [anon_sym_DASH_DASH] = ACTIONS(1229),
    [sym_this] = ACTIONS(1231),
    [anon_sym_throw] = ACTIONS(1231),
    [anon_sym_abstract] = ACTIONS(1231),
    [anon_sym_type] = ACTIONS(1231),
    [anon_sym_namespace] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [sym_false] = ACTIONS(1231),
    [anon_sym_case] = ACTIONS(1231),
    [anon_sym_module] = ACTIONS(1231),
    [anon_sym_class] = ACTIONS(1231),
    [anon_sym_declare] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_boolean] = ACTIONS(1231),
    [anon_sym_try] = ACTIONS(1231),
    [anon_sym_LT] = ACTIONS(1229),
    [sym_number] = ACTIONS(1229),
    [anon_sym_finally] = ACTIONS(1235),
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_function] = ACTIONS(1231),
    [sym_undefined] = ACTIONS(1231),
    [anon_sym_let] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_do] = ACTIONS(1231),
    [anon_sym_TILDE] = ACTIONS(1229),
    [anon_sym_await] = ACTIONS(1231),
  },
  [221] = {
    [sym_default_type] = STATE(504),
    [sym_constraint] = STATE(505),
    [sym_type_arguments] = STATE(506),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_COLON] = ACTIONS(1241),
    [anon_sym_extends] = ACTIONS(1241),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(1250),
  },
  [222] = {
    [anon_sym_BQUOTE] = ACTIONS(1252),
    [anon_sym_symbol] = ACTIONS(1254),
    [anon_sym_PIPE] = ACTIONS(1252),
    [anon_sym_break] = ACTIONS(1254),
    [anon_sym_return] = ACTIONS(1254),
    [anon_sym_static] = ACTIONS(1254),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_interface] = ACTIONS(1254),
    [anon_sym_delete] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_yield] = ACTIONS(1254),
    [sym_true] = ACTIONS(1254),
    [anon_sym_protected] = ACTIONS(1254),
    [anon_sym_set] = ACTIONS(1254),
    [anon_sym_import] = ACTIONS(1254),
    [anon_sym_DQUOTE] = ACTIONS(1252),
    [anon_sym_for] = ACTIONS(1254),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_number] = ACTIONS(1254),
    [anon_sym_typeof] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1254),
    [anon_sym_RBRACK] = ACTIONS(1252),
    [sym_null] = ACTIONS(1254),
    [anon_sym_any] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(1254),
    [anon_sym_public] = ACTIONS(1254),
    [anon_sym_var] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1254),
    [anon_sym_SQUOTE] = ACTIONS(1252),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_SLASH] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1254),
    [anon_sym_new] = ACTIONS(1254),
    [anon_sym_export] = ACTIONS(1254),
    [anon_sym_with] = ACTIONS(1254),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_debugger] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_void] = ACTIONS(1254),
    [anon_sym_const] = ACTIONS(1254),
    [sym_super] = ACTIONS(1254),
    [anon_sym_private] = ACTIONS(1254),
    [anon_sym_get] = ACTIONS(1254),
    [anon_sym_default] = ACTIONS(1254),
    [anon_sym_enum] = ACTIONS(1254),
    [anon_sym_continue] = ACTIONS(1254),
    [anon_sym_DASH_DASH] = ACTIONS(1252),
    [sym_this] = ACTIONS(1254),
    [anon_sym_throw] = ACTIONS(1254),
    [anon_sym_abstract] = ACTIONS(1254),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_namespace] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1252),
    [anon_sym_else] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [sym_false] = ACTIONS(1254),
    [anon_sym_case] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [anon_sym_class] = ACTIONS(1254),
    [anon_sym_declare] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1252),
    [anon_sym_boolean] = ACTIONS(1254),
    [anon_sym_EQ_GT] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1254),
    [anon_sym_LT] = ACTIONS(1252),
    [sym_number] = ACTIONS(1252),
    [ts_builtin_sym_end] = ACTIONS(1252),
    [anon_sym_function] = ACTIONS(1254),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(1254),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_do] = ACTIONS(1254),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_await] = ACTIONS(1254),
  },
  [223] = {
    [sym_array_type] = STATE(508),
    [sym_generic_type] = STATE(508),
    [sym_type_predicate] = STATE(508),
    [sym_literal_type] = STATE(508),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(508),
    [sym__primary_type] = STATE(508),
    [sym_lookup_type] = STATE(508),
    [sym_parenthesized_type] = STATE(508),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(508),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(508),
    [sym_type_query] = STATE(508),
    [sym_index_type_query] = STATE(508),
    [sym_existential_type] = STATE(508),
    [sym_flow_maybe_type] = STATE(508),
    [sym_string] = STATE(222),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(1258),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [224] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(518),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(518),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(518),
    [sym_property_signature] = STATE(518),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(518),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(1272),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [225] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(522),
    [sym_function_type] = STATE(522),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(522),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(522),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(522),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [226] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(523),
    [sym_function_type] = STATE(523),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(523),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(523),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(523),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [227] = {
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_symbol] = ACTIONS(1284),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_break] = ACTIONS(1284),
    [anon_sym_return] = ACTIONS(1284),
    [anon_sym_static] = ACTIONS(1284),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_interface] = ACTIONS(1284),
    [anon_sym_delete] = ACTIONS(1284),
    [anon_sym_if] = ACTIONS(1284),
    [anon_sym_yield] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [anon_sym_protected] = ACTIONS(1284),
    [anon_sym_set] = ACTIONS(1284),
    [anon_sym_import] = ACTIONS(1284),
    [anon_sym_DQUOTE] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1284),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_number] = ACTIONS(1284),
    [anon_sym_typeof] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1282),
    [anon_sym_switch] = ACTIONS(1284),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [sym_null] = ACTIONS(1284),
    [anon_sym_any] = ACTIONS(1284),
    [anon_sym_async] = ACTIONS(1284),
    [anon_sym_public] = ACTIONS(1284),
    [anon_sym_var] = ACTIONS(1284),
    [anon_sym_while] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_SLASH] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1284),
    [anon_sym_new] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(1284),
    [anon_sym_with] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_debugger] = ACTIONS(1284),
    [anon_sym_AT] = ACTIONS(1282),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_EQ] = ACTIONS(1284),
    [anon_sym_void] = ACTIONS(1284),
    [anon_sym_const] = ACTIONS(1284),
    [sym_super] = ACTIONS(1284),
    [anon_sym_private] = ACTIONS(1284),
    [anon_sym_get] = ACTIONS(1284),
    [anon_sym_default] = ACTIONS(1284),
    [anon_sym_enum] = ACTIONS(1284),
    [anon_sym_continue] = ACTIONS(1284),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [sym_this] = ACTIONS(1284),
    [anon_sym_throw] = ACTIONS(1284),
    [anon_sym_abstract] = ACTIONS(1284),
    [anon_sym_type] = ACTIONS(1284),
    [anon_sym_namespace] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [anon_sym_else] = ACTIONS(1284),
    [anon_sym_BANG] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [sym_false] = ACTIONS(1284),
    [anon_sym_case] = ACTIONS(1284),
    [anon_sym_module] = ACTIONS(1284),
    [anon_sym_class] = ACTIONS(1284),
    [anon_sym_declare] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1282),
    [anon_sym_boolean] = ACTIONS(1284),
    [anon_sym_EQ_GT] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_try] = ACTIONS(1284),
    [anon_sym_LT] = ACTIONS(1282),
    [sym_number] = ACTIONS(1282),
    [ts_builtin_sym_end] = ACTIONS(1282),
    [anon_sym_function] = ACTIONS(1284),
    [sym_undefined] = ACTIONS(1284),
    [anon_sym_let] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_do] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(1282),
    [anon_sym_await] = ACTIONS(1284),
  },
  [228] = {
    [sym_nested_identifier] = STATE(524),
    [sym_identifier] = ACTIONS(1286),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_number] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_symbol] = ACTIONS(1292),
    [anon_sym_PIPE] = ACTIONS(1290),
    [anon_sym_break] = ACTIONS(1292),
    [anon_sym_return] = ACTIONS(1292),
    [anon_sym_static] = ACTIONS(1292),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_interface] = ACTIONS(1292),
    [anon_sym_delete] = ACTIONS(1292),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_yield] = ACTIONS(1292),
    [sym_true] = ACTIONS(1292),
    [anon_sym_protected] = ACTIONS(1292),
    [anon_sym_set] = ACTIONS(1292),
    [anon_sym_import] = ACTIONS(1292),
    [anon_sym_DQUOTE] = ACTIONS(1290),
    [anon_sym_for] = ACTIONS(1292),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_number] = ACTIONS(1292),
    [anon_sym_typeof] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_switch] = ACTIONS(1292),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [sym_null] = ACTIONS(1292),
    [anon_sym_any] = ACTIONS(1292),
    [anon_sym_async] = ACTIONS(1292),
    [anon_sym_public] = ACTIONS(1292),
    [anon_sym_var] = ACTIONS(1292),
    [anon_sym_while] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1290),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_SLASH] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1292),
    [anon_sym_new] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1292),
    [anon_sym_with] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_debugger] = ACTIONS(1292),
    [anon_sym_AT] = ACTIONS(1290),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_EQ] = ACTIONS(1292),
    [anon_sym_void] = ACTIONS(1292),
    [anon_sym_const] = ACTIONS(1292),
    [sym_super] = ACTIONS(1292),
    [anon_sym_private] = ACTIONS(1292),
    [anon_sym_get] = ACTIONS(1292),
    [anon_sym_default] = ACTIONS(1292),
    [anon_sym_enum] = ACTIONS(1292),
    [anon_sym_continue] = ACTIONS(1292),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [sym_this] = ACTIONS(1292),
    [anon_sym_throw] = ACTIONS(1292),
    [anon_sym_abstract] = ACTIONS(1292),
    [anon_sym_type] = ACTIONS(1292),
    [anon_sym_namespace] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_else] = ACTIONS(1292),
    [anon_sym_BANG] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [sym_false] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1292),
    [anon_sym_module] = ACTIONS(1292),
    [anon_sym_class] = ACTIONS(1292),
    [anon_sym_declare] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1290),
    [anon_sym_boolean] = ACTIONS(1292),
    [anon_sym_EQ_GT] = ACTIONS(1290),
    [anon_sym_AMP] = ACTIONS(1290),
    [anon_sym_try] = ACTIONS(1292),
    [anon_sym_LT] = ACTIONS(1290),
    [sym_number] = ACTIONS(1290),
    [ts_builtin_sym_end] = ACTIONS(1290),
    [anon_sym_function] = ACTIONS(1292),
    [sym_undefined] = ACTIONS(1292),
    [anon_sym_let] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_do] = ACTIONS(1292),
    [anon_sym_TILDE] = ACTIONS(1290),
    [anon_sym_await] = ACTIONS(1292),
  },
  [231] = {
    [sym_nested_type_identifier] = STATE(527),
    [sym_nested_identifier] = STATE(237),
    [sym_identifier] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_formal_parameters] = STATE(528),
    [sym_type_parameters] = STATE(529),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(535),
    [sym_function_type] = STATE(535),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(535),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_object] = STATE(482),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(535),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(535),
    [aux_sym_export_statement_repeat1] = STATE(486),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(483),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_this] = ACTIONS(1300),
    [sym_true] = ACTIONS(457),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(457),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_export] = ACTIONS(1197),
  },
  [234] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(536),
    [sym_function_type] = STATE(536),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(536),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(536),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(536),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [235] = {
    [anon_sym_EQ_GT] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [anon_sym_symbol] = ACTIONS(1310),
    [anon_sym_PIPE] = ACTIONS(1308),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_static] = ACTIONS(1310),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_interface] = ACTIONS(1310),
    [anon_sym_delete] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(1310),
    [sym_true] = ACTIONS(1310),
    [anon_sym_protected] = ACTIONS(1310),
    [anon_sym_set] = ACTIONS(1310),
    [anon_sym_import] = ACTIONS(1310),
    [anon_sym_DQUOTE] = ACTIONS(1308),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_number] = ACTIONS(1310),
    [anon_sym_typeof] = ACTIONS(1310),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_switch] = ACTIONS(1310),
    [anon_sym_RBRACK] = ACTIONS(1308),
    [sym_null] = ACTIONS(1310),
    [anon_sym_any] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1310),
    [anon_sym_public] = ACTIONS(1310),
    [anon_sym_var] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1308),
    [anon_sym_RPAREN] = ACTIONS(1308),
    [anon_sym_SLASH] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1310),
    [anon_sym_new] = ACTIONS(1310),
    [anon_sym_export] = ACTIONS(1310),
    [anon_sym_with] = ACTIONS(1310),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_debugger] = ACTIONS(1310),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_EQ] = ACTIONS(1310),
    [anon_sym_void] = ACTIONS(1310),
    [anon_sym_const] = ACTIONS(1310),
    [sym_super] = ACTIONS(1310),
    [anon_sym_private] = ACTIONS(1310),
    [anon_sym_get] = ACTIONS(1310),
    [anon_sym_default] = ACTIONS(1310),
    [anon_sym_enum] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [sym_this] = ACTIONS(1310),
    [anon_sym_throw] = ACTIONS(1310),
    [anon_sym_abstract] = ACTIONS(1310),
    [anon_sym_type] = ACTIONS(1310),
    [anon_sym_namespace] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_else] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [sym_false] = ACTIONS(1310),
    [anon_sym_case] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1310),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_declare] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1308),
    [anon_sym_boolean] = ACTIONS(1310),
    [anon_sym_EQ_GT] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_try] = ACTIONS(1310),
    [anon_sym_LT] = ACTIONS(1308),
    [sym_number] = ACTIONS(1308),
    [ts_builtin_sym_end] = ACTIONS(1308),
    [anon_sym_function] = ACTIONS(1310),
    [sym_undefined] = ACTIONS(1310),
    [anon_sym_let] = ACTIONS(1310),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_do] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_await] = ACTIONS(1310),
  },
  [237] = {
    [anon_sym_DOT] = ACTIONS(1243),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_type_arguments] = STATE(539),
    [anon_sym_EQ_GT] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_RPAREN] = ACTIONS(1314),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1314),
  },
  [239] = {
    [aux_sym_type_parameters_repeat1] = STATE(542),
    [anon_sym_GT] = ACTIONS(1318),
    [anon_sym_COMMA] = ACTIONS(1320),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [aux_sym_implements_clause_repeat1] = STATE(547),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1324),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(1328),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_formal_parameters] = STATE(548),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [anon_sym_SLASH2] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(550),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(552),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_statement_block] = STATE(553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [246] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [247] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1340),
  },
  [248] = {
    [anon_sym_target] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_arguments] = STATE(556),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [250] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(556),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [251] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(556),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [252] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(556),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [253] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [254] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [255] = {
    [sym_arguments] = STATE(557),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1340),
  },
  [256] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [257] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [258] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(329),
  },
  [259] = {
    [sym__from_clause] = STATE(558),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__import_export_specifier] = STATE(561),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_COMMA] = ACTIONS(1400),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_arrow_function] = STATE(306),
    [sym_await_expression] = STATE(306),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(306),
    [sym_meta_property] = STATE(306),
    [sym__expression] = STATE(306),
    [sym_function] = STATE(52),
    [sym_import] = STATE(306),
    [sym_call_expression] = STATE(306),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(306),
    [sym_string] = STATE(306),
    [sym_template_string] = STATE(306),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(306),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(306),
    [sym_generator_function] = STATE(306),
    [sym_new_expression] = STATE(306),
    [sym_assignment_expression] = STATE(306),
    [sym_augmented_assignment_expression] = STATE(306),
    [sym_binary_expression] = STATE(306),
    [sym_unary_expression] = STATE(306),
    [sym_regex] = STATE(306),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(306),
    [sym_as_expression] = STATE(306),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(306),
    [sym_class] = STATE(306),
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(679),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(679),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(681),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(679),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [262] = {
    [sym_arrow_function] = STATE(563),
    [sym_await_expression] = STATE(563),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(563),
    [sym_meta_property] = STATE(563),
    [sym__expression] = STATE(563),
    [sym_function] = STATE(52),
    [sym_import] = STATE(563),
    [sym_call_expression] = STATE(563),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(563),
    [sym_string] = STATE(563),
    [sym_template_string] = STATE(563),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(563),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(563),
    [sym_generator_function] = STATE(563),
    [sym_new_expression] = STATE(563),
    [sym_assignment_expression] = STATE(563),
    [sym_augmented_assignment_expression] = STATE(563),
    [sym_binary_expression] = STATE(563),
    [sym_unary_expression] = STATE(563),
    [sym_regex] = STATE(563),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(563),
    [sym_as_expression] = STATE(563),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(563),
    [sym_class] = STATE(563),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(1416),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_true] = ACTIONS(1416),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1416),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1416),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1426),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1416),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_await] = ACTIONS(1430),
  },
  [263] = {
    [anon_sym_namespace] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [anon_sym_debugger] = ACTIONS(1434),
    [anon_sym_symbol] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_void] = ACTIONS(1434),
    [anon_sym_break] = ACTIONS(1434),
    [anon_sym_const] = ACTIONS(1434),
    [sym_super] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1434),
    [anon_sym_private] = ACTIONS(1434),
    [anon_sym_static] = ACTIONS(1434),
    [anon_sym_get] = ACTIONS(1434),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_interface] = ACTIONS(1434),
    [anon_sym_default] = ACTIONS(1434),
    [anon_sym_enum] = ACTIONS(1434),
    [anon_sym_delete] = ACTIONS(1434),
    [anon_sym_continue] = ACTIONS(1434),
    [anon_sym_DASH_DASH] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1434),
    [sym_this] = ACTIONS(1434),
    [anon_sym_yield] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [anon_sym_throw] = ACTIONS(1434),
    [anon_sym_protected] = ACTIONS(1434),
    [anon_sym_abstract] = ACTIONS(1434),
    [anon_sym_set] = ACTIONS(1434),
    [anon_sym_type] = ACTIONS(1434),
    [anon_sym_import] = ACTIONS(1434),
    [anon_sym_namespace] = ACTIONS(1434),
    [anon_sym_PLUS_PLUS] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1436),
    [anon_sym_else] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(1436),
    [sym_false] = ACTIONS(1434),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_case] = ACTIONS(1434),
    [anon_sym_module] = ACTIONS(1434),
    [anon_sym_number] = ACTIONS(1434),
    [anon_sym_class] = ACTIONS(1434),
    [anon_sym_declare] = ACTIONS(1434),
    [anon_sym_typeof] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1436),
    [anon_sym_switch] = ACTIONS(1434),
    [anon_sym_LPAREN] = ACTIONS(1436),
    [sym_null] = ACTIONS(1434),
    [anon_sym_any] = ACTIONS(1434),
    [anon_sym_boolean] = ACTIONS(1434),
    [anon_sym_async] = ACTIONS(1434),
    [anon_sym_public] = ACTIONS(1434),
    [anon_sym_var] = ACTIONS(1434),
    [anon_sym_while] = ACTIONS(1434),
    [anon_sym_SQUOTE] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1434),
    [anon_sym_LT] = ACTIONS(1436),
    [sym_number] = ACTIONS(1436),
    [anon_sym_SLASH] = ACTIONS(1434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1434),
    [anon_sym_function] = ACTIONS(1434),
    [sym_undefined] = ACTIONS(1434),
    [anon_sym_new] = ACTIONS(1434),
    [ts_builtin_sym_end] = ACTIONS(1436),
    [anon_sym_let] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_export] = ACTIONS(1434),
    [anon_sym_do] = ACTIONS(1434),
    [anon_sym_TILDE] = ACTIONS(1436),
    [anon_sym_with] = ACTIONS(1434),
    [anon_sym_await] = ACTIONS(1434),
  },
  [265] = {
    [sym__from_clause] = STATE(558),
    [sym__automatic_semicolon] = ACTIONS(1438),
    [anon_sym_SEMI] = ACTIONS(1438),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [anon_sym_while] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_generator_function_declaration] = STATE(567),
    [sym__declaration] = STATE(567),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(567),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(567),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(567),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(567),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(567),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(567),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(567),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(567),
    [sym_function_declaration] = STATE(567),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(567),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_labeled_statement] = STATE(567),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(567),
    [sym_class_declaration] = STATE(567),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(567),
    [sym_ambient_declaration] = STATE(567),
    [sym_type_alias_declaration] = STATE(567),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(567),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(567),
    [sym_switch_statement] = STATE(567),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(567),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(567),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(567),
    [sym_abstract_class_declaration] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_export_statement] = STATE(567),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(567),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(567),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(567),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [268] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1446),
    [anon_sym_debugger] = ACTIONS(1444),
    [anon_sym_symbol] = ACTIONS(1444),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1444),
    [anon_sym_void] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_const] = ACTIONS(1444),
    [sym_super] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_private] = ACTIONS(1444),
    [anon_sym_static] = ACTIONS(1444),
    [anon_sym_get] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1446),
    [anon_sym_interface] = ACTIONS(1444),
    [anon_sym_default] = ACTIONS(1444),
    [anon_sym_enum] = ACTIONS(1444),
    [anon_sym_delete] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_DASH_DASH] = ACTIONS(1446),
    [anon_sym_if] = ACTIONS(1444),
    [sym_this] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [anon_sym_throw] = ACTIONS(1444),
    [anon_sym_protected] = ACTIONS(1444),
    [anon_sym_abstract] = ACTIONS(1444),
    [anon_sym_set] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_namespace] = ACTIONS(1444),
    [anon_sym_PLUS_PLUS] = ACTIONS(1446),
    [anon_sym_DQUOTE] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1444),
    [anon_sym_BANG] = ACTIONS(1446),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [sym_false] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_case] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [anon_sym_number] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_declare] = ACTIONS(1444),
    [anon_sym_typeof] = ACTIONS(1444),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_switch] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [sym_null] = ACTIONS(1444),
    [anon_sym_any] = ACTIONS(1444),
    [anon_sym_boolean] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_public] = ACTIONS(1444),
    [anon_sym_var] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_SQUOTE] = ACTIONS(1446),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_LT] = ACTIONS(1446),
    [sym_number] = ACTIONS(1446),
    [anon_sym_SLASH] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1444),
    [anon_sym_function] = ACTIONS(1444),
    [sym_undefined] = ACTIONS(1444),
    [anon_sym_new] = ACTIONS(1444),
    [ts_builtin_sym_end] = ACTIONS(1446),
    [anon_sym_let] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(1444),
    [anon_sym_export] = ACTIONS(1444),
    [anon_sym_do] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_with] = ACTIONS(1444),
    [anon_sym_await] = ACTIONS(1444),
  },
  [270] = {
    [sym_arrow_function] = STATE(568),
    [sym_await_expression] = STATE(568),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(568),
    [sym_meta_property] = STATE(568),
    [sym__expression] = STATE(568),
    [sym_function] = STATE(52),
    [sym_import] = STATE(568),
    [sym_call_expression] = STATE(568),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(568),
    [sym_string] = STATE(568),
    [sym_template_string] = STATE(568),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(568),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(568),
    [sym_generator_function] = STATE(568),
    [sym_new_expression] = STATE(568),
    [sym_assignment_expression] = STATE(568),
    [sym_augmented_assignment_expression] = STATE(568),
    [sym_binary_expression] = STATE(568),
    [sym_unary_expression] = STATE(568),
    [sym_regex] = STATE(568),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(568),
    [sym_as_expression] = STATE(568),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(568),
    [sym_class] = STATE(568),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1448),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1450),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [271] = {
    [sym_arrow_function] = STATE(569),
    [sym_await_expression] = STATE(569),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(569),
    [sym_meta_property] = STATE(569),
    [sym__expression] = STATE(569),
    [sym_function] = STATE(52),
    [sym_import] = STATE(569),
    [sym_call_expression] = STATE(569),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(569),
    [sym_string] = STATE(569),
    [sym_template_string] = STATE(569),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(569),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(569),
    [sym_generator_function] = STATE(569),
    [sym_new_expression] = STATE(569),
    [sym_assignment_expression] = STATE(569),
    [sym_augmented_assignment_expression] = STATE(569),
    [sym_binary_expression] = STATE(569),
    [sym_unary_expression] = STATE(569),
    [sym_regex] = STATE(569),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(569),
    [sym_as_expression] = STATE(569),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(569),
    [sym_class] = STATE(569),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1452),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1452),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1454),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1452),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [272] = {
    [sym_arrow_function] = STATE(570),
    [sym_await_expression] = STATE(570),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(570),
    [sym_meta_property] = STATE(570),
    [sym__expression] = STATE(570),
    [sym_function] = STATE(52),
    [sym_import] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(570),
    [sym_string] = STATE(570),
    [sym_template_string] = STATE(570),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(570),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(570),
    [sym_generator_function] = STATE(570),
    [sym_new_expression] = STATE(570),
    [sym_assignment_expression] = STATE(570),
    [sym_augmented_assignment_expression] = STATE(570),
    [sym_binary_expression] = STATE(570),
    [sym_unary_expression] = STATE(570),
    [sym_regex] = STATE(570),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(570),
    [sym_as_expression] = STATE(570),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(570),
    [sym_class] = STATE(570),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1456),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1456),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1456),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1456),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1458),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1456),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [273] = {
    [sym_arrow_function] = STATE(571),
    [sym_await_expression] = STATE(571),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(571),
    [sym_meta_property] = STATE(571),
    [sym__expression] = STATE(571),
    [sym_function] = STATE(52),
    [sym_import] = STATE(571),
    [sym_call_expression] = STATE(571),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(571),
    [sym_string] = STATE(571),
    [sym_template_string] = STATE(571),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(571),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(571),
    [sym_generator_function] = STATE(571),
    [sym_new_expression] = STATE(571),
    [sym_assignment_expression] = STATE(571),
    [sym_augmented_assignment_expression] = STATE(571),
    [sym_binary_expression] = STATE(571),
    [sym_unary_expression] = STATE(571),
    [sym_regex] = STATE(571),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(571),
    [sym_as_expression] = STATE(571),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(571),
    [sym_class] = STATE(571),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1460),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1460),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1460),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1460),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1462),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1460),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [274] = {
    [sym_arrow_function] = STATE(572),
    [sym_await_expression] = STATE(572),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(572),
    [sym_meta_property] = STATE(572),
    [sym__expression] = STATE(572),
    [sym_function] = STATE(52),
    [sym_import] = STATE(572),
    [sym_call_expression] = STATE(572),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(572),
    [sym_string] = STATE(572),
    [sym_template_string] = STATE(572),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(572),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(572),
    [sym_generator_function] = STATE(572),
    [sym_new_expression] = STATE(572),
    [sym_assignment_expression] = STATE(572),
    [sym_augmented_assignment_expression] = STATE(572),
    [sym_binary_expression] = STATE(572),
    [sym_unary_expression] = STATE(572),
    [sym_regex] = STATE(572),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(572),
    [sym_as_expression] = STATE(572),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(572),
    [sym_class] = STATE(572),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1464),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1464),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1464),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1466),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1464),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [275] = {
    [sym_arrow_function] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(573),
    [sym_meta_property] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym__expression] = STATE(574),
    [sym_function] = STATE(52),
    [sym_import] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(574),
    [sym_generator_function] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_regex] = STATE(574),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(574),
    [sym_as_expression] = STATE(574),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(574),
    [sym_class] = STATE(574),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1468),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1468),
    [sym_number] = ACTIONS(1470),
    [sym_true] = ACTIONS(1468),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1468),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [276] = {
    [sym_arrow_function] = STATE(575),
    [sym_await_expression] = STATE(575),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(575),
    [sym_meta_property] = STATE(575),
    [sym__expression] = STATE(575),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(575),
    [sym_call_expression] = STATE(575),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(575),
    [sym_string] = STATE(575),
    [sym_template_string] = STATE(575),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(575),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(575),
    [sym_generator_function] = STATE(575),
    [sym_new_expression] = STATE(575),
    [sym_assignment_expression] = STATE(575),
    [sym_augmented_assignment_expression] = STATE(575),
    [sym_binary_expression] = STATE(575),
    [sym_unary_expression] = STATE(575),
    [sym_regex] = STATE(575),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(575),
    [sym_as_expression] = STATE(575),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(575),
    [sym_class] = STATE(575),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1472),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1472),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1474),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1472),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [277] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(576),
    [sym_function_type] = STATE(576),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(576),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_template_string] = STATE(577),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(576),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(576),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [278] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1510),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [sym__automatic_semicolon] = ACTIONS(1510),
    [anon_sym_SEMI] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_BANG_EQ] = ACTIONS(1512),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_as] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1512),
    [anon_sym_instanceof] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_SLASH] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1510),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_GT_GT] = ACTIONS(1512),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_in] = ACTIONS(1512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BANG] = ACTIONS(1512),
  },
  [279] = {
    [sym_await_expression] = STATE(568),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(568),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(568),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(568),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(52),
    [sym_import] = STATE(568),
    [sym_call_expression] = STATE(568),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(568),
    [sym_template_string] = STATE(568),
    [sym_yield_expression] = STATE(568),
    [sym_type_assertion] = STATE(568),
    [sym_new_expression] = STATE(568),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(568),
    [sym_binary_expression] = STATE(568),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(568),
    [sym_internal_module] = STATE(568),
    [sym_arrow_function] = STATE(568),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(53),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(56),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(58),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(53),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(579),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(568),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(568),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(568),
    [sym_regex] = STATE(568),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(568),
    [sym_class] = STATE(568),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1516),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1520),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1522),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1524),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [sym_false] = ACTIONS(1524),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [sym_null] = ACTIONS(1448),
    [anon_sym_any] = ACTIONS(1516),
    [anon_sym_boolean] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1534),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1516),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1448),
    [anon_sym_new] = ACTIONS(1536),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [280] = {
    [sym_arrow_function] = STATE(589),
    [sym_await_expression] = STATE(589),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(589),
    [sym_meta_property] = STATE(589),
    [sym__expression] = STATE(589),
    [sym_function] = STATE(52),
    [sym_import] = STATE(589),
    [sym_call_expression] = STATE(589),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(589),
    [sym_string] = STATE(589),
    [sym_template_string] = STATE(589),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(589),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(589),
    [sym_generator_function] = STATE(589),
    [sym_new_expression] = STATE(589),
    [sym_assignment_expression] = STATE(589),
    [sym_augmented_assignment_expression] = STATE(589),
    [sym_binary_expression] = STATE(589),
    [sym_unary_expression] = STATE(589),
    [sym_regex] = STATE(589),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(589),
    [sym_as_expression] = STATE(589),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(589),
    [sym_class] = STATE(589),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1538),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1538),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1538),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1538),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1538),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [281] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1542),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [sym__automatic_semicolon] = ACTIONS(1542),
    [anon_sym_SEMI] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_QMARK] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_as] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_instanceof] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BANG] = ACTIONS(1544),
  },
  [282] = {
    [sym_arrow_function] = STATE(590),
    [sym_await_expression] = STATE(590),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(590),
    [sym_meta_property] = STATE(590),
    [sym__expression] = STATE(590),
    [sym_function] = STATE(52),
    [sym_import] = STATE(590),
    [sym_call_expression] = STATE(590),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(590),
    [sym_string] = STATE(590),
    [sym_template_string] = STATE(590),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(590),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(590),
    [sym_generator_function] = STATE(590),
    [sym_new_expression] = STATE(590),
    [sym_assignment_expression] = STATE(590),
    [sym_augmented_assignment_expression] = STATE(590),
    [sym_binary_expression] = STATE(590),
    [sym_unary_expression] = STATE(590),
    [sym_regex] = STATE(590),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(590),
    [sym_as_expression] = STATE(590),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(590),
    [sym_class] = STATE(590),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1546),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1546),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1546),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1548),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1546),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [283] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [sym__automatic_semicolon] = ACTIONS(1550),
    [anon_sym_SEMI] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_GT_GT_GT] = ACTIONS(1550),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_BANG_EQ] = ACTIONS(1552),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_QMARK] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_as] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_EQ_EQ] = ACTIONS(1552),
    [anon_sym_instanceof] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1550),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_STAR_STAR] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_GT_GT] = ACTIONS(1552),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_in] = ACTIONS(1552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BANG] = ACTIONS(1552),
  },
  [284] = {
    [sym_arrow_function] = STATE(592),
    [sym_await_expression] = STATE(592),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(591),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(592),
    [sym_meta_property] = STATE(592),
    [sym__expression] = STATE(592),
    [sym_function] = STATE(52),
    [sym_import] = STATE(592),
    [sym_call_expression] = STATE(592),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(592),
    [sym_string] = STATE(592),
    [sym_template_string] = STATE(592),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(592),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(592),
    [sym_generator_function] = STATE(592),
    [sym_new_expression] = STATE(592),
    [sym_assignment_expression] = STATE(592),
    [sym_augmented_assignment_expression] = STATE(592),
    [sym_binary_expression] = STATE(592),
    [sym_unary_expression] = STATE(592),
    [sym_regex] = STATE(592),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(592),
    [sym_as_expression] = STATE(592),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(592),
    [sym_class] = STATE(592),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1554),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1554),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1554),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1554),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1556),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1554),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [285] = {
    [sym_type_annotation] = STATE(593),
    [anon_sym_EQ_GT] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1558),
  },
  [286] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(594),
    [sym_function_type] = STATE(594),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(594),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(594),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(594),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [287] = {
    [anon_sym_EQ_GT] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1560),
  },
  [288] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_BQUOTE] = ACTIONS(1565),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1571),
    [anon_sym_AT] = ACTIONS(1574),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_void] = ACTIONS(1580),
    [anon_sym_break] = ACTIONS(1583),
    [anon_sym_const] = ACTIONS(1586),
    [sym_super] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1592),
    [anon_sym_private] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1595),
    [anon_sym_interface] = ACTIONS(1597),
    [anon_sym_default] = ACTIONS(1600),
    [anon_sym_enum] = ACTIONS(1602),
    [anon_sym_delete] = ACTIONS(1605),
    [anon_sym_continue] = ACTIONS(1608),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1614),
    [sym_this] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1620),
    [sym_true] = ACTIONS(1617),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1571),
    [anon_sym_abstract] = ACTIONS(1626),
    [anon_sym_set] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1629),
    [anon_sym_import] = ACTIONS(1632),
    [anon_sym_namespace] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1638),
    [anon_sym_BANG] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1644),
    [anon_sym_LBRACK] = ACTIONS(1647),
    [sym_false] = ACTIONS(1617),
    [anon_sym_SEMI] = ACTIONS(1650),
    [anon_sym_case] = ACTIONS(1600),
    [anon_sym_module] = ACTIONS(1653),
    [anon_sym_number] = ACTIONS(1571),
    [anon_sym_class] = ACTIONS(1656),
    [anon_sym_declare] = ACTIONS(1659),
    [anon_sym_typeof] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1662),
    [anon_sym_switch] = ACTIONS(1665),
    [anon_sym_LPAREN] = ACTIONS(1668),
    [sym_null] = ACTIONS(1617),
    [anon_sym_any] = ACTIONS(1571),
    [anon_sym_boolean] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_public] = ACTIONS(1571),
    [anon_sym_var] = ACTIONS(1674),
    [anon_sym_while] = ACTIONS(1677),
    [anon_sym_SQUOTE] = ACTIONS(1680),
    [anon_sym_try] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(1686),
    [sym_number] = ACTIONS(1689),
    [anon_sym_SLASH] = ACTIONS(1692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1571),
    [anon_sym_function] = ACTIONS(1695),
    [sym_undefined] = ACTIONS(1617),
    [anon_sym_new] = ACTIONS(1698),
    [ts_builtin_sym_end] = ACTIONS(1595),
    [anon_sym_let] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_export] = ACTIONS(1704),
    [anon_sym_do] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1641),
    [anon_sym_with] = ACTIONS(1710),
    [anon_sym_await] = ACTIONS(1713),
  },
  [289] = {
    [sym_arrow_function] = STATE(595),
    [sym_await_expression] = STATE(595),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(595),
    [sym_meta_property] = STATE(595),
    [sym__expression] = STATE(595),
    [sym_function] = STATE(52),
    [sym_import] = STATE(595),
    [sym_call_expression] = STATE(595),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(595),
    [sym_string] = STATE(595),
    [sym_template_string] = STATE(595),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(595),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(595),
    [sym_generator_function] = STATE(595),
    [sym_new_expression] = STATE(595),
    [sym_assignment_expression] = STATE(595),
    [sym_augmented_assignment_expression] = STATE(595),
    [sym_binary_expression] = STATE(595),
    [sym_unary_expression] = STATE(595),
    [sym_regex] = STATE(595),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(595),
    [sym_as_expression] = STATE(595),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(595),
    [sym_class] = STATE(595),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1716),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1716),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(1716),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1716),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1718),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1716),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [290] = {
    [sym_class_declaration] = STATE(597),
    [sym_generator_function_declaration] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_enum_declaration] = STATE(597),
    [sym_function_signature] = STATE(597),
    [sym_abstract_class_declaration] = STATE(597),
    [sym_module] = STATE(597),
    [sym_interface_declaration] = STATE(597),
    [sym_function_declaration] = STATE(597),
    [sym_variable_declaration] = STATE(597),
    [sym_lexical_declaration] = STATE(597),
    [sym_ambient_declaration] = STATE(597),
    [sym_import_alias] = STATE(597),
    [sym_type_alias_declaration] = STATE(597),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(597),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_module] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_async] = ACTIONS(363),
  },
  [291] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(599),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(420),
    [sym_type_parameters] = STATE(600),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(1722),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [292] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_export] = ACTIONS(1724),
    [anon_sym_class] = ACTIONS(1724),
    [anon_sym_AT] = ACTIONS(1726),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_GT_GT_GT] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [anon_sym_QMARK] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(1729),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_instanceof] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG] = ACTIONS(1731),
  },
  [294] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [295] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1735),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [anon_sym_debugger] = ACTIONS(1735),
    [anon_sym_symbol] = ACTIONS(1735),
    [anon_sym_AT] = ACTIONS(1737),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_void] = ACTIONS(1735),
    [anon_sym_break] = ACTIONS(1735),
    [anon_sym_const] = ACTIONS(1735),
    [sym_super] = ACTIONS(1735),
    [anon_sym_return] = ACTIONS(1735),
    [anon_sym_private] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1735),
    [anon_sym_get] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1737),
    [anon_sym_interface] = ACTIONS(1735),
    [anon_sym_default] = ACTIONS(1735),
    [anon_sym_enum] = ACTIONS(1735),
    [anon_sym_delete] = ACTIONS(1735),
    [anon_sym_continue] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [anon_sym_if] = ACTIONS(1735),
    [sym_this] = ACTIONS(1735),
    [anon_sym_yield] = ACTIONS(1735),
    [sym_true] = ACTIONS(1735),
    [anon_sym_throw] = ACTIONS(1735),
    [anon_sym_protected] = ACTIONS(1735),
    [anon_sym_abstract] = ACTIONS(1735),
    [anon_sym_set] = ACTIONS(1735),
    [anon_sym_type] = ACTIONS(1735),
    [anon_sym_import] = ACTIONS(1735),
    [anon_sym_namespace] = ACTIONS(1735),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_DQUOTE] = ACTIONS(1737),
    [anon_sym_else] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1737),
    [anon_sym_for] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [sym_false] = ACTIONS(1735),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_case] = ACTIONS(1735),
    [anon_sym_module] = ACTIONS(1735),
    [anon_sym_number] = ACTIONS(1735),
    [anon_sym_class] = ACTIONS(1735),
    [anon_sym_declare] = ACTIONS(1735),
    [anon_sym_typeof] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(1737),
    [anon_sym_switch] = ACTIONS(1735),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [sym_null] = ACTIONS(1735),
    [anon_sym_any] = ACTIONS(1735),
    [anon_sym_boolean] = ACTIONS(1735),
    [anon_sym_async] = ACTIONS(1735),
    [anon_sym_public] = ACTIONS(1735),
    [anon_sym_var] = ACTIONS(1735),
    [anon_sym_while] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1737),
    [anon_sym_try] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1737),
    [sym_number] = ACTIONS(1737),
    [anon_sym_SLASH] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1735),
    [anon_sym_function] = ACTIONS(1735),
    [sym_undefined] = ACTIONS(1735),
    [anon_sym_new] = ACTIONS(1735),
    [ts_builtin_sym_end] = ACTIONS(1737),
    [anon_sym_let] = ACTIONS(1735),
    [anon_sym_PLUS] = ACTIONS(1735),
    [anon_sym_export] = ACTIONS(1735),
    [anon_sym_do] = ACTIONS(1735),
    [anon_sym_TILDE] = ACTIONS(1737),
    [anon_sym_with] = ACTIONS(1735),
    [anon_sym_await] = ACTIONS(1735),
  },
  [297] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(1743),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(1741),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_of] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [299] = {
    [anon_sym_RBRACE] = ACTIONS(1745),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(1745),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [301] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1747),
    [sym__automatic_semicolon] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1747),
    [anon_sym_BQUOTE] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1749),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_LT_EQ] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_GT_EQ] = ACTIONS(1747),
    [anon_sym_GT] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1747),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1747),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1749),
    [anon_sym_SLASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1747),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_GT_GT] = ACTIONS(1749),
    [anon_sym_PLUS_PLUS] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(1749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1747),
    [anon_sym_BANG] = ACTIONS(1749),
  },
  [302] = {
    [aux_sym_template_string_repeat1] = STATE(302),
    [sym_template_substitution] = STATE(302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1751),
    [sym_escape_sequence] = ACTIONS(1754),
    [anon_sym_BQUOTE] = ACTIONS(1757),
    [sym__template_chars] = ACTIONS(1754),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [sym__automatic_semicolon] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1761),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_GT_GT_GT] = ACTIONS(1759),
    [anon_sym_AMP_AMP] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_instanceof] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1759),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_STAR_STAR] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_PLUS_PLUS] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(1761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1759),
    [anon_sym_BANG] = ACTIONS(1761),
  },
  [304] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [305] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1763),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [306] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1765),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [307] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1767),
    [sym__automatic_semicolon] = ACTIONS(1767),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_PERCENT_EQ] = ACTIONS(1767),
    [anon_sym_AMP_EQ] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1769),
    [anon_sym_COMMA] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_GT_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ] = ACTIONS(1769),
    [anon_sym_BANG_EQ] = ACTIONS(1769),
    [anon_sym_GT_EQ] = ACTIONS(1767),
    [anon_sym_CARET_EQ] = ACTIONS(1767),
    [anon_sym_PIPE_EQ] = ACTIONS(1767),
    [anon_sym_DASH_EQ] = ACTIONS(1767),
    [anon_sym_RBRACE] = ACTIONS(1767),
    [anon_sym_PERCENT] = ACTIONS(1769),
    [anon_sym_LT_LT_EQ] = ACTIONS(1767),
    [anon_sym_as] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_instanceof] = ACTIONS(1767),
    [anon_sym_GT_GT_EQ] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1769),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_in] = ACTIONS(1769),
    [anon_sym_BANG] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(1767),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1767),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_of] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_STAR_EQ] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1767),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_EQ_EQ] = ACTIONS(1769),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1767),
    [anon_sym_CARET] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1771),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [anon_sym_LBRACK] = ACTIONS(1773),
    [sym_identifier] = ACTIONS(1775),
    [anon_sym_module] = ACTIONS(1775),
    [anon_sym_symbol] = ACTIONS(1775),
    [anon_sym_number] = ACTIONS(1775),
    [anon_sym_class] = ACTIONS(1775),
    [anon_sym_AT] = ACTIONS(1773),
    [anon_sym_declare] = ACTIONS(1775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(1773),
    [anon_sym_STAR] = ACTIONS(1773),
    [anon_sym_void] = ACTIONS(1775),
    [anon_sym_any] = ACTIONS(1775),
    [anon_sym_private] = ACTIONS(1775),
    [anon_sym_boolean] = ACTIONS(1775),
    [anon_sym_static] = ACTIONS(1775),
    [anon_sym_async] = ACTIONS(1775),
    [anon_sym_get] = ACTIONS(1775),
    [anon_sym_public] = ACTIONS(1775),
    [anon_sym_RBRACE] = ACTIONS(1773),
    [anon_sym_SQUOTE] = ACTIONS(1773),
    [sym_this] = ACTIONS(1775),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1775),
    [anon_sym_string] = ACTIONS(1775),
    [anon_sym_abstract] = ACTIONS(1775),
    [anon_sym_set] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1775),
    [anon_sym_export] = ACTIONS(1775),
    [sym_readonly] = ACTIONS(1775),
    [anon_sym_namespace] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1773),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [anon_sym_LBRACK] = ACTIONS(1779),
    [sym_identifier] = ACTIONS(1781),
    [anon_sym_module] = ACTIONS(1781),
    [anon_sym_symbol] = ACTIONS(1781),
    [anon_sym_number] = ACTIONS(1781),
    [anon_sym_class] = ACTIONS(1781),
    [anon_sym_AT] = ACTIONS(1779),
    [anon_sym_declare] = ACTIONS(1781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1779),
    [anon_sym_void] = ACTIONS(1781),
    [anon_sym_any] = ACTIONS(1781),
    [anon_sym_private] = ACTIONS(1781),
    [anon_sym_boolean] = ACTIONS(1781),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(1781),
    [anon_sym_public] = ACTIONS(1781),
    [anon_sym_RBRACE] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1779),
    [sym_this] = ACTIONS(1781),
    [sym_number] = ACTIONS(1779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1781),
    [anon_sym_string] = ACTIONS(1781),
    [anon_sym_abstract] = ACTIONS(1781),
    [anon_sym_set] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_export] = ACTIONS(1781),
    [sym_readonly] = ACTIONS(1781),
    [anon_sym_namespace] = ACTIONS(1781),
    [anon_sym_DQUOTE] = ACTIONS(1779),
  },
  [312] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(605),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(604),
    [sym_type_parameters] = STATE(606),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [313] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [aux_sym_object_repeat1] = STATE(433),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [315] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [316] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [317] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [318] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1069),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_of] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
  },
  [319] = {
    [anon_sym_EQ] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [anon_sym_EQ] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(489),
    [sym_identifier] = ACTIONS(1791),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(612),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(552),
    [sym_identifier] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(599),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(420),
    [sym_type_parameters] = STATE(600),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(1797),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [325] = {
    [sym_identifier] = ACTIONS(1799),
    [anon_sym_BQUOTE] = ACTIONS(1801),
    [anon_sym_debugger] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1799),
    [anon_sym_AT] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1799),
    [anon_sym_void] = ACTIONS(1799),
    [anon_sym_break] = ACTIONS(1799),
    [anon_sym_const] = ACTIONS(1799),
    [sym_super] = ACTIONS(1799),
    [anon_sym_return] = ACTIONS(1799),
    [anon_sym_private] = ACTIONS(1799),
    [anon_sym_static] = ACTIONS(1799),
    [anon_sym_get] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1801),
    [anon_sym_interface] = ACTIONS(1799),
    [anon_sym_default] = ACTIONS(1799),
    [anon_sym_enum] = ACTIONS(1799),
    [anon_sym_delete] = ACTIONS(1799),
    [anon_sym_continue] = ACTIONS(1799),
    [anon_sym_DASH_DASH] = ACTIONS(1801),
    [anon_sym_if] = ACTIONS(1799),
    [sym_this] = ACTIONS(1799),
    [anon_sym_yield] = ACTIONS(1799),
    [sym_true] = ACTIONS(1799),
    [anon_sym_throw] = ACTIONS(1799),
    [anon_sym_protected] = ACTIONS(1799),
    [anon_sym_abstract] = ACTIONS(1799),
    [anon_sym_set] = ACTIONS(1799),
    [anon_sym_type] = ACTIONS(1799),
    [anon_sym_import] = ACTIONS(1799),
    [anon_sym_namespace] = ACTIONS(1799),
    [anon_sym_PLUS_PLUS] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1801),
    [anon_sym_else] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1801),
    [anon_sym_for] = ACTIONS(1799),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [sym_false] = ACTIONS(1799),
    [anon_sym_SEMI] = ACTIONS(1801),
    [anon_sym_case] = ACTIONS(1799),
    [anon_sym_module] = ACTIONS(1799),
    [anon_sym_number] = ACTIONS(1799),
    [anon_sym_class] = ACTIONS(1799),
    [anon_sym_declare] = ACTIONS(1799),
    [anon_sym_typeof] = ACTIONS(1799),
    [anon_sym_LBRACE] = ACTIONS(1801),
    [anon_sym_switch] = ACTIONS(1799),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [sym_null] = ACTIONS(1799),
    [anon_sym_any] = ACTIONS(1799),
    [anon_sym_boolean] = ACTIONS(1799),
    [anon_sym_async] = ACTIONS(1799),
    [anon_sym_public] = ACTIONS(1799),
    [anon_sym_var] = ACTIONS(1799),
    [anon_sym_while] = ACTIONS(1799),
    [anon_sym_SQUOTE] = ACTIONS(1801),
    [anon_sym_try] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1801),
    [sym_number] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1799),
    [anon_sym_function] = ACTIONS(1799),
    [sym_undefined] = ACTIONS(1799),
    [anon_sym_new] = ACTIONS(1799),
    [ts_builtin_sym_end] = ACTIONS(1801),
    [anon_sym_let] = ACTIONS(1799),
    [anon_sym_PLUS] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1799),
    [anon_sym_do] = ACTIONS(1799),
    [anon_sym_TILDE] = ACTIONS(1801),
    [anon_sym_with] = ACTIONS(1799),
    [anon_sym_await] = ACTIONS(1799),
  },
  [326] = {
    [sym_arrow_function] = STATE(615),
    [sym_await_expression] = STATE(615),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(615),
    [sym_meta_property] = STATE(615),
    [sym__expression] = STATE(615),
    [sym_function] = STATE(52),
    [sym_import] = STATE(615),
    [sym_call_expression] = STATE(615),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(615),
    [sym_string] = STATE(615),
    [sym_template_string] = STATE(615),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(615),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(615),
    [sym_generator_function] = STATE(615),
    [sym_new_expression] = STATE(615),
    [sym_assignment_expression] = STATE(615),
    [sym_augmented_assignment_expression] = STATE(615),
    [sym_binary_expression] = STATE(615),
    [sym_unary_expression] = STATE(615),
    [sym_regex] = STATE(615),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(615),
    [sym_as_expression] = STATE(615),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(615),
    [sym_class] = STATE(615),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(1803),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(1803),
    [sym_number] = ACTIONS(1805),
    [sym_true] = ACTIONS(1803),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(1803),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [327] = {
    [sym__automatic_semicolon] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym__initializer] = STATE(616),
    [sym__automatic_semicolon] = ACTIONS(1809),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(1809),
    [anon_sym_COMMA] = ACTIONS(1809),
    [sym_comment] = ACTIONS(3),
  },
  [329] = {
    [sym_enum_body] = STATE(617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(778),
  },
  [330] = {
    [sym__automatic_semicolon] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_COMMA] = ACTIONS(1811),
    [sym_comment] = ACTIONS(3),
  },
  [331] = {
    [sym__initializer] = STATE(618),
    [sym__automatic_semicolon] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_COMMA] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(619),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [333] = {
    [sym_identifier] = ACTIONS(1815),
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [anon_sym_debugger] = ACTIONS(1815),
    [anon_sym_symbol] = ACTIONS(1815),
    [anon_sym_AT] = ACTIONS(1817),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_void] = ACTIONS(1815),
    [anon_sym_break] = ACTIONS(1815),
    [anon_sym_const] = ACTIONS(1815),
    [sym_super] = ACTIONS(1815),
    [anon_sym_return] = ACTIONS(1815),
    [anon_sym_private] = ACTIONS(1815),
    [anon_sym_static] = ACTIONS(1815),
    [anon_sym_get] = ACTIONS(1815),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_interface] = ACTIONS(1815),
    [anon_sym_default] = ACTIONS(1815),
    [anon_sym_enum] = ACTIONS(1815),
    [anon_sym_delete] = ACTIONS(1815),
    [anon_sym_continue] = ACTIONS(1815),
    [anon_sym_DASH_DASH] = ACTIONS(1817),
    [anon_sym_if] = ACTIONS(1815),
    [sym_this] = ACTIONS(1815),
    [anon_sym_yield] = ACTIONS(1815),
    [sym_true] = ACTIONS(1815),
    [anon_sym_throw] = ACTIONS(1815),
    [anon_sym_protected] = ACTIONS(1815),
    [anon_sym_abstract] = ACTIONS(1815),
    [anon_sym_set] = ACTIONS(1815),
    [anon_sym_type] = ACTIONS(1815),
    [anon_sym_import] = ACTIONS(1815),
    [anon_sym_namespace] = ACTIONS(1815),
    [anon_sym_PLUS_PLUS] = ACTIONS(1817),
    [anon_sym_DQUOTE] = ACTIONS(1817),
    [anon_sym_else] = ACTIONS(1815),
    [anon_sym_BANG] = ACTIONS(1817),
    [anon_sym_for] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [sym_false] = ACTIONS(1815),
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_case] = ACTIONS(1815),
    [anon_sym_module] = ACTIONS(1815),
    [anon_sym_number] = ACTIONS(1815),
    [anon_sym_class] = ACTIONS(1815),
    [anon_sym_declare] = ACTIONS(1815),
    [anon_sym_typeof] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1817),
    [anon_sym_switch] = ACTIONS(1815),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [sym_null] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1815),
    [anon_sym_boolean] = ACTIONS(1815),
    [anon_sym_async] = ACTIONS(1815),
    [anon_sym_public] = ACTIONS(1815),
    [anon_sym_var] = ACTIONS(1815),
    [anon_sym_while] = ACTIONS(1815),
    [anon_sym_SQUOTE] = ACTIONS(1817),
    [anon_sym_try] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(1817),
    [sym_number] = ACTIONS(1817),
    [anon_sym_SLASH] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1815),
    [anon_sym_function] = ACTIONS(1815),
    [sym_undefined] = ACTIONS(1815),
    [anon_sym_new] = ACTIONS(1815),
    [ts_builtin_sym_end] = ACTIONS(1817),
    [anon_sym_let] = ACTIONS(1815),
    [anon_sym_PLUS] = ACTIONS(1815),
    [anon_sym_export] = ACTIONS(1815),
    [anon_sym_do] = ACTIONS(1815),
    [anon_sym_TILDE] = ACTIONS(1817),
    [anon_sym_with] = ACTIONS(1815),
    [anon_sym_await] = ACTIONS(1815),
  },
  [334] = {
    [aux_sym_variable_declaration_repeat1] = STATE(621),
    [sym__automatic_semicolon] = ACTIONS(1819),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [335] = {
    [sym__automatic_semicolon] = ACTIONS(1821),
    [anon_sym_SEMI] = ACTIONS(1821),
    [anon_sym_COMMA] = ACTIONS(1821),
    [sym_comment] = ACTIONS(3),
  },
  [336] = {
    [sym__initializer] = STATE(622),
    [sym__automatic_semicolon] = ACTIONS(1823),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_COMMA] = ACTIONS(1823),
    [sym_comment] = ACTIONS(3),
  },
  [337] = {
    [anon_sym_RBRACK] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
  },
  [338] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(1825),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [339] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_EQ_GT] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1827),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
  },
  [340] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1829),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [sym__automatic_semicolon] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_GT_GT_GT] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_BANG_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_PERCENT] = ACTIONS(1829),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_EQ_EQ] = ACTIONS(1831),
    [anon_sym_instanceof] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_CARET] = ACTIONS(1829),
    [anon_sym_STAR_STAR] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_in] = ACTIONS(1831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
  },
  [341] = {
    [aux_sym_array_repeat1] = STATE(625),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [342] = {
    [aux_sym_array_repeat1] = STATE(625),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [343] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(1833),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [sym__automatic_semicolon] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1837),
  },
  [345] = {
    [sym_identifier] = ACTIONS(1839),
    [anon_sym_BQUOTE] = ACTIONS(1841),
    [anon_sym_debugger] = ACTIONS(1839),
    [anon_sym_symbol] = ACTIONS(1839),
    [anon_sym_AT] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1839),
    [anon_sym_void] = ACTIONS(1839),
    [anon_sym_break] = ACTIONS(1839),
    [anon_sym_const] = ACTIONS(1839),
    [sym_super] = ACTIONS(1839),
    [anon_sym_return] = ACTIONS(1839),
    [anon_sym_private] = ACTIONS(1839),
    [anon_sym_static] = ACTIONS(1839),
    [anon_sym_get] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_interface] = ACTIONS(1839),
    [anon_sym_default] = ACTIONS(1839),
    [anon_sym_enum] = ACTIONS(1839),
    [anon_sym_delete] = ACTIONS(1839),
    [anon_sym_continue] = ACTIONS(1839),
    [anon_sym_DASH_DASH] = ACTIONS(1841),
    [anon_sym_if] = ACTIONS(1839),
    [sym_this] = ACTIONS(1839),
    [anon_sym_yield] = ACTIONS(1839),
    [sym_true] = ACTIONS(1839),
    [anon_sym_throw] = ACTIONS(1839),
    [anon_sym_protected] = ACTIONS(1839),
    [anon_sym_abstract] = ACTIONS(1839),
    [anon_sym_set] = ACTIONS(1839),
    [anon_sym_type] = ACTIONS(1839),
    [anon_sym_import] = ACTIONS(1839),
    [anon_sym_namespace] = ACTIONS(1839),
    [anon_sym_PLUS_PLUS] = ACTIONS(1841),
    [anon_sym_DQUOTE] = ACTIONS(1841),
    [anon_sym_else] = ACTIONS(1839),
    [anon_sym_BANG] = ACTIONS(1841),
    [anon_sym_for] = ACTIONS(1839),
    [anon_sym_LBRACK] = ACTIONS(1841),
    [sym_false] = ACTIONS(1839),
    [anon_sym_SEMI] = ACTIONS(1841),
    [anon_sym_case] = ACTIONS(1839),
    [anon_sym_module] = ACTIONS(1839),
    [anon_sym_number] = ACTIONS(1839),
    [anon_sym_class] = ACTIONS(1839),
    [anon_sym_declare] = ACTIONS(1839),
    [anon_sym_typeof] = ACTIONS(1839),
    [anon_sym_LBRACE] = ACTIONS(1841),
    [anon_sym_switch] = ACTIONS(1839),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_null] = ACTIONS(1839),
    [anon_sym_any] = ACTIONS(1839),
    [anon_sym_boolean] = ACTIONS(1839),
    [anon_sym_async] = ACTIONS(1839),
    [anon_sym_public] = ACTIONS(1839),
    [anon_sym_var] = ACTIONS(1839),
    [anon_sym_while] = ACTIONS(1839),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [anon_sym_try] = ACTIONS(1839),
    [anon_sym_LT] = ACTIONS(1841),
    [sym_number] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1839),
    [anon_sym_function] = ACTIONS(1839),
    [sym_undefined] = ACTIONS(1839),
    [anon_sym_new] = ACTIONS(1839),
    [ts_builtin_sym_end] = ACTIONS(1841),
    [anon_sym_let] = ACTIONS(1839),
    [anon_sym_PLUS] = ACTIONS(1839),
    [anon_sym_export] = ACTIONS(1839),
    [anon_sym_do] = ACTIONS(1839),
    [anon_sym_TILDE] = ACTIONS(1841),
    [anon_sym_with] = ACTIONS(1839),
    [anon_sym_await] = ACTIONS(1839),
  },
  [346] = {
    [sym_identifier] = ACTIONS(1843),
    [anon_sym_BQUOTE] = ACTIONS(1845),
    [anon_sym_debugger] = ACTIONS(1843),
    [anon_sym_symbol] = ACTIONS(1843),
    [anon_sym_AT] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_void] = ACTIONS(1843),
    [anon_sym_break] = ACTIONS(1843),
    [anon_sym_const] = ACTIONS(1843),
    [sym_super] = ACTIONS(1843),
    [anon_sym_return] = ACTIONS(1843),
    [anon_sym_private] = ACTIONS(1843),
    [anon_sym_static] = ACTIONS(1843),
    [anon_sym_get] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1845),
    [anon_sym_interface] = ACTIONS(1843),
    [anon_sym_default] = ACTIONS(1843),
    [anon_sym_enum] = ACTIONS(1843),
    [anon_sym_delete] = ACTIONS(1843),
    [anon_sym_continue] = ACTIONS(1843),
    [anon_sym_DASH_DASH] = ACTIONS(1845),
    [anon_sym_if] = ACTIONS(1843),
    [sym_this] = ACTIONS(1843),
    [anon_sym_yield] = ACTIONS(1843),
    [sym_true] = ACTIONS(1843),
    [anon_sym_throw] = ACTIONS(1843),
    [anon_sym_protected] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(1843),
    [anon_sym_set] = ACTIONS(1843),
    [anon_sym_type] = ACTIONS(1843),
    [anon_sym_import] = ACTIONS(1843),
    [anon_sym_namespace] = ACTIONS(1843),
    [anon_sym_PLUS_PLUS] = ACTIONS(1845),
    [anon_sym_DQUOTE] = ACTIONS(1845),
    [anon_sym_else] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_for] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [sym_false] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1845),
    [anon_sym_case] = ACTIONS(1843),
    [anon_sym_module] = ACTIONS(1843),
    [anon_sym_number] = ACTIONS(1843),
    [anon_sym_class] = ACTIONS(1843),
    [anon_sym_declare] = ACTIONS(1843),
    [anon_sym_typeof] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1845),
    [anon_sym_switch] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [sym_null] = ACTIONS(1843),
    [anon_sym_any] = ACTIONS(1843),
    [anon_sym_boolean] = ACTIONS(1843),
    [anon_sym_async] = ACTIONS(1843),
    [anon_sym_public] = ACTIONS(1843),
    [anon_sym_var] = ACTIONS(1843),
    [anon_sym_while] = ACTIONS(1843),
    [anon_sym_SQUOTE] = ACTIONS(1845),
    [anon_sym_try] = ACTIONS(1843),
    [anon_sym_LT] = ACTIONS(1845),
    [sym_number] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1843),
    [anon_sym_function] = ACTIONS(1843),
    [sym_undefined] = ACTIONS(1843),
    [anon_sym_new] = ACTIONS(1843),
    [ts_builtin_sym_end] = ACTIONS(1845),
    [anon_sym_let] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [anon_sym_export] = ACTIONS(1843),
    [anon_sym_do] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1845),
    [anon_sym_with] = ACTIONS(1843),
    [anon_sym_await] = ACTIONS(1843),
  },
  [347] = {
    [sym_object_type] = STATE(626),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(481),
  },
  [348] = {
    [sym_object_type] = STATE(627),
    [sym_extends_clause] = STATE(628),
    [anon_sym_extends] = ACTIONS(776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(481),
  },
  [349] = {
    [sym_computed_property_name] = STATE(630),
    [sym_string] = STATE(630),
    [sym__property_name] = STATE(630),
    [sym_enum_assignment] = STATE(631),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1847),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(1849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [350] = {
    [sym_identifier] = ACTIONS(1851),
    [anon_sym_BQUOTE] = ACTIONS(1853),
    [anon_sym_debugger] = ACTIONS(1851),
    [anon_sym_symbol] = ACTIONS(1851),
    [anon_sym_AT] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_void] = ACTIONS(1851),
    [anon_sym_break] = ACTIONS(1851),
    [anon_sym_const] = ACTIONS(1851),
    [sym_super] = ACTIONS(1851),
    [anon_sym_return] = ACTIONS(1851),
    [anon_sym_private] = ACTIONS(1851),
    [anon_sym_static] = ACTIONS(1851),
    [anon_sym_get] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_interface] = ACTIONS(1851),
    [anon_sym_default] = ACTIONS(1851),
    [anon_sym_enum] = ACTIONS(1851),
    [anon_sym_delete] = ACTIONS(1851),
    [anon_sym_continue] = ACTIONS(1851),
    [anon_sym_DASH_DASH] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1851),
    [sym_this] = ACTIONS(1851),
    [anon_sym_yield] = ACTIONS(1851),
    [sym_true] = ACTIONS(1851),
    [anon_sym_throw] = ACTIONS(1851),
    [anon_sym_protected] = ACTIONS(1851),
    [anon_sym_abstract] = ACTIONS(1851),
    [anon_sym_set] = ACTIONS(1851),
    [anon_sym_type] = ACTIONS(1851),
    [anon_sym_import] = ACTIONS(1851),
    [anon_sym_namespace] = ACTIONS(1851),
    [anon_sym_PLUS_PLUS] = ACTIONS(1853),
    [anon_sym_DQUOTE] = ACTIONS(1853),
    [anon_sym_else] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1853),
    [anon_sym_for] = ACTIONS(1851),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [sym_false] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_case] = ACTIONS(1851),
    [anon_sym_module] = ACTIONS(1851),
    [anon_sym_number] = ACTIONS(1851),
    [anon_sym_class] = ACTIONS(1851),
    [anon_sym_declare] = ACTIONS(1851),
    [anon_sym_typeof] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1853),
    [anon_sym_switch] = ACTIONS(1851),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [sym_null] = ACTIONS(1851),
    [anon_sym_any] = ACTIONS(1851),
    [anon_sym_boolean] = ACTIONS(1851),
    [anon_sym_async] = ACTIONS(1851),
    [anon_sym_public] = ACTIONS(1851),
    [anon_sym_var] = ACTIONS(1851),
    [anon_sym_while] = ACTIONS(1851),
    [anon_sym_SQUOTE] = ACTIONS(1853),
    [anon_sym_try] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1853),
    [sym_number] = ACTIONS(1853),
    [anon_sym_SLASH] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1851),
    [anon_sym_function] = ACTIONS(1851),
    [sym_undefined] = ACTIONS(1851),
    [anon_sym_new] = ACTIONS(1851),
    [ts_builtin_sym_end] = ACTIONS(1853),
    [anon_sym_let] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1851),
    [anon_sym_export] = ACTIONS(1851),
    [anon_sym_do] = ACTIONS(1851),
    [anon_sym_TILDE] = ACTIONS(1853),
    [anon_sym_with] = ACTIONS(1851),
    [anon_sym_await] = ACTIONS(1851),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [anon_sym_debugger] = ACTIONS(1855),
    [anon_sym_symbol] = ACTIONS(1855),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_void] = ACTIONS(1855),
    [anon_sym_break] = ACTIONS(1855),
    [anon_sym_const] = ACTIONS(1855),
    [sym_super] = ACTIONS(1855),
    [anon_sym_return] = ACTIONS(1855),
    [anon_sym_private] = ACTIONS(1855),
    [anon_sym_static] = ACTIONS(1855),
    [anon_sym_get] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_interface] = ACTIONS(1855),
    [anon_sym_default] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1855),
    [anon_sym_delete] = ACTIONS(1855),
    [anon_sym_continue] = ACTIONS(1855),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_if] = ACTIONS(1855),
    [sym_this] = ACTIONS(1855),
    [anon_sym_yield] = ACTIONS(1855),
    [sym_true] = ACTIONS(1855),
    [anon_sym_throw] = ACTIONS(1855),
    [anon_sym_protected] = ACTIONS(1855),
    [anon_sym_abstract] = ACTIONS(1855),
    [anon_sym_set] = ACTIONS(1855),
    [anon_sym_type] = ACTIONS(1855),
    [anon_sym_import] = ACTIONS(1855),
    [anon_sym_namespace] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_else] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_for] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [sym_false] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1855),
    [anon_sym_module] = ACTIONS(1855),
    [anon_sym_number] = ACTIONS(1855),
    [anon_sym_class] = ACTIONS(1855),
    [anon_sym_declare] = ACTIONS(1855),
    [anon_sym_typeof] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1857),
    [anon_sym_switch] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [sym_null] = ACTIONS(1855),
    [anon_sym_any] = ACTIONS(1855),
    [anon_sym_boolean] = ACTIONS(1855),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_public] = ACTIONS(1855),
    [anon_sym_var] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(1855),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_try] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1855),
    [sym_undefined] = ACTIONS(1855),
    [anon_sym_new] = ACTIONS(1855),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [anon_sym_let] = ACTIONS(1855),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_export] = ACTIONS(1855),
    [anon_sym_do] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_with] = ACTIONS(1855),
    [anon_sym_await] = ACTIONS(1855),
  },
  [352] = {
    [sym_identifier] = ACTIONS(1859),
    [anon_sym_BQUOTE] = ACTIONS(1861),
    [anon_sym_debugger] = ACTIONS(1859),
    [anon_sym_symbol] = ACTIONS(1859),
    [anon_sym_AT] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_void] = ACTIONS(1859),
    [anon_sym_break] = ACTIONS(1859),
    [anon_sym_const] = ACTIONS(1859),
    [sym_super] = ACTIONS(1859),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_private] = ACTIONS(1859),
    [anon_sym_static] = ACTIONS(1859),
    [anon_sym_get] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_interface] = ACTIONS(1859),
    [anon_sym_default] = ACTIONS(1859),
    [anon_sym_enum] = ACTIONS(1859),
    [anon_sym_delete] = ACTIONS(1859),
    [anon_sym_continue] = ACTIONS(1859),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1859),
    [sym_this] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1859),
    [sym_true] = ACTIONS(1859),
    [anon_sym_throw] = ACTIONS(1859),
    [anon_sym_protected] = ACTIONS(1859),
    [anon_sym_abstract] = ACTIONS(1859),
    [anon_sym_set] = ACTIONS(1859),
    [anon_sym_type] = ACTIONS(1859),
    [anon_sym_import] = ACTIONS(1859),
    [anon_sym_namespace] = ACTIONS(1859),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_DQUOTE] = ACTIONS(1861),
    [anon_sym_else] = ACTIONS(1863),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [sym_false] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1861),
    [anon_sym_case] = ACTIONS(1859),
    [anon_sym_module] = ACTIONS(1859),
    [anon_sym_number] = ACTIONS(1859),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_declare] = ACTIONS(1859),
    [anon_sym_typeof] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [sym_null] = ACTIONS(1859),
    [anon_sym_any] = ACTIONS(1859),
    [anon_sym_boolean] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(1859),
    [anon_sym_public] = ACTIONS(1859),
    [anon_sym_var] = ACTIONS(1859),
    [anon_sym_while] = ACTIONS(1859),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1861),
    [sym_number] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1859),
    [anon_sym_function] = ACTIONS(1859),
    [sym_undefined] = ACTIONS(1859),
    [anon_sym_new] = ACTIONS(1859),
    [ts_builtin_sym_end] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [anon_sym_export] = ACTIONS(1859),
    [anon_sym_do] = ACTIONS(1859),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_with] = ACTIONS(1859),
    [anon_sym_await] = ACTIONS(1859),
  },
  [353] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_BQUOTE] = ACTIONS(1869),
    [anon_sym_debugger] = ACTIONS(1867),
    [anon_sym_symbol] = ACTIONS(1867),
    [anon_sym_AT] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1867),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(1867),
    [sym_super] = ACTIONS(1867),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_private] = ACTIONS(1867),
    [anon_sym_static] = ACTIONS(1867),
    [anon_sym_get] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1869),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_default] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1867),
    [anon_sym_delete] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1867),
    [sym_this] = ACTIONS(1867),
    [anon_sym_yield] = ACTIONS(1867),
    [sym_true] = ACTIONS(1867),
    [anon_sym_throw] = ACTIONS(1867),
    [anon_sym_protected] = ACTIONS(1867),
    [anon_sym_abstract] = ACTIONS(1867),
    [anon_sym_set] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1867),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_namespace] = ACTIONS(1867),
    [anon_sym_PLUS_PLUS] = ACTIONS(1869),
    [anon_sym_DQUOTE] = ACTIONS(1869),
    [anon_sym_else] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1869),
    [anon_sym_for] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [sym_false] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1869),
    [anon_sym_case] = ACTIONS(1867),
    [anon_sym_module] = ACTIONS(1867),
    [anon_sym_number] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1867),
    [anon_sym_declare] = ACTIONS(1867),
    [anon_sym_typeof] = ACTIONS(1867),
    [anon_sym_LBRACE] = ACTIONS(1869),
    [anon_sym_switch] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [sym_null] = ACTIONS(1867),
    [anon_sym_any] = ACTIONS(1867),
    [anon_sym_boolean] = ACTIONS(1867),
    [anon_sym_async] = ACTIONS(1867),
    [anon_sym_public] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(1867),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_try] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1869),
    [sym_number] = ACTIONS(1869),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1867),
    [anon_sym_function] = ACTIONS(1867),
    [sym_undefined] = ACTIONS(1867),
    [anon_sym_new] = ACTIONS(1867),
    [ts_builtin_sym_end] = ACTIONS(1869),
    [anon_sym_let] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_export] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1869),
    [anon_sym_with] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1867),
  },
  [355] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(634),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(633),
    [sym_type_parameters] = STATE(635),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1871),
  },
  [356] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(636),
    [sym_function_type] = STATE(636),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(636),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(636),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(636),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [357] = {
    [anon_sym_EQ] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [358] = {
    [sym_named_imports] = STATE(638),
    [sym_namespace_import] = STATE(638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(812),
    [anon_sym_LBRACE] = ACTIONS(241),
  },
  [359] = {
    [sym_nested_identifier] = STATE(640),
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_require] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(808),
    [anon_sym_from] = ACTIONS(810),
    [sym_comment] = ACTIONS(3),
  },
  [361] = {
    [sym__automatic_semicolon] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
  },
  [362] = {
    [sym__from_clause] = STATE(643),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [363] = {
    [sym_identifier] = ACTIONS(1917),
    [sym_comment] = ACTIONS(3),
  },
  [364] = {
    [anon_sym_RBRACE] = ACTIONS(1919),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_as] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [365] = {
    [anon_sym_from] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1925),
    [sym_comment] = ACTIONS(3),
  },
  [367] = {
    [anon_sym_RBRACE] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
  },
  [368] = {
    [aux_sym_named_imports_repeat1] = STATE(650),
    [anon_sym_COMMA] = ACTIONS(1929),
    [anon_sym_RBRACE] = ACTIONS(1931),
    [sym_comment] = ACTIONS(3),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1933),
    [anon_sym_BQUOTE] = ACTIONS(1935),
    [anon_sym_debugger] = ACTIONS(1933),
    [anon_sym_symbol] = ACTIONS(1933),
    [anon_sym_AT] = ACTIONS(1935),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_void] = ACTIONS(1933),
    [anon_sym_break] = ACTIONS(1933),
    [anon_sym_const] = ACTIONS(1933),
    [sym_super] = ACTIONS(1933),
    [anon_sym_return] = ACTIONS(1933),
    [anon_sym_private] = ACTIONS(1933),
    [anon_sym_static] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1935),
    [anon_sym_interface] = ACTIONS(1933),
    [anon_sym_default] = ACTIONS(1933),
    [anon_sym_enum] = ACTIONS(1933),
    [anon_sym_delete] = ACTIONS(1933),
    [anon_sym_continue] = ACTIONS(1933),
    [anon_sym_DASH_DASH] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1933),
    [sym_this] = ACTIONS(1933),
    [anon_sym_yield] = ACTIONS(1933),
    [sym_true] = ACTIONS(1933),
    [anon_sym_throw] = ACTIONS(1933),
    [anon_sym_protected] = ACTIONS(1933),
    [anon_sym_abstract] = ACTIONS(1933),
    [anon_sym_set] = ACTIONS(1933),
    [anon_sym_type] = ACTIONS(1933),
    [anon_sym_import] = ACTIONS(1933),
    [anon_sym_namespace] = ACTIONS(1933),
    [anon_sym_PLUS_PLUS] = ACTIONS(1935),
    [anon_sym_DQUOTE] = ACTIONS(1935),
    [anon_sym_else] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(1935),
    [sym_false] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1935),
    [anon_sym_case] = ACTIONS(1933),
    [anon_sym_module] = ACTIONS(1933),
    [anon_sym_number] = ACTIONS(1933),
    [anon_sym_class] = ACTIONS(1933),
    [anon_sym_declare] = ACTIONS(1933),
    [anon_sym_typeof] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(1935),
    [anon_sym_switch] = ACTIONS(1933),
    [anon_sym_LPAREN] = ACTIONS(1935),
    [sym_null] = ACTIONS(1933),
    [anon_sym_any] = ACTIONS(1933),
    [anon_sym_boolean] = ACTIONS(1933),
    [anon_sym_async] = ACTIONS(1933),
    [anon_sym_public] = ACTIONS(1933),
    [anon_sym_var] = ACTIONS(1933),
    [anon_sym_while] = ACTIONS(1933),
    [anon_sym_SQUOTE] = ACTIONS(1935),
    [anon_sym_try] = ACTIONS(1933),
    [anon_sym_LT] = ACTIONS(1935),
    [sym_number] = ACTIONS(1935),
    [anon_sym_SLASH] = ACTIONS(1933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1933),
    [anon_sym_function] = ACTIONS(1933),
    [sym_undefined] = ACTIONS(1933),
    [anon_sym_new] = ACTIONS(1933),
    [ts_builtin_sym_end] = ACTIONS(1935),
    [anon_sym_let] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1933),
    [anon_sym_export] = ACTIONS(1933),
    [anon_sym_do] = ACTIONS(1933),
    [anon_sym_TILDE] = ACTIONS(1935),
    [anon_sym_with] = ACTIONS(1933),
    [anon_sym_await] = ACTIONS(1933),
  },
  [370] = {
    [sym_string] = STATE(651),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [371] = {
    [sym_identifier] = ACTIONS(1937),
    [sym_comment] = ACTIONS(3),
  },
  [372] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1939),
    [sym__automatic_semicolon] = ACTIONS(1939),
    [anon_sym_BQUOTE] = ACTIONS(1939),
    [anon_sym_symbol] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1939),
    [anon_sym_break] = ACTIONS(1941),
    [anon_sym_BANG_EQ] = ACTIONS(1941),
    [anon_sym_return] = ACTIONS(1941),
    [anon_sym_static] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_interface] = ACTIONS(1941),
    [anon_sym_as] = ACTIONS(1941),
    [anon_sym_delete] = ACTIONS(1941),
    [anon_sym_if] = ACTIONS(1941),
    [anon_sym_instanceof] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1941),
    [sym_true] = ACTIONS(1941),
    [anon_sym_protected] = ACTIONS(1941),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_set] = ACTIONS(1941),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1939),
    [anon_sym_import] = ACTIONS(1941),
    [anon_sym_in] = ACTIONS(1941),
    [anon_sym_DQUOTE] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1941),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_number] = ACTIONS(1941),
    [anon_sym_typeof] = ACTIONS(1941),
    [anon_sym_LT_LT] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [anon_sym_AMP_AMP] = ACTIONS(1939),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_LT_EQ] = ACTIONS(1939),
    [sym_null] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1941),
    [anon_sym_async] = ACTIONS(1941),
    [anon_sym_public] = ACTIONS(1941),
    [anon_sym_var] = ACTIONS(1941),
    [anon_sym_QMARK] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1941),
    [anon_sym_new] = ACTIONS(1941),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_export] = ACTIONS(1941),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1939),
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_debugger] = ACTIONS(1941),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_COMMA] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_void] = ACTIONS(1941),
    [anon_sym_const] = ACTIONS(1941),
    [anon_sym_GT_EQ] = ACTIONS(1939),
    [sym_super] = ACTIONS(1941),
    [anon_sym_private] = ACTIONS(1941),
    [anon_sym_get] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(1941),
    [anon_sym_enum] = ACTIONS(1941),
    [anon_sym_continue] = ACTIONS(1941),
    [anon_sym_DASH_DASH] = ACTIONS(1939),
    [sym_this] = ACTIONS(1941),
    [anon_sym_throw] = ACTIONS(1941),
    [anon_sym_abstract] = ACTIONS(1941),
    [anon_sym_type] = ACTIONS(1941),
    [anon_sym_STAR_STAR] = ACTIONS(1939),
    [anon_sym_namespace] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1939),
    [anon_sym_else] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [sym_false] = ACTIONS(1941),
    [anon_sym_case] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(1941),
    [anon_sym_declare] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_boolean] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_PIPE_PIPE] = ACTIONS(1939),
    [anon_sym_try] = ACTIONS(1941),
    [anon_sym_EQ_EQ] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1941),
    [sym_number] = ACTIONS(1939),
    [ts_builtin_sym_end] = ACTIONS(1939),
    [anon_sym_function] = ACTIONS(1941),
    [sym_undefined] = ACTIONS(1941),
    [anon_sym_let] = ACTIONS(1941),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_do] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1939),
    [anon_sym_await] = ACTIONS(1941),
  },
  [373] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1943),
    [sym__automatic_semicolon] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ] = ACTIONS(1945),
    [anon_sym_BANG_EQ] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_as] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_instanceof] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1943),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1943),
    [anon_sym_STAR_STAR] = ACTIONS(1943),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1945),
    [anon_sym_GT_GT] = ACTIONS(1945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1943),
  },
  [374] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(1947),
    [aux_sym_string_token1] = ACTIONS(1950),
    [anon_sym_DQUOTE] = ACTIONS(1953),
    [sym_comment] = ACTIONS(255),
  },
  [375] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [376] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1960),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [377] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(107),
  },
  [378] = {
    [sym_arrow_function] = STATE(1854),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(660),
    [sym_variable_declarator] = STATE(99),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1854),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(660),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1854),
    [sym_template_string] = STATE(1854),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(661),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(660),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(662),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1854),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(1967),
    [sym_false] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [anon_sym_number] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1969),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1969),
    [sym_number] = ACTIONS(1977),
    [sym_true] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [379] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(435),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [380] = {
    [sym_arrow_function] = STATE(1854),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(660),
    [sym_variable_declarator] = STATE(215),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1854),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(660),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1854),
    [sym_template_string] = STATE(1854),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(661),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(660),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(662),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1854),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(1967),
    [sym_false] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [anon_sym_number] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1969),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1969),
    [sym_number] = ACTIONS(1977),
    [sym_true] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [381] = {
    [sym_string] = STATE(1586),
    [sym_nested_identifier] = STATE(1585),
    [sym__module] = STATE(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [382] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [383] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(663),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(663),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [384] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(633),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [385] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(611),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(1986),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [386] = {
    [sym_arrow_function] = STATE(1854),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1369),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1854),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1369),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1854),
    [sym_template_string] = STATE(1854),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1370),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1369),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1371),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1854),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(1991),
    [sym_false] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(1993),
    [anon_sym_symbol] = ACTIONS(1993),
    [anon_sym_number] = ACTIONS(1993),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1993),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1969),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1993),
    [anon_sym_private] = ACTIONS(1993),
    [anon_sym_boolean] = ACTIONS(1993),
    [anon_sym_static] = ACTIONS(1993),
    [anon_sym_public] = ACTIONS(1993),
    [anon_sym_get] = ACTIONS(1993),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_var] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1969),
    [sym_number] = ACTIONS(1977),
    [sym_true] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1993),
    [anon_sym_string] = ACTIONS(1993),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_set] = ACTIONS(1993),
    [anon_sym_type] = ACTIONS(1993),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1993),
    [anon_sym_namespace] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [387] = {
    [sym_generator_function_declaration] = STATE(667),
    [sym__declaration] = STATE(667),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(667),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(667),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(667),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(667),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(667),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(667),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(667),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(667),
    [sym_function_declaration] = STATE(667),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(667),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(667),
    [sym_break_statement] = STATE(667),
    [sym_labeled_statement] = STATE(667),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(667),
    [sym_class_declaration] = STATE(667),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(667),
    [sym_ambient_declaration] = STATE(667),
    [sym_type_alias_declaration] = STATE(667),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(667),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(667),
    [sym_switch_statement] = STATE(667),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(667),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(667),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(667),
    [sym_abstract_class_declaration] = STATE(667),
    [sym_interface_declaration] = STATE(667),
    [sym_export_statement] = STATE(667),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(667),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(667),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(667),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(667),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [388] = {
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_BQUOTE] = ACTIONS(2005),
    [anon_sym_debugger] = ACTIONS(2003),
    [anon_sym_symbol] = ACTIONS(2003),
    [anon_sym_AT] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_void] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_private] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_get] = ACTIONS(2003),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_interface] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [anon_sym_delete] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_DASH_DASH] = ACTIONS(2005),
    [anon_sym_if] = ACTIONS(2003),
    [sym_this] = ACTIONS(2003),
    [anon_sym_yield] = ACTIONS(2003),
    [sym_true] = ACTIONS(2003),
    [anon_sym_throw] = ACTIONS(2003),
    [anon_sym_protected] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(2003),
    [anon_sym_set] = ACTIONS(2003),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_import] = ACTIONS(2003),
    [anon_sym_namespace] = ACTIONS(2003),
    [anon_sym_PLUS_PLUS] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [anon_sym_else] = ACTIONS(2003),
    [anon_sym_BANG] = ACTIONS(2005),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [sym_false] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_case] = ACTIONS(2003),
    [anon_sym_module] = ACTIONS(2003),
    [anon_sym_number] = ACTIONS(2003),
    [anon_sym_class] = ACTIONS(2003),
    [anon_sym_declare] = ACTIONS(2003),
    [anon_sym_typeof] = ACTIONS(2003),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_switch] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [sym_null] = ACTIONS(2003),
    [anon_sym_any] = ACTIONS(2003),
    [anon_sym_boolean] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_public] = ACTIONS(2003),
    [anon_sym_var] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2005),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2005),
    [sym_number] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2003),
    [anon_sym_function] = ACTIONS(2003),
    [sym_undefined] = ACTIONS(2003),
    [anon_sym_new] = ACTIONS(2003),
    [ts_builtin_sym_end] = ACTIONS(2005),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2003),
    [anon_sym_export] = ACTIONS(2003),
    [anon_sym_do] = ACTIONS(2003),
    [anon_sym_TILDE] = ACTIONS(2005),
    [anon_sym_with] = ACTIONS(2003),
    [anon_sym_await] = ACTIONS(2003),
  },
  [389] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2007),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [390] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [391] = {
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_RBRACK] = ACTIONS(2009),
    [sym_comment] = ACTIONS(3),
  },
  [392] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_STAR_STAR] = ACTIONS(2011),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2011),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_of] = ACTIONS(2011),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
  },
  [393] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(2015),
    [sym_comment] = ACTIONS(3),
  },
  [394] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(2009),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [aux_sym_extends_clause_repeat1] = STATE(671),
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(2024),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(2033),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(2024),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [396] = {
    [aux_sym_extends_clause_repeat1] = STATE(672),
    [anon_sym_implements] = ACTIONS(2035),
    [anon_sym_COMMA] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2035),
  },
  [397] = {
    [sym_arguments] = STATE(1272),
    [aux_sym_extends_clause_repeat1] = STATE(672),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2035),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2035),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [398] = {
    [aux_sym_extends_clause_repeat1] = STATE(672),
    [sym_type_arguments] = STATE(539),
    [anon_sym_implements] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2035),
  },
  [399] = {
    [aux_sym_implements_clause_repeat1] = STATE(674),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2063),
  },
  [400] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2065),
    [sym__automatic_semicolon] = ACTIONS(2067),
    [anon_sym_BQUOTE] = ACTIONS(2069),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_PIPE] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2065),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_BANG_EQ] = ACTIONS(2073),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_interface] = ACTIONS(2071),
    [anon_sym_as] = ACTIONS(2073),
    [anon_sym_delete] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(2071),
    [anon_sym_instanceof] = ACTIONS(2073),
    [anon_sym_yield] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_DOT] = ACTIONS(2073),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_import] = ACTIONS(2071),
    [anon_sym_in] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(2071),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [sym_null] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_var] = ACTIONS(2071),
    [anon_sym_QMARK] = ACTIONS(2065),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_SLASH] = ACTIONS(2071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_new] = ACTIONS(2071),
    [anon_sym_CARET] = ACTIONS(2065),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_with] = ACTIONS(2071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(2071),
    [anon_sym_debugger] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_void] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [sym_super] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_enum] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_DASH_DASH] = ACTIONS(2069),
    [sym_this] = ACTIONS(2071),
    [anon_sym_throw] = ACTIONS(2071),
    [anon_sym_abstract] = ACTIONS(2071),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_STAR_STAR] = ACTIONS(2065),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_PLUS_PLUS] = ACTIONS(2069),
    [anon_sym_else] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(2071),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_false] = ACTIONS(2071),
    [anon_sym_case] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_class] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [anon_sym_GT] = ACTIONS(2073),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_try] = ACTIONS(2071),
    [anon_sym_EQ_EQ] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2071),
    [sym_number] = ACTIONS(2069),
    [ts_builtin_sym_end] = ACTIONS(2069),
    [anon_sym_function] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_let] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_do] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_await] = ACTIONS(2071),
  },
  [401] = {
    [sym_class_body] = STATE(676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [402] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(677),
    [sym_class_heritage] = STATE(678),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [403] = {
    [sym_default_type] = STATE(504),
    [sym_constraint] = STATE(505),
    [anon_sym_GT] = ACTIONS(2075),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_COLON] = ACTIONS(1241),
    [anon_sym_extends] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(2075),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_string] = STATE(679),
    [sym__property_name] = STATE(679),
    [sym_computed_property_name] = STATE(679),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [405] = {
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [406] = {
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_abstract] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [407] = {
    [sym_arrow_function] = STATE(685),
    [sym_await_expression] = STATE(685),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(685),
    [sym_meta_property] = STATE(685),
    [sym__expression] = STATE(685),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(685),
    [sym_call_expression] = STATE(685),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(685),
    [sym_string] = STATE(685),
    [sym_template_string] = STATE(685),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(685),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(685),
    [sym_generator_function] = STATE(685),
    [sym_new_expression] = STATE(685),
    [sym_assignment_expression] = STATE(685),
    [sym_augmented_assignment_expression] = STATE(685),
    [sym_binary_expression] = STATE(685),
    [sym_unary_expression] = STATE(685),
    [sym_mapped_type_clause] = STATE(686),
    [sym_regex] = STATE(685),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(685),
    [sym_as_expression] = STATE(685),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(685),
    [sym_class] = STATE(685),
    [sym_identifier] = ACTIONS(2079),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2081),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(2083),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(2081),
    [anon_sym_static] = ACTIONS(2081),
    [anon_sym_get] = ACTIONS(2081),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(2085),
    [anon_sym_protected] = ACTIONS(2081),
    [anon_sym_set] = ACTIONS(2081),
    [anon_sym_type] = ACTIONS(2081),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(2087),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2085),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_number] = ACTIONS(2081),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(2081),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2085),
    [anon_sym_any] = ACTIONS(2081),
    [anon_sym_boolean] = ACTIONS(2081),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2081),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2091),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2081),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(2081),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [408] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2093),
    [sym__automatic_semicolon] = ACTIONS(2093),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2095),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_instanceof] = ACTIONS(2093),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2095),
    [anon_sym_else] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_while] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2093),
  },
  [409] = {
    [sym_string] = STATE(679),
    [sym__property_name] = STATE(679),
    [sym_computed_property_name] = STATE(679),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [410] = {
    [sym_string] = STATE(690),
    [sym__property_name] = STATE(690),
    [sym_computed_property_name] = STATE(690),
    [anon_sym_get] = ACTIONS(2097),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2101),
    [anon_sym_STAR] = ACTIONS(2103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2097),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
  },
  [411] = {
    [sym_string] = STATE(694),
    [sym__property_name] = STATE(694),
    [sym_computed_property_name] = STATE(694),
    [anon_sym_get] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(2105),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [412] = {
    [sym_string] = STATE(679),
    [sym__property_name] = STATE(679),
    [sym_computed_property_name] = STATE(679),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2113),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(2115),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(2115),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [413] = {
    [sym_string] = STATE(694),
    [sym__property_name] = STATE(694),
    [sym_computed_property_name] = STATE(694),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2113),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2107),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [414] = {
    [sym__automatic_semicolon] = ACTIONS(2119),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_decorator] = STATE(698),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [416] = {
    [sym__automatic_semicolon] = ACTIONS(2119),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [sym_identifier] = ACTIONS(2125),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_module] = ACTIONS(2125),
    [anon_sym_symbol] = ACTIONS(2125),
    [anon_sym_number] = ACTIONS(2125),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_declare] = ACTIONS(2125),
    [anon_sym_STAR] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2125),
    [anon_sym_any] = ACTIONS(2125),
    [anon_sym_private] = ACTIONS(2125),
    [anon_sym_boolean] = ACTIONS(2125),
    [anon_sym_static] = ACTIONS(2125),
    [anon_sym_public] = ACTIONS(2125),
    [anon_sym_get] = ACTIONS(2125),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_async] = ACTIONS(2125),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2125),
    [anon_sym_string] = ACTIONS(2125),
    [anon_sym_abstract] = ACTIONS(2125),
    [anon_sym_set] = ACTIONS(2125),
    [anon_sym_type] = ACTIONS(2125),
    [anon_sym_export] = ACTIONS(2125),
    [sym_readonly] = ACTIONS(2125),
    [anon_sym_namespace] = ACTIONS(2125),
    [anon_sym_DQUOTE] = ACTIONS(2123),
  },
  [417] = {
    [sym_string] = STATE(694),
    [sym__property_name] = STATE(694),
    [sym_computed_property_name] = STATE(694),
    [anon_sym_get] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2111),
    [anon_sym_STAR] = ACTIONS(2113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(2127),
    [anon_sym_set] = ACTIONS(2107),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2129),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(2131),
    [anon_sym_private] = ACTIONS(960),
  },
  [418] = {
    [sym_type_annotation] = STATE(706),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(705),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(704),
    [sym__automatic_semicolon] = ACTIONS(2133),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2133),
    [anon_sym_QMARK] = ACTIONS(2135),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2137),
  },
  [419] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2139),
  },
  [420] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2141),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [sym__automatic_semicolon] = ACTIONS(2141),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2143),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_LT_LT] = ACTIONS(2141),
    [anon_sym_STAR] = ACTIONS(2143),
    [anon_sym_GT_GT_GT] = ACTIONS(2141),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_BANG_EQ] = ACTIONS(2143),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(2141),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2143),
    [anon_sym_PERCENT] = ACTIONS(2141),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_as] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_EQ_EQ] = ACTIONS(2143),
    [anon_sym_instanceof] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_CARET] = ACTIONS(2141),
    [anon_sym_STAR_STAR] = ACTIONS(2141),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_GT_GT] = ACTIONS(2143),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_in] = ACTIONS(2143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BANG] = ACTIONS(2143),
  },
  [421] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [sym__automatic_semicolon] = ACTIONS(2145),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BANG] = ACTIONS(2147),
  },
  [422] = {
    [sym_class_body] = STATE(707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [423] = {
    [sym_identifier] = ACTIONS(2149),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(710),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(709),
    [sym_type_parameters] = STATE(711),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [425] = {
    [sym_identifier] = ACTIONS(2153),
    [anon_sym_BQUOTE] = ACTIONS(2155),
    [anon_sym_debugger] = ACTIONS(2153),
    [anon_sym_symbol] = ACTIONS(2153),
    [anon_sym_AT] = ACTIONS(2155),
    [anon_sym_DASH] = ACTIONS(2153),
    [anon_sym_void] = ACTIONS(2153),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_const] = ACTIONS(2153),
    [sym_super] = ACTIONS(2153),
    [anon_sym_return] = ACTIONS(2153),
    [anon_sym_private] = ACTIONS(2153),
    [anon_sym_static] = ACTIONS(2153),
    [anon_sym_get] = ACTIONS(2153),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_interface] = ACTIONS(2153),
    [anon_sym_default] = ACTIONS(2153),
    [anon_sym_enum] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2153),
    [anon_sym_continue] = ACTIONS(2153),
    [anon_sym_DASH_DASH] = ACTIONS(2155),
    [anon_sym_if] = ACTIONS(2153),
    [sym_this] = ACTIONS(2153),
    [anon_sym_yield] = ACTIONS(2153),
    [sym_true] = ACTIONS(2153),
    [anon_sym_throw] = ACTIONS(2153),
    [anon_sym_protected] = ACTIONS(2153),
    [anon_sym_abstract] = ACTIONS(2153),
    [anon_sym_set] = ACTIONS(2153),
    [anon_sym_type] = ACTIONS(2153),
    [anon_sym_import] = ACTIONS(2153),
    [anon_sym_namespace] = ACTIONS(2153),
    [anon_sym_PLUS_PLUS] = ACTIONS(2155),
    [anon_sym_DQUOTE] = ACTIONS(2155),
    [anon_sym_else] = ACTIONS(2153),
    [anon_sym_BANG] = ACTIONS(2155),
    [anon_sym_for] = ACTIONS(2153),
    [anon_sym_LBRACK] = ACTIONS(2155),
    [sym_false] = ACTIONS(2153),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_case] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2153),
    [anon_sym_number] = ACTIONS(2153),
    [anon_sym_class] = ACTIONS(2153),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_typeof] = ACTIONS(2153),
    [anon_sym_LBRACE] = ACTIONS(2155),
    [anon_sym_switch] = ACTIONS(2153),
    [anon_sym_LPAREN] = ACTIONS(2155),
    [sym_null] = ACTIONS(2153),
    [anon_sym_any] = ACTIONS(2153),
    [anon_sym_boolean] = ACTIONS(2153),
    [anon_sym_async] = ACTIONS(2153),
    [anon_sym_public] = ACTIONS(2153),
    [anon_sym_var] = ACTIONS(2153),
    [anon_sym_while] = ACTIONS(2153),
    [anon_sym_SQUOTE] = ACTIONS(2155),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_LT] = ACTIONS(2155),
    [sym_number] = ACTIONS(2155),
    [anon_sym_SLASH] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2153),
    [anon_sym_function] = ACTIONS(2153),
    [sym_undefined] = ACTIONS(2153),
    [anon_sym_new] = ACTIONS(2153),
    [ts_builtin_sym_end] = ACTIONS(2155),
    [anon_sym_let] = ACTIONS(2153),
    [anon_sym_PLUS] = ACTIONS(2153),
    [anon_sym_export] = ACTIONS(2153),
    [anon_sym_do] = ACTIONS(2153),
    [anon_sym_TILDE] = ACTIONS(2155),
    [anon_sym_with] = ACTIONS(2153),
    [anon_sym_await] = ACTIONS(2153),
  },
  [426] = {
    [sym_identifier] = ACTIONS(2157),
    [anon_sym_STAR] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(714),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_identifier] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [anon_sym_EQ] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [sym_identifier] = ACTIONS(2165),
    [sym_comment] = ACTIONS(3),
  },
  [431] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2167),
    [sym__automatic_semicolon] = ACTIONS(2167),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2167),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_instanceof] = ACTIONS(2167),
    [anon_sym_COLON] = ACTIONS(2167),
    [anon_sym_DOT] = ACTIONS(2167),
    [anon_sym_STAR_STAR] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2167),
    [anon_sym_AMP_AMP] = ACTIONS(2167),
    [anon_sym_of] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2167),
    [anon_sym_PIPE_PIPE] = ACTIONS(2167),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2167),
  },
  [432] = {
    [sym_arrow_function] = STATE(718),
    [sym_await_expression] = STATE(718),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(718),
    [sym_meta_property] = STATE(718),
    [sym__expression] = STATE(718),
    [sym_function] = STATE(52),
    [sym_import] = STATE(718),
    [sym_call_expression] = STATE(718),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(718),
    [sym_string] = STATE(718),
    [sym_template_string] = STATE(718),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(718),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(718),
    [sym_generator_function] = STATE(718),
    [sym_new_expression] = STATE(718),
    [sym_assignment_expression] = STATE(718),
    [sym_augmented_assignment_expression] = STATE(718),
    [sym_binary_expression] = STATE(718),
    [sym_unary_expression] = STATE(718),
    [sym_regex] = STATE(718),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(718),
    [sym_as_expression] = STATE(718),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(718),
    [sym_class] = STATE(718),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2171),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2171),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2171),
    [sym_number] = ACTIONS(2173),
    [sym_true] = ACTIONS(2171),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [433] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [434] = {
    [sym_arrow_function] = STATE(720),
    [sym_await_expression] = STATE(720),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(720),
    [sym_meta_property] = STATE(720),
    [sym__expression] = STATE(720),
    [sym_function] = STATE(52),
    [sym_import] = STATE(720),
    [sym_call_expression] = STATE(720),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(720),
    [sym_string] = STATE(720),
    [sym_template_string] = STATE(720),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(720),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(720),
    [sym_generator_function] = STATE(720),
    [sym_new_expression] = STATE(720),
    [sym_assignment_expression] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(720),
    [sym_binary_expression] = STATE(720),
    [sym_unary_expression] = STATE(720),
    [sym_regex] = STATE(720),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(720),
    [sym_as_expression] = STATE(720),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(720),
    [sym_class] = STATE(720),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2177),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2177),
    [sym_number] = ACTIONS(2179),
    [sym_true] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [435] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [436] = {
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [438] = {
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [439] = {
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_computed_property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(2181),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [440] = {
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
  },
  [441] = {
    [sym_arrow_function] = STATE(1949),
    [sym_await_expression] = STATE(1949),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1949),
    [sym_meta_property] = STATE(1949),
    [sym__expression] = STATE(1949),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1949),
    [sym_call_expression] = STATE(1949),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1949),
    [sym_string] = STATE(1949),
    [sym_template_string] = STATE(1949),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1949),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(1949),
    [sym_generator_function] = STATE(1949),
    [sym_new_expression] = STATE(1949),
    [sym_assignment_expression] = STATE(1949),
    [sym_augmented_assignment_expression] = STATE(1949),
    [sym_binary_expression] = STATE(1949),
    [sym_unary_expression] = STATE(1949),
    [sym_regex] = STATE(1949),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(1949),
    [sym_as_expression] = STATE(1949),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(1949),
    [sym_class] = STATE(1949),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(2185),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(2185),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2185),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2185),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2187),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2185),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [442] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(722),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [443] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [444] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [anon_sym_get] = ACTIONS(2193),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [445] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [446] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [anon_sym_get] = ACTIONS(2193),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2191),
    [anon_sym_STAR] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [447] = {
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [anon_sym_catch] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [anon_sym_finally] = ACTIONS(2201),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
  },
  [448] = {
    [aux_sym_array_repeat1] = STATE(393),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(2203),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [449] = {
    [anon_sym_EQ_GT] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_EQ_GT] = ACTIONS(1211),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2191),
    [anon_sym_public] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [452] = {
    [sym_arrow_function] = STATE(720),
    [sym_await_expression] = STATE(720),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(720),
    [sym_meta_property] = STATE(720),
    [sym__expression] = STATE(720),
    [sym_function] = STATE(52),
    [sym_import] = STATE(720),
    [sym_call_expression] = STATE(720),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(720),
    [sym_string] = STATE(720),
    [sym_template_string] = STATE(720),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(720),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(720),
    [sym_generator_function] = STATE(720),
    [sym_new_expression] = STATE(720),
    [sym_assignment_expression] = STATE(720),
    [sym_augmented_assignment_expression] = STATE(720),
    [sym_binary_expression] = STATE(720),
    [sym_unary_expression] = STATE(720),
    [sym_regex] = STATE(720),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(720),
    [sym_as_expression] = STATE(720),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(720),
    [sym_class] = STATE(720),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(1402),
    [sym_false] = ACTIONS(2177),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2177),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2177),
    [sym_number] = ACTIONS(2179),
    [sym_true] = ACTIONS(2177),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2177),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [453] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2205),
    [sym__automatic_semicolon] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_instanceof] = ACTIONS(2205),
    [anon_sym_COLON] = ACTIONS(2205),
    [anon_sym_DOT] = ACTIONS(2205),
    [anon_sym_STAR_STAR] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_SEMI] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_of] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_QMARK] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2207),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2205),
  },
  [454] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(2209),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_arrow_function] = STATE(729),
    [sym_await_expression] = STATE(729),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(729),
    [sym_meta_property] = STATE(729),
    [sym__expression] = STATE(729),
    [sym_function] = STATE(52),
    [sym_import] = STATE(729),
    [sym_call_expression] = STATE(729),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(729),
    [sym_string] = STATE(729),
    [sym_template_string] = STATE(729),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(729),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(729),
    [sym_generator_function] = STATE(729),
    [sym_new_expression] = STATE(729),
    [sym_assignment_expression] = STATE(729),
    [sym_augmented_assignment_expression] = STATE(729),
    [sym_binary_expression] = STATE(729),
    [sym_unary_expression] = STATE(729),
    [sym_regex] = STATE(729),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(729),
    [sym_as_expression] = STATE(729),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(729),
    [sym_class] = STATE(729),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2211),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2211),
    [sym_number] = ACTIONS(2213),
    [sym_true] = ACTIONS(2211),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [456] = {
    [sym_arrow_function] = STATE(730),
    [sym_await_expression] = STATE(730),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(730),
    [sym_meta_property] = STATE(730),
    [sym__expression] = STATE(730),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(730),
    [sym_call_expression] = STATE(730),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(730),
    [sym_string] = STATE(730),
    [sym_template_string] = STATE(730),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(730),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(730),
    [sym_generator_function] = STATE(730),
    [sym_new_expression] = STATE(730),
    [sym_assignment_expression] = STATE(730),
    [sym_augmented_assignment_expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_unary_expression] = STATE(730),
    [sym_regex] = STATE(730),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(730),
    [sym_as_expression] = STATE(730),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(730),
    [sym_class] = STATE(730),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2215),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2215),
    [sym_number] = ACTIONS(2217),
    [sym_true] = ACTIONS(2215),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2215),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [457] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(731),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [458] = {
    [sym_statement_block] = STATE(732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [459] = {
    [sym__automatic_semicolon] = ACTIONS(2219),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [anon_sym_catch] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [anon_sym_finally] = ACTIONS(2201),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
  },
  [460] = {
    [sym_arrow_function] = STATE(734),
    [sym_await_expression] = STATE(734),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(734),
    [sym_meta_property] = STATE(734),
    [sym__expression] = STATE(734),
    [sym_function] = STATE(52),
    [sym_import] = STATE(734),
    [sym_call_expression] = STATE(734),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(734),
    [sym_string] = STATE(734),
    [sym_template_string] = STATE(734),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(734),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(734),
    [sym_generator_function] = STATE(734),
    [sym_new_expression] = STATE(734),
    [sym_assignment_expression] = STATE(734),
    [sym_augmented_assignment_expression] = STATE(734),
    [sym_binary_expression] = STATE(734),
    [sym_unary_expression] = STATE(734),
    [sym_regex] = STATE(734),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(734),
    [sym_as_expression] = STATE(734),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(734),
    [sym_class] = STATE(734),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(2221),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2221),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2221),
    [sym_number] = ACTIONS(2223),
    [sym_true] = ACTIONS(2221),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2221),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [461] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_COMMA] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_string] = STATE(723),
    [sym__property_name] = STATE(723),
    [sym_computed_property_name] = STATE(723),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(2195),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [sym_readonly] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [463] = {
    [sym_switch_default] = STATE(739),
    [aux_sym_switch_body_repeat1] = STATE(739),
    [sym_switch_case] = STATE(739),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_identifier] = ACTIONS(2236),
    [anon_sym_BQUOTE] = ACTIONS(2238),
    [anon_sym_debugger] = ACTIONS(2236),
    [anon_sym_symbol] = ACTIONS(2236),
    [anon_sym_AT] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2236),
    [anon_sym_void] = ACTIONS(2236),
    [anon_sym_break] = ACTIONS(2236),
    [anon_sym_const] = ACTIONS(2236),
    [sym_super] = ACTIONS(2236),
    [anon_sym_return] = ACTIONS(2236),
    [anon_sym_private] = ACTIONS(2236),
    [anon_sym_static] = ACTIONS(2236),
    [anon_sym_get] = ACTIONS(2236),
    [anon_sym_RBRACE] = ACTIONS(2238),
    [anon_sym_interface] = ACTIONS(2236),
    [anon_sym_default] = ACTIONS(2236),
    [anon_sym_enum] = ACTIONS(2236),
    [anon_sym_delete] = ACTIONS(2236),
    [anon_sym_continue] = ACTIONS(2236),
    [anon_sym_DASH_DASH] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2236),
    [sym_this] = ACTIONS(2236),
    [anon_sym_yield] = ACTIONS(2236),
    [sym_true] = ACTIONS(2236),
    [anon_sym_throw] = ACTIONS(2236),
    [anon_sym_protected] = ACTIONS(2236),
    [anon_sym_abstract] = ACTIONS(2236),
    [anon_sym_set] = ACTIONS(2236),
    [anon_sym_type] = ACTIONS(2236),
    [anon_sym_import] = ACTIONS(2236),
    [anon_sym_namespace] = ACTIONS(2236),
    [anon_sym_PLUS_PLUS] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(2238),
    [anon_sym_else] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2236),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [sym_false] = ACTIONS(2236),
    [anon_sym_SEMI] = ACTIONS(2238),
    [anon_sym_case] = ACTIONS(2236),
    [anon_sym_module] = ACTIONS(2236),
    [anon_sym_number] = ACTIONS(2236),
    [anon_sym_class] = ACTIONS(2236),
    [anon_sym_declare] = ACTIONS(2236),
    [anon_sym_typeof] = ACTIONS(2236),
    [anon_sym_LBRACE] = ACTIONS(2238),
    [anon_sym_switch] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [sym_null] = ACTIONS(2236),
    [anon_sym_any] = ACTIONS(2236),
    [anon_sym_boolean] = ACTIONS(2236),
    [anon_sym_async] = ACTIONS(2236),
    [anon_sym_public] = ACTIONS(2236),
    [anon_sym_var] = ACTIONS(2236),
    [anon_sym_while] = ACTIONS(2236),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_try] = ACTIONS(2236),
    [anon_sym_LT] = ACTIONS(2238),
    [sym_number] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2236),
    [anon_sym_function] = ACTIONS(2236),
    [sym_undefined] = ACTIONS(2236),
    [anon_sym_new] = ACTIONS(2236),
    [ts_builtin_sym_end] = ACTIONS(2238),
    [anon_sym_let] = ACTIONS(2236),
    [anon_sym_PLUS] = ACTIONS(2236),
    [anon_sym_export] = ACTIONS(2236),
    [anon_sym_do] = ACTIONS(2236),
    [anon_sym_TILDE] = ACTIONS(2238),
    [anon_sym_with] = ACTIONS(2236),
    [anon_sym_await] = ACTIONS(2236),
  },
  [465] = {
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_COLON] = ACTIONS(2240),
    [anon_sym_RPAREN] = ACTIONS(2240),
    [anon_sym_QMARK] = ACTIONS(2240),
    [anon_sym_COMMA] = ACTIONS(2240),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [anon_sym_EQ] = ACTIONS(2242),
    [anon_sym_COLON] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_QMARK] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_COLON] = ACTIONS(2244),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [anon_sym_QMARK] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(2244),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [anon_sym_EQ] = ACTIONS(2246),
    [anon_sym_COLON] = ACTIONS(2246),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_COMMA] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_type_annotation] = STATE(740),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(2248),
    [anon_sym_COMMA] = ACTIONS(2248),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [471] = {
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_EQ_GT] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2252),
  },
  [472] = {
    [aux_sym_formal_parameters_repeat1] = STATE(745),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [sym__initializer] = STATE(746),
    [sym_type_annotation] = STATE(747),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_COMMA] = ACTIONS(2256),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym__initializer] = STATE(748),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2262),
    [sym__automatic_semicolon] = ACTIONS(2262),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_GT_GT_GT] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_BANG_EQ] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_instanceof] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2262),
    [anon_sym_STAR_STAR] = ACTIONS(2264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_of] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_EQ_EQ] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2262),
  },
  [477] = {
    [anon_sym_RPAREN] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_object] = STATE(752),
    [sym_array] = STATE(753),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(2270),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_module] = ACTIONS(2268),
    [anon_sym_symbol] = ACTIONS(2268),
    [anon_sym_number] = ACTIONS(2268),
    [anon_sym_declare] = ACTIONS(2268),
    [sym_this] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_string] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_type] = ACTIONS(2268),
    [anon_sym_export] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_any] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_boolean] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
  },
  [479] = {
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_QMARK] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(2272),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [sym_this] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
  },
  [481] = {
    [aux_sym_formal_parameters_repeat1] = STATE(754),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_COMMA] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [anon_sym_EQ] = ACTIONS(2274),
    [anon_sym_COLON] = ACTIONS(2274),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_QMARK] = ACTIONS(2274),
    [anon_sym_COMMA] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [anon_sym_EQ] = ACTIONS(2276),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_RPAREN] = ACTIONS(2276),
    [anon_sym_QMARK] = ACTIONS(2276),
    [anon_sym_COMMA] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_arrow_function] = STATE(756),
    [sym_await_expression] = STATE(756),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(755),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(756),
    [sym_meta_property] = STATE(756),
    [sym__expression] = STATE(756),
    [sym_function] = STATE(52),
    [sym_import] = STATE(756),
    [sym_call_expression] = STATE(756),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(756),
    [sym_string] = STATE(756),
    [sym_template_string] = STATE(756),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(756),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(756),
    [sym_generator_function] = STATE(756),
    [sym_new_expression] = STATE(756),
    [sym_assignment_expression] = STATE(756),
    [sym_augmented_assignment_expression] = STATE(756),
    [sym_binary_expression] = STATE(756),
    [sym_unary_expression] = STATE(756),
    [sym_regex] = STATE(756),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(756),
    [sym_as_expression] = STATE(756),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(756),
    [sym_class] = STATE(756),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2278),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2278),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2278),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2278),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2280),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2278),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [485] = {
    [sym_arrow_function] = STATE(758),
    [sym_await_expression] = STATE(758),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(757),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(758),
    [sym_meta_property] = STATE(758),
    [sym__expression] = STATE(758),
    [sym_function] = STATE(52),
    [sym_import] = STATE(758),
    [sym_call_expression] = STATE(758),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(758),
    [sym_string] = STATE(758),
    [sym_template_string] = STATE(758),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(758),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(758),
    [sym_generator_function] = STATE(758),
    [sym_new_expression] = STATE(758),
    [sym_assignment_expression] = STATE(758),
    [sym_augmented_assignment_expression] = STATE(758),
    [sym_binary_expression] = STATE(758),
    [sym_unary_expression] = STATE(758),
    [sym_regex] = STATE(758),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(758),
    [sym_as_expression] = STATE(758),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(758),
    [sym_class] = STATE(758),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2282),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2284),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2282),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [486] = {
    [sym_optional_parameter] = STATE(481),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(481),
    [aux_sym_export_statement_repeat1] = STATE(2539),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(481),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [487] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(759),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(761),
    [sym_identifier] = ACTIONS(2286),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_statement_block] = STATE(762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [490] = {
    [sym_arrow_function] = STATE(764),
    [sym_await_expression] = STATE(764),
    [sym_member_expression] = STATE(53),
    [sym_statement_block] = STATE(763),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(764),
    [sym_meta_property] = STATE(764),
    [sym__expression] = STATE(764),
    [sym_function] = STATE(52),
    [sym_import] = STATE(764),
    [sym_call_expression] = STATE(764),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(764),
    [sym_string] = STATE(764),
    [sym_template_string] = STATE(764),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(764),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(764),
    [sym_generator_function] = STATE(764),
    [sym_new_expression] = STATE(764),
    [sym_assignment_expression] = STATE(764),
    [sym_augmented_assignment_expression] = STATE(764),
    [sym_binary_expression] = STATE(764),
    [sym_unary_expression] = STATE(764),
    [sym_regex] = STATE(764),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(764),
    [sym_as_expression] = STATE(764),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(764),
    [sym_class] = STATE(764),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2288),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2288),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2290),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [491] = {
    [sym_identifier] = ACTIONS(2292),
    [anon_sym_BQUOTE] = ACTIONS(2294),
    [anon_sym_debugger] = ACTIONS(2292),
    [anon_sym_symbol] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2294),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_void] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [sym_super] = ACTIONS(2292),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_delete] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_if] = ACTIONS(2292),
    [sym_this] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [sym_true] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_type] = ACTIONS(2292),
    [anon_sym_import] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [sym_false] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_module] = ACTIONS(2292),
    [anon_sym_number] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_declare] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [sym_null] = ACTIONS(2292),
    [anon_sym_any] = ACTIONS(2292),
    [anon_sym_boolean] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_LT] = ACTIONS(2294),
    [sym_number] = ACTIONS(2294),
    [anon_sym_SLASH] = ACTIONS(2292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2292),
    [anon_sym_function] = ACTIONS(2292),
    [sym_undefined] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [ts_builtin_sym_end] = ACTIONS(2294),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_export] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_with] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
  },
  [492] = {
    [aux_sym_variable_declaration_repeat1] = STATE(621),
    [sym__automatic_semicolon] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2296),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2298),
    [anon_sym_BQUOTE] = ACTIONS(2300),
    [anon_sym_debugger] = ACTIONS(2298),
    [anon_sym_symbol] = ACTIONS(2298),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2298),
    [anon_sym_void] = ACTIONS(2298),
    [anon_sym_break] = ACTIONS(2298),
    [anon_sym_const] = ACTIONS(2298),
    [sym_super] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2298),
    [anon_sym_private] = ACTIONS(2298),
    [anon_sym_static] = ACTIONS(2298),
    [anon_sym_get] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2298),
    [anon_sym_default] = ACTIONS(2298),
    [anon_sym_enum] = ACTIONS(2298),
    [anon_sym_delete] = ACTIONS(2298),
    [anon_sym_continue] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2298),
    [sym_this] = ACTIONS(2298),
    [anon_sym_yield] = ACTIONS(2298),
    [sym_true] = ACTIONS(2298),
    [anon_sym_throw] = ACTIONS(2298),
    [anon_sym_protected] = ACTIONS(2298),
    [anon_sym_abstract] = ACTIONS(2298),
    [anon_sym_set] = ACTIONS(2298),
    [anon_sym_type] = ACTIONS(2298),
    [anon_sym_import] = ACTIONS(2298),
    [anon_sym_namespace] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2300),
    [anon_sym_DQUOTE] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2298),
    [anon_sym_BANG] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2298),
    [anon_sym_LBRACK] = ACTIONS(2300),
    [sym_false] = ACTIONS(2298),
    [anon_sym_SEMI] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2298),
    [anon_sym_module] = ACTIONS(2298),
    [anon_sym_number] = ACTIONS(2298),
    [anon_sym_class] = ACTIONS(2298),
    [anon_sym_declare] = ACTIONS(2298),
    [anon_sym_typeof] = ACTIONS(2298),
    [anon_sym_LBRACE] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2298),
    [anon_sym_LPAREN] = ACTIONS(2300),
    [sym_null] = ACTIONS(2298),
    [anon_sym_any] = ACTIONS(2298),
    [anon_sym_boolean] = ACTIONS(2298),
    [anon_sym_async] = ACTIONS(2298),
    [anon_sym_public] = ACTIONS(2298),
    [anon_sym_var] = ACTIONS(2298),
    [anon_sym_while] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2298),
    [anon_sym_LT] = ACTIONS(2300),
    [sym_number] = ACTIONS(2300),
    [anon_sym_SLASH] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2298),
    [anon_sym_function] = ACTIONS(2298),
    [sym_undefined] = ACTIONS(2298),
    [anon_sym_new] = ACTIONS(2298),
    [ts_builtin_sym_end] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2298),
    [anon_sym_PLUS] = ACTIONS(2298),
    [anon_sym_export] = ACTIONS(2298),
    [anon_sym_do] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2300),
    [anon_sym_with] = ACTIONS(2298),
    [anon_sym_await] = ACTIONS(2298),
  },
  [494] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(2302),
    [aux_sym_string_token2] = ACTIONS(2305),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(2308),
  },
  [495] = {
    [sym__automatic_semicolon] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_yield] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1075),
    [sym_null] = ACTIONS(1075),
    [anon_sym_catch] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_with] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [sym_super] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_false] = ACTIONS(1075),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [anon_sym_finally] = ACTIONS(1075),
    [ts_builtin_sym_end] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1075),
  },
  [496] = {
    [sym_statement_block] = STATE(767),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [497] = {
    [sym_statement_block] = STATE(768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [498] = {
    [sym_finally_clause] = STATE(769),
    [sym_identifier] = ACTIONS(2312),
    [anon_sym_BQUOTE] = ACTIONS(2314),
    [anon_sym_debugger] = ACTIONS(2312),
    [anon_sym_symbol] = ACTIONS(2312),
    [anon_sym_AT] = ACTIONS(2314),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_void] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [sym_super] = ACTIONS(2312),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_delete] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(2312),
    [sym_this] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [sym_true] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_type] = ACTIONS(2312),
    [anon_sym_import] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [sym_false] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_module] = ACTIONS(2312),
    [anon_sym_number] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_declare] = ACTIONS(2312),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [sym_null] = ACTIONS(2312),
    [anon_sym_any] = ACTIONS(2312),
    [anon_sym_boolean] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_LT] = ACTIONS(2314),
    [sym_number] = ACTIONS(2314),
    [anon_sym_SLASH] = ACTIONS(2312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1235),
    [anon_sym_string] = ACTIONS(2312),
    [anon_sym_function] = ACTIONS(2312),
    [sym_undefined] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [ts_builtin_sym_end] = ACTIONS(2314),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_export] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_with] = ACTIONS(2312),
    [anon_sym_await] = ACTIONS(2312),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2316),
    [anon_sym_BQUOTE] = ACTIONS(2318),
    [anon_sym_debugger] = ACTIONS(2316),
    [anon_sym_symbol] = ACTIONS(2316),
    [anon_sym_AT] = ACTIONS(2318),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_void] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [sym_super] = ACTIONS(2316),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_interface] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_delete] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(2316),
    [sym_this] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [sym_true] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_type] = ACTIONS(2316),
    [anon_sym_import] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [sym_false] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_module] = ACTIONS(2316),
    [anon_sym_number] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_declare] = ACTIONS(2316),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [sym_null] = ACTIONS(2316),
    [anon_sym_any] = ACTIONS(2316),
    [anon_sym_boolean] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_LT] = ACTIONS(2318),
    [sym_number] = ACTIONS(2318),
    [anon_sym_SLASH] = ACTIONS(2316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2316),
    [anon_sym_function] = ACTIONS(2316),
    [sym_undefined] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [ts_builtin_sym_end] = ACTIONS(2318),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_export] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_with] = ACTIONS(2316),
    [anon_sym_await] = ACTIONS(2316),
  },
  [500] = {
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(770),
    [sym_function_type] = STATE(770),
    [sym_constructor_type] = STATE(770),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(236),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(770),
    [sym__type] = STATE(770),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_symbol] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [sym_true] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_keyof] = ACTIONS(477),
    [sym_number] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(467),
  },
  [501] = {
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(771),
    [sym_function_type] = STATE(771),
    [sym_constructor_type] = STATE(771),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(236),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(771),
    [sym__type] = STATE(771),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_symbol] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [sym_true] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_keyof] = ACTIONS(477),
    [sym_number] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(467),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2320),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(773),
    [sym_function_type] = STATE(773),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(773),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(773),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(773),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [504] = {
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_GT] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_default_type] = STATE(774),
    [anon_sym_GT] = ACTIONS(2322),
    [anon_sym_EQ] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [anon_sym_BQUOTE] = ACTIONS(2324),
    [anon_sym_symbol] = ACTIONS(2326),
    [anon_sym_PIPE] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2326),
    [anon_sym_return] = ACTIONS(2326),
    [anon_sym_static] = ACTIONS(2326),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2326),
    [anon_sym_delete] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(2326),
    [anon_sym_yield] = ACTIONS(2326),
    [sym_true] = ACTIONS(2326),
    [anon_sym_protected] = ACTIONS(2326),
    [anon_sym_set] = ACTIONS(2326),
    [anon_sym_import] = ACTIONS(2326),
    [anon_sym_DQUOTE] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2326),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym_number] = ACTIONS(2326),
    [anon_sym_typeof] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_switch] = ACTIONS(2326),
    [anon_sym_RBRACK] = ACTIONS(2324),
    [sym_null] = ACTIONS(2326),
    [anon_sym_any] = ACTIONS(2326),
    [anon_sym_async] = ACTIONS(2326),
    [anon_sym_public] = ACTIONS(2326),
    [anon_sym_var] = ACTIONS(2326),
    [anon_sym_while] = ACTIONS(2326),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_RPAREN] = ACTIONS(2324),
    [anon_sym_SLASH] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2326),
    [anon_sym_new] = ACTIONS(2326),
    [anon_sym_export] = ACTIONS(2326),
    [anon_sym_with] = ACTIONS(2326),
    [sym_identifier] = ACTIONS(2326),
    [anon_sym_debugger] = ACTIONS(2326),
    [anon_sym_AT] = ACTIONS(2324),
    [anon_sym_COMMA] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_EQ] = ACTIONS(2326),
    [anon_sym_void] = ACTIONS(2326),
    [anon_sym_const] = ACTIONS(2326),
    [sym_super] = ACTIONS(2326),
    [anon_sym_private] = ACTIONS(2326),
    [anon_sym_get] = ACTIONS(2326),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2326),
    [anon_sym_enum] = ACTIONS(2326),
    [anon_sym_continue] = ACTIONS(2326),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [sym_this] = ACTIONS(2326),
    [anon_sym_throw] = ACTIONS(2326),
    [anon_sym_abstract] = ACTIONS(2326),
    [anon_sym_type] = ACTIONS(2326),
    [anon_sym_namespace] = ACTIONS(2326),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [sym_false] = ACTIONS(2326),
    [anon_sym_case] = ACTIONS(2326),
    [anon_sym_module] = ACTIONS(2326),
    [anon_sym_class] = ACTIONS(2326),
    [anon_sym_declare] = ACTIONS(2326),
    [anon_sym_LPAREN] = ACTIONS(2324),
    [anon_sym_GT] = ACTIONS(2324),
    [anon_sym_boolean] = ACTIONS(2326),
    [anon_sym_EQ_GT] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2326),
    [anon_sym_LT] = ACTIONS(2324),
    [sym_number] = ACTIONS(2324),
    [ts_builtin_sym_end] = ACTIONS(2324),
    [anon_sym_function] = ACTIONS(2326),
    [sym_undefined] = ACTIONS(2326),
    [anon_sym_let] = ACTIONS(2326),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_implements] = ACTIONS(2326),
    [anon_sym_do] = ACTIONS(2326),
    [anon_sym_TILDE] = ACTIONS(2324),
    [anon_sym_await] = ACTIONS(2326),
  },
  [507] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(535),
    [sym_function_type] = STATE(535),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(535),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(535),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(535),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [508] = {
    [anon_sym_BQUOTE] = ACTIONS(2328),
    [anon_sym_symbol] = ACTIONS(2330),
    [anon_sym_PIPE] = ACTIONS(2328),
    [anon_sym_break] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2330),
    [anon_sym_static] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_interface] = ACTIONS(2330),
    [anon_sym_delete] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(2330),
    [anon_sym_yield] = ACTIONS(2330),
    [sym_true] = ACTIONS(2330),
    [anon_sym_protected] = ACTIONS(2330),
    [anon_sym_set] = ACTIONS(2330),
    [anon_sym_import] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2328),
    [anon_sym_for] = ACTIONS(2330),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym_number] = ACTIONS(2330),
    [anon_sym_typeof] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_switch] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2328),
    [sym_null] = ACTIONS(2330),
    [anon_sym_any] = ACTIONS(2330),
    [anon_sym_async] = ACTIONS(2330),
    [anon_sym_public] = ACTIONS(2330),
    [anon_sym_var] = ACTIONS(2330),
    [anon_sym_while] = ACTIONS(2330),
    [anon_sym_SQUOTE] = ACTIONS(2328),
    [anon_sym_RPAREN] = ACTIONS(2328),
    [anon_sym_SLASH] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2330),
    [anon_sym_new] = ACTIONS(2330),
    [anon_sym_export] = ACTIONS(2330),
    [anon_sym_with] = ACTIONS(2330),
    [sym_identifier] = ACTIONS(2330),
    [anon_sym_debugger] = ACTIONS(2330),
    [anon_sym_AT] = ACTIONS(2328),
    [anon_sym_COMMA] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_EQ] = ACTIONS(2330),
    [anon_sym_void] = ACTIONS(2330),
    [anon_sym_const] = ACTIONS(2330),
    [sym_super] = ACTIONS(2330),
    [anon_sym_private] = ACTIONS(2330),
    [anon_sym_get] = ACTIONS(2330),
    [anon_sym_default] = ACTIONS(2330),
    [anon_sym_enum] = ACTIONS(2330),
    [anon_sym_continue] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [sym_this] = ACTIONS(2330),
    [anon_sym_throw] = ACTIONS(2330),
    [anon_sym_abstract] = ACTIONS(2330),
    [anon_sym_type] = ACTIONS(2330),
    [anon_sym_namespace] = ACTIONS(2330),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_else] = ACTIONS(2330),
    [anon_sym_BANG] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [sym_false] = ACTIONS(2330),
    [anon_sym_case] = ACTIONS(2330),
    [anon_sym_module] = ACTIONS(2330),
    [anon_sym_class] = ACTIONS(2330),
    [anon_sym_declare] = ACTIONS(2330),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_GT] = ACTIONS(2328),
    [anon_sym_boolean] = ACTIONS(2330),
    [anon_sym_EQ_GT] = ACTIONS(2328),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_try] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(2328),
    [sym_number] = ACTIONS(2328),
    [ts_builtin_sym_end] = ACTIONS(2328),
    [anon_sym_function] = ACTIONS(2330),
    [sym_undefined] = ACTIONS(2330),
    [anon_sym_let] = ACTIONS(2330),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_do] = ACTIONS(2330),
    [anon_sym_TILDE] = ACTIONS(2328),
    [anon_sym_await] = ACTIONS(2330),
  },
  [509] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(775),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(775),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(775),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(775),
    [sym_property_signature] = STATE(775),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(775),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(960),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [510] = {
    [sym_string] = STATE(776),
    [sym__property_name] = STATE(776),
    [sym_computed_property_name] = STATE(776),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [511] = {
    [sym_string] = STATE(776),
    [sym__property_name] = STATE(776),
    [sym_computed_property_name] = STATE(776),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [512] = {
    [sym_string] = STATE(776),
    [sym__property_name] = STATE(776),
    [sym_computed_property_name] = STATE(776),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [513] = {
    [sym_string] = STATE(781),
    [sym__property_name] = STATE(781),
    [sym_computed_property_name] = STATE(781),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(2338),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [514] = {
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [anon_sym_symbol] = ACTIONS(2348),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_delete] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [sym_true] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_import] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_number] = ACTIONS(2348),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_RBRACK] = ACTIONS(2346),
    [sym_null] = ACTIONS(2348),
    [anon_sym_any] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_export] = ACTIONS(2348),
    [anon_sym_with] = ACTIONS(2348),
    [sym_identifier] = ACTIONS(2348),
    [anon_sym_debugger] = ACTIONS(2348),
    [anon_sym_AT] = ACTIONS(2346),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_EQ] = ACTIONS(2348),
    [anon_sym_void] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [sym_super] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [sym_this] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_type] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [sym_false] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_module] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_declare] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_boolean] = ACTIONS(2348),
    [anon_sym_EQ_GT] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2346),
    [sym_number] = ACTIONS(2346),
    [ts_builtin_sym_end] = ACTIONS(2346),
    [anon_sym_function] = ACTIONS(2348),
    [sym_undefined] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_await] = ACTIONS(2348),
  },
  [515] = {
    [sym_formal_parameters] = STATE(782),
    [sym_type_parameters] = STATE(783),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [516] = {
    [sym_class_declaration] = STATE(1320),
    [sym_generator_function_declaration] = STATE(1320),
    [sym__declaration] = STATE(1320),
    [sym_enum_declaration] = STATE(1320),
    [sym_function_signature] = STATE(1320),
    [sym_abstract_class_declaration] = STATE(1320),
    [sym_module] = STATE(1320),
    [sym_interface_declaration] = STATE(1320),
    [sym_function_declaration] = STATE(1320),
    [sym_export_clause] = STATE(1855),
    [sym_variable_declaration] = STATE(1320),
    [sym_lexical_declaration] = STATE(1320),
    [sym_ambient_declaration] = STATE(1320),
    [sym_import_alias] = STATE(1320),
    [sym_type_alias_declaration] = STATE(1320),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1320),
    [sym_decorator] = STATE(63),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_as] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
  },
  [517] = {
    [sym_string] = STATE(781),
    [sym__property_name] = STATE(781),
    [sym_computed_property_name] = STATE(781),
    [anon_sym_get] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2338),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [518] = {
    [aux_sym_object_type_repeat1] = STATE(787),
    [sym__automatic_semicolon] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_string] = STATE(781),
    [sym__property_name] = STATE(781),
    [sym_computed_property_name] = STATE(781),
    [anon_sym_get] = ACTIONS(2340),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(2338),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2342),
    [anon_sym_STAR] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(960),
  },
  [521] = {
    [sym__call_signature] = STATE(791),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(790),
    [sym__automatic_semicolon] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_QMARK] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [aux_sym_implements_clause_repeat1] = STATE(793),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [anon_sym_symbol] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_interface] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [sym_true] = ACTIONS(2402),
    [anon_sym_protected] = ACTIONS(2402),
    [anon_sym_set] = ACTIONS(2402),
    [anon_sym_import] = ACTIONS(2402),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_number] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_switch] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [sym_null] = ACTIONS(2402),
    [anon_sym_any] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_public] = ACTIONS(2402),
    [anon_sym_var] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_RPAREN] = ACTIONS(2400),
    [anon_sym_SLASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2402),
    [anon_sym_with] = ACTIONS(2402),
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_debugger] = ACTIONS(2402),
    [anon_sym_AT] = ACTIONS(2400),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_EQ] = ACTIONS(2402),
    [anon_sym_void] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [sym_super] = ACTIONS(2402),
    [anon_sym_private] = ACTIONS(2402),
    [anon_sym_get] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [sym_this] = ACTIONS(2402),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_abstract] = ACTIONS(2402),
    [anon_sym_type] = ACTIONS(2402),
    [anon_sym_namespace] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_else] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [sym_false] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2402),
    [anon_sym_module] = ACTIONS(2402),
    [anon_sym_class] = ACTIONS(2402),
    [anon_sym_declare] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2400),
    [anon_sym_boolean] = ACTIONS(2402),
    [anon_sym_EQ_GT] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_try] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2400),
    [sym_number] = ACTIONS(2400),
    [ts_builtin_sym_end] = ACTIONS(2400),
    [anon_sym_function] = ACTIONS(2402),
    [sym_undefined] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_do] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_await] = ACTIONS(2402),
  },
  [524] = {
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [anon_sym_symbol] = ACTIONS(2406),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_interface] = ACTIONS(2406),
    [anon_sym_delete] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [sym_true] = ACTIONS(2406),
    [anon_sym_protected] = ACTIONS(2406),
    [anon_sym_DOT] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(2406),
    [anon_sym_import] = ACTIONS(2406),
    [anon_sym_DQUOTE] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_number] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2406),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [sym_null] = ACTIONS(2406),
    [anon_sym_any] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_public] = ACTIONS(2406),
    [anon_sym_var] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2406),
    [anon_sym_export] = ACTIONS(2406),
    [anon_sym_with] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(2406),
    [anon_sym_debugger] = ACTIONS(2406),
    [anon_sym_AT] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_EQ] = ACTIONS(2406),
    [anon_sym_void] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [sym_super] = ACTIONS(2406),
    [anon_sym_private] = ACTIONS(2406),
    [anon_sym_get] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [sym_this] = ACTIONS(2406),
    [anon_sym_throw] = ACTIONS(2406),
    [anon_sym_abstract] = ACTIONS(2406),
    [anon_sym_type] = ACTIONS(2406),
    [anon_sym_namespace] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [sym_false] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2406),
    [anon_sym_module] = ACTIONS(2406),
    [anon_sym_class] = ACTIONS(2406),
    [anon_sym_declare] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_boolean] = ACTIONS(2406),
    [anon_sym_EQ_GT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_try] = ACTIONS(2406),
    [anon_sym_LT] = ACTIONS(2404),
    [sym_number] = ACTIONS(2404),
    [ts_builtin_sym_end] = ACTIONS(2404),
    [anon_sym_function] = ACTIONS(2406),
    [sym_undefined] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(2406),
  },
  [525] = {
    [anon_sym_BQUOTE] = ACTIONS(2410),
    [anon_sym_symbol] = ACTIONS(2412),
    [anon_sym_PIPE] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2412),
    [anon_sym_delete] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_yield] = ACTIONS(2412),
    [sym_true] = ACTIONS(2412),
    [anon_sym_protected] = ACTIONS(2412),
    [anon_sym_set] = ACTIONS(2412),
    [anon_sym_import] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_number] = ACTIONS(2412),
    [anon_sym_typeof] = ACTIONS(2412),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2412),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [sym_null] = ACTIONS(2412),
    [anon_sym_any] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_public] = ACTIONS(2412),
    [anon_sym_var] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2410),
    [anon_sym_RPAREN] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2412),
    [anon_sym_new] = ACTIONS(2412),
    [anon_sym_export] = ACTIONS(2412),
    [anon_sym_with] = ACTIONS(2412),
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_debugger] = ACTIONS(2412),
    [anon_sym_AT] = ACTIONS(2410),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_EQ] = ACTIONS(2412),
    [anon_sym_void] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [anon_sym_private] = ACTIONS(2412),
    [anon_sym_get] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2410),
    [sym_this] = ACTIONS(2412),
    [anon_sym_throw] = ACTIONS(2412),
    [anon_sym_abstract] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_namespace] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym_false] = ACTIONS(2412),
    [anon_sym_case] = ACTIONS(2412),
    [anon_sym_module] = ACTIONS(2412),
    [anon_sym_class] = ACTIONS(2412),
    [anon_sym_declare] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2410),
    [anon_sym_boolean] = ACTIONS(2412),
    [anon_sym_EQ_GT] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2410),
    [sym_number] = ACTIONS(2410),
    [ts_builtin_sym_end] = ACTIONS(2410),
    [anon_sym_function] = ACTIONS(2412),
    [sym_undefined] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_PLUS] = ACTIONS(2412),
    [anon_sym_do] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2410),
    [anon_sym_await] = ACTIONS(2412),
  },
  [526] = {
    [anon_sym_BQUOTE] = ACTIONS(2414),
    [anon_sym_symbol] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2416),
    [anon_sym_delete] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_yield] = ACTIONS(2416),
    [sym_true] = ACTIONS(2416),
    [anon_sym_protected] = ACTIONS(2416),
    [anon_sym_DOT] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2416),
    [anon_sym_import] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_number] = ACTIONS(2416),
    [anon_sym_typeof] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2414),
    [sym_null] = ACTIONS(2416),
    [anon_sym_any] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_public] = ACTIONS(2416),
    [anon_sym_var] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2414),
    [anon_sym_RPAREN] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2416),
    [anon_sym_new] = ACTIONS(2416),
    [anon_sym_export] = ACTIONS(2416),
    [anon_sym_with] = ACTIONS(2416),
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_debugger] = ACTIONS(2416),
    [anon_sym_AT] = ACTIONS(2414),
    [anon_sym_COMMA] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_EQ] = ACTIONS(2416),
    [anon_sym_void] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [anon_sym_private] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [sym_this] = ACTIONS(2416),
    [anon_sym_throw] = ACTIONS(2416),
    [anon_sym_abstract] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_namespace] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [sym_false] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2416),
    [anon_sym_module] = ACTIONS(2416),
    [anon_sym_class] = ACTIONS(2416),
    [anon_sym_declare] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2414),
    [anon_sym_boolean] = ACTIONS(2416),
    [anon_sym_EQ_GT] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2414),
    [sym_number] = ACTIONS(2414),
    [ts_builtin_sym_end] = ACTIONS(2414),
    [anon_sym_function] = ACTIONS(2416),
    [sym_undefined] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_do] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2414),
    [anon_sym_await] = ACTIONS(2416),
  },
  [527] = {
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_symbol] = ACTIONS(2422),
    [anon_sym_PIPE] = ACTIONS(2420),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [sym_true] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_number] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [sym_null] = ACTIONS(2422),
    [anon_sym_any] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_SLASH] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_debugger] = ACTIONS(2422),
    [anon_sym_AT] = ACTIONS(2420),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_EQ] = ACTIONS(2422),
    [anon_sym_void] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [sym_this] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [sym_false] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_declare] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2420),
    [anon_sym_boolean] = ACTIONS(2422),
    [anon_sym_EQ_GT] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_LT] = ACTIONS(2420),
    [sym_number] = ACTIONS(2420),
    [ts_builtin_sym_end] = ACTIONS(2420),
    [anon_sym_function] = ACTIONS(2422),
    [sym_undefined] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_await] = ACTIONS(2422),
  },
  [528] = {
    [anon_sym_EQ_GT] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_formal_parameters] = STATE(795),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_await_expression] = STATE(1808),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(1808),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(1808),
    [sym_function_type] = STATE(522),
    [sym__expression] = STATE(1808),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(1808),
    [sym_template_string] = STATE(1808),
    [sym_yield_expression] = STATE(1808),
    [sym_type_assertion] = STATE(1808),
    [sym_new_expression] = STATE(1808),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(1808),
    [sym_binary_expression] = STATE(1808),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(522),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(1252),
    [sym_as_expression] = STATE(1808),
    [sym_internal_module] = STATE(1808),
    [sym_arrow_function] = STATE(1808),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_intersection_type] = STATE(522),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(522),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_spread_element] = STATE(1809),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1625),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(1256),
    [sym_generator_function] = STATE(1808),
    [sym_constructor_type] = STATE(522),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(1808),
    [sym_regex] = STATE(1808),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [aux_sym_array_repeat1] = STATE(1810),
    [sym_non_null_expression] = STATE(1808),
    [sym_class] = STATE(1808),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2432),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [sym_null] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [531] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_RPAREN] = ACTIONS(2454),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(1250),
  },
  [532] = {
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(2272),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_PIPE] = ACTIONS(1282),
    [anon_sym_COMMA] = ACTIONS(2272),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [sym_type_parameters] = STATE(1793),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_construct_signature] = STATE(518),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(518),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(1829),
    [sym__call_signature] = STATE(518),
    [sym_property_signature] = STATE(518),
    [sym_string] = STATE(805),
    [sym_index_signature] = STATE(518),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [534] = {
    [anon_sym_EQ] = ACTIONS(2452),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_QMARK] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_RPAREN] = ACTIONS(2484),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_COMMA] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(2487),
    [anon_sym_PIPE] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [anon_sym_BQUOTE] = ACTIONS(2489),
    [anon_sym_symbol] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(2489),
    [anon_sym_break] = ACTIONS(2491),
    [anon_sym_return] = ACTIONS(2491),
    [anon_sym_static] = ACTIONS(2491),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_interface] = ACTIONS(2491),
    [anon_sym_delete] = ACTIONS(2491),
    [anon_sym_if] = ACTIONS(2491),
    [anon_sym_yield] = ACTIONS(2491),
    [sym_true] = ACTIONS(2491),
    [anon_sym_protected] = ACTIONS(2491),
    [anon_sym_set] = ACTIONS(2491),
    [anon_sym_import] = ACTIONS(2491),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [anon_sym_for] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_number] = ACTIONS(2491),
    [anon_sym_typeof] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_switch] = ACTIONS(2491),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [sym_null] = ACTIONS(2491),
    [anon_sym_any] = ACTIONS(2491),
    [anon_sym_async] = ACTIONS(2491),
    [anon_sym_public] = ACTIONS(2491),
    [anon_sym_var] = ACTIONS(2491),
    [anon_sym_while] = ACTIONS(2491),
    [anon_sym_SQUOTE] = ACTIONS(2489),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_SLASH] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2491),
    [anon_sym_new] = ACTIONS(2491),
    [anon_sym_export] = ACTIONS(2491),
    [anon_sym_with] = ACTIONS(2491),
    [sym_identifier] = ACTIONS(2491),
    [anon_sym_debugger] = ACTIONS(2491),
    [anon_sym_AT] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_void] = ACTIONS(2491),
    [anon_sym_const] = ACTIONS(2491),
    [sym_super] = ACTIONS(2491),
    [anon_sym_private] = ACTIONS(2491),
    [anon_sym_get] = ACTIONS(2491),
    [anon_sym_default] = ACTIONS(2491),
    [anon_sym_enum] = ACTIONS(2491),
    [anon_sym_continue] = ACTIONS(2491),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [sym_this] = ACTIONS(2491),
    [anon_sym_throw] = ACTIONS(2491),
    [anon_sym_abstract] = ACTIONS(2491),
    [anon_sym_type] = ACTIONS(2491),
    [anon_sym_namespace] = ACTIONS(2491),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_else] = ACTIONS(2491),
    [anon_sym_BANG] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [sym_false] = ACTIONS(2491),
    [anon_sym_case] = ACTIONS(2491),
    [anon_sym_module] = ACTIONS(2491),
    [anon_sym_class] = ACTIONS(2491),
    [anon_sym_declare] = ACTIONS(2491),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2489),
    [anon_sym_boolean] = ACTIONS(2491),
    [anon_sym_EQ_GT] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_try] = ACTIONS(2491),
    [anon_sym_LT] = ACTIONS(2489),
    [sym_number] = ACTIONS(2489),
    [ts_builtin_sym_end] = ACTIONS(2489),
    [anon_sym_function] = ACTIONS(2491),
    [sym_undefined] = ACTIONS(2491),
    [anon_sym_let] = ACTIONS(2491),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_do] = ACTIONS(2491),
    [anon_sym_TILDE] = ACTIONS(2489),
    [anon_sym_await] = ACTIONS(2491),
  },
  [537] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(807),
    [sym_function_type] = STATE(807),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(807),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(807),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(807),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [538] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(809),
    [sym_function_type] = STATE(809),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(809),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(809),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(809),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(2493),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [539] = {
    [anon_sym_BQUOTE] = ACTIONS(2495),
    [anon_sym_symbol] = ACTIONS(2497),
    [anon_sym_PIPE] = ACTIONS(2495),
    [anon_sym_break] = ACTIONS(2497),
    [anon_sym_return] = ACTIONS(2497),
    [anon_sym_static] = ACTIONS(2497),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_interface] = ACTIONS(2497),
    [anon_sym_delete] = ACTIONS(2497),
    [anon_sym_if] = ACTIONS(2497),
    [anon_sym_yield] = ACTIONS(2497),
    [sym_true] = ACTIONS(2497),
    [anon_sym_protected] = ACTIONS(2497),
    [anon_sym_set] = ACTIONS(2497),
    [anon_sym_import] = ACTIONS(2497),
    [anon_sym_DQUOTE] = ACTIONS(2495),
    [anon_sym_for] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(2495),
    [anon_sym_number] = ACTIONS(2497),
    [anon_sym_typeof] = ACTIONS(2497),
    [anon_sym_LBRACE] = ACTIONS(2497),
    [anon_sym_switch] = ACTIONS(2497),
    [anon_sym_RBRACK] = ACTIONS(2495),
    [sym_null] = ACTIONS(2497),
    [anon_sym_any] = ACTIONS(2497),
    [anon_sym_async] = ACTIONS(2497),
    [anon_sym_public] = ACTIONS(2497),
    [anon_sym_var] = ACTIONS(2497),
    [anon_sym_while] = ACTIONS(2497),
    [anon_sym_SQUOTE] = ACTIONS(2495),
    [anon_sym_RPAREN] = ACTIONS(2495),
    [anon_sym_SLASH] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2497),
    [anon_sym_new] = ACTIONS(2497),
    [anon_sym_export] = ACTIONS(2497),
    [anon_sym_with] = ACTIONS(2497),
    [sym_identifier] = ACTIONS(2497),
    [anon_sym_debugger] = ACTIONS(2497),
    [anon_sym_AT] = ACTIONS(2495),
    [anon_sym_COMMA] = ACTIONS(2495),
    [anon_sym_DASH] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(2497),
    [anon_sym_void] = ACTIONS(2497),
    [anon_sym_const] = ACTIONS(2497),
    [sym_super] = ACTIONS(2497),
    [anon_sym_private] = ACTIONS(2497),
    [anon_sym_get] = ACTIONS(2497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2495),
    [anon_sym_default] = ACTIONS(2497),
    [anon_sym_enum] = ACTIONS(2497),
    [anon_sym_continue] = ACTIONS(2497),
    [anon_sym_DASH_DASH] = ACTIONS(2495),
    [sym_this] = ACTIONS(2497),
    [anon_sym_throw] = ACTIONS(2497),
    [anon_sym_abstract] = ACTIONS(2497),
    [anon_sym_type] = ACTIONS(2497),
    [anon_sym_namespace] = ACTIONS(2497),
    [anon_sym_PLUS_PLUS] = ACTIONS(2495),
    [anon_sym_else] = ACTIONS(2497),
    [anon_sym_BANG] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [sym_false] = ACTIONS(2497),
    [anon_sym_case] = ACTIONS(2497),
    [anon_sym_module] = ACTIONS(2497),
    [anon_sym_class] = ACTIONS(2497),
    [anon_sym_declare] = ACTIONS(2497),
    [anon_sym_LPAREN] = ACTIONS(2495),
    [anon_sym_GT] = ACTIONS(2495),
    [anon_sym_boolean] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(2495),
    [anon_sym_AMP] = ACTIONS(2495),
    [anon_sym_try] = ACTIONS(2497),
    [anon_sym_LT] = ACTIONS(2495),
    [sym_number] = ACTIONS(2495),
    [ts_builtin_sym_end] = ACTIONS(2495),
    [anon_sym_function] = ACTIONS(2497),
    [sym_undefined] = ACTIONS(2497),
    [anon_sym_let] = ACTIONS(2497),
    [anon_sym_PLUS] = ACTIONS(2497),
    [anon_sym_implements] = ACTIONS(2497),
    [anon_sym_do] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2495),
    [anon_sym_await] = ACTIONS(2497),
  },
  [540] = {
    [sym_type_parameter] = STATE(811),
    [anon_sym_GT] = ACTIONS(2499),
    [sym_identifier] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [anon_sym_extends] = ACTIONS(2501),
    [anon_sym_implements] = ACTIONS(2501),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2501),
    [anon_sym_EQ] = ACTIONS(2501),
    [anon_sym_LPAREN] = ACTIONS(2501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2503),
  },
  [542] = {
    [aux_sym_type_parameters_repeat1] = STATE(813),
    [anon_sym_GT] = ACTIONS(2499),
    [anon_sym_COMMA] = ACTIONS(2505),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [anon_sym_symbol] = ACTIONS(2509),
    [anon_sym_PIPE] = ACTIONS(2507),
    [anon_sym_break] = ACTIONS(2509),
    [anon_sym_return] = ACTIONS(2509),
    [anon_sym_static] = ACTIONS(2509),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_interface] = ACTIONS(2509),
    [anon_sym_delete] = ACTIONS(2509),
    [anon_sym_if] = ACTIONS(2509),
    [anon_sym_yield] = ACTIONS(2509),
    [sym_true] = ACTIONS(2509),
    [anon_sym_protected] = ACTIONS(2509),
    [anon_sym_set] = ACTIONS(2509),
    [anon_sym_import] = ACTIONS(2509),
    [anon_sym_DQUOTE] = ACTIONS(2507),
    [anon_sym_for] = ACTIONS(2509),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_number] = ACTIONS(2509),
    [anon_sym_typeof] = ACTIONS(2509),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_switch] = ACTIONS(2509),
    [anon_sym_RBRACK] = ACTIONS(2507),
    [sym_null] = ACTIONS(2509),
    [anon_sym_any] = ACTIONS(2509),
    [anon_sym_async] = ACTIONS(2509),
    [anon_sym_public] = ACTIONS(2509),
    [anon_sym_var] = ACTIONS(2509),
    [anon_sym_while] = ACTIONS(2509),
    [anon_sym_SQUOTE] = ACTIONS(2507),
    [anon_sym_RPAREN] = ACTIONS(2507),
    [anon_sym_SLASH] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2509),
    [anon_sym_new] = ACTIONS(2509),
    [anon_sym_export] = ACTIONS(2509),
    [anon_sym_with] = ACTIONS(2509),
    [sym_identifier] = ACTIONS(2509),
    [anon_sym_debugger] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(2507),
    [anon_sym_COMMA] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(2509),
    [anon_sym_void] = ACTIONS(2509),
    [anon_sym_const] = ACTIONS(2509),
    [sym_super] = ACTIONS(2509),
    [anon_sym_private] = ACTIONS(2509),
    [anon_sym_get] = ACTIONS(2509),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2507),
    [anon_sym_default] = ACTIONS(2509),
    [anon_sym_enum] = ACTIONS(2509),
    [anon_sym_continue] = ACTIONS(2509),
    [anon_sym_DASH_DASH] = ACTIONS(2507),
    [sym_this] = ACTIONS(2509),
    [anon_sym_throw] = ACTIONS(2509),
    [anon_sym_abstract] = ACTIONS(2509),
    [anon_sym_type] = ACTIONS(2509),
    [anon_sym_namespace] = ACTIONS(2509),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_else] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [sym_false] = ACTIONS(2509),
    [anon_sym_case] = ACTIONS(2509),
    [anon_sym_module] = ACTIONS(2509),
    [anon_sym_class] = ACTIONS(2509),
    [anon_sym_declare] = ACTIONS(2509),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2507),
    [anon_sym_boolean] = ACTIONS(2509),
    [anon_sym_EQ_GT] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_try] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(2507),
    [sym_number] = ACTIONS(2507),
    [ts_builtin_sym_end] = ACTIONS(2507),
    [anon_sym_function] = ACTIONS(2509),
    [sym_undefined] = ACTIONS(2509),
    [anon_sym_let] = ACTIONS(2509),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_implements] = ACTIONS(2509),
    [anon_sym_do] = ACTIONS(2509),
    [anon_sym_TILDE] = ACTIONS(2507),
    [anon_sym_await] = ACTIONS(2509),
  },
  [544] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(814),
    [sym_function_type] = STATE(814),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(814),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(814),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(814),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [545] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(815),
    [sym_function_type] = STATE(815),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(815),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(815),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(815),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [546] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(2511),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [547] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_GT] = ACTIONS(2511),
    [anon_sym_COMMA] = ACTIONS(2513),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [anon_sym_EQ_GT] = ACTIONS(2515),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2517),
    [sym__automatic_semicolon] = ACTIONS(2517),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_STAR] = ACTIONS(2519),
    [anon_sym_GT_GT_GT] = ACTIONS(2517),
    [anon_sym_BANG_EQ] = ACTIONS(2519),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2517),
    [anon_sym_as] = ACTIONS(2519),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_instanceof] = ACTIONS(2519),
    [sym_regex_flags] = ACTIONS(2521),
    [anon_sym_DOT] = ACTIONS(2517),
    [anon_sym_STAR_STAR] = ACTIONS(2517),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_in] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2519),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_SEMI] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_LT] = ACTIONS(2519),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_GT_GT] = ACTIONS(2519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2517),
  },
  [550] = {
    [sym_statement_block] = STATE(823),
    [sym__automatic_semicolon] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(836),
  },
  [551] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(824),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [sym_statement_block] = STATE(825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [553] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2525),
    [anon_sym_LBRACK] = ACTIONS(2525),
    [sym__automatic_semicolon] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_BQUOTE] = ACTIONS(2525),
    [anon_sym_PIPE] = ACTIONS(2527),
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_LT_LT] = ACTIONS(2525),
    [anon_sym_STAR] = ACTIONS(2527),
    [anon_sym_GT_GT_GT] = ACTIONS(2525),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_BANG_EQ] = ACTIONS(2527),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_PERCENT] = ACTIONS(2525),
    [anon_sym_QMARK] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2525),
    [anon_sym_as] = ACTIONS(2525),
    [anon_sym_PIPE_PIPE] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_EQ_EQ] = ACTIONS(2527),
    [anon_sym_instanceof] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_SLASH] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2525),
    [anon_sym_CARET] = ACTIONS(2525),
    [anon_sym_STAR_STAR] = ACTIONS(2525),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_GT_GT] = ACTIONS(2527),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_in] = ACTIONS(2527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BANG] = ACTIONS(2527),
  },
  [554] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [sym__automatic_semicolon] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_GT_GT_GT] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_BANG_EQ] = ACTIONS(2531),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_instanceof] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_in] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2531),
  },
  [555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2533),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [sym__automatic_semicolon] = ACTIONS(2533),
    [anon_sym_SEMI] = ACTIONS(2533),
    [anon_sym_BQUOTE] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_STAR] = ACTIONS(2535),
    [anon_sym_GT_GT_GT] = ACTIONS(2533),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_BANG_EQ] = ACTIONS(2535),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2535),
    [anon_sym_AMP] = ACTIONS(2535),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_as] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2535),
    [anon_sym_instanceof] = ACTIONS(2533),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_GT_GT] = ACTIONS(2535),
    [anon_sym_PLUS_PLUS] = ACTIONS(2533),
    [anon_sym_in] = ACTIONS(2535),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
    [anon_sym_BANG] = ACTIONS(2535),
  },
  [556] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [sym__automatic_semicolon] = ACTIONS(2537),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_GT_GT_GT] = ACTIONS(2537),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_DASH] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2539),
    [anon_sym_LT_EQ] = ACTIONS(2537),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_as] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_instanceof] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_in] = ACTIONS(2539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_BANG] = ACTIONS(2539),
  },
  [557] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2529),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [sym__automatic_semicolon] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_GT_GT_GT] = ACTIONS(2529),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2531),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_instanceof] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2529),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_in] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(2531),
  },
  [558] = {
    [sym__automatic_semicolon] = ACTIONS(2541),
    [anon_sym_SEMI] = ACTIONS(2541),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [sym__automatic_semicolon] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2543),
    [anon_sym_from] = ACTIONS(2543),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [anon_sym_RBRACE] = ACTIONS(2545),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [aux_sym_export_clause_repeat1] = STATE(833),
    [anon_sym_COMMA] = ACTIONS(2547),
    [anon_sym_RBRACE] = ACTIONS(2549),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(2541),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2541),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [563] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2553),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2553),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [564] = {
    [sym_identifier] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2579),
    [anon_sym_BQUOTE] = ACTIONS(2581),
    [anon_sym_debugger] = ACTIONS(2579),
    [anon_sym_symbol] = ACTIONS(2579),
    [anon_sym_AT] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2579),
    [anon_sym_void] = ACTIONS(2579),
    [anon_sym_break] = ACTIONS(2579),
    [anon_sym_const] = ACTIONS(2579),
    [sym_super] = ACTIONS(2579),
    [anon_sym_return] = ACTIONS(2579),
    [anon_sym_private] = ACTIONS(2579),
    [anon_sym_static] = ACTIONS(2579),
    [anon_sym_get] = ACTIONS(2579),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_interface] = ACTIONS(2579),
    [anon_sym_default] = ACTIONS(2579),
    [anon_sym_enum] = ACTIONS(2579),
    [anon_sym_delete] = ACTIONS(2579),
    [anon_sym_continue] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2581),
    [anon_sym_if] = ACTIONS(2579),
    [sym_this] = ACTIONS(2579),
    [anon_sym_yield] = ACTIONS(2579),
    [sym_true] = ACTIONS(2579),
    [anon_sym_throw] = ACTIONS(2579),
    [anon_sym_protected] = ACTIONS(2579),
    [anon_sym_abstract] = ACTIONS(2579),
    [anon_sym_set] = ACTIONS(2579),
    [anon_sym_type] = ACTIONS(2579),
    [anon_sym_import] = ACTIONS(2579),
    [anon_sym_namespace] = ACTIONS(2579),
    [anon_sym_PLUS_PLUS] = ACTIONS(2581),
    [anon_sym_DQUOTE] = ACTIONS(2581),
    [anon_sym_else] = ACTIONS(2579),
    [anon_sym_BANG] = ACTIONS(2581),
    [anon_sym_for] = ACTIONS(2579),
    [anon_sym_LBRACK] = ACTIONS(2581),
    [sym_false] = ACTIONS(2579),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_case] = ACTIONS(2579),
    [anon_sym_module] = ACTIONS(2579),
    [anon_sym_number] = ACTIONS(2579),
    [anon_sym_class] = ACTIONS(2579),
    [anon_sym_declare] = ACTIONS(2579),
    [anon_sym_typeof] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_switch] = ACTIONS(2579),
    [anon_sym_LPAREN] = ACTIONS(2581),
    [sym_null] = ACTIONS(2579),
    [anon_sym_any] = ACTIONS(2579),
    [anon_sym_boolean] = ACTIONS(2579),
    [anon_sym_async] = ACTIONS(2579),
    [anon_sym_public] = ACTIONS(2579),
    [anon_sym_var] = ACTIONS(2579),
    [anon_sym_while] = ACTIONS(2579),
    [anon_sym_SQUOTE] = ACTIONS(2581),
    [anon_sym_try] = ACTIONS(2579),
    [anon_sym_LT] = ACTIONS(2581),
    [sym_number] = ACTIONS(2581),
    [anon_sym_SLASH] = ACTIONS(2579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2579),
    [anon_sym_function] = ACTIONS(2579),
    [sym_undefined] = ACTIONS(2579),
    [anon_sym_new] = ACTIONS(2579),
    [ts_builtin_sym_end] = ACTIONS(2581),
    [anon_sym_let] = ACTIONS(2579),
    [anon_sym_PLUS] = ACTIONS(2579),
    [anon_sym_export] = ACTIONS(2579),
    [anon_sym_do] = ACTIONS(2579),
    [anon_sym_TILDE] = ACTIONS(2581),
    [anon_sym_with] = ACTIONS(2579),
    [anon_sym_await] = ACTIONS(2579),
  },
  [566] = {
    [sym_parenthesized_expression] = STATE(836),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [sym_identifier] = ACTIONS(2585),
    [anon_sym_BQUOTE] = ACTIONS(2587),
    [anon_sym_debugger] = ACTIONS(2585),
    [anon_sym_symbol] = ACTIONS(2585),
    [anon_sym_AT] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_void] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [sym_super] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_private] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_get] = ACTIONS(2585),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_interface] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_if] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2585),
    [sym_true] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_protected] = ACTIONS(2585),
    [anon_sym_abstract] = ACTIONS(2585),
    [anon_sym_set] = ACTIONS(2585),
    [anon_sym_type] = ACTIONS(2585),
    [anon_sym_import] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [sym_false] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_module] = ACTIONS(2585),
    [anon_sym_number] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_declare] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [sym_null] = ACTIONS(2585),
    [anon_sym_any] = ACTIONS(2585),
    [anon_sym_boolean] = ACTIONS(2585),
    [anon_sym_async] = ACTIONS(2585),
    [anon_sym_public] = ACTIONS(2585),
    [anon_sym_var] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_LT] = ACTIONS(2587),
    [sym_number] = ACTIONS(2587),
    [anon_sym_SLASH] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2585),
    [anon_sym_function] = ACTIONS(2585),
    [sym_undefined] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [ts_builtin_sym_end] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_export] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_with] = ACTIONS(2585),
    [anon_sym_await] = ACTIONS(2585),
  },
  [568] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [569] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [570] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [571] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [572] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [573] = {
    [sym__automatic_semicolon] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2596),
  },
  [574] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2596),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [575] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2598),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [576] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [sym__automatic_semicolon] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_GT_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_GT_EQ] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_PERCENT] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_CARET] = ACTIONS(2600),
    [anon_sym_STAR_STAR] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2602),
  },
  [577] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [sym__automatic_semicolon] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2600),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_GT_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [anon_sym_LT_EQ] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_GT_EQ] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_PERCENT] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_instanceof] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_CARET] = ACTIONS(2600),
    [anon_sym_STAR_STAR] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2600),
    [anon_sym_BANG] = ACTIONS(2602),
  },
  [578] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(2610),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [579] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [580] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [581] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(177),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [582] = {
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_function] = STATE(52),
    [sym_import] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(91),
    [sym_string] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(91),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_new_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(91),
    [sym_class] = STATE(91),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(153),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(153),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(153),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(153),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(153),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [583] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [584] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(205),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(205),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(205),
    [sym_function_type] = STATE(535),
    [sym__expression] = STATE(205),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(205),
    [sym_template_string] = STATE(205),
    [sym_yield_expression] = STATE(205),
    [sym_type_assertion] = STATE(205),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(205),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(535),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(205),
    [sym_internal_module] = STATE(205),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(205),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(204),
    [sym_intersection_type] = STATE(535),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(535),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(205),
    [sym_constructor_type] = STATE(535),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(205),
    [sym_class] = STATE(205),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(2634),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(409),
    [anon_sym_get] = ACTIONS(409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_set] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(409),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(423),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(409),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(419),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(419),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [585] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [586] = {
    [sym_arrow_function] = STATE(247),
    [sym_await_expression] = STATE(254),
    [sym_member_expression] = STATE(253),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(254),
    [sym_meta_property] = STATE(247),
    [sym__expression] = STATE(254),
    [sym_function] = STATE(255),
    [sym_import] = STATE(247),
    [sym_call_expression] = STATE(254),
    [sym_subscript_expression] = STATE(253),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(254),
    [sym_string] = STATE(247),
    [sym_template_string] = STATE(247),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(254),
    [sym_object] = STATE(256),
    [sym_type_assertion] = STATE(254),
    [sym_generator_function] = STATE(247),
    [sym_new_expression] = STATE(247),
    [sym_assignment_expression] = STATE(254),
    [sym_augmented_assignment_expression] = STATE(254),
    [sym_binary_expression] = STATE(254),
    [sym_unary_expression] = STATE(254),
    [sym_regex] = STATE(247),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(253),
    [sym_non_null_expression] = STATE(254),
    [sym_as_expression] = STATE(254),
    [sym_array] = STATE(257),
    [sym_internal_module] = STATE(254),
    [sym_class] = STATE(247),
    [sym_identifier] = ACTIONS(497),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(499),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(503),
    [sym_super] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_get] = ACTIONS(499),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(511),
    [anon_sym_protected] = ACTIONS(499),
    [anon_sym_DOT] = ACTIONS(515),
    [anon_sym_set] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(499),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(511),
    [anon_sym_module] = ACTIONS(499),
    [anon_sym_number] = ACTIONS(499),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(499),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(511),
    [anon_sym_any] = ACTIONS(499),
    [anon_sym_boolean] = ACTIONS(499),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_public] = ACTIONS(499),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(523),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(499),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [587] = {
    [sym_formal_parameters] = STATE(846),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [sym_type_annotation] = STATE(287),
    [anon_sym_EQ_GT] = ACTIONS(2652),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2593),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [590] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [591] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [sym__automatic_semicolon] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_BQUOTE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_LT_EQ] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2657),
    [anon_sym_GT_EQ] = ACTIONS(2657),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_PERCENT] = ACTIONS(2657),
    [anon_sym_QMARK] = ACTIONS(2657),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_as] = ACTIONS(2657),
    [anon_sym_PIPE_PIPE] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_instanceof] = ACTIONS(2657),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2657),
    [anon_sym_CARET] = ACTIONS(2657),
    [anon_sym_STAR_STAR] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2657),
    [anon_sym_BANG] = ACTIONS(2659),
  },
  [592] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [593] = {
    [anon_sym_EQ_GT] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2661),
  },
  [594] = {
    [anon_sym_EQ_GT] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_EQ] = ACTIONS(2665),
    [anon_sym_RPAREN] = ACTIONS(2663),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2663),
  },
  [595] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [596] = {
    [sym_arrow_function] = STATE(847),
    [sym_await_expression] = STATE(847),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(847),
    [sym_meta_property] = STATE(847),
    [sym__expression] = STATE(847),
    [sym_function] = STATE(52),
    [sym_import] = STATE(847),
    [sym_call_expression] = STATE(847),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(847),
    [sym_string] = STATE(847),
    [sym_template_string] = STATE(847),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(847),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(847),
    [sym_generator_function] = STATE(847),
    [sym_new_expression] = STATE(847),
    [sym_assignment_expression] = STATE(847),
    [sym_augmented_assignment_expression] = STATE(847),
    [sym_binary_expression] = STATE(847),
    [sym_unary_expression] = STATE(847),
    [sym_regex] = STATE(847),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(847),
    [sym_as_expression] = STATE(847),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(847),
    [sym_class] = STATE(847),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_void] = ACTIONS(1410),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(2669),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_true] = ACTIONS(2669),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(2669),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(2669),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2671),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_await] = ACTIONS(1430),
  },
  [597] = {
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_BQUOTE] = ACTIONS(2675),
    [anon_sym_debugger] = ACTIONS(2673),
    [anon_sym_symbol] = ACTIONS(2673),
    [anon_sym_AT] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_void] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [sym_super] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_private] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_get] = ACTIONS(2673),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_interface] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_if] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
    [anon_sym_yield] = ACTIONS(2673),
    [sym_true] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_protected] = ACTIONS(2673),
    [anon_sym_abstract] = ACTIONS(2673),
    [anon_sym_set] = ACTIONS(2673),
    [anon_sym_type] = ACTIONS(2673),
    [anon_sym_import] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2675),
    [sym_false] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_module] = ACTIONS(2673),
    [anon_sym_number] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_declare] = ACTIONS(2673),
    [anon_sym_typeof] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [sym_null] = ACTIONS(2673),
    [anon_sym_any] = ACTIONS(2673),
    [anon_sym_boolean] = ACTIONS(2673),
    [anon_sym_async] = ACTIONS(2673),
    [anon_sym_public] = ACTIONS(2673),
    [anon_sym_var] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_LT] = ACTIONS(2675),
    [sym_number] = ACTIONS(2675),
    [anon_sym_SLASH] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2673),
    [anon_sym_function] = ACTIONS(2673),
    [sym_undefined] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [ts_builtin_sym_end] = ACTIONS(2675),
    [anon_sym_let] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_export] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_with] = ACTIONS(2673),
    [anon_sym_await] = ACTIONS(2673),
  },
  [598] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(849),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(848),
    [sym_type_parameters] = STATE(850),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [599] = {
    [sym_class_body] = STATE(851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [600] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(852),
    [sym_class_heritage] = STATE(853),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [601] = {
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2677),
    [sym_escape_sequence] = ACTIONS(2677),
    [anon_sym_BQUOTE] = ACTIONS(2677),
    [sym__template_chars] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
  },
  [602] = {
    [anon_sym_LBRACK] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_module] = ACTIONS(2681),
    [anon_sym_symbol] = ACTIONS(2681),
    [anon_sym_number] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_AT] = ACTIONS(2679),
    [anon_sym_declare] = ACTIONS(2681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2679),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_void] = ACTIONS(2681),
    [anon_sym_LPAREN] = ACTIONS(2679),
    [anon_sym_any] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_boolean] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_async] = ACTIONS(2681),
    [anon_sym_get] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [sym_this] = ACTIONS(2681),
    [sym_number] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_string] = ACTIONS(2681),
    [anon_sym_abstract] = ACTIONS(2681),
    [anon_sym_DOT] = ACTIONS(2681),
    [anon_sym_set] = ACTIONS(2681),
    [anon_sym_type] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(2681),
    [sym_readonly] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_DQUOTE] = ACTIONS(2679),
  },
  [603] = {
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_module] = ACTIONS(2685),
    [anon_sym_symbol] = ACTIONS(2685),
    [anon_sym_number] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_declare] = ACTIONS(2685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_void] = ACTIONS(2685),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_any] = ACTIONS(2685),
    [anon_sym_private] = ACTIONS(2685),
    [anon_sym_boolean] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_async] = ACTIONS(2685),
    [anon_sym_get] = ACTIONS(2685),
    [anon_sym_public] = ACTIONS(2685),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [sym_this] = ACTIONS(2685),
    [sym_number] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2685),
    [anon_sym_string] = ACTIONS(2685),
    [anon_sym_abstract] = ACTIONS(2685),
    [anon_sym_DOT] = ACTIONS(2685),
    [anon_sym_set] = ACTIONS(2685),
    [anon_sym_type] = ACTIONS(2685),
    [anon_sym_export] = ACTIONS(2685),
    [sym_readonly] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_DQUOTE] = ACTIONS(2683),
  },
  [604] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [sym__automatic_semicolon] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2073),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_BANG_EQ] = ACTIONS(2073),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_QMARK] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_as] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(2065),
    [anon_sym_EQ_EQ] = ACTIONS(2073),
    [anon_sym_instanceof] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_CARET] = ACTIONS(2065),
    [anon_sym_STAR_STAR] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_PLUS_PLUS] = ACTIONS(2065),
    [anon_sym_in] = ACTIONS(2073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(2073),
  },
  [605] = {
    [sym_class_body] = STATE(854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [606] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(855),
    [sym_class_heritage] = STATE(856),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [607] = {
    [sym_arrow_function] = STATE(857),
    [sym_await_expression] = STATE(857),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(857),
    [sym_meta_property] = STATE(857),
    [sym__expression] = STATE(857),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(857),
    [sym_call_expression] = STATE(857),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(857),
    [sym_string] = STATE(857),
    [sym_template_string] = STATE(857),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(857),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(857),
    [sym_generator_function] = STATE(857),
    [sym_new_expression] = STATE(857),
    [sym_assignment_expression] = STATE(857),
    [sym_augmented_assignment_expression] = STATE(857),
    [sym_binary_expression] = STATE(857),
    [sym_unary_expression] = STATE(857),
    [sym_regex] = STATE(857),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(857),
    [sym_as_expression] = STATE(857),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(857),
    [sym_class] = STATE(857),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2687),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2687),
    [sym_number] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2687),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [608] = {
    [sym_arrow_function] = STATE(858),
    [sym_await_expression] = STATE(858),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(858),
    [sym_meta_property] = STATE(858),
    [sym__expression] = STATE(858),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(858),
    [sym_call_expression] = STATE(858),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(858),
    [sym_string] = STATE(858),
    [sym_template_string] = STATE(858),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(858),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(858),
    [sym_generator_function] = STATE(858),
    [sym_new_expression] = STATE(858),
    [sym_assignment_expression] = STATE(858),
    [sym_augmented_assignment_expression] = STATE(858),
    [sym_binary_expression] = STATE(858),
    [sym_unary_expression] = STATE(858),
    [sym_regex] = STATE(858),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(858),
    [sym_as_expression] = STATE(858),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(858),
    [sym_class] = STATE(858),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2691),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2691),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2691),
    [sym_number] = ACTIONS(2693),
    [sym_true] = ACTIONS(2691),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2691),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [609] = {
    [sym_arrow_function] = STATE(859),
    [sym_await_expression] = STATE(859),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(859),
    [sym_meta_property] = STATE(859),
    [sym__expression] = STATE(859),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(859),
    [sym_call_expression] = STATE(859),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(859),
    [sym_string] = STATE(859),
    [sym_template_string] = STATE(859),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(859),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(859),
    [sym_generator_function] = STATE(859),
    [sym_new_expression] = STATE(859),
    [sym_assignment_expression] = STATE(859),
    [sym_augmented_assignment_expression] = STATE(859),
    [sym_binary_expression] = STATE(859),
    [sym_unary_expression] = STATE(859),
    [sym_regex] = STATE(859),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(859),
    [sym_as_expression] = STATE(859),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(859),
    [sym_class] = STATE(859),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2695),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2695),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2695),
    [sym_number] = ACTIONS(2697),
    [sym_true] = ACTIONS(2695),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2695),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [610] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(860),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(761),
    [sym_identifier] = ACTIONS(2699),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [612] = {
    [sym_statement_block] = STATE(862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [613] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(863),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [614] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(865),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(864),
    [sym_type_parameters] = STATE(866),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [615] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2701),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [616] = {
    [sym__automatic_semicolon] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym_COMMA] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
  },
  [617] = {
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_BQUOTE] = ACTIONS(2707),
    [anon_sym_debugger] = ACTIONS(2705),
    [anon_sym_symbol] = ACTIONS(2705),
    [anon_sym_AT] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_void] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [sym_super] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_private] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_get] = ACTIONS(2705),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_interface] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_if] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [sym_true] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_protected] = ACTIONS(2705),
    [anon_sym_abstract] = ACTIONS(2705),
    [anon_sym_set] = ACTIONS(2705),
    [anon_sym_type] = ACTIONS(2705),
    [anon_sym_import] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [sym_false] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_module] = ACTIONS(2705),
    [anon_sym_number] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_declare] = ACTIONS(2705),
    [anon_sym_typeof] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [sym_null] = ACTIONS(2705),
    [anon_sym_any] = ACTIONS(2705),
    [anon_sym_boolean] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_public] = ACTIONS(2705),
    [anon_sym_var] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_LT] = ACTIONS(2707),
    [sym_number] = ACTIONS(2707),
    [anon_sym_SLASH] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2705),
    [anon_sym_function] = ACTIONS(2705),
    [sym_undefined] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [ts_builtin_sym_end] = ACTIONS(2707),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_export] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_with] = ACTIONS(2705),
    [anon_sym_await] = ACTIONS(2705),
  },
  [618] = {
    [sym__automatic_semicolon] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2709),
    [anon_sym_COMMA] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
  },
  [619] = {
    [sym__automatic_semicolon] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_COMMA] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
  },
  [620] = {
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [anon_sym_debugger] = ACTIONS(2713),
    [anon_sym_symbol] = ACTIONS(2713),
    [anon_sym_AT] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_void] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [sym_super] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_private] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_get] = ACTIONS(2713),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_interface] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_if] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
    [anon_sym_yield] = ACTIONS(2713),
    [sym_true] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_protected] = ACTIONS(2713),
    [anon_sym_abstract] = ACTIONS(2713),
    [anon_sym_set] = ACTIONS(2713),
    [anon_sym_type] = ACTIONS(2713),
    [anon_sym_import] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2715),
    [sym_false] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_module] = ACTIONS(2713),
    [anon_sym_number] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_declare] = ACTIONS(2713),
    [anon_sym_typeof] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_LPAREN] = ACTIONS(2715),
    [sym_null] = ACTIONS(2713),
    [anon_sym_any] = ACTIONS(2713),
    [anon_sym_boolean] = ACTIONS(2713),
    [anon_sym_async] = ACTIONS(2713),
    [anon_sym_public] = ACTIONS(2713),
    [anon_sym_var] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_LT] = ACTIONS(2715),
    [sym_number] = ACTIONS(2715),
    [anon_sym_SLASH] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2713),
    [anon_sym_function] = ACTIONS(2713),
    [sym_undefined] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [ts_builtin_sym_end] = ACTIONS(2715),
    [anon_sym_let] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_export] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_with] = ACTIONS(2713),
    [anon_sym_await] = ACTIONS(2713),
  },
  [621] = {
    [aux_sym_variable_declaration_repeat1] = STATE(621),
    [sym__automatic_semicolon] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_COMMA] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
  },
  [622] = {
    [sym__automatic_semicolon] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_COMMA] = ACTIONS(2720),
    [sym_comment] = ACTIONS(3),
  },
  [623] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2722),
    [sym__automatic_semicolon] = ACTIONS(2722),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [anon_sym_PERCENT_EQ] = ACTIONS(2722),
    [anon_sym_AMP_EQ] = ACTIONS(2722),
    [anon_sym_PLUS_EQ] = ACTIONS(2722),
    [anon_sym_PIPE] = ACTIONS(2724),
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_STAR] = ACTIONS(2724),
    [anon_sym_GT_GT_GT] = ACTIONS(2724),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_BANG_EQ] = ACTIONS(2724),
    [anon_sym_GT_EQ] = ACTIONS(2722),
    [anon_sym_CARET_EQ] = ACTIONS(2722),
    [anon_sym_PIPE_EQ] = ACTIONS(2722),
    [anon_sym_DASH_EQ] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_PERCENT] = ACTIONS(2724),
    [anon_sym_LT_LT_EQ] = ACTIONS(2722),
    [anon_sym_as] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_instanceof] = ACTIONS(2722),
    [anon_sym_GT_GT_EQ] = ACTIONS(2722),
    [anon_sym_DOT] = ACTIONS(2722),
    [anon_sym_STAR_STAR] = ACTIONS(2724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2722),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_in] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2722),
    [anon_sym_LT_LT] = ACTIONS(2724),
    [anon_sym_AMP_AMP] = ACTIONS(2722),
    [anon_sym_of] = ACTIONS(2722),
    [anon_sym_LT_EQ] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_GT] = ACTIONS(2724),
    [anon_sym_STAR_EQ] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_PIPE_PIPE] = ACTIONS(2722),
    [anon_sym_EQ_EQ] = ACTIONS(2724),
    [anon_sym_LT] = ACTIONS(2724),
    [anon_sym_SLASH] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2722),
    [anon_sym_CARET] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_GT_GT] = ACTIONS(2724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2722),
  },
  [624] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [sym__automatic_semicolon] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_COMMA] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(2726),
    [anon_sym_STAR] = ACTIONS(2728),
    [anon_sym_GT_GT_GT] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_BANG_EQ] = ACTIONS(2728),
    [anon_sym_LT_EQ] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_GT_EQ] = ACTIONS(2726),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_PERCENT] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_as] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_EQ_EQ] = ACTIONS(2728),
    [anon_sym_instanceof] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_SLASH] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2726),
    [anon_sym_CARET] = ACTIONS(2726),
    [anon_sym_STAR_STAR] = ACTIONS(2726),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2728),
  },
  [625] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(2734),
    [anon_sym_debugger] = ACTIONS(2732),
    [anon_sym_symbol] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2732),
    [anon_sym_void] = ACTIONS(2732),
    [anon_sym_break] = ACTIONS(2732),
    [anon_sym_const] = ACTIONS(2732),
    [sym_super] = ACTIONS(2732),
    [anon_sym_return] = ACTIONS(2732),
    [anon_sym_private] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(2732),
    [anon_sym_get] = ACTIONS(2732),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_interface] = ACTIONS(2732),
    [anon_sym_default] = ACTIONS(2732),
    [anon_sym_enum] = ACTIONS(2732),
    [anon_sym_delete] = ACTIONS(2732),
    [anon_sym_continue] = ACTIONS(2732),
    [anon_sym_DASH_DASH] = ACTIONS(2734),
    [anon_sym_if] = ACTIONS(2732),
    [sym_this] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2732),
    [sym_true] = ACTIONS(2732),
    [anon_sym_throw] = ACTIONS(2732),
    [anon_sym_protected] = ACTIONS(2732),
    [anon_sym_abstract] = ACTIONS(2732),
    [anon_sym_set] = ACTIONS(2732),
    [anon_sym_type] = ACTIONS(2732),
    [anon_sym_import] = ACTIONS(2732),
    [anon_sym_namespace] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2734),
    [anon_sym_DQUOTE] = ACTIONS(2734),
    [anon_sym_else] = ACTIONS(2732),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2734),
    [sym_false] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_case] = ACTIONS(2732),
    [anon_sym_module] = ACTIONS(2732),
    [anon_sym_number] = ACTIONS(2732),
    [anon_sym_class] = ACTIONS(2732),
    [anon_sym_declare] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_switch] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [sym_null] = ACTIONS(2732),
    [anon_sym_any] = ACTIONS(2732),
    [anon_sym_boolean] = ACTIONS(2732),
    [anon_sym_async] = ACTIONS(2732),
    [anon_sym_public] = ACTIONS(2732),
    [anon_sym_var] = ACTIONS(2732),
    [anon_sym_while] = ACTIONS(2732),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2734),
    [sym_number] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2732),
    [anon_sym_function] = ACTIONS(2732),
    [sym_undefined] = ACTIONS(2732),
    [anon_sym_new] = ACTIONS(2732),
    [ts_builtin_sym_end] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2732),
    [anon_sym_export] = ACTIONS(2732),
    [anon_sym_do] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2734),
    [anon_sym_with] = ACTIONS(2732),
    [anon_sym_await] = ACTIONS(2732),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2736),
    [anon_sym_BQUOTE] = ACTIONS(2738),
    [anon_sym_debugger] = ACTIONS(2736),
    [anon_sym_symbol] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2738),
    [anon_sym_DASH] = ACTIONS(2736),
    [anon_sym_void] = ACTIONS(2736),
    [anon_sym_break] = ACTIONS(2736),
    [anon_sym_const] = ACTIONS(2736),
    [sym_super] = ACTIONS(2736),
    [anon_sym_return] = ACTIONS(2736),
    [anon_sym_private] = ACTIONS(2736),
    [anon_sym_static] = ACTIONS(2736),
    [anon_sym_get] = ACTIONS(2736),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_interface] = ACTIONS(2736),
    [anon_sym_default] = ACTIONS(2736),
    [anon_sym_enum] = ACTIONS(2736),
    [anon_sym_delete] = ACTIONS(2736),
    [anon_sym_continue] = ACTIONS(2736),
    [anon_sym_DASH_DASH] = ACTIONS(2738),
    [anon_sym_if] = ACTIONS(2736),
    [sym_this] = ACTIONS(2736),
    [anon_sym_yield] = ACTIONS(2736),
    [sym_true] = ACTIONS(2736),
    [anon_sym_throw] = ACTIONS(2736),
    [anon_sym_protected] = ACTIONS(2736),
    [anon_sym_abstract] = ACTIONS(2736),
    [anon_sym_set] = ACTIONS(2736),
    [anon_sym_type] = ACTIONS(2736),
    [anon_sym_import] = ACTIONS(2736),
    [anon_sym_namespace] = ACTIONS(2736),
    [anon_sym_PLUS_PLUS] = ACTIONS(2738),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [anon_sym_else] = ACTIONS(2736),
    [anon_sym_BANG] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2736),
    [anon_sym_LBRACK] = ACTIONS(2738),
    [sym_false] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_case] = ACTIONS(2736),
    [anon_sym_module] = ACTIONS(2736),
    [anon_sym_number] = ACTIONS(2736),
    [anon_sym_class] = ACTIONS(2736),
    [anon_sym_declare] = ACTIONS(2736),
    [anon_sym_typeof] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2738),
    [anon_sym_switch] = ACTIONS(2736),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [sym_null] = ACTIONS(2736),
    [anon_sym_any] = ACTIONS(2736),
    [anon_sym_boolean] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(2736),
    [anon_sym_public] = ACTIONS(2736),
    [anon_sym_var] = ACTIONS(2736),
    [anon_sym_while] = ACTIONS(2736),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2736),
    [anon_sym_LT] = ACTIONS(2738),
    [sym_number] = ACTIONS(2738),
    [anon_sym_SLASH] = ACTIONS(2736),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2736),
    [anon_sym_function] = ACTIONS(2736),
    [sym_undefined] = ACTIONS(2736),
    [anon_sym_new] = ACTIONS(2736),
    [ts_builtin_sym_end] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2736),
    [anon_sym_export] = ACTIONS(2736),
    [anon_sym_do] = ACTIONS(2736),
    [anon_sym_TILDE] = ACTIONS(2738),
    [anon_sym_with] = ACTIONS(2736),
    [anon_sym_await] = ACTIONS(2736),
  },
  [628] = {
    [sym_object_type] = STATE(868),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(481),
  },
  [629] = {
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_BQUOTE] = ACTIONS(2742),
    [anon_sym_debugger] = ACTIONS(2740),
    [anon_sym_symbol] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2742),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_void] = ACTIONS(2740),
    [anon_sym_break] = ACTIONS(2740),
    [anon_sym_const] = ACTIONS(2740),
    [sym_super] = ACTIONS(2740),
    [anon_sym_return] = ACTIONS(2740),
    [anon_sym_private] = ACTIONS(2740),
    [anon_sym_static] = ACTIONS(2740),
    [anon_sym_get] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_interface] = ACTIONS(2740),
    [anon_sym_default] = ACTIONS(2740),
    [anon_sym_enum] = ACTIONS(2740),
    [anon_sym_delete] = ACTIONS(2740),
    [anon_sym_continue] = ACTIONS(2740),
    [anon_sym_DASH_DASH] = ACTIONS(2742),
    [anon_sym_if] = ACTIONS(2740),
    [sym_this] = ACTIONS(2740),
    [anon_sym_yield] = ACTIONS(2740),
    [sym_true] = ACTIONS(2740),
    [anon_sym_throw] = ACTIONS(2740),
    [anon_sym_protected] = ACTIONS(2740),
    [anon_sym_abstract] = ACTIONS(2740),
    [anon_sym_set] = ACTIONS(2740),
    [anon_sym_type] = ACTIONS(2740),
    [anon_sym_import] = ACTIONS(2740),
    [anon_sym_namespace] = ACTIONS(2740),
    [anon_sym_PLUS_PLUS] = ACTIONS(2742),
    [anon_sym_DQUOTE] = ACTIONS(2742),
    [anon_sym_else] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2742),
    [anon_sym_for] = ACTIONS(2740),
    [anon_sym_LBRACK] = ACTIONS(2742),
    [sym_false] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_case] = ACTIONS(2740),
    [anon_sym_module] = ACTIONS(2740),
    [anon_sym_number] = ACTIONS(2740),
    [anon_sym_class] = ACTIONS(2740),
    [anon_sym_declare] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(2742),
    [anon_sym_switch] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(2742),
    [sym_null] = ACTIONS(2740),
    [anon_sym_any] = ACTIONS(2740),
    [anon_sym_boolean] = ACTIONS(2740),
    [anon_sym_async] = ACTIONS(2740),
    [anon_sym_public] = ACTIONS(2740),
    [anon_sym_var] = ACTIONS(2740),
    [anon_sym_while] = ACTIONS(2740),
    [anon_sym_SQUOTE] = ACTIONS(2742),
    [anon_sym_try] = ACTIONS(2740),
    [anon_sym_LT] = ACTIONS(2742),
    [sym_number] = ACTIONS(2742),
    [anon_sym_SLASH] = ACTIONS(2740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2740),
    [anon_sym_function] = ACTIONS(2740),
    [sym_undefined] = ACTIONS(2740),
    [anon_sym_new] = ACTIONS(2740),
    [ts_builtin_sym_end] = ACTIONS(2742),
    [anon_sym_let] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_export] = ACTIONS(2740),
    [anon_sym_do] = ACTIONS(2740),
    [anon_sym_TILDE] = ACTIONS(2742),
    [anon_sym_with] = ACTIONS(2740),
    [anon_sym_await] = ACTIONS(2740),
  },
  [630] = {
    [sym__initializer] = STATE(871),
    [aux_sym_enum_body_repeat1] = STATE(872),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [aux_sym_enum_body_repeat1] = STATE(872),
    [anon_sym_RBRACE] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2746),
    [sym_comment] = ACTIONS(3),
  },
  [632] = {
    [sym_generator_function_declaration] = STATE(873),
    [sym__declaration] = STATE(873),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(873),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(873),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(873),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(873),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(873),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(873),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(873),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(873),
    [sym_function_declaration] = STATE(873),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(873),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(873),
    [sym_break_statement] = STATE(873),
    [sym_labeled_statement] = STATE(873),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(873),
    [sym_class_declaration] = STATE(873),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(873),
    [sym_ambient_declaration] = STATE(873),
    [sym_type_alias_declaration] = STATE(873),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(873),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(873),
    [sym_switch_statement] = STATE(873),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(873),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(873),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(873),
    [sym_abstract_class_declaration] = STATE(873),
    [sym_interface_declaration] = STATE(873),
    [sym_export_statement] = STATE(873),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(873),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(873),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(873),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(873),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [633] = {
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_BQUOTE] = ACTIONS(2750),
    [anon_sym_debugger] = ACTIONS(2748),
    [anon_sym_symbol] = ACTIONS(2748),
    [anon_sym_AT] = ACTIONS(2750),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(2748),
    [anon_sym_break] = ACTIONS(2748),
    [anon_sym_const] = ACTIONS(2748),
    [sym_super] = ACTIONS(2748),
    [anon_sym_return] = ACTIONS(2748),
    [anon_sym_private] = ACTIONS(2748),
    [anon_sym_static] = ACTIONS(2748),
    [anon_sym_get] = ACTIONS(2748),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_interface] = ACTIONS(2748),
    [anon_sym_default] = ACTIONS(2748),
    [anon_sym_enum] = ACTIONS(2748),
    [anon_sym_delete] = ACTIONS(2748),
    [anon_sym_continue] = ACTIONS(2748),
    [anon_sym_DASH_DASH] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2748),
    [sym_this] = ACTIONS(2748),
    [anon_sym_yield] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [anon_sym_throw] = ACTIONS(2748),
    [anon_sym_protected] = ACTIONS(2748),
    [anon_sym_abstract] = ACTIONS(2748),
    [anon_sym_set] = ACTIONS(2748),
    [anon_sym_type] = ACTIONS(2748),
    [anon_sym_import] = ACTIONS(2748),
    [anon_sym_namespace] = ACTIONS(2748),
    [anon_sym_PLUS_PLUS] = ACTIONS(2750),
    [anon_sym_DQUOTE] = ACTIONS(2750),
    [anon_sym_else] = ACTIONS(2748),
    [anon_sym_BANG] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2748),
    [anon_sym_LBRACK] = ACTIONS(2750),
    [sym_false] = ACTIONS(2748),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_case] = ACTIONS(2748),
    [anon_sym_module] = ACTIONS(2748),
    [anon_sym_number] = ACTIONS(2748),
    [anon_sym_class] = ACTIONS(2748),
    [anon_sym_declare] = ACTIONS(2748),
    [anon_sym_typeof] = ACTIONS(2748),
    [anon_sym_LBRACE] = ACTIONS(2750),
    [anon_sym_switch] = ACTIONS(2748),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [sym_null] = ACTIONS(2748),
    [anon_sym_any] = ACTIONS(2748),
    [anon_sym_boolean] = ACTIONS(2748),
    [anon_sym_async] = ACTIONS(2748),
    [anon_sym_public] = ACTIONS(2748),
    [anon_sym_var] = ACTIONS(2748),
    [anon_sym_while] = ACTIONS(2748),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2748),
    [anon_sym_LT] = ACTIONS(2750),
    [sym_number] = ACTIONS(2750),
    [anon_sym_SLASH] = ACTIONS(2748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2748),
    [sym_undefined] = ACTIONS(2748),
    [anon_sym_new] = ACTIONS(2748),
    [ts_builtin_sym_end] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2748),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_export] = ACTIONS(2748),
    [anon_sym_do] = ACTIONS(2748),
    [anon_sym_TILDE] = ACTIONS(2750),
    [anon_sym_with] = ACTIONS(2748),
    [anon_sym_await] = ACTIONS(2748),
  },
  [634] = {
    [sym_class_body] = STATE(874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1871),
  },
  [635] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(875),
    [sym_class_heritage] = STATE(876),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1871),
  },
  [636] = {
    [sym__automatic_semicolon] = ACTIONS(2752),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_PIPE] = ACTIONS(2756),
    [sym_comment] = ACTIONS(3),
  },
  [637] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(878),
    [sym_function_type] = STATE(878),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(878),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(878),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(878),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [638] = {
    [anon_sym_from] = ACTIONS(2758),
    [sym_comment] = ACTIONS(3),
  },
  [639] = {
    [anon_sym_LPAREN] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
  },
  [640] = {
    [sym__automatic_semicolon] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_DOT] = ACTIONS(2764),
    [sym_comment] = ACTIONS(3),
  },
  [641] = {
    [anon_sym_require] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
  },
  [642] = {
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_BQUOTE] = ACTIONS(2770),
    [anon_sym_debugger] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2770),
    [anon_sym_DASH] = ACTIONS(2768),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_break] = ACTIONS(2768),
    [anon_sym_const] = ACTIONS(2768),
    [sym_super] = ACTIONS(2768),
    [anon_sym_return] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_interface] = ACTIONS(2768),
    [anon_sym_default] = ACTIONS(2768),
    [anon_sym_enum] = ACTIONS(2768),
    [anon_sym_delete] = ACTIONS(2768),
    [anon_sym_continue] = ACTIONS(2768),
    [anon_sym_DASH_DASH] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2768),
    [sym_this] = ACTIONS(2768),
    [anon_sym_yield] = ACTIONS(2768),
    [sym_true] = ACTIONS(2768),
    [anon_sym_throw] = ACTIONS(2768),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [anon_sym_PLUS_PLUS] = ACTIONS(2770),
    [anon_sym_DQUOTE] = ACTIONS(2770),
    [anon_sym_else] = ACTIONS(2768),
    [anon_sym_BANG] = ACTIONS(2770),
    [anon_sym_for] = ACTIONS(2768),
    [anon_sym_LBRACK] = ACTIONS(2770),
    [sym_false] = ACTIONS(2768),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_case] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_class] = ACTIONS(2768),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_typeof] = ACTIONS(2768),
    [anon_sym_LBRACE] = ACTIONS(2770),
    [anon_sym_switch] = ACTIONS(2768),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [sym_null] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_var] = ACTIONS(2768),
    [anon_sym_while] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_try] = ACTIONS(2768),
    [anon_sym_LT] = ACTIONS(2770),
    [sym_number] = ACTIONS(2770),
    [anon_sym_SLASH] = ACTIONS(2768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_function] = ACTIONS(2768),
    [sym_undefined] = ACTIONS(2768),
    [anon_sym_new] = ACTIONS(2768),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [anon_sym_let] = ACTIONS(2768),
    [anon_sym_PLUS] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_do] = ACTIONS(2768),
    [anon_sym_TILDE] = ACTIONS(2770),
    [anon_sym_with] = ACTIONS(2768),
    [anon_sym_await] = ACTIONS(2768),
  },
  [643] = {
    [sym__automatic_semicolon] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2772),
    [sym_comment] = ACTIONS(3),
  },
  [644] = {
    [anon_sym_from] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
  },
  [646] = {
    [anon_sym_RBRACE] = ACTIONS(2778),
    [anon_sym_COMMA] = ACTIONS(2778),
    [anon_sym_as] = ACTIONS(2780),
    [sym_comment] = ACTIONS(3),
  },
  [647] = {
    [anon_sym_from] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [sym__import_export_specifier] = STATE(885),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [649] = {
    [anon_sym_from] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
  },
  [650] = {
    [aux_sym_named_imports_repeat1] = STATE(887),
    [anon_sym_COMMA] = ACTIONS(2788),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [sym_comment] = ACTIONS(3),
  },
  [651] = {
    [sym__automatic_semicolon] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2790),
  },
  [652] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2792),
    [sym__automatic_semicolon] = ACTIONS(2792),
    [anon_sym_BQUOTE] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_GT_GT_GT] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_return] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_PERCENT] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2794),
    [anon_sym_as] = ACTIONS(2794),
    [anon_sym_delete] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_instanceof] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2794),
    [sym_true] = ACTIONS(2794),
    [anon_sym_protected] = ACTIONS(2794),
    [anon_sym_DOT] = ACTIONS(2794),
    [anon_sym_set] = ACTIONS(2794),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2792),
    [anon_sym_import] = ACTIONS(2794),
    [anon_sym_in] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2794),
    [anon_sym_typeof] = ACTIONS(2794),
    [anon_sym_LT_LT] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_AMP_AMP] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2792),
    [sym_null] = ACTIONS(2794),
    [anon_sym_any] = ACTIONS(2794),
    [anon_sym_async] = ACTIONS(2794),
    [anon_sym_public] = ACTIONS(2794),
    [anon_sym_var] = ACTIONS(2794),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2792),
    [anon_sym_SLASH] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2794),
    [anon_sym_CARET] = ACTIONS(2792),
    [anon_sym_export] = ACTIONS(2794),
    [anon_sym_GT_GT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2792),
    [sym_identifier] = ACTIONS(2794),
    [anon_sym_debugger] = ACTIONS(2794),
    [anon_sym_AT] = ACTIONS(2792),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2794),
    [anon_sym_const] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2792),
    [sym_super] = ACTIONS(2794),
    [anon_sym_private] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2794),
    [anon_sym_default] = ACTIONS(2794),
    [anon_sym_enum] = ACTIONS(2794),
    [anon_sym_continue] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2792),
    [sym_this] = ACTIONS(2794),
    [anon_sym_throw] = ACTIONS(2794),
    [anon_sym_abstract] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2794),
    [anon_sym_STAR_STAR] = ACTIONS(2792),
    [anon_sym_namespace] = ACTIONS(2794),
    [anon_sym_PLUS_PLUS] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2794),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [sym_false] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_module] = ACTIONS(2794),
    [anon_sym_class] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_boolean] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2794),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [sym_number] = ACTIONS(2792),
    [ts_builtin_sym_end] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2794),
    [sym_undefined] = ACTIONS(2794),
    [anon_sym_let] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2792),
    [anon_sym_await] = ACTIONS(2794),
  },
  [653] = {
    [sym_arrow_function] = STATE(889),
    [sym_await_expression] = STATE(889),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(888),
    [sym_meta_property] = STATE(889),
    [sym_update_expression] = STATE(889),
    [sym__expression] = STATE(889),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(889),
    [sym_call_expression] = STATE(889),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(889),
    [sym_string] = STATE(889),
    [sym_template_string] = STATE(889),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(889),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(889),
    [sym_generator_function] = STATE(889),
    [sym_new_expression] = STATE(889),
    [sym_assignment_expression] = STATE(889),
    [sym_augmented_assignment_expression] = STATE(889),
    [sym_binary_expression] = STATE(889),
    [sym_unary_expression] = STATE(889),
    [sym_regex] = STATE(889),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(889),
    [sym_as_expression] = STATE(889),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(889),
    [sym_class] = STATE(889),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2796),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2796),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2796),
    [sym_number] = ACTIONS(2798),
    [sym_true] = ACTIONS(2796),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2796),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [654] = {
    [sym_arrow_function] = STATE(891),
    [sym_await_expression] = STATE(891),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(890),
    [sym_meta_property] = STATE(891),
    [sym_update_expression] = STATE(891),
    [sym__expression] = STATE(891),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(891),
    [sym_call_expression] = STATE(891),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(891),
    [sym_string] = STATE(891),
    [sym_template_string] = STATE(891),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(891),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(891),
    [sym_generator_function] = STATE(891),
    [sym_new_expression] = STATE(891),
    [sym_assignment_expression] = STATE(891),
    [sym_augmented_assignment_expression] = STATE(891),
    [sym_binary_expression] = STATE(891),
    [sym_unary_expression] = STATE(891),
    [sym_regex] = STATE(891),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(891),
    [sym_as_expression] = STATE(891),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(891),
    [sym_class] = STATE(891),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2800),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2800),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2800),
    [sym_number] = ACTIONS(2802),
    [sym_true] = ACTIONS(2800),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2800),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [655] = {
    [sym__initializer] = STATE(327),
    [sym_type_annotation] = STATE(328),
    [sym__automatic_semicolon] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(738),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(738),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2804),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2806),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [656] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_of] = ACTIONS(2813),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [657] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2822),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(525),
  },
  [658] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(2822),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [659] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_of] = ACTIONS(2822),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [660] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_of] = ACTIONS(2806),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [661] = {
    [sym__initializer] = STATE(330),
    [sym_type_annotation] = STATE(331),
    [sym__automatic_semicolon] = ACTIONS(746),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(746),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2828),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2830),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [662] = {
    [sym__initializer] = STATE(335),
    [sym_type_annotation] = STATE(336),
    [sym__automatic_semicolon] = ACTIONS(752),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(752),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(752),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_of] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [663] = {
    [sym_arrow_function] = STATE(901),
    [sym_await_expression] = STATE(901),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(900),
    [sym_meta_property] = STATE(901),
    [sym_update_expression] = STATE(901),
    [sym__expression] = STATE(901),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(901),
    [sym_call_expression] = STATE(901),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(901),
    [sym_string] = STATE(901),
    [sym_template_string] = STATE(901),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(901),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(901),
    [sym_generator_function] = STATE(901),
    [sym_new_expression] = STATE(901),
    [sym_assignment_expression] = STATE(901),
    [sym_augmented_assignment_expression] = STATE(901),
    [sym_binary_expression] = STATE(901),
    [sym_unary_expression] = STATE(901),
    [sym_regex] = STATE(901),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(901),
    [sym_as_expression] = STATE(901),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(901),
    [sym_class] = STATE(901),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2842),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2842),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2846),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [664] = {
    [sym_arrow_function] = STATE(903),
    [sym_await_expression] = STATE(903),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(902),
    [sym_meta_property] = STATE(903),
    [sym_update_expression] = STATE(903),
    [sym__expression] = STATE(903),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(903),
    [sym_call_expression] = STATE(903),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(903),
    [sym_string] = STATE(903),
    [sym_template_string] = STATE(903),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(903),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(903),
    [sym_generator_function] = STATE(903),
    [sym_new_expression] = STATE(903),
    [sym_assignment_expression] = STATE(903),
    [sym_augmented_assignment_expression] = STATE(903),
    [sym_binary_expression] = STATE(903),
    [sym_unary_expression] = STATE(903),
    [sym_regex] = STATE(903),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(903),
    [sym_as_expression] = STATE(903),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(903),
    [sym_class] = STATE(903),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2848),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2848),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2848),
    [sym_number] = ACTIONS(2850),
    [sym_true] = ACTIONS(2848),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2848),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [665] = {
    [sym_arrow_function] = STATE(905),
    [sym_await_expression] = STATE(905),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(904),
    [sym_meta_property] = STATE(905),
    [sym_update_expression] = STATE(905),
    [sym__expression] = STATE(905),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(905),
    [sym_call_expression] = STATE(905),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(905),
    [sym_string] = STATE(905),
    [sym_template_string] = STATE(905),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(905),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(905),
    [sym_generator_function] = STATE(905),
    [sym_new_expression] = STATE(905),
    [sym_assignment_expression] = STATE(905),
    [sym_augmented_assignment_expression] = STATE(905),
    [sym_binary_expression] = STATE(905),
    [sym_unary_expression] = STATE(905),
    [sym_regex] = STATE(905),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(905),
    [sym_as_expression] = STATE(905),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(905),
    [sym_class] = STATE(905),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(2852),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2852),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2852),
    [sym_number] = ACTIONS(2854),
    [sym_true] = ACTIONS(2852),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2852),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [666] = {
    [sym_arrow_function] = STATE(1854),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(660),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1854),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1854),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(660),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1854),
    [sym_template_string] = STATE(1854),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(907),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1854),
    [sym_new_expression] = STATE(1854),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1854),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(660),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(908),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1854),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(2856),
    [sym_false] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1971),
    [anon_sym_symbol] = ACTIONS(1971),
    [anon_sym_number] = ACTIONS(1971),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1971),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1969),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1971),
    [anon_sym_private] = ACTIONS(1971),
    [anon_sym_boolean] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_public] = ACTIONS(1971),
    [anon_sym_get] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1969),
    [sym_number] = ACTIONS(1977),
    [sym_true] = ACTIONS(1969),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1971),
    [anon_sym_string] = ACTIONS(1971),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1969),
    [anon_sym_set] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1971),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2858),
    [anon_sym_BQUOTE] = ACTIONS(2860),
    [anon_sym_debugger] = ACTIONS(2858),
    [anon_sym_symbol] = ACTIONS(2858),
    [anon_sym_AT] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2858),
    [anon_sym_void] = ACTIONS(2858),
    [anon_sym_break] = ACTIONS(2858),
    [anon_sym_const] = ACTIONS(2858),
    [sym_super] = ACTIONS(2858),
    [anon_sym_return] = ACTIONS(2858),
    [anon_sym_private] = ACTIONS(2858),
    [anon_sym_static] = ACTIONS(2858),
    [anon_sym_get] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2860),
    [anon_sym_interface] = ACTIONS(2858),
    [anon_sym_default] = ACTIONS(2858),
    [anon_sym_enum] = ACTIONS(2858),
    [anon_sym_delete] = ACTIONS(2858),
    [anon_sym_continue] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2860),
    [anon_sym_if] = ACTIONS(2858),
    [sym_this] = ACTIONS(2858),
    [anon_sym_yield] = ACTIONS(2858),
    [sym_true] = ACTIONS(2858),
    [anon_sym_throw] = ACTIONS(2858),
    [anon_sym_protected] = ACTIONS(2858),
    [anon_sym_abstract] = ACTIONS(2858),
    [anon_sym_set] = ACTIONS(2858),
    [anon_sym_type] = ACTIONS(2858),
    [anon_sym_import] = ACTIONS(2858),
    [anon_sym_namespace] = ACTIONS(2858),
    [anon_sym_PLUS_PLUS] = ACTIONS(2860),
    [anon_sym_DQUOTE] = ACTIONS(2860),
    [anon_sym_else] = ACTIONS(2858),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_for] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [sym_false] = ACTIONS(2858),
    [anon_sym_SEMI] = ACTIONS(2860),
    [anon_sym_case] = ACTIONS(2858),
    [anon_sym_module] = ACTIONS(2858),
    [anon_sym_number] = ACTIONS(2858),
    [anon_sym_class] = ACTIONS(2858),
    [anon_sym_declare] = ACTIONS(2858),
    [anon_sym_typeof] = ACTIONS(2858),
    [anon_sym_LBRACE] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(2860),
    [sym_null] = ACTIONS(2858),
    [anon_sym_any] = ACTIONS(2858),
    [anon_sym_boolean] = ACTIONS(2858),
    [anon_sym_async] = ACTIONS(2858),
    [anon_sym_public] = ACTIONS(2858),
    [anon_sym_var] = ACTIONS(2858),
    [anon_sym_while] = ACTIONS(2858),
    [anon_sym_SQUOTE] = ACTIONS(2860),
    [anon_sym_try] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2860),
    [sym_number] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2858),
    [anon_sym_function] = ACTIONS(2858),
    [sym_undefined] = ACTIONS(2858),
    [anon_sym_new] = ACTIONS(2858),
    [ts_builtin_sym_end] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2858),
    [anon_sym_export] = ACTIONS(2858),
    [anon_sym_do] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2860),
    [anon_sym_with] = ACTIONS(2858),
    [anon_sym_await] = ACTIONS(2858),
  },
  [668] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2862),
    [sym__automatic_semicolon] = ACTIONS(2862),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2864),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_GT_GT_GT] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(2864),
    [anon_sym_BANG_EQ] = ACTIONS(2864),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_PERCENT] = ACTIONS(2862),
    [anon_sym_as] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_instanceof] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [anon_sym_DOT] = ACTIONS(2862),
    [anon_sym_STAR_STAR] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_in] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_LT_LT] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_of] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(2864),
    [anon_sym_AMP] = ACTIONS(2864),
    [anon_sym_QMARK] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_EQ_EQ] = ACTIONS(2864),
    [anon_sym_LT] = ACTIONS(2864),
    [anon_sym_SLASH] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_GT_GT] = ACTIONS(2864),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2862),
  },
  [669] = {
    [sym_arrow_function] = STATE(911),
    [sym_await_expression] = STATE(911),
    [sym_member_expression] = STATE(2579),
    [sym_generic_type] = STATE(910),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(911),
    [sym_meta_property] = STATE(911),
    [sym__expression] = STATE(911),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(912),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(911),
    [sym_call_expression] = STATE(911),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(911),
    [sym_string] = STATE(911),
    [sym_template_string] = STATE(911),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(911),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(911),
    [sym_generator_function] = STATE(911),
    [sym_new_expression] = STATE(911),
    [sym_assignment_expression] = STATE(911),
    [sym_augmented_assignment_expression] = STATE(911),
    [sym_binary_expression] = STATE(911),
    [sym_unary_expression] = STATE(911),
    [sym_regex] = STATE(911),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(911),
    [sym_as_expression] = STATE(911),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(911),
    [sym_class] = STATE(911),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(2866),
    [sym_false] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2868),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(2868),
    [sym_number] = ACTIONS(2870),
    [sym_true] = ACTIONS(2868),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2868),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [670] = {
    [sym_identifier] = ACTIONS(2872),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [aux_sym_extends_clause_repeat1] = STATE(914),
    [anon_sym_implements] = ACTIONS(2874),
    [anon_sym_COMMA] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2874),
  },
  [672] = {
    [aux_sym_extends_clause_repeat1] = STATE(914),
    [anon_sym_implements] = ACTIONS(2876),
    [anon_sym_COMMA] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2876),
  },
  [673] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [674] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2878),
  },
  [675] = {
    [sym_identifier] = ACTIONS(2880),
    [anon_sym_BQUOTE] = ACTIONS(2882),
    [anon_sym_debugger] = ACTIONS(2880),
    [anon_sym_symbol] = ACTIONS(2880),
    [anon_sym_AT] = ACTIONS(2882),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_void] = ACTIONS(2880),
    [anon_sym_break] = ACTIONS(2880),
    [anon_sym_const] = ACTIONS(2880),
    [sym_super] = ACTIONS(2880),
    [anon_sym_return] = ACTIONS(2880),
    [anon_sym_private] = ACTIONS(2880),
    [anon_sym_static] = ACTIONS(2880),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_interface] = ACTIONS(2880),
    [anon_sym_default] = ACTIONS(2880),
    [anon_sym_enum] = ACTIONS(2880),
    [anon_sym_delete] = ACTIONS(2880),
    [anon_sym_continue] = ACTIONS(2880),
    [anon_sym_DASH_DASH] = ACTIONS(2882),
    [anon_sym_if] = ACTIONS(2880),
    [sym_this] = ACTIONS(2880),
    [anon_sym_yield] = ACTIONS(2880),
    [sym_true] = ACTIONS(2880),
    [anon_sym_throw] = ACTIONS(2880),
    [anon_sym_protected] = ACTIONS(2880),
    [anon_sym_abstract] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_type] = ACTIONS(2880),
    [anon_sym_import] = ACTIONS(2880),
    [anon_sym_namespace] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2882),
    [anon_sym_DQUOTE] = ACTIONS(2882),
    [anon_sym_else] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(2882),
    [anon_sym_for] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(2882),
    [sym_false] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2882),
    [anon_sym_case] = ACTIONS(2880),
    [anon_sym_module] = ACTIONS(2880),
    [anon_sym_number] = ACTIONS(2880),
    [anon_sym_class] = ACTIONS(2880),
    [anon_sym_declare] = ACTIONS(2880),
    [anon_sym_typeof] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_switch] = ACTIONS(2880),
    [anon_sym_LPAREN] = ACTIONS(2882),
    [sym_null] = ACTIONS(2880),
    [anon_sym_any] = ACTIONS(2880),
    [anon_sym_boolean] = ACTIONS(2880),
    [anon_sym_async] = ACTIONS(2880),
    [anon_sym_public] = ACTIONS(2880),
    [anon_sym_var] = ACTIONS(2880),
    [anon_sym_while] = ACTIONS(2880),
    [anon_sym_SQUOTE] = ACTIONS(2882),
    [anon_sym_try] = ACTIONS(2880),
    [anon_sym_LT] = ACTIONS(2882),
    [sym_number] = ACTIONS(2882),
    [anon_sym_SLASH] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2880),
    [anon_sym_function] = ACTIONS(2880),
    [sym_undefined] = ACTIONS(2880),
    [anon_sym_new] = ACTIONS(2880),
    [ts_builtin_sym_end] = ACTIONS(2882),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_PLUS] = ACTIONS(2880),
    [anon_sym_export] = ACTIONS(2880),
    [anon_sym_do] = ACTIONS(2880),
    [anon_sym_TILDE] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2880),
    [anon_sym_await] = ACTIONS(2880),
  },
  [676] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2884),
    [sym__automatic_semicolon] = ACTIONS(2886),
    [anon_sym_BQUOTE] = ACTIONS(2888),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_GT_GT_GT] = ACTIONS(2884),
    [anon_sym_break] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2892),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_interface] = ACTIONS(2890),
    [anon_sym_as] = ACTIONS(2892),
    [anon_sym_delete] = ACTIONS(2890),
    [anon_sym_if] = ACTIONS(2890),
    [anon_sym_instanceof] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_import] = ACTIONS(2890),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_DQUOTE] = ACTIONS(2888),
    [anon_sym_for] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_typeof] = ACTIONS(2890),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2888),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_switch] = ACTIONS(2890),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [sym_null] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_var] = ACTIONS(2890),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2890),
    [anon_sym_SQUOTE] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_new] = ACTIONS(2890),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_export] = ACTIONS(2890),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_with] = ACTIONS(2890),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2884),
    [sym_identifier] = ACTIONS(2890),
    [anon_sym_debugger] = ACTIONS(2890),
    [anon_sym_AT] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2890),
    [anon_sym_void] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2890),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [sym_super] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_default] = ACTIONS(2890),
    [anon_sym_enum] = ACTIONS(2890),
    [anon_sym_continue] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2888),
    [sym_this] = ACTIONS(2890),
    [anon_sym_throw] = ACTIONS(2890),
    [anon_sym_abstract] = ACTIONS(2890),
    [anon_sym_type] = ACTIONS(2890),
    [anon_sym_STAR_STAR] = ACTIONS(2884),
    [anon_sym_namespace] = ACTIONS(2890),
    [anon_sym_PLUS_PLUS] = ACTIONS(2888),
    [anon_sym_else] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(2890),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_false] = ACTIONS(2890),
    [anon_sym_case] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2890),
    [anon_sym_class] = ACTIONS(2890),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2888),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_try] = ACTIONS(2890),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2890),
    [sym_number] = ACTIONS(2888),
    [ts_builtin_sym_end] = ACTIONS(2888),
    [anon_sym_function] = ACTIONS(2890),
    [sym_undefined] = ACTIONS(2890),
    [anon_sym_let] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2890),
    [anon_sym_do] = ACTIONS(2890),
    [anon_sym_TILDE] = ACTIONS(2888),
    [anon_sym_await] = ACTIONS(2890),
  },
  [677] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2894),
    [sym__automatic_semicolon] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2894),
    [anon_sym_break] = ACTIONS(2900),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_PERCENT] = ACTIONS(2894),
    [anon_sym_interface] = ACTIONS(2900),
    [anon_sym_as] = ACTIONS(2902),
    [anon_sym_delete] = ACTIONS(2900),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_instanceof] = ACTIONS(2902),
    [anon_sym_yield] = ACTIONS(2900),
    [sym_true] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_DOT] = ACTIONS(2902),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_typeof] = ACTIONS(2900),
    [anon_sym_LT_LT] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2900),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [sym_null] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_var] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_new] = ACTIONS(2900),
    [anon_sym_CARET] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_with] = ACTIONS(2900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2894),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_debugger] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2898),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2900),
    [anon_sym_void] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [sym_super] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_enum] = ACTIONS(2900),
    [anon_sym_continue] = ACTIONS(2900),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [sym_this] = ACTIONS(2900),
    [anon_sym_throw] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_STAR_STAR] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [sym_false] = ACTIONS(2900),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_class] = ACTIONS(2900),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2900),
    [sym_number] = ACTIONS(2898),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_function] = ACTIONS(2900),
    [sym_undefined] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2898),
    [anon_sym_await] = ACTIONS(2900),
  },
  [678] = {
    [sym_class_body] = STATE(917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [679] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(919),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [680] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [681] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [682] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [683] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [684] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [685] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2912),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [686] = {
    [anon_sym_RBRACK] = ACTIONS(2914),
    [sym_comment] = ACTIONS(3),
  },
  [687] = {
    [sym_string] = STATE(925),
    [sym__property_name] = STATE(925),
    [sym_computed_property_name] = STATE(925),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [688] = {
    [sym_string] = STATE(926),
    [sym__property_name] = STATE(926),
    [sym_computed_property_name] = STATE(926),
    [anon_sym_get] = ACTIONS(960),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(960),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [689] = {
    [sym_string] = STATE(925),
    [sym__property_name] = STATE(925),
    [sym_computed_property_name] = STATE(925),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [690] = {
    [sym_type_annotation] = STATE(931),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(930),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(929),
    [sym__automatic_semicolon] = ACTIONS(2920),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2924),
  },
  [691] = {
    [sym_string] = STATE(932),
    [sym__property_name] = STATE(932),
    [sym_computed_property_name] = STATE(932),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [692] = {
    [sym_string] = STATE(932),
    [sym__property_name] = STATE(932),
    [sym_computed_property_name] = STATE(932),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [693] = {
    [sym_string] = STATE(932),
    [sym__property_name] = STATE(932),
    [sym_computed_property_name] = STATE(932),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(2930),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(2930),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [694] = {
    [sym_type_annotation] = STATE(931),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(930),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(919),
    [sym__automatic_semicolon] = ACTIONS(2920),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2920),
    [anon_sym_QMARK] = ACTIONS(2932),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2924),
  },
  [695] = {
    [sym_string] = STATE(937),
    [sym__property_name] = STATE(937),
    [sym_computed_property_name] = STATE(937),
    [anon_sym_get] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2936),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [696] = {
    [anon_sym_LBRACK] = ACTIONS(2940),
    [sym_identifier] = ACTIONS(2942),
    [anon_sym_module] = ACTIONS(2942),
    [anon_sym_symbol] = ACTIONS(2942),
    [anon_sym_number] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2940),
    [anon_sym_declare] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2940),
    [anon_sym_void] = ACTIONS(2942),
    [anon_sym_any] = ACTIONS(2942),
    [anon_sym_private] = ACTIONS(2942),
    [anon_sym_boolean] = ACTIONS(2942),
    [anon_sym_static] = ACTIONS(2942),
    [anon_sym_public] = ACTIONS(2942),
    [anon_sym_get] = ACTIONS(2942),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_SQUOTE] = ACTIONS(2940),
    [sym_number] = ACTIONS(2940),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2942),
    [anon_sym_string] = ACTIONS(2942),
    [anon_sym_abstract] = ACTIONS(2942),
    [anon_sym_set] = ACTIONS(2942),
    [anon_sym_type] = ACTIONS(2942),
    [anon_sym_export] = ACTIONS(2942),
    [sym_readonly] = ACTIONS(2942),
    [anon_sym_namespace] = ACTIONS(2942),
    [anon_sym_DQUOTE] = ACTIONS(2940),
  },
  [697] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2944),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_GT_GT_GT] = ACTIONS(2944),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_instanceof] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2944),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2944),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2944),
  },
  [698] = {
    [sym_abstract_method_signature] = STATE(414),
    [sym_index_signature] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_computed_property_name] = STATE(418),
    [sym_decorator] = STATE(698),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym_string] = STATE(418),
    [sym_method_signature] = STATE(414),
    [anon_sym_LBRACK] = ACTIONS(2948),
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_symbol] = ACTIONS(2951),
    [anon_sym_number] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2954),
    [anon_sym_declare] = ACTIONS(2951),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_void] = ACTIONS(2951),
    [anon_sym_any] = ACTIONS(2951),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_boolean] = ACTIONS(2951),
    [anon_sym_static] = ACTIONS(2963),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_get] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_async] = ACTIONS(2969),
    [anon_sym_SQUOTE] = ACTIONS(2972),
    [sym_number] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_string] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2978),
    [anon_sym_set] = ACTIONS(2966),
    [anon_sym_type] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [sym_readonly] = ACTIONS(2981),
    [anon_sym_namespace] = ACTIONS(2951),
    [anon_sym_DQUOTE] = ACTIONS(2984),
  },
  [699] = {
    [sym_string] = STATE(937),
    [sym__property_name] = STATE(937),
    [sym_computed_property_name] = STATE(937),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(2936),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2987),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [700] = {
    [sym_string] = STATE(937),
    [sym__property_name] = STATE(937),
    [sym_computed_property_name] = STATE(937),
    [anon_sym_get] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(2936),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [701] = {
    [sym_string] = STATE(942),
    [sym__property_name] = STATE(942),
    [sym_computed_property_name] = STATE(942),
    [anon_sym_get] = ACTIONS(2991),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(2993),
    [anon_sym_STAR] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(2991),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(2989),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
  },
  [702] = {
    [sym_type_annotation] = STATE(945),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(944),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(943),
    [sym__automatic_semicolon] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
  },
  [703] = {
    [sym__initializer] = STATE(944),
    [sym_type_annotation] = STATE(945),
    [sym__automatic_semicolon] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
  },
  [704] = {
    [sym_statement_block] = STATE(1464),
    [sym__automatic_semicolon] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [705] = {
    [sym__automatic_semicolon] = ACTIONS(3003),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3003),
    [sym_comment] = ACTIONS(3),
  },
  [706] = {
    [sym__initializer] = STATE(946),
    [sym__automatic_semicolon] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3005),
    [sym_comment] = ACTIONS(3),
  },
  [707] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [sym__automatic_semicolon] = ACTIONS(3007),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_STAR] = ACTIONS(3009),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_BANG_EQ] = ACTIONS(3009),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3009),
    [anon_sym_instanceof] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_STAR_STAR] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_GT_GT] = ACTIONS(3009),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG] = ACTIONS(3009),
  },
  [708] = {
    [anon_sym_COLON] = ACTIONS(3011),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [sym__automatic_semicolon] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2071),
    [anon_sym_BQUOTE] = ACTIONS(2069),
    [anon_sym_debugger] = ACTIONS(2071),
    [anon_sym_symbol] = ACTIONS(2071),
    [anon_sym_AT] = ACTIONS(2069),
    [anon_sym_DASH] = ACTIONS(2071),
    [anon_sym_void] = ACTIONS(2071),
    [anon_sym_break] = ACTIONS(2071),
    [anon_sym_const] = ACTIONS(2071),
    [sym_super] = ACTIONS(2071),
    [anon_sym_return] = ACTIONS(2071),
    [anon_sym_private] = ACTIONS(2071),
    [anon_sym_static] = ACTIONS(2071),
    [anon_sym_get] = ACTIONS(2071),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_interface] = ACTIONS(2071),
    [anon_sym_default] = ACTIONS(2071),
    [anon_sym_enum] = ACTIONS(2071),
    [anon_sym_delete] = ACTIONS(2071),
    [anon_sym_continue] = ACTIONS(2071),
    [anon_sym_DASH_DASH] = ACTIONS(2069),
    [anon_sym_if] = ACTIONS(2071),
    [sym_this] = ACTIONS(2071),
    [anon_sym_yield] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [anon_sym_throw] = ACTIONS(2071),
    [anon_sym_protected] = ACTIONS(2071),
    [anon_sym_abstract] = ACTIONS(2071),
    [anon_sym_set] = ACTIONS(2071),
    [anon_sym_type] = ACTIONS(2071),
    [anon_sym_import] = ACTIONS(2071),
    [anon_sym_namespace] = ACTIONS(2071),
    [anon_sym_PLUS_PLUS] = ACTIONS(2069),
    [anon_sym_DQUOTE] = ACTIONS(2069),
    [anon_sym_else] = ACTIONS(2071),
    [anon_sym_BANG] = ACTIONS(2069),
    [anon_sym_for] = ACTIONS(2071),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_false] = ACTIONS(2071),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_case] = ACTIONS(2071),
    [anon_sym_module] = ACTIONS(2071),
    [anon_sym_number] = ACTIONS(2071),
    [anon_sym_class] = ACTIONS(2071),
    [anon_sym_declare] = ACTIONS(2071),
    [anon_sym_typeof] = ACTIONS(2071),
    [anon_sym_LBRACE] = ACTIONS(2069),
    [anon_sym_switch] = ACTIONS(2071),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [sym_null] = ACTIONS(2071),
    [anon_sym_any] = ACTIONS(2071),
    [anon_sym_boolean] = ACTIONS(2071),
    [anon_sym_async] = ACTIONS(2071),
    [anon_sym_public] = ACTIONS(2071),
    [anon_sym_var] = ACTIONS(2071),
    [anon_sym_while] = ACTIONS(2071),
    [anon_sym_SQUOTE] = ACTIONS(2069),
    [anon_sym_try] = ACTIONS(2071),
    [anon_sym_LT] = ACTIONS(2069),
    [sym_number] = ACTIONS(2069),
    [anon_sym_SLASH] = ACTIONS(2071),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2071),
    [anon_sym_function] = ACTIONS(2071),
    [sym_undefined] = ACTIONS(2071),
    [anon_sym_new] = ACTIONS(2071),
    [ts_builtin_sym_end] = ACTIONS(2069),
    [anon_sym_let] = ACTIONS(2071),
    [anon_sym_PLUS] = ACTIONS(2071),
    [anon_sym_export] = ACTIONS(2071),
    [anon_sym_do] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(2069),
    [anon_sym_with] = ACTIONS(2071),
    [anon_sym_await] = ACTIONS(2071),
  },
  [710] = {
    [sym_class_body] = STATE(948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [711] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(949),
    [sym_class_heritage] = STATE(950),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [712] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(951),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [713] = {
    [sym_identifier] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [sym_statement_block] = STATE(953),
    [sym__automatic_semicolon] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3015),
  },
  [715] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(954),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [sym_nested_identifier] = STATE(640),
    [sym_identifier] = ACTIONS(3017),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(956),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(955),
    [sym_type_parameters] = STATE(957),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [718] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [719] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3024),
    [sym__automatic_semicolon] = ACTIONS(3024),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3026),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_GT_GT_GT] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3026),
    [anon_sym_BANG_EQ] = ACTIONS(3026),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_instanceof] = ACTIONS(3024),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_STAR_STAR] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SEMI] = ACTIONS(3024),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_of] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_EQ_EQ] = ACTIONS(3026),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_SLASH] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_GT_GT] = ACTIONS(3026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3024),
  },
  [720] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3028),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [721] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(958),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [722] = {
    [sym_statement_block] = STATE(959),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [723] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(961),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [sym_string] = STATE(962),
    [sym__property_name] = STATE(962),
    [sym_computed_property_name] = STATE(962),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [725] = {
    [sym_string] = STATE(962),
    [sym__property_name] = STATE(962),
    [sym_computed_property_name] = STATE(962),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [726] = {
    [sym_string] = STATE(962),
    [sym__property_name] = STATE(962),
    [sym_computed_property_name] = STATE(962),
    [anon_sym_get] = ACTIONS(3035),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3033),
    [anon_sym_STAR] = ACTIONS(3037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [727] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [sym__automatic_semicolon] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_PERCENT] = ACTIONS(2011),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(3042),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_CARET] = ACTIONS(2011),
    [anon_sym_STAR_STAR] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
  },
  [728] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3047),
    [sym__automatic_semicolon] = ACTIONS(3047),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_instanceof] = ACTIONS(3047),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_STAR_STAR] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_of] = ACTIONS(3047),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3047),
  },
  [729] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [730] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3056),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [731] = {
    [sym_statement_block] = STATE(965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [732] = {
    [anon_sym_COMMA] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
  },
  [733] = {
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [anon_sym_symbol] = ACTIONS(3062),
    [anon_sym_break] = ACTIONS(3062),
    [anon_sym_return] = ACTIONS(3062),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3062),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_yield] = ACTIONS(3062),
    [sym_true] = ACTIONS(3062),
    [anon_sym_protected] = ACTIONS(3062),
    [anon_sym_set] = ACTIONS(3062),
    [anon_sym_import] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_number] = ACTIONS(3062),
    [anon_sym_typeof] = ACTIONS(3062),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3062),
    [sym_null] = ACTIONS(3062),
    [anon_sym_catch] = ACTIONS(3062),
    [anon_sym_any] = ACTIONS(3062),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(3062),
    [anon_sym_var] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3062),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_with] = ACTIONS(3062),
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_debugger] = ACTIONS(3062),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_void] = ACTIONS(3062),
    [anon_sym_const] = ACTIONS(3062),
    [sym_super] = ACTIONS(3062),
    [anon_sym_private] = ACTIONS(3062),
    [anon_sym_get] = ACTIONS(3062),
    [anon_sym_default] = ACTIONS(3062),
    [anon_sym_enum] = ACTIONS(3062),
    [anon_sym_continue] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [sym_this] = ACTIONS(3062),
    [anon_sym_throw] = ACTIONS(3062),
    [anon_sym_abstract] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3062),
    [anon_sym_namespace] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [sym_false] = ACTIONS(3062),
    [anon_sym_case] = ACTIONS(3062),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_class] = ACTIONS(3062),
    [anon_sym_declare] = ACTIONS(3062),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_boolean] = ACTIONS(3062),
    [anon_sym_try] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3060),
    [sym_number] = ACTIONS(3060),
    [anon_sym_finally] = ACTIONS(3062),
    [ts_builtin_sym_end] = ACTIONS(3060),
    [anon_sym_function] = ACTIONS(3062),
    [sym_undefined] = ACTIONS(3062),
    [anon_sym_let] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_await] = ACTIONS(3062),
  },
  [734] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3064),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [735] = {
    [sym_string] = STATE(962),
    [sym__property_name] = STATE(962),
    [sym_computed_property_name] = STATE(962),
    [anon_sym_get] = ACTIONS(3035),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(3069),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3033),
    [anon_sym_STAR] = ACTIONS(3037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3035),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [736] = {
    [sym_arrow_function] = STATE(968),
    [sym_await_expression] = STATE(968),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(967),
    [sym_meta_property] = STATE(968),
    [sym_update_expression] = STATE(968),
    [sym__expression] = STATE(968),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(968),
    [sym_call_expression] = STATE(968),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(968),
    [sym_string] = STATE(968),
    [sym_template_string] = STATE(968),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(968),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(968),
    [sym_generator_function] = STATE(968),
    [sym_new_expression] = STATE(968),
    [sym_assignment_expression] = STATE(968),
    [sym_augmented_assignment_expression] = STATE(968),
    [sym_binary_expression] = STATE(968),
    [sym_unary_expression] = STATE(968),
    [sym_regex] = STATE(968),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(968),
    [sym_as_expression] = STATE(968),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(968),
    [sym_class] = STATE(968),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3071),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3071),
    [sym_number] = ACTIONS(3073),
    [sym_true] = ACTIONS(3071),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3071),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [737] = {
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3077),
    [anon_sym_debugger] = ACTIONS(3075),
    [anon_sym_symbol] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3077),
    [anon_sym_DASH] = ACTIONS(3075),
    [anon_sym_void] = ACTIONS(3075),
    [anon_sym_break] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [sym_super] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_private] = ACTIONS(3075),
    [anon_sym_static] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_interface] = ACTIONS(3075),
    [anon_sym_default] = ACTIONS(3075),
    [anon_sym_enum] = ACTIONS(3075),
    [anon_sym_delete] = ACTIONS(3075),
    [anon_sym_continue] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3077),
    [anon_sym_if] = ACTIONS(3075),
    [sym_this] = ACTIONS(3075),
    [anon_sym_yield] = ACTIONS(3075),
    [sym_true] = ACTIONS(3075),
    [anon_sym_throw] = ACTIONS(3075),
    [anon_sym_protected] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_set] = ACTIONS(3075),
    [anon_sym_type] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_namespace] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3077),
    [anon_sym_DQUOTE] = ACTIONS(3077),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3077),
    [sym_false] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_case] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_number] = ACTIONS(3075),
    [anon_sym_class] = ACTIONS(3075),
    [anon_sym_declare] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3077),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [sym_null] = ACTIONS(3075),
    [anon_sym_any] = ACTIONS(3075),
    [anon_sym_boolean] = ACTIONS(3075),
    [anon_sym_async] = ACTIONS(3075),
    [anon_sym_public] = ACTIONS(3075),
    [anon_sym_var] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_LT] = ACTIONS(3077),
    [sym_number] = ACTIONS(3077),
    [anon_sym_SLASH] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3075),
    [sym_undefined] = ACTIONS(3075),
    [anon_sym_new] = ACTIONS(3075),
    [ts_builtin_sym_end] = ACTIONS(3077),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_do] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_await] = ACTIONS(3075),
  },
  [738] = {
    [anon_sym_COLON] = ACTIONS(3079),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [sym_switch_default] = STATE(971),
    [aux_sym_switch_body_repeat1] = STATE(971),
    [sym_switch_case] = STATE(971),
    [anon_sym_RBRACE] = ACTIONS(3081),
    [anon_sym_default] = ACTIONS(2232),
    [anon_sym_case] = ACTIONS(2234),
    [sym_comment] = ACTIONS(3),
  },
  [740] = {
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [anon_sym_COLON] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3085),
  },
  [742] = {
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [sym_comment] = ACTIONS(3),
  },
  [743] = {
    [sym_optional_parameter] = STATE(972),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(972),
    [aux_sym_export_statement_repeat1] = STATE(2539),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(972),
    [sym_decorator] = STATE(63),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [sym_this] = ACTIONS(1195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
  },
  [744] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(3089),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [745] = {
    [aux_sym_formal_parameters_repeat1] = STATE(745),
    [anon_sym_COMMA] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
  },
  [746] = {
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
  },
  [747] = {
    [sym__initializer] = STATE(975),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(3098),
    [anon_sym_COMMA] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
  },
  [748] = {
    [anon_sym_COMMA] = ACTIONS(3100),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [sym_comment] = ACTIONS(3),
  },
  [749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3102),
    [sym__automatic_semicolon] = ACTIONS(3102),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_GT_GT_GT] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3104),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3104),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_as] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_instanceof] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(3104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_of] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(3104),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_SLASH] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_GT_GT] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
  },
  [750] = {
    [anon_sym_EQ] = ACTIONS(3106),
    [anon_sym_COLON] = ACTIONS(3106),
    [anon_sym_RPAREN] = ACTIONS(3106),
    [anon_sym_QMARK] = ACTIONS(3106),
    [anon_sym_COMMA] = ACTIONS(3106),
    [sym_comment] = ACTIONS(3),
  },
  [751] = {
    [anon_sym_EQ] = ACTIONS(3108),
    [anon_sym_COLON] = ACTIONS(3108),
    [anon_sym_RPAREN] = ACTIONS(3108),
    [anon_sym_QMARK] = ACTIONS(3108),
    [anon_sym_COMMA] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
  },
  [752] = {
    [anon_sym_EQ] = ACTIONS(3110),
    [anon_sym_COLON] = ACTIONS(3110),
    [anon_sym_RPAREN] = ACTIONS(3110),
    [anon_sym_QMARK] = ACTIONS(3110),
    [anon_sym_COMMA] = ACTIONS(3110),
    [sym_comment] = ACTIONS(3),
  },
  [753] = {
    [anon_sym_EQ] = ACTIONS(3112),
    [anon_sym_COLON] = ACTIONS(3112),
    [anon_sym_RPAREN] = ACTIONS(3112),
    [anon_sym_QMARK] = ACTIONS(3112),
    [anon_sym_COMMA] = ACTIONS(3112),
    [sym_comment] = ACTIONS(3),
  },
  [754] = {
    [aux_sym_formal_parameters_repeat1] = STATE(745),
    [anon_sym_RPAREN] = ACTIONS(3089),
    [anon_sym_COMMA] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
  },
  [755] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3116),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_GT_GT_GT] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3118),
    [anon_sym_BANG_EQ] = ACTIONS(3118),
    [anon_sym_LT_EQ] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_GT_EQ] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
    [anon_sym_PERCENT] = ACTIONS(3116),
    [anon_sym_QMARK] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_EQ_EQ] = ACTIONS(3118),
    [anon_sym_instanceof] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_SLASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_CARET] = ACTIONS(3116),
    [anon_sym_STAR_STAR] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_in] = ACTIONS(3118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
  },
  [756] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [757] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [sym__automatic_semicolon] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3120),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_GT_GT_GT] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_BANG_EQ] = ACTIONS(3122),
    [anon_sym_LT_EQ] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3120),
    [anon_sym_GT_EQ] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_PERCENT] = ACTIONS(3120),
    [anon_sym_QMARK] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_DASH_DASH] = ACTIONS(3120),
    [anon_sym_EQ_EQ] = ACTIONS(3122),
    [anon_sym_instanceof] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_SLASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3120),
    [anon_sym_CARET] = ACTIONS(3120),
    [anon_sym_STAR_STAR] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_PLUS_PLUS] = ACTIONS(3120),
    [anon_sym_in] = ACTIONS(3122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
  },
  [758] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [759] = {
    [sym_statement_block] = STATE(978),
    [sym__automatic_semicolon] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(836),
  },
  [760] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(979),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [761] = {
    [sym_statement_block] = STATE(980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [762] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [sym__automatic_semicolon] = ACTIONS(3126),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_BQUOTE] = ACTIONS(3126),
    [anon_sym_PIPE] = ACTIONS(3128),
    [anon_sym_COMMA] = ACTIONS(3126),
    [anon_sym_LT_LT] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_GT_GT_GT] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_BANG_EQ] = ACTIONS(3128),
    [anon_sym_LT_EQ] = ACTIONS(3126),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_GT_EQ] = ACTIONS(3126),
    [anon_sym_GT] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_PERCENT] = ACTIONS(3126),
    [anon_sym_QMARK] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_as] = ACTIONS(3126),
    [anon_sym_PIPE_PIPE] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_EQ_EQ] = ACTIONS(3128),
    [anon_sym_instanceof] = ACTIONS(3126),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3126),
    [anon_sym_CARET] = ACTIONS(3126),
    [anon_sym_STAR_STAR] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_GT_GT] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_in] = ACTIONS(3128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3126),
    [anon_sym_BANG] = ACTIONS(3128),
  },
  [763] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [sym__automatic_semicolon] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [anon_sym_PIPE] = ACTIONS(3132),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(3130),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_GT_GT_GT] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_BANG_EQ] = ACTIONS(3132),
    [anon_sym_LT_EQ] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_GT_EQ] = ACTIONS(3130),
    [anon_sym_GT] = ACTIONS(3132),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3130),
    [anon_sym_QMARK] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_as] = ACTIONS(3130),
    [anon_sym_PIPE_PIPE] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_EQ_EQ] = ACTIONS(3132),
    [anon_sym_instanceof] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3130),
    [anon_sym_CARET] = ACTIONS(3130),
    [anon_sym_STAR_STAR] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_GT_GT] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_in] = ACTIONS(3132),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3132),
  },
  [764] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [765] = {
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_BQUOTE] = ACTIONS(3136),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3136),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_static] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3136),
    [anon_sym_if] = ACTIONS(3134),
    [sym_this] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(3136),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3136),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3136),
    [sym_false] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3136),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3136),
    [sym_null] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3136),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3136),
    [sym_number] = ACTIONS(3136),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [ts_builtin_sym_end] = ACTIONS(3136),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3136),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
  },
  [766] = {
    [sym_object] = STATE(982),
    [sym_array] = STATE(983),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(301),
  },
  [767] = {
    [sym_identifier] = ACTIONS(3140),
    [anon_sym_BQUOTE] = ACTIONS(3142),
    [anon_sym_debugger] = ACTIONS(3140),
    [anon_sym_symbol] = ACTIONS(3140),
    [anon_sym_AT] = ACTIONS(3142),
    [anon_sym_DASH] = ACTIONS(3140),
    [anon_sym_void] = ACTIONS(3140),
    [anon_sym_break] = ACTIONS(3140),
    [anon_sym_const] = ACTIONS(3140),
    [sym_super] = ACTIONS(3140),
    [anon_sym_return] = ACTIONS(3140),
    [anon_sym_private] = ACTIONS(3140),
    [anon_sym_static] = ACTIONS(3140),
    [anon_sym_get] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_interface] = ACTIONS(3140),
    [anon_sym_default] = ACTIONS(3140),
    [anon_sym_enum] = ACTIONS(3140),
    [anon_sym_delete] = ACTIONS(3140),
    [anon_sym_continue] = ACTIONS(3140),
    [anon_sym_DASH_DASH] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3140),
    [sym_this] = ACTIONS(3140),
    [anon_sym_yield] = ACTIONS(3140),
    [sym_true] = ACTIONS(3140),
    [anon_sym_throw] = ACTIONS(3140),
    [anon_sym_protected] = ACTIONS(3140),
    [anon_sym_abstract] = ACTIONS(3140),
    [anon_sym_set] = ACTIONS(3140),
    [anon_sym_type] = ACTIONS(3140),
    [anon_sym_import] = ACTIONS(3140),
    [anon_sym_namespace] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3142),
    [anon_sym_else] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [sym_false] = ACTIONS(3140),
    [anon_sym_SEMI] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3140),
    [anon_sym_module] = ACTIONS(3140),
    [anon_sym_number] = ACTIONS(3140),
    [anon_sym_class] = ACTIONS(3140),
    [anon_sym_declare] = ACTIONS(3140),
    [anon_sym_typeof] = ACTIONS(3140),
    [anon_sym_LBRACE] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3140),
    [anon_sym_LPAREN] = ACTIONS(3142),
    [sym_null] = ACTIONS(3140),
    [anon_sym_any] = ACTIONS(3140),
    [anon_sym_boolean] = ACTIONS(3140),
    [anon_sym_async] = ACTIONS(3140),
    [anon_sym_public] = ACTIONS(3140),
    [anon_sym_var] = ACTIONS(3140),
    [anon_sym_while] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3140),
    [anon_sym_LT] = ACTIONS(3142),
    [sym_number] = ACTIONS(3142),
    [anon_sym_SLASH] = ACTIONS(3140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3140),
    [anon_sym_string] = ACTIONS(3140),
    [anon_sym_function] = ACTIONS(3140),
    [sym_undefined] = ACTIONS(3140),
    [anon_sym_new] = ACTIONS(3140),
    [ts_builtin_sym_end] = ACTIONS(3142),
    [anon_sym_let] = ACTIONS(3140),
    [anon_sym_PLUS] = ACTIONS(3140),
    [anon_sym_export] = ACTIONS(3140),
    [anon_sym_do] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3140),
    [anon_sym_await] = ACTIONS(3140),
  },
  [768] = {
    [sym_identifier] = ACTIONS(3144),
    [anon_sym_BQUOTE] = ACTIONS(3146),
    [anon_sym_debugger] = ACTIONS(3144),
    [anon_sym_symbol] = ACTIONS(3144),
    [anon_sym_AT] = ACTIONS(3146),
    [anon_sym_DASH] = ACTIONS(3144),
    [anon_sym_void] = ACTIONS(3144),
    [anon_sym_break] = ACTIONS(3144),
    [anon_sym_const] = ACTIONS(3144),
    [sym_super] = ACTIONS(3144),
    [anon_sym_return] = ACTIONS(3144),
    [anon_sym_private] = ACTIONS(3144),
    [anon_sym_static] = ACTIONS(3144),
    [anon_sym_get] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3146),
    [anon_sym_interface] = ACTIONS(3144),
    [anon_sym_default] = ACTIONS(3144),
    [anon_sym_enum] = ACTIONS(3144),
    [anon_sym_delete] = ACTIONS(3144),
    [anon_sym_continue] = ACTIONS(3144),
    [anon_sym_DASH_DASH] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3144),
    [sym_this] = ACTIONS(3144),
    [anon_sym_yield] = ACTIONS(3144),
    [sym_true] = ACTIONS(3144),
    [anon_sym_throw] = ACTIONS(3144),
    [anon_sym_protected] = ACTIONS(3144),
    [anon_sym_abstract] = ACTIONS(3144),
    [anon_sym_set] = ACTIONS(3144),
    [anon_sym_type] = ACTIONS(3144),
    [anon_sym_import] = ACTIONS(3144),
    [anon_sym_namespace] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3146),
    [anon_sym_DQUOTE] = ACTIONS(3146),
    [anon_sym_else] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [sym_false] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3144),
    [anon_sym_module] = ACTIONS(3144),
    [anon_sym_number] = ACTIONS(3144),
    [anon_sym_class] = ACTIONS(3144),
    [anon_sym_declare] = ACTIONS(3144),
    [anon_sym_typeof] = ACTIONS(3144),
    [anon_sym_LBRACE] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3144),
    [anon_sym_LPAREN] = ACTIONS(3146),
    [sym_null] = ACTIONS(3144),
    [anon_sym_any] = ACTIONS(3144),
    [anon_sym_boolean] = ACTIONS(3144),
    [anon_sym_async] = ACTIONS(3144),
    [anon_sym_public] = ACTIONS(3144),
    [anon_sym_var] = ACTIONS(3144),
    [anon_sym_while] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3144),
    [anon_sym_LT] = ACTIONS(3146),
    [sym_number] = ACTIONS(3146),
    [anon_sym_SLASH] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3144),
    [anon_sym_function] = ACTIONS(3144),
    [sym_undefined] = ACTIONS(3144),
    [anon_sym_new] = ACTIONS(3144),
    [ts_builtin_sym_end] = ACTIONS(3146),
    [anon_sym_let] = ACTIONS(3144),
    [anon_sym_PLUS] = ACTIONS(3144),
    [anon_sym_export] = ACTIONS(3144),
    [anon_sym_do] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3146),
    [anon_sym_with] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3144),
  },
  [769] = {
    [sym_identifier] = ACTIONS(3148),
    [anon_sym_BQUOTE] = ACTIONS(3150),
    [anon_sym_debugger] = ACTIONS(3148),
    [anon_sym_symbol] = ACTIONS(3148),
    [anon_sym_AT] = ACTIONS(3150),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_void] = ACTIONS(3148),
    [anon_sym_break] = ACTIONS(3148),
    [anon_sym_const] = ACTIONS(3148),
    [sym_super] = ACTIONS(3148),
    [anon_sym_return] = ACTIONS(3148),
    [anon_sym_private] = ACTIONS(3148),
    [anon_sym_static] = ACTIONS(3148),
    [anon_sym_get] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3150),
    [anon_sym_interface] = ACTIONS(3148),
    [anon_sym_default] = ACTIONS(3148),
    [anon_sym_enum] = ACTIONS(3148),
    [anon_sym_delete] = ACTIONS(3148),
    [anon_sym_continue] = ACTIONS(3148),
    [anon_sym_DASH_DASH] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3148),
    [sym_this] = ACTIONS(3148),
    [anon_sym_yield] = ACTIONS(3148),
    [sym_true] = ACTIONS(3148),
    [anon_sym_throw] = ACTIONS(3148),
    [anon_sym_protected] = ACTIONS(3148),
    [anon_sym_abstract] = ACTIONS(3148),
    [anon_sym_set] = ACTIONS(3148),
    [anon_sym_type] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3148),
    [anon_sym_namespace] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3150),
    [anon_sym_DQUOTE] = ACTIONS(3150),
    [anon_sym_else] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [sym_false] = ACTIONS(3148),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3148),
    [anon_sym_module] = ACTIONS(3148),
    [anon_sym_number] = ACTIONS(3148),
    [anon_sym_class] = ACTIONS(3148),
    [anon_sym_declare] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(3150),
    [sym_null] = ACTIONS(3148),
    [anon_sym_any] = ACTIONS(3148),
    [anon_sym_boolean] = ACTIONS(3148),
    [anon_sym_async] = ACTIONS(3148),
    [anon_sym_public] = ACTIONS(3148),
    [anon_sym_var] = ACTIONS(3148),
    [anon_sym_while] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3150),
    [sym_number] = ACTIONS(3150),
    [anon_sym_SLASH] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3148),
    [anon_sym_function] = ACTIONS(3148),
    [sym_undefined] = ACTIONS(3148),
    [anon_sym_new] = ACTIONS(3148),
    [ts_builtin_sym_end] = ACTIONS(3150),
    [anon_sym_let] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_export] = ACTIONS(3148),
    [anon_sym_do] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3148),
    [anon_sym_await] = ACTIONS(3148),
  },
  [770] = {
    [anon_sym_GT] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3152),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [anon_sym_EQ] = ACTIONS(3154),
    [anon_sym_GT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
  },
  [772] = {
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_symbol] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_interface] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_yield] = ACTIONS(3158),
    [sym_true] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(2794),
    [anon_sym_set] = ACTIONS(3158),
    [anon_sym_import] = ACTIONS(3158),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_number] = ACTIONS(3158),
    [anon_sym_typeof] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_RBRACK] = ACTIONS(3156),
    [sym_null] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(3158),
    [anon_sym_async] = ACTIONS(3158),
    [anon_sym_public] = ACTIONS(3158),
    [anon_sym_var] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_RPAREN] = ACTIONS(3156),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_export] = ACTIONS(3158),
    [anon_sym_with] = ACTIONS(3158),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_debugger] = ACTIONS(3158),
    [anon_sym_AT] = ACTIONS(3156),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_EQ] = ACTIONS(3158),
    [anon_sym_void] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [sym_super] = ACTIONS(3158),
    [anon_sym_private] = ACTIONS(3158),
    [anon_sym_get] = ACTIONS(3158),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [sym_this] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_abstract] = ACTIONS(3158),
    [anon_sym_type] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [sym_false] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_declare] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3156),
    [anon_sym_boolean] = ACTIONS(3158),
    [anon_sym_EQ_GT] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(3156),
    [sym_number] = ACTIONS(3156),
    [ts_builtin_sym_end] = ACTIONS(3156),
    [anon_sym_function] = ACTIONS(3158),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_let] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_implements] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3158),
  },
  [773] = {
    [anon_sym_EQ_GT] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(3160),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_EQ] = ACTIONS(3162),
    [anon_sym_RBRACK] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3160),
    [anon_sym_else] = ACTIONS(3160),
  },
  [774] = {
    [anon_sym_COMMA] = ACTIONS(3164),
    [anon_sym_GT] = ACTIONS(3164),
    [sym_comment] = ACTIONS(3),
  },
  [775] = {
    [aux_sym_object_type_repeat1] = STATE(986),
    [sym__automatic_semicolon] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3168),
    [anon_sym_COMMA] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
  },
  [776] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(988),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3170),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_string] = STATE(989),
    [sym__property_name] = STATE(989),
    [sym_computed_property_name] = STATE(989),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [778] = {
    [sym_string] = STATE(989),
    [sym__property_name] = STATE(989),
    [sym_computed_property_name] = STATE(989),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [779] = {
    [sym_string] = STATE(993),
    [sym__property_name] = STATE(993),
    [sym_computed_property_name] = STATE(993),
    [anon_sym_get] = ACTIONS(3174),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [780] = {
    [sym_string] = STATE(989),
    [sym__property_name] = STATE(989),
    [sym_computed_property_name] = STATE(989),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3182),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [781] = {
    [sym__call_signature] = STATE(988),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(995),
    [sym__automatic_semicolon] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
  },
  [782] = {
    [sym_type_annotation] = STATE(996),
    [sym__automatic_semicolon] = ACTIONS(3188),
    [anon_sym_RBRACE] = ACTIONS(3188),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3188),
    [anon_sym_COMMA] = ACTIONS(3188),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3188),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [sym_formal_parameters] = STATE(997),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [784] = {
    [sym_identifier] = ACTIONS(3190),
    [sym_comment] = ACTIONS(3),
  },
  [785] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3168),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [786] = {
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_PIPE] = ACTIONS(3192),
    [anon_sym_break] = ACTIONS(3194),
    [anon_sym_return] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_interface] = ACTIONS(3194),
    [anon_sym_delete] = ACTIONS(3194),
    [anon_sym_if] = ACTIONS(3194),
    [anon_sym_yield] = ACTIONS(3194),
    [sym_true] = ACTIONS(3194),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3192),
    [anon_sym_for] = ACTIONS(3194),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_typeof] = ACTIONS(3194),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_switch] = ACTIONS(3194),
    [anon_sym_RBRACK] = ACTIONS(3192),
    [sym_null] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_var] = ACTIONS(3194),
    [anon_sym_while] = ACTIONS(3194),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(3192),
    [anon_sym_SLASH] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_new] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3194),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_debugger] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_COMMA] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_EQ] = ACTIONS(3194),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_const] = ACTIONS(3194),
    [sym_super] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_default] = ACTIONS(3194),
    [anon_sym_enum] = ACTIONS(3194),
    [anon_sym_continue] = ACTIONS(3194),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [sym_this] = ACTIONS(3194),
    [anon_sym_throw] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_else] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [sym_false] = ACTIONS(3194),
    [anon_sym_case] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3192),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_EQ_GT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_LT] = ACTIONS(3192),
    [sym_number] = ACTIONS(3192),
    [ts_builtin_sym_end] = ACTIONS(3192),
    [anon_sym_function] = ACTIONS(3194),
    [sym_undefined] = ACTIONS(3194),
    [anon_sym_let] = ACTIONS(3194),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_do] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3192),
    [anon_sym_await] = ACTIONS(3194),
  },
  [787] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(3166),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_SEMI] = ACTIONS(3166),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3168),
    [anon_sym_COMMA] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
  },
  [788] = {
    [sym_string] = STATE(993),
    [sym__property_name] = STATE(993),
    [sym_computed_property_name] = STATE(993),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3180),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(3176),
    [anon_sym_get] = ACTIONS(3174),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3174),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [789] = {
    [sym__call_signature] = STATE(1002),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1001),
    [sym__automatic_semicolon] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3198),
    [sym_comment] = ACTIONS(3),
  },
  [790] = {
    [sym__automatic_semicolon] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
  },
  [791] = {
    [sym__automatic_semicolon] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2999),
    [sym_comment] = ACTIONS(3),
  },
  [792] = {
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3202),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_static] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3202),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3202),
    [sym_null] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3202),
    [anon_sym_RPAREN] = ACTIONS(3202),
    [anon_sym_SLASH] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_with] = ACTIONS(3204),
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_EQ] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [sym_this] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [sym_false] = ACTIONS(3204),
    [anon_sym_case] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_GT] = ACTIONS(3202),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3202),
    [sym_number] = ACTIONS(3202),
    [ts_builtin_sym_end] = ACTIONS(3202),
    [anon_sym_function] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3202),
    [anon_sym_await] = ACTIONS(3204),
  },
  [793] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
  },
  [794] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1004),
    [sym_function_type] = STATE(1004),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1004),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1004),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1004),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [795] = {
    [anon_sym_EQ_GT] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
  },
  [796] = {
    [sym_arrow_function] = STATE(2079),
    [sym_await_expression] = STATE(2079),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(2079),
    [sym_meta_property] = STATE(2079),
    [sym__expression] = STATE(2079),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2079),
    [sym_call_expression] = STATE(2079),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(1809),
    [sym_ternary_expression] = STATE(2079),
    [sym_string] = STATE(2079),
    [sym_template_string] = STATE(2079),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2079),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(2079),
    [sym_generator_function] = STATE(2079),
    [sym_new_expression] = STATE(2079),
    [sym_assignment_expression] = STATE(2079),
    [sym_augmented_assignment_expression] = STATE(2079),
    [sym_binary_expression] = STATE(2079),
    [sym_unary_expression] = STATE(2079),
    [sym_mapped_type_clause] = STATE(686),
    [sym_regex] = STATE(2079),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(1810),
    [sym_non_null_expression] = STATE(2079),
    [sym_as_expression] = STATE(2079),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(2079),
    [sym_class] = STATE(2079),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(3210),
    [sym_false] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [sym_null] = ACTIONS(3212),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_static] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3212),
    [sym_number] = ACTIONS(3220),
    [sym_true] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [797] = {
    [sym_construct_signature] = STATE(775),
    [sym_pair] = STATE(440),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(775),
    [sym__call_signature] = STATE(775),
    [sym_spread_element] = STATE(440),
    [sym_property_signature] = STATE(775),
    [sym_type_parameters] = STATE(1793),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(805),
    [sym_formal_parameters] = STATE(1255),
    [sym_index_signature] = STATE(775),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(775),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(440),
    [sym_assignment_pattern] = STATE(440),
    [sym_array] = STATE(320),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(3234),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [798] = {
    [sym_computed_property_name] = STATE(2310),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [799] = {
    [sym_computed_property_name] = STATE(1011),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(1011),
    [sym__property_name] = STATE(1011),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3248),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [800] = {
    [sym_computed_property_name] = STATE(2310),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [801] = {
    [anon_sym_EQ] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_COMMA] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
  },
  [802] = {
    [sym_class_declaration] = STATE(1320),
    [sym_generator_function_declaration] = STATE(1320),
    [sym__declaration] = STATE(1320),
    [sym_ambient_declaration] = STATE(1320),
    [sym_import_alias] = STATE(1320),
    [sym_type_alias_declaration] = STATE(1320),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_function_signature] = STATE(1320),
    [sym_abstract_class_declaration] = STATE(1320),
    [sym_module] = STATE(1320),
    [sym_interface_declaration] = STATE(1320),
    [sym_function_declaration] = STATE(1320),
    [sym_export_clause] = STATE(1855),
    [sym_variable_declaration] = STATE(1320),
    [sym_lexical_declaration] = STATE(1320),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1320),
    [sym_enum_declaration] = STATE(1320),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_as] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
  },
  [803] = {
    [sym_string] = STATE(1011),
    [sym__property_name] = STATE(1011),
    [sym_computed_property_name] = STATE(1011),
    [anon_sym_get] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [804] = {
    [sym_string] = STATE(1011),
    [sym__property_name] = STATE(1011),
    [sym_computed_property_name] = STATE(1011),
    [anon_sym_get] = ACTIONS(3244),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3246),
    [anon_sym_STAR] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3248),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(3252),
    [anon_sym_private] = ACTIONS(960),
  },
  [805] = {
    [sym__call_signature] = STATE(1950),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(790),
    [sym__automatic_semicolon] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_COLON] = ACTIONS(3254),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_QMARK] = ACTIONS(3256),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
  },
  [806] = {
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [anon_sym_symbol] = ACTIONS(3260),
    [anon_sym_PIPE] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_return] = ACTIONS(3260),
    [anon_sym_static] = ACTIONS(3260),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_interface] = ACTIONS(3260),
    [anon_sym_delete] = ACTIONS(3260),
    [anon_sym_if] = ACTIONS(3260),
    [anon_sym_yield] = ACTIONS(3260),
    [sym_true] = ACTIONS(3260),
    [anon_sym_protected] = ACTIONS(3260),
    [anon_sym_set] = ACTIONS(3260),
    [anon_sym_import] = ACTIONS(3260),
    [anon_sym_DQUOTE] = ACTIONS(3258),
    [anon_sym_for] = ACTIONS(3260),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_number] = ACTIONS(3260),
    [anon_sym_typeof] = ACTIONS(3260),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_switch] = ACTIONS(3260),
    [anon_sym_RBRACK] = ACTIONS(3258),
    [sym_null] = ACTIONS(3260),
    [anon_sym_any] = ACTIONS(3260),
    [anon_sym_async] = ACTIONS(3260),
    [anon_sym_public] = ACTIONS(3260),
    [anon_sym_var] = ACTIONS(3260),
    [anon_sym_while] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3258),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [anon_sym_SLASH] = ACTIONS(3260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3260),
    [anon_sym_new] = ACTIONS(3260),
    [anon_sym_export] = ACTIONS(3260),
    [anon_sym_with] = ACTIONS(3260),
    [sym_identifier] = ACTIONS(3260),
    [anon_sym_debugger] = ACTIONS(3260),
    [anon_sym_AT] = ACTIONS(3258),
    [anon_sym_COMMA] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_EQ] = ACTIONS(3260),
    [anon_sym_void] = ACTIONS(3260),
    [anon_sym_const] = ACTIONS(3260),
    [sym_super] = ACTIONS(3260),
    [anon_sym_private] = ACTIONS(3260),
    [anon_sym_get] = ACTIONS(3260),
    [anon_sym_default] = ACTIONS(3260),
    [anon_sym_enum] = ACTIONS(3260),
    [anon_sym_continue] = ACTIONS(3260),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [sym_this] = ACTIONS(3260),
    [anon_sym_throw] = ACTIONS(3260),
    [anon_sym_abstract] = ACTIONS(3260),
    [anon_sym_type] = ACTIONS(3260),
    [anon_sym_namespace] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_else] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [sym_false] = ACTIONS(3260),
    [anon_sym_case] = ACTIONS(3260),
    [anon_sym_module] = ACTIONS(3260),
    [anon_sym_class] = ACTIONS(3260),
    [anon_sym_declare] = ACTIONS(3260),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_GT] = ACTIONS(3258),
    [anon_sym_boolean] = ACTIONS(3260),
    [anon_sym_EQ_GT] = ACTIONS(3258),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_try] = ACTIONS(3260),
    [anon_sym_LT] = ACTIONS(3258),
    [sym_number] = ACTIONS(3258),
    [ts_builtin_sym_end] = ACTIONS(3258),
    [anon_sym_function] = ACTIONS(3260),
    [sym_undefined] = ACTIONS(3260),
    [anon_sym_let] = ACTIONS(3260),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_do] = ACTIONS(3260),
    [anon_sym_TILDE] = ACTIONS(3258),
    [anon_sym_await] = ACTIONS(3260),
  },
  [807] = {
    [anon_sym_EQ_GT] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_while] = ACTIONS(3262),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_RBRACK] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3262),
    [anon_sym_else] = ACTIONS(3262),
  },
  [808] = {
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [anon_sym_symbol] = ACTIONS(3268),
    [anon_sym_PIPE] = ACTIONS(3266),
    [anon_sym_break] = ACTIONS(3268),
    [anon_sym_return] = ACTIONS(3268),
    [anon_sym_static] = ACTIONS(3268),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_interface] = ACTIONS(3268),
    [anon_sym_delete] = ACTIONS(3268),
    [anon_sym_if] = ACTIONS(3268),
    [anon_sym_yield] = ACTIONS(3268),
    [sym_true] = ACTIONS(3268),
    [anon_sym_protected] = ACTIONS(3268),
    [anon_sym_set] = ACTIONS(3268),
    [anon_sym_import] = ACTIONS(3268),
    [anon_sym_DQUOTE] = ACTIONS(3266),
    [anon_sym_for] = ACTIONS(3268),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_number] = ACTIONS(3268),
    [anon_sym_typeof] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3268),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [sym_null] = ACTIONS(3268),
    [anon_sym_any] = ACTIONS(3268),
    [anon_sym_async] = ACTIONS(3268),
    [anon_sym_public] = ACTIONS(3268),
    [anon_sym_var] = ACTIONS(3268),
    [anon_sym_while] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_SLASH] = ACTIONS(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3268),
    [anon_sym_new] = ACTIONS(3268),
    [anon_sym_export] = ACTIONS(3268),
    [anon_sym_with] = ACTIONS(3268),
    [sym_identifier] = ACTIONS(3268),
    [anon_sym_debugger] = ACTIONS(3268),
    [anon_sym_AT] = ACTIONS(3266),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_void] = ACTIONS(3268),
    [anon_sym_const] = ACTIONS(3268),
    [sym_super] = ACTIONS(3268),
    [anon_sym_private] = ACTIONS(3268),
    [anon_sym_get] = ACTIONS(3268),
    [anon_sym_default] = ACTIONS(3268),
    [anon_sym_enum] = ACTIONS(3268),
    [anon_sym_continue] = ACTIONS(3268),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [sym_this] = ACTIONS(3268),
    [anon_sym_throw] = ACTIONS(3268),
    [anon_sym_abstract] = ACTIONS(3268),
    [anon_sym_type] = ACTIONS(3268),
    [anon_sym_namespace] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_else] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [sym_false] = ACTIONS(3268),
    [anon_sym_case] = ACTIONS(3268),
    [anon_sym_module] = ACTIONS(3268),
    [anon_sym_class] = ACTIONS(3268),
    [anon_sym_declare] = ACTIONS(3268),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3266),
    [anon_sym_boolean] = ACTIONS(3268),
    [anon_sym_EQ_GT] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_try] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3266),
    [sym_number] = ACTIONS(3266),
    [ts_builtin_sym_end] = ACTIONS(3266),
    [anon_sym_function] = ACTIONS(3268),
    [sym_undefined] = ACTIONS(3268),
    [anon_sym_let] = ACTIONS(3268),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_do] = ACTIONS(3268),
    [anon_sym_TILDE] = ACTIONS(3266),
    [anon_sym_await] = ACTIONS(3268),
  },
  [809] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(3270),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [anon_sym_extends] = ACTIONS(3272),
    [anon_sym_implements] = ACTIONS(3272),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3272),
    [anon_sym_EQ] = ACTIONS(3272),
    [anon_sym_LPAREN] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3274),
  },
  [811] = {
    [anon_sym_COMMA] = ACTIONS(3276),
    [anon_sym_GT] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [sym_type_parameter] = STATE(811),
    [anon_sym_GT] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [aux_sym_type_parameters_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(3280),
    [anon_sym_GT] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
  },
  [814] = {
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [anon_sym_symbol] = ACTIONS(3285),
    [anon_sym_PIPE] = ACTIONS(3283),
    [anon_sym_break] = ACTIONS(3285),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_static] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_interface] = ACTIONS(3285),
    [anon_sym_delete] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(3285),
    [anon_sym_yield] = ACTIONS(3285),
    [sym_true] = ACTIONS(3285),
    [anon_sym_protected] = ACTIONS(3285),
    [anon_sym_set] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3285),
    [anon_sym_DQUOTE] = ACTIONS(3283),
    [anon_sym_for] = ACTIONS(3285),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_number] = ACTIONS(3285),
    [anon_sym_typeof] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_switch] = ACTIONS(3285),
    [anon_sym_RBRACK] = ACTIONS(3283),
    [sym_null] = ACTIONS(3285),
    [anon_sym_any] = ACTIONS(3285),
    [anon_sym_async] = ACTIONS(3285),
    [anon_sym_public] = ACTIONS(3285),
    [anon_sym_var] = ACTIONS(3285),
    [anon_sym_while] = ACTIONS(3285),
    [anon_sym_SQUOTE] = ACTIONS(3283),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3285),
    [anon_sym_new] = ACTIONS(3285),
    [anon_sym_export] = ACTIONS(3285),
    [anon_sym_with] = ACTIONS(3285),
    [sym_identifier] = ACTIONS(3285),
    [anon_sym_debugger] = ACTIONS(3285),
    [anon_sym_AT] = ACTIONS(3283),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3285),
    [anon_sym_void] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3285),
    [sym_super] = ACTIONS(3285),
    [anon_sym_private] = ACTIONS(3285),
    [anon_sym_get] = ACTIONS(3285),
    [anon_sym_default] = ACTIONS(3285),
    [anon_sym_enum] = ACTIONS(3285),
    [anon_sym_continue] = ACTIONS(3285),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [sym_this] = ACTIONS(3285),
    [anon_sym_throw] = ACTIONS(3285),
    [anon_sym_abstract] = ACTIONS(3285),
    [anon_sym_type] = ACTIONS(3285),
    [anon_sym_namespace] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [sym_false] = ACTIONS(3285),
    [anon_sym_case] = ACTIONS(3285),
    [anon_sym_module] = ACTIONS(3285),
    [anon_sym_class] = ACTIONS(3285),
    [anon_sym_declare] = ACTIONS(3285),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3283),
    [anon_sym_boolean] = ACTIONS(3285),
    [anon_sym_EQ_GT] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_try] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(3283),
    [sym_number] = ACTIONS(3283),
    [ts_builtin_sym_end] = ACTIONS(3283),
    [anon_sym_function] = ACTIONS(3285),
    [sym_undefined] = ACTIONS(3285),
    [anon_sym_let] = ACTIONS(3285),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_do] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3283),
    [anon_sym_await] = ACTIONS(3285),
  },
  [815] = {
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [anon_sym_symbol] = ACTIONS(3289),
    [anon_sym_PIPE] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3289),
    [anon_sym_return] = ACTIONS(3289),
    [anon_sym_static] = ACTIONS(3289),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_interface] = ACTIONS(3289),
    [anon_sym_delete] = ACTIONS(3289),
    [anon_sym_if] = ACTIONS(3289),
    [anon_sym_yield] = ACTIONS(3289),
    [sym_true] = ACTIONS(3289),
    [anon_sym_protected] = ACTIONS(3289),
    [anon_sym_set] = ACTIONS(3289),
    [anon_sym_import] = ACTIONS(3289),
    [anon_sym_DQUOTE] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3289),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_number] = ACTIONS(3289),
    [anon_sym_typeof] = ACTIONS(3289),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_switch] = ACTIONS(3289),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [sym_null] = ACTIONS(3289),
    [anon_sym_any] = ACTIONS(3289),
    [anon_sym_async] = ACTIONS(3289),
    [anon_sym_public] = ACTIONS(3289),
    [anon_sym_var] = ACTIONS(3289),
    [anon_sym_while] = ACTIONS(3289),
    [anon_sym_SQUOTE] = ACTIONS(3287),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3289),
    [anon_sym_new] = ACTIONS(3289),
    [anon_sym_export] = ACTIONS(3289),
    [anon_sym_with] = ACTIONS(3289),
    [sym_identifier] = ACTIONS(3289),
    [anon_sym_debugger] = ACTIONS(3289),
    [anon_sym_AT] = ACTIONS(3287),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(3289),
    [anon_sym_void] = ACTIONS(3289),
    [anon_sym_const] = ACTIONS(3289),
    [sym_super] = ACTIONS(3289),
    [anon_sym_private] = ACTIONS(3289),
    [anon_sym_get] = ACTIONS(3289),
    [anon_sym_default] = ACTIONS(3289),
    [anon_sym_enum] = ACTIONS(3289),
    [anon_sym_continue] = ACTIONS(3289),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [sym_this] = ACTIONS(3289),
    [anon_sym_throw] = ACTIONS(3289),
    [anon_sym_abstract] = ACTIONS(3289),
    [anon_sym_type] = ACTIONS(3289),
    [anon_sym_namespace] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [sym_false] = ACTIONS(3289),
    [anon_sym_case] = ACTIONS(3289),
    [anon_sym_module] = ACTIONS(3289),
    [anon_sym_class] = ACTIONS(3289),
    [anon_sym_declare] = ACTIONS(3289),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3287),
    [anon_sym_boolean] = ACTIONS(3289),
    [anon_sym_EQ_GT] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(3287),
    [sym_number] = ACTIONS(3287),
    [ts_builtin_sym_end] = ACTIONS(3287),
    [anon_sym_function] = ACTIONS(3289),
    [sym_undefined] = ACTIONS(3289),
    [anon_sym_let] = ACTIONS(3289),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_do] = ACTIONS(3289),
    [anon_sym_TILDE] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3289),
  },
  [816] = {
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [anon_sym_symbol] = ACTIONS(3293),
    [anon_sym_PIPE] = ACTIONS(3291),
    [anon_sym_break] = ACTIONS(3293),
    [anon_sym_return] = ACTIONS(3293),
    [anon_sym_static] = ACTIONS(3293),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_interface] = ACTIONS(3293),
    [anon_sym_delete] = ACTIONS(3293),
    [anon_sym_if] = ACTIONS(3293),
    [anon_sym_yield] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [anon_sym_protected] = ACTIONS(3293),
    [anon_sym_set] = ACTIONS(3293),
    [anon_sym_import] = ACTIONS(3293),
    [anon_sym_DQUOTE] = ACTIONS(3291),
    [anon_sym_for] = ACTIONS(3293),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_number] = ACTIONS(3293),
    [anon_sym_typeof] = ACTIONS(3293),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_switch] = ACTIONS(3293),
    [anon_sym_RBRACK] = ACTIONS(3291),
    [sym_null] = ACTIONS(3293),
    [anon_sym_any] = ACTIONS(3293),
    [anon_sym_async] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3293),
    [anon_sym_var] = ACTIONS(3293),
    [anon_sym_while] = ACTIONS(3293),
    [anon_sym_SQUOTE] = ACTIONS(3291),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_SLASH] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3293),
    [anon_sym_new] = ACTIONS(3293),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_with] = ACTIONS(3293),
    [sym_identifier] = ACTIONS(3293),
    [anon_sym_debugger] = ACTIONS(3293),
    [anon_sym_AT] = ACTIONS(3291),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(3293),
    [anon_sym_void] = ACTIONS(3293),
    [anon_sym_const] = ACTIONS(3293),
    [sym_super] = ACTIONS(3293),
    [anon_sym_private] = ACTIONS(3293),
    [anon_sym_get] = ACTIONS(3293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3291),
    [anon_sym_default] = ACTIONS(3293),
    [anon_sym_enum] = ACTIONS(3293),
    [anon_sym_continue] = ACTIONS(3293),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [sym_this] = ACTIONS(3293),
    [anon_sym_throw] = ACTIONS(3293),
    [anon_sym_abstract] = ACTIONS(3293),
    [anon_sym_type] = ACTIONS(3293),
    [anon_sym_namespace] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_else] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [sym_false] = ACTIONS(3293),
    [anon_sym_case] = ACTIONS(3293),
    [anon_sym_module] = ACTIONS(3293),
    [anon_sym_class] = ACTIONS(3293),
    [anon_sym_declare] = ACTIONS(3293),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3291),
    [anon_sym_boolean] = ACTIONS(3293),
    [anon_sym_EQ_GT] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_try] = ACTIONS(3293),
    [anon_sym_LT] = ACTIONS(3291),
    [sym_number] = ACTIONS(3291),
    [ts_builtin_sym_end] = ACTIONS(3291),
    [anon_sym_function] = ACTIONS(3293),
    [sym_undefined] = ACTIONS(3293),
    [anon_sym_let] = ACTIONS(3293),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_implements] = ACTIONS(3293),
    [anon_sym_do] = ACTIONS(3293),
    [anon_sym_TILDE] = ACTIONS(3291),
    [anon_sym_await] = ACTIONS(3293),
  },
  [817] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RBRACK] = ACTIONS(3295),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3295),
  },
  [818] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [819] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_GT] = ACTIONS(3295),
    [anon_sym_RBRACK] = ACTIONS(3295),
    [anon_sym_COMMA] = ACTIONS(3299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3295),
  },
  [820] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1020),
    [sym_function_type] = STATE(1020),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1020),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1020),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1020),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [821] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3302),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [sym__automatic_semicolon] = ACTIONS(3302),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_LT_EQ] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_QMARK] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_instanceof] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3302),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3302),
    [anon_sym_BANG] = ACTIONS(3304),
  },
  [822] = {
    [sym_identifier] = ACTIONS(3306),
    [anon_sym_BQUOTE] = ACTIONS(3308),
    [anon_sym_debugger] = ACTIONS(3306),
    [anon_sym_symbol] = ACTIONS(3306),
    [anon_sym_AT] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3306),
    [anon_sym_void] = ACTIONS(3306),
    [anon_sym_break] = ACTIONS(3306),
    [anon_sym_const] = ACTIONS(3306),
    [sym_super] = ACTIONS(3306),
    [anon_sym_return] = ACTIONS(3306),
    [anon_sym_private] = ACTIONS(3306),
    [anon_sym_static] = ACTIONS(3306),
    [anon_sym_get] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_interface] = ACTIONS(3306),
    [anon_sym_default] = ACTIONS(3306),
    [anon_sym_enum] = ACTIONS(3306),
    [anon_sym_delete] = ACTIONS(3306),
    [anon_sym_continue] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3308),
    [anon_sym_if] = ACTIONS(3306),
    [sym_this] = ACTIONS(3306),
    [anon_sym_yield] = ACTIONS(3306),
    [sym_true] = ACTIONS(3306),
    [anon_sym_throw] = ACTIONS(3306),
    [anon_sym_protected] = ACTIONS(3306),
    [anon_sym_abstract] = ACTIONS(3306),
    [anon_sym_set] = ACTIONS(3306),
    [anon_sym_type] = ACTIONS(3306),
    [anon_sym_import] = ACTIONS(3306),
    [anon_sym_namespace] = ACTIONS(3306),
    [anon_sym_PLUS_PLUS] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(3308),
    [anon_sym_else] = ACTIONS(3306),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_for] = ACTIONS(3306),
    [anon_sym_LBRACK] = ACTIONS(3308),
    [sym_false] = ACTIONS(3306),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_case] = ACTIONS(3306),
    [anon_sym_module] = ACTIONS(3306),
    [anon_sym_number] = ACTIONS(3306),
    [anon_sym_class] = ACTIONS(3306),
    [anon_sym_declare] = ACTIONS(3306),
    [anon_sym_typeof] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3308),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3308),
    [sym_null] = ACTIONS(3306),
    [anon_sym_any] = ACTIONS(3306),
    [anon_sym_boolean] = ACTIONS(3306),
    [anon_sym_async] = ACTIONS(3306),
    [anon_sym_public] = ACTIONS(3306),
    [anon_sym_var] = ACTIONS(3306),
    [anon_sym_while] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(3308),
    [anon_sym_try] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [sym_number] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3306),
    [anon_sym_function] = ACTIONS(3306),
    [sym_undefined] = ACTIONS(3306),
    [anon_sym_new] = ACTIONS(3306),
    [ts_builtin_sym_end] = ACTIONS(3308),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3306),
    [anon_sym_export] = ACTIONS(3306),
    [anon_sym_do] = ACTIONS(3306),
    [anon_sym_TILDE] = ACTIONS(3308),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_await] = ACTIONS(3306),
  },
  [823] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3310),
    [sym__automatic_semicolon] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3310),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_as] = ACTIONS(3318),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_if] = ACTIONS(3316),
    [anon_sym_instanceof] = ACTIONS(3318),
    [anon_sym_yield] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [sym_null] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [anon_sym_CARET] = ACTIONS(3310),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3310),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [sym_super] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_default] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [sym_this] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_STAR_STAR] = ACTIONS(3310),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [sym_false] = ACTIONS(3316),
    [anon_sym_case] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3316),
    [sym_number] = ACTIONS(3314),
    [ts_builtin_sym_end] = ACTIONS(3314),
    [anon_sym_function] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_await] = ACTIONS(3316),
  },
  [824] = {
    [sym_statement_block] = STATE(1022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(836),
  },
  [825] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [sym__automatic_semicolon] = ACTIONS(3320),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_LT_LT] = ACTIONS(3320),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_GT_GT_GT] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_LT_EQ] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_QMARK] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_as] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_instanceof] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3320),
    [anon_sym_CARET] = ACTIONS(3320),
    [anon_sym_STAR_STAR] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG] = ACTIONS(3322),
  },
  [826] = {
    [sym_arrow_function] = STATE(389),
    [sym_await_expression] = STATE(389),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(389),
    [sym_meta_property] = STATE(389),
    [sym__expression] = STATE(389),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(389),
    [sym_call_expression] = STATE(389),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(389),
    [sym_string] = STATE(389),
    [sym_template_string] = STATE(389),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(389),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(389),
    [sym_generator_function] = STATE(389),
    [sym_new_expression] = STATE(389),
    [sym_assignment_expression] = STATE(389),
    [sym_augmented_assignment_expression] = STATE(389),
    [sym_binary_expression] = STATE(389),
    [sym_unary_expression] = STATE(389),
    [sym_regex] = STATE(389),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(389),
    [sym_as_expression] = STATE(389),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(389),
    [sym_class] = STATE(389),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(3324),
    [sym_false] = ACTIONS(868),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(868),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(868),
    [sym_number] = ACTIONS(870),
    [sym_true] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(868),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [827] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1829),
    [sym__automatic_semicolon] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_GT_GT_GT] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1831),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_PERCENT] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_instanceof] = ACTIONS(1829),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_STAR_STAR] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_in] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_EQ_EQ] = ACTIONS(1831),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1829),
  },
  [828] = {
    [sym_type_arguments] = STATE(1802),
    [sym_type_annotation] = STATE(2081),
    [aux_sym_array_repeat1] = STATE(625),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [829] = {
    [sym_identifier] = ACTIONS(3330),
    [anon_sym_BQUOTE] = ACTIONS(3332),
    [anon_sym_debugger] = ACTIONS(3330),
    [anon_sym_symbol] = ACTIONS(3330),
    [anon_sym_AT] = ACTIONS(3332),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_void] = ACTIONS(3330),
    [anon_sym_break] = ACTIONS(3330),
    [anon_sym_const] = ACTIONS(3330),
    [sym_super] = ACTIONS(3330),
    [anon_sym_return] = ACTIONS(3330),
    [anon_sym_private] = ACTIONS(3330),
    [anon_sym_static] = ACTIONS(3330),
    [anon_sym_get] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_interface] = ACTIONS(3330),
    [anon_sym_default] = ACTIONS(3330),
    [anon_sym_enum] = ACTIONS(3330),
    [anon_sym_delete] = ACTIONS(3330),
    [anon_sym_continue] = ACTIONS(3330),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_if] = ACTIONS(3330),
    [sym_this] = ACTIONS(3330),
    [anon_sym_yield] = ACTIONS(3330),
    [sym_true] = ACTIONS(3330),
    [anon_sym_throw] = ACTIONS(3330),
    [anon_sym_protected] = ACTIONS(3330),
    [anon_sym_abstract] = ACTIONS(3330),
    [anon_sym_set] = ACTIONS(3330),
    [anon_sym_type] = ACTIONS(3330),
    [anon_sym_import] = ACTIONS(3330),
    [anon_sym_namespace] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DQUOTE] = ACTIONS(3332),
    [anon_sym_else] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3332),
    [anon_sym_for] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [sym_false] = ACTIONS(3330),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_case] = ACTIONS(3330),
    [anon_sym_module] = ACTIONS(3330),
    [anon_sym_number] = ACTIONS(3330),
    [anon_sym_class] = ACTIONS(3330),
    [anon_sym_declare] = ACTIONS(3330),
    [anon_sym_typeof] = ACTIONS(3330),
    [anon_sym_LBRACE] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3330),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [sym_null] = ACTIONS(3330),
    [anon_sym_any] = ACTIONS(3330),
    [anon_sym_boolean] = ACTIONS(3330),
    [anon_sym_async] = ACTIONS(3330),
    [anon_sym_public] = ACTIONS(3330),
    [anon_sym_var] = ACTIONS(3330),
    [anon_sym_while] = ACTIONS(3330),
    [anon_sym_SQUOTE] = ACTIONS(3332),
    [anon_sym_try] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3332),
    [sym_number] = ACTIONS(3332),
    [anon_sym_SLASH] = ACTIONS(3330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3330),
    [anon_sym_function] = ACTIONS(3330),
    [sym_undefined] = ACTIONS(3330),
    [anon_sym_new] = ACTIONS(3330),
    [ts_builtin_sym_end] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3330),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_export] = ACTIONS(3330),
    [anon_sym_do] = ACTIONS(3330),
    [anon_sym_TILDE] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3330),
    [anon_sym_await] = ACTIONS(3330),
  },
  [830] = {
    [sym__automatic_semicolon] = ACTIONS(3334),
    [anon_sym_SEMI] = ACTIONS(3334),
    [anon_sym_from] = ACTIONS(3334),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [sym__import_export_specifier] = STATE(1027),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [832] = {
    [sym__automatic_semicolon] = ACTIONS(3338),
    [anon_sym_SEMI] = ACTIONS(3338),
    [anon_sym_from] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
  },
  [833] = {
    [aux_sym_export_clause_repeat1] = STATE(1029),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
  },
  [834] = {
    [sym_identifier] = ACTIONS(3342),
    [anon_sym_BQUOTE] = ACTIONS(3344),
    [anon_sym_debugger] = ACTIONS(3342),
    [anon_sym_symbol] = ACTIONS(3342),
    [anon_sym_AT] = ACTIONS(3344),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_void] = ACTIONS(3342),
    [anon_sym_break] = ACTIONS(3342),
    [anon_sym_const] = ACTIONS(3342),
    [sym_super] = ACTIONS(3342),
    [anon_sym_return] = ACTIONS(3342),
    [anon_sym_private] = ACTIONS(3342),
    [anon_sym_static] = ACTIONS(3342),
    [anon_sym_get] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_interface] = ACTIONS(3342),
    [anon_sym_default] = ACTIONS(3342),
    [anon_sym_enum] = ACTIONS(3342),
    [anon_sym_delete] = ACTIONS(3342),
    [anon_sym_continue] = ACTIONS(3342),
    [anon_sym_DASH_DASH] = ACTIONS(3344),
    [anon_sym_if] = ACTIONS(3342),
    [sym_this] = ACTIONS(3342),
    [anon_sym_yield] = ACTIONS(3342),
    [sym_true] = ACTIONS(3342),
    [anon_sym_throw] = ACTIONS(3342),
    [anon_sym_protected] = ACTIONS(3342),
    [anon_sym_abstract] = ACTIONS(3342),
    [anon_sym_set] = ACTIONS(3342),
    [anon_sym_type] = ACTIONS(3342),
    [anon_sym_import] = ACTIONS(3342),
    [anon_sym_namespace] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3344),
    [anon_sym_DQUOTE] = ACTIONS(3344),
    [anon_sym_else] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3344),
    [anon_sym_for] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3344),
    [sym_false] = ACTIONS(3342),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_case] = ACTIONS(3342),
    [anon_sym_module] = ACTIONS(3342),
    [anon_sym_number] = ACTIONS(3342),
    [anon_sym_class] = ACTIONS(3342),
    [anon_sym_declare] = ACTIONS(3342),
    [anon_sym_typeof] = ACTIONS(3342),
    [anon_sym_LBRACE] = ACTIONS(3344),
    [anon_sym_switch] = ACTIONS(3342),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [sym_null] = ACTIONS(3342),
    [anon_sym_any] = ACTIONS(3342),
    [anon_sym_boolean] = ACTIONS(3342),
    [anon_sym_async] = ACTIONS(3342),
    [anon_sym_public] = ACTIONS(3342),
    [anon_sym_var] = ACTIONS(3342),
    [anon_sym_while] = ACTIONS(3342),
    [anon_sym_SQUOTE] = ACTIONS(3344),
    [anon_sym_try] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3344),
    [sym_number] = ACTIONS(3344),
    [anon_sym_SLASH] = ACTIONS(3342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3342),
    [anon_sym_function] = ACTIONS(3342),
    [sym_undefined] = ACTIONS(3342),
    [anon_sym_new] = ACTIONS(3342),
    [ts_builtin_sym_end] = ACTIONS(3344),
    [anon_sym_let] = ACTIONS(3342),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_export] = ACTIONS(3342),
    [anon_sym_do] = ACTIONS(3342),
    [anon_sym_TILDE] = ACTIONS(3344),
    [anon_sym_with] = ACTIONS(3342),
    [anon_sym_await] = ACTIONS(3342),
  },
  [835] = {
    [sym__automatic_semicolon] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [sym__automatic_semicolon] = ACTIONS(3348),
    [anon_sym_SEMI] = ACTIONS(3348),
    [sym_comment] = ACTIONS(3),
  },
  [837] = {
    [sym_arrow_function] = STATE(1032),
    [sym_await_expression] = STATE(1032),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(1032),
    [sym_meta_property] = STATE(1032),
    [sym__expression] = STATE(1032),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1032),
    [sym_call_expression] = STATE(1032),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1032),
    [sym_string] = STATE(1032),
    [sym_template_string] = STATE(1032),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1032),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(1032),
    [sym_generator_function] = STATE(1032),
    [sym_new_expression] = STATE(1032),
    [sym_assignment_expression] = STATE(1032),
    [sym_augmented_assignment_expression] = STATE(1032),
    [sym_binary_expression] = STATE(1032),
    [sym_unary_expression] = STATE(1032),
    [sym_regex] = STATE(1032),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1032),
    [sym_as_expression] = STATE(1032),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(1032),
    [sym_class] = STATE(1032),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3350),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(3350),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3350),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3350),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [838] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(3354),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [839] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [840] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [841] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [842] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1141),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [843] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1127),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [844] = {
    [sym_formal_parameters] = STATE(1034),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [845] = {
    [sym_type_annotation] = STATE(287),
    [anon_sym_EQ_GT] = ACTIONS(3370),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [846] = {
    [sym_type_annotation] = STATE(593),
    [anon_sym_EQ_GT] = ACTIONS(3373),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [847] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3376),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3376),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [848] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3378),
    [sym__automatic_semicolon] = ACTIONS(3380),
    [anon_sym_BQUOTE] = ACTIONS(3382),
    [anon_sym_symbol] = ACTIONS(3384),
    [anon_sym_PIPE] = ACTIONS(3386),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_GT_GT_GT] = ACTIONS(3378),
    [anon_sym_break] = ACTIONS(3384),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_return] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3384),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_PERCENT] = ACTIONS(3378),
    [anon_sym_interface] = ACTIONS(3384),
    [anon_sym_as] = ACTIONS(3386),
    [anon_sym_delete] = ACTIONS(3384),
    [anon_sym_if] = ACTIONS(3384),
    [anon_sym_instanceof] = ACTIONS(3386),
    [anon_sym_yield] = ACTIONS(3384),
    [sym_true] = ACTIONS(3384),
    [anon_sym_protected] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3386),
    [anon_sym_set] = ACTIONS(3384),
    [anon_sym_import] = ACTIONS(3384),
    [anon_sym_in] = ACTIONS(3386),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [anon_sym_for] = ACTIONS(3384),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym_number] = ACTIONS(3384),
    [anon_sym_typeof] = ACTIONS(3384),
    [anon_sym_LT_LT] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3384),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [sym_null] = ACTIONS(3384),
    [anon_sym_any] = ACTIONS(3384),
    [anon_sym_async] = ACTIONS(3384),
    [anon_sym_public] = ACTIONS(3384),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3384),
    [anon_sym_SQUOTE] = ACTIONS(3382),
    [anon_sym_SLASH] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3384),
    [anon_sym_new] = ACTIONS(3384),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_export] = ACTIONS(3384),
    [anon_sym_GT_GT] = ACTIONS(3386),
    [anon_sym_with] = ACTIONS(3384),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3378),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_debugger] = ACTIONS(3384),
    [anon_sym_AT] = ACTIONS(3382),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_void] = ACTIONS(3384),
    [anon_sym_const] = ACTIONS(3384),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [sym_super] = ACTIONS(3384),
    [anon_sym_private] = ACTIONS(3384),
    [anon_sym_get] = ACTIONS(3384),
    [anon_sym_default] = ACTIONS(3384),
    [anon_sym_enum] = ACTIONS(3384),
    [anon_sym_continue] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [sym_this] = ACTIONS(3384),
    [anon_sym_throw] = ACTIONS(3384),
    [anon_sym_abstract] = ACTIONS(3384),
    [anon_sym_type] = ACTIONS(3384),
    [anon_sym_STAR_STAR] = ACTIONS(3378),
    [anon_sym_namespace] = ACTIONS(3384),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_else] = ACTIONS(3384),
    [anon_sym_BANG] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [sym_false] = ACTIONS(3384),
    [anon_sym_case] = ACTIONS(3384),
    [anon_sym_module] = ACTIONS(3384),
    [anon_sym_class] = ACTIONS(3384),
    [anon_sym_declare] = ACTIONS(3384),
    [anon_sym_LPAREN] = ACTIONS(3382),
    [anon_sym_GT] = ACTIONS(3386),
    [anon_sym_boolean] = ACTIONS(3384),
    [anon_sym_AMP] = ACTIONS(3386),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_try] = ACTIONS(3384),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_LT] = ACTIONS(3384),
    [sym_number] = ACTIONS(3382),
    [ts_builtin_sym_end] = ACTIONS(3382),
    [anon_sym_function] = ACTIONS(3384),
    [sym_undefined] = ACTIONS(3384),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(3384),
    [anon_sym_TILDE] = ACTIONS(3382),
    [anon_sym_await] = ACTIONS(3384),
  },
  [849] = {
    [sym_class_body] = STATE(1037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [850] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1038),
    [sym_class_heritage] = STATE(1039),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [851] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [sym__automatic_semicolon] = ACTIONS(3388),
    [anon_sym_SEMI] = ACTIONS(3388),
    [anon_sym_BQUOTE] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_GT_GT_GT] = ACTIONS(3388),
    [anon_sym_AMP_AMP] = ACTIONS(3388),
    [anon_sym_DASH] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3388),
    [anon_sym_GT_EQ] = ACTIONS(3388),
    [anon_sym_GT] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3390),
    [anon_sym_PERCENT] = ACTIONS(3388),
    [anon_sym_QMARK] = ACTIONS(3388),
    [anon_sym_RBRACE] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3388),
    [anon_sym_PIPE_PIPE] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_instanceof] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3390),
    [anon_sym_SLASH] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_CARET] = ACTIONS(3388),
    [anon_sym_STAR_STAR] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3390),
    [anon_sym_GT_GT] = ACTIONS(3390),
    [anon_sym_PLUS_PLUS] = ACTIONS(3388),
    [anon_sym_in] = ACTIONS(3390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3388),
    [anon_sym_BANG] = ACTIONS(3390),
  },
  [852] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [sym__automatic_semicolon] = ACTIONS(3392),
    [anon_sym_SEMI] = ACTIONS(3392),
    [anon_sym_BQUOTE] = ACTIONS(3392),
    [anon_sym_PIPE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_GT_GT_GT] = ACTIONS(3392),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3394),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LPAREN] = ACTIONS(3392),
    [anon_sym_GT_EQ] = ACTIONS(3392),
    [anon_sym_GT] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3394),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_QMARK] = ACTIONS(3392),
    [anon_sym_RBRACE] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3392),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_instanceof] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3394),
    [anon_sym_SLASH] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_STAR_STAR] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3394),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_PLUS_PLUS] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BANG] = ACTIONS(3394),
  },
  [853] = {
    [sym_class_body] = STATE(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [854] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [sym__automatic_semicolon] = ACTIONS(2884),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_GT_GT_GT] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_BANG_EQ] = ACTIONS(2892),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_DASH_DASH] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_instanceof] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_STAR_STAR] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2884),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2892),
  },
  [855] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2894),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [sym__automatic_semicolon] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_LT_LT] = ACTIONS(2894),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_PERCENT] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_as] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_instanceof] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2894),
    [anon_sym_CARET] = ACTIONS(2894),
    [anon_sym_STAR_STAR] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2902),
  },
  [856] = {
    [sym_class_body] = STATE(1041),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [857] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3022),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [858] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [859] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3054),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_RBRACE] = ACTIONS(3054),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [860] = {
    [sym_statement_block] = STATE(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [861] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1043),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [862] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3310),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [sym__automatic_semicolon] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3310),
    [anon_sym_BQUOTE] = ACTIONS(3310),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_LT_LT] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_instanceof] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3310),
    [anon_sym_CARET] = ACTIONS(3310),
    [anon_sym_STAR_STAR] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3310),
    [anon_sym_BANG] = ACTIONS(3318),
  },
  [863] = {
    [sym_statement_block] = STATE(1044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [864] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [sym__automatic_semicolon] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_BQUOTE] = ACTIONS(3378),
    [anon_sym_PIPE] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_LT_LT] = ACTIONS(3378),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_GT_GT_GT] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_DASH] = ACTIONS(3386),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [anon_sym_GT] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3386),
    [anon_sym_PERCENT] = ACTIONS(3378),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_as] = ACTIONS(3378),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3378),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_instanceof] = ACTIONS(3378),
    [anon_sym_LT] = ACTIONS(3386),
    [anon_sym_SLASH] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3378),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3386),
    [anon_sym_GT_GT] = ACTIONS(3386),
    [anon_sym_PLUS_PLUS] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3378),
    [anon_sym_BANG] = ACTIONS(3386),
  },
  [865] = {
    [sym_class_body] = STATE(1045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [866] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1046),
    [sym_class_heritage] = STATE(1047),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [867] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [sym__automatic_semicolon] = ACTIONS(3396),
    [anon_sym_SEMI] = ACTIONS(3396),
    [anon_sym_BQUOTE] = ACTIONS(3396),
    [anon_sym_PIPE] = ACTIONS(3398),
    [anon_sym_COMMA] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_GT_GT_GT] = ACTIONS(3396),
    [anon_sym_AMP_AMP] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3398),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_LT_EQ] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_GT_EQ] = ACTIONS(3396),
    [anon_sym_GT] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3398),
    [anon_sym_PERCENT] = ACTIONS(3396),
    [anon_sym_QMARK] = ACTIONS(3396),
    [anon_sym_RBRACE] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3396),
    [anon_sym_PIPE_PIPE] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_instanceof] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3398),
    [anon_sym_SLASH] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_CARET] = ACTIONS(3396),
    [anon_sym_STAR_STAR] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_GT_GT] = ACTIONS(3398),
    [anon_sym_PLUS_PLUS] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(3398),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
    [anon_sym_BANG] = ACTIONS(3398),
  },
  [868] = {
    [sym_identifier] = ACTIONS(3400),
    [anon_sym_BQUOTE] = ACTIONS(3402),
    [anon_sym_debugger] = ACTIONS(3400),
    [anon_sym_symbol] = ACTIONS(3400),
    [anon_sym_AT] = ACTIONS(3402),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_void] = ACTIONS(3400),
    [anon_sym_break] = ACTIONS(3400),
    [anon_sym_const] = ACTIONS(3400),
    [sym_super] = ACTIONS(3400),
    [anon_sym_return] = ACTIONS(3400),
    [anon_sym_private] = ACTIONS(3400),
    [anon_sym_static] = ACTIONS(3400),
    [anon_sym_get] = ACTIONS(3400),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_interface] = ACTIONS(3400),
    [anon_sym_default] = ACTIONS(3400),
    [anon_sym_enum] = ACTIONS(3400),
    [anon_sym_delete] = ACTIONS(3400),
    [anon_sym_continue] = ACTIONS(3400),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_if] = ACTIONS(3400),
    [sym_this] = ACTIONS(3400),
    [anon_sym_yield] = ACTIONS(3400),
    [sym_true] = ACTIONS(3400),
    [anon_sym_throw] = ACTIONS(3400),
    [anon_sym_protected] = ACTIONS(3400),
    [anon_sym_abstract] = ACTIONS(3400),
    [anon_sym_set] = ACTIONS(3400),
    [anon_sym_type] = ACTIONS(3400),
    [anon_sym_import] = ACTIONS(3400),
    [anon_sym_namespace] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DQUOTE] = ACTIONS(3402),
    [anon_sym_else] = ACTIONS(3400),
    [anon_sym_BANG] = ACTIONS(3402),
    [anon_sym_for] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [sym_false] = ACTIONS(3400),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_case] = ACTIONS(3400),
    [anon_sym_module] = ACTIONS(3400),
    [anon_sym_number] = ACTIONS(3400),
    [anon_sym_class] = ACTIONS(3400),
    [anon_sym_declare] = ACTIONS(3400),
    [anon_sym_typeof] = ACTIONS(3400),
    [anon_sym_LBRACE] = ACTIONS(3402),
    [anon_sym_switch] = ACTIONS(3400),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [sym_null] = ACTIONS(3400),
    [anon_sym_any] = ACTIONS(3400),
    [anon_sym_boolean] = ACTIONS(3400),
    [anon_sym_async] = ACTIONS(3400),
    [anon_sym_public] = ACTIONS(3400),
    [anon_sym_var] = ACTIONS(3400),
    [anon_sym_while] = ACTIONS(3400),
    [anon_sym_SQUOTE] = ACTIONS(3402),
    [anon_sym_try] = ACTIONS(3400),
    [anon_sym_LT] = ACTIONS(3402),
    [sym_number] = ACTIONS(3402),
    [anon_sym_SLASH] = ACTIONS(3400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3400),
    [anon_sym_function] = ACTIONS(3400),
    [sym_undefined] = ACTIONS(3400),
    [anon_sym_new] = ACTIONS(3400),
    [ts_builtin_sym_end] = ACTIONS(3402),
    [anon_sym_let] = ACTIONS(3400),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_export] = ACTIONS(3400),
    [anon_sym_do] = ACTIONS(3400),
    [anon_sym_TILDE] = ACTIONS(3402),
    [anon_sym_with] = ACTIONS(3400),
    [anon_sym_await] = ACTIONS(3400),
  },
  [869] = {
    [sym_computed_property_name] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym__property_name] = STATE(1049),
    [sym_enum_assignment] = STATE(1050),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(3404),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [870] = {
    [sym_identifier] = ACTIONS(3408),
    [anon_sym_BQUOTE] = ACTIONS(3410),
    [anon_sym_debugger] = ACTIONS(3408),
    [anon_sym_symbol] = ACTIONS(3408),
    [anon_sym_AT] = ACTIONS(3410),
    [anon_sym_DASH] = ACTIONS(3408),
    [anon_sym_void] = ACTIONS(3408),
    [anon_sym_break] = ACTIONS(3408),
    [anon_sym_const] = ACTIONS(3408),
    [sym_super] = ACTIONS(3408),
    [anon_sym_return] = ACTIONS(3408),
    [anon_sym_private] = ACTIONS(3408),
    [anon_sym_static] = ACTIONS(3408),
    [anon_sym_get] = ACTIONS(3408),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_interface] = ACTIONS(3408),
    [anon_sym_default] = ACTIONS(3408),
    [anon_sym_enum] = ACTIONS(3408),
    [anon_sym_delete] = ACTIONS(3408),
    [anon_sym_continue] = ACTIONS(3408),
    [anon_sym_DASH_DASH] = ACTIONS(3410),
    [anon_sym_if] = ACTIONS(3408),
    [sym_this] = ACTIONS(3408),
    [anon_sym_yield] = ACTIONS(3408),
    [sym_true] = ACTIONS(3408),
    [anon_sym_throw] = ACTIONS(3408),
    [anon_sym_protected] = ACTIONS(3408),
    [anon_sym_abstract] = ACTIONS(3408),
    [anon_sym_set] = ACTIONS(3408),
    [anon_sym_type] = ACTIONS(3408),
    [anon_sym_import] = ACTIONS(3408),
    [anon_sym_namespace] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3410),
    [anon_sym_DQUOTE] = ACTIONS(3410),
    [anon_sym_else] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3410),
    [anon_sym_for] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [sym_false] = ACTIONS(3408),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_case] = ACTIONS(3408),
    [anon_sym_module] = ACTIONS(3408),
    [anon_sym_number] = ACTIONS(3408),
    [anon_sym_class] = ACTIONS(3408),
    [anon_sym_declare] = ACTIONS(3408),
    [anon_sym_typeof] = ACTIONS(3408),
    [anon_sym_LBRACE] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3408),
    [anon_sym_LPAREN] = ACTIONS(3410),
    [sym_null] = ACTIONS(3408),
    [anon_sym_any] = ACTIONS(3408),
    [anon_sym_boolean] = ACTIONS(3408),
    [anon_sym_async] = ACTIONS(3408),
    [anon_sym_public] = ACTIONS(3408),
    [anon_sym_var] = ACTIONS(3408),
    [anon_sym_while] = ACTIONS(3408),
    [anon_sym_SQUOTE] = ACTIONS(3410),
    [anon_sym_try] = ACTIONS(3408),
    [anon_sym_LT] = ACTIONS(3410),
    [sym_number] = ACTIONS(3410),
    [anon_sym_SLASH] = ACTIONS(3408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3408),
    [anon_sym_function] = ACTIONS(3408),
    [sym_undefined] = ACTIONS(3408),
    [anon_sym_new] = ACTIONS(3408),
    [ts_builtin_sym_end] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3408),
    [anon_sym_PLUS] = ACTIONS(3408),
    [anon_sym_export] = ACTIONS(3408),
    [anon_sym_do] = ACTIONS(3408),
    [anon_sym_TILDE] = ACTIONS(3410),
    [anon_sym_with] = ACTIONS(3408),
    [anon_sym_await] = ACTIONS(3408),
  },
  [871] = {
    [anon_sym_COMMA] = ACTIONS(3412),
    [anon_sym_RBRACE] = ACTIONS(3412),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [aux_sym_enum_body_repeat1] = STATE(1052),
    [anon_sym_RBRACE] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
  },
  [873] = {
    [sym_identifier] = ACTIONS(3416),
    [anon_sym_BQUOTE] = ACTIONS(3418),
    [anon_sym_debugger] = ACTIONS(3416),
    [anon_sym_symbol] = ACTIONS(3416),
    [anon_sym_AT] = ACTIONS(3418),
    [anon_sym_DASH] = ACTIONS(3416),
    [anon_sym_void] = ACTIONS(3416),
    [anon_sym_break] = ACTIONS(3416),
    [anon_sym_const] = ACTIONS(3416),
    [sym_super] = ACTIONS(3416),
    [anon_sym_return] = ACTIONS(3416),
    [anon_sym_private] = ACTIONS(3416),
    [anon_sym_static] = ACTIONS(3416),
    [anon_sym_get] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_interface] = ACTIONS(3416),
    [anon_sym_default] = ACTIONS(3416),
    [anon_sym_enum] = ACTIONS(3416),
    [anon_sym_delete] = ACTIONS(3416),
    [anon_sym_continue] = ACTIONS(3416),
    [anon_sym_DASH_DASH] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(3416),
    [sym_this] = ACTIONS(3416),
    [anon_sym_yield] = ACTIONS(3416),
    [sym_true] = ACTIONS(3416),
    [anon_sym_throw] = ACTIONS(3416),
    [anon_sym_protected] = ACTIONS(3416),
    [anon_sym_abstract] = ACTIONS(3416),
    [anon_sym_set] = ACTIONS(3416),
    [anon_sym_type] = ACTIONS(3416),
    [anon_sym_import] = ACTIONS(3416),
    [anon_sym_namespace] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3418),
    [anon_sym_DQUOTE] = ACTIONS(3418),
    [anon_sym_else] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3418),
    [anon_sym_for] = ACTIONS(3416),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [sym_false] = ACTIONS(3416),
    [anon_sym_SEMI] = ACTIONS(3418),
    [anon_sym_case] = ACTIONS(3416),
    [anon_sym_module] = ACTIONS(3416),
    [anon_sym_number] = ACTIONS(3416),
    [anon_sym_class] = ACTIONS(3416),
    [anon_sym_declare] = ACTIONS(3416),
    [anon_sym_typeof] = ACTIONS(3416),
    [anon_sym_LBRACE] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3416),
    [anon_sym_LPAREN] = ACTIONS(3418),
    [sym_null] = ACTIONS(3416),
    [anon_sym_any] = ACTIONS(3416),
    [anon_sym_boolean] = ACTIONS(3416),
    [anon_sym_async] = ACTIONS(3416),
    [anon_sym_public] = ACTIONS(3416),
    [anon_sym_var] = ACTIONS(3416),
    [anon_sym_while] = ACTIONS(3416),
    [anon_sym_SQUOTE] = ACTIONS(3418),
    [anon_sym_try] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3418),
    [sym_number] = ACTIONS(3418),
    [anon_sym_SLASH] = ACTIONS(3416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3416),
    [anon_sym_function] = ACTIONS(3416),
    [sym_undefined] = ACTIONS(3416),
    [anon_sym_new] = ACTIONS(3416),
    [ts_builtin_sym_end] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3416),
    [anon_sym_PLUS] = ACTIONS(3416),
    [anon_sym_export] = ACTIONS(3416),
    [anon_sym_do] = ACTIONS(3416),
    [anon_sym_TILDE] = ACTIONS(3418),
    [anon_sym_with] = ACTIONS(3416),
    [anon_sym_await] = ACTIONS(3416),
  },
  [874] = {
    [sym_identifier] = ACTIONS(3420),
    [anon_sym_BQUOTE] = ACTIONS(3422),
    [anon_sym_debugger] = ACTIONS(3420),
    [anon_sym_symbol] = ACTIONS(3420),
    [anon_sym_AT] = ACTIONS(3422),
    [anon_sym_DASH] = ACTIONS(3420),
    [anon_sym_void] = ACTIONS(3420),
    [anon_sym_break] = ACTIONS(3420),
    [anon_sym_const] = ACTIONS(3420),
    [sym_super] = ACTIONS(3420),
    [anon_sym_return] = ACTIONS(3420),
    [anon_sym_private] = ACTIONS(3420),
    [anon_sym_static] = ACTIONS(3420),
    [anon_sym_get] = ACTIONS(3420),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_interface] = ACTIONS(3420),
    [anon_sym_default] = ACTIONS(3420),
    [anon_sym_enum] = ACTIONS(3420),
    [anon_sym_delete] = ACTIONS(3420),
    [anon_sym_continue] = ACTIONS(3420),
    [anon_sym_DASH_DASH] = ACTIONS(3422),
    [anon_sym_if] = ACTIONS(3420),
    [sym_this] = ACTIONS(3420),
    [anon_sym_yield] = ACTIONS(3420),
    [sym_true] = ACTIONS(3420),
    [anon_sym_throw] = ACTIONS(3420),
    [anon_sym_protected] = ACTIONS(3420),
    [anon_sym_abstract] = ACTIONS(3420),
    [anon_sym_set] = ACTIONS(3420),
    [anon_sym_type] = ACTIONS(3420),
    [anon_sym_import] = ACTIONS(3420),
    [anon_sym_namespace] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3422),
    [anon_sym_DQUOTE] = ACTIONS(3422),
    [anon_sym_else] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3422),
    [anon_sym_for] = ACTIONS(3420),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [sym_false] = ACTIONS(3420),
    [anon_sym_SEMI] = ACTIONS(3422),
    [anon_sym_case] = ACTIONS(3420),
    [anon_sym_module] = ACTIONS(3420),
    [anon_sym_number] = ACTIONS(3420),
    [anon_sym_class] = ACTIONS(3420),
    [anon_sym_declare] = ACTIONS(3420),
    [anon_sym_typeof] = ACTIONS(3420),
    [anon_sym_LBRACE] = ACTIONS(3422),
    [anon_sym_switch] = ACTIONS(3420),
    [anon_sym_LPAREN] = ACTIONS(3422),
    [sym_null] = ACTIONS(3420),
    [anon_sym_any] = ACTIONS(3420),
    [anon_sym_boolean] = ACTIONS(3420),
    [anon_sym_async] = ACTIONS(3420),
    [anon_sym_public] = ACTIONS(3420),
    [anon_sym_var] = ACTIONS(3420),
    [anon_sym_while] = ACTIONS(3420),
    [anon_sym_SQUOTE] = ACTIONS(3422),
    [anon_sym_try] = ACTIONS(3420),
    [anon_sym_LT] = ACTIONS(3422),
    [sym_number] = ACTIONS(3422),
    [anon_sym_SLASH] = ACTIONS(3420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3420),
    [anon_sym_function] = ACTIONS(3420),
    [sym_undefined] = ACTIONS(3420),
    [anon_sym_new] = ACTIONS(3420),
    [ts_builtin_sym_end] = ACTIONS(3422),
    [anon_sym_let] = ACTIONS(3420),
    [anon_sym_PLUS] = ACTIONS(3420),
    [anon_sym_export] = ACTIONS(3420),
    [anon_sym_do] = ACTIONS(3420),
    [anon_sym_TILDE] = ACTIONS(3422),
    [anon_sym_with] = ACTIONS(3420),
    [anon_sym_await] = ACTIONS(3420),
  },
  [875] = {
    [sym_identifier] = ACTIONS(3424),
    [anon_sym_BQUOTE] = ACTIONS(3426),
    [anon_sym_debugger] = ACTIONS(3424),
    [anon_sym_symbol] = ACTIONS(3424),
    [anon_sym_AT] = ACTIONS(3426),
    [anon_sym_DASH] = ACTIONS(3424),
    [anon_sym_void] = ACTIONS(3424),
    [anon_sym_break] = ACTIONS(3424),
    [anon_sym_const] = ACTIONS(3424),
    [sym_super] = ACTIONS(3424),
    [anon_sym_return] = ACTIONS(3424),
    [anon_sym_private] = ACTIONS(3424),
    [anon_sym_static] = ACTIONS(3424),
    [anon_sym_get] = ACTIONS(3424),
    [anon_sym_RBRACE] = ACTIONS(3426),
    [anon_sym_interface] = ACTIONS(3424),
    [anon_sym_default] = ACTIONS(3424),
    [anon_sym_enum] = ACTIONS(3424),
    [anon_sym_delete] = ACTIONS(3424),
    [anon_sym_continue] = ACTIONS(3424),
    [anon_sym_DASH_DASH] = ACTIONS(3426),
    [anon_sym_if] = ACTIONS(3424),
    [sym_this] = ACTIONS(3424),
    [anon_sym_yield] = ACTIONS(3424),
    [sym_true] = ACTIONS(3424),
    [anon_sym_throw] = ACTIONS(3424),
    [anon_sym_protected] = ACTIONS(3424),
    [anon_sym_abstract] = ACTIONS(3424),
    [anon_sym_set] = ACTIONS(3424),
    [anon_sym_type] = ACTIONS(3424),
    [anon_sym_import] = ACTIONS(3424),
    [anon_sym_namespace] = ACTIONS(3424),
    [anon_sym_PLUS_PLUS] = ACTIONS(3426),
    [anon_sym_DQUOTE] = ACTIONS(3426),
    [anon_sym_else] = ACTIONS(3424),
    [anon_sym_BANG] = ACTIONS(3426),
    [anon_sym_for] = ACTIONS(3424),
    [anon_sym_LBRACK] = ACTIONS(3426),
    [sym_false] = ACTIONS(3424),
    [anon_sym_SEMI] = ACTIONS(3426),
    [anon_sym_case] = ACTIONS(3424),
    [anon_sym_module] = ACTIONS(3424),
    [anon_sym_number] = ACTIONS(3424),
    [anon_sym_class] = ACTIONS(3424),
    [anon_sym_declare] = ACTIONS(3424),
    [anon_sym_typeof] = ACTIONS(3424),
    [anon_sym_LBRACE] = ACTIONS(3426),
    [anon_sym_switch] = ACTIONS(3424),
    [anon_sym_LPAREN] = ACTIONS(3426),
    [sym_null] = ACTIONS(3424),
    [anon_sym_any] = ACTIONS(3424),
    [anon_sym_boolean] = ACTIONS(3424),
    [anon_sym_async] = ACTIONS(3424),
    [anon_sym_public] = ACTIONS(3424),
    [anon_sym_var] = ACTIONS(3424),
    [anon_sym_while] = ACTIONS(3424),
    [anon_sym_SQUOTE] = ACTIONS(3426),
    [anon_sym_try] = ACTIONS(3424),
    [anon_sym_LT] = ACTIONS(3426),
    [sym_number] = ACTIONS(3426),
    [anon_sym_SLASH] = ACTIONS(3424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3424),
    [anon_sym_function] = ACTIONS(3424),
    [sym_undefined] = ACTIONS(3424),
    [anon_sym_new] = ACTIONS(3424),
    [ts_builtin_sym_end] = ACTIONS(3426),
    [anon_sym_let] = ACTIONS(3424),
    [anon_sym_PLUS] = ACTIONS(3424),
    [anon_sym_export] = ACTIONS(3424),
    [anon_sym_do] = ACTIONS(3424),
    [anon_sym_TILDE] = ACTIONS(3426),
    [anon_sym_with] = ACTIONS(3424),
    [anon_sym_await] = ACTIONS(3424),
  },
  [876] = {
    [sym_class_body] = STATE(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1871),
  },
  [877] = {
    [sym_identifier] = ACTIONS(3428),
    [anon_sym_BQUOTE] = ACTIONS(3430),
    [anon_sym_debugger] = ACTIONS(3428),
    [anon_sym_symbol] = ACTIONS(3428),
    [anon_sym_AT] = ACTIONS(3430),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_void] = ACTIONS(3428),
    [anon_sym_break] = ACTIONS(3428),
    [anon_sym_const] = ACTIONS(3428),
    [sym_super] = ACTIONS(3428),
    [anon_sym_return] = ACTIONS(3428),
    [anon_sym_private] = ACTIONS(3428),
    [anon_sym_static] = ACTIONS(3428),
    [anon_sym_get] = ACTIONS(3428),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_interface] = ACTIONS(3428),
    [anon_sym_default] = ACTIONS(3428),
    [anon_sym_enum] = ACTIONS(3428),
    [anon_sym_delete] = ACTIONS(3428),
    [anon_sym_continue] = ACTIONS(3428),
    [anon_sym_DASH_DASH] = ACTIONS(3430),
    [anon_sym_if] = ACTIONS(3428),
    [sym_this] = ACTIONS(3428),
    [anon_sym_yield] = ACTIONS(3428),
    [sym_true] = ACTIONS(3428),
    [anon_sym_throw] = ACTIONS(3428),
    [anon_sym_protected] = ACTIONS(3428),
    [anon_sym_abstract] = ACTIONS(3428),
    [anon_sym_set] = ACTIONS(3428),
    [anon_sym_type] = ACTIONS(3428),
    [anon_sym_import] = ACTIONS(3428),
    [anon_sym_namespace] = ACTIONS(3428),
    [anon_sym_PLUS_PLUS] = ACTIONS(3430),
    [anon_sym_DQUOTE] = ACTIONS(3430),
    [anon_sym_else] = ACTIONS(3428),
    [anon_sym_BANG] = ACTIONS(3430),
    [anon_sym_for] = ACTIONS(3428),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [sym_false] = ACTIONS(3428),
    [anon_sym_SEMI] = ACTIONS(3430),
    [anon_sym_case] = ACTIONS(3428),
    [anon_sym_module] = ACTIONS(3428),
    [anon_sym_number] = ACTIONS(3428),
    [anon_sym_class] = ACTIONS(3428),
    [anon_sym_declare] = ACTIONS(3428),
    [anon_sym_typeof] = ACTIONS(3428),
    [anon_sym_LBRACE] = ACTIONS(3430),
    [anon_sym_switch] = ACTIONS(3428),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [sym_null] = ACTIONS(3428),
    [anon_sym_any] = ACTIONS(3428),
    [anon_sym_boolean] = ACTIONS(3428),
    [anon_sym_async] = ACTIONS(3428),
    [anon_sym_public] = ACTIONS(3428),
    [anon_sym_var] = ACTIONS(3428),
    [anon_sym_while] = ACTIONS(3428),
    [anon_sym_SQUOTE] = ACTIONS(3430),
    [anon_sym_try] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3430),
    [sym_number] = ACTIONS(3430),
    [anon_sym_SLASH] = ACTIONS(3428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3428),
    [anon_sym_function] = ACTIONS(3428),
    [sym_undefined] = ACTIONS(3428),
    [anon_sym_new] = ACTIONS(3428),
    [ts_builtin_sym_end] = ACTIONS(3430),
    [anon_sym_let] = ACTIONS(3428),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_export] = ACTIONS(3428),
    [anon_sym_do] = ACTIONS(3428),
    [anon_sym_TILDE] = ACTIONS(3430),
    [anon_sym_with] = ACTIONS(3428),
    [anon_sym_await] = ACTIONS(3428),
  },
  [878] = {
    [sym__automatic_semicolon] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(3432),
    [anon_sym_PIPE] = ACTIONS(2756),
    [sym_comment] = ACTIONS(3),
  },
  [879] = {
    [sym_string] = STATE(1055),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [880] = {
    [sym_identifier] = ACTIONS(3434),
    [anon_sym_BQUOTE] = ACTIONS(3436),
    [anon_sym_debugger] = ACTIONS(3434),
    [anon_sym_symbol] = ACTIONS(3434),
    [anon_sym_AT] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3434),
    [anon_sym_void] = ACTIONS(3434),
    [anon_sym_break] = ACTIONS(3434),
    [anon_sym_const] = ACTIONS(3434),
    [sym_super] = ACTIONS(3434),
    [anon_sym_return] = ACTIONS(3434),
    [anon_sym_private] = ACTIONS(3434),
    [anon_sym_static] = ACTIONS(3434),
    [anon_sym_get] = ACTIONS(3434),
    [anon_sym_RBRACE] = ACTIONS(3436),
    [anon_sym_interface] = ACTIONS(3434),
    [anon_sym_default] = ACTIONS(3434),
    [anon_sym_enum] = ACTIONS(3434),
    [anon_sym_delete] = ACTIONS(3434),
    [anon_sym_continue] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3436),
    [anon_sym_if] = ACTIONS(3434),
    [sym_this] = ACTIONS(3434),
    [anon_sym_yield] = ACTIONS(3434),
    [sym_true] = ACTIONS(3434),
    [anon_sym_throw] = ACTIONS(3434),
    [anon_sym_protected] = ACTIONS(3434),
    [anon_sym_abstract] = ACTIONS(3434),
    [anon_sym_set] = ACTIONS(3434),
    [anon_sym_type] = ACTIONS(3434),
    [anon_sym_import] = ACTIONS(3434),
    [anon_sym_namespace] = ACTIONS(3434),
    [anon_sym_PLUS_PLUS] = ACTIONS(3436),
    [anon_sym_DQUOTE] = ACTIONS(3436),
    [anon_sym_else] = ACTIONS(3434),
    [anon_sym_BANG] = ACTIONS(3436),
    [anon_sym_for] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(3436),
    [sym_false] = ACTIONS(3434),
    [anon_sym_SEMI] = ACTIONS(3436),
    [anon_sym_case] = ACTIONS(3434),
    [anon_sym_module] = ACTIONS(3434),
    [anon_sym_number] = ACTIONS(3434),
    [anon_sym_class] = ACTIONS(3434),
    [anon_sym_declare] = ACTIONS(3434),
    [anon_sym_typeof] = ACTIONS(3434),
    [anon_sym_LBRACE] = ACTIONS(3436),
    [anon_sym_switch] = ACTIONS(3434),
    [anon_sym_LPAREN] = ACTIONS(3436),
    [sym_null] = ACTIONS(3434),
    [anon_sym_any] = ACTIONS(3434),
    [anon_sym_boolean] = ACTIONS(3434),
    [anon_sym_async] = ACTIONS(3434),
    [anon_sym_public] = ACTIONS(3434),
    [anon_sym_var] = ACTIONS(3434),
    [anon_sym_while] = ACTIONS(3434),
    [anon_sym_SQUOTE] = ACTIONS(3436),
    [anon_sym_try] = ACTIONS(3434),
    [anon_sym_LT] = ACTIONS(3436),
    [sym_number] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3434),
    [anon_sym_function] = ACTIONS(3434),
    [sym_undefined] = ACTIONS(3434),
    [anon_sym_new] = ACTIONS(3434),
    [ts_builtin_sym_end] = ACTIONS(3436),
    [anon_sym_let] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3434),
    [anon_sym_export] = ACTIONS(3434),
    [anon_sym_do] = ACTIONS(3434),
    [anon_sym_TILDE] = ACTIONS(3436),
    [anon_sym_with] = ACTIONS(3434),
    [anon_sym_await] = ACTIONS(3434),
  },
  [881] = {
    [sym_identifier] = ACTIONS(3438),
    [anon_sym_BQUOTE] = ACTIONS(3440),
    [anon_sym_debugger] = ACTIONS(3438),
    [anon_sym_symbol] = ACTIONS(3438),
    [anon_sym_AT] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3438),
    [anon_sym_void] = ACTIONS(3438),
    [anon_sym_break] = ACTIONS(3438),
    [anon_sym_const] = ACTIONS(3438),
    [sym_super] = ACTIONS(3438),
    [anon_sym_return] = ACTIONS(3438),
    [anon_sym_private] = ACTIONS(3438),
    [anon_sym_static] = ACTIONS(3438),
    [anon_sym_get] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3440),
    [anon_sym_interface] = ACTIONS(3438),
    [anon_sym_default] = ACTIONS(3438),
    [anon_sym_enum] = ACTIONS(3438),
    [anon_sym_delete] = ACTIONS(3438),
    [anon_sym_continue] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3440),
    [anon_sym_if] = ACTIONS(3438),
    [sym_this] = ACTIONS(3438),
    [anon_sym_yield] = ACTIONS(3438),
    [sym_true] = ACTIONS(3438),
    [anon_sym_throw] = ACTIONS(3438),
    [anon_sym_protected] = ACTIONS(3438),
    [anon_sym_abstract] = ACTIONS(3438),
    [anon_sym_set] = ACTIONS(3438),
    [anon_sym_type] = ACTIONS(3438),
    [anon_sym_import] = ACTIONS(3438),
    [anon_sym_namespace] = ACTIONS(3438),
    [anon_sym_PLUS_PLUS] = ACTIONS(3440),
    [anon_sym_DQUOTE] = ACTIONS(3440),
    [anon_sym_else] = ACTIONS(3438),
    [anon_sym_BANG] = ACTIONS(3440),
    [anon_sym_for] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(3440),
    [sym_false] = ACTIONS(3438),
    [anon_sym_SEMI] = ACTIONS(3440),
    [anon_sym_case] = ACTIONS(3438),
    [anon_sym_module] = ACTIONS(3438),
    [anon_sym_number] = ACTIONS(3438),
    [anon_sym_class] = ACTIONS(3438),
    [anon_sym_declare] = ACTIONS(3438),
    [anon_sym_typeof] = ACTIONS(3438),
    [anon_sym_LBRACE] = ACTIONS(3440),
    [anon_sym_switch] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3440),
    [sym_null] = ACTIONS(3438),
    [anon_sym_any] = ACTIONS(3438),
    [anon_sym_boolean] = ACTIONS(3438),
    [anon_sym_async] = ACTIONS(3438),
    [anon_sym_public] = ACTIONS(3438),
    [anon_sym_var] = ACTIONS(3438),
    [anon_sym_while] = ACTIONS(3438),
    [anon_sym_SQUOTE] = ACTIONS(3440),
    [anon_sym_try] = ACTIONS(3438),
    [anon_sym_LT] = ACTIONS(3440),
    [sym_number] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3438),
    [anon_sym_function] = ACTIONS(3438),
    [sym_undefined] = ACTIONS(3438),
    [anon_sym_new] = ACTIONS(3438),
    [ts_builtin_sym_end] = ACTIONS(3440),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3438),
    [anon_sym_export] = ACTIONS(3438),
    [anon_sym_do] = ACTIONS(3438),
    [anon_sym_TILDE] = ACTIONS(3440),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_await] = ACTIONS(3438),
  },
  [882] = {
    [anon_sym_COMMA] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [sym_comment] = ACTIONS(3),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3444),
    [sym_comment] = ACTIONS(3),
  },
  [884] = {
    [anon_sym_from] = ACTIONS(3446),
    [sym_comment] = ACTIONS(3),
  },
  [885] = {
    [anon_sym_COMMA] = ACTIONS(3448),
    [anon_sym_RBRACE] = ACTIONS(3448),
    [sym_comment] = ACTIONS(3),
  },
  [886] = {
    [sym__import_export_specifier] = STATE(885),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [aux_sym_named_imports_repeat1] = STATE(887),
    [anon_sym_COMMA] = ACTIONS(3452),
    [anon_sym_RBRACE] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
  },
  [888] = {
    [anon_sym_RPAREN] = ACTIONS(3457),
    [sym_comment] = ACTIONS(3),
  },
  [889] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3457),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [890] = {
    [anon_sym_RPAREN] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [891] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3459),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [892] = {
    [sym_arrow_function] = STATE(1061),
    [sym_await_expression] = STATE(1061),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(1061),
    [sym_meta_property] = STATE(1061),
    [sym__expression] = STATE(1061),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1061),
    [sym_call_expression] = STATE(1061),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1061),
    [sym_string] = STATE(1061),
    [sym_template_string] = STATE(1061),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1061),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(1061),
    [sym_generator_function] = STATE(1061),
    [sym_new_expression] = STATE(1061),
    [sym_assignment_expression] = STATE(1061),
    [sym_augmented_assignment_expression] = STATE(1061),
    [sym_binary_expression] = STATE(1061),
    [sym_unary_expression] = STATE(1061),
    [sym_regex] = STATE(1061),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1061),
    [sym_as_expression] = STATE(1061),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(1061),
    [sym_class] = STATE(1061),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3461),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3461),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3461),
    [sym_number] = ACTIONS(3463),
    [sym_true] = ACTIONS(3461),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3461),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [893] = {
    [sym_arrow_function] = STATE(1063),
    [sym_await_expression] = STATE(1063),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1062),
    [sym_meta_property] = STATE(1063),
    [sym_update_expression] = STATE(1063),
    [sym__expression] = STATE(1063),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1063),
    [sym_call_expression] = STATE(1063),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1063),
    [sym_string] = STATE(1063),
    [sym_template_string] = STATE(1063),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1063),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1063),
    [sym_generator_function] = STATE(1063),
    [sym_new_expression] = STATE(1063),
    [sym_assignment_expression] = STATE(1063),
    [sym_augmented_assignment_expression] = STATE(1063),
    [sym_binary_expression] = STATE(1063),
    [sym_unary_expression] = STATE(1063),
    [sym_regex] = STATE(1063),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1063),
    [sym_as_expression] = STATE(1063),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1063),
    [sym_class] = STATE(1063),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3465),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3465),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3465),
    [sym_number] = ACTIONS(3467),
    [sym_true] = ACTIONS(3465),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3465),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [894] = {
    [sym_arrow_function] = STATE(1065),
    [sym_await_expression] = STATE(1065),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1064),
    [sym_meta_property] = STATE(1065),
    [sym_update_expression] = STATE(1065),
    [sym__expression] = STATE(1065),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1065),
    [sym_call_expression] = STATE(1065),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1065),
    [sym_string] = STATE(1065),
    [sym_template_string] = STATE(1065),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1065),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1065),
    [sym_generator_function] = STATE(1065),
    [sym_new_expression] = STATE(1065),
    [sym_assignment_expression] = STATE(1065),
    [sym_augmented_assignment_expression] = STATE(1065),
    [sym_binary_expression] = STATE(1065),
    [sym_unary_expression] = STATE(1065),
    [sym_regex] = STATE(1065),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1065),
    [sym_as_expression] = STATE(1065),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1065),
    [sym_class] = STATE(1065),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3469),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3469),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3469),
    [sym_number] = ACTIONS(3471),
    [sym_true] = ACTIONS(3469),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3469),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [895] = {
    [sym_arrow_function] = STATE(1066),
    [sym_await_expression] = STATE(1066),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(1066),
    [sym_meta_property] = STATE(1066),
    [sym__expression] = STATE(1066),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1066),
    [sym_call_expression] = STATE(1066),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1066),
    [sym_string] = STATE(1066),
    [sym_template_string] = STATE(1066),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1066),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(1066),
    [sym_generator_function] = STATE(1066),
    [sym_new_expression] = STATE(1066),
    [sym_assignment_expression] = STATE(1066),
    [sym_augmented_assignment_expression] = STATE(1066),
    [sym_binary_expression] = STATE(1066),
    [sym_unary_expression] = STATE(1066),
    [sym_regex] = STATE(1066),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1066),
    [sym_as_expression] = STATE(1066),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(1066),
    [sym_class] = STATE(1066),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3473),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3473),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3473),
    [sym_number] = ACTIONS(3475),
    [sym_true] = ACTIONS(3473),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3473),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [896] = {
    [sym_arrow_function] = STATE(1068),
    [sym_await_expression] = STATE(1068),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1067),
    [sym_meta_property] = STATE(1068),
    [sym_update_expression] = STATE(1068),
    [sym__expression] = STATE(1068),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1068),
    [sym_call_expression] = STATE(1068),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1068),
    [sym_string] = STATE(1068),
    [sym_template_string] = STATE(1068),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1068),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1068),
    [sym_generator_function] = STATE(1068),
    [sym_new_expression] = STATE(1068),
    [sym_assignment_expression] = STATE(1068),
    [sym_augmented_assignment_expression] = STATE(1068),
    [sym_binary_expression] = STATE(1068),
    [sym_unary_expression] = STATE(1068),
    [sym_regex] = STATE(1068),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1068),
    [sym_as_expression] = STATE(1068),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1068),
    [sym_class] = STATE(1068),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3477),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3477),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3477),
    [sym_number] = ACTIONS(3479),
    [sym_true] = ACTIONS(3477),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3477),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [897] = {
    [sym_arrow_function] = STATE(1069),
    [sym_await_expression] = STATE(1069),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(1069),
    [sym_meta_property] = STATE(1069),
    [sym__expression] = STATE(1069),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1069),
    [sym_call_expression] = STATE(1069),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(1069),
    [sym_string] = STATE(1069),
    [sym_template_string] = STATE(1069),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1069),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(1069),
    [sym_generator_function] = STATE(1069),
    [sym_new_expression] = STATE(1069),
    [sym_assignment_expression] = STATE(1069),
    [sym_augmented_assignment_expression] = STATE(1069),
    [sym_binary_expression] = STATE(1069),
    [sym_unary_expression] = STATE(1069),
    [sym_regex] = STATE(1069),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(1069),
    [sym_as_expression] = STATE(1069),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(1069),
    [sym_class] = STATE(1069),
    [anon_sym_await] = ACTIONS(107),
    [sym_identifier] = ACTIONS(147),
    [sym_false] = ACTIONS(3481),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(3481),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(3481),
    [sym_number] = ACTIONS(3483),
    [sym_true] = ACTIONS(3481),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(3481),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
  },
  [898] = {
    [sym_arrow_function] = STATE(1071),
    [sym_await_expression] = STATE(1071),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1070),
    [sym_meta_property] = STATE(1071),
    [sym_update_expression] = STATE(1071),
    [sym__expression] = STATE(1071),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1071),
    [sym_call_expression] = STATE(1071),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1071),
    [sym_string] = STATE(1071),
    [sym_template_string] = STATE(1071),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1071),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1071),
    [sym_generator_function] = STATE(1071),
    [sym_new_expression] = STATE(1071),
    [sym_assignment_expression] = STATE(1071),
    [sym_augmented_assignment_expression] = STATE(1071),
    [sym_binary_expression] = STATE(1071),
    [sym_unary_expression] = STATE(1071),
    [sym_regex] = STATE(1071),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1071),
    [sym_as_expression] = STATE(1071),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1071),
    [sym_class] = STATE(1071),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3485),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3485),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3485),
    [sym_number] = ACTIONS(3487),
    [sym_true] = ACTIONS(3485),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3485),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [899] = {
    [sym_generator_function_declaration] = STATE(1072),
    [sym__declaration] = STATE(1072),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1072),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1072),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1072),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1072),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1072),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1072),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1072),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1072),
    [sym_function_declaration] = STATE(1072),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1072),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1072),
    [sym_break_statement] = STATE(1072),
    [sym_labeled_statement] = STATE(1072),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(1072),
    [sym_class_declaration] = STATE(1072),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1072),
    [sym_ambient_declaration] = STATE(1072),
    [sym_type_alias_declaration] = STATE(1072),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1072),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1072),
    [sym_switch_statement] = STATE(1072),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1072),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1072),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1072),
    [sym_abstract_class_declaration] = STATE(1072),
    [sym_interface_declaration] = STATE(1072),
    [sym_export_statement] = STATE(1072),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1072),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1072),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1072),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1072),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [900] = {
    [anon_sym_RPAREN] = ACTIONS(3489),
    [sym_comment] = ACTIONS(3),
  },
  [901] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3489),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [902] = {
    [anon_sym_RPAREN] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3491),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [904] = {
    [anon_sym_RPAREN] = ACTIONS(3493),
    [sym_comment] = ACTIONS(3),
  },
  [905] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3493),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [906] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_of] = ACTIONS(2806),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2810),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [907] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_of] = ACTIONS(2830),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [908] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_of] = ACTIONS(2837),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2839),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [909] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(3495),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(2033),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(3495),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [910] = {
    [anon_sym_implements] = ACTIONS(3497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3499),
  },
  [911] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_LBRACE] = ACTIONS(3497),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(3497),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [912] = {
    [sym_type_arguments] = STATE(539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3497),
    [anon_sym_implements] = ACTIONS(3497),
    [anon_sym_LT] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(3497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3499),
  },
  [913] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(1743),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3501),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(3507),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_implements] = ACTIONS(3501),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [914] = {
    [aux_sym_extends_clause_repeat1] = STATE(914),
    [anon_sym_implements] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3497),
  },
  [915] = {
    [sym_identifier] = ACTIONS(3513),
    [anon_sym_BQUOTE] = ACTIONS(3515),
    [anon_sym_debugger] = ACTIONS(3513),
    [anon_sym_symbol] = ACTIONS(3513),
    [anon_sym_AT] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_void] = ACTIONS(3513),
    [anon_sym_break] = ACTIONS(3513),
    [anon_sym_const] = ACTIONS(3513),
    [sym_super] = ACTIONS(3513),
    [anon_sym_return] = ACTIONS(3513),
    [anon_sym_private] = ACTIONS(3513),
    [anon_sym_static] = ACTIONS(3513),
    [anon_sym_get] = ACTIONS(3513),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_interface] = ACTIONS(3513),
    [anon_sym_default] = ACTIONS(3513),
    [anon_sym_enum] = ACTIONS(3513),
    [anon_sym_delete] = ACTIONS(3513),
    [anon_sym_continue] = ACTIONS(3513),
    [anon_sym_DASH_DASH] = ACTIONS(3515),
    [anon_sym_if] = ACTIONS(3513),
    [sym_this] = ACTIONS(3513),
    [anon_sym_yield] = ACTIONS(3513),
    [sym_true] = ACTIONS(3513),
    [anon_sym_throw] = ACTIONS(3513),
    [anon_sym_protected] = ACTIONS(3513),
    [anon_sym_abstract] = ACTIONS(3513),
    [anon_sym_set] = ACTIONS(3513),
    [anon_sym_type] = ACTIONS(3513),
    [anon_sym_import] = ACTIONS(3513),
    [anon_sym_namespace] = ACTIONS(3513),
    [anon_sym_PLUS_PLUS] = ACTIONS(3515),
    [anon_sym_DQUOTE] = ACTIONS(3515),
    [anon_sym_else] = ACTIONS(3513),
    [anon_sym_BANG] = ACTIONS(3515),
    [anon_sym_for] = ACTIONS(3513),
    [anon_sym_LBRACK] = ACTIONS(3515),
    [sym_false] = ACTIONS(3513),
    [anon_sym_SEMI] = ACTIONS(3515),
    [anon_sym_case] = ACTIONS(3513),
    [anon_sym_module] = ACTIONS(3513),
    [anon_sym_number] = ACTIONS(3513),
    [anon_sym_class] = ACTIONS(3513),
    [anon_sym_declare] = ACTIONS(3513),
    [anon_sym_typeof] = ACTIONS(3513),
    [anon_sym_LBRACE] = ACTIONS(3515),
    [anon_sym_switch] = ACTIONS(3513),
    [anon_sym_LPAREN] = ACTIONS(3515),
    [sym_null] = ACTIONS(3513),
    [anon_sym_any] = ACTIONS(3513),
    [anon_sym_boolean] = ACTIONS(3513),
    [anon_sym_async] = ACTIONS(3513),
    [anon_sym_public] = ACTIONS(3513),
    [anon_sym_var] = ACTIONS(3513),
    [anon_sym_while] = ACTIONS(3513),
    [anon_sym_SQUOTE] = ACTIONS(3515),
    [anon_sym_try] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(3515),
    [sym_number] = ACTIONS(3515),
    [anon_sym_SLASH] = ACTIONS(3513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3513),
    [anon_sym_function] = ACTIONS(3513),
    [sym_undefined] = ACTIONS(3513),
    [anon_sym_new] = ACTIONS(3513),
    [ts_builtin_sym_end] = ACTIONS(3515),
    [anon_sym_let] = ACTIONS(3513),
    [anon_sym_PLUS] = ACTIONS(3513),
    [anon_sym_export] = ACTIONS(3513),
    [anon_sym_do] = ACTIONS(3513),
    [anon_sym_TILDE] = ACTIONS(3515),
    [anon_sym_with] = ACTIONS(3513),
    [anon_sym_await] = ACTIONS(3513),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(3519),
    [anon_sym_debugger] = ACTIONS(3517),
    [anon_sym_symbol] = ACTIONS(3517),
    [anon_sym_AT] = ACTIONS(3519),
    [anon_sym_DASH] = ACTIONS(3517),
    [anon_sym_void] = ACTIONS(3517),
    [anon_sym_break] = ACTIONS(3517),
    [anon_sym_const] = ACTIONS(3517),
    [sym_super] = ACTIONS(3517),
    [anon_sym_return] = ACTIONS(3517),
    [anon_sym_private] = ACTIONS(3517),
    [anon_sym_static] = ACTIONS(3517),
    [anon_sym_get] = ACTIONS(3517),
    [anon_sym_RBRACE] = ACTIONS(3519),
    [anon_sym_interface] = ACTIONS(3517),
    [anon_sym_default] = ACTIONS(3517),
    [anon_sym_enum] = ACTIONS(3517),
    [anon_sym_delete] = ACTIONS(3517),
    [anon_sym_continue] = ACTIONS(3517),
    [anon_sym_DASH_DASH] = ACTIONS(3519),
    [anon_sym_if] = ACTIONS(3517),
    [sym_this] = ACTIONS(3517),
    [anon_sym_yield] = ACTIONS(3517),
    [sym_true] = ACTIONS(3517),
    [anon_sym_throw] = ACTIONS(3517),
    [anon_sym_protected] = ACTIONS(3517),
    [anon_sym_abstract] = ACTIONS(3517),
    [anon_sym_set] = ACTIONS(3517),
    [anon_sym_type] = ACTIONS(3517),
    [anon_sym_import] = ACTIONS(3517),
    [anon_sym_namespace] = ACTIONS(3517),
    [anon_sym_PLUS_PLUS] = ACTIONS(3519),
    [anon_sym_DQUOTE] = ACTIONS(3519),
    [anon_sym_else] = ACTIONS(3517),
    [anon_sym_BANG] = ACTIONS(3519),
    [anon_sym_for] = ACTIONS(3517),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [sym_false] = ACTIONS(3517),
    [anon_sym_SEMI] = ACTIONS(3519),
    [anon_sym_case] = ACTIONS(3517),
    [anon_sym_module] = ACTIONS(3517),
    [anon_sym_number] = ACTIONS(3517),
    [anon_sym_class] = ACTIONS(3517),
    [anon_sym_declare] = ACTIONS(3517),
    [anon_sym_typeof] = ACTIONS(3517),
    [anon_sym_LBRACE] = ACTIONS(3519),
    [anon_sym_switch] = ACTIONS(3517),
    [anon_sym_LPAREN] = ACTIONS(3519),
    [sym_null] = ACTIONS(3517),
    [anon_sym_any] = ACTIONS(3517),
    [anon_sym_boolean] = ACTIONS(3517),
    [anon_sym_async] = ACTIONS(3517),
    [anon_sym_public] = ACTIONS(3517),
    [anon_sym_var] = ACTIONS(3517),
    [anon_sym_while] = ACTIONS(3517),
    [anon_sym_SQUOTE] = ACTIONS(3519),
    [anon_sym_try] = ACTIONS(3517),
    [anon_sym_LT] = ACTIONS(3519),
    [sym_number] = ACTIONS(3519),
    [anon_sym_SLASH] = ACTIONS(3517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3517),
    [anon_sym_function] = ACTIONS(3517),
    [sym_undefined] = ACTIONS(3517),
    [anon_sym_new] = ACTIONS(3517),
    [ts_builtin_sym_end] = ACTIONS(3519),
    [anon_sym_let] = ACTIONS(3517),
    [anon_sym_PLUS] = ACTIONS(3517),
    [anon_sym_export] = ACTIONS(3517),
    [anon_sym_do] = ACTIONS(3517),
    [anon_sym_TILDE] = ACTIONS(3519),
    [anon_sym_with] = ACTIONS(3517),
    [anon_sym_await] = ACTIONS(3517),
  },
  [917] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3521),
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3525),
    [anon_sym_symbol] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3521),
    [anon_sym_break] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3529),
    [anon_sym_delete] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3527),
    [anon_sym_instanceof] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3527),
    [sym_true] = ACTIONS(3527),
    [anon_sym_protected] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3529),
    [anon_sym_set] = ACTIONS(3527),
    [anon_sym_import] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_number] = ACTIONS(3527),
    [anon_sym_typeof] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_switch] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3521),
    [sym_null] = ACTIONS(3527),
    [anon_sym_any] = ACTIONS(3527),
    [anon_sym_async] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(3527),
    [anon_sym_var] = ACTIONS(3527),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_export] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3521),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_debugger] = ACTIONS(3527),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_void] = ACTIONS(3527),
    [anon_sym_const] = ACTIONS(3527),
    [anon_sym_GT_EQ] = ACTIONS(3521),
    [sym_super] = ACTIONS(3527),
    [anon_sym_private] = ACTIONS(3527),
    [anon_sym_get] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_enum] = ACTIONS(3527),
    [anon_sym_continue] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3525),
    [sym_this] = ACTIONS(3527),
    [anon_sym_throw] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3525),
    [anon_sym_else] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [sym_false] = ACTIONS(3527),
    [anon_sym_case] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_class] = ACTIONS(3527),
    [anon_sym_declare] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3525),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_boolean] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3527),
    [sym_number] = ACTIONS(3525),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [anon_sym_function] = ACTIONS(3527),
    [sym_undefined] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [anon_sym_await] = ACTIONS(3527),
  },
  [918] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1077),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [919] = {
    [sym_statement_block] = STATE(1524),
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [920] = {
    [sym_predefined_type] = STATE(1078),
    [anon_sym_void] = ACTIONS(3533),
    [anon_sym_string] = ACTIONS(3533),
    [anon_sym_symbol] = ACTIONS(3533),
    [anon_sym_number] = ACTIONS(3533),
    [anon_sym_any] = ACTIONS(3533),
    [anon_sym_boolean] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
  },
  [921] = {
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1079),
    [sym_function_type] = STATE(1079),
    [sym_constructor_type] = STATE(1079),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(236),
    [sym_nested_type_identifier] = STATE(238),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1079),
    [sym__type] = STATE(1079),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_symbol] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [anon_sym_typeof] = ACTIONS(471),
    [sym_true] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_keyof] = ACTIONS(477),
    [sym_number] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_boolean] = ACTIONS(467),
  },
  [922] = {
    [sym_predefined_type] = STATE(1080),
    [anon_sym_void] = ACTIONS(3533),
    [anon_sym_string] = ACTIONS(3533),
    [anon_sym_symbol] = ACTIONS(3533),
    [anon_sym_number] = ACTIONS(3533),
    [anon_sym_any] = ACTIONS(3533),
    [anon_sym_boolean] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
  },
  [923] = {
    [sym__automatic_semicolon] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
  },
  [924] = {
    [sym_type_annotation] = STATE(1081),
    [anon_sym_COLON] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
  },
  [925] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1083),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [926] = {
    [sym__initializer] = STATE(1085),
    [sym_type_annotation] = STATE(1086),
    [sym__automatic_semicolon] = ACTIONS(3537),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3539),
  },
  [927] = {
    [sym_type_annotation] = STATE(1089),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1088),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1087),
    [sym__automatic_semicolon] = ACTIONS(3541),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
  },
  [928] = {
    [sym__initializer] = STATE(1088),
    [sym_type_annotation] = STATE(1089),
    [sym__automatic_semicolon] = ACTIONS(3541),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_COMMA] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
  },
  [929] = {
    [sym__automatic_semicolon] = ACTIONS(3543),
    [anon_sym_SEMI] = ACTIONS(3543),
    [anon_sym_COMMA] = ACTIONS(3543),
    [sym_comment] = ACTIONS(3),
  },
  [930] = {
    [sym__automatic_semicolon] = ACTIONS(3545),
    [anon_sym_SEMI] = ACTIONS(3545),
    [anon_sym_COMMA] = ACTIONS(3545),
    [sym_comment] = ACTIONS(3),
  },
  [931] = {
    [sym__initializer] = STATE(1090),
    [sym__automatic_semicolon] = ACTIONS(3547),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(3547),
    [anon_sym_COMMA] = ACTIONS(3547),
    [sym_comment] = ACTIONS(3),
  },
  [932] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1092),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3549),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [933] = {
    [sym_string] = STATE(1093),
    [sym__property_name] = STATE(1093),
    [sym_computed_property_name] = STATE(1093),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [934] = {
    [sym_string] = STATE(1093),
    [sym__property_name] = STATE(1093),
    [sym_computed_property_name] = STATE(1093),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [935] = {
    [sym_type_annotation] = STATE(1089),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1088),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1077),
    [sym__automatic_semicolon] = ACTIONS(3541),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
  },
  [936] = {
    [sym_string] = STATE(1093),
    [sym__property_name] = STATE(1093),
    [sym_computed_property_name] = STATE(1093),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3553),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3555),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3555),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [937] = {
    [sym_type_annotation] = STATE(1086),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1085),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1092),
    [sym__automatic_semicolon] = ACTIONS(3537),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3557),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3539),
  },
  [938] = {
    [sym_string] = STATE(1098),
    [sym__property_name] = STATE(1098),
    [sym_computed_property_name] = STATE(1098),
    [anon_sym_get] = ACTIONS(3559),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3563),
    [anon_sym_STAR] = ACTIONS(3553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3559),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [939] = {
    [sym_string] = STATE(1099),
    [sym__property_name] = STATE(1099),
    [sym_computed_property_name] = STATE(1099),
    [anon_sym_get] = ACTIONS(960),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(960),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(960),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [940] = {
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_computed_property_name] = STATE(1100),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [941] = {
    [sym_string] = STATE(1100),
    [sym__property_name] = STATE(1100),
    [sym_computed_property_name] = STATE(1100),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [942] = {
    [sym_type_annotation] = STATE(1086),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1085),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1083),
    [sym__automatic_semicolon] = ACTIONS(3537),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3537),
    [anon_sym_QMARK] = ACTIONS(3569),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3537),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3539),
  },
  [943] = {
    [sym_statement_block] = STATE(1525),
    [sym__automatic_semicolon] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_COMMA] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [944] = {
    [sym__automatic_semicolon] = ACTIONS(3573),
    [anon_sym_SEMI] = ACTIONS(3573),
    [anon_sym_COMMA] = ACTIONS(3573),
    [sym_comment] = ACTIONS(3),
  },
  [945] = {
    [sym__initializer] = STATE(1102),
    [sym__automatic_semicolon] = ACTIONS(3575),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(3575),
    [anon_sym_COMMA] = ACTIONS(3575),
    [sym_comment] = ACTIONS(3),
  },
  [946] = {
    [sym__automatic_semicolon] = ACTIONS(3577),
    [anon_sym_SEMI] = ACTIONS(3577),
    [anon_sym_COMMA] = ACTIONS(3577),
    [sym_comment] = ACTIONS(3),
  },
  [947] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1103),
    [sym_function_type] = STATE(1103),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1103),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1103),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1103),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [948] = {
    [sym__automatic_semicolon] = ACTIONS(2886),
    [sym_identifier] = ACTIONS(2890),
    [anon_sym_BQUOTE] = ACTIONS(2888),
    [anon_sym_debugger] = ACTIONS(2890),
    [anon_sym_symbol] = ACTIONS(2890),
    [anon_sym_AT] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2890),
    [anon_sym_void] = ACTIONS(2890),
    [anon_sym_break] = ACTIONS(2890),
    [anon_sym_const] = ACTIONS(2890),
    [sym_super] = ACTIONS(2890),
    [anon_sym_return] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_static] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_interface] = ACTIONS(2890),
    [anon_sym_default] = ACTIONS(2890),
    [anon_sym_enum] = ACTIONS(2890),
    [anon_sym_delete] = ACTIONS(2890),
    [anon_sym_continue] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2888),
    [anon_sym_if] = ACTIONS(2890),
    [sym_this] = ACTIONS(2890),
    [anon_sym_yield] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [anon_sym_throw] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_abstract] = ACTIONS(2890),
    [anon_sym_set] = ACTIONS(2890),
    [anon_sym_type] = ACTIONS(2890),
    [anon_sym_import] = ACTIONS(2890),
    [anon_sym_namespace] = ACTIONS(2890),
    [anon_sym_PLUS_PLUS] = ACTIONS(2888),
    [anon_sym_DQUOTE] = ACTIONS(2888),
    [anon_sym_else] = ACTIONS(2890),
    [anon_sym_BANG] = ACTIONS(2888),
    [anon_sym_for] = ACTIONS(2890),
    [anon_sym_LBRACK] = ACTIONS(2888),
    [sym_false] = ACTIONS(2890),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_case] = ACTIONS(2890),
    [anon_sym_module] = ACTIONS(2890),
    [anon_sym_number] = ACTIONS(2890),
    [anon_sym_class] = ACTIONS(2890),
    [anon_sym_declare] = ACTIONS(2890),
    [anon_sym_typeof] = ACTIONS(2890),
    [anon_sym_LBRACE] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2888),
    [sym_null] = ACTIONS(2890),
    [anon_sym_any] = ACTIONS(2890),
    [anon_sym_boolean] = ACTIONS(2890),
    [anon_sym_async] = ACTIONS(2890),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_var] = ACTIONS(2890),
    [anon_sym_while] = ACTIONS(2890),
    [anon_sym_SQUOTE] = ACTIONS(2888),
    [anon_sym_try] = ACTIONS(2890),
    [anon_sym_LT] = ACTIONS(2888),
    [sym_number] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2890),
    [anon_sym_function] = ACTIONS(2890),
    [sym_undefined] = ACTIONS(2890),
    [anon_sym_new] = ACTIONS(2890),
    [ts_builtin_sym_end] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2890),
    [anon_sym_export] = ACTIONS(2890),
    [anon_sym_do] = ACTIONS(2890),
    [anon_sym_TILDE] = ACTIONS(2888),
    [anon_sym_with] = ACTIONS(2890),
    [anon_sym_await] = ACTIONS(2890),
  },
  [949] = {
    [sym__automatic_semicolon] = ACTIONS(2896),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_BQUOTE] = ACTIONS(2898),
    [anon_sym_debugger] = ACTIONS(2900),
    [anon_sym_symbol] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2898),
    [anon_sym_DASH] = ACTIONS(2900),
    [anon_sym_void] = ACTIONS(2900),
    [anon_sym_break] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [sym_super] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_private] = ACTIONS(2900),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_get] = ACTIONS(2900),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_interface] = ACTIONS(2900),
    [anon_sym_default] = ACTIONS(2900),
    [anon_sym_enum] = ACTIONS(2900),
    [anon_sym_delete] = ACTIONS(2900),
    [anon_sym_continue] = ACTIONS(2900),
    [anon_sym_DASH_DASH] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2900),
    [sym_this] = ACTIONS(2900),
    [anon_sym_yield] = ACTIONS(2900),
    [sym_true] = ACTIONS(2900),
    [anon_sym_throw] = ACTIONS(2900),
    [anon_sym_protected] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_set] = ACTIONS(2900),
    [anon_sym_type] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_namespace] = ACTIONS(2900),
    [anon_sym_PLUS_PLUS] = ACTIONS(2898),
    [anon_sym_DQUOTE] = ACTIONS(2898),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_BANG] = ACTIONS(2898),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [sym_false] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_case] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_number] = ACTIONS(2900),
    [anon_sym_class] = ACTIONS(2900),
    [anon_sym_declare] = ACTIONS(2900),
    [anon_sym_typeof] = ACTIONS(2900),
    [anon_sym_LBRACE] = ACTIONS(2898),
    [anon_sym_switch] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [sym_null] = ACTIONS(2900),
    [anon_sym_any] = ACTIONS(2900),
    [anon_sym_boolean] = ACTIONS(2900),
    [anon_sym_async] = ACTIONS(2900),
    [anon_sym_public] = ACTIONS(2900),
    [anon_sym_var] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_LT] = ACTIONS(2898),
    [sym_number] = ACTIONS(2898),
    [anon_sym_SLASH] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [sym_undefined] = ACTIONS(2900),
    [anon_sym_new] = ACTIONS(2900),
    [ts_builtin_sym_end] = ACTIONS(2898),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_do] = ACTIONS(2900),
    [anon_sym_TILDE] = ACTIONS(2898),
    [anon_sym_with] = ACTIONS(2900),
    [anon_sym_await] = ACTIONS(2900),
  },
  [950] = {
    [sym_class_body] = STATE(1104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [951] = {
    [sym_statement_block] = STATE(1105),
    [sym__automatic_semicolon] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3015),
  },
  [952] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1106),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [953] = {
    [sym__automatic_semicolon] = ACTIONS(3312),
    [sym_identifier] = ACTIONS(3316),
    [anon_sym_BQUOTE] = ACTIONS(3314),
    [anon_sym_debugger] = ACTIONS(3316),
    [anon_sym_symbol] = ACTIONS(3316),
    [anon_sym_AT] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3316),
    [anon_sym_void] = ACTIONS(3316),
    [anon_sym_break] = ACTIONS(3316),
    [anon_sym_const] = ACTIONS(3316),
    [sym_super] = ACTIONS(3316),
    [anon_sym_return] = ACTIONS(3316),
    [anon_sym_private] = ACTIONS(3316),
    [anon_sym_static] = ACTIONS(3316),
    [anon_sym_get] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_interface] = ACTIONS(3316),
    [anon_sym_default] = ACTIONS(3316),
    [anon_sym_enum] = ACTIONS(3316),
    [anon_sym_delete] = ACTIONS(3316),
    [anon_sym_continue] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3314),
    [anon_sym_if] = ACTIONS(3316),
    [sym_this] = ACTIONS(3316),
    [anon_sym_yield] = ACTIONS(3316),
    [sym_true] = ACTIONS(3316),
    [anon_sym_throw] = ACTIONS(3316),
    [anon_sym_protected] = ACTIONS(3316),
    [anon_sym_abstract] = ACTIONS(3316),
    [anon_sym_set] = ACTIONS(3316),
    [anon_sym_type] = ACTIONS(3316),
    [anon_sym_import] = ACTIONS(3316),
    [anon_sym_namespace] = ACTIONS(3316),
    [anon_sym_PLUS_PLUS] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(3314),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_BANG] = ACTIONS(3314),
    [anon_sym_for] = ACTIONS(3316),
    [anon_sym_LBRACK] = ACTIONS(3314),
    [sym_false] = ACTIONS(3316),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_case] = ACTIONS(3316),
    [anon_sym_module] = ACTIONS(3316),
    [anon_sym_number] = ACTIONS(3316),
    [anon_sym_class] = ACTIONS(3316),
    [anon_sym_declare] = ACTIONS(3316),
    [anon_sym_typeof] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3314),
    [sym_null] = ACTIONS(3316),
    [anon_sym_any] = ACTIONS(3316),
    [anon_sym_boolean] = ACTIONS(3316),
    [anon_sym_async] = ACTIONS(3316),
    [anon_sym_public] = ACTIONS(3316),
    [anon_sym_var] = ACTIONS(3316),
    [anon_sym_while] = ACTIONS(3316),
    [anon_sym_SQUOTE] = ACTIONS(3314),
    [anon_sym_try] = ACTIONS(3316),
    [anon_sym_LT] = ACTIONS(3314),
    [sym_number] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3316),
    [anon_sym_function] = ACTIONS(3316),
    [sym_undefined] = ACTIONS(3316),
    [anon_sym_new] = ACTIONS(3316),
    [ts_builtin_sym_end] = ACTIONS(3314),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3316),
    [anon_sym_export] = ACTIONS(3316),
    [anon_sym_do] = ACTIONS(3316),
    [anon_sym_TILDE] = ACTIONS(3314),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_await] = ACTIONS(3316),
  },
  [954] = {
    [sym_statement_block] = STATE(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3015),
  },
  [955] = {
    [sym__automatic_semicolon] = ACTIONS(3380),
    [sym_identifier] = ACTIONS(3384),
    [anon_sym_BQUOTE] = ACTIONS(3382),
    [anon_sym_debugger] = ACTIONS(3384),
    [anon_sym_symbol] = ACTIONS(3384),
    [anon_sym_AT] = ACTIONS(3382),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_void] = ACTIONS(3384),
    [anon_sym_break] = ACTIONS(3384),
    [anon_sym_const] = ACTIONS(3384),
    [sym_super] = ACTIONS(3384),
    [anon_sym_return] = ACTIONS(3384),
    [anon_sym_private] = ACTIONS(3384),
    [anon_sym_static] = ACTIONS(3384),
    [anon_sym_get] = ACTIONS(3384),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_interface] = ACTIONS(3384),
    [anon_sym_default] = ACTIONS(3384),
    [anon_sym_enum] = ACTIONS(3384),
    [anon_sym_delete] = ACTIONS(3384),
    [anon_sym_continue] = ACTIONS(3384),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_if] = ACTIONS(3384),
    [sym_this] = ACTIONS(3384),
    [anon_sym_yield] = ACTIONS(3384),
    [sym_true] = ACTIONS(3384),
    [anon_sym_throw] = ACTIONS(3384),
    [anon_sym_protected] = ACTIONS(3384),
    [anon_sym_abstract] = ACTIONS(3384),
    [anon_sym_set] = ACTIONS(3384),
    [anon_sym_type] = ACTIONS(3384),
    [anon_sym_import] = ACTIONS(3384),
    [anon_sym_namespace] = ACTIONS(3384),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_DQUOTE] = ACTIONS(3382),
    [anon_sym_else] = ACTIONS(3384),
    [anon_sym_BANG] = ACTIONS(3382),
    [anon_sym_for] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [sym_false] = ACTIONS(3384),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym_case] = ACTIONS(3384),
    [anon_sym_module] = ACTIONS(3384),
    [anon_sym_number] = ACTIONS(3384),
    [anon_sym_class] = ACTIONS(3384),
    [anon_sym_declare] = ACTIONS(3384),
    [anon_sym_typeof] = ACTIONS(3384),
    [anon_sym_LBRACE] = ACTIONS(3382),
    [anon_sym_switch] = ACTIONS(3384),
    [anon_sym_LPAREN] = ACTIONS(3382),
    [sym_null] = ACTIONS(3384),
    [anon_sym_any] = ACTIONS(3384),
    [anon_sym_boolean] = ACTIONS(3384),
    [anon_sym_async] = ACTIONS(3384),
    [anon_sym_public] = ACTIONS(3384),
    [anon_sym_var] = ACTIONS(3384),
    [anon_sym_while] = ACTIONS(3384),
    [anon_sym_SQUOTE] = ACTIONS(3382),
    [anon_sym_try] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3382),
    [sym_number] = ACTIONS(3382),
    [anon_sym_SLASH] = ACTIONS(3384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3384),
    [anon_sym_function] = ACTIONS(3384),
    [sym_undefined] = ACTIONS(3384),
    [anon_sym_new] = ACTIONS(3384),
    [ts_builtin_sym_end] = ACTIONS(3382),
    [anon_sym_let] = ACTIONS(3384),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_export] = ACTIONS(3384),
    [anon_sym_do] = ACTIONS(3384),
    [anon_sym_TILDE] = ACTIONS(3382),
    [anon_sym_with] = ACTIONS(3384),
    [anon_sym_await] = ACTIONS(3384),
  },
  [956] = {
    [sym_class_body] = STATE(1108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [957] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1109),
    [sym_class_heritage] = STATE(1110),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [958] = {
    [sym_statement_block] = STATE(1111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [959] = {
    [anon_sym_COMMA] = ACTIONS(3589),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
  },
  [960] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1112),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [961] = {
    [sym_statement_block] = STATE(1113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [962] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1115),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [963] = {
    [sym_string] = STATE(1116),
    [sym__property_name] = STATE(1116),
    [sym_computed_property_name] = STATE(1116),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [964] = {
    [sym_string] = STATE(1116),
    [sym__property_name] = STATE(1116),
    [sym_computed_property_name] = STATE(1116),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [965] = {
    [anon_sym_COMMA] = ACTIONS(3595),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
  },
  [966] = {
    [sym_string] = STATE(1116),
    [sym__property_name] = STATE(1116),
    [sym_computed_property_name] = STATE(1116),
    [anon_sym_get] = ACTIONS(3597),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(3597),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [967] = {
    [anon_sym_COLON] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
  },
  [968] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3601),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [969] = {
    [sym_generator_function_declaration] = STATE(1120),
    [sym__declaration] = STATE(1120),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1120),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1120),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1120),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1120),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1120),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1120),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1120),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1120),
    [sym_function_declaration] = STATE(1120),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1120),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1120),
    [sym_break_statement] = STATE(1120),
    [sym_labeled_statement] = STATE(1120),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(1120),
    [sym_class_declaration] = STATE(1120),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1120),
    [sym_ambient_declaration] = STATE(1120),
    [sym_type_alias_declaration] = STATE(1120),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1120),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1120),
    [sym_switch_statement] = STATE(1120),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1120),
    [sym_throw_statement] = STATE(1120),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1120),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1120),
    [sym_abstract_class_declaration] = STATE(1120),
    [sym_interface_declaration] = STATE(1120),
    [sym_export_statement] = STATE(1120),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1120),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1120),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1120),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1120),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3603),
    [anon_sym_default] = ACTIONS(3605),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(3605),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [970] = {
    [sym_identifier] = ACTIONS(3607),
    [anon_sym_BQUOTE] = ACTIONS(3609),
    [anon_sym_debugger] = ACTIONS(3607),
    [anon_sym_symbol] = ACTIONS(3607),
    [anon_sym_AT] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_void] = ACTIONS(3607),
    [anon_sym_break] = ACTIONS(3607),
    [anon_sym_const] = ACTIONS(3607),
    [sym_super] = ACTIONS(3607),
    [anon_sym_return] = ACTIONS(3607),
    [anon_sym_private] = ACTIONS(3607),
    [anon_sym_static] = ACTIONS(3607),
    [anon_sym_get] = ACTIONS(3607),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_interface] = ACTIONS(3607),
    [anon_sym_default] = ACTIONS(3607),
    [anon_sym_enum] = ACTIONS(3607),
    [anon_sym_delete] = ACTIONS(3607),
    [anon_sym_continue] = ACTIONS(3607),
    [anon_sym_DASH_DASH] = ACTIONS(3609),
    [anon_sym_if] = ACTIONS(3607),
    [sym_this] = ACTIONS(3607),
    [anon_sym_yield] = ACTIONS(3607),
    [sym_true] = ACTIONS(3607),
    [anon_sym_throw] = ACTIONS(3607),
    [anon_sym_protected] = ACTIONS(3607),
    [anon_sym_abstract] = ACTIONS(3607),
    [anon_sym_set] = ACTIONS(3607),
    [anon_sym_type] = ACTIONS(3607),
    [anon_sym_import] = ACTIONS(3607),
    [anon_sym_namespace] = ACTIONS(3607),
    [anon_sym_PLUS_PLUS] = ACTIONS(3609),
    [anon_sym_DQUOTE] = ACTIONS(3609),
    [anon_sym_else] = ACTIONS(3607),
    [anon_sym_BANG] = ACTIONS(3609),
    [anon_sym_for] = ACTIONS(3607),
    [anon_sym_LBRACK] = ACTIONS(3609),
    [sym_false] = ACTIONS(3607),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_case] = ACTIONS(3607),
    [anon_sym_module] = ACTIONS(3607),
    [anon_sym_number] = ACTIONS(3607),
    [anon_sym_class] = ACTIONS(3607),
    [anon_sym_declare] = ACTIONS(3607),
    [anon_sym_typeof] = ACTIONS(3607),
    [anon_sym_LBRACE] = ACTIONS(3609),
    [anon_sym_switch] = ACTIONS(3607),
    [anon_sym_LPAREN] = ACTIONS(3609),
    [sym_null] = ACTIONS(3607),
    [anon_sym_any] = ACTIONS(3607),
    [anon_sym_boolean] = ACTIONS(3607),
    [anon_sym_async] = ACTIONS(3607),
    [anon_sym_public] = ACTIONS(3607),
    [anon_sym_var] = ACTIONS(3607),
    [anon_sym_while] = ACTIONS(3607),
    [anon_sym_SQUOTE] = ACTIONS(3609),
    [anon_sym_try] = ACTIONS(3607),
    [anon_sym_LT] = ACTIONS(3609),
    [sym_number] = ACTIONS(3609),
    [anon_sym_SLASH] = ACTIONS(3607),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3607),
    [anon_sym_function] = ACTIONS(3607),
    [sym_undefined] = ACTIONS(3607),
    [anon_sym_new] = ACTIONS(3607),
    [ts_builtin_sym_end] = ACTIONS(3609),
    [anon_sym_let] = ACTIONS(3607),
    [anon_sym_PLUS] = ACTIONS(3607),
    [anon_sym_export] = ACTIONS(3607),
    [anon_sym_do] = ACTIONS(3607),
    [anon_sym_TILDE] = ACTIONS(3609),
    [anon_sym_with] = ACTIONS(3607),
    [anon_sym_await] = ACTIONS(3607),
  },
  [971] = {
    [sym_switch_case] = STATE(971),
    [sym_switch_default] = STATE(971),
    [aux_sym_switch_body_repeat1] = STATE(971),
    [anon_sym_RBRACE] = ACTIONS(3611),
    [anon_sym_default] = ACTIONS(3613),
    [anon_sym_case] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
  },
  [972] = {
    [anon_sym_COMMA] = ACTIONS(3619),
    [anon_sym_RPAREN] = ACTIONS(3619),
    [sym_comment] = ACTIONS(3),
  },
  [973] = {
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_EQ_GT] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3621),
  },
  [974] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [sym_this] = ACTIONS(1195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_boolean] = ACTIONS(1197),
  },
  [975] = {
    [anon_sym_COMMA] = ACTIONS(3623),
    [anon_sym_RPAREN] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
  },
  [976] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(3625),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [977] = {
    [sym_identifier] = ACTIONS(3627),
    [anon_sym_BQUOTE] = ACTIONS(3629),
    [anon_sym_debugger] = ACTIONS(3627),
    [anon_sym_symbol] = ACTIONS(3627),
    [anon_sym_AT] = ACTIONS(3629),
    [anon_sym_DASH] = ACTIONS(3627),
    [anon_sym_void] = ACTIONS(3627),
    [anon_sym_break] = ACTIONS(3627),
    [anon_sym_const] = ACTIONS(3627),
    [sym_super] = ACTIONS(3627),
    [anon_sym_return] = ACTIONS(3627),
    [anon_sym_private] = ACTIONS(3627),
    [anon_sym_static] = ACTIONS(3627),
    [anon_sym_get] = ACTIONS(3627),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_interface] = ACTIONS(3627),
    [anon_sym_default] = ACTIONS(3627),
    [anon_sym_enum] = ACTIONS(3627),
    [anon_sym_delete] = ACTIONS(3627),
    [anon_sym_continue] = ACTIONS(3627),
    [anon_sym_DASH_DASH] = ACTIONS(3629),
    [anon_sym_if] = ACTIONS(3627),
    [sym_this] = ACTIONS(3627),
    [anon_sym_yield] = ACTIONS(3627),
    [sym_true] = ACTIONS(3627),
    [anon_sym_throw] = ACTIONS(3627),
    [anon_sym_protected] = ACTIONS(3627),
    [anon_sym_abstract] = ACTIONS(3627),
    [anon_sym_set] = ACTIONS(3627),
    [anon_sym_type] = ACTIONS(3627),
    [anon_sym_import] = ACTIONS(3627),
    [anon_sym_namespace] = ACTIONS(3627),
    [anon_sym_PLUS_PLUS] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3629),
    [anon_sym_else] = ACTIONS(3627),
    [anon_sym_BANG] = ACTIONS(3629),
    [anon_sym_for] = ACTIONS(3627),
    [anon_sym_LBRACK] = ACTIONS(3629),
    [sym_false] = ACTIONS(3627),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_case] = ACTIONS(3627),
    [anon_sym_module] = ACTIONS(3627),
    [anon_sym_number] = ACTIONS(3627),
    [anon_sym_class] = ACTIONS(3627),
    [anon_sym_declare] = ACTIONS(3627),
    [anon_sym_typeof] = ACTIONS(3627),
    [anon_sym_LBRACE] = ACTIONS(3629),
    [anon_sym_switch] = ACTIONS(3627),
    [anon_sym_LPAREN] = ACTIONS(3629),
    [sym_null] = ACTIONS(3627),
    [anon_sym_any] = ACTIONS(3627),
    [anon_sym_boolean] = ACTIONS(3627),
    [anon_sym_async] = ACTIONS(3627),
    [anon_sym_public] = ACTIONS(3627),
    [anon_sym_var] = ACTIONS(3627),
    [anon_sym_while] = ACTIONS(3627),
    [anon_sym_SQUOTE] = ACTIONS(3629),
    [anon_sym_try] = ACTIONS(3627),
    [anon_sym_LT] = ACTIONS(3629),
    [sym_number] = ACTIONS(3629),
    [anon_sym_SLASH] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3627),
    [anon_sym_function] = ACTIONS(3627),
    [sym_undefined] = ACTIONS(3627),
    [anon_sym_new] = ACTIONS(3627),
    [ts_builtin_sym_end] = ACTIONS(3629),
    [anon_sym_let] = ACTIONS(3627),
    [anon_sym_PLUS] = ACTIONS(3627),
    [anon_sym_export] = ACTIONS(3627),
    [anon_sym_do] = ACTIONS(3627),
    [anon_sym_TILDE] = ACTIONS(3629),
    [anon_sym_with] = ACTIONS(3627),
    [anon_sym_await] = ACTIONS(3627),
  },
  [978] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3631),
    [sym__automatic_semicolon] = ACTIONS(3633),
    [anon_sym_BQUOTE] = ACTIONS(3635),
    [anon_sym_symbol] = ACTIONS(3637),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3631),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_PERCENT] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_as] = ACTIONS(3639),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_if] = ACTIONS(3637),
    [anon_sym_instanceof] = ACTIONS(3639),
    [anon_sym_yield] = ACTIONS(3637),
    [sym_true] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_DOT] = ACTIONS(3639),
    [anon_sym_set] = ACTIONS(3637),
    [anon_sym_import] = ACTIONS(3637),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_number] = ACTIONS(3637),
    [anon_sym_typeof] = ACTIONS(3637),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_LT_EQ] = ACTIONS(3631),
    [sym_null] = ACTIONS(3637),
    [anon_sym_any] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_QMARK] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_export] = ACTIONS(3637),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_with] = ACTIONS(3637),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3631),
    [sym_identifier] = ACTIONS(3637),
    [anon_sym_debugger] = ACTIONS(3637),
    [anon_sym_AT] = ACTIONS(3635),
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_void] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [anon_sym_GT_EQ] = ACTIONS(3631),
    [sym_super] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_get] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [sym_this] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_abstract] = ACTIONS(3637),
    [anon_sym_type] = ACTIONS(3637),
    [anon_sym_STAR_STAR] = ACTIONS(3631),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [sym_false] = ACTIONS(3637),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_module] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_declare] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_boolean] = ACTIONS(3637),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_PIPE_PIPE] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_LT] = ACTIONS(3637),
    [sym_number] = ACTIONS(3635),
    [ts_builtin_sym_end] = ACTIONS(3635),
    [anon_sym_function] = ACTIONS(3637),
    [sym_undefined] = ACTIONS(3637),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_await] = ACTIONS(3637),
  },
  [979] = {
    [sym_statement_block] = STATE(1123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(836),
  },
  [980] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3641),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [sym__automatic_semicolon] = ACTIONS(3641),
    [anon_sym_SEMI] = ACTIONS(3641),
    [anon_sym_BQUOTE] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_GT_GT_GT] = ACTIONS(3641),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_BANG_EQ] = ACTIONS(3643),
    [anon_sym_LT_EQ] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_as] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3643),
    [anon_sym_instanceof] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_STAR_STAR] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_GT_GT] = ACTIONS(3643),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BANG] = ACTIONS(3643),
  },
  [981] = {
    [anon_sym_RPAREN] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [982] = {
    [anon_sym_RPAREN] = ACTIONS(3647),
    [sym_comment] = ACTIONS(3),
  },
  [983] = {
    [anon_sym_RPAREN] = ACTIONS(3649),
    [sym_comment] = ACTIONS(3),
  },
  [984] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3651),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [985] = {
    [anon_sym_BQUOTE] = ACTIONS(3653),
    [anon_sym_symbol] = ACTIONS(3655),
    [anon_sym_PIPE] = ACTIONS(3653),
    [anon_sym_break] = ACTIONS(3655),
    [anon_sym_return] = ACTIONS(3655),
    [anon_sym_static] = ACTIONS(3655),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_interface] = ACTIONS(3655),
    [anon_sym_delete] = ACTIONS(3655),
    [anon_sym_if] = ACTIONS(3655),
    [anon_sym_yield] = ACTIONS(3655),
    [sym_true] = ACTIONS(3655),
    [anon_sym_protected] = ACTIONS(3655),
    [anon_sym_set] = ACTIONS(3655),
    [anon_sym_import] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(3653),
    [anon_sym_for] = ACTIONS(3655),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_number] = ACTIONS(3655),
    [anon_sym_typeof] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_switch] = ACTIONS(3655),
    [anon_sym_RBRACK] = ACTIONS(3653),
    [sym_null] = ACTIONS(3655),
    [anon_sym_any] = ACTIONS(3655),
    [anon_sym_async] = ACTIONS(3655),
    [anon_sym_public] = ACTIONS(3655),
    [anon_sym_var] = ACTIONS(3655),
    [anon_sym_while] = ACTIONS(3655),
    [anon_sym_SQUOTE] = ACTIONS(3653),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [anon_sym_SLASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3655),
    [anon_sym_new] = ACTIONS(3655),
    [anon_sym_export] = ACTIONS(3655),
    [anon_sym_with] = ACTIONS(3655),
    [sym_identifier] = ACTIONS(3655),
    [anon_sym_debugger] = ACTIONS(3655),
    [anon_sym_AT] = ACTIONS(3653),
    [anon_sym_COMMA] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_void] = ACTIONS(3655),
    [anon_sym_const] = ACTIONS(3655),
    [sym_super] = ACTIONS(3655),
    [anon_sym_private] = ACTIONS(3655),
    [anon_sym_get] = ACTIONS(3655),
    [anon_sym_default] = ACTIONS(3655),
    [anon_sym_enum] = ACTIONS(3655),
    [anon_sym_continue] = ACTIONS(3655),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [sym_this] = ACTIONS(3655),
    [anon_sym_throw] = ACTIONS(3655),
    [anon_sym_abstract] = ACTIONS(3655),
    [anon_sym_type] = ACTIONS(3655),
    [anon_sym_namespace] = ACTIONS(3655),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_else] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [sym_false] = ACTIONS(3655),
    [anon_sym_case] = ACTIONS(3655),
    [anon_sym_module] = ACTIONS(3655),
    [anon_sym_class] = ACTIONS(3655),
    [anon_sym_declare] = ACTIONS(3655),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3653),
    [anon_sym_boolean] = ACTIONS(3655),
    [anon_sym_EQ_GT] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_try] = ACTIONS(3655),
    [anon_sym_LT] = ACTIONS(3653),
    [sym_number] = ACTIONS(3653),
    [ts_builtin_sym_end] = ACTIONS(3653),
    [anon_sym_function] = ACTIONS(3655),
    [sym_undefined] = ACTIONS(3655),
    [anon_sym_let] = ACTIONS(3655),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_do] = ACTIONS(3655),
    [anon_sym_TILDE] = ACTIONS(3653),
    [anon_sym_await] = ACTIONS(3655),
  },
  [986] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(3657),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_SEMI] = ACTIONS(3657),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3651),
    [anon_sym_COMMA] = ACTIONS(3657),
    [sym_comment] = ACTIONS(3),
  },
  [987] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1129),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [988] = {
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
  },
  [989] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1131),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [990] = {
    [sym_string] = STATE(1132),
    [sym__property_name] = STATE(1132),
    [sym_computed_property_name] = STATE(1132),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [991] = {
    [sym_string] = STATE(1132),
    [sym__property_name] = STATE(1132),
    [sym_computed_property_name] = STATE(1132),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [992] = {
    [sym_string] = STATE(1132),
    [sym__property_name] = STATE(1132),
    [sym_computed_property_name] = STATE(1132),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3663),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3665),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3665),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [993] = {
    [sym__call_signature] = STATE(1131),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1136),
    [sym__automatic_semicolon] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(3669),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
  },
  [994] = {
    [sym__call_signature] = STATE(1129),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1137),
    [sym__automatic_semicolon] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
  },
  [995] = {
    [sym__automatic_semicolon] = ACTIONS(3673),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_SEMI] = ACTIONS(3673),
    [anon_sym_COMMA] = ACTIONS(3673),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3673),
    [sym_comment] = ACTIONS(3),
  },
  [996] = {
    [sym__automatic_semicolon] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
  },
  [997] = {
    [sym_type_annotation] = STATE(1138),
    [sym__automatic_semicolon] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3675),
    [anon_sym_COMMA] = ACTIONS(3675),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3675),
    [sym_comment] = ACTIONS(3),
  },
  [998] = {
    [sym__automatic_semicolon] = ACTIONS(3677),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_SEMI] = ACTIONS(3677),
    [anon_sym_COMMA] = ACTIONS(3677),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3677),
    [sym_comment] = ACTIONS(3),
  },
  [999] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(3679),
    [anon_sym_RBRACE] = ACTIONS(3682),
    [anon_sym_SEMI] = ACTIONS(3679),
    [anon_sym_COMMA] = ACTIONS(3679),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
  },
  [1000] = {
    [sym_string] = STATE(1141),
    [sym__property_name] = STATE(1141),
    [sym_computed_property_name] = STATE(1141),
    [anon_sym_get] = ACTIONS(3684),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(3686),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3688),
    [anon_sym_STAR] = ACTIONS(3663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3684),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1001] = {
    [sym__automatic_semicolon] = ACTIONS(3690),
    [anon_sym_RBRACE] = ACTIONS(3690),
    [anon_sym_SEMI] = ACTIONS(3690),
    [anon_sym_COMMA] = ACTIONS(3690),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [sym__automatic_semicolon] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_COMMA] = ACTIONS(3571),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [anon_sym_BQUOTE] = ACTIONS(3692),
    [anon_sym_symbol] = ACTIONS(3694),
    [anon_sym_PIPE] = ACTIONS(3692),
    [anon_sym_break] = ACTIONS(3694),
    [anon_sym_return] = ACTIONS(3694),
    [anon_sym_static] = ACTIONS(3694),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [anon_sym_interface] = ACTIONS(3694),
    [anon_sym_delete] = ACTIONS(3694),
    [anon_sym_if] = ACTIONS(3694),
    [anon_sym_yield] = ACTIONS(3694),
    [sym_true] = ACTIONS(3694),
    [anon_sym_protected] = ACTIONS(3694),
    [anon_sym_set] = ACTIONS(3694),
    [anon_sym_import] = ACTIONS(3694),
    [anon_sym_DQUOTE] = ACTIONS(3692),
    [anon_sym_for] = ACTIONS(3694),
    [anon_sym_SEMI] = ACTIONS(3692),
    [anon_sym_number] = ACTIONS(3694),
    [anon_sym_typeof] = ACTIONS(3694),
    [anon_sym_LBRACE] = ACTIONS(3692),
    [anon_sym_switch] = ACTIONS(3694),
    [anon_sym_RBRACK] = ACTIONS(3692),
    [sym_null] = ACTIONS(3694),
    [anon_sym_any] = ACTIONS(3694),
    [anon_sym_async] = ACTIONS(3694),
    [anon_sym_public] = ACTIONS(3694),
    [anon_sym_var] = ACTIONS(3694),
    [anon_sym_while] = ACTIONS(3694),
    [anon_sym_SQUOTE] = ACTIONS(3692),
    [anon_sym_RPAREN] = ACTIONS(3692),
    [anon_sym_SLASH] = ACTIONS(3694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3694),
    [anon_sym_new] = ACTIONS(3694),
    [anon_sym_export] = ACTIONS(3694),
    [anon_sym_with] = ACTIONS(3694),
    [sym_identifier] = ACTIONS(3694),
    [anon_sym_debugger] = ACTIONS(3694),
    [anon_sym_AT] = ACTIONS(3692),
    [anon_sym_COMMA] = ACTIONS(3692),
    [anon_sym_DASH] = ACTIONS(3694),
    [anon_sym_EQ] = ACTIONS(3694),
    [anon_sym_void] = ACTIONS(3694),
    [anon_sym_const] = ACTIONS(3694),
    [sym_super] = ACTIONS(3694),
    [anon_sym_private] = ACTIONS(3694),
    [anon_sym_get] = ACTIONS(3694),
    [anon_sym_default] = ACTIONS(3694),
    [anon_sym_enum] = ACTIONS(3694),
    [anon_sym_continue] = ACTIONS(3694),
    [anon_sym_DASH_DASH] = ACTIONS(3692),
    [sym_this] = ACTIONS(3694),
    [anon_sym_throw] = ACTIONS(3694),
    [anon_sym_abstract] = ACTIONS(3694),
    [anon_sym_type] = ACTIONS(3694),
    [anon_sym_namespace] = ACTIONS(3694),
    [anon_sym_PLUS_PLUS] = ACTIONS(3692),
    [anon_sym_else] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3692),
    [anon_sym_LBRACK] = ACTIONS(3692),
    [sym_false] = ACTIONS(3694),
    [anon_sym_case] = ACTIONS(3694),
    [anon_sym_module] = ACTIONS(3694),
    [anon_sym_class] = ACTIONS(3694),
    [anon_sym_declare] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3692),
    [anon_sym_boolean] = ACTIONS(3694),
    [anon_sym_EQ_GT] = ACTIONS(3692),
    [anon_sym_AMP] = ACTIONS(3692),
    [anon_sym_try] = ACTIONS(3694),
    [anon_sym_LT] = ACTIONS(3692),
    [sym_number] = ACTIONS(3692),
    [ts_builtin_sym_end] = ACTIONS(3692),
    [anon_sym_function] = ACTIONS(3694),
    [sym_undefined] = ACTIONS(3694),
    [anon_sym_let] = ACTIONS(3694),
    [anon_sym_PLUS] = ACTIONS(3694),
    [anon_sym_do] = ACTIONS(3694),
    [anon_sym_TILDE] = ACTIONS(3692),
    [anon_sym_await] = ACTIONS(3694),
  },
  [1004] = {
    [anon_sym_EQ_GT] = ACTIONS(3696),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_while] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(3696),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3696),
    [anon_sym_EQ] = ACTIONS(3698),
    [anon_sym_RBRACK] = ACTIONS(3696),
    [anon_sym_GT] = ACTIONS(3696),
    [anon_sym_else] = ACTIONS(3696),
  },
  [1005] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1142),
    [sym_function_type] = STATE(1142),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1142),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1142),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1142),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1006] = {
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym_computed_property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1007] = {
    [sym_string] = STATE(1011),
    [sym__property_name] = STATE(1011),
    [sym_computed_property_name] = STATE(1011),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3248),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1008] = {
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym_computed_property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(3700),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1009] = {
    [sym_class_declaration] = STATE(1320),
    [sym_generator_function_declaration] = STATE(1320),
    [sym__declaration] = STATE(1320),
    [sym_enum_declaration] = STATE(1320),
    [sym_function_signature] = STATE(1320),
    [sym_abstract_class_declaration] = STATE(1320),
    [sym_module] = STATE(1320),
    [sym_interface_declaration] = STATE(1320),
    [sym_function_declaration] = STATE(1320),
    [sym_export_clause] = STATE(1855),
    [sym_variable_declaration] = STATE(1320),
    [sym_lexical_declaration] = STATE(1320),
    [sym_ambient_declaration] = STATE(1320),
    [sym_import_alias] = STATE(1320),
    [sym_type_alias_declaration] = STATE(1320),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1320),
    [sym_decorator] = STATE(63),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_as] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
  },
  [1010] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [anon_sym_get] = ACTIONS(3703),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(3705),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3703),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1011] = {
    [sym__call_signature] = STATE(1994),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(995),
    [sym__automatic_semicolon] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3184),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
  },
  [1012] = {
    [sym_arrow_function] = STATE(857),
    [sym_await_expression] = STATE(857),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(857),
    [sym_meta_property] = STATE(857),
    [sym__expression] = STATE(857),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(857),
    [sym_call_expression] = STATE(857),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(857),
    [sym_string] = STATE(857),
    [sym_template_string] = STATE(857),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(857),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(857),
    [sym_generator_function] = STATE(857),
    [sym_new_expression] = STATE(857),
    [sym_assignment_expression] = STATE(857),
    [sym_augmented_assignment_expression] = STATE(857),
    [sym_binary_expression] = STATE(857),
    [sym_unary_expression] = STATE(857),
    [sym_regex] = STATE(857),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(857),
    [sym_as_expression] = STATE(857),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(857),
    [sym_class] = STATE(857),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(3713),
    [sym_false] = ACTIONS(2687),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2687),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2687),
    [sym_number] = ACTIONS(2689),
    [sym_true] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2687),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1013] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(3705),
    [anon_sym_get] = ACTIONS(3703),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3703),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3715),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1014] = {
    [sym_await_expression] = STATE(730),
    [sym_type_predicate] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_update_expression] = STATE(730),
    [sym_object_type] = STATE(1596),
    [sym_meta_property] = STATE(730),
    [sym_function_type] = STATE(1440),
    [sym__expression] = STATE(730),
    [sym_nested_identifier] = STATE(2397),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(730),
    [sym_call_expression] = STATE(730),
    [sym_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_ternary_expression] = STATE(730),
    [sym_template_string] = STATE(730),
    [sym_yield_expression] = STATE(730),
    [sym_type_assertion] = STATE(730),
    [sym_new_expression] = STATE(730),
    [sym__primary_type] = STATE(1596),
    [sym_assignment_expression] = STATE(730),
    [sym_binary_expression] = STATE(730),
    [sym_predefined_type] = STATE(1596),
    [sym_union_type] = STATE(1440),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(1252),
    [sym_as_expression] = STATE(730),
    [sym_internal_module] = STATE(730),
    [sym_arrow_function] = STATE(730),
    [sym_generic_type] = STATE(1596),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(1596),
    [sym_type_arguments] = STATE(1254),
    [sym_intersection_type] = STATE(1440),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(1440),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1780),
    [sym_type_parameters] = STATE(1926),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(1434),
    [sym_object] = STATE(1256),
    [sym_generator_function] = STATE(730),
    [sym_constructor_type] = STATE(1440),
    [sym_lookup_type] = STATE(1596),
    [sym_augmented_assignment_expression] = STATE(730),
    [sym_parenthesized_type] = STATE(1596),
    [sym_unary_expression] = STATE(730),
    [sym_regex] = STATE(730),
    [sym_tuple_type] = STATE(1596),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_non_null_expression] = STATE(730),
    [sym_class] = STATE(730),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(3717),
    [sym_false] = ACTIONS(3719),
    [anon_sym_LBRACK] = ACTIONS(3721),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(3723),
    [anon_sym_number] = ACTIONS(3723),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(3725),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_LBRACE] = ACTIONS(3729),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_void] = ACTIONS(3731),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_LPAREN] = ACTIONS(3733),
    [sym_null] = ACTIONS(2215),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(3723),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(3723),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(3735),
    [sym_number] = ACTIONS(3737),
    [sym_true] = ACTIONS(3719),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(3723),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2215),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(3739),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1015] = {
    [sym__call_signature] = STATE(1995),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1001),
    [sym__automatic_semicolon] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3198),
    [sym_comment] = ACTIONS(3),
  },
  [1016] = {
    [anon_sym_BQUOTE] = ACTIONS(3741),
    [anon_sym_symbol] = ACTIONS(3743),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_static] = ACTIONS(3743),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_interface] = ACTIONS(3743),
    [anon_sym_delete] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [sym_true] = ACTIONS(3743),
    [anon_sym_protected] = ACTIONS(3743),
    [anon_sym_set] = ACTIONS(3743),
    [anon_sym_import] = ACTIONS(3743),
    [anon_sym_DQUOTE] = ACTIONS(3741),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_number] = ACTIONS(3743),
    [anon_sym_typeof] = ACTIONS(3743),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_switch] = ACTIONS(3743),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [sym_null] = ACTIONS(3743),
    [anon_sym_any] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_public] = ACTIONS(3743),
    [anon_sym_var] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_SQUOTE] = ACTIONS(3741),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [anon_sym_SLASH] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3743),
    [anon_sym_new] = ACTIONS(3743),
    [anon_sym_export] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [sym_identifier] = ACTIONS(3743),
    [anon_sym_debugger] = ACTIONS(3743),
    [anon_sym_AT] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_EQ] = ACTIONS(3743),
    [anon_sym_void] = ACTIONS(3743),
    [anon_sym_const] = ACTIONS(3743),
    [sym_super] = ACTIONS(3743),
    [anon_sym_private] = ACTIONS(3743),
    [anon_sym_get] = ACTIONS(3743),
    [anon_sym_default] = ACTIONS(3743),
    [anon_sym_enum] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [sym_this] = ACTIONS(3743),
    [anon_sym_throw] = ACTIONS(3743),
    [anon_sym_abstract] = ACTIONS(3743),
    [anon_sym_type] = ACTIONS(3743),
    [anon_sym_namespace] = ACTIONS(3743),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_else] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3741),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [sym_false] = ACTIONS(3743),
    [anon_sym_case] = ACTIONS(3743),
    [anon_sym_module] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_declare] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_GT] = ACTIONS(3741),
    [anon_sym_boolean] = ACTIONS(3743),
    [anon_sym_EQ_GT] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_LT] = ACTIONS(3741),
    [sym_number] = ACTIONS(3741),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [anon_sym_function] = ACTIONS(3743),
    [sym_undefined] = ACTIONS(3743),
    [anon_sym_let] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_do] = ACTIONS(3743),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_await] = ACTIONS(3743),
  },
  [1017] = {
    [anon_sym_extends] = ACTIONS(3745),
    [anon_sym_implements] = ACTIONS(3745),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3745),
    [anon_sym_EQ] = ACTIONS(3745),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3747),
  },
  [1018] = {
    [sym_type_parameter] = STATE(811),
    [sym_identifier] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [1019] = {
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [anon_sym_symbol] = ACTIONS(3751),
    [anon_sym_PIPE] = ACTIONS(3749),
    [anon_sym_break] = ACTIONS(3751),
    [anon_sym_return] = ACTIONS(3751),
    [anon_sym_static] = ACTIONS(3751),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_interface] = ACTIONS(3751),
    [anon_sym_delete] = ACTIONS(3751),
    [anon_sym_if] = ACTIONS(3751),
    [anon_sym_yield] = ACTIONS(3751),
    [sym_true] = ACTIONS(3751),
    [anon_sym_protected] = ACTIONS(3751),
    [anon_sym_set] = ACTIONS(3751),
    [anon_sym_import] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(3749),
    [anon_sym_for] = ACTIONS(3751),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_number] = ACTIONS(3751),
    [anon_sym_typeof] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(3751),
    [anon_sym_switch] = ACTIONS(3751),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [sym_null] = ACTIONS(3751),
    [anon_sym_any] = ACTIONS(3751),
    [anon_sym_async] = ACTIONS(3751),
    [anon_sym_public] = ACTIONS(3751),
    [anon_sym_var] = ACTIONS(3751),
    [anon_sym_while] = ACTIONS(3751),
    [anon_sym_SQUOTE] = ACTIONS(3749),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_SLASH] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3751),
    [anon_sym_new] = ACTIONS(3751),
    [anon_sym_export] = ACTIONS(3751),
    [anon_sym_with] = ACTIONS(3751),
    [sym_identifier] = ACTIONS(3751),
    [anon_sym_debugger] = ACTIONS(3751),
    [anon_sym_AT] = ACTIONS(3749),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_EQ] = ACTIONS(3751),
    [anon_sym_void] = ACTIONS(3751),
    [anon_sym_const] = ACTIONS(3751),
    [sym_super] = ACTIONS(3751),
    [anon_sym_private] = ACTIONS(3751),
    [anon_sym_get] = ACTIONS(3751),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3749),
    [anon_sym_default] = ACTIONS(3751),
    [anon_sym_enum] = ACTIONS(3751),
    [anon_sym_continue] = ACTIONS(3751),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [sym_this] = ACTIONS(3751),
    [anon_sym_throw] = ACTIONS(3751),
    [anon_sym_abstract] = ACTIONS(3751),
    [anon_sym_type] = ACTIONS(3751),
    [anon_sym_namespace] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_else] = ACTIONS(3751),
    [anon_sym_BANG] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [sym_false] = ACTIONS(3751),
    [anon_sym_case] = ACTIONS(3751),
    [anon_sym_module] = ACTIONS(3751),
    [anon_sym_class] = ACTIONS(3751),
    [anon_sym_declare] = ACTIONS(3751),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_GT] = ACTIONS(3749),
    [anon_sym_boolean] = ACTIONS(3751),
    [anon_sym_EQ_GT] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3749),
    [anon_sym_try] = ACTIONS(3751),
    [anon_sym_LT] = ACTIONS(3749),
    [sym_number] = ACTIONS(3749),
    [ts_builtin_sym_end] = ACTIONS(3749),
    [anon_sym_function] = ACTIONS(3751),
    [sym_undefined] = ACTIONS(3751),
    [anon_sym_let] = ACTIONS(3751),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_implements] = ACTIONS(3751),
    [anon_sym_do] = ACTIONS(3751),
    [anon_sym_TILDE] = ACTIONS(3749),
    [anon_sym_await] = ACTIONS(3751),
  },
  [1020] = {
    [anon_sym_EQ_GT] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_while] = ACTIONS(3753),
    [anon_sym_RPAREN] = ACTIONS(3753),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(3753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3755),
    [anon_sym_RBRACK] = ACTIONS(3753),
    [anon_sym_GT] = ACTIONS(3753),
    [anon_sym_else] = ACTIONS(3753),
  },
  [1021] = {
    [sym_identifier] = ACTIONS(3757),
    [anon_sym_BQUOTE] = ACTIONS(3759),
    [anon_sym_debugger] = ACTIONS(3757),
    [anon_sym_symbol] = ACTIONS(3757),
    [anon_sym_AT] = ACTIONS(3759),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_void] = ACTIONS(3757),
    [anon_sym_break] = ACTIONS(3757),
    [anon_sym_const] = ACTIONS(3757),
    [sym_super] = ACTIONS(3757),
    [anon_sym_return] = ACTIONS(3757),
    [anon_sym_private] = ACTIONS(3757),
    [anon_sym_static] = ACTIONS(3757),
    [anon_sym_get] = ACTIONS(3757),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_interface] = ACTIONS(3757),
    [anon_sym_default] = ACTIONS(3757),
    [anon_sym_enum] = ACTIONS(3757),
    [anon_sym_delete] = ACTIONS(3757),
    [anon_sym_continue] = ACTIONS(3757),
    [anon_sym_DASH_DASH] = ACTIONS(3759),
    [anon_sym_if] = ACTIONS(3757),
    [sym_this] = ACTIONS(3757),
    [anon_sym_yield] = ACTIONS(3757),
    [sym_true] = ACTIONS(3757),
    [anon_sym_throw] = ACTIONS(3757),
    [anon_sym_protected] = ACTIONS(3757),
    [anon_sym_abstract] = ACTIONS(3757),
    [anon_sym_set] = ACTIONS(3757),
    [anon_sym_type] = ACTIONS(3757),
    [anon_sym_import] = ACTIONS(3757),
    [anon_sym_namespace] = ACTIONS(3757),
    [anon_sym_PLUS_PLUS] = ACTIONS(3759),
    [anon_sym_DQUOTE] = ACTIONS(3759),
    [anon_sym_else] = ACTIONS(3757),
    [anon_sym_BANG] = ACTIONS(3759),
    [anon_sym_for] = ACTIONS(3757),
    [anon_sym_LBRACK] = ACTIONS(3759),
    [sym_false] = ACTIONS(3757),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym_case] = ACTIONS(3757),
    [anon_sym_module] = ACTIONS(3757),
    [anon_sym_number] = ACTIONS(3757),
    [anon_sym_class] = ACTIONS(3757),
    [anon_sym_declare] = ACTIONS(3757),
    [anon_sym_typeof] = ACTIONS(3757),
    [anon_sym_LBRACE] = ACTIONS(3759),
    [anon_sym_switch] = ACTIONS(3757),
    [anon_sym_LPAREN] = ACTIONS(3759),
    [sym_null] = ACTIONS(3757),
    [anon_sym_any] = ACTIONS(3757),
    [anon_sym_boolean] = ACTIONS(3757),
    [anon_sym_async] = ACTIONS(3757),
    [anon_sym_public] = ACTIONS(3757),
    [anon_sym_var] = ACTIONS(3757),
    [anon_sym_while] = ACTIONS(3757),
    [anon_sym_SQUOTE] = ACTIONS(3759),
    [anon_sym_try] = ACTIONS(3757),
    [anon_sym_LT] = ACTIONS(3759),
    [sym_number] = ACTIONS(3759),
    [anon_sym_SLASH] = ACTIONS(3757),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3757),
    [anon_sym_function] = ACTIONS(3757),
    [sym_undefined] = ACTIONS(3757),
    [anon_sym_new] = ACTIONS(3757),
    [ts_builtin_sym_end] = ACTIONS(3759),
    [anon_sym_let] = ACTIONS(3757),
    [anon_sym_PLUS] = ACTIONS(3757),
    [anon_sym_export] = ACTIONS(3757),
    [anon_sym_do] = ACTIONS(3757),
    [anon_sym_TILDE] = ACTIONS(3759),
    [anon_sym_with] = ACTIONS(3757),
    [anon_sym_await] = ACTIONS(3757),
  },
  [1022] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3761),
    [sym__automatic_semicolon] = ACTIONS(3763),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_GT_GT_GT] = ACTIONS(3761),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_BANG_EQ] = ACTIONS(3769),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_PERCENT] = ACTIONS(3761),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_as] = ACTIONS(3769),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_if] = ACTIONS(3767),
    [anon_sym_instanceof] = ACTIONS(3769),
    [anon_sym_yield] = ACTIONS(3767),
    [sym_true] = ACTIONS(3767),
    [anon_sym_protected] = ACTIONS(3767),
    [anon_sym_DOT] = ACTIONS(3769),
    [anon_sym_set] = ACTIONS(3767),
    [anon_sym_import] = ACTIONS(3767),
    [anon_sym_in] = ACTIONS(3769),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_LT_LT] = ACTIONS(3761),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_LT_EQ] = ACTIONS(3761),
    [sym_null] = ACTIONS(3767),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_async] = ACTIONS(3767),
    [anon_sym_public] = ACTIONS(3767),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_SLASH] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_export] = ACTIONS(3767),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3761),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_debugger] = ACTIONS(3767),
    [anon_sym_AT] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_void] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [sym_super] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [sym_this] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_STAR_STAR] = ACTIONS(3761),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_else] = ACTIONS(3767),
    [anon_sym_BANG] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [sym_false] = ACTIONS(3767),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_declare] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_EQ_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3767),
    [sym_number] = ACTIONS(3765),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [anon_sym_function] = ACTIONS(3767),
    [sym_undefined] = ACTIONS(3767),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_await] = ACTIONS(3767),
  },
  [1023] = {
    [sym_type_annotation] = STATE(740),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3771),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(3771),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1024] = {
    [sym_arrow_function] = STATE(1147),
    [sym_await_expression] = STATE(1147),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1422),
    [sym_meta_property] = STATE(1147),
    [sym_update_expression] = STATE(1147),
    [sym__expression] = STATE(1147),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1147),
    [sym_call_expression] = STATE(1147),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(391),
    [sym_ternary_expression] = STATE(1147),
    [sym_string] = STATE(1147),
    [sym_template_string] = STATE(1147),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1147),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1147),
    [sym_generator_function] = STATE(1147),
    [sym_new_expression] = STATE(1147),
    [sym_assignment_expression] = STATE(1147),
    [sym_augmented_assignment_expression] = STATE(1147),
    [sym_binary_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym_regex] = STATE(1147),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1147),
    [sym_as_expression] = STATE(1147),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1147),
    [sym_class] = STATE(1147),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_COMMA] = ACTIONS(872),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(3776),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_RPAREN] = ACTIONS(872),
    [sym_this] = ACTIONS(3776),
    [sym_number] = ACTIONS(3778),
    [sym_true] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(3776),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1025] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2726),
    [sym__automatic_semicolon] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_COMMA] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_STAR] = ACTIONS(2728),
    [anon_sym_GT_GT_GT] = ACTIONS(2728),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_BANG_EQ] = ACTIONS(2728),
    [anon_sym_GT_EQ] = ACTIONS(2726),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_PERCENT] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_instanceof] = ACTIONS(2726),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2726),
    [anon_sym_STAR_STAR] = ACTIONS(2728),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_LT_EQ] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_EQ_EQ] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_SLASH] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2726),
  },
  [1026] = {
    [sym__automatic_semicolon] = ACTIONS(3780),
    [anon_sym_SEMI] = ACTIONS(3780),
    [anon_sym_from] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
  },
  [1027] = {
    [anon_sym_COMMA] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
  },
  [1028] = {
    [sym__import_export_specifier] = STATE(1027),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_RBRACE] = ACTIONS(3784),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [1029] = {
    [aux_sym_export_clause_repeat1] = STATE(1029),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [sym_comment] = ACTIONS(3),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(3791),
    [anon_sym_BQUOTE] = ACTIONS(3793),
    [anon_sym_debugger] = ACTIONS(3791),
    [anon_sym_symbol] = ACTIONS(3791),
    [anon_sym_AT] = ACTIONS(3793),
    [anon_sym_DASH] = ACTIONS(3791),
    [anon_sym_void] = ACTIONS(3791),
    [anon_sym_break] = ACTIONS(3791),
    [anon_sym_const] = ACTIONS(3791),
    [sym_super] = ACTIONS(3791),
    [anon_sym_return] = ACTIONS(3791),
    [anon_sym_private] = ACTIONS(3791),
    [anon_sym_static] = ACTIONS(3791),
    [anon_sym_get] = ACTIONS(3791),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_interface] = ACTIONS(3791),
    [anon_sym_default] = ACTIONS(3791),
    [anon_sym_enum] = ACTIONS(3791),
    [anon_sym_delete] = ACTIONS(3791),
    [anon_sym_continue] = ACTIONS(3791),
    [anon_sym_DASH_DASH] = ACTIONS(3793),
    [anon_sym_if] = ACTIONS(3791),
    [sym_this] = ACTIONS(3791),
    [anon_sym_yield] = ACTIONS(3791),
    [sym_true] = ACTIONS(3791),
    [anon_sym_throw] = ACTIONS(3791),
    [anon_sym_protected] = ACTIONS(3791),
    [anon_sym_abstract] = ACTIONS(3791),
    [anon_sym_set] = ACTIONS(3791),
    [anon_sym_type] = ACTIONS(3791),
    [anon_sym_import] = ACTIONS(3791),
    [anon_sym_namespace] = ACTIONS(3791),
    [anon_sym_PLUS_PLUS] = ACTIONS(3793),
    [anon_sym_DQUOTE] = ACTIONS(3793),
    [anon_sym_else] = ACTIONS(3791),
    [anon_sym_BANG] = ACTIONS(3793),
    [anon_sym_for] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3793),
    [sym_false] = ACTIONS(3791),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_case] = ACTIONS(3791),
    [anon_sym_module] = ACTIONS(3791),
    [anon_sym_number] = ACTIONS(3791),
    [anon_sym_class] = ACTIONS(3791),
    [anon_sym_declare] = ACTIONS(3791),
    [anon_sym_typeof] = ACTIONS(3791),
    [anon_sym_LBRACE] = ACTIONS(3793),
    [anon_sym_switch] = ACTIONS(3791),
    [anon_sym_LPAREN] = ACTIONS(3793),
    [sym_null] = ACTIONS(3791),
    [anon_sym_any] = ACTIONS(3791),
    [anon_sym_boolean] = ACTIONS(3791),
    [anon_sym_async] = ACTIONS(3791),
    [anon_sym_public] = ACTIONS(3791),
    [anon_sym_var] = ACTIONS(3791),
    [anon_sym_while] = ACTIONS(3791),
    [anon_sym_SQUOTE] = ACTIONS(3793),
    [anon_sym_try] = ACTIONS(3791),
    [anon_sym_LT] = ACTIONS(3793),
    [sym_number] = ACTIONS(3793),
    [anon_sym_SLASH] = ACTIONS(3791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3791),
    [anon_sym_function] = ACTIONS(3791),
    [sym_undefined] = ACTIONS(3791),
    [anon_sym_new] = ACTIONS(3791),
    [ts_builtin_sym_end] = ACTIONS(3793),
    [anon_sym_let] = ACTIONS(3791),
    [anon_sym_PLUS] = ACTIONS(3791),
    [anon_sym_export] = ACTIONS(3791),
    [anon_sym_do] = ACTIONS(3791),
    [anon_sym_TILDE] = ACTIONS(3793),
    [anon_sym_with] = ACTIONS(3791),
    [anon_sym_await] = ACTIONS(3791),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(3795),
    [anon_sym_BQUOTE] = ACTIONS(3797),
    [anon_sym_debugger] = ACTIONS(3795),
    [anon_sym_symbol] = ACTIONS(3795),
    [anon_sym_AT] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_void] = ACTIONS(3795),
    [anon_sym_break] = ACTIONS(3795),
    [anon_sym_const] = ACTIONS(3795),
    [sym_super] = ACTIONS(3795),
    [anon_sym_return] = ACTIONS(3795),
    [anon_sym_private] = ACTIONS(3795),
    [anon_sym_static] = ACTIONS(3795),
    [anon_sym_get] = ACTIONS(3795),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_interface] = ACTIONS(3795),
    [anon_sym_default] = ACTIONS(3795),
    [anon_sym_enum] = ACTIONS(3795),
    [anon_sym_delete] = ACTIONS(3795),
    [anon_sym_continue] = ACTIONS(3795),
    [anon_sym_DASH_DASH] = ACTIONS(3797),
    [anon_sym_if] = ACTIONS(3795),
    [sym_this] = ACTIONS(3795),
    [anon_sym_yield] = ACTIONS(3795),
    [sym_true] = ACTIONS(3795),
    [anon_sym_throw] = ACTIONS(3795),
    [anon_sym_protected] = ACTIONS(3795),
    [anon_sym_abstract] = ACTIONS(3795),
    [anon_sym_set] = ACTIONS(3795),
    [anon_sym_type] = ACTIONS(3795),
    [anon_sym_import] = ACTIONS(3795),
    [anon_sym_namespace] = ACTIONS(3795),
    [anon_sym_PLUS_PLUS] = ACTIONS(3797),
    [anon_sym_DQUOTE] = ACTIONS(3797),
    [anon_sym_else] = ACTIONS(3795),
    [anon_sym_BANG] = ACTIONS(3797),
    [anon_sym_for] = ACTIONS(3795),
    [anon_sym_LBRACK] = ACTIONS(3797),
    [sym_false] = ACTIONS(3795),
    [anon_sym_SEMI] = ACTIONS(3797),
    [anon_sym_case] = ACTIONS(3795),
    [anon_sym_module] = ACTIONS(3795),
    [anon_sym_number] = ACTIONS(3795),
    [anon_sym_class] = ACTIONS(3795),
    [anon_sym_declare] = ACTIONS(3795),
    [anon_sym_typeof] = ACTIONS(3795),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_switch] = ACTIONS(3795),
    [anon_sym_LPAREN] = ACTIONS(3797),
    [sym_null] = ACTIONS(3795),
    [anon_sym_any] = ACTIONS(3795),
    [anon_sym_boolean] = ACTIONS(3795),
    [anon_sym_async] = ACTIONS(3795),
    [anon_sym_public] = ACTIONS(3795),
    [anon_sym_var] = ACTIONS(3795),
    [anon_sym_while] = ACTIONS(3795),
    [anon_sym_SQUOTE] = ACTIONS(3797),
    [anon_sym_try] = ACTIONS(3795),
    [anon_sym_LT] = ACTIONS(3797),
    [sym_number] = ACTIONS(3797),
    [anon_sym_SLASH] = ACTIONS(3795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3795),
    [anon_sym_function] = ACTIONS(3795),
    [sym_undefined] = ACTIONS(3795),
    [anon_sym_new] = ACTIONS(3795),
    [ts_builtin_sym_end] = ACTIONS(3797),
    [anon_sym_let] = ACTIONS(3795),
    [anon_sym_PLUS] = ACTIONS(3795),
    [anon_sym_export] = ACTIONS(3795),
    [anon_sym_do] = ACTIONS(3795),
    [anon_sym_TILDE] = ACTIONS(3797),
    [anon_sym_with] = ACTIONS(3795),
    [anon_sym_await] = ACTIONS(3795),
  },
  [1032] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3799),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(3801),
    [sym_comment] = ACTIONS(3),
  },
  [1034] = {
    [sym_type_annotation] = STATE(593),
    [anon_sym_EQ_GT] = ACTIONS(3803),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(3806),
    [anon_sym_BQUOTE] = ACTIONS(3808),
    [anon_sym_debugger] = ACTIONS(3806),
    [anon_sym_symbol] = ACTIONS(3806),
    [anon_sym_AT] = ACTIONS(3808),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_void] = ACTIONS(3806),
    [anon_sym_break] = ACTIONS(3806),
    [anon_sym_const] = ACTIONS(3806),
    [sym_super] = ACTIONS(3806),
    [anon_sym_return] = ACTIONS(3806),
    [anon_sym_private] = ACTIONS(3806),
    [anon_sym_static] = ACTIONS(3806),
    [anon_sym_get] = ACTIONS(3806),
    [anon_sym_RBRACE] = ACTIONS(3808),
    [anon_sym_interface] = ACTIONS(3806),
    [anon_sym_default] = ACTIONS(3806),
    [anon_sym_enum] = ACTIONS(3806),
    [anon_sym_delete] = ACTIONS(3806),
    [anon_sym_continue] = ACTIONS(3806),
    [anon_sym_DASH_DASH] = ACTIONS(3808),
    [anon_sym_if] = ACTIONS(3806),
    [sym_this] = ACTIONS(3806),
    [anon_sym_yield] = ACTIONS(3806),
    [sym_true] = ACTIONS(3806),
    [anon_sym_throw] = ACTIONS(3806),
    [anon_sym_protected] = ACTIONS(3806),
    [anon_sym_abstract] = ACTIONS(3806),
    [anon_sym_set] = ACTIONS(3806),
    [anon_sym_type] = ACTIONS(3806),
    [anon_sym_import] = ACTIONS(3806),
    [anon_sym_namespace] = ACTIONS(3806),
    [anon_sym_PLUS_PLUS] = ACTIONS(3808),
    [anon_sym_DQUOTE] = ACTIONS(3808),
    [anon_sym_else] = ACTIONS(3806),
    [anon_sym_BANG] = ACTIONS(3808),
    [anon_sym_for] = ACTIONS(3806),
    [anon_sym_LBRACK] = ACTIONS(3808),
    [sym_false] = ACTIONS(3806),
    [anon_sym_SEMI] = ACTIONS(3808),
    [anon_sym_case] = ACTIONS(3806),
    [anon_sym_module] = ACTIONS(3806),
    [anon_sym_number] = ACTIONS(3806),
    [anon_sym_class] = ACTIONS(3806),
    [anon_sym_declare] = ACTIONS(3806),
    [anon_sym_typeof] = ACTIONS(3806),
    [anon_sym_LBRACE] = ACTIONS(3808),
    [anon_sym_switch] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(3808),
    [sym_null] = ACTIONS(3806),
    [anon_sym_any] = ACTIONS(3806),
    [anon_sym_boolean] = ACTIONS(3806),
    [anon_sym_async] = ACTIONS(3806),
    [anon_sym_public] = ACTIONS(3806),
    [anon_sym_var] = ACTIONS(3806),
    [anon_sym_while] = ACTIONS(3806),
    [anon_sym_SQUOTE] = ACTIONS(3808),
    [anon_sym_try] = ACTIONS(3806),
    [anon_sym_LT] = ACTIONS(3808),
    [sym_number] = ACTIONS(3808),
    [anon_sym_SLASH] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3806),
    [anon_sym_function] = ACTIONS(3806),
    [sym_undefined] = ACTIONS(3806),
    [anon_sym_new] = ACTIONS(3806),
    [ts_builtin_sym_end] = ACTIONS(3808),
    [anon_sym_let] = ACTIONS(3806),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_export] = ACTIONS(3806),
    [anon_sym_do] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3808),
    [anon_sym_with] = ACTIONS(3806),
    [anon_sym_await] = ACTIONS(3806),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3810),
    [anon_sym_BQUOTE] = ACTIONS(3812),
    [anon_sym_debugger] = ACTIONS(3810),
    [anon_sym_symbol] = ACTIONS(3810),
    [anon_sym_AT] = ACTIONS(3812),
    [anon_sym_DASH] = ACTIONS(3810),
    [anon_sym_void] = ACTIONS(3810),
    [anon_sym_break] = ACTIONS(3810),
    [anon_sym_const] = ACTIONS(3810),
    [sym_super] = ACTIONS(3810),
    [anon_sym_return] = ACTIONS(3810),
    [anon_sym_private] = ACTIONS(3810),
    [anon_sym_static] = ACTIONS(3810),
    [anon_sym_get] = ACTIONS(3810),
    [anon_sym_RBRACE] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3810),
    [anon_sym_default] = ACTIONS(3810),
    [anon_sym_enum] = ACTIONS(3810),
    [anon_sym_delete] = ACTIONS(3810),
    [anon_sym_continue] = ACTIONS(3810),
    [anon_sym_DASH_DASH] = ACTIONS(3812),
    [anon_sym_if] = ACTIONS(3810),
    [sym_this] = ACTIONS(3810),
    [anon_sym_yield] = ACTIONS(3810),
    [sym_true] = ACTIONS(3810),
    [anon_sym_throw] = ACTIONS(3810),
    [anon_sym_protected] = ACTIONS(3810),
    [anon_sym_abstract] = ACTIONS(3810),
    [anon_sym_set] = ACTIONS(3810),
    [anon_sym_type] = ACTIONS(3810),
    [anon_sym_import] = ACTIONS(3810),
    [anon_sym_namespace] = ACTIONS(3810),
    [anon_sym_PLUS_PLUS] = ACTIONS(3812),
    [anon_sym_DQUOTE] = ACTIONS(3812),
    [anon_sym_else] = ACTIONS(3810),
    [anon_sym_BANG] = ACTIONS(3812),
    [anon_sym_for] = ACTIONS(3810),
    [anon_sym_LBRACK] = ACTIONS(3812),
    [sym_false] = ACTIONS(3810),
    [anon_sym_SEMI] = ACTIONS(3812),
    [anon_sym_case] = ACTIONS(3810),
    [anon_sym_module] = ACTIONS(3810),
    [anon_sym_number] = ACTIONS(3810),
    [anon_sym_class] = ACTIONS(3810),
    [anon_sym_declare] = ACTIONS(3810),
    [anon_sym_typeof] = ACTIONS(3810),
    [anon_sym_LBRACE] = ACTIONS(3812),
    [anon_sym_switch] = ACTIONS(3810),
    [anon_sym_LPAREN] = ACTIONS(3812),
    [sym_null] = ACTIONS(3810),
    [anon_sym_any] = ACTIONS(3810),
    [anon_sym_boolean] = ACTIONS(3810),
    [anon_sym_async] = ACTIONS(3810),
    [anon_sym_public] = ACTIONS(3810),
    [anon_sym_var] = ACTIONS(3810),
    [anon_sym_while] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(3812),
    [anon_sym_try] = ACTIONS(3810),
    [anon_sym_LT] = ACTIONS(3812),
    [sym_number] = ACTIONS(3812),
    [anon_sym_SLASH] = ACTIONS(3810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3810),
    [anon_sym_function] = ACTIONS(3810),
    [sym_undefined] = ACTIONS(3810),
    [anon_sym_new] = ACTIONS(3810),
    [ts_builtin_sym_end] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3810),
    [anon_sym_PLUS] = ACTIONS(3810),
    [anon_sym_export] = ACTIONS(3810),
    [anon_sym_do] = ACTIONS(3810),
    [anon_sym_TILDE] = ACTIONS(3812),
    [anon_sym_with] = ACTIONS(3810),
    [anon_sym_await] = ACTIONS(3810),
  },
  [1037] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [sym__automatic_semicolon] = ACTIONS(3816),
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_symbol] = ACTIONS(3820),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_as] = ACTIONS(3822),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_instanceof] = ACTIONS(3822),
    [anon_sym_yield] = ACTIONS(3820),
    [sym_true] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_DOT] = ACTIONS(3822),
    [anon_sym_set] = ACTIONS(3820),
    [anon_sym_import] = ACTIONS(3820),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_number] = ACTIONS(3820),
    [anon_sym_typeof] = ACTIONS(3820),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [sym_null] = ACTIONS(3820),
    [anon_sym_any] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_export] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_with] = ACTIONS(3820),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
    [sym_identifier] = ACTIONS(3820),
    [anon_sym_debugger] = ACTIONS(3820),
    [anon_sym_AT] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_void] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [sym_super] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_get] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [sym_this] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_type] = ACTIONS(3820),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_else] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [sym_false] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_module] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_declare] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_boolean] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3820),
    [sym_number] = ACTIONS(3818),
    [ts_builtin_sym_end] = ACTIONS(3818),
    [anon_sym_function] = ACTIONS(3820),
    [sym_undefined] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_await] = ACTIONS(3820),
  },
  [1038] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [sym__automatic_semicolon] = ACTIONS(3826),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [anon_sym_symbol] = ACTIONS(3830),
    [anon_sym_PIPE] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_break] = ACTIONS(3830),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_return] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_interface] = ACTIONS(3830),
    [anon_sym_as] = ACTIONS(3832),
    [anon_sym_delete] = ACTIONS(3830),
    [anon_sym_if] = ACTIONS(3830),
    [anon_sym_instanceof] = ACTIONS(3832),
    [anon_sym_yield] = ACTIONS(3830),
    [sym_true] = ACTIONS(3830),
    [anon_sym_protected] = ACTIONS(3830),
    [anon_sym_DOT] = ACTIONS(3832),
    [anon_sym_set] = ACTIONS(3830),
    [anon_sym_import] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_number] = ACTIONS(3830),
    [anon_sym_typeof] = ACTIONS(3830),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_switch] = ACTIONS(3830),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [sym_null] = ACTIONS(3830),
    [anon_sym_any] = ACTIONS(3830),
    [anon_sym_async] = ACTIONS(3830),
    [anon_sym_public] = ACTIONS(3830),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3830),
    [anon_sym_new] = ACTIONS(3830),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_export] = ACTIONS(3830),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_with] = ACTIONS(3830),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_debugger] = ACTIONS(3830),
    [anon_sym_AT] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_void] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [sym_super] = ACTIONS(3830),
    [anon_sym_private] = ACTIONS(3830),
    [anon_sym_get] = ACTIONS(3830),
    [anon_sym_default] = ACTIONS(3830),
    [anon_sym_enum] = ACTIONS(3830),
    [anon_sym_continue] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3828),
    [sym_this] = ACTIONS(3830),
    [anon_sym_throw] = ACTIONS(3830),
    [anon_sym_abstract] = ACTIONS(3830),
    [anon_sym_type] = ACTIONS(3830),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_namespace] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3828),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [sym_false] = ACTIONS(3830),
    [anon_sym_case] = ACTIONS(3830),
    [anon_sym_module] = ACTIONS(3830),
    [anon_sym_class] = ACTIONS(3830),
    [anon_sym_declare] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_boolean] = ACTIONS(3830),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_try] = ACTIONS(3830),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_LT] = ACTIONS(3830),
    [sym_number] = ACTIONS(3828),
    [ts_builtin_sym_end] = ACTIONS(3828),
    [anon_sym_function] = ACTIONS(3830),
    [sym_undefined] = ACTIONS(3830),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_do] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3828),
    [anon_sym_await] = ACTIONS(3830),
  },
  [1039] = {
    [sym_class_body] = STATE(1153),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(956),
  },
  [1040] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3834),
    [sym__automatic_semicolon] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(3834),
    [anon_sym_PIPE] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(3834),
    [anon_sym_STAR] = ACTIONS(3836),
    [anon_sym_GT_GT_GT] = ACTIONS(3834),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_LT_EQ] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_GT_EQ] = ACTIONS(3834),
    [anon_sym_GT] = ACTIONS(3836),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_PERCENT] = ACTIONS(3834),
    [anon_sym_QMARK] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_as] = ACTIONS(3834),
    [anon_sym_PIPE_PIPE] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_EQ_EQ] = ACTIONS(3836),
    [anon_sym_instanceof] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(3836),
    [anon_sym_SLASH] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3834),
    [anon_sym_CARET] = ACTIONS(3834),
    [anon_sym_STAR_STAR] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_GT_GT] = ACTIONS(3836),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(3836),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3836),
  },
  [1041] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3521),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [sym__automatic_semicolon] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_BQUOTE] = ACTIONS(3521),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_LT_EQ] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_GT_EQ] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3521),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_instanceof] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3521),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_STAR_STAR] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3521),
    [anon_sym_BANG] = ACTIONS(3529),
  },
  [1042] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3631),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [sym__automatic_semicolon] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_BQUOTE] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_LT_EQ] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_GT_EQ] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3631),
    [anon_sym_QMARK] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3631),
    [anon_sym_PIPE_PIPE] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_instanceof] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3631),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_STAR_STAR] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3631),
    [anon_sym_BANG] = ACTIONS(3639),
  },
  [1043] = {
    [sym_statement_block] = STATE(1154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [1044] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3761),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [sym__automatic_semicolon] = ACTIONS(3761),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_BQUOTE] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_LT_LT] = ACTIONS(3761),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_GT_GT_GT] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_BANG_EQ] = ACTIONS(3769),
    [anon_sym_LT_EQ] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(3761),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_PERCENT] = ACTIONS(3761),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_as] = ACTIONS(3761),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_EQ_EQ] = ACTIONS(3769),
    [anon_sym_instanceof] = ACTIONS(3761),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3761),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_STAR_STAR] = ACTIONS(3761),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_in] = ACTIONS(3769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BANG] = ACTIONS(3769),
  },
  [1045] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [sym__automatic_semicolon] = ACTIONS(3814),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3822),
  },
  [1046] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [sym__automatic_semicolon] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_SLASH] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3832),
  },
  [1047] = {
    [sym_class_body] = STATE(1155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(3838),
    [anon_sym_BQUOTE] = ACTIONS(3840),
    [anon_sym_debugger] = ACTIONS(3838),
    [anon_sym_symbol] = ACTIONS(3838),
    [anon_sym_AT] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3838),
    [anon_sym_void] = ACTIONS(3838),
    [anon_sym_break] = ACTIONS(3838),
    [anon_sym_const] = ACTIONS(3838),
    [sym_super] = ACTIONS(3838),
    [anon_sym_return] = ACTIONS(3838),
    [anon_sym_private] = ACTIONS(3838),
    [anon_sym_static] = ACTIONS(3838),
    [anon_sym_get] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3840),
    [anon_sym_interface] = ACTIONS(3838),
    [anon_sym_default] = ACTIONS(3838),
    [anon_sym_enum] = ACTIONS(3838),
    [anon_sym_delete] = ACTIONS(3838),
    [anon_sym_continue] = ACTIONS(3838),
    [anon_sym_DASH_DASH] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3838),
    [sym_this] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3838),
    [sym_true] = ACTIONS(3838),
    [anon_sym_throw] = ACTIONS(3838),
    [anon_sym_protected] = ACTIONS(3838),
    [anon_sym_abstract] = ACTIONS(3838),
    [anon_sym_set] = ACTIONS(3838),
    [anon_sym_type] = ACTIONS(3838),
    [anon_sym_import] = ACTIONS(3838),
    [anon_sym_namespace] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3840),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_else] = ACTIONS(3838),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3838),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [sym_false] = ACTIONS(3838),
    [anon_sym_SEMI] = ACTIONS(3840),
    [anon_sym_case] = ACTIONS(3838),
    [anon_sym_module] = ACTIONS(3838),
    [anon_sym_number] = ACTIONS(3838),
    [anon_sym_class] = ACTIONS(3838),
    [anon_sym_declare] = ACTIONS(3838),
    [anon_sym_typeof] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [sym_null] = ACTIONS(3838),
    [anon_sym_any] = ACTIONS(3838),
    [anon_sym_boolean] = ACTIONS(3838),
    [anon_sym_async] = ACTIONS(3838),
    [anon_sym_public] = ACTIONS(3838),
    [anon_sym_var] = ACTIONS(3838),
    [anon_sym_while] = ACTIONS(3838),
    [anon_sym_SQUOTE] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3840),
    [sym_number] = ACTIONS(3840),
    [anon_sym_SLASH] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3838),
    [sym_undefined] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3838),
    [ts_builtin_sym_end] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3838),
    [anon_sym_PLUS] = ACTIONS(3838),
    [anon_sym_export] = ACTIONS(3838),
    [anon_sym_do] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_with] = ACTIONS(3838),
    [anon_sym_await] = ACTIONS(3838),
  },
  [1049] = {
    [sym__initializer] = STATE(871),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_COMMA] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
  },
  [1050] = {
    [anon_sym_COMMA] = ACTIONS(3842),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
  },
  [1051] = {
    [sym_computed_property_name] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym__property_name] = STATE(1049),
    [sym_enum_assignment] = STATE(1050),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_number] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1052] = {
    [aux_sym_enum_body_repeat1] = STATE(1052),
    [anon_sym_COMMA] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
  },
  [1053] = {
    [sym_identifier] = ACTIONS(3849),
    [anon_sym_BQUOTE] = ACTIONS(3851),
    [anon_sym_debugger] = ACTIONS(3849),
    [anon_sym_symbol] = ACTIONS(3849),
    [anon_sym_AT] = ACTIONS(3851),
    [anon_sym_DASH] = ACTIONS(3849),
    [anon_sym_void] = ACTIONS(3849),
    [anon_sym_break] = ACTIONS(3849),
    [anon_sym_const] = ACTIONS(3849),
    [sym_super] = ACTIONS(3849),
    [anon_sym_return] = ACTIONS(3849),
    [anon_sym_private] = ACTIONS(3849),
    [anon_sym_static] = ACTIONS(3849),
    [anon_sym_get] = ACTIONS(3849),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_interface] = ACTIONS(3849),
    [anon_sym_default] = ACTIONS(3849),
    [anon_sym_enum] = ACTIONS(3849),
    [anon_sym_delete] = ACTIONS(3849),
    [anon_sym_continue] = ACTIONS(3849),
    [anon_sym_DASH_DASH] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(3849),
    [sym_this] = ACTIONS(3849),
    [anon_sym_yield] = ACTIONS(3849),
    [sym_true] = ACTIONS(3849),
    [anon_sym_throw] = ACTIONS(3849),
    [anon_sym_protected] = ACTIONS(3849),
    [anon_sym_abstract] = ACTIONS(3849),
    [anon_sym_set] = ACTIONS(3849),
    [anon_sym_type] = ACTIONS(3849),
    [anon_sym_import] = ACTIONS(3849),
    [anon_sym_namespace] = ACTIONS(3849),
    [anon_sym_PLUS_PLUS] = ACTIONS(3851),
    [anon_sym_DQUOTE] = ACTIONS(3851),
    [anon_sym_else] = ACTIONS(3849),
    [anon_sym_BANG] = ACTIONS(3851),
    [anon_sym_for] = ACTIONS(3849),
    [anon_sym_LBRACK] = ACTIONS(3851),
    [sym_false] = ACTIONS(3849),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_case] = ACTIONS(3849),
    [anon_sym_module] = ACTIONS(3849),
    [anon_sym_number] = ACTIONS(3849),
    [anon_sym_class] = ACTIONS(3849),
    [anon_sym_declare] = ACTIONS(3849),
    [anon_sym_typeof] = ACTIONS(3849),
    [anon_sym_LBRACE] = ACTIONS(3851),
    [anon_sym_switch] = ACTIONS(3849),
    [anon_sym_LPAREN] = ACTIONS(3851),
    [sym_null] = ACTIONS(3849),
    [anon_sym_any] = ACTIONS(3849),
    [anon_sym_boolean] = ACTIONS(3849),
    [anon_sym_async] = ACTIONS(3849),
    [anon_sym_public] = ACTIONS(3849),
    [anon_sym_var] = ACTIONS(3849),
    [anon_sym_while] = ACTIONS(3849),
    [anon_sym_SQUOTE] = ACTIONS(3851),
    [anon_sym_try] = ACTIONS(3849),
    [anon_sym_LT] = ACTIONS(3851),
    [sym_number] = ACTIONS(3851),
    [anon_sym_SLASH] = ACTIONS(3849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3849),
    [anon_sym_function] = ACTIONS(3849),
    [sym_undefined] = ACTIONS(3849),
    [anon_sym_new] = ACTIONS(3849),
    [ts_builtin_sym_end] = ACTIONS(3851),
    [anon_sym_let] = ACTIONS(3849),
    [anon_sym_PLUS] = ACTIONS(3849),
    [anon_sym_export] = ACTIONS(3849),
    [anon_sym_do] = ACTIONS(3849),
    [anon_sym_TILDE] = ACTIONS(3851),
    [anon_sym_with] = ACTIONS(3849),
    [anon_sym_await] = ACTIONS(3849),
  },
  [1054] = {
    [sym_identifier] = ACTIONS(3853),
    [anon_sym_BQUOTE] = ACTIONS(3855),
    [anon_sym_debugger] = ACTIONS(3853),
    [anon_sym_symbol] = ACTIONS(3853),
    [anon_sym_AT] = ACTIONS(3855),
    [anon_sym_DASH] = ACTIONS(3853),
    [anon_sym_void] = ACTIONS(3853),
    [anon_sym_break] = ACTIONS(3853),
    [anon_sym_const] = ACTIONS(3853),
    [sym_super] = ACTIONS(3853),
    [anon_sym_return] = ACTIONS(3853),
    [anon_sym_private] = ACTIONS(3853),
    [anon_sym_static] = ACTIONS(3853),
    [anon_sym_get] = ACTIONS(3853),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_interface] = ACTIONS(3853),
    [anon_sym_default] = ACTIONS(3853),
    [anon_sym_enum] = ACTIONS(3853),
    [anon_sym_delete] = ACTIONS(3853),
    [anon_sym_continue] = ACTIONS(3853),
    [anon_sym_DASH_DASH] = ACTIONS(3855),
    [anon_sym_if] = ACTIONS(3853),
    [sym_this] = ACTIONS(3853),
    [anon_sym_yield] = ACTIONS(3853),
    [sym_true] = ACTIONS(3853),
    [anon_sym_throw] = ACTIONS(3853),
    [anon_sym_protected] = ACTIONS(3853),
    [anon_sym_abstract] = ACTIONS(3853),
    [anon_sym_set] = ACTIONS(3853),
    [anon_sym_type] = ACTIONS(3853),
    [anon_sym_import] = ACTIONS(3853),
    [anon_sym_namespace] = ACTIONS(3853),
    [anon_sym_PLUS_PLUS] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [anon_sym_else] = ACTIONS(3853),
    [anon_sym_BANG] = ACTIONS(3855),
    [anon_sym_for] = ACTIONS(3853),
    [anon_sym_LBRACK] = ACTIONS(3855),
    [sym_false] = ACTIONS(3853),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_case] = ACTIONS(3853),
    [anon_sym_module] = ACTIONS(3853),
    [anon_sym_number] = ACTIONS(3853),
    [anon_sym_class] = ACTIONS(3853),
    [anon_sym_declare] = ACTIONS(3853),
    [anon_sym_typeof] = ACTIONS(3853),
    [anon_sym_LBRACE] = ACTIONS(3855),
    [anon_sym_switch] = ACTIONS(3853),
    [anon_sym_LPAREN] = ACTIONS(3855),
    [sym_null] = ACTIONS(3853),
    [anon_sym_any] = ACTIONS(3853),
    [anon_sym_boolean] = ACTIONS(3853),
    [anon_sym_async] = ACTIONS(3853),
    [anon_sym_public] = ACTIONS(3853),
    [anon_sym_var] = ACTIONS(3853),
    [anon_sym_while] = ACTIONS(3853),
    [anon_sym_SQUOTE] = ACTIONS(3855),
    [anon_sym_try] = ACTIONS(3853),
    [anon_sym_LT] = ACTIONS(3855),
    [sym_number] = ACTIONS(3855),
    [anon_sym_SLASH] = ACTIONS(3853),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3853),
    [anon_sym_function] = ACTIONS(3853),
    [sym_undefined] = ACTIONS(3853),
    [anon_sym_new] = ACTIONS(3853),
    [ts_builtin_sym_end] = ACTIONS(3855),
    [anon_sym_let] = ACTIONS(3853),
    [anon_sym_PLUS] = ACTIONS(3853),
    [anon_sym_export] = ACTIONS(3853),
    [anon_sym_do] = ACTIONS(3853),
    [anon_sym_TILDE] = ACTIONS(3855),
    [anon_sym_with] = ACTIONS(3853),
    [anon_sym_await] = ACTIONS(3853),
  },
  [1055] = {
    [anon_sym_RPAREN] = ACTIONS(3857),
    [sym_comment] = ACTIONS(3),
  },
  [1056] = {
    [anon_sym_COMMA] = ACTIONS(3859),
    [anon_sym_RBRACE] = ACTIONS(3859),
    [sym_comment] = ACTIONS(3),
  },
  [1057] = {
    [anon_sym_from] = ACTIONS(3861),
    [sym_comment] = ACTIONS(3),
  },
  [1058] = {
    [sym__import_export_specifier] = STATE(885),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(3863),
    [anon_sym_BQUOTE] = ACTIONS(3865),
    [anon_sym_debugger] = ACTIONS(3863),
    [anon_sym_symbol] = ACTIONS(3863),
    [anon_sym_AT] = ACTIONS(3865),
    [anon_sym_DASH] = ACTIONS(3863),
    [anon_sym_void] = ACTIONS(3863),
    [anon_sym_break] = ACTIONS(3863),
    [anon_sym_const] = ACTIONS(3863),
    [sym_super] = ACTIONS(3863),
    [anon_sym_return] = ACTIONS(3863),
    [anon_sym_private] = ACTIONS(3863),
    [anon_sym_static] = ACTIONS(3863),
    [anon_sym_get] = ACTIONS(3863),
    [anon_sym_interface] = ACTIONS(3863),
    [anon_sym_enum] = ACTIONS(3863),
    [anon_sym_delete] = ACTIONS(3863),
    [anon_sym_continue] = ACTIONS(3863),
    [anon_sym_DASH_DASH] = ACTIONS(3865),
    [anon_sym_if] = ACTIONS(3863),
    [sym_this] = ACTIONS(3863),
    [anon_sym_yield] = ACTIONS(3863),
    [sym_true] = ACTIONS(3863),
    [anon_sym_throw] = ACTIONS(3863),
    [anon_sym_protected] = ACTIONS(3863),
    [anon_sym_abstract] = ACTIONS(3863),
    [anon_sym_set] = ACTIONS(3863),
    [anon_sym_type] = ACTIONS(3863),
    [anon_sym_import] = ACTIONS(3863),
    [anon_sym_namespace] = ACTIONS(3863),
    [anon_sym_PLUS_PLUS] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(3865),
    [anon_sym_BANG] = ACTIONS(3865),
    [anon_sym_for] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(3865),
    [sym_false] = ACTIONS(3863),
    [anon_sym_SEMI] = ACTIONS(3865),
    [anon_sym_module] = ACTIONS(3863),
    [anon_sym_number] = ACTIONS(3863),
    [anon_sym_class] = ACTIONS(3863),
    [anon_sym_declare] = ACTIONS(3863),
    [anon_sym_typeof] = ACTIONS(3863),
    [anon_sym_LBRACE] = ACTIONS(3865),
    [anon_sym_switch] = ACTIONS(3863),
    [anon_sym_LPAREN] = ACTIONS(3865),
    [sym_null] = ACTIONS(3863),
    [anon_sym_any] = ACTIONS(3863),
    [anon_sym_boolean] = ACTIONS(3863),
    [anon_sym_async] = ACTIONS(3863),
    [anon_sym_public] = ACTIONS(3863),
    [anon_sym_var] = ACTIONS(3863),
    [anon_sym_while] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3865),
    [anon_sym_try] = ACTIONS(3863),
    [anon_sym_LT] = ACTIONS(3865),
    [sym_number] = ACTIONS(3865),
    [anon_sym_SLASH] = ACTIONS(3863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3863),
    [anon_sym_function] = ACTIONS(3863),
    [sym_undefined] = ACTIONS(3863),
    [anon_sym_new] = ACTIONS(3863),
    [anon_sym_let] = ACTIONS(3863),
    [anon_sym_PLUS] = ACTIONS(3863),
    [anon_sym_export] = ACTIONS(3863),
    [anon_sym_do] = ACTIONS(3863),
    [anon_sym_TILDE] = ACTIONS(3865),
    [anon_sym_with] = ACTIONS(3863),
    [anon_sym_await] = ACTIONS(3863),
  },
  [1060] = {
    [sym_identifier] = ACTIONS(3867),
    [anon_sym_BQUOTE] = ACTIONS(3869),
    [anon_sym_debugger] = ACTIONS(3867),
    [anon_sym_symbol] = ACTIONS(3867),
    [anon_sym_AT] = ACTIONS(3869),
    [anon_sym_DASH] = ACTIONS(3867),
    [anon_sym_void] = ACTIONS(3867),
    [anon_sym_break] = ACTIONS(3867),
    [anon_sym_const] = ACTIONS(3867),
    [sym_super] = ACTIONS(3867),
    [anon_sym_return] = ACTIONS(3867),
    [anon_sym_private] = ACTIONS(3867),
    [anon_sym_static] = ACTIONS(3867),
    [anon_sym_get] = ACTIONS(3867),
    [anon_sym_interface] = ACTIONS(3867),
    [anon_sym_enum] = ACTIONS(3867),
    [anon_sym_delete] = ACTIONS(3867),
    [anon_sym_continue] = ACTIONS(3867),
    [anon_sym_DASH_DASH] = ACTIONS(3869),
    [anon_sym_if] = ACTIONS(3867),
    [sym_this] = ACTIONS(3867),
    [anon_sym_yield] = ACTIONS(3867),
    [sym_true] = ACTIONS(3867),
    [anon_sym_throw] = ACTIONS(3867),
    [anon_sym_protected] = ACTIONS(3867),
    [anon_sym_abstract] = ACTIONS(3867),
    [anon_sym_set] = ACTIONS(3867),
    [anon_sym_type] = ACTIONS(3867),
    [anon_sym_import] = ACTIONS(3867),
    [anon_sym_namespace] = ACTIONS(3867),
    [anon_sym_PLUS_PLUS] = ACTIONS(3869),
    [anon_sym_DQUOTE] = ACTIONS(3869),
    [anon_sym_BANG] = ACTIONS(3869),
    [anon_sym_for] = ACTIONS(3867),
    [anon_sym_LBRACK] = ACTIONS(3869),
    [sym_false] = ACTIONS(3867),
    [anon_sym_SEMI] = ACTIONS(3869),
    [anon_sym_module] = ACTIONS(3867),
    [anon_sym_number] = ACTIONS(3867),
    [anon_sym_class] = ACTIONS(3867),
    [anon_sym_declare] = ACTIONS(3867),
    [anon_sym_typeof] = ACTIONS(3867),
    [anon_sym_LBRACE] = ACTIONS(3869),
    [anon_sym_switch] = ACTIONS(3867),
    [anon_sym_LPAREN] = ACTIONS(3869),
    [sym_null] = ACTIONS(3867),
    [anon_sym_any] = ACTIONS(3867),
    [anon_sym_boolean] = ACTIONS(3867),
    [anon_sym_async] = ACTIONS(3867),
    [anon_sym_public] = ACTIONS(3867),
    [anon_sym_var] = ACTIONS(3867),
    [anon_sym_while] = ACTIONS(3867),
    [anon_sym_SQUOTE] = ACTIONS(3869),
    [anon_sym_try] = ACTIONS(3867),
    [anon_sym_LT] = ACTIONS(3869),
    [sym_number] = ACTIONS(3869),
    [anon_sym_SLASH] = ACTIONS(3867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3867),
    [anon_sym_function] = ACTIONS(3867),
    [sym_undefined] = ACTIONS(3867),
    [anon_sym_new] = ACTIONS(3867),
    [anon_sym_let] = ACTIONS(3867),
    [anon_sym_PLUS] = ACTIONS(3867),
    [anon_sym_export] = ACTIONS(3867),
    [anon_sym_do] = ACTIONS(3867),
    [anon_sym_TILDE] = ACTIONS(3869),
    [anon_sym_with] = ACTIONS(3867),
    [anon_sym_await] = ACTIONS(3867),
  },
  [1061] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1062] = {
    [anon_sym_RPAREN] = ACTIONS(3871),
    [sym_comment] = ACTIONS(3),
  },
  [1063] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3871),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1064] = {
    [anon_sym_RPAREN] = ACTIONS(3873),
    [sym_comment] = ACTIONS(3),
  },
  [1065] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3873),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1066] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1067] = {
    [anon_sym_RPAREN] = ACTIONS(3875),
    [sym_comment] = ACTIONS(3),
  },
  [1068] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3875),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1069] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [sym__automatic_semicolon] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(579),
    [anon_sym_SEMI] = ACTIONS(2701),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(581),
    [anon_sym_COMMA] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(585),
    [anon_sym_STAR] = ACTIONS(589),
    [anon_sym_GT_GT_GT] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG_EQ] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(579),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_AMP] = ACTIONS(595),
    [anon_sym_PERCENT] = ACTIONS(585),
    [anon_sym_QMARK] = ACTIONS(597),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(599),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(593),
    [anon_sym_instanceof] = ACTIONS(579),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_SLASH] = ACTIONS(589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(599),
    [anon_sym_STAR_STAR] = ACTIONS(607),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_GT_GT] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(593),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1070] = {
    [anon_sym_RPAREN] = ACTIONS(3877),
    [sym_comment] = ACTIONS(3),
  },
  [1071] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(3877),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1072] = {
    [sym_identifier] = ACTIONS(3879),
    [anon_sym_BQUOTE] = ACTIONS(3881),
    [anon_sym_debugger] = ACTIONS(3879),
    [anon_sym_symbol] = ACTIONS(3879),
    [anon_sym_AT] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_void] = ACTIONS(3879),
    [anon_sym_break] = ACTIONS(3879),
    [anon_sym_const] = ACTIONS(3879),
    [sym_super] = ACTIONS(3879),
    [anon_sym_return] = ACTIONS(3879),
    [anon_sym_private] = ACTIONS(3879),
    [anon_sym_static] = ACTIONS(3879),
    [anon_sym_get] = ACTIONS(3879),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_interface] = ACTIONS(3879),
    [anon_sym_default] = ACTIONS(3879),
    [anon_sym_enum] = ACTIONS(3879),
    [anon_sym_delete] = ACTIONS(3879),
    [anon_sym_continue] = ACTIONS(3879),
    [anon_sym_DASH_DASH] = ACTIONS(3881),
    [anon_sym_if] = ACTIONS(3879),
    [sym_this] = ACTIONS(3879),
    [anon_sym_yield] = ACTIONS(3879),
    [sym_true] = ACTIONS(3879),
    [anon_sym_throw] = ACTIONS(3879),
    [anon_sym_protected] = ACTIONS(3879),
    [anon_sym_abstract] = ACTIONS(3879),
    [anon_sym_set] = ACTIONS(3879),
    [anon_sym_type] = ACTIONS(3879),
    [anon_sym_import] = ACTIONS(3879),
    [anon_sym_namespace] = ACTIONS(3879),
    [anon_sym_PLUS_PLUS] = ACTIONS(3881),
    [anon_sym_DQUOTE] = ACTIONS(3881),
    [anon_sym_else] = ACTIONS(3879),
    [anon_sym_BANG] = ACTIONS(3881),
    [anon_sym_for] = ACTIONS(3879),
    [anon_sym_LBRACK] = ACTIONS(3881),
    [sym_false] = ACTIONS(3879),
    [anon_sym_SEMI] = ACTIONS(3881),
    [anon_sym_case] = ACTIONS(3879),
    [anon_sym_module] = ACTIONS(3879),
    [anon_sym_number] = ACTIONS(3879),
    [anon_sym_class] = ACTIONS(3879),
    [anon_sym_declare] = ACTIONS(3879),
    [anon_sym_typeof] = ACTIONS(3879),
    [anon_sym_LBRACE] = ACTIONS(3881),
    [anon_sym_switch] = ACTIONS(3879),
    [anon_sym_LPAREN] = ACTIONS(3881),
    [sym_null] = ACTIONS(3879),
    [anon_sym_any] = ACTIONS(3879),
    [anon_sym_boolean] = ACTIONS(3879),
    [anon_sym_async] = ACTIONS(3879),
    [anon_sym_public] = ACTIONS(3879),
    [anon_sym_var] = ACTIONS(3879),
    [anon_sym_while] = ACTIONS(3879),
    [anon_sym_SQUOTE] = ACTIONS(3881),
    [anon_sym_try] = ACTIONS(3879),
    [anon_sym_LT] = ACTIONS(3881),
    [sym_number] = ACTIONS(3881),
    [anon_sym_SLASH] = ACTIONS(3879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3879),
    [anon_sym_function] = ACTIONS(3879),
    [sym_undefined] = ACTIONS(3879),
    [anon_sym_new] = ACTIONS(3879),
    [ts_builtin_sym_end] = ACTIONS(3881),
    [anon_sym_let] = ACTIONS(3879),
    [anon_sym_PLUS] = ACTIONS(3879),
    [anon_sym_export] = ACTIONS(3879),
    [anon_sym_do] = ACTIONS(3879),
    [anon_sym_TILDE] = ACTIONS(3881),
    [anon_sym_with] = ACTIONS(3879),
    [anon_sym_await] = ACTIONS(3879),
  },
  [1073] = {
    [sym_generator_function_declaration] = STATE(1163),
    [sym__declaration] = STATE(1163),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1163),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1163),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1163),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1163),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1163),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1163),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1163),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1163),
    [sym_function_declaration] = STATE(1163),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1163),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1163),
    [sym_break_statement] = STATE(1163),
    [sym_labeled_statement] = STATE(1163),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(1163),
    [sym_class_declaration] = STATE(1163),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1163),
    [sym_ambient_declaration] = STATE(1163),
    [sym_type_alias_declaration] = STATE(1163),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1163),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1163),
    [sym_switch_statement] = STATE(1163),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1163),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1163),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1163),
    [sym_abstract_class_declaration] = STATE(1163),
    [sym_interface_declaration] = STATE(1163),
    [sym_export_statement] = STATE(1163),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1163),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1163),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1163),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1074] = {
    [sym_identifier] = ACTIONS(3883),
    [anon_sym_BQUOTE] = ACTIONS(3885),
    [anon_sym_debugger] = ACTIONS(3883),
    [anon_sym_symbol] = ACTIONS(3883),
    [anon_sym_AT] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(3883),
    [anon_sym_void] = ACTIONS(3883),
    [anon_sym_break] = ACTIONS(3883),
    [anon_sym_const] = ACTIONS(3883),
    [sym_super] = ACTIONS(3883),
    [anon_sym_return] = ACTIONS(3883),
    [anon_sym_private] = ACTIONS(3883),
    [anon_sym_static] = ACTIONS(3883),
    [anon_sym_get] = ACTIONS(3883),
    [anon_sym_interface] = ACTIONS(3883),
    [anon_sym_enum] = ACTIONS(3883),
    [anon_sym_delete] = ACTIONS(3883),
    [anon_sym_continue] = ACTIONS(3883),
    [anon_sym_DASH_DASH] = ACTIONS(3885),
    [anon_sym_if] = ACTIONS(3883),
    [sym_this] = ACTIONS(3883),
    [anon_sym_yield] = ACTIONS(3883),
    [sym_true] = ACTIONS(3883),
    [anon_sym_throw] = ACTIONS(3883),
    [anon_sym_protected] = ACTIONS(3883),
    [anon_sym_abstract] = ACTIONS(3883),
    [anon_sym_set] = ACTIONS(3883),
    [anon_sym_type] = ACTIONS(3883),
    [anon_sym_import] = ACTIONS(3883),
    [anon_sym_namespace] = ACTIONS(3883),
    [anon_sym_PLUS_PLUS] = ACTIONS(3885),
    [anon_sym_DQUOTE] = ACTIONS(3885),
    [anon_sym_BANG] = ACTIONS(3885),
    [anon_sym_for] = ACTIONS(3883),
    [anon_sym_LBRACK] = ACTIONS(3885),
    [sym_false] = ACTIONS(3883),
    [anon_sym_SEMI] = ACTIONS(3885),
    [anon_sym_module] = ACTIONS(3883),
    [anon_sym_number] = ACTIONS(3883),
    [anon_sym_class] = ACTIONS(3883),
    [anon_sym_declare] = ACTIONS(3883),
    [anon_sym_typeof] = ACTIONS(3883),
    [anon_sym_LBRACE] = ACTIONS(3885),
    [anon_sym_switch] = ACTIONS(3883),
    [anon_sym_LPAREN] = ACTIONS(3885),
    [sym_null] = ACTIONS(3883),
    [anon_sym_any] = ACTIONS(3883),
    [anon_sym_boolean] = ACTIONS(3883),
    [anon_sym_async] = ACTIONS(3883),
    [anon_sym_public] = ACTIONS(3883),
    [anon_sym_var] = ACTIONS(3883),
    [anon_sym_while] = ACTIONS(3883),
    [anon_sym_SQUOTE] = ACTIONS(3885),
    [anon_sym_try] = ACTIONS(3883),
    [anon_sym_LT] = ACTIONS(3885),
    [sym_number] = ACTIONS(3885),
    [anon_sym_SLASH] = ACTIONS(3883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3883),
    [anon_sym_function] = ACTIONS(3883),
    [sym_undefined] = ACTIONS(3883),
    [anon_sym_new] = ACTIONS(3883),
    [anon_sym_let] = ACTIONS(3883),
    [anon_sym_PLUS] = ACTIONS(3883),
    [anon_sym_export] = ACTIONS(3883),
    [anon_sym_do] = ACTIONS(3883),
    [anon_sym_TILDE] = ACTIONS(3885),
    [anon_sym_with] = ACTIONS(3883),
    [anon_sym_await] = ACTIONS(3883),
  },
  [1075] = {
    [sym_identifier] = ACTIONS(3887),
    [anon_sym_BQUOTE] = ACTIONS(3889),
    [anon_sym_debugger] = ACTIONS(3887),
    [anon_sym_symbol] = ACTIONS(3887),
    [anon_sym_AT] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(3887),
    [anon_sym_void] = ACTIONS(3887),
    [anon_sym_break] = ACTIONS(3887),
    [anon_sym_const] = ACTIONS(3887),
    [sym_super] = ACTIONS(3887),
    [anon_sym_return] = ACTIONS(3887),
    [anon_sym_private] = ACTIONS(3887),
    [anon_sym_static] = ACTIONS(3887),
    [anon_sym_get] = ACTIONS(3887),
    [anon_sym_interface] = ACTIONS(3887),
    [anon_sym_enum] = ACTIONS(3887),
    [anon_sym_delete] = ACTIONS(3887),
    [anon_sym_continue] = ACTIONS(3887),
    [anon_sym_DASH_DASH] = ACTIONS(3889),
    [anon_sym_if] = ACTIONS(3887),
    [sym_this] = ACTIONS(3887),
    [anon_sym_yield] = ACTIONS(3887),
    [sym_true] = ACTIONS(3887),
    [anon_sym_throw] = ACTIONS(3887),
    [anon_sym_protected] = ACTIONS(3887),
    [anon_sym_abstract] = ACTIONS(3887),
    [anon_sym_set] = ACTIONS(3887),
    [anon_sym_type] = ACTIONS(3887),
    [anon_sym_import] = ACTIONS(3887),
    [anon_sym_namespace] = ACTIONS(3887),
    [anon_sym_PLUS_PLUS] = ACTIONS(3889),
    [anon_sym_DQUOTE] = ACTIONS(3889),
    [anon_sym_BANG] = ACTIONS(3889),
    [anon_sym_for] = ACTIONS(3887),
    [anon_sym_LBRACK] = ACTIONS(3889),
    [sym_false] = ACTIONS(3887),
    [anon_sym_SEMI] = ACTIONS(3889),
    [anon_sym_module] = ACTIONS(3887),
    [anon_sym_number] = ACTIONS(3887),
    [anon_sym_class] = ACTIONS(3887),
    [anon_sym_declare] = ACTIONS(3887),
    [anon_sym_typeof] = ACTIONS(3887),
    [anon_sym_LBRACE] = ACTIONS(3889),
    [anon_sym_switch] = ACTIONS(3887),
    [anon_sym_LPAREN] = ACTIONS(3889),
    [sym_null] = ACTIONS(3887),
    [anon_sym_any] = ACTIONS(3887),
    [anon_sym_boolean] = ACTIONS(3887),
    [anon_sym_async] = ACTIONS(3887),
    [anon_sym_public] = ACTIONS(3887),
    [anon_sym_var] = ACTIONS(3887),
    [anon_sym_while] = ACTIONS(3887),
    [anon_sym_SQUOTE] = ACTIONS(3889),
    [anon_sym_try] = ACTIONS(3887),
    [anon_sym_LT] = ACTIONS(3889),
    [sym_number] = ACTIONS(3889),
    [anon_sym_SLASH] = ACTIONS(3887),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3887),
    [anon_sym_function] = ACTIONS(3887),
    [sym_undefined] = ACTIONS(3887),
    [anon_sym_new] = ACTIONS(3887),
    [anon_sym_let] = ACTIONS(3887),
    [anon_sym_PLUS] = ACTIONS(3887),
    [anon_sym_export] = ACTIONS(3887),
    [anon_sym_do] = ACTIONS(3887),
    [anon_sym_TILDE] = ACTIONS(3889),
    [anon_sym_with] = ACTIONS(3887),
    [anon_sym_await] = ACTIONS(3887),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(3891),
    [anon_sym_BQUOTE] = ACTIONS(3893),
    [anon_sym_debugger] = ACTIONS(3891),
    [anon_sym_symbol] = ACTIONS(3891),
    [anon_sym_AT] = ACTIONS(3893),
    [anon_sym_DASH] = ACTIONS(3891),
    [anon_sym_void] = ACTIONS(3891),
    [anon_sym_break] = ACTIONS(3891),
    [anon_sym_const] = ACTIONS(3891),
    [sym_super] = ACTIONS(3891),
    [anon_sym_return] = ACTIONS(3891),
    [anon_sym_private] = ACTIONS(3891),
    [anon_sym_static] = ACTIONS(3891),
    [anon_sym_get] = ACTIONS(3891),
    [anon_sym_RBRACE] = ACTIONS(3893),
    [anon_sym_interface] = ACTIONS(3891),
    [anon_sym_default] = ACTIONS(3891),
    [anon_sym_enum] = ACTIONS(3891),
    [anon_sym_delete] = ACTIONS(3891),
    [anon_sym_continue] = ACTIONS(3891),
    [anon_sym_DASH_DASH] = ACTIONS(3893),
    [anon_sym_if] = ACTIONS(3891),
    [sym_this] = ACTIONS(3891),
    [anon_sym_yield] = ACTIONS(3891),
    [sym_true] = ACTIONS(3891),
    [anon_sym_throw] = ACTIONS(3891),
    [anon_sym_protected] = ACTIONS(3891),
    [anon_sym_abstract] = ACTIONS(3891),
    [anon_sym_set] = ACTIONS(3891),
    [anon_sym_type] = ACTIONS(3891),
    [anon_sym_import] = ACTIONS(3891),
    [anon_sym_namespace] = ACTIONS(3891),
    [anon_sym_PLUS_PLUS] = ACTIONS(3893),
    [anon_sym_DQUOTE] = ACTIONS(3893),
    [anon_sym_else] = ACTIONS(3891),
    [anon_sym_BANG] = ACTIONS(3893),
    [anon_sym_for] = ACTIONS(3891),
    [anon_sym_LBRACK] = ACTIONS(3893),
    [sym_false] = ACTIONS(3891),
    [anon_sym_SEMI] = ACTIONS(3893),
    [anon_sym_case] = ACTIONS(3891),
    [anon_sym_module] = ACTIONS(3891),
    [anon_sym_number] = ACTIONS(3891),
    [anon_sym_class] = ACTIONS(3891),
    [anon_sym_declare] = ACTIONS(3891),
    [anon_sym_typeof] = ACTIONS(3891),
    [anon_sym_LBRACE] = ACTIONS(3893),
    [anon_sym_switch] = ACTIONS(3891),
    [anon_sym_LPAREN] = ACTIONS(3893),
    [sym_null] = ACTIONS(3891),
    [anon_sym_any] = ACTIONS(3891),
    [anon_sym_boolean] = ACTIONS(3891),
    [anon_sym_async] = ACTIONS(3891),
    [anon_sym_public] = ACTIONS(3891),
    [anon_sym_var] = ACTIONS(3891),
    [anon_sym_while] = ACTIONS(3891),
    [anon_sym_SQUOTE] = ACTIONS(3893),
    [anon_sym_try] = ACTIONS(3891),
    [anon_sym_LT] = ACTIONS(3893),
    [sym_number] = ACTIONS(3893),
    [anon_sym_SLASH] = ACTIONS(3891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3891),
    [anon_sym_function] = ACTIONS(3891),
    [sym_undefined] = ACTIONS(3891),
    [anon_sym_new] = ACTIONS(3891),
    [ts_builtin_sym_end] = ACTIONS(3893),
    [anon_sym_let] = ACTIONS(3891),
    [anon_sym_PLUS] = ACTIONS(3891),
    [anon_sym_export] = ACTIONS(3891),
    [anon_sym_do] = ACTIONS(3891),
    [anon_sym_TILDE] = ACTIONS(3893),
    [anon_sym_with] = ACTIONS(3891),
    [anon_sym_await] = ACTIONS(3891),
  },
  [1077] = {
    [sym_statement_block] = STATE(1561),
    [sym__automatic_semicolon] = ACTIONS(3895),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1078] = {
    [anon_sym_RBRACK] = ACTIONS(3897),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(3899),
    [sym_comment] = ACTIONS(3),
  },
  [1080] = {
    [anon_sym_RBRACK] = ACTIONS(3901),
    [sym_comment] = ACTIONS(3),
  },
  [1081] = {
    [sym__automatic_semicolon] = ACTIONS(3903),
    [anon_sym_RBRACE] = ACTIONS(3903),
    [anon_sym_SEMI] = ACTIONS(3903),
    [anon_sym_COMMA] = ACTIONS(3903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3903),
  },
  [1082] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1166),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1083] = {
    [sym__automatic_semicolon] = ACTIONS(3905),
    [anon_sym_SEMI] = ACTIONS(3905),
    [anon_sym_COMMA] = ACTIONS(3905),
    [sym_comment] = ACTIONS(3),
  },
  [1084] = {
    [sym__initializer] = STATE(1167),
    [sym_type_annotation] = STATE(1168),
    [sym__automatic_semicolon] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym_COMMA] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
  },
  [1085] = {
    [sym__automatic_semicolon] = ACTIONS(3909),
    [anon_sym_SEMI] = ACTIONS(3909),
    [anon_sym_COMMA] = ACTIONS(3909),
    [sym_comment] = ACTIONS(3),
  },
  [1086] = {
    [sym__initializer] = STATE(1169),
    [sym__automatic_semicolon] = ACTIONS(3911),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(3911),
    [anon_sym_COMMA] = ACTIONS(3911),
    [sym_comment] = ACTIONS(3),
  },
  [1087] = {
    [sym__automatic_semicolon] = ACTIONS(3913),
    [anon_sym_SEMI] = ACTIONS(3913),
    [anon_sym_COMMA] = ACTIONS(3913),
    [sym_comment] = ACTIONS(3),
  },
  [1088] = {
    [sym__automatic_semicolon] = ACTIONS(3915),
    [anon_sym_SEMI] = ACTIONS(3915),
    [anon_sym_COMMA] = ACTIONS(3915),
    [sym_comment] = ACTIONS(3),
  },
  [1089] = {
    [sym__initializer] = STATE(1170),
    [sym__automatic_semicolon] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(3917),
    [anon_sym_COMMA] = ACTIONS(3917),
    [sym_comment] = ACTIONS(3),
  },
  [1090] = {
    [sym__automatic_semicolon] = ACTIONS(3919),
    [anon_sym_SEMI] = ACTIONS(3919),
    [anon_sym_COMMA] = ACTIONS(3919),
    [sym_comment] = ACTIONS(3),
  },
  [1091] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1171),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1092] = {
    [sym_statement_block] = STATE(1562),
    [sym__automatic_semicolon] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1093] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1173),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3923),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1094] = {
    [sym_string] = STATE(1174),
    [sym__property_name] = STATE(1174),
    [sym_computed_property_name] = STATE(1174),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1095] = {
    [sym_string] = STATE(1174),
    [sym__property_name] = STATE(1174),
    [sym_computed_property_name] = STATE(1174),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1096] = {
    [sym_type_annotation] = STATE(1168),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1167),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1171),
    [sym__automatic_semicolon] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
  },
  [1097] = {
    [sym_string] = STATE(1174),
    [sym__property_name] = STATE(1174),
    [sym_computed_property_name] = STATE(1174),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3927),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3929),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3929),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [1098] = {
    [sym_type_annotation] = STATE(1180),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1179),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1173),
    [sym__automatic_semicolon] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3933),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3935),
  },
  [1099] = {
    [sym__initializer] = STATE(1179),
    [sym_type_annotation] = STATE(1180),
    [sym__automatic_semicolon] = ACTIONS(3931),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3931),
    [anon_sym_QMARK] = ACTIONS(3935),
    [anon_sym_COMMA] = ACTIONS(3931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3935),
  },
  [1100] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1182),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3937),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1101] = {
    [sym_type_annotation] = STATE(1168),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1167),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1166),
    [sym__automatic_semicolon] = ACTIONS(3907),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3907),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3907),
    [sym_comment] = ACTIONS(3),
  },
  [1102] = {
    [sym__automatic_semicolon] = ACTIONS(3939),
    [anon_sym_SEMI] = ACTIONS(3939),
    [anon_sym_COMMA] = ACTIONS(3939),
    [sym_comment] = ACTIONS(3),
  },
  [1103] = {
    [anon_sym_BQUOTE] = ACTIONS(3941),
    [anon_sym_symbol] = ACTIONS(3943),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3943),
    [anon_sym_return] = ACTIONS(3943),
    [anon_sym_static] = ACTIONS(3943),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_interface] = ACTIONS(3943),
    [anon_sym_delete] = ACTIONS(3943),
    [anon_sym_if] = ACTIONS(3943),
    [anon_sym_yield] = ACTIONS(3943),
    [sym_true] = ACTIONS(3943),
    [anon_sym_protected] = ACTIONS(3943),
    [anon_sym_set] = ACTIONS(3943),
    [anon_sym_import] = ACTIONS(3943),
    [anon_sym_DQUOTE] = ACTIONS(3941),
    [anon_sym_for] = ACTIONS(3943),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_number] = ACTIONS(3943),
    [anon_sym_typeof] = ACTIONS(3943),
    [anon_sym_LBRACE] = ACTIONS(3941),
    [anon_sym_switch] = ACTIONS(3943),
    [sym_null] = ACTIONS(3943),
    [anon_sym_any] = ACTIONS(3943),
    [anon_sym_async] = ACTIONS(3943),
    [anon_sym_public] = ACTIONS(3943),
    [anon_sym_var] = ACTIONS(3943),
    [anon_sym_while] = ACTIONS(3943),
    [anon_sym_SQUOTE] = ACTIONS(3941),
    [anon_sym_SLASH] = ACTIONS(3943),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3943),
    [anon_sym_new] = ACTIONS(3943),
    [anon_sym_export] = ACTIONS(3943),
    [anon_sym_with] = ACTIONS(3943),
    [sym_identifier] = ACTIONS(3943),
    [anon_sym_debugger] = ACTIONS(3943),
    [anon_sym_AT] = ACTIONS(3941),
    [anon_sym_DASH] = ACTIONS(3943),
    [anon_sym_void] = ACTIONS(3943),
    [anon_sym_const] = ACTIONS(3943),
    [sym_super] = ACTIONS(3943),
    [anon_sym_private] = ACTIONS(3943),
    [anon_sym_get] = ACTIONS(3943),
    [anon_sym_default] = ACTIONS(3943),
    [anon_sym_enum] = ACTIONS(3943),
    [anon_sym_continue] = ACTIONS(3943),
    [anon_sym_DASH_DASH] = ACTIONS(3941),
    [sym_this] = ACTIONS(3943),
    [anon_sym_throw] = ACTIONS(3943),
    [anon_sym_abstract] = ACTIONS(3943),
    [anon_sym_type] = ACTIONS(3943),
    [anon_sym_namespace] = ACTIONS(3943),
    [anon_sym_PLUS_PLUS] = ACTIONS(3941),
    [anon_sym_else] = ACTIONS(3943),
    [anon_sym_BANG] = ACTIONS(3941),
    [anon_sym_LBRACK] = ACTIONS(3941),
    [sym_false] = ACTIONS(3943),
    [anon_sym_case] = ACTIONS(3943),
    [anon_sym_module] = ACTIONS(3943),
    [anon_sym_class] = ACTIONS(3943),
    [anon_sym_declare] = ACTIONS(3943),
    [anon_sym_LPAREN] = ACTIONS(3941),
    [anon_sym_boolean] = ACTIONS(3943),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3943),
    [anon_sym_LT] = ACTIONS(3941),
    [sym_number] = ACTIONS(3941),
    [ts_builtin_sym_end] = ACTIONS(3941),
    [anon_sym_function] = ACTIONS(3943),
    [sym_undefined] = ACTIONS(3943),
    [anon_sym_let] = ACTIONS(3943),
    [anon_sym_PLUS] = ACTIONS(3943),
    [anon_sym_do] = ACTIONS(3943),
    [anon_sym_TILDE] = ACTIONS(3941),
    [anon_sym_await] = ACTIONS(3943),
  },
  [1104] = {
    [sym__automatic_semicolon] = ACTIONS(3523),
    [sym_identifier] = ACTIONS(3527),
    [anon_sym_BQUOTE] = ACTIONS(3525),
    [anon_sym_debugger] = ACTIONS(3527),
    [anon_sym_symbol] = ACTIONS(3527),
    [anon_sym_AT] = ACTIONS(3525),
    [anon_sym_DASH] = ACTIONS(3527),
    [anon_sym_void] = ACTIONS(3527),
    [anon_sym_break] = ACTIONS(3527),
    [anon_sym_const] = ACTIONS(3527),
    [sym_super] = ACTIONS(3527),
    [anon_sym_return] = ACTIONS(3527),
    [anon_sym_private] = ACTIONS(3527),
    [anon_sym_static] = ACTIONS(3527),
    [anon_sym_get] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_interface] = ACTIONS(3527),
    [anon_sym_default] = ACTIONS(3527),
    [anon_sym_enum] = ACTIONS(3527),
    [anon_sym_delete] = ACTIONS(3527),
    [anon_sym_continue] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3527),
    [sym_this] = ACTIONS(3527),
    [anon_sym_yield] = ACTIONS(3527),
    [sym_true] = ACTIONS(3527),
    [anon_sym_throw] = ACTIONS(3527),
    [anon_sym_protected] = ACTIONS(3527),
    [anon_sym_abstract] = ACTIONS(3527),
    [anon_sym_set] = ACTIONS(3527),
    [anon_sym_type] = ACTIONS(3527),
    [anon_sym_import] = ACTIONS(3527),
    [anon_sym_namespace] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(3525),
    [anon_sym_else] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_for] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3525),
    [sym_false] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3527),
    [anon_sym_module] = ACTIONS(3527),
    [anon_sym_number] = ACTIONS(3527),
    [anon_sym_class] = ACTIONS(3527),
    [anon_sym_declare] = ACTIONS(3527),
    [anon_sym_typeof] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3525),
    [sym_null] = ACTIONS(3527),
    [anon_sym_any] = ACTIONS(3527),
    [anon_sym_boolean] = ACTIONS(3527),
    [anon_sym_async] = ACTIONS(3527),
    [anon_sym_public] = ACTIONS(3527),
    [anon_sym_var] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_SQUOTE] = ACTIONS(3525),
    [anon_sym_try] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3525),
    [sym_number] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3527),
    [anon_sym_function] = ACTIONS(3527),
    [sym_undefined] = ACTIONS(3527),
    [anon_sym_new] = ACTIONS(3527),
    [ts_builtin_sym_end] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3527),
    [anon_sym_export] = ACTIONS(3527),
    [anon_sym_do] = ACTIONS(3527),
    [anon_sym_TILDE] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3527),
    [anon_sym_await] = ACTIONS(3527),
  },
  [1105] = {
    [sym__automatic_semicolon] = ACTIONS(3633),
    [sym_identifier] = ACTIONS(3637),
    [anon_sym_BQUOTE] = ACTIONS(3635),
    [anon_sym_debugger] = ACTIONS(3637),
    [anon_sym_symbol] = ACTIONS(3637),
    [anon_sym_AT] = ACTIONS(3635),
    [anon_sym_DASH] = ACTIONS(3637),
    [anon_sym_void] = ACTIONS(3637),
    [anon_sym_break] = ACTIONS(3637),
    [anon_sym_const] = ACTIONS(3637),
    [sym_super] = ACTIONS(3637),
    [anon_sym_return] = ACTIONS(3637),
    [anon_sym_private] = ACTIONS(3637),
    [anon_sym_static] = ACTIONS(3637),
    [anon_sym_get] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_interface] = ACTIONS(3637),
    [anon_sym_default] = ACTIONS(3637),
    [anon_sym_enum] = ACTIONS(3637),
    [anon_sym_delete] = ACTIONS(3637),
    [anon_sym_continue] = ACTIONS(3637),
    [anon_sym_DASH_DASH] = ACTIONS(3635),
    [anon_sym_if] = ACTIONS(3637),
    [sym_this] = ACTIONS(3637),
    [anon_sym_yield] = ACTIONS(3637),
    [sym_true] = ACTIONS(3637),
    [anon_sym_throw] = ACTIONS(3637),
    [anon_sym_protected] = ACTIONS(3637),
    [anon_sym_abstract] = ACTIONS(3637),
    [anon_sym_set] = ACTIONS(3637),
    [anon_sym_type] = ACTIONS(3637),
    [anon_sym_import] = ACTIONS(3637),
    [anon_sym_namespace] = ACTIONS(3637),
    [anon_sym_PLUS_PLUS] = ACTIONS(3635),
    [anon_sym_DQUOTE] = ACTIONS(3635),
    [anon_sym_else] = ACTIONS(3637),
    [anon_sym_BANG] = ACTIONS(3635),
    [anon_sym_for] = ACTIONS(3637),
    [anon_sym_LBRACK] = ACTIONS(3635),
    [sym_false] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_case] = ACTIONS(3637),
    [anon_sym_module] = ACTIONS(3637),
    [anon_sym_number] = ACTIONS(3637),
    [anon_sym_class] = ACTIONS(3637),
    [anon_sym_declare] = ACTIONS(3637),
    [anon_sym_typeof] = ACTIONS(3637),
    [anon_sym_LBRACE] = ACTIONS(3635),
    [anon_sym_switch] = ACTIONS(3637),
    [anon_sym_LPAREN] = ACTIONS(3635),
    [sym_null] = ACTIONS(3637),
    [anon_sym_any] = ACTIONS(3637),
    [anon_sym_boolean] = ACTIONS(3637),
    [anon_sym_async] = ACTIONS(3637),
    [anon_sym_public] = ACTIONS(3637),
    [anon_sym_var] = ACTIONS(3637),
    [anon_sym_while] = ACTIONS(3637),
    [anon_sym_SQUOTE] = ACTIONS(3635),
    [anon_sym_try] = ACTIONS(3637),
    [anon_sym_LT] = ACTIONS(3635),
    [sym_number] = ACTIONS(3635),
    [anon_sym_SLASH] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3637),
    [anon_sym_function] = ACTIONS(3637),
    [sym_undefined] = ACTIONS(3637),
    [anon_sym_new] = ACTIONS(3637),
    [ts_builtin_sym_end] = ACTIONS(3635),
    [anon_sym_let] = ACTIONS(3637),
    [anon_sym_PLUS] = ACTIONS(3637),
    [anon_sym_export] = ACTIONS(3637),
    [anon_sym_do] = ACTIONS(3637),
    [anon_sym_TILDE] = ACTIONS(3635),
    [anon_sym_with] = ACTIONS(3637),
    [anon_sym_await] = ACTIONS(3637),
  },
  [1106] = {
    [sym_statement_block] = STATE(1183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3015),
  },
  [1107] = {
    [sym__automatic_semicolon] = ACTIONS(3763),
    [sym_identifier] = ACTIONS(3767),
    [anon_sym_BQUOTE] = ACTIONS(3765),
    [anon_sym_debugger] = ACTIONS(3767),
    [anon_sym_symbol] = ACTIONS(3767),
    [anon_sym_AT] = ACTIONS(3765),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_void] = ACTIONS(3767),
    [anon_sym_break] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3767),
    [sym_super] = ACTIONS(3767),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_private] = ACTIONS(3767),
    [anon_sym_static] = ACTIONS(3767),
    [anon_sym_get] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_interface] = ACTIONS(3767),
    [anon_sym_default] = ACTIONS(3767),
    [anon_sym_enum] = ACTIONS(3767),
    [anon_sym_delete] = ACTIONS(3767),
    [anon_sym_continue] = ACTIONS(3767),
    [anon_sym_DASH_DASH] = ACTIONS(3765),
    [anon_sym_if] = ACTIONS(3767),
    [sym_this] = ACTIONS(3767),
    [anon_sym_yield] = ACTIONS(3767),
    [sym_true] = ACTIONS(3767),
    [anon_sym_throw] = ACTIONS(3767),
    [anon_sym_protected] = ACTIONS(3767),
    [anon_sym_abstract] = ACTIONS(3767),
    [anon_sym_set] = ACTIONS(3767),
    [anon_sym_type] = ACTIONS(3767),
    [anon_sym_import] = ACTIONS(3767),
    [anon_sym_namespace] = ACTIONS(3767),
    [anon_sym_PLUS_PLUS] = ACTIONS(3765),
    [anon_sym_DQUOTE] = ACTIONS(3765),
    [anon_sym_else] = ACTIONS(3767),
    [anon_sym_BANG] = ACTIONS(3765),
    [anon_sym_for] = ACTIONS(3767),
    [anon_sym_LBRACK] = ACTIONS(3765),
    [sym_false] = ACTIONS(3767),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_case] = ACTIONS(3767),
    [anon_sym_module] = ACTIONS(3767),
    [anon_sym_number] = ACTIONS(3767),
    [anon_sym_class] = ACTIONS(3767),
    [anon_sym_declare] = ACTIONS(3767),
    [anon_sym_typeof] = ACTIONS(3767),
    [anon_sym_LBRACE] = ACTIONS(3765),
    [anon_sym_switch] = ACTIONS(3767),
    [anon_sym_LPAREN] = ACTIONS(3765),
    [sym_null] = ACTIONS(3767),
    [anon_sym_any] = ACTIONS(3767),
    [anon_sym_boolean] = ACTIONS(3767),
    [anon_sym_async] = ACTIONS(3767),
    [anon_sym_public] = ACTIONS(3767),
    [anon_sym_var] = ACTIONS(3767),
    [anon_sym_while] = ACTIONS(3767),
    [anon_sym_SQUOTE] = ACTIONS(3765),
    [anon_sym_try] = ACTIONS(3767),
    [anon_sym_LT] = ACTIONS(3765),
    [sym_number] = ACTIONS(3765),
    [anon_sym_SLASH] = ACTIONS(3767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3767),
    [anon_sym_function] = ACTIONS(3767),
    [sym_undefined] = ACTIONS(3767),
    [anon_sym_new] = ACTIONS(3767),
    [ts_builtin_sym_end] = ACTIONS(3765),
    [anon_sym_let] = ACTIONS(3767),
    [anon_sym_PLUS] = ACTIONS(3767),
    [anon_sym_export] = ACTIONS(3767),
    [anon_sym_do] = ACTIONS(3767),
    [anon_sym_TILDE] = ACTIONS(3765),
    [anon_sym_with] = ACTIONS(3767),
    [anon_sym_await] = ACTIONS(3767),
  },
  [1108] = {
    [sym__automatic_semicolon] = ACTIONS(3816),
    [sym_identifier] = ACTIONS(3820),
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_debugger] = ACTIONS(3820),
    [anon_sym_symbol] = ACTIONS(3820),
    [anon_sym_AT] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_void] = ACTIONS(3820),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [sym_super] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_static] = ACTIONS(3820),
    [anon_sym_get] = ACTIONS(3820),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3820),
    [sym_this] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3820),
    [sym_true] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_set] = ACTIONS(3820),
    [anon_sym_type] = ACTIONS(3820),
    [anon_sym_import] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_else] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [sym_false] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_module] = ACTIONS(3820),
    [anon_sym_number] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_declare] = ACTIONS(3820),
    [anon_sym_typeof] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [sym_null] = ACTIONS(3820),
    [anon_sym_any] = ACTIONS(3820),
    [anon_sym_boolean] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3818),
    [sym_number] = ACTIONS(3818),
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3820),
    [anon_sym_function] = ACTIONS(3820),
    [sym_undefined] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [ts_builtin_sym_end] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_export] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3818),
    [anon_sym_with] = ACTIONS(3820),
    [anon_sym_await] = ACTIONS(3820),
  },
  [1109] = {
    [sym__automatic_semicolon] = ACTIONS(3826),
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3828),
    [anon_sym_debugger] = ACTIONS(3830),
    [anon_sym_symbol] = ACTIONS(3830),
    [anon_sym_AT] = ACTIONS(3828),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_void] = ACTIONS(3830),
    [anon_sym_break] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [sym_super] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3830),
    [anon_sym_private] = ACTIONS(3830),
    [anon_sym_static] = ACTIONS(3830),
    [anon_sym_get] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_interface] = ACTIONS(3830),
    [anon_sym_default] = ACTIONS(3830),
    [anon_sym_enum] = ACTIONS(3830),
    [anon_sym_delete] = ACTIONS(3830),
    [anon_sym_continue] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3828),
    [anon_sym_if] = ACTIONS(3830),
    [sym_this] = ACTIONS(3830),
    [anon_sym_yield] = ACTIONS(3830),
    [sym_true] = ACTIONS(3830),
    [anon_sym_throw] = ACTIONS(3830),
    [anon_sym_protected] = ACTIONS(3830),
    [anon_sym_abstract] = ACTIONS(3830),
    [anon_sym_set] = ACTIONS(3830),
    [anon_sym_type] = ACTIONS(3830),
    [anon_sym_import] = ACTIONS(3830),
    [anon_sym_namespace] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3828),
    [anon_sym_DQUOTE] = ACTIONS(3828),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_for] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3828),
    [sym_false] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_case] = ACTIONS(3830),
    [anon_sym_module] = ACTIONS(3830),
    [anon_sym_number] = ACTIONS(3830),
    [anon_sym_class] = ACTIONS(3830),
    [anon_sym_declare] = ACTIONS(3830),
    [anon_sym_typeof] = ACTIONS(3830),
    [anon_sym_LBRACE] = ACTIONS(3828),
    [anon_sym_switch] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3828),
    [sym_null] = ACTIONS(3830),
    [anon_sym_any] = ACTIONS(3830),
    [anon_sym_boolean] = ACTIONS(3830),
    [anon_sym_async] = ACTIONS(3830),
    [anon_sym_public] = ACTIONS(3830),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_while] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3828),
    [anon_sym_try] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3828),
    [sym_number] = ACTIONS(3828),
    [anon_sym_SLASH] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3830),
    [anon_sym_function] = ACTIONS(3830),
    [sym_undefined] = ACTIONS(3830),
    [anon_sym_new] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3828),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_export] = ACTIONS(3830),
    [anon_sym_do] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3828),
    [anon_sym_with] = ACTIONS(3830),
    [anon_sym_await] = ACTIONS(3830),
  },
  [1110] = {
    [sym_class_body] = STATE(1184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2151),
  },
  [1111] = {
    [anon_sym_COMMA] = ACTIONS(3949),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
  },
  [1112] = {
    [sym_statement_block] = STATE(1185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1113] = {
    [anon_sym_COMMA] = ACTIONS(3951),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
  },
  [1114] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1186),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1115] = {
    [sym_statement_block] = STATE(1187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1116] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1189),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3953),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [1117] = {
    [sym_string] = STATE(1190),
    [sym__property_name] = STATE(1190),
    [sym_computed_property_name] = STATE(1190),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1118] = {
    [sym_string] = STATE(1190),
    [sym__property_name] = STATE(1190),
    [sym_computed_property_name] = STATE(1190),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3955),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1119] = {
    [sym_generator_function_declaration] = STATE(1191),
    [sym__declaration] = STATE(1191),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1191),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1191),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1191),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1191),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1191),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1191),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1191),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1191),
    [sym_function_declaration] = STATE(1191),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1191),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1191),
    [sym_break_statement] = STATE(1191),
    [sym_labeled_statement] = STATE(1191),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(1191),
    [sym_class_declaration] = STATE(1191),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1191),
    [sym_ambient_declaration] = STATE(1191),
    [sym_type_alias_declaration] = STATE(1191),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1191),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1191),
    [sym_switch_statement] = STATE(1191),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1191),
    [sym_throw_statement] = STATE(1191),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1191),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1191),
    [sym_abstract_class_declaration] = STATE(1191),
    [sym_interface_declaration] = STATE(1191),
    [sym_export_statement] = STATE(1191),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1191),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1191),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1191),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1191),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_default] = ACTIONS(3959),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(3959),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1120] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3961),
    [anon_sym_default] = ACTIONS(3963),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(3963),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1121] = {
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_EQ_GT] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3965),
  },
  [1122] = {
    [sym_identifier] = ACTIONS(3967),
    [anon_sym_BQUOTE] = ACTIONS(3969),
    [anon_sym_debugger] = ACTIONS(3967),
    [anon_sym_symbol] = ACTIONS(3967),
    [anon_sym_AT] = ACTIONS(3969),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_void] = ACTIONS(3967),
    [anon_sym_break] = ACTIONS(3967),
    [anon_sym_const] = ACTIONS(3967),
    [sym_super] = ACTIONS(3967),
    [anon_sym_return] = ACTIONS(3967),
    [anon_sym_private] = ACTIONS(3967),
    [anon_sym_static] = ACTIONS(3967),
    [anon_sym_get] = ACTIONS(3967),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_interface] = ACTIONS(3967),
    [anon_sym_default] = ACTIONS(3967),
    [anon_sym_enum] = ACTIONS(3967),
    [anon_sym_delete] = ACTIONS(3967),
    [anon_sym_continue] = ACTIONS(3967),
    [anon_sym_DASH_DASH] = ACTIONS(3969),
    [anon_sym_if] = ACTIONS(3967),
    [sym_this] = ACTIONS(3967),
    [anon_sym_yield] = ACTIONS(3967),
    [sym_true] = ACTIONS(3967),
    [anon_sym_throw] = ACTIONS(3967),
    [anon_sym_protected] = ACTIONS(3967),
    [anon_sym_abstract] = ACTIONS(3967),
    [anon_sym_set] = ACTIONS(3967),
    [anon_sym_type] = ACTIONS(3967),
    [anon_sym_import] = ACTIONS(3967),
    [anon_sym_namespace] = ACTIONS(3967),
    [anon_sym_PLUS_PLUS] = ACTIONS(3969),
    [anon_sym_DQUOTE] = ACTIONS(3969),
    [anon_sym_else] = ACTIONS(3967),
    [anon_sym_BANG] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(3969),
    [sym_false] = ACTIONS(3967),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_case] = ACTIONS(3967),
    [anon_sym_module] = ACTIONS(3967),
    [anon_sym_number] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(3967),
    [anon_sym_declare] = ACTIONS(3967),
    [anon_sym_typeof] = ACTIONS(3967),
    [anon_sym_LBRACE] = ACTIONS(3969),
    [anon_sym_switch] = ACTIONS(3967),
    [anon_sym_LPAREN] = ACTIONS(3969),
    [sym_null] = ACTIONS(3967),
    [anon_sym_any] = ACTIONS(3967),
    [anon_sym_boolean] = ACTIONS(3967),
    [anon_sym_async] = ACTIONS(3967),
    [anon_sym_public] = ACTIONS(3967),
    [anon_sym_var] = ACTIONS(3967),
    [anon_sym_while] = ACTIONS(3967),
    [anon_sym_SQUOTE] = ACTIONS(3969),
    [anon_sym_try] = ACTIONS(3967),
    [anon_sym_LT] = ACTIONS(3969),
    [sym_number] = ACTIONS(3969),
    [anon_sym_SLASH] = ACTIONS(3967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3967),
    [anon_sym_function] = ACTIONS(3967),
    [sym_undefined] = ACTIONS(3967),
    [anon_sym_new] = ACTIONS(3967),
    [ts_builtin_sym_end] = ACTIONS(3969),
    [anon_sym_let] = ACTIONS(3967),
    [anon_sym_PLUS] = ACTIONS(3967),
    [anon_sym_export] = ACTIONS(3967),
    [anon_sym_do] = ACTIONS(3967),
    [anon_sym_TILDE] = ACTIONS(3969),
    [anon_sym_with] = ACTIONS(3967),
    [anon_sym_await] = ACTIONS(3967),
  },
  [1123] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3971),
    [sym__automatic_semicolon] = ACTIONS(3973),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_symbol] = ACTIONS(3977),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3971),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_as] = ACTIONS(3979),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_instanceof] = ACTIONS(3979),
    [anon_sym_yield] = ACTIONS(3977),
    [sym_true] = ACTIONS(3977),
    [anon_sym_protected] = ACTIONS(3977),
    [anon_sym_DOT] = ACTIONS(3979),
    [anon_sym_set] = ACTIONS(3977),
    [anon_sym_import] = ACTIONS(3977),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_number] = ACTIONS(3977),
    [anon_sym_typeof] = ACTIONS(3977),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [sym_null] = ACTIONS(3977),
    [anon_sym_any] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3977),
    [anon_sym_public] = ACTIONS(3977),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_QMARK] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_SQUOTE] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_export] = ACTIONS(3977),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3971),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_debugger] = ACTIONS(3977),
    [anon_sym_AT] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_void] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [anon_sym_GT_EQ] = ACTIONS(3971),
    [sym_super] = ACTIONS(3977),
    [anon_sym_private] = ACTIONS(3977),
    [anon_sym_get] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [sym_this] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_abstract] = ACTIONS(3977),
    [anon_sym_type] = ACTIONS(3977),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_else] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [sym_false] = ACTIONS(3977),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_module] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_declare] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3975),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_boolean] = ACTIONS(3977),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3977),
    [sym_number] = ACTIONS(3975),
    [ts_builtin_sym_end] = ACTIONS(3975),
    [anon_sym_function] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3975),
    [anon_sym_await] = ACTIONS(3977),
  },
  [1124] = {
    [sym_statement_block] = STATE(1193),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1125] = {
    [sym_statement_block] = STATE(1194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1126] = {
    [sym_statement_block] = STATE(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1127] = {
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [anon_sym_symbol] = ACTIONS(3983),
    [anon_sym_PIPE] = ACTIONS(3981),
    [anon_sym_break] = ACTIONS(3983),
    [anon_sym_return] = ACTIONS(3983),
    [anon_sym_static] = ACTIONS(3983),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_interface] = ACTIONS(3983),
    [anon_sym_delete] = ACTIONS(3983),
    [anon_sym_if] = ACTIONS(3983),
    [anon_sym_yield] = ACTIONS(3983),
    [sym_true] = ACTIONS(3983),
    [anon_sym_protected] = ACTIONS(3983),
    [anon_sym_set] = ACTIONS(3983),
    [anon_sym_import] = ACTIONS(3983),
    [anon_sym_DQUOTE] = ACTIONS(3981),
    [anon_sym_for] = ACTIONS(3983),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_number] = ACTIONS(3983),
    [anon_sym_typeof] = ACTIONS(3983),
    [anon_sym_LBRACE] = ACTIONS(3981),
    [anon_sym_switch] = ACTIONS(3983),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [sym_null] = ACTIONS(3983),
    [anon_sym_any] = ACTIONS(3983),
    [anon_sym_async] = ACTIONS(3983),
    [anon_sym_public] = ACTIONS(3983),
    [anon_sym_var] = ACTIONS(3983),
    [anon_sym_while] = ACTIONS(3983),
    [anon_sym_SQUOTE] = ACTIONS(3981),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_SLASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3983),
    [anon_sym_new] = ACTIONS(3983),
    [anon_sym_export] = ACTIONS(3983),
    [anon_sym_with] = ACTIONS(3983),
    [sym_identifier] = ACTIONS(3983),
    [anon_sym_debugger] = ACTIONS(3983),
    [anon_sym_AT] = ACTIONS(3981),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_EQ] = ACTIONS(3983),
    [anon_sym_void] = ACTIONS(3983),
    [anon_sym_const] = ACTIONS(3983),
    [sym_super] = ACTIONS(3983),
    [anon_sym_private] = ACTIONS(3983),
    [anon_sym_get] = ACTIONS(3983),
    [anon_sym_default] = ACTIONS(3983),
    [anon_sym_enum] = ACTIONS(3983),
    [anon_sym_continue] = ACTIONS(3983),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [sym_this] = ACTIONS(3983),
    [anon_sym_throw] = ACTIONS(3983),
    [anon_sym_abstract] = ACTIONS(3983),
    [anon_sym_type] = ACTIONS(3983),
    [anon_sym_namespace] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_else] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [sym_false] = ACTIONS(3983),
    [anon_sym_case] = ACTIONS(3983),
    [anon_sym_module] = ACTIONS(3983),
    [anon_sym_class] = ACTIONS(3983),
    [anon_sym_declare] = ACTIONS(3983),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3981),
    [anon_sym_boolean] = ACTIONS(3983),
    [anon_sym_EQ_GT] = ACTIONS(3981),
    [anon_sym_AMP] = ACTIONS(3981),
    [anon_sym_try] = ACTIONS(3983),
    [anon_sym_LT] = ACTIONS(3981),
    [sym_number] = ACTIONS(3981),
    [ts_builtin_sym_end] = ACTIONS(3981),
    [anon_sym_function] = ACTIONS(3983),
    [sym_undefined] = ACTIONS(3983),
    [anon_sym_let] = ACTIONS(3983),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_do] = ACTIONS(3983),
    [anon_sym_TILDE] = ACTIONS(3981),
    [anon_sym_await] = ACTIONS(3983),
  },
  [1128] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(3985),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3985),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1129] = {
    [sym__automatic_semicolon] = ACTIONS(3895),
    [anon_sym_RBRACE] = ACTIONS(3895),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3895),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3895),
    [sym_comment] = ACTIONS(3),
  },
  [1130] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1197),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1131] = {
    [sym__automatic_semicolon] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
  },
  [1132] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1199),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(3987),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1133] = {
    [sym_string] = STATE(1200),
    [sym__property_name] = STATE(1200),
    [sym_computed_property_name] = STATE(1200),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1134] = {
    [sym_string] = STATE(1200),
    [sym__property_name] = STATE(1200),
    [sym_computed_property_name] = STATE(1200),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1135] = {
    [sym__call_signature] = STATE(1197),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1201),
    [sym__automatic_semicolon] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
  },
  [1136] = {
    [sym__automatic_semicolon] = ACTIONS(3993),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_SEMI] = ACTIONS(3993),
    [anon_sym_COMMA] = ACTIONS(3993),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3993),
    [sym_comment] = ACTIONS(3),
  },
  [1137] = {
    [sym__automatic_semicolon] = ACTIONS(3995),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_SEMI] = ACTIONS(3995),
    [anon_sym_COMMA] = ACTIONS(3995),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3995),
    [sym_comment] = ACTIONS(3),
  },
  [1138] = {
    [sym__automatic_semicolon] = ACTIONS(3997),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_SEMI] = ACTIONS(3997),
    [anon_sym_COMMA] = ACTIONS(3997),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3997),
    [sym_comment] = ACTIONS(3),
  },
  [1139] = {
    [sym_index_signature] = STATE(998),
    [sym_formal_parameters] = STATE(1255),
    [sym_method_signature] = STATE(998),
    [sym_computed_property_name] = STATE(521),
    [sym__property_name] = STATE(521),
    [sym_type_parameters] = STATE(1793),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_string] = STATE(521),
    [sym_decorator] = STATE(63),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(960),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1140] = {
    [sym_string] = STATE(1200),
    [sym__property_name] = STATE(1200),
    [sym_computed_property_name] = STATE(1200),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3999),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(4001),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(4001),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1141] = {
    [sym__call_signature] = STATE(1199),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1205),
    [sym__automatic_semicolon] = ACTIONS(4003),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4005),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4003),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [1142] = {
    [anon_sym_EQ_GT] = ACTIONS(4007),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_while] = ACTIONS(4007),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(4007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4009),
    [anon_sym_RBRACK] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4007),
    [anon_sym_else] = ACTIONS(4007),
  },
  [1143] = {
    [sym__call_signature] = STATE(2013),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1136),
    [sym__automatic_semicolon] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_QMARK] = ACTIONS(4011),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3667),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
  },
  [1144] = {
    [sym__call_signature] = STATE(2012),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1137),
    [sym__automatic_semicolon] = ACTIONS(3671),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3671),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3671),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [sym_string] = STATE(1207),
    [sym__property_name] = STATE(1207),
    [sym_computed_property_name] = STATE(1207),
    [anon_sym_get] = ACTIONS(4013),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_async] = ACTIONS(4015),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [sym_number] = ACTIONS(4017),
    [anon_sym_STAR] = ACTIONS(4019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(4013),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(4021),
    [anon_sym_BQUOTE] = ACTIONS(4023),
    [anon_sym_debugger] = ACTIONS(4021),
    [anon_sym_symbol] = ACTIONS(4021),
    [anon_sym_AT] = ACTIONS(4023),
    [anon_sym_DASH] = ACTIONS(4021),
    [anon_sym_void] = ACTIONS(4021),
    [anon_sym_break] = ACTIONS(4021),
    [anon_sym_const] = ACTIONS(4021),
    [sym_super] = ACTIONS(4021),
    [anon_sym_return] = ACTIONS(4021),
    [anon_sym_private] = ACTIONS(4021),
    [anon_sym_static] = ACTIONS(4021),
    [anon_sym_get] = ACTIONS(4021),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_interface] = ACTIONS(4021),
    [anon_sym_default] = ACTIONS(4021),
    [anon_sym_enum] = ACTIONS(4021),
    [anon_sym_delete] = ACTIONS(4021),
    [anon_sym_continue] = ACTIONS(4021),
    [anon_sym_DASH_DASH] = ACTIONS(4023),
    [anon_sym_if] = ACTIONS(4021),
    [sym_this] = ACTIONS(4021),
    [anon_sym_yield] = ACTIONS(4021),
    [sym_true] = ACTIONS(4021),
    [anon_sym_throw] = ACTIONS(4021),
    [anon_sym_protected] = ACTIONS(4021),
    [anon_sym_abstract] = ACTIONS(4021),
    [anon_sym_set] = ACTIONS(4021),
    [anon_sym_type] = ACTIONS(4021),
    [anon_sym_import] = ACTIONS(4021),
    [anon_sym_namespace] = ACTIONS(4021),
    [anon_sym_PLUS_PLUS] = ACTIONS(4023),
    [anon_sym_DQUOTE] = ACTIONS(4023),
    [anon_sym_else] = ACTIONS(4021),
    [anon_sym_BANG] = ACTIONS(4023),
    [anon_sym_for] = ACTIONS(4021),
    [anon_sym_LBRACK] = ACTIONS(4023),
    [sym_false] = ACTIONS(4021),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_case] = ACTIONS(4021),
    [anon_sym_module] = ACTIONS(4021),
    [anon_sym_number] = ACTIONS(4021),
    [anon_sym_class] = ACTIONS(4021),
    [anon_sym_declare] = ACTIONS(4021),
    [anon_sym_typeof] = ACTIONS(4021),
    [anon_sym_LBRACE] = ACTIONS(4023),
    [anon_sym_switch] = ACTIONS(4021),
    [anon_sym_LPAREN] = ACTIONS(4023),
    [sym_null] = ACTIONS(4021),
    [anon_sym_any] = ACTIONS(4021),
    [anon_sym_boolean] = ACTIONS(4021),
    [anon_sym_async] = ACTIONS(4021),
    [anon_sym_public] = ACTIONS(4021),
    [anon_sym_var] = ACTIONS(4021),
    [anon_sym_while] = ACTIONS(4021),
    [anon_sym_SQUOTE] = ACTIONS(4023),
    [anon_sym_try] = ACTIONS(4021),
    [anon_sym_LT] = ACTIONS(4023),
    [sym_number] = ACTIONS(4023),
    [anon_sym_SLASH] = ACTIONS(4021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4021),
    [anon_sym_function] = ACTIONS(4021),
    [sym_undefined] = ACTIONS(4021),
    [anon_sym_new] = ACTIONS(4021),
    [ts_builtin_sym_end] = ACTIONS(4023),
    [anon_sym_let] = ACTIONS(4021),
    [anon_sym_PLUS] = ACTIONS(4021),
    [anon_sym_export] = ACTIONS(4021),
    [anon_sym_do] = ACTIONS(4021),
    [anon_sym_TILDE] = ACTIONS(4023),
    [anon_sym_with] = ACTIONS(4021),
    [anon_sym_await] = ACTIONS(4021),
  },
  [1147] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2009),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1148] = {
    [sym__automatic_semicolon] = ACTIONS(4025),
    [anon_sym_SEMI] = ACTIONS(4025),
    [anon_sym_from] = ACTIONS(4025),
    [sym_comment] = ACTIONS(3),
  },
  [1149] = {
    [sym__import_export_specifier] = STATE(1027),
    [sym_identifier] = ACTIONS(818),
    [anon_sym_typeof] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(822),
    [sym_comment] = ACTIONS(3),
  },
  [1150] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1151] = {
    [sym_identifier] = ACTIONS(4030),
    [anon_sym_BQUOTE] = ACTIONS(4032),
    [anon_sym_debugger] = ACTIONS(4030),
    [anon_sym_symbol] = ACTIONS(4030),
    [anon_sym_AT] = ACTIONS(4032),
    [anon_sym_DASH] = ACTIONS(4030),
    [anon_sym_void] = ACTIONS(4030),
    [anon_sym_break] = ACTIONS(4030),
    [anon_sym_const] = ACTIONS(4030),
    [sym_super] = ACTIONS(4030),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_private] = ACTIONS(4030),
    [anon_sym_static] = ACTIONS(4030),
    [anon_sym_get] = ACTIONS(4030),
    [anon_sym_RBRACE] = ACTIONS(4032),
    [anon_sym_interface] = ACTIONS(4030),
    [anon_sym_default] = ACTIONS(4030),
    [anon_sym_enum] = ACTIONS(4030),
    [anon_sym_delete] = ACTIONS(4030),
    [anon_sym_continue] = ACTIONS(4030),
    [anon_sym_DASH_DASH] = ACTIONS(4032),
    [anon_sym_if] = ACTIONS(4030),
    [sym_this] = ACTIONS(4030),
    [anon_sym_yield] = ACTIONS(4030),
    [sym_true] = ACTIONS(4030),
    [anon_sym_throw] = ACTIONS(4030),
    [anon_sym_protected] = ACTIONS(4030),
    [anon_sym_abstract] = ACTIONS(4030),
    [anon_sym_set] = ACTIONS(4030),
    [anon_sym_type] = ACTIONS(4030),
    [anon_sym_import] = ACTIONS(4030),
    [anon_sym_namespace] = ACTIONS(4030),
    [anon_sym_PLUS_PLUS] = ACTIONS(4032),
    [anon_sym_DQUOTE] = ACTIONS(4032),
    [anon_sym_else] = ACTIONS(4030),
    [anon_sym_BANG] = ACTIONS(4032),
    [anon_sym_for] = ACTIONS(4030),
    [anon_sym_LBRACK] = ACTIONS(4032),
    [sym_false] = ACTIONS(4030),
    [anon_sym_SEMI] = ACTIONS(4032),
    [anon_sym_case] = ACTIONS(4030),
    [anon_sym_module] = ACTIONS(4030),
    [anon_sym_number] = ACTIONS(4030),
    [anon_sym_class] = ACTIONS(4030),
    [anon_sym_declare] = ACTIONS(4030),
    [anon_sym_typeof] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(4032),
    [anon_sym_switch] = ACTIONS(4030),
    [anon_sym_LPAREN] = ACTIONS(4032),
    [sym_null] = ACTIONS(4030),
    [anon_sym_any] = ACTIONS(4030),
    [anon_sym_boolean] = ACTIONS(4030),
    [anon_sym_async] = ACTIONS(4030),
    [anon_sym_public] = ACTIONS(4030),
    [anon_sym_var] = ACTIONS(4030),
    [anon_sym_while] = ACTIONS(4030),
    [anon_sym_SQUOTE] = ACTIONS(4032),
    [anon_sym_try] = ACTIONS(4030),
    [anon_sym_LT] = ACTIONS(4032),
    [sym_number] = ACTIONS(4032),
    [anon_sym_SLASH] = ACTIONS(4030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4030),
    [anon_sym_function] = ACTIONS(4030),
    [sym_undefined] = ACTIONS(4030),
    [anon_sym_new] = ACTIONS(4030),
    [ts_builtin_sym_end] = ACTIONS(4032),
    [anon_sym_let] = ACTIONS(4030),
    [anon_sym_PLUS] = ACTIONS(4030),
    [anon_sym_export] = ACTIONS(4030),
    [anon_sym_do] = ACTIONS(4030),
    [anon_sym_TILDE] = ACTIONS(4032),
    [anon_sym_with] = ACTIONS(4030),
    [anon_sym_await] = ACTIONS(4030),
  },
  [1152] = {
    [sym_identifier] = ACTIONS(4034),
    [anon_sym_BQUOTE] = ACTIONS(4036),
    [anon_sym_debugger] = ACTIONS(4034),
    [anon_sym_symbol] = ACTIONS(4034),
    [anon_sym_AT] = ACTIONS(4036),
    [anon_sym_DASH] = ACTIONS(4034),
    [anon_sym_void] = ACTIONS(4034),
    [anon_sym_break] = ACTIONS(4034),
    [anon_sym_const] = ACTIONS(4034),
    [sym_super] = ACTIONS(4034),
    [anon_sym_return] = ACTIONS(4034),
    [anon_sym_private] = ACTIONS(4034),
    [anon_sym_static] = ACTIONS(4034),
    [anon_sym_get] = ACTIONS(4034),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_interface] = ACTIONS(4034),
    [anon_sym_default] = ACTIONS(4034),
    [anon_sym_enum] = ACTIONS(4034),
    [anon_sym_delete] = ACTIONS(4034),
    [anon_sym_continue] = ACTIONS(4034),
    [anon_sym_DASH_DASH] = ACTIONS(4036),
    [anon_sym_if] = ACTIONS(4034),
    [sym_this] = ACTIONS(4034),
    [anon_sym_yield] = ACTIONS(4034),
    [sym_true] = ACTIONS(4034),
    [anon_sym_throw] = ACTIONS(4034),
    [anon_sym_protected] = ACTIONS(4034),
    [anon_sym_abstract] = ACTIONS(4034),
    [anon_sym_set] = ACTIONS(4034),
    [anon_sym_type] = ACTIONS(4034),
    [anon_sym_import] = ACTIONS(4034),
    [anon_sym_namespace] = ACTIONS(4034),
    [anon_sym_PLUS_PLUS] = ACTIONS(4036),
    [anon_sym_DQUOTE] = ACTIONS(4036),
    [anon_sym_else] = ACTIONS(4034),
    [anon_sym_BANG] = ACTIONS(4036),
    [anon_sym_for] = ACTIONS(4034),
    [anon_sym_LBRACK] = ACTIONS(4036),
    [sym_false] = ACTIONS(4034),
    [anon_sym_SEMI] = ACTIONS(4036),
    [anon_sym_case] = ACTIONS(4034),
    [anon_sym_module] = ACTIONS(4034),
    [anon_sym_number] = ACTIONS(4034),
    [anon_sym_class] = ACTIONS(4034),
    [anon_sym_declare] = ACTIONS(4034),
    [anon_sym_typeof] = ACTIONS(4034),
    [anon_sym_LBRACE] = ACTIONS(4036),
    [anon_sym_switch] = ACTIONS(4034),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [sym_null] = ACTIONS(4034),
    [anon_sym_any] = ACTIONS(4034),
    [anon_sym_boolean] = ACTIONS(4034),
    [anon_sym_async] = ACTIONS(4034),
    [anon_sym_public] = ACTIONS(4034),
    [anon_sym_var] = ACTIONS(4034),
    [anon_sym_while] = ACTIONS(4034),
    [anon_sym_SQUOTE] = ACTIONS(4036),
    [anon_sym_try] = ACTIONS(4034),
    [anon_sym_LT] = ACTIONS(4036),
    [sym_number] = ACTIONS(4036),
    [anon_sym_SLASH] = ACTIONS(4034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4034),
    [anon_sym_function] = ACTIONS(4034),
    [sym_undefined] = ACTIONS(4034),
    [anon_sym_new] = ACTIONS(4034),
    [ts_builtin_sym_end] = ACTIONS(4036),
    [anon_sym_let] = ACTIONS(4034),
    [anon_sym_PLUS] = ACTIONS(4034),
    [anon_sym_export] = ACTIONS(4034),
    [anon_sym_do] = ACTIONS(4034),
    [anon_sym_TILDE] = ACTIONS(4036),
    [anon_sym_with] = ACTIONS(4034),
    [anon_sym_await] = ACTIONS(4034),
  },
  [1153] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [sym__automatic_semicolon] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_symbol] = ACTIONS(4044),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_BANG_EQ] = ACTIONS(4046),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_interface] = ACTIONS(4044),
    [anon_sym_as] = ACTIONS(4046),
    [anon_sym_delete] = ACTIONS(4044),
    [anon_sym_if] = ACTIONS(4044),
    [anon_sym_instanceof] = ACTIONS(4046),
    [anon_sym_yield] = ACTIONS(4044),
    [sym_true] = ACTIONS(4044),
    [anon_sym_protected] = ACTIONS(4044),
    [anon_sym_DOT] = ACTIONS(4046),
    [anon_sym_set] = ACTIONS(4044),
    [anon_sym_import] = ACTIONS(4044),
    [anon_sym_in] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_number] = ACTIONS(4044),
    [anon_sym_typeof] = ACTIONS(4044),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(4042),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [sym_null] = ACTIONS(4044),
    [anon_sym_any] = ACTIONS(4044),
    [anon_sym_async] = ACTIONS(4044),
    [anon_sym_public] = ACTIONS(4044),
    [anon_sym_var] = ACTIONS(4044),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_SQUOTE] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4044),
    [anon_sym_new] = ACTIONS(4044),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_export] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_with] = ACTIONS(4044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
    [sym_identifier] = ACTIONS(4044),
    [anon_sym_debugger] = ACTIONS(4044),
    [anon_sym_AT] = ACTIONS(4042),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_void] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [sym_super] = ACTIONS(4044),
    [anon_sym_private] = ACTIONS(4044),
    [anon_sym_get] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4042),
    [sym_this] = ACTIONS(4044),
    [anon_sym_throw] = ACTIONS(4044),
    [anon_sym_abstract] = ACTIONS(4044),
    [anon_sym_type] = ACTIONS(4044),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_namespace] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4042),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_BANG] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4042),
    [sym_false] = ACTIONS(4044),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_module] = ACTIONS(4044),
    [anon_sym_class] = ACTIONS(4044),
    [anon_sym_declare] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_boolean] = ACTIONS(4044),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_try] = ACTIONS(4044),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4044),
    [sym_number] = ACTIONS(4042),
    [ts_builtin_sym_end] = ACTIONS(4042),
    [anon_sym_function] = ACTIONS(4044),
    [sym_undefined] = ACTIONS(4044),
    [anon_sym_let] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_TILDE] = ACTIONS(4042),
    [anon_sym_await] = ACTIONS(4044),
  },
  [1154] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [sym__automatic_semicolon] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3971),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_GT_EQ] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_QMARK] = ACTIONS(3971),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_instanceof] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3971),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3971),
    [anon_sym_BANG] = ACTIONS(3979),
  },
  [1155] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [sym__automatic_semicolon] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_BANG_EQ] = ACTIONS(4046),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_PLUS] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
    [anon_sym_BANG] = ACTIONS(4046),
  },
  [1156] = {
    [sym_identifier] = ACTIONS(4048),
    [anon_sym_BQUOTE] = ACTIONS(4050),
    [anon_sym_debugger] = ACTIONS(4048),
    [anon_sym_symbol] = ACTIONS(4048),
    [anon_sym_AT] = ACTIONS(4050),
    [anon_sym_DASH] = ACTIONS(4048),
    [anon_sym_void] = ACTIONS(4048),
    [anon_sym_break] = ACTIONS(4048),
    [anon_sym_const] = ACTIONS(4048),
    [sym_super] = ACTIONS(4048),
    [anon_sym_return] = ACTIONS(4048),
    [anon_sym_private] = ACTIONS(4048),
    [anon_sym_static] = ACTIONS(4048),
    [anon_sym_get] = ACTIONS(4048),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_interface] = ACTIONS(4048),
    [anon_sym_default] = ACTIONS(4048),
    [anon_sym_enum] = ACTIONS(4048),
    [anon_sym_delete] = ACTIONS(4048),
    [anon_sym_continue] = ACTIONS(4048),
    [anon_sym_DASH_DASH] = ACTIONS(4050),
    [anon_sym_if] = ACTIONS(4048),
    [sym_this] = ACTIONS(4048),
    [anon_sym_yield] = ACTIONS(4048),
    [sym_true] = ACTIONS(4048),
    [anon_sym_throw] = ACTIONS(4048),
    [anon_sym_protected] = ACTIONS(4048),
    [anon_sym_abstract] = ACTIONS(4048),
    [anon_sym_set] = ACTIONS(4048),
    [anon_sym_type] = ACTIONS(4048),
    [anon_sym_import] = ACTIONS(4048),
    [anon_sym_namespace] = ACTIONS(4048),
    [anon_sym_PLUS_PLUS] = ACTIONS(4050),
    [anon_sym_DQUOTE] = ACTIONS(4050),
    [anon_sym_else] = ACTIONS(4048),
    [anon_sym_BANG] = ACTIONS(4050),
    [anon_sym_for] = ACTIONS(4048),
    [anon_sym_LBRACK] = ACTIONS(4050),
    [sym_false] = ACTIONS(4048),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_case] = ACTIONS(4048),
    [anon_sym_module] = ACTIONS(4048),
    [anon_sym_number] = ACTIONS(4048),
    [anon_sym_class] = ACTIONS(4048),
    [anon_sym_declare] = ACTIONS(4048),
    [anon_sym_typeof] = ACTIONS(4048),
    [anon_sym_LBRACE] = ACTIONS(4050),
    [anon_sym_switch] = ACTIONS(4048),
    [anon_sym_LPAREN] = ACTIONS(4050),
    [sym_null] = ACTIONS(4048),
    [anon_sym_any] = ACTIONS(4048),
    [anon_sym_boolean] = ACTIONS(4048),
    [anon_sym_async] = ACTIONS(4048),
    [anon_sym_public] = ACTIONS(4048),
    [anon_sym_var] = ACTIONS(4048),
    [anon_sym_while] = ACTIONS(4048),
    [anon_sym_SQUOTE] = ACTIONS(4050),
    [anon_sym_try] = ACTIONS(4048),
    [anon_sym_LT] = ACTIONS(4050),
    [sym_number] = ACTIONS(4050),
    [anon_sym_SLASH] = ACTIONS(4048),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4048),
    [anon_sym_function] = ACTIONS(4048),
    [sym_undefined] = ACTIONS(4048),
    [anon_sym_new] = ACTIONS(4048),
    [ts_builtin_sym_end] = ACTIONS(4050),
    [anon_sym_let] = ACTIONS(4048),
    [anon_sym_PLUS] = ACTIONS(4048),
    [anon_sym_export] = ACTIONS(4048),
    [anon_sym_do] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4050),
    [anon_sym_with] = ACTIONS(4048),
    [anon_sym_await] = ACTIONS(4048),
  },
  [1157] = {
    [sym_computed_property_name] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym__property_name] = STATE(1049),
    [sym_enum_assignment] = STATE(1050),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1158] = {
    [sym__automatic_semicolon] = ACTIONS(4052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4052),
  },
  [1159] = {
    [sym_identifier] = ACTIONS(4054),
    [anon_sym_BQUOTE] = ACTIONS(4056),
    [anon_sym_debugger] = ACTIONS(4054),
    [anon_sym_symbol] = ACTIONS(4054),
    [anon_sym_AT] = ACTIONS(4056),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_void] = ACTIONS(4054),
    [anon_sym_break] = ACTIONS(4054),
    [anon_sym_const] = ACTIONS(4054),
    [sym_super] = ACTIONS(4054),
    [anon_sym_return] = ACTIONS(4054),
    [anon_sym_private] = ACTIONS(4054),
    [anon_sym_static] = ACTIONS(4054),
    [anon_sym_get] = ACTIONS(4054),
    [anon_sym_interface] = ACTIONS(4054),
    [anon_sym_enum] = ACTIONS(4054),
    [anon_sym_delete] = ACTIONS(4054),
    [anon_sym_continue] = ACTIONS(4054),
    [anon_sym_DASH_DASH] = ACTIONS(4056),
    [anon_sym_if] = ACTIONS(4054),
    [sym_this] = ACTIONS(4054),
    [anon_sym_yield] = ACTIONS(4054),
    [sym_true] = ACTIONS(4054),
    [anon_sym_throw] = ACTIONS(4054),
    [anon_sym_protected] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4054),
    [anon_sym_set] = ACTIONS(4054),
    [anon_sym_type] = ACTIONS(4054),
    [anon_sym_import] = ACTIONS(4054),
    [anon_sym_namespace] = ACTIONS(4054),
    [anon_sym_PLUS_PLUS] = ACTIONS(4056),
    [anon_sym_DQUOTE] = ACTIONS(4056),
    [anon_sym_BANG] = ACTIONS(4056),
    [anon_sym_for] = ACTIONS(4054),
    [anon_sym_LBRACK] = ACTIONS(4056),
    [sym_false] = ACTIONS(4054),
    [anon_sym_SEMI] = ACTIONS(4056),
    [anon_sym_module] = ACTIONS(4054),
    [anon_sym_number] = ACTIONS(4054),
    [anon_sym_class] = ACTIONS(4054),
    [anon_sym_declare] = ACTIONS(4054),
    [anon_sym_typeof] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4056),
    [anon_sym_switch] = ACTIONS(4054),
    [anon_sym_LPAREN] = ACTIONS(4056),
    [sym_null] = ACTIONS(4054),
    [anon_sym_any] = ACTIONS(4054),
    [anon_sym_boolean] = ACTIONS(4054),
    [anon_sym_async] = ACTIONS(4054),
    [anon_sym_public] = ACTIONS(4054),
    [anon_sym_var] = ACTIONS(4054),
    [anon_sym_while] = ACTIONS(4054),
    [anon_sym_SQUOTE] = ACTIONS(4056),
    [anon_sym_try] = ACTIONS(4054),
    [anon_sym_LT] = ACTIONS(4056),
    [sym_number] = ACTIONS(4056),
    [anon_sym_SLASH] = ACTIONS(4054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4054),
    [anon_sym_function] = ACTIONS(4054),
    [sym_undefined] = ACTIONS(4054),
    [anon_sym_new] = ACTIONS(4054),
    [anon_sym_let] = ACTIONS(4054),
    [anon_sym_PLUS] = ACTIONS(4054),
    [anon_sym_export] = ACTIONS(4054),
    [anon_sym_do] = ACTIONS(4054),
    [anon_sym_TILDE] = ACTIONS(4056),
    [anon_sym_with] = ACTIONS(4054),
    [anon_sym_await] = ACTIONS(4054),
  },
  [1160] = {
    [sym_identifier] = ACTIONS(4058),
    [anon_sym_BQUOTE] = ACTIONS(4060),
    [anon_sym_debugger] = ACTIONS(4058),
    [anon_sym_symbol] = ACTIONS(4058),
    [anon_sym_AT] = ACTIONS(4060),
    [anon_sym_DASH] = ACTIONS(4058),
    [anon_sym_void] = ACTIONS(4058),
    [anon_sym_break] = ACTIONS(4058),
    [anon_sym_const] = ACTIONS(4058),
    [sym_super] = ACTIONS(4058),
    [anon_sym_return] = ACTIONS(4058),
    [anon_sym_private] = ACTIONS(4058),
    [anon_sym_static] = ACTIONS(4058),
    [anon_sym_get] = ACTIONS(4058),
    [anon_sym_interface] = ACTIONS(4058),
    [anon_sym_enum] = ACTIONS(4058),
    [anon_sym_delete] = ACTIONS(4058),
    [anon_sym_continue] = ACTIONS(4058),
    [anon_sym_DASH_DASH] = ACTIONS(4060),
    [anon_sym_if] = ACTIONS(4058),
    [sym_this] = ACTIONS(4058),
    [anon_sym_yield] = ACTIONS(4058),
    [sym_true] = ACTIONS(4058),
    [anon_sym_throw] = ACTIONS(4058),
    [anon_sym_protected] = ACTIONS(4058),
    [anon_sym_abstract] = ACTIONS(4058),
    [anon_sym_set] = ACTIONS(4058),
    [anon_sym_type] = ACTIONS(4058),
    [anon_sym_import] = ACTIONS(4058),
    [anon_sym_namespace] = ACTIONS(4058),
    [anon_sym_PLUS_PLUS] = ACTIONS(4060),
    [anon_sym_DQUOTE] = ACTIONS(4060),
    [anon_sym_BANG] = ACTIONS(4060),
    [anon_sym_for] = ACTIONS(4058),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [sym_false] = ACTIONS(4058),
    [anon_sym_SEMI] = ACTIONS(4060),
    [anon_sym_module] = ACTIONS(4058),
    [anon_sym_number] = ACTIONS(4058),
    [anon_sym_class] = ACTIONS(4058),
    [anon_sym_declare] = ACTIONS(4058),
    [anon_sym_typeof] = ACTIONS(4058),
    [anon_sym_LBRACE] = ACTIONS(4060),
    [anon_sym_switch] = ACTIONS(4058),
    [anon_sym_LPAREN] = ACTIONS(4060),
    [sym_null] = ACTIONS(4058),
    [anon_sym_any] = ACTIONS(4058),
    [anon_sym_boolean] = ACTIONS(4058),
    [anon_sym_async] = ACTIONS(4058),
    [anon_sym_public] = ACTIONS(4058),
    [anon_sym_var] = ACTIONS(4058),
    [anon_sym_while] = ACTIONS(4058),
    [anon_sym_SQUOTE] = ACTIONS(4060),
    [anon_sym_try] = ACTIONS(4058),
    [anon_sym_LT] = ACTIONS(4060),
    [sym_number] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4058),
    [anon_sym_function] = ACTIONS(4058),
    [sym_undefined] = ACTIONS(4058),
    [anon_sym_new] = ACTIONS(4058),
    [anon_sym_let] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4058),
    [anon_sym_export] = ACTIONS(4058),
    [anon_sym_do] = ACTIONS(4058),
    [anon_sym_TILDE] = ACTIONS(4060),
    [anon_sym_with] = ACTIONS(4058),
    [anon_sym_await] = ACTIONS(4058),
  },
  [1161] = {
    [sym_identifier] = ACTIONS(4062),
    [anon_sym_BQUOTE] = ACTIONS(4064),
    [anon_sym_debugger] = ACTIONS(4062),
    [anon_sym_symbol] = ACTIONS(4062),
    [anon_sym_AT] = ACTIONS(4064),
    [anon_sym_DASH] = ACTIONS(4062),
    [anon_sym_void] = ACTIONS(4062),
    [anon_sym_break] = ACTIONS(4062),
    [anon_sym_const] = ACTIONS(4062),
    [sym_super] = ACTIONS(4062),
    [anon_sym_return] = ACTIONS(4062),
    [anon_sym_private] = ACTIONS(4062),
    [anon_sym_static] = ACTIONS(4062),
    [anon_sym_get] = ACTIONS(4062),
    [anon_sym_interface] = ACTIONS(4062),
    [anon_sym_enum] = ACTIONS(4062),
    [anon_sym_delete] = ACTIONS(4062),
    [anon_sym_continue] = ACTIONS(4062),
    [anon_sym_DASH_DASH] = ACTIONS(4064),
    [anon_sym_if] = ACTIONS(4062),
    [sym_this] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4062),
    [sym_true] = ACTIONS(4062),
    [anon_sym_throw] = ACTIONS(4062),
    [anon_sym_protected] = ACTIONS(4062),
    [anon_sym_abstract] = ACTIONS(4062),
    [anon_sym_set] = ACTIONS(4062),
    [anon_sym_type] = ACTIONS(4062),
    [anon_sym_import] = ACTIONS(4062),
    [anon_sym_namespace] = ACTIONS(4062),
    [anon_sym_PLUS_PLUS] = ACTIONS(4064),
    [anon_sym_DQUOTE] = ACTIONS(4064),
    [anon_sym_BANG] = ACTIONS(4064),
    [anon_sym_for] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4064),
    [sym_false] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_module] = ACTIONS(4062),
    [anon_sym_number] = ACTIONS(4062),
    [anon_sym_class] = ACTIONS(4062),
    [anon_sym_declare] = ACTIONS(4062),
    [anon_sym_typeof] = ACTIONS(4062),
    [anon_sym_LBRACE] = ACTIONS(4064),
    [anon_sym_switch] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4064),
    [sym_null] = ACTIONS(4062),
    [anon_sym_any] = ACTIONS(4062),
    [anon_sym_boolean] = ACTIONS(4062),
    [anon_sym_async] = ACTIONS(4062),
    [anon_sym_public] = ACTIONS(4062),
    [anon_sym_var] = ACTIONS(4062),
    [anon_sym_while] = ACTIONS(4062),
    [anon_sym_SQUOTE] = ACTIONS(4064),
    [anon_sym_try] = ACTIONS(4062),
    [anon_sym_LT] = ACTIONS(4064),
    [sym_number] = ACTIONS(4064),
    [anon_sym_SLASH] = ACTIONS(4062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4062),
    [anon_sym_function] = ACTIONS(4062),
    [sym_undefined] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_PLUS] = ACTIONS(4062),
    [anon_sym_export] = ACTIONS(4062),
    [anon_sym_do] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4064),
    [anon_sym_with] = ACTIONS(4062),
    [anon_sym_await] = ACTIONS(4062),
  },
  [1162] = {
    [sym_identifier] = ACTIONS(4066),
    [anon_sym_BQUOTE] = ACTIONS(4068),
    [anon_sym_debugger] = ACTIONS(4066),
    [anon_sym_symbol] = ACTIONS(4066),
    [anon_sym_AT] = ACTIONS(4068),
    [anon_sym_DASH] = ACTIONS(4066),
    [anon_sym_void] = ACTIONS(4066),
    [anon_sym_break] = ACTIONS(4066),
    [anon_sym_const] = ACTIONS(4066),
    [sym_super] = ACTIONS(4066),
    [anon_sym_return] = ACTIONS(4066),
    [anon_sym_private] = ACTIONS(4066),
    [anon_sym_static] = ACTIONS(4066),
    [anon_sym_get] = ACTIONS(4066),
    [anon_sym_interface] = ACTIONS(4066),
    [anon_sym_enum] = ACTIONS(4066),
    [anon_sym_delete] = ACTIONS(4066),
    [anon_sym_continue] = ACTIONS(4066),
    [anon_sym_DASH_DASH] = ACTIONS(4068),
    [anon_sym_if] = ACTIONS(4066),
    [sym_this] = ACTIONS(4066),
    [anon_sym_yield] = ACTIONS(4066),
    [sym_true] = ACTIONS(4066),
    [anon_sym_throw] = ACTIONS(4066),
    [anon_sym_protected] = ACTIONS(4066),
    [anon_sym_abstract] = ACTIONS(4066),
    [anon_sym_set] = ACTIONS(4066),
    [anon_sym_type] = ACTIONS(4066),
    [anon_sym_import] = ACTIONS(4066),
    [anon_sym_namespace] = ACTIONS(4066),
    [anon_sym_PLUS_PLUS] = ACTIONS(4068),
    [anon_sym_DQUOTE] = ACTIONS(4068),
    [anon_sym_BANG] = ACTIONS(4068),
    [anon_sym_for] = ACTIONS(4066),
    [anon_sym_LBRACK] = ACTIONS(4068),
    [sym_false] = ACTIONS(4066),
    [anon_sym_SEMI] = ACTIONS(4068),
    [anon_sym_module] = ACTIONS(4066),
    [anon_sym_number] = ACTIONS(4066),
    [anon_sym_class] = ACTIONS(4066),
    [anon_sym_declare] = ACTIONS(4066),
    [anon_sym_typeof] = ACTIONS(4066),
    [anon_sym_LBRACE] = ACTIONS(4068),
    [anon_sym_switch] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(4068),
    [sym_null] = ACTIONS(4066),
    [anon_sym_any] = ACTIONS(4066),
    [anon_sym_boolean] = ACTIONS(4066),
    [anon_sym_async] = ACTIONS(4066),
    [anon_sym_public] = ACTIONS(4066),
    [anon_sym_var] = ACTIONS(4066),
    [anon_sym_while] = ACTIONS(4066),
    [anon_sym_SQUOTE] = ACTIONS(4068),
    [anon_sym_try] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(4068),
    [sym_number] = ACTIONS(4068),
    [anon_sym_SLASH] = ACTIONS(4066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4066),
    [anon_sym_function] = ACTIONS(4066),
    [sym_undefined] = ACTIONS(4066),
    [anon_sym_new] = ACTIONS(4066),
    [anon_sym_let] = ACTIONS(4066),
    [anon_sym_PLUS] = ACTIONS(4066),
    [anon_sym_export] = ACTIONS(4066),
    [anon_sym_do] = ACTIONS(4066),
    [anon_sym_TILDE] = ACTIONS(4068),
    [anon_sym_with] = ACTIONS(4066),
    [anon_sym_await] = ACTIONS(4066),
  },
  [1163] = {
    [sym_identifier] = ACTIONS(4070),
    [anon_sym_BQUOTE] = ACTIONS(4072),
    [anon_sym_debugger] = ACTIONS(4070),
    [anon_sym_symbol] = ACTIONS(4070),
    [anon_sym_AT] = ACTIONS(4072),
    [anon_sym_DASH] = ACTIONS(4070),
    [anon_sym_void] = ACTIONS(4070),
    [anon_sym_break] = ACTIONS(4070),
    [anon_sym_const] = ACTIONS(4070),
    [sym_super] = ACTIONS(4070),
    [anon_sym_return] = ACTIONS(4070),
    [anon_sym_private] = ACTIONS(4070),
    [anon_sym_static] = ACTIONS(4070),
    [anon_sym_get] = ACTIONS(4070),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_interface] = ACTIONS(4070),
    [anon_sym_default] = ACTIONS(4070),
    [anon_sym_enum] = ACTIONS(4070),
    [anon_sym_delete] = ACTIONS(4070),
    [anon_sym_continue] = ACTIONS(4070),
    [anon_sym_DASH_DASH] = ACTIONS(4072),
    [anon_sym_if] = ACTIONS(4070),
    [sym_this] = ACTIONS(4070),
    [anon_sym_yield] = ACTIONS(4070),
    [sym_true] = ACTIONS(4070),
    [anon_sym_throw] = ACTIONS(4070),
    [anon_sym_protected] = ACTIONS(4070),
    [anon_sym_abstract] = ACTIONS(4070),
    [anon_sym_set] = ACTIONS(4070),
    [anon_sym_type] = ACTIONS(4070),
    [anon_sym_import] = ACTIONS(4070),
    [anon_sym_namespace] = ACTIONS(4070),
    [anon_sym_PLUS_PLUS] = ACTIONS(4072),
    [anon_sym_DQUOTE] = ACTIONS(4072),
    [anon_sym_else] = ACTIONS(4070),
    [anon_sym_BANG] = ACTIONS(4072),
    [anon_sym_for] = ACTIONS(4070),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [sym_false] = ACTIONS(4070),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_case] = ACTIONS(4070),
    [anon_sym_module] = ACTIONS(4070),
    [anon_sym_number] = ACTIONS(4070),
    [anon_sym_class] = ACTIONS(4070),
    [anon_sym_declare] = ACTIONS(4070),
    [anon_sym_typeof] = ACTIONS(4070),
    [anon_sym_LBRACE] = ACTIONS(4072),
    [anon_sym_switch] = ACTIONS(4070),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [sym_null] = ACTIONS(4070),
    [anon_sym_any] = ACTIONS(4070),
    [anon_sym_boolean] = ACTIONS(4070),
    [anon_sym_async] = ACTIONS(4070),
    [anon_sym_public] = ACTIONS(4070),
    [anon_sym_var] = ACTIONS(4070),
    [anon_sym_while] = ACTIONS(4070),
    [anon_sym_SQUOTE] = ACTIONS(4072),
    [anon_sym_try] = ACTIONS(4070),
    [anon_sym_LT] = ACTIONS(4072),
    [sym_number] = ACTIONS(4072),
    [anon_sym_SLASH] = ACTIONS(4070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4070),
    [anon_sym_function] = ACTIONS(4070),
    [sym_undefined] = ACTIONS(4070),
    [anon_sym_new] = ACTIONS(4070),
    [ts_builtin_sym_end] = ACTIONS(4072),
    [anon_sym_let] = ACTIONS(4070),
    [anon_sym_PLUS] = ACTIONS(4070),
    [anon_sym_export] = ACTIONS(4070),
    [anon_sym_do] = ACTIONS(4070),
    [anon_sym_TILDE] = ACTIONS(4072),
    [anon_sym_with] = ACTIONS(4070),
    [anon_sym_await] = ACTIONS(4070),
  },
  [1164] = {
    [sym_type_annotation] = STATE(1209),
    [anon_sym_COLON] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
  },
  [1165] = {
    [sym_type_annotation] = STATE(1210),
    [anon_sym_COLON] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
  },
  [1166] = {
    [sym__automatic_semicolon] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4074),
    [anon_sym_COMMA] = ACTIONS(4074),
    [sym_comment] = ACTIONS(3),
  },
  [1167] = {
    [sym__automatic_semicolon] = ACTIONS(4076),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_COMMA] = ACTIONS(4076),
    [sym_comment] = ACTIONS(3),
  },
  [1168] = {
    [sym__initializer] = STATE(1211),
    [sym__automatic_semicolon] = ACTIONS(4078),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(4078),
    [anon_sym_COMMA] = ACTIONS(4078),
    [sym_comment] = ACTIONS(3),
  },
  [1169] = {
    [sym__automatic_semicolon] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4080),
    [anon_sym_COMMA] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
  },
  [1170] = {
    [sym__automatic_semicolon] = ACTIONS(4082),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_COMMA] = ACTIONS(4082),
    [sym_comment] = ACTIONS(3),
  },
  [1171] = {
    [sym_statement_block] = STATE(1576),
    [sym__automatic_semicolon] = ACTIONS(4084),
    [anon_sym_SEMI] = ACTIONS(4084),
    [anon_sym_COMMA] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1172] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1212),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1173] = {
    [sym_statement_block] = STATE(1577),
    [sym__automatic_semicolon] = ACTIONS(4086),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1174] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1214),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(4088),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1175] = {
    [sym_string] = STATE(1215),
    [sym__property_name] = STATE(1215),
    [sym_computed_property_name] = STATE(1215),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(4090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1176] = {
    [sym_string] = STATE(1215),
    [sym__property_name] = STATE(1215),
    [sym_computed_property_name] = STATE(1215),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(4090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1177] = {
    [sym_type_annotation] = STATE(1217),
    [sym_formal_parameters] = STATE(1255),
    [sym__initializer] = STATE(1216),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1212),
    [sym__automatic_semicolon] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(4092),
    [sym_comment] = ACTIONS(3),
  },
  [1178] = {
    [sym__initializer] = STATE(1216),
    [sym_type_annotation] = STATE(1217),
    [sym__automatic_semicolon] = ACTIONS(4092),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4092),
    [anon_sym_COMMA] = ACTIONS(4092),
    [sym_comment] = ACTIONS(3),
  },
  [1179] = {
    [sym__automatic_semicolon] = ACTIONS(4094),
    [anon_sym_SEMI] = ACTIONS(4094),
    [anon_sym_COMMA] = ACTIONS(4094),
    [sym_comment] = ACTIONS(3),
  },
  [1180] = {
    [sym__initializer] = STATE(1218),
    [sym__automatic_semicolon] = ACTIONS(4096),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(4096),
    [anon_sym_COMMA] = ACTIONS(4096),
    [sym_comment] = ACTIONS(3),
  },
  [1181] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1219),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1182] = {
    [sym__automatic_semicolon] = ACTIONS(4098),
    [anon_sym_SEMI] = ACTIONS(4098),
    [anon_sym_COMMA] = ACTIONS(4098),
    [sym_comment] = ACTIONS(3),
  },
  [1183] = {
    [sym__automatic_semicolon] = ACTIONS(3973),
    [sym_identifier] = ACTIONS(3977),
    [anon_sym_BQUOTE] = ACTIONS(3975),
    [anon_sym_debugger] = ACTIONS(3977),
    [anon_sym_symbol] = ACTIONS(3977),
    [anon_sym_AT] = ACTIONS(3975),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_void] = ACTIONS(3977),
    [anon_sym_break] = ACTIONS(3977),
    [anon_sym_const] = ACTIONS(3977),
    [sym_super] = ACTIONS(3977),
    [anon_sym_return] = ACTIONS(3977),
    [anon_sym_private] = ACTIONS(3977),
    [anon_sym_static] = ACTIONS(3977),
    [anon_sym_get] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_interface] = ACTIONS(3977),
    [anon_sym_default] = ACTIONS(3977),
    [anon_sym_enum] = ACTIONS(3977),
    [anon_sym_delete] = ACTIONS(3977),
    [anon_sym_continue] = ACTIONS(3977),
    [anon_sym_DASH_DASH] = ACTIONS(3975),
    [anon_sym_if] = ACTIONS(3977),
    [sym_this] = ACTIONS(3977),
    [anon_sym_yield] = ACTIONS(3977),
    [sym_true] = ACTIONS(3977),
    [anon_sym_throw] = ACTIONS(3977),
    [anon_sym_protected] = ACTIONS(3977),
    [anon_sym_abstract] = ACTIONS(3977),
    [anon_sym_set] = ACTIONS(3977),
    [anon_sym_type] = ACTIONS(3977),
    [anon_sym_import] = ACTIONS(3977),
    [anon_sym_namespace] = ACTIONS(3977),
    [anon_sym_PLUS_PLUS] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3975),
    [anon_sym_else] = ACTIONS(3977),
    [anon_sym_BANG] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3977),
    [anon_sym_LBRACK] = ACTIONS(3975),
    [sym_false] = ACTIONS(3977),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_case] = ACTIONS(3977),
    [anon_sym_module] = ACTIONS(3977),
    [anon_sym_number] = ACTIONS(3977),
    [anon_sym_class] = ACTIONS(3977),
    [anon_sym_declare] = ACTIONS(3977),
    [anon_sym_typeof] = ACTIONS(3977),
    [anon_sym_LBRACE] = ACTIONS(3975),
    [anon_sym_switch] = ACTIONS(3977),
    [anon_sym_LPAREN] = ACTIONS(3975),
    [sym_null] = ACTIONS(3977),
    [anon_sym_any] = ACTIONS(3977),
    [anon_sym_boolean] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3977),
    [anon_sym_public] = ACTIONS(3977),
    [anon_sym_var] = ACTIONS(3977),
    [anon_sym_while] = ACTIONS(3977),
    [anon_sym_SQUOTE] = ACTIONS(3975),
    [anon_sym_try] = ACTIONS(3977),
    [anon_sym_LT] = ACTIONS(3975),
    [sym_number] = ACTIONS(3975),
    [anon_sym_SLASH] = ACTIONS(3977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3977),
    [anon_sym_function] = ACTIONS(3977),
    [sym_undefined] = ACTIONS(3977),
    [anon_sym_new] = ACTIONS(3977),
    [ts_builtin_sym_end] = ACTIONS(3975),
    [anon_sym_let] = ACTIONS(3977),
    [anon_sym_PLUS] = ACTIONS(3977),
    [anon_sym_export] = ACTIONS(3977),
    [anon_sym_do] = ACTIONS(3977),
    [anon_sym_TILDE] = ACTIONS(3975),
    [anon_sym_with] = ACTIONS(3977),
    [anon_sym_await] = ACTIONS(3977),
  },
  [1184] = {
    [sym__automatic_semicolon] = ACTIONS(4040),
    [sym_identifier] = ACTIONS(4044),
    [anon_sym_BQUOTE] = ACTIONS(4042),
    [anon_sym_debugger] = ACTIONS(4044),
    [anon_sym_symbol] = ACTIONS(4044),
    [anon_sym_AT] = ACTIONS(4042),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_void] = ACTIONS(4044),
    [anon_sym_break] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [sym_super] = ACTIONS(4044),
    [anon_sym_return] = ACTIONS(4044),
    [anon_sym_private] = ACTIONS(4044),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_get] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_interface] = ACTIONS(4044),
    [anon_sym_default] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_delete] = ACTIONS(4044),
    [anon_sym_continue] = ACTIONS(4044),
    [anon_sym_DASH_DASH] = ACTIONS(4042),
    [anon_sym_if] = ACTIONS(4044),
    [sym_this] = ACTIONS(4044),
    [anon_sym_yield] = ACTIONS(4044),
    [sym_true] = ACTIONS(4044),
    [anon_sym_throw] = ACTIONS(4044),
    [anon_sym_protected] = ACTIONS(4044),
    [anon_sym_abstract] = ACTIONS(4044),
    [anon_sym_set] = ACTIONS(4044),
    [anon_sym_type] = ACTIONS(4044),
    [anon_sym_import] = ACTIONS(4044),
    [anon_sym_namespace] = ACTIONS(4044),
    [anon_sym_PLUS_PLUS] = ACTIONS(4042),
    [anon_sym_DQUOTE] = ACTIONS(4042),
    [anon_sym_else] = ACTIONS(4044),
    [anon_sym_BANG] = ACTIONS(4042),
    [anon_sym_for] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4042),
    [sym_false] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_case] = ACTIONS(4044),
    [anon_sym_module] = ACTIONS(4044),
    [anon_sym_number] = ACTIONS(4044),
    [anon_sym_class] = ACTIONS(4044),
    [anon_sym_declare] = ACTIONS(4044),
    [anon_sym_typeof] = ACTIONS(4044),
    [anon_sym_LBRACE] = ACTIONS(4042),
    [anon_sym_switch] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [sym_null] = ACTIONS(4044),
    [anon_sym_any] = ACTIONS(4044),
    [anon_sym_boolean] = ACTIONS(4044),
    [anon_sym_async] = ACTIONS(4044),
    [anon_sym_public] = ACTIONS(4044),
    [anon_sym_var] = ACTIONS(4044),
    [anon_sym_while] = ACTIONS(4044),
    [anon_sym_SQUOTE] = ACTIONS(4042),
    [anon_sym_try] = ACTIONS(4044),
    [anon_sym_LT] = ACTIONS(4042),
    [sym_number] = ACTIONS(4042),
    [anon_sym_SLASH] = ACTIONS(4044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4044),
    [anon_sym_function] = ACTIONS(4044),
    [sym_undefined] = ACTIONS(4044),
    [anon_sym_new] = ACTIONS(4044),
    [ts_builtin_sym_end] = ACTIONS(4042),
    [anon_sym_let] = ACTIONS(4044),
    [anon_sym_PLUS] = ACTIONS(4044),
    [anon_sym_export] = ACTIONS(4044),
    [anon_sym_do] = ACTIONS(4044),
    [anon_sym_TILDE] = ACTIONS(4042),
    [anon_sym_with] = ACTIONS(4044),
    [anon_sym_await] = ACTIONS(4044),
  },
  [1185] = {
    [anon_sym_COMMA] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
  },
  [1186] = {
    [sym_statement_block] = STATE(1220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1187] = {
    [anon_sym_COMMA] = ACTIONS(4102),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
  },
  [1188] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1221),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1189] = {
    [sym_statement_block] = STATE(1222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1190] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1224),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [1191] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_default] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_case] = ACTIONS(4108),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1192] = {
    [sym_identifier] = ACTIONS(4110),
    [anon_sym_BQUOTE] = ACTIONS(4112),
    [anon_sym_debugger] = ACTIONS(4110),
    [anon_sym_symbol] = ACTIONS(4110),
    [anon_sym_AT] = ACTIONS(4112),
    [anon_sym_DASH] = ACTIONS(4110),
    [anon_sym_void] = ACTIONS(4110),
    [anon_sym_break] = ACTIONS(4110),
    [anon_sym_const] = ACTIONS(4110),
    [sym_super] = ACTIONS(4110),
    [anon_sym_return] = ACTIONS(4110),
    [anon_sym_private] = ACTIONS(4110),
    [anon_sym_static] = ACTIONS(4110),
    [anon_sym_get] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4110),
    [anon_sym_default] = ACTIONS(4110),
    [anon_sym_enum] = ACTIONS(4110),
    [anon_sym_delete] = ACTIONS(4110),
    [anon_sym_continue] = ACTIONS(4110),
    [anon_sym_DASH_DASH] = ACTIONS(4112),
    [anon_sym_if] = ACTIONS(4110),
    [sym_this] = ACTIONS(4110),
    [anon_sym_yield] = ACTIONS(4110),
    [sym_true] = ACTIONS(4110),
    [anon_sym_throw] = ACTIONS(4110),
    [anon_sym_protected] = ACTIONS(4110),
    [anon_sym_abstract] = ACTIONS(4110),
    [anon_sym_set] = ACTIONS(4110),
    [anon_sym_type] = ACTIONS(4110),
    [anon_sym_import] = ACTIONS(4110),
    [anon_sym_namespace] = ACTIONS(4110),
    [anon_sym_PLUS_PLUS] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(4112),
    [anon_sym_else] = ACTIONS(4110),
    [anon_sym_BANG] = ACTIONS(4112),
    [anon_sym_for] = ACTIONS(4110),
    [anon_sym_LBRACK] = ACTIONS(4112),
    [sym_false] = ACTIONS(4110),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_case] = ACTIONS(4110),
    [anon_sym_module] = ACTIONS(4110),
    [anon_sym_number] = ACTIONS(4110),
    [anon_sym_class] = ACTIONS(4110),
    [anon_sym_declare] = ACTIONS(4110),
    [anon_sym_typeof] = ACTIONS(4110),
    [anon_sym_LBRACE] = ACTIONS(4112),
    [anon_sym_switch] = ACTIONS(4110),
    [anon_sym_LPAREN] = ACTIONS(4112),
    [sym_null] = ACTIONS(4110),
    [anon_sym_any] = ACTIONS(4110),
    [anon_sym_boolean] = ACTIONS(4110),
    [anon_sym_async] = ACTIONS(4110),
    [anon_sym_public] = ACTIONS(4110),
    [anon_sym_var] = ACTIONS(4110),
    [anon_sym_while] = ACTIONS(4110),
    [anon_sym_SQUOTE] = ACTIONS(4112),
    [anon_sym_try] = ACTIONS(4110),
    [anon_sym_LT] = ACTIONS(4112),
    [sym_number] = ACTIONS(4112),
    [anon_sym_SLASH] = ACTIONS(4110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4110),
    [anon_sym_function] = ACTIONS(4110),
    [sym_undefined] = ACTIONS(4110),
    [anon_sym_new] = ACTIONS(4110),
    [ts_builtin_sym_end] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4110),
    [anon_sym_PLUS] = ACTIONS(4110),
    [anon_sym_export] = ACTIONS(4110),
    [anon_sym_do] = ACTIONS(4110),
    [anon_sym_TILDE] = ACTIONS(4112),
    [anon_sym_with] = ACTIONS(4110),
    [anon_sym_await] = ACTIONS(4110),
  },
  [1193] = {
    [sym_identifier] = ACTIONS(4114),
    [anon_sym_BQUOTE] = ACTIONS(4116),
    [anon_sym_debugger] = ACTIONS(4114),
    [anon_sym_symbol] = ACTIONS(4114),
    [anon_sym_AT] = ACTIONS(4116),
    [anon_sym_DASH] = ACTIONS(4114),
    [anon_sym_void] = ACTIONS(4114),
    [anon_sym_break] = ACTIONS(4114),
    [anon_sym_const] = ACTIONS(4114),
    [sym_super] = ACTIONS(4114),
    [anon_sym_return] = ACTIONS(4114),
    [anon_sym_private] = ACTIONS(4114),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_get] = ACTIONS(4114),
    [anon_sym_RBRACE] = ACTIONS(4116),
    [anon_sym_interface] = ACTIONS(4114),
    [anon_sym_default] = ACTIONS(4114),
    [anon_sym_enum] = ACTIONS(4114),
    [anon_sym_delete] = ACTIONS(4114),
    [anon_sym_continue] = ACTIONS(4114),
    [anon_sym_DASH_DASH] = ACTIONS(4116),
    [anon_sym_if] = ACTIONS(4114),
    [sym_this] = ACTIONS(4114),
    [anon_sym_yield] = ACTIONS(4114),
    [sym_true] = ACTIONS(4114),
    [anon_sym_throw] = ACTIONS(4114),
    [anon_sym_protected] = ACTIONS(4114),
    [anon_sym_abstract] = ACTIONS(4114),
    [anon_sym_set] = ACTIONS(4114),
    [anon_sym_type] = ACTIONS(4114),
    [anon_sym_import] = ACTIONS(4114),
    [anon_sym_namespace] = ACTIONS(4114),
    [anon_sym_PLUS_PLUS] = ACTIONS(4116),
    [anon_sym_DQUOTE] = ACTIONS(4116),
    [anon_sym_else] = ACTIONS(4114),
    [anon_sym_BANG] = ACTIONS(4116),
    [anon_sym_for] = ACTIONS(4114),
    [anon_sym_LBRACK] = ACTIONS(4116),
    [sym_false] = ACTIONS(4114),
    [anon_sym_SEMI] = ACTIONS(4116),
    [anon_sym_case] = ACTIONS(4114),
    [anon_sym_module] = ACTIONS(4114),
    [anon_sym_number] = ACTIONS(4114),
    [anon_sym_class] = ACTIONS(4114),
    [anon_sym_declare] = ACTIONS(4114),
    [anon_sym_typeof] = ACTIONS(4114),
    [anon_sym_LBRACE] = ACTIONS(4116),
    [anon_sym_switch] = ACTIONS(4114),
    [anon_sym_LPAREN] = ACTIONS(4116),
    [sym_null] = ACTIONS(4114),
    [anon_sym_any] = ACTIONS(4114),
    [anon_sym_boolean] = ACTIONS(4114),
    [anon_sym_async] = ACTIONS(4114),
    [anon_sym_public] = ACTIONS(4114),
    [anon_sym_var] = ACTIONS(4114),
    [anon_sym_while] = ACTIONS(4114),
    [anon_sym_SQUOTE] = ACTIONS(4116),
    [anon_sym_try] = ACTIONS(4114),
    [anon_sym_LT] = ACTIONS(4116),
    [sym_number] = ACTIONS(4116),
    [anon_sym_SLASH] = ACTIONS(4114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4114),
    [anon_sym_string] = ACTIONS(4114),
    [anon_sym_function] = ACTIONS(4114),
    [sym_undefined] = ACTIONS(4114),
    [anon_sym_new] = ACTIONS(4114),
    [ts_builtin_sym_end] = ACTIONS(4116),
    [anon_sym_let] = ACTIONS(4114),
    [anon_sym_PLUS] = ACTIONS(4114),
    [anon_sym_export] = ACTIONS(4114),
    [anon_sym_do] = ACTIONS(4114),
    [anon_sym_TILDE] = ACTIONS(4116),
    [anon_sym_with] = ACTIONS(4114),
    [anon_sym_await] = ACTIONS(4114),
  },
  [1194] = {
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_BQUOTE] = ACTIONS(4120),
    [anon_sym_debugger] = ACTIONS(4118),
    [anon_sym_symbol] = ACTIONS(4118),
    [anon_sym_AT] = ACTIONS(4120),
    [anon_sym_DASH] = ACTIONS(4118),
    [anon_sym_void] = ACTIONS(4118),
    [anon_sym_break] = ACTIONS(4118),
    [anon_sym_const] = ACTIONS(4118),
    [sym_super] = ACTIONS(4118),
    [anon_sym_return] = ACTIONS(4118),
    [anon_sym_private] = ACTIONS(4118),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_get] = ACTIONS(4118),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_interface] = ACTIONS(4118),
    [anon_sym_default] = ACTIONS(4118),
    [anon_sym_enum] = ACTIONS(4118),
    [anon_sym_delete] = ACTIONS(4118),
    [anon_sym_continue] = ACTIONS(4118),
    [anon_sym_DASH_DASH] = ACTIONS(4120),
    [anon_sym_if] = ACTIONS(4118),
    [sym_this] = ACTIONS(4118),
    [anon_sym_yield] = ACTIONS(4118),
    [sym_true] = ACTIONS(4118),
    [anon_sym_throw] = ACTIONS(4118),
    [anon_sym_protected] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_set] = ACTIONS(4118),
    [anon_sym_type] = ACTIONS(4118),
    [anon_sym_import] = ACTIONS(4118),
    [anon_sym_namespace] = ACTIONS(4118),
    [anon_sym_PLUS_PLUS] = ACTIONS(4120),
    [anon_sym_DQUOTE] = ACTIONS(4120),
    [anon_sym_else] = ACTIONS(4118),
    [anon_sym_BANG] = ACTIONS(4120),
    [anon_sym_for] = ACTIONS(4118),
    [anon_sym_LBRACK] = ACTIONS(4120),
    [sym_false] = ACTIONS(4118),
    [anon_sym_SEMI] = ACTIONS(4120),
    [anon_sym_case] = ACTIONS(4118),
    [anon_sym_module] = ACTIONS(4118),
    [anon_sym_number] = ACTIONS(4118),
    [anon_sym_class] = ACTIONS(4118),
    [anon_sym_declare] = ACTIONS(4118),
    [anon_sym_typeof] = ACTIONS(4118),
    [anon_sym_LBRACE] = ACTIONS(4120),
    [anon_sym_switch] = ACTIONS(4118),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [sym_null] = ACTIONS(4118),
    [anon_sym_any] = ACTIONS(4118),
    [anon_sym_boolean] = ACTIONS(4118),
    [anon_sym_async] = ACTIONS(4118),
    [anon_sym_public] = ACTIONS(4118),
    [anon_sym_var] = ACTIONS(4118),
    [anon_sym_while] = ACTIONS(4118),
    [anon_sym_SQUOTE] = ACTIONS(4120),
    [anon_sym_try] = ACTIONS(4118),
    [anon_sym_LT] = ACTIONS(4120),
    [sym_number] = ACTIONS(4120),
    [anon_sym_SLASH] = ACTIONS(4118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4118),
    [anon_sym_string] = ACTIONS(4118),
    [anon_sym_function] = ACTIONS(4118),
    [sym_undefined] = ACTIONS(4118),
    [anon_sym_new] = ACTIONS(4118),
    [ts_builtin_sym_end] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4118),
    [anon_sym_PLUS] = ACTIONS(4118),
    [anon_sym_export] = ACTIONS(4118),
    [anon_sym_do] = ACTIONS(4118),
    [anon_sym_TILDE] = ACTIONS(4120),
    [anon_sym_with] = ACTIONS(4118),
    [anon_sym_await] = ACTIONS(4118),
  },
  [1195] = {
    [sym_identifier] = ACTIONS(4122),
    [anon_sym_BQUOTE] = ACTIONS(4124),
    [anon_sym_debugger] = ACTIONS(4122),
    [anon_sym_symbol] = ACTIONS(4122),
    [anon_sym_AT] = ACTIONS(4124),
    [anon_sym_DASH] = ACTIONS(4122),
    [anon_sym_void] = ACTIONS(4122),
    [anon_sym_break] = ACTIONS(4122),
    [anon_sym_const] = ACTIONS(4122),
    [sym_super] = ACTIONS(4122),
    [anon_sym_return] = ACTIONS(4122),
    [anon_sym_private] = ACTIONS(4122),
    [anon_sym_static] = ACTIONS(4122),
    [anon_sym_get] = ACTIONS(4122),
    [anon_sym_RBRACE] = ACTIONS(4124),
    [anon_sym_interface] = ACTIONS(4122),
    [anon_sym_default] = ACTIONS(4122),
    [anon_sym_enum] = ACTIONS(4122),
    [anon_sym_delete] = ACTIONS(4122),
    [anon_sym_continue] = ACTIONS(4122),
    [anon_sym_DASH_DASH] = ACTIONS(4124),
    [anon_sym_if] = ACTIONS(4122),
    [sym_this] = ACTIONS(4122),
    [anon_sym_yield] = ACTIONS(4122),
    [sym_true] = ACTIONS(4122),
    [anon_sym_throw] = ACTIONS(4122),
    [anon_sym_protected] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4122),
    [anon_sym_set] = ACTIONS(4122),
    [anon_sym_type] = ACTIONS(4122),
    [anon_sym_import] = ACTIONS(4122),
    [anon_sym_namespace] = ACTIONS(4122),
    [anon_sym_PLUS_PLUS] = ACTIONS(4124),
    [anon_sym_DQUOTE] = ACTIONS(4124),
    [anon_sym_else] = ACTIONS(4122),
    [anon_sym_BANG] = ACTIONS(4124),
    [anon_sym_for] = ACTIONS(4122),
    [anon_sym_LBRACK] = ACTIONS(4124),
    [sym_false] = ACTIONS(4122),
    [anon_sym_SEMI] = ACTIONS(4124),
    [anon_sym_case] = ACTIONS(4122),
    [anon_sym_module] = ACTIONS(4122),
    [anon_sym_number] = ACTIONS(4122),
    [anon_sym_class] = ACTIONS(4122),
    [anon_sym_declare] = ACTIONS(4122),
    [anon_sym_typeof] = ACTIONS(4122),
    [anon_sym_LBRACE] = ACTIONS(4124),
    [anon_sym_switch] = ACTIONS(4122),
    [anon_sym_LPAREN] = ACTIONS(4124),
    [sym_null] = ACTIONS(4122),
    [anon_sym_any] = ACTIONS(4122),
    [anon_sym_boolean] = ACTIONS(4122),
    [anon_sym_async] = ACTIONS(4122),
    [anon_sym_public] = ACTIONS(4122),
    [anon_sym_var] = ACTIONS(4122),
    [anon_sym_while] = ACTIONS(4122),
    [anon_sym_SQUOTE] = ACTIONS(4124),
    [anon_sym_try] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [sym_number] = ACTIONS(4124),
    [anon_sym_SLASH] = ACTIONS(4122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(4122),
    [anon_sym_string] = ACTIONS(4122),
    [anon_sym_function] = ACTIONS(4122),
    [sym_undefined] = ACTIONS(4122),
    [anon_sym_new] = ACTIONS(4122),
    [ts_builtin_sym_end] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4122),
    [anon_sym_PLUS] = ACTIONS(4122),
    [anon_sym_export] = ACTIONS(4122),
    [anon_sym_do] = ACTIONS(4122),
    [anon_sym_TILDE] = ACTIONS(4124),
    [anon_sym_with] = ACTIONS(4122),
    [anon_sym_await] = ACTIONS(4122),
  },
  [1196] = {
    [anon_sym_BQUOTE] = ACTIONS(4126),
    [anon_sym_symbol] = ACTIONS(4128),
    [anon_sym_PIPE] = ACTIONS(4126),
    [anon_sym_break] = ACTIONS(4128),
    [anon_sym_return] = ACTIONS(4128),
    [anon_sym_static] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4126),
    [anon_sym_interface] = ACTIONS(4128),
    [anon_sym_delete] = ACTIONS(4128),
    [anon_sym_if] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4128),
    [sym_true] = ACTIONS(4128),
    [anon_sym_protected] = ACTIONS(4128),
    [anon_sym_set] = ACTIONS(4128),
    [anon_sym_import] = ACTIONS(4128),
    [anon_sym_DQUOTE] = ACTIONS(4126),
    [anon_sym_for] = ACTIONS(4128),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_number] = ACTIONS(4128),
    [anon_sym_typeof] = ACTIONS(4128),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_switch] = ACTIONS(4128),
    [anon_sym_RBRACK] = ACTIONS(4126),
    [sym_null] = ACTIONS(4128),
    [anon_sym_any] = ACTIONS(4128),
    [anon_sym_async] = ACTIONS(4128),
    [anon_sym_public] = ACTIONS(4128),
    [anon_sym_var] = ACTIONS(4128),
    [anon_sym_while] = ACTIONS(4128),
    [anon_sym_SQUOTE] = ACTIONS(4126),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_SLASH] = ACTIONS(4128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4128),
    [anon_sym_export] = ACTIONS(4128),
    [anon_sym_with] = ACTIONS(4128),
    [sym_identifier] = ACTIONS(4128),
    [anon_sym_debugger] = ACTIONS(4128),
    [anon_sym_AT] = ACTIONS(4126),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(4128),
    [anon_sym_void] = ACTIONS(4128),
    [anon_sym_const] = ACTIONS(4128),
    [sym_super] = ACTIONS(4128),
    [anon_sym_private] = ACTIONS(4128),
    [anon_sym_get] = ACTIONS(4128),
    [anon_sym_default] = ACTIONS(4128),
    [anon_sym_enum] = ACTIONS(4128),
    [anon_sym_continue] = ACTIONS(4128),
    [anon_sym_DASH_DASH] = ACTIONS(4126),
    [sym_this] = ACTIONS(4128),
    [anon_sym_throw] = ACTIONS(4128),
    [anon_sym_abstract] = ACTIONS(4128),
    [anon_sym_type] = ACTIONS(4128),
    [anon_sym_namespace] = ACTIONS(4128),
    [anon_sym_PLUS_PLUS] = ACTIONS(4126),
    [anon_sym_else] = ACTIONS(4128),
    [anon_sym_BANG] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [sym_false] = ACTIONS(4128),
    [anon_sym_case] = ACTIONS(4128),
    [anon_sym_module] = ACTIONS(4128),
    [anon_sym_class] = ACTIONS(4128),
    [anon_sym_declare] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4126),
    [anon_sym_boolean] = ACTIONS(4128),
    [anon_sym_EQ_GT] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_try] = ACTIONS(4128),
    [anon_sym_LT] = ACTIONS(4126),
    [sym_number] = ACTIONS(4126),
    [ts_builtin_sym_end] = ACTIONS(4126),
    [anon_sym_function] = ACTIONS(4128),
    [sym_undefined] = ACTIONS(4128),
    [anon_sym_let] = ACTIONS(4128),
    [anon_sym_PLUS] = ACTIONS(4128),
    [anon_sym_do] = ACTIONS(4128),
    [anon_sym_TILDE] = ACTIONS(4126),
    [anon_sym_await] = ACTIONS(4128),
  },
  [1197] = {
    [sym__automatic_semicolon] = ACTIONS(4084),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [anon_sym_SEMI] = ACTIONS(4084),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
  },
  [1198] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1225),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1199] = {
    [sym__automatic_semicolon] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
  },
  [1200] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1227),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(4130),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1201] = {
    [sym__automatic_semicolon] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_SEMI] = ACTIONS(4132),
    [anon_sym_COMMA] = ACTIONS(4132),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
  },
  [1202] = {
    [sym_string] = STATE(1228),
    [sym__property_name] = STATE(1228),
    [sym_computed_property_name] = STATE(1228),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(4134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1203] = {
    [sym_string] = STATE(1228),
    [sym__property_name] = STATE(1228),
    [sym_computed_property_name] = STATE(1228),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(4134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1204] = {
    [sym__call_signature] = STATE(1225),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1229),
    [sym__automatic_semicolon] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(4136),
    [sym_comment] = ACTIONS(3),
  },
  [1205] = {
    [sym__automatic_semicolon] = ACTIONS(4138),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_SEMI] = ACTIONS(4138),
    [anon_sym_COMMA] = ACTIONS(4138),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4138),
    [sym_comment] = ACTIONS(3),
  },
  [1206] = {
    [sym__call_signature] = STATE(2018),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1201),
    [sym__automatic_semicolon] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(3991),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3991),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(3991),
    [sym_comment] = ACTIONS(3),
  },
  [1207] = {
    [sym__call_signature] = STATE(2019),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1205),
    [sym__automatic_semicolon] = ACTIONS(4003),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4003),
    [anon_sym_QMARK] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4003),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
  },
  [1208] = {
    [sym_identifier] = ACTIONS(4142),
    [anon_sym_BQUOTE] = ACTIONS(4144),
    [anon_sym_debugger] = ACTIONS(4142),
    [anon_sym_symbol] = ACTIONS(4142),
    [anon_sym_AT] = ACTIONS(4144),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_void] = ACTIONS(4142),
    [anon_sym_break] = ACTIONS(4142),
    [anon_sym_const] = ACTIONS(4142),
    [sym_super] = ACTIONS(4142),
    [anon_sym_return] = ACTIONS(4142),
    [anon_sym_private] = ACTIONS(4142),
    [anon_sym_static] = ACTIONS(4142),
    [anon_sym_get] = ACTIONS(4142),
    [anon_sym_RBRACE] = ACTIONS(4144),
    [anon_sym_interface] = ACTIONS(4142),
    [anon_sym_default] = ACTIONS(4142),
    [anon_sym_enum] = ACTIONS(4142),
    [anon_sym_delete] = ACTIONS(4142),
    [anon_sym_continue] = ACTIONS(4142),
    [anon_sym_DASH_DASH] = ACTIONS(4144),
    [anon_sym_if] = ACTIONS(4142),
    [sym_this] = ACTIONS(4142),
    [anon_sym_yield] = ACTIONS(4142),
    [sym_true] = ACTIONS(4142),
    [anon_sym_throw] = ACTIONS(4142),
    [anon_sym_protected] = ACTIONS(4142),
    [anon_sym_abstract] = ACTIONS(4142),
    [anon_sym_set] = ACTIONS(4142),
    [anon_sym_type] = ACTIONS(4142),
    [anon_sym_import] = ACTIONS(4142),
    [anon_sym_namespace] = ACTIONS(4142),
    [anon_sym_PLUS_PLUS] = ACTIONS(4144),
    [anon_sym_DQUOTE] = ACTIONS(4144),
    [anon_sym_else] = ACTIONS(4142),
    [anon_sym_BANG] = ACTIONS(4144),
    [anon_sym_for] = ACTIONS(4142),
    [anon_sym_LBRACK] = ACTIONS(4144),
    [sym_false] = ACTIONS(4142),
    [anon_sym_SEMI] = ACTIONS(4144),
    [anon_sym_case] = ACTIONS(4142),
    [anon_sym_module] = ACTIONS(4142),
    [anon_sym_number] = ACTIONS(4142),
    [anon_sym_class] = ACTIONS(4142),
    [anon_sym_declare] = ACTIONS(4142),
    [anon_sym_typeof] = ACTIONS(4142),
    [anon_sym_LBRACE] = ACTIONS(4144),
    [anon_sym_switch] = ACTIONS(4142),
    [anon_sym_LPAREN] = ACTIONS(4144),
    [sym_null] = ACTIONS(4142),
    [anon_sym_any] = ACTIONS(4142),
    [anon_sym_boolean] = ACTIONS(4142),
    [anon_sym_async] = ACTIONS(4142),
    [anon_sym_public] = ACTIONS(4142),
    [anon_sym_var] = ACTIONS(4142),
    [anon_sym_while] = ACTIONS(4142),
    [anon_sym_SQUOTE] = ACTIONS(4144),
    [anon_sym_try] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4144),
    [sym_number] = ACTIONS(4144),
    [anon_sym_SLASH] = ACTIONS(4142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4142),
    [anon_sym_function] = ACTIONS(4142),
    [sym_undefined] = ACTIONS(4142),
    [anon_sym_new] = ACTIONS(4142),
    [ts_builtin_sym_end] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4142),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_export] = ACTIONS(4142),
    [anon_sym_do] = ACTIONS(4142),
    [anon_sym_TILDE] = ACTIONS(4144),
    [anon_sym_with] = ACTIONS(4142),
    [anon_sym_await] = ACTIONS(4142),
  },
  [1209] = {
    [sym__automatic_semicolon] = ACTIONS(4146),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_SEMI] = ACTIONS(4146),
    [anon_sym_COMMA] = ACTIONS(4146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4146),
  },
  [1210] = {
    [sym__automatic_semicolon] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4148),
    [anon_sym_SEMI] = ACTIONS(4148),
    [anon_sym_COMMA] = ACTIONS(4148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4148),
  },
  [1211] = {
    [sym__automatic_semicolon] = ACTIONS(4150),
    [anon_sym_SEMI] = ACTIONS(4150),
    [anon_sym_COMMA] = ACTIONS(4150),
    [sym_comment] = ACTIONS(3),
  },
  [1212] = {
    [sym_statement_block] = STATE(1580),
    [sym__automatic_semicolon] = ACTIONS(4152),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1213] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1231),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1214] = {
    [sym_statement_block] = STATE(1581),
    [sym__automatic_semicolon] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1215] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1233),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1216] = {
    [sym__automatic_semicolon] = ACTIONS(4158),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_COMMA] = ACTIONS(4158),
    [sym_comment] = ACTIONS(3),
  },
  [1217] = {
    [sym__initializer] = STATE(1234),
    [sym__automatic_semicolon] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4160),
    [sym_comment] = ACTIONS(3),
  },
  [1218] = {
    [sym__automatic_semicolon] = ACTIONS(4162),
    [anon_sym_SEMI] = ACTIONS(4162),
    [anon_sym_COMMA] = ACTIONS(4162),
    [sym_comment] = ACTIONS(3),
  },
  [1219] = {
    [sym__automatic_semicolon] = ACTIONS(4164),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
  },
  [1220] = {
    [anon_sym_COMMA] = ACTIONS(4166),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [sym_comment] = ACTIONS(3),
  },
  [1221] = {
    [sym_statement_block] = STATE(1235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1222] = {
    [anon_sym_COMMA] = ACTIONS(4168),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [sym_comment] = ACTIONS(3),
  },
  [1223] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1236),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1224] = {
    [sym_statement_block] = STATE(1237),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1225] = {
    [sym__automatic_semicolon] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
  },
  [1226] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1238),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1227] = {
    [sym__automatic_semicolon] = ACTIONS(4154),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
  },
  [1228] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1240),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(4170),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1229] = {
    [sym__automatic_semicolon] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(4172),
    [anon_sym_COMMA] = ACTIONS(4172),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4172),
    [sym_comment] = ACTIONS(3),
  },
  [1230] = {
    [sym__call_signature] = STATE(2021),
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym_type_annotation] = STATE(1229),
    [sym__automatic_semicolon] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4136),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(4136),
    [sym_comment] = ACTIONS(3),
  },
  [1231] = {
    [sym_statement_block] = STATE(1582),
    [sym__automatic_semicolon] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1232] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1241),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1233] = {
    [sym_statement_block] = STATE(1583),
    [sym__automatic_semicolon] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4176),
    [anon_sym_COMMA] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1234] = {
    [sym__automatic_semicolon] = ACTIONS(4178),
    [anon_sym_SEMI] = ACTIONS(4178),
    [anon_sym_COMMA] = ACTIONS(4178),
    [sym_comment] = ACTIONS(3),
  },
  [1235] = {
    [anon_sym_COMMA] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
  },
  [1236] = {
    [sym_statement_block] = STATE(1242),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1237] = {
    [anon_sym_COMMA] = ACTIONS(4182),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
  },
  [1238] = {
    [sym__automatic_semicolon] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
  },
  [1239] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1243),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [1240] = {
    [sym__automatic_semicolon] = ACTIONS(4176),
    [anon_sym_RBRACE] = ACTIONS(4176),
    [anon_sym_SEMI] = ACTIONS(4176),
    [anon_sym_COMMA] = ACTIONS(4176),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
  },
  [1241] = {
    [sym_statement_block] = STATE(1584),
    [sym__automatic_semicolon] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3001),
  },
  [1242] = {
    [anon_sym_COMMA] = ACTIONS(4186),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [sym_comment] = ACTIONS(3),
  },
  [1243] = {
    [sym__automatic_semicolon] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
  },
  [1244] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1245] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1246] = {
    [sym_arrow_function] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym__expression] = STATE(1273),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1273),
    [sym_generator_function] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_regex] = STATE(1273),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1273),
    [sym_class] = STATE(1273),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4188),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4188),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4188),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4188),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4188),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1247] = {
    [sym_arrow_function] = STATE(1275),
    [sym_await_expression] = STATE(1275),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1275),
    [sym_meta_property] = STATE(1275),
    [sym__expression] = STATE(1275),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1275),
    [sym_call_expression] = STATE(1275),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1275),
    [sym_string] = STATE(1275),
    [sym_template_string] = STATE(1275),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1275),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1275),
    [sym_generator_function] = STATE(1275),
    [sym_new_expression] = STATE(1275),
    [sym_assignment_expression] = STATE(1275),
    [sym_augmented_assignment_expression] = STATE(1275),
    [sym_binary_expression] = STATE(1275),
    [sym_unary_expression] = STATE(1275),
    [sym_regex] = STATE(1275),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1275),
    [sym_as_expression] = STATE(1275),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1275),
    [sym_class] = STATE(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(215),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4194),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(213),
    [sym_null] = ACTIONS(4194),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4194),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4194),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(4196),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1248] = {
    [sym_arrow_function] = STATE(1280),
    [sym_await_expression] = STATE(1280),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1280),
    [sym_meta_property] = STATE(1280),
    [sym__expression] = STATE(1280),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1280),
    [sym_call_expression] = STATE(1280),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1280),
    [sym_string] = STATE(1280),
    [sym_template_string] = STATE(1280),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1280),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1280),
    [sym_generator_function] = STATE(1280),
    [sym_new_expression] = STATE(1280),
    [sym_assignment_expression] = STATE(1280),
    [sym_augmented_assignment_expression] = STATE(1280),
    [sym_binary_expression] = STATE(1280),
    [sym_unary_expression] = STATE(1280),
    [sym_regex] = STATE(1280),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1280),
    [sym_as_expression] = STATE(1280),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1280),
    [sym_class] = STATE(1280),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4198),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4198),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4198),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4198),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4200),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4198),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1249] = {
    [sym_arrow_function] = STATE(1321),
    [sym_await_expression] = STATE(1321),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1321),
    [sym_meta_property] = STATE(1321),
    [sym__expression] = STATE(1321),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1321),
    [sym_call_expression] = STATE(1321),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1321),
    [sym_string] = STATE(1321),
    [sym_template_string] = STATE(1321),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1321),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1321),
    [sym_generator_function] = STATE(1321),
    [sym_new_expression] = STATE(1321),
    [sym_assignment_expression] = STATE(1321),
    [sym_augmented_assignment_expression] = STATE(1321),
    [sym_binary_expression] = STATE(1321),
    [sym_unary_expression] = STATE(1321),
    [sym_regex] = STATE(1321),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1321),
    [sym_as_expression] = STATE(1321),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1321),
    [sym_class] = STATE(1321),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4202),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4202),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4202),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4202),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4204),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4202),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1250] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1251] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1252] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1253] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_else] = ACTIONS(613),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_while] = ACTIONS(613),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1254] = {
    [sym_arrow_function] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym__expression] = STATE(1333),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1333),
    [sym_call_expression] = STATE(1333),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1333),
    [sym_generator_function] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_regex] = STATE(1333),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1333),
    [sym_class] = STATE(1333),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4208),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1255] = {
    [sym_type_annotation] = STATE(1337),
    [sym__automatic_semicolon] = ACTIONS(625),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(625),
    [anon_sym_PIPE_RBRACE] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(625),
  },
  [1256] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4212),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1257] = {
    [sym_arrow_function] = STATE(1341),
    [sym_await_expression] = STATE(1341),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1340),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1341),
    [sym_meta_property] = STATE(1341),
    [sym__expression] = STATE(1341),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1341),
    [sym_call_expression] = STATE(1341),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1341),
    [sym_string] = STATE(1341),
    [sym_template_string] = STATE(1341),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1341),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1341),
    [sym_generator_function] = STATE(1341),
    [sym_new_expression] = STATE(1341),
    [sym_assignment_expression] = STATE(1341),
    [sym_augmented_assignment_expression] = STATE(1341),
    [sym_binary_expression] = STATE(1341),
    [sym_unary_expression] = STATE(1341),
    [sym_regex] = STATE(1341),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1341),
    [sym_as_expression] = STATE(1341),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1341),
    [sym_class] = STATE(1341),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4214),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4214),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4214),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4214),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4218),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4214),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1258] = {
    [sym_arrow_function] = STATE(1342),
    [sym_await_expression] = STATE(1342),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1342),
    [sym_meta_property] = STATE(1342),
    [sym__expression] = STATE(1342),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1342),
    [sym_call_expression] = STATE(1342),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1342),
    [sym_string] = STATE(1342),
    [sym_template_string] = STATE(1342),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1342),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1342),
    [sym_generator_function] = STATE(1342),
    [sym_new_expression] = STATE(1342),
    [sym_assignment_expression] = STATE(1342),
    [sym_augmented_assignment_expression] = STATE(1342),
    [sym_binary_expression] = STATE(1342),
    [sym_unary_expression] = STATE(1342),
    [sym_regex] = STATE(1342),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1342),
    [sym_as_expression] = STATE(1342),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1342),
    [sym_class] = STATE(1342),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4220),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4220),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4220),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4222),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4220),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1259] = {
    [sym_arrow_function] = STATE(1343),
    [sym_await_expression] = STATE(1343),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1343),
    [sym_meta_property] = STATE(1343),
    [sym__expression] = STATE(1343),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1343),
    [sym_call_expression] = STATE(1343),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1343),
    [sym_string] = STATE(1343),
    [sym_template_string] = STATE(1343),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1343),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1343),
    [sym_generator_function] = STATE(1343),
    [sym_new_expression] = STATE(1343),
    [sym_assignment_expression] = STATE(1343),
    [sym_augmented_assignment_expression] = STATE(1343),
    [sym_binary_expression] = STATE(1343),
    [sym_unary_expression] = STATE(1343),
    [sym_regex] = STATE(1343),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1343),
    [sym_as_expression] = STATE(1343),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1343),
    [sym_class] = STATE(1343),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4224),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4224),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4224),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4224),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4226),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4224),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1260] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(659),
    [anon_sym_BQUOTE] = ACTIONS(659),
    [anon_sym_PIPE] = ACTIONS(661),
    [anon_sym_COMMA] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(661),
    [anon_sym_STAR] = ACTIONS(661),
    [anon_sym_GT_GT_GT] = ACTIONS(659),
    [anon_sym_BANG_EQ] = ACTIONS(661),
    [anon_sym_GT_EQ] = ACTIONS(659),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym_PERCENT] = ACTIONS(659),
    [anon_sym_LBRACE_PIPE] = ACTIONS(659),
    [anon_sym_as] = ACTIONS(659),
    [anon_sym_DASH_DASH] = ACTIONS(659),
    [anon_sym_instanceof] = ACTIONS(659),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_DOT] = ACTIONS(659),
    [anon_sym_STAR_STAR] = ACTIONS(659),
    [anon_sym_PLUS_PLUS] = ACTIONS(659),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_LBRACK] = ACTIONS(659),
    [anon_sym_LT_LT] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(659),
    [anon_sym_LT_EQ] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(659),
    [anon_sym_RBRACK] = ACTIONS(659),
    [anon_sym_GT] = ACTIONS(661),
    [anon_sym_AMP] = ACTIONS(661),
    [anon_sym_QMARK] = ACTIONS(659),
    [anon_sym_PIPE_PIPE] = ACTIONS(659),
    [anon_sym_EQ_EQ] = ACTIONS(661),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LT] = ACTIONS(661),
    [anon_sym_SLASH] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(659),
    [anon_sym_PLUS] = ACTIONS(661),
    [anon_sym_implements] = ACTIONS(659),
    [anon_sym_GT_GT] = ACTIONS(661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(659),
  },
  [1261] = {
    [sym_arrow_function] = STATE(1347),
    [sym_await_expression] = STATE(1347),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1346),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1347),
    [sym_meta_property] = STATE(1347),
    [sym__expression] = STATE(1347),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1347),
    [sym_call_expression] = STATE(1347),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1347),
    [sym_string] = STATE(1347),
    [sym_template_string] = STATE(1347),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1347),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1347),
    [sym_generator_function] = STATE(1347),
    [sym_new_expression] = STATE(1347),
    [sym_assignment_expression] = STATE(1347),
    [sym_augmented_assignment_expression] = STATE(1347),
    [sym_binary_expression] = STATE(1347),
    [sym_unary_expression] = STATE(1347),
    [sym_regex] = STATE(1347),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1347),
    [sym_as_expression] = STATE(1347),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1347),
    [sym_class] = STATE(1347),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4228),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4228),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4228),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4228),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4230),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4228),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1262] = {
    [sym_arrow_function] = STATE(1348),
    [sym_await_expression] = STATE(1348),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1348),
    [sym_meta_property] = STATE(1348),
    [sym__expression] = STATE(1348),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1348),
    [sym_call_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1348),
    [sym_string] = STATE(1348),
    [sym_template_string] = STATE(1348),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1348),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1348),
    [sym_generator_function] = STATE(1348),
    [sym_new_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1348),
    [sym_augmented_assignment_expression] = STATE(1348),
    [sym_binary_expression] = STATE(1348),
    [sym_unary_expression] = STATE(1348),
    [sym_regex] = STATE(1348),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1348),
    [sym_as_expression] = STATE(1348),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1348),
    [sym_class] = STATE(1348),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4232),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4232),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4232),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4232),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4234),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4232),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1263] = {
    [sym_arrow_function] = STATE(1349),
    [sym_await_expression] = STATE(1349),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1349),
    [sym_meta_property] = STATE(1349),
    [sym__expression] = STATE(1349),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1349),
    [sym_call_expression] = STATE(1349),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1349),
    [sym_string] = STATE(1349),
    [sym_template_string] = STATE(1349),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1349),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1349),
    [sym_generator_function] = STATE(1349),
    [sym_new_expression] = STATE(1349),
    [sym_assignment_expression] = STATE(1349),
    [sym_augmented_assignment_expression] = STATE(1349),
    [sym_binary_expression] = STATE(1349),
    [sym_unary_expression] = STATE(1349),
    [sym_regex] = STATE(1349),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1349),
    [sym_as_expression] = STATE(1349),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1349),
    [sym_class] = STATE(1349),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4236),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4236),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4236),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4236),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4238),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4236),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1264] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1265] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1266] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1267] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1837),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1268] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(231),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(231),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(231),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_PERCENT] = ACTIONS(231),
    [anon_sym_LBRACE_PIPE] = ACTIONS(231),
    [anon_sym_as] = ACTIONS(231),
    [anon_sym_DASH_DASH] = ACTIONS(231),
    [anon_sym_instanceof] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_DOT] = ACTIONS(231),
    [anon_sym_STAR_STAR] = ACTIONS(231),
    [anon_sym_PLUS_PLUS] = ACTIONS(231),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_LT_LT] = ACTIONS(231),
    [anon_sym_LBRACE] = ACTIONS(235),
    [anon_sym_AMP_AMP] = ACTIONS(231),
    [anon_sym_LT_EQ] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(231),
    [anon_sym_GT] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_QMARK] = ACTIONS(231),
    [anon_sym_PIPE_PIPE] = ACTIONS(231),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(231),
    [anon_sym_LT] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(231),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_implements] = ACTIONS(231),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(231),
  },
  [1269] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1270] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
  },
  [1271] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
  },
  [1272] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(766),
    [anon_sym_BQUOTE] = ACTIONS(766),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(768),
    [anon_sym_GT_GT_GT] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(768),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_PERCENT] = ACTIONS(766),
    [anon_sym_LBRACE_PIPE] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(766),
    [anon_sym_DASH_DASH] = ACTIONS(766),
    [anon_sym_instanceof] = ACTIONS(766),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(766),
    [anon_sym_STAR_STAR] = ACTIONS(766),
    [anon_sym_PLUS_PLUS] = ACTIONS(766),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_BANG] = ACTIONS(768),
    [anon_sym_LBRACK] = ACTIONS(766),
    [anon_sym_LT_LT] = ACTIONS(766),
    [anon_sym_LBRACE] = ACTIONS(768),
    [anon_sym_AMP_AMP] = ACTIONS(766),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_LPAREN] = ACTIONS(766),
    [anon_sym_RBRACK] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_QMARK] = ACTIONS(766),
    [anon_sym_PIPE_PIPE] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(768),
    [anon_sym_RPAREN] = ACTIONS(766),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_implements] = ACTIONS(766),
    [anon_sym_GT_GT] = ACTIONS(768),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(766),
  },
  [1273] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(786),
    [anon_sym_BQUOTE] = ACTIONS(786),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(788),
    [anon_sym_STAR] = ACTIONS(788),
    [anon_sym_GT_GT_GT] = ACTIONS(786),
    [anon_sym_BANG_EQ] = ACTIONS(788),
    [anon_sym_GT_EQ] = ACTIONS(786),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_PERCENT] = ACTIONS(786),
    [anon_sym_LBRACE_PIPE] = ACTIONS(786),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(786),
    [anon_sym_instanceof] = ACTIONS(786),
    [anon_sym_COLON] = ACTIONS(786),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(786),
    [anon_sym_PLUS_PLUS] = ACTIONS(786),
    [anon_sym_in] = ACTIONS(788),
    [anon_sym_BANG] = ACTIONS(788),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(786),
    [anon_sym_LBRACE] = ACTIONS(788),
    [anon_sym_AMP_AMP] = ACTIONS(786),
    [anon_sym_LT_EQ] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(786),
    [anon_sym_RBRACK] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_QMARK] = ACTIONS(786),
    [anon_sym_PIPE_PIPE] = ACTIONS(786),
    [anon_sym_EQ_EQ] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_LT] = ACTIONS(788),
    [anon_sym_SLASH] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(788),
    [anon_sym_implements] = ACTIONS(786),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(786),
  },
  [1274] = {
    [sym_arrow_function] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym__expression] = STATE(1361),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1361),
    [sym_call_expression] = STATE(1361),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1361),
    [sym_string] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1361),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1361),
    [sym_generator_function] = STATE(1361),
    [sym_new_expression] = STATE(1361),
    [sym_assignment_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_regex] = STATE(1361),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1361),
    [sym_class] = STATE(1361),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4245),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4245),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4245),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4245),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4247),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4245),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1275] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(798),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(798),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(798),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1276] = {
    [sym_statement_block] = STATE(1362),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_debugger] = ACTIONS(832),
    [anon_sym_symbol] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_break] = ACTIONS(832),
    [anon_sym_const] = ACTIONS(832),
    [sym_super] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(832),
    [anon_sym_private] = ACTIONS(832),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_get] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_interface] = ACTIONS(832),
    [anon_sym_default] = ACTIONS(832),
    [anon_sym_enum] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(832),
    [anon_sym_continue] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_if] = ACTIONS(832),
    [sym_this] = ACTIONS(832),
    [anon_sym_yield] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [anon_sym_throw] = ACTIONS(832),
    [anon_sym_protected] = ACTIONS(832),
    [anon_sym_abstract] = ACTIONS(832),
    [anon_sym_DOT] = ACTIONS(2408),
    [anon_sym_set] = ACTIONS(832),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [sym_false] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_case] = ACTIONS(832),
    [anon_sym_module] = ACTIONS(832),
    [anon_sym_number] = ACTIONS(832),
    [anon_sym_class] = ACTIONS(832),
    [anon_sym_declare] = ACTIONS(832),
    [anon_sym_typeof] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_LPAREN] = ACTIONS(830),
    [sym_null] = ACTIONS(832),
    [anon_sym_any] = ACTIONS(832),
    [anon_sym_boolean] = ACTIONS(832),
    [anon_sym_async] = ACTIONS(832),
    [anon_sym_public] = ACTIONS(832),
    [anon_sym_var] = ACTIONS(832),
    [anon_sym_while] = ACTIONS(832),
    [anon_sym_SQUOTE] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(830),
    [sym_number] = ACTIONS(830),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(832),
    [anon_sym_function] = ACTIONS(832),
    [sym_undefined] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(832),
    [ts_builtin_sym_end] = ACTIONS(830),
    [anon_sym_let] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_export] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_with] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(832),
  },
  [1277] = {
    [sym_statement_block] = STATE(1362),
    [sym_identifier] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_debugger] = ACTIONS(832),
    [anon_sym_symbol] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_void] = ACTIONS(832),
    [anon_sym_break] = ACTIONS(832),
    [anon_sym_const] = ACTIONS(832),
    [sym_super] = ACTIONS(832),
    [anon_sym_return] = ACTIONS(832),
    [anon_sym_private] = ACTIONS(832),
    [anon_sym_static] = ACTIONS(832),
    [anon_sym_get] = ACTIONS(832),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_interface] = ACTIONS(832),
    [anon_sym_default] = ACTIONS(832),
    [anon_sym_enum] = ACTIONS(832),
    [anon_sym_delete] = ACTIONS(832),
    [anon_sym_continue] = ACTIONS(832),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_if] = ACTIONS(832),
    [sym_this] = ACTIONS(832),
    [anon_sym_yield] = ACTIONS(832),
    [sym_true] = ACTIONS(832),
    [anon_sym_throw] = ACTIONS(832),
    [anon_sym_protected] = ACTIONS(832),
    [anon_sym_abstract] = ACTIONS(832),
    [anon_sym_set] = ACTIONS(832),
    [anon_sym_type] = ACTIONS(832),
    [anon_sym_import] = ACTIONS(832),
    [anon_sym_namespace] = ACTIONS(832),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [anon_sym_else] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(830),
    [anon_sym_for] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [sym_false] = ACTIONS(832),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_case] = ACTIONS(832),
    [anon_sym_module] = ACTIONS(832),
    [anon_sym_number] = ACTIONS(832),
    [anon_sym_class] = ACTIONS(832),
    [anon_sym_declare] = ACTIONS(832),
    [anon_sym_typeof] = ACTIONS(832),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_switch] = ACTIONS(832),
    [anon_sym_LPAREN] = ACTIONS(830),
    [sym_null] = ACTIONS(832),
    [anon_sym_any] = ACTIONS(832),
    [anon_sym_boolean] = ACTIONS(832),
    [anon_sym_async] = ACTIONS(832),
    [anon_sym_public] = ACTIONS(832),
    [anon_sym_var] = ACTIONS(832),
    [anon_sym_while] = ACTIONS(832),
    [anon_sym_SQUOTE] = ACTIONS(830),
    [anon_sym_try] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(830),
    [sym_number] = ACTIONS(830),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(832),
    [anon_sym_function] = ACTIONS(832),
    [sym_undefined] = ACTIONS(832),
    [anon_sym_new] = ACTIONS(832),
    [ts_builtin_sym_end] = ACTIONS(830),
    [anon_sym_let] = ACTIONS(832),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_export] = ACTIONS(832),
    [anon_sym_do] = ACTIONS(832),
    [anon_sym_TILDE] = ACTIONS(830),
    [anon_sym_with] = ACTIONS(832),
    [anon_sym_await] = ACTIONS(832),
  },
  [1278] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [sym__automatic_semicolon] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1279] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(842),
    [sym__automatic_semicolon] = ACTIONS(842),
    [anon_sym_BQUOTE] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_GT_GT_GT] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(844),
    [anon_sym_BANG_EQ] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_static] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_PERCENT] = ACTIONS(842),
    [anon_sym_interface] = ACTIONS(844),
    [anon_sym_as] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_instanceof] = ACTIONS(844),
    [anon_sym_yield] = ACTIONS(844),
    [sym_true] = ACTIONS(844),
    [anon_sym_protected] = ACTIONS(844),
    [anon_sym_DOT] = ACTIONS(844),
    [anon_sym_set] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(844),
    [anon_sym_in] = ACTIONS(844),
    [anon_sym_DQUOTE] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_LT_LT] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(842),
    [anon_sym_AMP_AMP] = ACTIONS(842),
    [anon_sym_switch] = ACTIONS(844),
    [anon_sym_LT_EQ] = ACTIONS(842),
    [sym_null] = ACTIONS(844),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_async] = ACTIONS(844),
    [anon_sym_public] = ACTIONS(844),
    [anon_sym_var] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(844),
    [anon_sym_CARET] = ACTIONS(842),
    [anon_sym_export] = ACTIONS(844),
    [anon_sym_GT_GT] = ACTIONS(844),
    [anon_sym_with] = ACTIONS(844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(842),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_debugger] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(842),
    [anon_sym_COMMA] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(844),
    [anon_sym_GT_EQ] = ACTIONS(842),
    [sym_super] = ACTIONS(844),
    [anon_sym_private] = ACTIONS(844),
    [anon_sym_get] = ACTIONS(844),
    [anon_sym_default] = ACTIONS(844),
    [anon_sym_enum] = ACTIONS(844),
    [anon_sym_continue] = ACTIONS(844),
    [anon_sym_DASH_DASH] = ACTIONS(842),
    [sym_this] = ACTIONS(844),
    [anon_sym_throw] = ACTIONS(844),
    [anon_sym_abstract] = ACTIONS(844),
    [anon_sym_type] = ACTIONS(844),
    [anon_sym_STAR_STAR] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(842),
    [sym_false] = ACTIONS(844),
    [anon_sym_case] = ACTIONS(844),
    [anon_sym_module] = ACTIONS(844),
    [anon_sym_class] = ACTIONS(844),
    [anon_sym_declare] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_AMP] = ACTIONS(844),
    [anon_sym_PIPE_PIPE] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(844),
    [anon_sym_EQ_EQ] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(844),
    [sym_number] = ACTIONS(842),
    [ts_builtin_sym_end] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [sym_undefined] = ACTIONS(844),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_await] = ACTIONS(844),
  },
  [1280] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
  },
  [1281] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(878),
    [anon_sym_BQUOTE] = ACTIONS(878),
    [anon_sym_PIPE] = ACTIONS(880),
    [anon_sym_COMMA] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(880),
    [anon_sym_GT_GT_GT] = ACTIONS(878),
    [anon_sym_EQ] = ACTIONS(880),
    [anon_sym_BANG_EQ] = ACTIONS(880),
    [anon_sym_GT_EQ] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_PERCENT] = ACTIONS(878),
    [anon_sym_LBRACE_PIPE] = ACTIONS(878),
    [anon_sym_as] = ACTIONS(878),
    [anon_sym_DASH_DASH] = ACTIONS(878),
    [anon_sym_instanceof] = ACTIONS(878),
    [anon_sym_COLON] = ACTIONS(878),
    [anon_sym_DOT] = ACTIONS(878),
    [anon_sym_STAR_STAR] = ACTIONS(878),
    [anon_sym_PLUS_PLUS] = ACTIONS(878),
    [anon_sym_in] = ACTIONS(880),
    [anon_sym_BANG] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(878),
    [anon_sym_LT_LT] = ACTIONS(878),
    [anon_sym_LBRACE] = ACTIONS(880),
    [anon_sym_AMP_AMP] = ACTIONS(878),
    [anon_sym_of] = ACTIONS(878),
    [anon_sym_LT_EQ] = ACTIONS(878),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_RBRACK] = ACTIONS(878),
    [anon_sym_GT] = ACTIONS(880),
    [anon_sym_AMP] = ACTIONS(880),
    [anon_sym_QMARK] = ACTIONS(878),
    [anon_sym_PIPE_PIPE] = ACTIONS(878),
    [anon_sym_EQ_EQ] = ACTIONS(880),
    [anon_sym_RPAREN] = ACTIONS(878),
    [anon_sym_LT] = ACTIONS(880),
    [anon_sym_SLASH] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(878),
    [anon_sym_PLUS] = ACTIONS(880),
    [anon_sym_implements] = ACTIONS(878),
    [anon_sym_GT_GT] = ACTIONS(880),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(878),
  },
  [1282] = {
    [sym__automatic_semicolon] = ACTIONS(920),
    [anon_sym_RBRACE] = ACTIONS(920),
    [anon_sym_SEMI] = ACTIONS(920),
    [anon_sym_COMMA] = ACTIONS(920),
    [anon_sym_PIPE_RBRACE] = ACTIONS(920),
    [sym_comment] = ACTIONS(3),
  },
  [1283] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(988),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(990),
    [anon_sym_COMMA] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_STAR] = ACTIONS(990),
    [anon_sym_GT_GT_GT] = ACTIONS(988),
    [anon_sym_BANG_EQ] = ACTIONS(990),
    [anon_sym_GT_EQ] = ACTIONS(988),
    [anon_sym_RBRACE] = ACTIONS(988),
    [anon_sym_PERCENT] = ACTIONS(988),
    [anon_sym_LBRACE_PIPE] = ACTIONS(988),
    [anon_sym_as] = ACTIONS(988),
    [anon_sym_DASH_DASH] = ACTIONS(988),
    [anon_sym_instanceof] = ACTIONS(988),
    [anon_sym_COLON] = ACTIONS(988),
    [anon_sym_DOT] = ACTIONS(988),
    [anon_sym_STAR_STAR] = ACTIONS(988),
    [anon_sym_PLUS_PLUS] = ACTIONS(988),
    [anon_sym_in] = ACTIONS(990),
    [anon_sym_BANG] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(988),
    [anon_sym_LT_LT] = ACTIONS(988),
    [anon_sym_LBRACE] = ACTIONS(990),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_LT_EQ] = ACTIONS(988),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_RBRACK] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(990),
    [anon_sym_AMP] = ACTIONS(990),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_EQ_EQ] = ACTIONS(990),
    [anon_sym_RPAREN] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(990),
    [anon_sym_SLASH] = ACTIONS(990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(988),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_implements] = ACTIONS(988),
    [anon_sym_GT_GT] = ACTIONS(990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(988),
  },
  [1284] = {
    [sym_string] = STATE(2246),
    [sym_nested_identifier] = STATE(2245),
    [sym__module] = STATE(1282),
    [sym_identifier] = ACTIONS(4249),
    [anon_sym_DOT] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1285] = {
    [sym_class_declaration] = STATE(1287),
    [sym_generator_function_declaration] = STATE(1287),
    [sym__declaration] = STATE(1287),
    [sym_enum_declaration] = STATE(1287),
    [sym_function_signature] = STATE(1287),
    [sym_abstract_class_declaration] = STATE(1287),
    [sym_module] = STATE(1287),
    [sym_interface_declaration] = STATE(1287),
    [sym_function_declaration] = STATE(1287),
    [sym_variable_declaration] = STATE(1287),
    [sym_lexical_declaration] = STATE(1287),
    [sym_ambient_declaration] = STATE(1287),
    [sym_import_alias] = STATE(1287),
    [sym_type_alias_declaration] = STATE(1287),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1287),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_module] = ACTIONS(4253),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_global] = ACTIONS(4255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2362),
  },
  [1286] = {
    [sym_string] = STATE(2246),
    [sym_nested_identifier] = STATE(2245),
    [sym__module] = STATE(131),
    [sym_identifier] = ACTIONS(4249),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1287] = {
    [sym__automatic_semicolon] = ACTIONS(1010),
    [anon_sym_RBRACE] = ACTIONS(1010),
    [anon_sym_SEMI] = ACTIONS(1010),
    [anon_sym_COMMA] = ACTIONS(1010),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
  },
  [1288] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1071),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
  },
  [1289] = {
    [sym_arrow_function] = STATE(1894),
    [sym_await_expression] = STATE(1894),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1894),
    [sym_meta_property] = STATE(1894),
    [sym__expression] = STATE(1894),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1894),
    [sym_call_expression] = STATE(1894),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(1809),
    [sym_ternary_expression] = STATE(1894),
    [sym_string] = STATE(1894),
    [sym_template_string] = STATE(1894),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1894),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1894),
    [sym_generator_function] = STATE(1894),
    [sym_new_expression] = STATE(1894),
    [sym_assignment_expression] = STATE(1894),
    [sym_augmented_assignment_expression] = STATE(1894),
    [sym_binary_expression] = STATE(1894),
    [sym_unary_expression] = STATE(1894),
    [sym_regex] = STATE(1894),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(1810),
    [sym_non_null_expression] = STATE(1894),
    [sym_as_expression] = STATE(1894),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1894),
    [sym_class] = STATE(1894),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4257),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [sym_null] = ACTIONS(4257),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4257),
    [sym_number] = ACTIONS(4259),
    [sym_true] = ACTIONS(4257),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4257),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [1290] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1130),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1291] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1292] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [1293] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1294] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1837),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1295] = {
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [sym__automatic_semicolon] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1167),
  },
  [1296] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1127),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2452),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1297] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1141),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1144),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1141),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(1141),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2272),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1187),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2274),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1299] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(1203),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2276),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1300] = {
    [sym_optional_parameter] = STATE(1832),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(1832),
    [aux_sym_export_statement_repeat1] = STATE(1901),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(1832),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [1301] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [sym__automatic_semicolon] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_BQUOTE] = ACTIONS(1252),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1252),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_GT_GT_GT] = ACTIONS(1252),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_PERCENT] = ACTIONS(1252),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1252),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_instanceof] = ACTIONS(1252),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1252),
    [anon_sym_CARET] = ACTIONS(1252),
    [anon_sym_STAR_STAR] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_PLUS_PLUS] = ACTIONS(1252),
    [anon_sym_in] = ACTIONS(1254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BANG] = ACTIONS(1254),
  },
  [1302] = {
    [sym_array_type] = STATE(1394),
    [sym_generic_type] = STATE(1394),
    [sym_type_predicate] = STATE(1394),
    [sym_literal_type] = STATE(1394),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1394),
    [sym__primary_type] = STATE(1394),
    [sym_lookup_type] = STATE(1394),
    [sym_parenthesized_type] = STATE(1394),
    [sym_nested_identifier] = STATE(2256),
    [sym_predefined_type] = STATE(1394),
    [sym_nested_type_identifier] = STATE(1308),
    [sym_tuple_type] = STATE(1394),
    [sym_type_query] = STATE(1394),
    [sym_index_type_query] = STATE(1394),
    [sym_existential_type] = STATE(1394),
    [sym_flow_maybe_type] = STATE(1394),
    [sym_string] = STATE(1301),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(4263),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(4265),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1303] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1396),
    [sym_function_type] = STATE(1396),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1396),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1396),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1396),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1304] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [sym__automatic_semicolon] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_STAR] = ACTIONS(1284),
    [anon_sym_GT_GT_GT] = ACTIONS(1282),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_BANG_EQ] = ACTIONS(1284),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1284),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1284),
    [anon_sym_instanceof] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_CARET] = ACTIONS(1282),
    [anon_sym_STAR_STAR] = ACTIONS(1282),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_GT_GT] = ACTIONS(1284),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [anon_sym_in] = ACTIONS(1284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BANG] = ACTIONS(1284),
  },
  [1305] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_BANG_EQ] = ACTIONS(1292),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1292),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BANG] = ACTIONS(1292),
  },
  [1306] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1403),
    [sym_function_type] = STATE(1403),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1403),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1403),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1403),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1307] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(4267),
    [sym__automatic_semicolon] = ACTIONS(1308),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_GT_GT_GT] = ACTIONS(1308),
    [anon_sym_AMP_AMP] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_BANG_EQ] = ACTIONS(1310),
    [anon_sym_LT_EQ] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_GT_EQ] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_PERCENT] = ACTIONS(1308),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_as] = ACTIONS(1308),
    [anon_sym_PIPE_PIPE] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_EQ_EQ] = ACTIONS(1310),
    [anon_sym_instanceof] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1308),
    [anon_sym_CARET] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_GT_GT] = ACTIONS(1310),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_in] = ACTIONS(1310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(1310),
  },
  [1308] = {
    [sym_type_arguments] = STATE(1405),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [sym__automatic_semicolon] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1314),
    [anon_sym_BQUOTE] = ACTIONS(1314),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_LT_LT] = ACTIONS(1314),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_GT_GT_GT] = ACTIONS(1314),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_BANG_EQ] = ACTIONS(1316),
    [anon_sym_LT_EQ] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_GT_EQ] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_PERCENT] = ACTIONS(1314),
    [anon_sym_QMARK] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [anon_sym_EQ_EQ] = ACTIONS(1316),
    [anon_sym_instanceof] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(4269),
    [anon_sym_SLASH] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1314),
    [anon_sym_CARET] = ACTIONS(1314),
    [anon_sym_STAR_STAR] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_GT_GT] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [anon_sym_in] = ACTIONS(1316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1314),
    [anon_sym_BANG] = ACTIONS(1316),
  },
  [1309] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1310] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1311] = {
    [sym_arguments] = STATE(1413),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [1312] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(1413),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(1346),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [1313] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1413),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1837),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [1314] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(1413),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_RBRACE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_RPAREN] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [1315] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1316] = {
    [sym_arguments] = STATE(1414),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1317] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1318] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [anon_sym_PERCENT] = ACTIONS(1336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_DOT] = ACTIONS(1336),
    [anon_sym_STAR_STAR] = ACTIONS(1336),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_LT_LT] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [1319] = {
    [sym_string] = STATE(2246),
    [sym_nested_identifier] = STATE(2245),
    [sym__module] = STATE(1282),
    [sym_identifier] = ACTIONS(4249),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(83),
  },
  [1320] = {
    [sym__automatic_semicolon] = ACTIONS(1436),
    [anon_sym_RBRACE] = ACTIONS(1436),
    [anon_sym_SEMI] = ACTIONS(1436),
    [anon_sym_COMMA] = ACTIONS(1436),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
  },
  [1321] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1442),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1322] = {
    [sym_arrow_function] = STATE(1417),
    [sym_await_expression] = STATE(1417),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1417),
    [sym_meta_property] = STATE(1417),
    [sym__expression] = STATE(1417),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1417),
    [sym_call_expression] = STATE(1417),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1417),
    [sym_string] = STATE(1417),
    [sym_template_string] = STATE(1417),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1417),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1417),
    [sym_generator_function] = STATE(1417),
    [sym_new_expression] = STATE(1417),
    [sym_assignment_expression] = STATE(1417),
    [sym_augmented_assignment_expression] = STATE(1417),
    [sym_binary_expression] = STATE(1417),
    [sym_unary_expression] = STATE(1417),
    [sym_regex] = STATE(1417),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1417),
    [sym_as_expression] = STATE(1417),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1417),
    [sym_class] = STATE(1417),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4272),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4272),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4272),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4272),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4274),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4272),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1323] = {
    [sym_arrow_function] = STATE(1418),
    [sym_await_expression] = STATE(1418),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1418),
    [sym_meta_property] = STATE(1418),
    [sym__expression] = STATE(1418),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1418),
    [sym_call_expression] = STATE(1418),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1418),
    [sym_string] = STATE(1418),
    [sym_template_string] = STATE(1418),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1418),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1418),
    [sym_generator_function] = STATE(1418),
    [sym_new_expression] = STATE(1418),
    [sym_assignment_expression] = STATE(1418),
    [sym_augmented_assignment_expression] = STATE(1418),
    [sym_binary_expression] = STATE(1418),
    [sym_unary_expression] = STATE(1418),
    [sym_regex] = STATE(1418),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1418),
    [sym_as_expression] = STATE(1418),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1418),
    [sym_class] = STATE(1418),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4276),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4276),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4276),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4276),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4278),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4276),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1324] = {
    [sym_arrow_function] = STATE(1419),
    [sym_await_expression] = STATE(1419),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1419),
    [sym_meta_property] = STATE(1419),
    [sym__expression] = STATE(1419),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1419),
    [sym_call_expression] = STATE(1419),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1419),
    [sym_string] = STATE(1419),
    [sym_template_string] = STATE(1419),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1419),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1419),
    [sym_generator_function] = STATE(1419),
    [sym_new_expression] = STATE(1419),
    [sym_assignment_expression] = STATE(1419),
    [sym_augmented_assignment_expression] = STATE(1419),
    [sym_binary_expression] = STATE(1419),
    [sym_unary_expression] = STATE(1419),
    [sym_regex] = STATE(1419),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1419),
    [sym_as_expression] = STATE(1419),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1419),
    [sym_class] = STATE(1419),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4280),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4280),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4280),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4280),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4282),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4280),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1325] = {
    [sym_arrow_function] = STATE(1420),
    [sym_await_expression] = STATE(1420),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1420),
    [sym_meta_property] = STATE(1420),
    [sym__expression] = STATE(1420),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1420),
    [sym_call_expression] = STATE(1420),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1420),
    [sym_string] = STATE(1420),
    [sym_template_string] = STATE(1420),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1420),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1420),
    [sym_generator_function] = STATE(1420),
    [sym_new_expression] = STATE(1420),
    [sym_assignment_expression] = STATE(1420),
    [sym_augmented_assignment_expression] = STATE(1420),
    [sym_binary_expression] = STATE(1420),
    [sym_unary_expression] = STATE(1420),
    [sym_regex] = STATE(1420),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1420),
    [sym_as_expression] = STATE(1420),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1420),
    [sym_class] = STATE(1420),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4284),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4284),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4284),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4284),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4286),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4284),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1326] = {
    [sym_arrow_function] = STATE(1421),
    [sym_await_expression] = STATE(1421),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1421),
    [sym_meta_property] = STATE(1421),
    [sym__expression] = STATE(1421),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1421),
    [sym_call_expression] = STATE(1421),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1421),
    [sym_string] = STATE(1421),
    [sym_template_string] = STATE(1421),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1421),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1421),
    [sym_generator_function] = STATE(1421),
    [sym_new_expression] = STATE(1421),
    [sym_assignment_expression] = STATE(1421),
    [sym_augmented_assignment_expression] = STATE(1421),
    [sym_binary_expression] = STATE(1421),
    [sym_unary_expression] = STATE(1421),
    [sym_regex] = STATE(1421),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1421),
    [sym_as_expression] = STATE(1421),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1421),
    [sym_class] = STATE(1421),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4288),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4288),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4288),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4290),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4288),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1327] = {
    [sym_arrow_function] = STATE(1423),
    [sym_await_expression] = STATE(1423),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1422),
    [sym_meta_property] = STATE(1423),
    [sym_update_expression] = STATE(1423),
    [sym__expression] = STATE(1423),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1423),
    [sym_call_expression] = STATE(1423),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1423),
    [sym_string] = STATE(1423),
    [sym_template_string] = STATE(1423),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1423),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1423),
    [sym_generator_function] = STATE(1423),
    [sym_new_expression] = STATE(1423),
    [sym_assignment_expression] = STATE(1423),
    [sym_augmented_assignment_expression] = STATE(1423),
    [sym_binary_expression] = STATE(1423),
    [sym_unary_expression] = STATE(1423),
    [sym_regex] = STATE(1423),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1423),
    [sym_as_expression] = STATE(1423),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1423),
    [sym_class] = STATE(1423),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4292),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4292),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4292),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4292),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4294),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4292),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1328] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1510),
    [anon_sym_PIPE] = ACTIONS(1512),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_GT_GT_GT] = ACTIONS(1510),
    [anon_sym_BANG_EQ] = ACTIONS(1512),
    [anon_sym_GT_EQ] = ACTIONS(1510),
    [anon_sym_RBRACE] = ACTIONS(1510),
    [anon_sym_PERCENT] = ACTIONS(1510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1510),
    [anon_sym_as] = ACTIONS(1510),
    [anon_sym_DASH_DASH] = ACTIONS(1510),
    [anon_sym_instanceof] = ACTIONS(1510),
    [anon_sym_COLON] = ACTIONS(1510),
    [anon_sym_DOT] = ACTIONS(1510),
    [anon_sym_STAR_STAR] = ACTIONS(1510),
    [anon_sym_PLUS_PLUS] = ACTIONS(1510),
    [anon_sym_in] = ACTIONS(1512),
    [anon_sym_BANG] = ACTIONS(1512),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_LT_LT] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_AMP_AMP] = ACTIONS(1510),
    [anon_sym_LT_EQ] = ACTIONS(1510),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_RBRACK] = ACTIONS(1510),
    [anon_sym_GT] = ACTIONS(1512),
    [anon_sym_AMP] = ACTIONS(1512),
    [anon_sym_QMARK] = ACTIONS(1510),
    [anon_sym_PIPE_PIPE] = ACTIONS(1510),
    [anon_sym_EQ_EQ] = ACTIONS(1512),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [anon_sym_LT] = ACTIONS(1512),
    [anon_sym_SLASH] = ACTIONS(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_implements] = ACTIONS(1510),
    [anon_sym_GT_GT] = ACTIONS(1512),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1510),
  },
  [1329] = {
    [sym_await_expression] = STATE(1417),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(1417),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(1417),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(1417),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1417),
    [sym_call_expression] = STATE(1417),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(1417),
    [sym_template_string] = STATE(1417),
    [sym_yield_expression] = STATE(1417),
    [sym_type_assertion] = STATE(1417),
    [sym_new_expression] = STATE(1417),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(1417),
    [sym_binary_expression] = STATE(1417),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(1252),
    [sym_as_expression] = STATE(1417),
    [sym_internal_module] = STATE(1417),
    [sym_arrow_function] = STATE(1417),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1427),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(1256),
    [sym_generator_function] = STATE(1417),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(1417),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(1417),
    [sym_regex] = STATE(1417),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_non_null_expression] = STATE(1417),
    [sym_class] = STATE(1417),
    [sym_identifier] = ACTIONS(4296),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4298),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(4300),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(4302),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4304),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4306),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(4306),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(4298),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(4308),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(4272),
    [anon_sym_any] = ACTIONS(4298),
    [anon_sym_boolean] = ACTIONS(4298),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4312),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4298),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4272),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(4300),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1330] = {
    [sym_arrow_function] = STATE(1435),
    [sym_await_expression] = STATE(1435),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1435),
    [sym_meta_property] = STATE(1435),
    [sym__expression] = STATE(1435),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1435),
    [sym_call_expression] = STATE(1435),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1435),
    [sym_string] = STATE(1435),
    [sym_template_string] = STATE(1435),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1435),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1435),
    [sym_generator_function] = STATE(1435),
    [sym_new_expression] = STATE(1435),
    [sym_assignment_expression] = STATE(1435),
    [sym_augmented_assignment_expression] = STATE(1435),
    [sym_binary_expression] = STATE(1435),
    [sym_unary_expression] = STATE(1435),
    [sym_regex] = STATE(1435),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1435),
    [sym_as_expression] = STATE(1435),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1435),
    [sym_class] = STATE(1435),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4314),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4314),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4314),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4314),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4316),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4314),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1331] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1542),
    [anon_sym_PIPE] = ACTIONS(1544),
    [anon_sym_COMMA] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_GT_GT_GT] = ACTIONS(1542),
    [anon_sym_BANG_EQ] = ACTIONS(1544),
    [anon_sym_GT_EQ] = ACTIONS(1542),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [anon_sym_PERCENT] = ACTIONS(1542),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1542),
    [anon_sym_as] = ACTIONS(1542),
    [anon_sym_DASH_DASH] = ACTIONS(1542),
    [anon_sym_instanceof] = ACTIONS(1542),
    [anon_sym_COLON] = ACTIONS(1542),
    [anon_sym_DOT] = ACTIONS(1542),
    [anon_sym_STAR_STAR] = ACTIONS(1542),
    [anon_sym_PLUS_PLUS] = ACTIONS(1542),
    [anon_sym_in] = ACTIONS(1544),
    [anon_sym_BANG] = ACTIONS(1544),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_LT_LT] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1542),
    [anon_sym_LT_EQ] = ACTIONS(1542),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_RBRACK] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(1544),
    [anon_sym_QMARK] = ACTIONS(1542),
    [anon_sym_PIPE_PIPE] = ACTIONS(1542),
    [anon_sym_EQ_EQ] = ACTIONS(1544),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_LT] = ACTIONS(1544),
    [anon_sym_SLASH] = ACTIONS(1544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_implements] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1542),
  },
  [1332] = {
    [sym_arrow_function] = STATE(1436),
    [sym_await_expression] = STATE(1436),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1436),
    [sym_meta_property] = STATE(1436),
    [sym__expression] = STATE(1436),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1436),
    [sym_call_expression] = STATE(1436),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1436),
    [sym_string] = STATE(1436),
    [sym_template_string] = STATE(1436),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1436),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1436),
    [sym_generator_function] = STATE(1436),
    [sym_new_expression] = STATE(1436),
    [sym_assignment_expression] = STATE(1436),
    [sym_augmented_assignment_expression] = STATE(1436),
    [sym_binary_expression] = STATE(1436),
    [sym_unary_expression] = STATE(1436),
    [sym_regex] = STATE(1436),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1436),
    [sym_as_expression] = STATE(1436),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1436),
    [sym_class] = STATE(1436),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4318),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4318),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4318),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4318),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4320),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4318),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1333] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(1550),
    [anon_sym_PIPE] = ACTIONS(1552),
    [anon_sym_COMMA] = ACTIONS(1550),
    [anon_sym_DASH] = ACTIONS(1552),
    [anon_sym_STAR] = ACTIONS(1552),
    [anon_sym_GT_GT_GT] = ACTIONS(1550),
    [anon_sym_BANG_EQ] = ACTIONS(1552),
    [anon_sym_GT_EQ] = ACTIONS(1550),
    [anon_sym_RBRACE] = ACTIONS(1550),
    [anon_sym_PERCENT] = ACTIONS(1550),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1550),
    [anon_sym_as] = ACTIONS(1550),
    [anon_sym_DASH_DASH] = ACTIONS(1550),
    [anon_sym_instanceof] = ACTIONS(1550),
    [anon_sym_COLON] = ACTIONS(1550),
    [anon_sym_DOT] = ACTIONS(1550),
    [anon_sym_STAR_STAR] = ACTIONS(1550),
    [anon_sym_PLUS_PLUS] = ACTIONS(1550),
    [anon_sym_in] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1550),
    [anon_sym_LT_LT] = ACTIONS(1550),
    [anon_sym_LBRACE] = ACTIONS(1552),
    [anon_sym_AMP_AMP] = ACTIONS(1550),
    [anon_sym_LT_EQ] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1550),
    [anon_sym_RBRACK] = ACTIONS(1550),
    [anon_sym_GT] = ACTIONS(1552),
    [anon_sym_AMP] = ACTIONS(1552),
    [anon_sym_QMARK] = ACTIONS(1550),
    [anon_sym_PIPE_PIPE] = ACTIONS(1550),
    [anon_sym_EQ_EQ] = ACTIONS(1552),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_LT] = ACTIONS(1552),
    [anon_sym_SLASH] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1550),
    [anon_sym_PLUS] = ACTIONS(1552),
    [anon_sym_implements] = ACTIONS(1550),
    [anon_sym_GT_GT] = ACTIONS(1552),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1550),
  },
  [1334] = {
    [sym_arrow_function] = STATE(1438),
    [sym_await_expression] = STATE(1438),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1437),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1438),
    [sym_meta_property] = STATE(1438),
    [sym__expression] = STATE(1438),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1438),
    [sym_call_expression] = STATE(1438),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1438),
    [sym_string] = STATE(1438),
    [sym_template_string] = STATE(1438),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1438),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1438),
    [sym_generator_function] = STATE(1438),
    [sym_new_expression] = STATE(1438),
    [sym_assignment_expression] = STATE(1438),
    [sym_augmented_assignment_expression] = STATE(1438),
    [sym_binary_expression] = STATE(1438),
    [sym_unary_expression] = STATE(1438),
    [sym_regex] = STATE(1438),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1438),
    [sym_as_expression] = STATE(1438),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1438),
    [sym_class] = STATE(1438),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4322),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4322),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4322),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4322),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4324),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4322),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1335] = {
    [sym_type_annotation] = STATE(1439),
    [sym__automatic_semicolon] = ACTIONS(1558),
    [anon_sym_RBRACE] = ACTIONS(1558),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_SEMI] = ACTIONS(1558),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1558),
    [anon_sym_COMMA] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1558),
  },
  [1336] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1440),
    [sym_function_type] = STATE(1440),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1440),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1440),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1440),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1337] = {
    [sym__automatic_semicolon] = ACTIONS(1560),
    [anon_sym_RBRACE] = ACTIONS(1560),
    [anon_sym_SEMI] = ACTIONS(1560),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1560),
    [anon_sym_COMMA] = ACTIONS(1560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1560),
  },
  [1338] = {
    [sym_arrow_function] = STATE(1441),
    [sym_await_expression] = STATE(1441),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1441),
    [sym_meta_property] = STATE(1441),
    [sym__expression] = STATE(1441),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1441),
    [sym_call_expression] = STATE(1441),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1441),
    [sym_string] = STATE(1441),
    [sym_template_string] = STATE(1441),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1441),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1441),
    [sym_generator_function] = STATE(1441),
    [sym_new_expression] = STATE(1441),
    [sym_assignment_expression] = STATE(1441),
    [sym_augmented_assignment_expression] = STATE(1441),
    [sym_binary_expression] = STATE(1441),
    [sym_unary_expression] = STATE(1441),
    [sym_regex] = STATE(1441),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1441),
    [sym_as_expression] = STATE(1441),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1441),
    [sym_class] = STATE(1441),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4326),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4326),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4326),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4326),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4328),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4326),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1339] = {
    [sym_class_declaration] = STATE(1442),
    [sym_generator_function_declaration] = STATE(1442),
    [sym__declaration] = STATE(1442),
    [sym_enum_declaration] = STATE(1442),
    [sym_function_signature] = STATE(1442),
    [sym_abstract_class_declaration] = STATE(1442),
    [sym_module] = STATE(1442),
    [sym_interface_declaration] = STATE(1442),
    [sym_function_declaration] = STATE(1442),
    [sym_variable_declaration] = STATE(1442),
    [sym_lexical_declaration] = STATE(1442),
    [sym_ambient_declaration] = STATE(1442),
    [sym_import_alias] = STATE(1442),
    [sym_type_alias_declaration] = STATE(1442),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1442),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(4330),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2362),
  },
  [1340] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(1729),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_GT_GT_GT] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1731),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(1729),
    [anon_sym_DASH_DASH] = ACTIONS(1729),
    [anon_sym_instanceof] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_PLUS_PLUS] = ACTIONS(1729),
    [anon_sym_in] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(1729),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_QMARK] = ACTIONS(1729),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1731),
    [anon_sym_RPAREN] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_implements] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1731),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1729),
  },
  [1341] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1342] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1343] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1739),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(1743),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(1741),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_of] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_RPAREN] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_implements] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1345] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1747),
    [anon_sym_BQUOTE] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_STAR] = ACTIONS(1749),
    [anon_sym_GT_GT_GT] = ACTIONS(1747),
    [anon_sym_BANG_EQ] = ACTIONS(1749),
    [anon_sym_GT_EQ] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1747),
    [anon_sym_PERCENT] = ACTIONS(1747),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1747),
    [anon_sym_as] = ACTIONS(1747),
    [anon_sym_DASH_DASH] = ACTIONS(1747),
    [anon_sym_instanceof] = ACTIONS(1747),
    [anon_sym_COLON] = ACTIONS(1747),
    [anon_sym_DOT] = ACTIONS(1747),
    [anon_sym_STAR_STAR] = ACTIONS(1747),
    [anon_sym_PLUS_PLUS] = ACTIONS(1747),
    [anon_sym_in] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(1747),
    [anon_sym_LT_LT] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(1749),
    [anon_sym_AMP_AMP] = ACTIONS(1747),
    [anon_sym_LT_EQ] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RBRACK] = ACTIONS(1747),
    [anon_sym_GT] = ACTIONS(1749),
    [anon_sym_AMP] = ACTIONS(1749),
    [anon_sym_QMARK] = ACTIONS(1747),
    [anon_sym_PIPE_PIPE] = ACTIONS(1747),
    [anon_sym_EQ_EQ] = ACTIONS(1749),
    [anon_sym_RPAREN] = ACTIONS(1747),
    [anon_sym_LT] = ACTIONS(1749),
    [anon_sym_SLASH] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1747),
    [anon_sym_PLUS] = ACTIONS(1749),
    [anon_sym_implements] = ACTIONS(1747),
    [anon_sym_GT_GT] = ACTIONS(1749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1747),
  },
  [1346] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1761),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_GT_GT_GT] = ACTIONS(1759),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1759),
    [anon_sym_instanceof] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1759),
    [anon_sym_DOT] = ACTIONS(1759),
    [anon_sym_STAR_STAR] = ACTIONS(1759),
    [anon_sym_PLUS_PLUS] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(1761),
    [anon_sym_BANG] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1759),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_implements] = ACTIONS(1759),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1759),
  },
  [1347] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1759),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1348] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1763),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1763),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1763),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1349] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1765),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1765),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1765),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1350] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1767),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_PERCENT_EQ] = ACTIONS(1767),
    [anon_sym_AMP_EQ] = ACTIONS(1767),
    [anon_sym_PLUS_EQ] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1769),
    [anon_sym_COMMA] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1769),
    [anon_sym_GT_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ] = ACTIONS(1769),
    [anon_sym_BANG_EQ] = ACTIONS(1769),
    [anon_sym_GT_EQ] = ACTIONS(1767),
    [anon_sym_CARET_EQ] = ACTIONS(1767),
    [anon_sym_PIPE_EQ] = ACTIONS(1767),
    [anon_sym_DASH_EQ] = ACTIONS(1767),
    [anon_sym_RBRACE] = ACTIONS(1767),
    [anon_sym_PERCENT] = ACTIONS(1769),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1767),
    [anon_sym_LT_LT_EQ] = ACTIONS(1767),
    [anon_sym_as] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1767),
    [anon_sym_instanceof] = ACTIONS(1767),
    [anon_sym_COLON] = ACTIONS(1767),
    [anon_sym_GT_GT_EQ] = ACTIONS(1767),
    [anon_sym_DOT] = ACTIONS(1767),
    [anon_sym_STAR_STAR] = ACTIONS(1769),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1767),
    [anon_sym_in] = ACTIONS(1769),
    [anon_sym_BANG] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(1767),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1767),
    [anon_sym_LT_LT] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(1769),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_of] = ACTIONS(1767),
    [anon_sym_LT_EQ] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_RBRACK] = ACTIONS(1767),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_STAR_EQ] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1769),
    [anon_sym_QMARK] = ACTIONS(1767),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_EQ_EQ] = ACTIONS(1769),
    [anon_sym_RPAREN] = ACTIONS(1767),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1767),
    [anon_sym_CARET] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_implements] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1767),
  },
  [1351] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
  },
  [1352] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [1353] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_of] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_implements] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
  },
  [1354] = {
    [sym_arrow_function] = STATE(1444),
    [sym_await_expression] = STATE(1444),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1444),
    [sym_meta_property] = STATE(1444),
    [sym__expression] = STATE(1444),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1444),
    [sym_call_expression] = STATE(1444),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1444),
    [sym_string] = STATE(1444),
    [sym_template_string] = STATE(1444),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1444),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1444),
    [sym_generator_function] = STATE(1444),
    [sym_new_expression] = STATE(1444),
    [sym_assignment_expression] = STATE(1444),
    [sym_augmented_assignment_expression] = STATE(1444),
    [sym_binary_expression] = STATE(1444),
    [sym_unary_expression] = STATE(1444),
    [sym_regex] = STATE(1444),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1444),
    [sym_as_expression] = STATE(1444),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1444),
    [sym_class] = STATE(1444),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4332),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4332),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4332),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4332),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4334),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4332),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1355] = {
    [sym__automatic_semicolon] = ACTIONS(1817),
    [anon_sym_RBRACE] = ACTIONS(1817),
    [anon_sym_SEMI] = ACTIONS(1817),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1817),
    [sym_comment] = ACTIONS(3),
  },
  [1356] = {
    [sym_type_arguments] = STATE(1393),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [sym__automatic_semicolon] = ACTIONS(1239),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1827),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1827),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_is] = ACTIONS(4338),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1827),
    [anon_sym_LT] = ACTIONS(4340),
    [anon_sym_SLASH] = ACTIONS(1827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_GT_GT] = ACTIONS(1827),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
  },
  [1357] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_AT] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_GT_GT_GT] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1831),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_PERCENT] = ACTIONS(1829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_instanceof] = ACTIONS(1829),
    [anon_sym_COLON] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_STAR_STAR] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_in] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_class] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1831),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_RBRACK] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_EQ_EQ] = ACTIONS(1831),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_export] = ACTIONS(1829),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_implements] = ACTIONS(1829),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1829),
  },
  [1358] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1835),
    [anon_sym_BQUOTE] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1837),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1837),
    [anon_sym_STAR] = ACTIONS(1837),
    [anon_sym_GT_GT_GT] = ACTIONS(1835),
    [anon_sym_BANG_EQ] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_PERCENT] = ACTIONS(1835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1835),
    [anon_sym_as] = ACTIONS(1835),
    [anon_sym_DASH_DASH] = ACTIONS(1835),
    [anon_sym_instanceof] = ACTIONS(1835),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_DOT] = ACTIONS(1835),
    [anon_sym_STAR_STAR] = ACTIONS(1835),
    [anon_sym_PLUS_PLUS] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1837),
    [anon_sym_BANG] = ACTIONS(1837),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_LT_LT] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1837),
    [anon_sym_AMP_AMP] = ACTIONS(1835),
    [anon_sym_LT_EQ] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1837),
    [anon_sym_AMP] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_PIPE_PIPE] = ACTIONS(1835),
    [anon_sym_EQ_EQ] = ACTIONS(1837),
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_SLASH] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1835),
    [anon_sym_PLUS] = ACTIONS(1837),
    [anon_sym_implements] = ACTIONS(1835),
    [anon_sym_GT_GT] = ACTIONS(1837),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1835),
  },
  [1359] = {
    [sym__automatic_semicolon] = ACTIONS(1845),
    [anon_sym_RBRACE] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1845),
    [anon_sym_COMMA] = ACTIONS(1845),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [1360] = {
    [sym__automatic_semicolon] = ACTIONS(1853),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
  },
  [1361] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1362] = {
    [sym_identifier] = ACTIONS(1941),
    [anon_sym_BQUOTE] = ACTIONS(1939),
    [anon_sym_debugger] = ACTIONS(1941),
    [anon_sym_symbol] = ACTIONS(1941),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_void] = ACTIONS(1941),
    [anon_sym_break] = ACTIONS(1941),
    [anon_sym_const] = ACTIONS(1941),
    [sym_super] = ACTIONS(1941),
    [anon_sym_return] = ACTIONS(1941),
    [anon_sym_private] = ACTIONS(1941),
    [anon_sym_static] = ACTIONS(1941),
    [anon_sym_get] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_interface] = ACTIONS(1941),
    [anon_sym_default] = ACTIONS(1941),
    [anon_sym_enum] = ACTIONS(1941),
    [anon_sym_delete] = ACTIONS(1941),
    [anon_sym_continue] = ACTIONS(1941),
    [anon_sym_DASH_DASH] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(1941),
    [sym_this] = ACTIONS(1941),
    [anon_sym_yield] = ACTIONS(1941),
    [sym_true] = ACTIONS(1941),
    [anon_sym_throw] = ACTIONS(1941),
    [anon_sym_protected] = ACTIONS(1941),
    [anon_sym_abstract] = ACTIONS(1941),
    [anon_sym_set] = ACTIONS(1941),
    [anon_sym_type] = ACTIONS(1941),
    [anon_sym_import] = ACTIONS(1941),
    [anon_sym_namespace] = ACTIONS(1941),
    [anon_sym_PLUS_PLUS] = ACTIONS(1939),
    [anon_sym_DQUOTE] = ACTIONS(1939),
    [anon_sym_else] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [sym_false] = ACTIONS(1941),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_case] = ACTIONS(1941),
    [anon_sym_module] = ACTIONS(1941),
    [anon_sym_number] = ACTIONS(1941),
    [anon_sym_class] = ACTIONS(1941),
    [anon_sym_declare] = ACTIONS(1941),
    [anon_sym_typeof] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(1939),
    [anon_sym_switch] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [sym_null] = ACTIONS(1941),
    [anon_sym_any] = ACTIONS(1941),
    [anon_sym_boolean] = ACTIONS(1941),
    [anon_sym_async] = ACTIONS(1941),
    [anon_sym_public] = ACTIONS(1941),
    [anon_sym_var] = ACTIONS(1941),
    [anon_sym_while] = ACTIONS(1941),
    [anon_sym_SQUOTE] = ACTIONS(1939),
    [anon_sym_try] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1939),
    [sym_number] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1941),
    [anon_sym_function] = ACTIONS(1941),
    [sym_undefined] = ACTIONS(1941),
    [anon_sym_new] = ACTIONS(1941),
    [ts_builtin_sym_end] = ACTIONS(1939),
    [anon_sym_let] = ACTIONS(1941),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_export] = ACTIONS(1941),
    [anon_sym_do] = ACTIONS(1941),
    [anon_sym_TILDE] = ACTIONS(1939),
    [anon_sym_with] = ACTIONS(1941),
    [anon_sym_await] = ACTIONS(1941),
  },
  [1363] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1943),
    [sym__automatic_semicolon] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_symbol] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1945),
    [anon_sym_BANG_EQ] = ACTIONS(1945),
    [anon_sym_return] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_interface] = ACTIONS(1945),
    [anon_sym_as] = ACTIONS(1945),
    [anon_sym_delete] = ACTIONS(1945),
    [anon_sym_if] = ACTIONS(1945),
    [anon_sym_instanceof] = ACTIONS(1945),
    [anon_sym_yield] = ACTIONS(1945),
    [sym_true] = ACTIONS(1945),
    [anon_sym_protected] = ACTIONS(1945),
    [anon_sym_DOT] = ACTIONS(1945),
    [anon_sym_set] = ACTIONS(1945),
    [anon_sym_import] = ACTIONS(1945),
    [anon_sym_in] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_number] = ACTIONS(1945),
    [anon_sym_typeof] = ACTIONS(1945),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1945),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [sym_null] = ACTIONS(1945),
    [anon_sym_any] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(1945),
    [anon_sym_public] = ACTIONS(1945),
    [anon_sym_var] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1945),
    [anon_sym_new] = ACTIONS(1945),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_export] = ACTIONS(1945),
    [anon_sym_GT_GT] = ACTIONS(1945),
    [anon_sym_with] = ACTIONS(1945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1943),
    [sym_identifier] = ACTIONS(1945),
    [anon_sym_debugger] = ACTIONS(1945),
    [anon_sym_AT] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1945),
    [anon_sym_const] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [sym_super] = ACTIONS(1945),
    [anon_sym_private] = ACTIONS(1945),
    [anon_sym_get] = ACTIONS(1945),
    [anon_sym_default] = ACTIONS(1945),
    [anon_sym_enum] = ACTIONS(1945),
    [anon_sym_continue] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [sym_this] = ACTIONS(1945),
    [anon_sym_throw] = ACTIONS(1945),
    [anon_sym_abstract] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1945),
    [anon_sym_STAR_STAR] = ACTIONS(1943),
    [anon_sym_namespace] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_else] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [sym_false] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1945),
    [anon_sym_module] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(1945),
    [anon_sym_boolean] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_try] = ACTIONS(1945),
    [anon_sym_EQ_EQ] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [sym_number] = ACTIONS(1943),
    [ts_builtin_sym_end] = ACTIONS(1943),
    [anon_sym_function] = ACTIONS(1945),
    [sym_undefined] = ACTIONS(1945),
    [anon_sym_let] = ACTIONS(1945),
    [anon_sym_PLUS] = ACTIONS(1945),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1943),
    [anon_sym_await] = ACTIONS(1945),
  },
  [1364] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_of] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1365] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_of] = ACTIONS(1960),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1366] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(525),
  },
  [1367] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1368] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_of] = ACTIONS(1965),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(1962),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1369] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_of] = ACTIONS(1955),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1370] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_of] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1371] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_of] = ACTIONS(1986),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1372] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2011),
    [anon_sym_BQUOTE] = ACTIONS(2011),
    [anon_sym_PIPE] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_GT_GT_GT] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_BANG_EQ] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_PERCENT] = ACTIONS(2011),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2011),
    [anon_sym_as] = ACTIONS(2011),
    [anon_sym_DASH_DASH] = ACTIONS(2011),
    [anon_sym_instanceof] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_STAR_STAR] = ACTIONS(2011),
    [anon_sym_PLUS_PLUS] = ACTIONS(2011),
    [anon_sym_in] = ACTIONS(2013),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2011),
    [anon_sym_LBRACE] = ACTIONS(2013),
    [anon_sym_AMP_AMP] = ACTIONS(2011),
    [anon_sym_of] = ACTIONS(2011),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_RBRACK] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2013),
    [anon_sym_AMP] = ACTIONS(2013),
    [anon_sym_QMARK] = ACTIONS(2011),
    [anon_sym_PIPE_PIPE] = ACTIONS(2011),
    [anon_sym_EQ_EQ] = ACTIONS(2013),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2013),
    [anon_sym_implements] = ACTIONS(2011),
    [anon_sym_GT_GT] = ACTIONS(2013),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2011),
  },
  [1373] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2065),
    [sym__automatic_semicolon] = ACTIONS(2067),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2073),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2065),
    [anon_sym_BANG_EQ] = ACTIONS(2073),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_as] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(2065),
    [anon_sym_instanceof] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_STAR_STAR] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(2065),
    [anon_sym_in] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(2069),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_QMARK] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_while] = ACTIONS(2069),
    [anon_sym_EQ_EQ] = ACTIONS(2073),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2065),
  },
  [1374] = {
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1783),
  },
  [1375] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2093),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [anon_sym_PIPE] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_BANG_EQ] = ACTIONS(2095),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2093),
    [anon_sym_as] = ACTIONS(2093),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_instanceof] = ACTIONS(2093),
    [anon_sym_COLON] = ACTIONS(2093),
    [anon_sym_DOT] = ACTIONS(2093),
    [anon_sym_STAR_STAR] = ACTIONS(2093),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_in] = ACTIONS(2095),
    [anon_sym_else] = ACTIONS(2093),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2095),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_RBRACK] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_while] = ACTIONS(2093),
    [anon_sym_EQ_EQ] = ACTIONS(2095),
    [anon_sym_RPAREN] = ACTIONS(2093),
    [anon_sym_LT] = ACTIONS(2095),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_implements] = ACTIONS(2093),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2093),
  },
  [1376] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2141),
    [anon_sym_BQUOTE] = ACTIONS(2141),
    [anon_sym_PIPE] = ACTIONS(2143),
    [anon_sym_COMMA] = ACTIONS(2141),
    [anon_sym_DASH] = ACTIONS(2143),
    [anon_sym_STAR] = ACTIONS(2143),
    [anon_sym_GT_GT_GT] = ACTIONS(2141),
    [anon_sym_BANG_EQ] = ACTIONS(2143),
    [anon_sym_GT_EQ] = ACTIONS(2141),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_PERCENT] = ACTIONS(2141),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2141),
    [anon_sym_as] = ACTIONS(2141),
    [anon_sym_DASH_DASH] = ACTIONS(2141),
    [anon_sym_instanceof] = ACTIONS(2141),
    [anon_sym_COLON] = ACTIONS(2141),
    [anon_sym_DOT] = ACTIONS(2141),
    [anon_sym_STAR_STAR] = ACTIONS(2141),
    [anon_sym_PLUS_PLUS] = ACTIONS(2141),
    [anon_sym_in] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(2143),
    [anon_sym_LBRACK] = ACTIONS(2141),
    [anon_sym_LT_LT] = ACTIONS(2141),
    [anon_sym_LBRACE] = ACTIONS(2143),
    [anon_sym_AMP_AMP] = ACTIONS(2141),
    [anon_sym_LT_EQ] = ACTIONS(2141),
    [anon_sym_LPAREN] = ACTIONS(2141),
    [anon_sym_RBRACK] = ACTIONS(2141),
    [anon_sym_GT] = ACTIONS(2143),
    [anon_sym_AMP] = ACTIONS(2143),
    [anon_sym_QMARK] = ACTIONS(2141),
    [anon_sym_PIPE_PIPE] = ACTIONS(2141),
    [anon_sym_EQ_EQ] = ACTIONS(2143),
    [anon_sym_RPAREN] = ACTIONS(2141),
    [anon_sym_LT] = ACTIONS(2143),
    [anon_sym_SLASH] = ACTIONS(2143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2141),
    [anon_sym_PLUS] = ACTIONS(2143),
    [anon_sym_implements] = ACTIONS(2141),
    [anon_sym_GT_GT] = ACTIONS(2143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2141),
  },
  [1377] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2145),
    [anon_sym_BQUOTE] = ACTIONS(2145),
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_COMMA] = ACTIONS(2145),
    [anon_sym_DASH] = ACTIONS(2147),
    [anon_sym_STAR] = ACTIONS(2147),
    [anon_sym_GT_GT_GT] = ACTIONS(2145),
    [anon_sym_BANG_EQ] = ACTIONS(2147),
    [anon_sym_GT_EQ] = ACTIONS(2145),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_PERCENT] = ACTIONS(2145),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2145),
    [anon_sym_as] = ACTIONS(2145),
    [anon_sym_DASH_DASH] = ACTIONS(2145),
    [anon_sym_instanceof] = ACTIONS(2145),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_DOT] = ACTIONS(2145),
    [anon_sym_STAR_STAR] = ACTIONS(2145),
    [anon_sym_PLUS_PLUS] = ACTIONS(2145),
    [anon_sym_in] = ACTIONS(2147),
    [anon_sym_BANG] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2145),
    [anon_sym_LT_LT] = ACTIONS(2145),
    [anon_sym_LBRACE] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2145),
    [anon_sym_LT_EQ] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2145),
    [anon_sym_RBRACK] = ACTIONS(2145),
    [anon_sym_GT] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
    [anon_sym_QMARK] = ACTIONS(2145),
    [anon_sym_PIPE_PIPE] = ACTIONS(2145),
    [anon_sym_EQ_EQ] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2145),
    [anon_sym_LT] = ACTIONS(2147),
    [anon_sym_SLASH] = ACTIONS(2147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2145),
    [anon_sym_PLUS] = ACTIONS(2147),
    [anon_sym_implements] = ACTIONS(2145),
    [anon_sym_GT_GT] = ACTIONS(2147),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2145),
  },
  [1378] = {
    [sym__automatic_semicolon] = ACTIONS(2155),
    [anon_sym_RBRACE] = ACTIONS(2155),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_COMMA] = ACTIONS(2155),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
  },
  [1379] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2167),
    [anon_sym_BQUOTE] = ACTIONS(2167),
    [anon_sym_PIPE] = ACTIONS(2169),
    [anon_sym_COMMA] = ACTIONS(2167),
    [anon_sym_DASH] = ACTIONS(2169),
    [anon_sym_STAR] = ACTIONS(2169),
    [anon_sym_GT_GT_GT] = ACTIONS(2167),
    [anon_sym_EQ] = ACTIONS(2169),
    [anon_sym_BANG_EQ] = ACTIONS(2169),
    [anon_sym_GT_EQ] = ACTIONS(2167),
    [anon_sym_RBRACE] = ACTIONS(2167),
    [anon_sym_PERCENT] = ACTIONS(2167),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2167),
    [anon_sym_as] = ACTIONS(2167),
    [anon_sym_DASH_DASH] = ACTIONS(2167),
    [anon_sym_instanceof] = ACTIONS(2167),
    [anon_sym_COLON] = ACTIONS(2167),
    [anon_sym_DOT] = ACTIONS(2167),
    [anon_sym_STAR_STAR] = ACTIONS(2167),
    [anon_sym_PLUS_PLUS] = ACTIONS(2167),
    [anon_sym_in] = ACTIONS(2169),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(2167),
    [anon_sym_LT_LT] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2169),
    [anon_sym_AMP_AMP] = ACTIONS(2167),
    [anon_sym_of] = ACTIONS(2167),
    [anon_sym_LT_EQ] = ACTIONS(2167),
    [anon_sym_LPAREN] = ACTIONS(2167),
    [anon_sym_RBRACK] = ACTIONS(2167),
    [anon_sym_GT] = ACTIONS(2169),
    [anon_sym_AMP] = ACTIONS(2169),
    [anon_sym_QMARK] = ACTIONS(2167),
    [anon_sym_PIPE_PIPE] = ACTIONS(2167),
    [anon_sym_EQ_EQ] = ACTIONS(2169),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [anon_sym_LT] = ACTIONS(2169),
    [anon_sym_SLASH] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2167),
    [anon_sym_PLUS] = ACTIONS(2169),
    [anon_sym_implements] = ACTIONS(2167),
    [anon_sym_GT_GT] = ACTIONS(2169),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2167),
  },
  [1380] = {
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(3700),
    [sym_comment] = ACTIONS(3),
  },
  [1381] = {
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(3700),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [1382] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [sym__automatic_semicolon] = ACTIONS(2199),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2199),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
  },
  [1383] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2205),
    [anon_sym_BQUOTE] = ACTIONS(2205),
    [anon_sym_PIPE] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(2205),
    [anon_sym_DASH] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(2207),
    [anon_sym_GT_GT_GT] = ACTIONS(2205),
    [anon_sym_EQ] = ACTIONS(2207),
    [anon_sym_BANG_EQ] = ACTIONS(2207),
    [anon_sym_GT_EQ] = ACTIONS(2205),
    [anon_sym_RBRACE] = ACTIONS(2205),
    [anon_sym_PERCENT] = ACTIONS(2205),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2205),
    [anon_sym_as] = ACTIONS(2205),
    [anon_sym_DASH_DASH] = ACTIONS(2205),
    [anon_sym_instanceof] = ACTIONS(2205),
    [anon_sym_COLON] = ACTIONS(2205),
    [anon_sym_DOT] = ACTIONS(2205),
    [anon_sym_STAR_STAR] = ACTIONS(2205),
    [anon_sym_PLUS_PLUS] = ACTIONS(2205),
    [anon_sym_in] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(2205),
    [anon_sym_LT_LT] = ACTIONS(2205),
    [anon_sym_LBRACE] = ACTIONS(2207),
    [anon_sym_AMP_AMP] = ACTIONS(2205),
    [anon_sym_of] = ACTIONS(2205),
    [anon_sym_LT_EQ] = ACTIONS(2205),
    [anon_sym_LPAREN] = ACTIONS(2205),
    [anon_sym_RBRACK] = ACTIONS(2205),
    [anon_sym_GT] = ACTIONS(2207),
    [anon_sym_AMP] = ACTIONS(2207),
    [anon_sym_QMARK] = ACTIONS(2205),
    [anon_sym_PIPE_PIPE] = ACTIONS(2205),
    [anon_sym_EQ_EQ] = ACTIONS(2207),
    [anon_sym_RPAREN] = ACTIONS(2205),
    [anon_sym_LT] = ACTIONS(2207),
    [anon_sym_SLASH] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2205),
    [anon_sym_PLUS] = ACTIONS(2207),
    [anon_sym_implements] = ACTIONS(2205),
    [anon_sym_GT_GT] = ACTIONS(2207),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2205),
  },
  [1384] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [sym__automatic_semicolon] = ACTIONS(4343),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2199),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
  },
  [1385] = {
    [anon_sym_COLON] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [sym__automatic_semicolon] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2252),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2252),
  },
  [1386] = {
    [sym_identifier] = ACTIONS(2264),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [anon_sym_debugger] = ACTIONS(2264),
    [anon_sym_symbol] = ACTIONS(2264),
    [anon_sym_AT] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_void] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [sym_super] = ACTIONS(2264),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_delete] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(2264),
    [sym_this] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [sym_true] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_type] = ACTIONS(2264),
    [anon_sym_import] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [sym_false] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_module] = ACTIONS(2264),
    [anon_sym_number] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_declare] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [sym_null] = ACTIONS(2264),
    [anon_sym_any] = ACTIONS(2264),
    [anon_sym_boolean] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(2262),
    [sym_number] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2264),
    [anon_sym_function] = ACTIONS(2264),
    [sym_undefined] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_export] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_with] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
  },
  [1387] = {
    [sym_arrow_function] = STATE(1469),
    [sym_await_expression] = STATE(1469),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1468),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1469),
    [sym_meta_property] = STATE(1469),
    [sym__expression] = STATE(1469),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1469),
    [sym_call_expression] = STATE(1469),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1469),
    [sym_string] = STATE(1469),
    [sym_template_string] = STATE(1469),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1469),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1469),
    [sym_generator_function] = STATE(1469),
    [sym_new_expression] = STATE(1469),
    [sym_assignment_expression] = STATE(1469),
    [sym_augmented_assignment_expression] = STATE(1469),
    [sym_binary_expression] = STATE(1469),
    [sym_unary_expression] = STATE(1469),
    [sym_regex] = STATE(1469),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1469),
    [sym_as_expression] = STATE(1469),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1469),
    [sym_class] = STATE(1469),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4345),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4345),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4345),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4345),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4347),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4345),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1388] = {
    [sym_arrow_function] = STATE(1471),
    [sym_await_expression] = STATE(1471),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1470),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1471),
    [sym_meta_property] = STATE(1471),
    [sym__expression] = STATE(1471),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1471),
    [sym_call_expression] = STATE(1471),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1471),
    [sym_string] = STATE(1471),
    [sym_template_string] = STATE(1471),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1471),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1471),
    [sym_generator_function] = STATE(1471),
    [sym_new_expression] = STATE(1471),
    [sym_assignment_expression] = STATE(1471),
    [sym_augmented_assignment_expression] = STATE(1471),
    [sym_binary_expression] = STATE(1471),
    [sym_unary_expression] = STATE(1471),
    [sym_regex] = STATE(1471),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1471),
    [sym_as_expression] = STATE(1471),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1471),
    [sym_class] = STATE(1471),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4349),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4349),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4349),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4349),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4351),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4349),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1389] = {
    [sym_arrow_function] = STATE(1474),
    [sym_await_expression] = STATE(1474),
    [sym_member_expression] = STATE(1251),
    [sym_statement_block] = STATE(1473),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1474),
    [sym_meta_property] = STATE(1474),
    [sym__expression] = STATE(1474),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1474),
    [sym_call_expression] = STATE(1474),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1474),
    [sym_string] = STATE(1474),
    [sym_template_string] = STATE(1474),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1474),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1474),
    [sym_generator_function] = STATE(1474),
    [sym_new_expression] = STATE(1474),
    [sym_assignment_expression] = STATE(1474),
    [sym_augmented_assignment_expression] = STATE(1474),
    [sym_binary_expression] = STATE(1474),
    [sym_unary_expression] = STATE(1474),
    [sym_regex] = STATE(1474),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1474),
    [sym_as_expression] = STATE(1474),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1474),
    [sym_class] = STATE(1474),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4353),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4353),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4353),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4353),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4355),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4353),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1390] = {
    [sym__automatic_semicolon] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_COMMA] = ACTIONS(2294),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
  },
  [1391] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(4357),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_BANG_EQ] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_as] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_instanceof] = ACTIONS(1075),
    [anon_sym_yield] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_DOT] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_in] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [sym_null] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(1075),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_with] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [sym_super] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [sym_this] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_false] = ACTIONS(1075),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [sym_number] = ACTIONS(1073),
    [ts_builtin_sym_end] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1075),
  },
  [1392] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1477),
    [sym_function_type] = STATE(1477),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1477),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1477),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1477),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1393] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [sym__automatic_semicolon] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym_BQUOTE] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_COMMA] = ACTIONS(2324),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_GT_GT_GT] = ACTIONS(2324),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_BANG_EQ] = ACTIONS(2326),
    [anon_sym_LT_EQ] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2324),
    [anon_sym_GT_EQ] = ACTIONS(2324),
    [anon_sym_GT] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_PERCENT] = ACTIONS(2324),
    [anon_sym_QMARK] = ACTIONS(2324),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_as] = ACTIONS(2324),
    [anon_sym_PIPE_PIPE] = ACTIONS(2324),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_EQ_EQ] = ACTIONS(2326),
    [anon_sym_instanceof] = ACTIONS(2324),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2324),
    [anon_sym_CARET] = ACTIONS(2324),
    [anon_sym_STAR_STAR] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_GT_GT] = ACTIONS(2326),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2326),
  },
  [1394] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(4267),
    [sym__automatic_semicolon] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym_BQUOTE] = ACTIONS(2328),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_COMMA] = ACTIONS(2328),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_GT_GT_GT] = ACTIONS(2328),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_BANG_EQ] = ACTIONS(2330),
    [anon_sym_LT_EQ] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_GT_EQ] = ACTIONS(2328),
    [anon_sym_GT] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_as] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_EQ_EQ] = ACTIONS(2330),
    [anon_sym_instanceof] = ACTIONS(2328),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_CARET] = ACTIONS(2328),
    [anon_sym_STAR_STAR] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_GT_GT] = ACTIONS(2330),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2328),
    [anon_sym_BANG] = ACTIONS(2330),
  },
  [1395] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [sym__automatic_semicolon] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_GT_GT_GT] = ACTIONS(2346),
    [anon_sym_AMP_AMP] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_BANG_EQ] = ACTIONS(2348),
    [anon_sym_LT_EQ] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_GT_EQ] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PERCENT] = ACTIONS(2346),
    [anon_sym_QMARK] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2346),
    [anon_sym_PIPE_PIPE] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2348),
    [anon_sym_instanceof] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2348),
    [anon_sym_SLASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2346),
    [anon_sym_STAR_STAR] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2348),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2348),
  },
  [1396] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [sym__automatic_semicolon] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2400),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_GT_GT_GT] = ACTIONS(2400),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_STAR_STAR] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_GT_GT] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_in] = ACTIONS(2402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BANG] = ACTIONS(2402),
  },
  [1397] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_GT_GT_GT] = ACTIONS(2404),
    [anon_sym_AMP_AMP] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_instanceof] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4359),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_STAR_STAR] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2406),
  },
  [1398] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym__automatic_semicolon] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_GT_GT_GT] = ACTIONS(2410),
    [anon_sym_AMP_AMP] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_BANG_EQ] = ACTIONS(2412),
    [anon_sym_LT_EQ] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_GT_EQ] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(2410),
    [anon_sym_QMARK] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2410),
    [anon_sym_EQ_EQ] = ACTIONS(2412),
    [anon_sym_instanceof] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_SLASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2410),
    [anon_sym_CARET] = ACTIONS(2410),
    [anon_sym_STAR_STAR] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2412),
    [anon_sym_GT_GT] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2412),
  },
  [1399] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [sym__automatic_semicolon] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_BQUOTE] = ACTIONS(2414),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2414),
    [anon_sym_LT_LT] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_GT_GT_GT] = ACTIONS(2414),
    [anon_sym_AMP_AMP] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_GT_EQ] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_PERCENT] = ACTIONS(2414),
    [anon_sym_QMARK] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2414),
    [anon_sym_PIPE_PIPE] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_EQ_EQ] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_SLASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_CARET] = ACTIONS(2414),
    [anon_sym_STAR_STAR] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_GT_GT] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2416),
  },
  [1400] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [sym__automatic_semicolon] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BANG] = ACTIONS(2422),
  },
  [1401] = {
    [sym_await_expression] = STATE(141),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(141),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(141),
    [sym_function_type] = STATE(522),
    [sym__expression] = STATE(141),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(141),
    [sym_call_expression] = STATE(141),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(141),
    [sym_template_string] = STATE(141),
    [sym_yield_expression] = STATE(141),
    [sym_type_assertion] = STATE(141),
    [sym_new_expression] = STATE(141),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(522),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(1252),
    [sym_as_expression] = STATE(141),
    [sym_internal_module] = STATE(141),
    [sym_arrow_function] = STATE(141),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_intersection_type] = STATE(522),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(522),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_spread_element] = STATE(142),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1625),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(1256),
    [sym_generator_function] = STATE(141),
    [sym_constructor_type] = STATE(522),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(141),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(141),
    [sym_regex] = STATE(141),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [aux_sym_array_repeat1] = STATE(143),
    [sym_non_null_expression] = STATE(141),
    [sym_class] = STATE(141),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2432),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(305),
    [sym_null] = ACTIONS(283),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(283),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1402] = {
    [sym_type_parameters] = STATE(1793),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_construct_signature] = STATE(2083),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(2083),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(2083),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(1829),
    [sym__call_signature] = STATE(2083),
    [sym_property_signature] = STATE(2083),
    [sym_string] = STATE(805),
    [sym_index_signature] = STATE(2083),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(4361),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(4363),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(4365),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4367),
    [anon_sym_export] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1403] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [sym__automatic_semicolon] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_BQUOTE] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_LT_LT] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(2491),
    [anon_sym_GT_GT_GT] = ACTIONS(2489),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_LT_EQ] = ACTIONS(2489),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_GT_EQ] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_PERCENT] = ACTIONS(2489),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_PIPE_PIPE] = ACTIONS(2489),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_EQ_EQ] = ACTIONS(2491),
    [anon_sym_instanceof] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2489),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_STAR_STAR] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2489),
    [anon_sym_BANG] = ACTIONS(2491),
  },
  [1404] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1484),
    [sym_function_type] = STATE(1484),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1484),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1484),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1484),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1405] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [sym__automatic_semicolon] = ACTIONS(2495),
    [anon_sym_SEMI] = ACTIONS(2495),
    [anon_sym_BQUOTE] = ACTIONS(2495),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2495),
    [anon_sym_LT_LT] = ACTIONS(2495),
    [anon_sym_STAR] = ACTIONS(2497),
    [anon_sym_GT_GT_GT] = ACTIONS(2495),
    [anon_sym_AMP_AMP] = ACTIONS(2495),
    [anon_sym_DASH] = ACTIONS(2497),
    [anon_sym_BANG_EQ] = ACTIONS(2497),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2495),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_GT] = ACTIONS(2497),
    [anon_sym_AMP] = ACTIONS(2497),
    [anon_sym_PERCENT] = ACTIONS(2495),
    [anon_sym_QMARK] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_as] = ACTIONS(2495),
    [anon_sym_PIPE_PIPE] = ACTIONS(2495),
    [anon_sym_DASH_DASH] = ACTIONS(2495),
    [anon_sym_EQ_EQ] = ACTIONS(2497),
    [anon_sym_instanceof] = ACTIONS(2495),
    [anon_sym_LT] = ACTIONS(2497),
    [anon_sym_SLASH] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2495),
    [anon_sym_CARET] = ACTIONS(2495),
    [anon_sym_STAR_STAR] = ACTIONS(2495),
    [anon_sym_PLUS] = ACTIONS(2497),
    [anon_sym_GT_GT] = ACTIONS(2497),
    [anon_sym_PLUS_PLUS] = ACTIONS(2495),
    [anon_sym_in] = ACTIONS(2497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2495),
    [anon_sym_BANG] = ACTIONS(2497),
  },
  [1406] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [sym__automatic_semicolon] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(2507),
    [anon_sym_LT_LT] = ACTIONS(2507),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_GT_GT_GT] = ACTIONS(2507),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_BANG_EQ] = ACTIONS(2509),
    [anon_sym_LT_EQ] = ACTIONS(2507),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_GT_EQ] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2509),
    [anon_sym_AMP] = ACTIONS(2509),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_QMARK] = ACTIONS(2507),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_as] = ACTIONS(2507),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2507),
    [anon_sym_EQ_EQ] = ACTIONS(2509),
    [anon_sym_instanceof] = ACTIONS(2507),
    [anon_sym_LT] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(2507),
    [anon_sym_CARET] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_in] = ACTIONS(2509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
    [anon_sym_BANG] = ACTIONS(2509),
  },
  [1407] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1486),
    [sym_function_type] = STATE(1486),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1486),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1486),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1486),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1408] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1487),
    [sym_function_type] = STATE(1487),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1487),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1487),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1487),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1409] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2517),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_STAR] = ACTIONS(2519),
    [anon_sym_GT_GT_GT] = ACTIONS(2517),
    [anon_sym_BANG_EQ] = ACTIONS(2519),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_RBRACE] = ACTIONS(2517),
    [anon_sym_PERCENT] = ACTIONS(2517),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2517),
    [anon_sym_as] = ACTIONS(2519),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_instanceof] = ACTIONS(2519),
    [sym_regex_flags] = ACTIONS(4369),
    [anon_sym_COLON] = ACTIONS(2517),
    [anon_sym_DOT] = ACTIONS(2517),
    [anon_sym_STAR_STAR] = ACTIONS(2517),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_in] = ACTIONS(2519),
    [anon_sym_BANG] = ACTIONS(2519),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(2517),
    [anon_sym_LBRACE] = ACTIONS(2519),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_RBRACK] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [anon_sym_LT] = ACTIONS(2519),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_GT_GT] = ACTIONS(2519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2517),
  },
  [1410] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2525),
    [anon_sym_BQUOTE] = ACTIONS(2525),
    [anon_sym_PIPE] = ACTIONS(2527),
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_DASH] = ACTIONS(2527),
    [anon_sym_STAR] = ACTIONS(2527),
    [anon_sym_GT_GT_GT] = ACTIONS(2525),
    [anon_sym_BANG_EQ] = ACTIONS(2527),
    [anon_sym_GT_EQ] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2525),
    [anon_sym_PERCENT] = ACTIONS(2525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2525),
    [anon_sym_as] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2525),
    [anon_sym_instanceof] = ACTIONS(2525),
    [anon_sym_COLON] = ACTIONS(2525),
    [anon_sym_DOT] = ACTIONS(2525),
    [anon_sym_STAR_STAR] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2525),
    [anon_sym_in] = ACTIONS(2527),
    [anon_sym_BANG] = ACTIONS(2527),
    [anon_sym_LBRACK] = ACTIONS(2525),
    [anon_sym_LT_LT] = ACTIONS(2525),
    [anon_sym_LBRACE] = ACTIONS(2527),
    [anon_sym_AMP_AMP] = ACTIONS(2525),
    [anon_sym_LT_EQ] = ACTIONS(2525),
    [anon_sym_LPAREN] = ACTIONS(2525),
    [anon_sym_RBRACK] = ACTIONS(2525),
    [anon_sym_GT] = ACTIONS(2527),
    [anon_sym_AMP] = ACTIONS(2527),
    [anon_sym_QMARK] = ACTIONS(2525),
    [anon_sym_PIPE_PIPE] = ACTIONS(2525),
    [anon_sym_EQ_EQ] = ACTIONS(2527),
    [anon_sym_RPAREN] = ACTIONS(2525),
    [anon_sym_LT] = ACTIONS(2527),
    [anon_sym_SLASH] = ACTIONS(2527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2525),
    [anon_sym_PLUS] = ACTIONS(2527),
    [anon_sym_implements] = ACTIONS(2525),
    [anon_sym_GT_GT] = ACTIONS(2527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2525),
  },
  [1411] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_GT_GT_GT] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_instanceof] = ACTIONS(2529),
    [anon_sym_COLON] = ACTIONS(2529),
    [anon_sym_DOT] = ACTIONS(2529),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_in] = ACTIONS(2531),
    [anon_sym_BANG] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_implements] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
  },
  [1412] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2533),
    [anon_sym_BQUOTE] = ACTIONS(2533),
    [anon_sym_PIPE] = ACTIONS(2535),
    [anon_sym_COMMA] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(2535),
    [anon_sym_STAR] = ACTIONS(2535),
    [anon_sym_GT_GT_GT] = ACTIONS(2533),
    [anon_sym_BANG_EQ] = ACTIONS(2535),
    [anon_sym_GT_EQ] = ACTIONS(2533),
    [anon_sym_RBRACE] = ACTIONS(2533),
    [anon_sym_PERCENT] = ACTIONS(2533),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2533),
    [anon_sym_as] = ACTIONS(2533),
    [anon_sym_DASH_DASH] = ACTIONS(2533),
    [anon_sym_instanceof] = ACTIONS(2533),
    [anon_sym_COLON] = ACTIONS(2533),
    [anon_sym_DOT] = ACTIONS(2533),
    [anon_sym_STAR_STAR] = ACTIONS(2533),
    [anon_sym_PLUS_PLUS] = ACTIONS(2533),
    [anon_sym_in] = ACTIONS(2535),
    [anon_sym_BANG] = ACTIONS(2535),
    [anon_sym_LBRACK] = ACTIONS(2533),
    [anon_sym_LT_LT] = ACTIONS(2533),
    [anon_sym_LBRACE] = ACTIONS(2535),
    [anon_sym_AMP_AMP] = ACTIONS(2533),
    [anon_sym_LT_EQ] = ACTIONS(2533),
    [anon_sym_LPAREN] = ACTIONS(2533),
    [anon_sym_RBRACK] = ACTIONS(2533),
    [anon_sym_GT] = ACTIONS(2535),
    [anon_sym_AMP] = ACTIONS(2535),
    [anon_sym_QMARK] = ACTIONS(2533),
    [anon_sym_PIPE_PIPE] = ACTIONS(2533),
    [anon_sym_EQ_EQ] = ACTIONS(2535),
    [anon_sym_RPAREN] = ACTIONS(2533),
    [anon_sym_LT] = ACTIONS(2535),
    [anon_sym_SLASH] = ACTIONS(2535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2533),
    [anon_sym_PLUS] = ACTIONS(2535),
    [anon_sym_implements] = ACTIONS(2533),
    [anon_sym_GT_GT] = ACTIONS(2535),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2533),
  },
  [1413] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2537),
    [anon_sym_BQUOTE] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_DASH] = ACTIONS(2539),
    [anon_sym_STAR] = ACTIONS(2539),
    [anon_sym_GT_GT_GT] = ACTIONS(2537),
    [anon_sym_BANG_EQ] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2537),
    [anon_sym_as] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2537),
    [anon_sym_instanceof] = ACTIONS(2537),
    [anon_sym_COLON] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_PLUS_PLUS] = ACTIONS(2537),
    [anon_sym_in] = ACTIONS(2539),
    [anon_sym_BANG] = ACTIONS(2539),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2539),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2537),
    [anon_sym_LPAREN] = ACTIONS(2537),
    [anon_sym_RBRACK] = ACTIONS(2537),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_implements] = ACTIONS(2537),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
  },
  [1414] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2529),
    [anon_sym_BQUOTE] = ACTIONS(2529),
    [anon_sym_PIPE] = ACTIONS(2531),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(2531),
    [anon_sym_STAR] = ACTIONS(2531),
    [anon_sym_GT_GT_GT] = ACTIONS(2529),
    [anon_sym_BANG_EQ] = ACTIONS(2531),
    [anon_sym_GT_EQ] = ACTIONS(2529),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(2529),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2529),
    [anon_sym_as] = ACTIONS(2529),
    [anon_sym_DASH_DASH] = ACTIONS(2529),
    [anon_sym_instanceof] = ACTIONS(2529),
    [anon_sym_COLON] = ACTIONS(2529),
    [anon_sym_DOT] = ACTIONS(2529),
    [anon_sym_STAR_STAR] = ACTIONS(2529),
    [anon_sym_PLUS_PLUS] = ACTIONS(2529),
    [anon_sym_in] = ACTIONS(2531),
    [anon_sym_BANG] = ACTIONS(2531),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(2531),
    [anon_sym_AMP_AMP] = ACTIONS(2529),
    [anon_sym_LT_EQ] = ACTIONS(2529),
    [anon_sym_LPAREN] = ACTIONS(2529),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(2531),
    [anon_sym_AMP] = ACTIONS(2531),
    [anon_sym_QMARK] = ACTIONS(2529),
    [anon_sym_PIPE_PIPE] = ACTIONS(2529),
    [anon_sym_EQ_EQ] = ACTIONS(2531),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(2531),
    [anon_sym_SLASH] = ACTIONS(2531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2529),
    [anon_sym_PLUS] = ACTIONS(2531),
    [anon_sym_implements] = ACTIONS(2529),
    [anon_sym_GT_GT] = ACTIONS(2531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2529),
  },
  [1415] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(4371),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(4371),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1416] = {
    [sym__automatic_semicolon] = ACTIONS(2581),
    [anon_sym_RBRACE] = ACTIONS(2581),
    [anon_sym_SEMI] = ACTIONS(2581),
    [anon_sym_COMMA] = ACTIONS(2581),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2581),
    [sym_comment] = ACTIONS(3),
  },
  [1417] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
  },
  [1418] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1419] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
  },
  [1420] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
  },
  [1421] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1422] = {
    [anon_sym_COLON] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(2596),
  },
  [1423] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(2596),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1424] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2600),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_GT_GT_GT] = ACTIONS(2600),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_instanceof] = ACTIONS(2600),
    [anon_sym_COLON] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_STAR_STAR] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_LT_EQ] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_RBRACK] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_implements] = ACTIONS(2600),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2600),
  },
  [1425] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2600),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_PIPE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(2602),
    [anon_sym_GT_GT_GT] = ACTIONS(2600),
    [anon_sym_BANG_EQ] = ACTIONS(2602),
    [anon_sym_GT_EQ] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_PERCENT] = ACTIONS(2600),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2600),
    [anon_sym_as] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_instanceof] = ACTIONS(2600),
    [anon_sym_COLON] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_STAR_STAR] = ACTIONS(2600),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2600),
    [anon_sym_LBRACE] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_LT_EQ] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_RBRACK] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(2602),
    [anon_sym_AMP] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_EQ_EQ] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_implements] = ACTIONS(2600),
    [anon_sym_GT_GT] = ACTIONS(2602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2600),
  },
  [1426] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4376),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1427] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1428] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1429] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym_identifier] = ACTIONS(4378),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1430] = {
    [sym_arrow_function] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym__expression] = STATE(1270),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1270),
    [sym_generator_function] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_regex] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4380),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4380),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4380),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4382),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4380),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1431] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1153),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1432] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1433] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [sym_identifier] = ACTIONS(4384),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4386),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(4388),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(4386),
    [anon_sym_static] = ACTIONS(4386),
    [anon_sym_get] = ACTIONS(4386),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4390),
    [anon_sym_protected] = ACTIONS(4386),
    [anon_sym_DOT] = ACTIONS(4392),
    [anon_sym_set] = ACTIONS(4386),
    [anon_sym_type] = ACTIONS(4386),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4390),
    [anon_sym_module] = ACTIONS(4386),
    [anon_sym_number] = ACTIONS(4386),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4386),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [anon_sym_any] = ACTIONS(4386),
    [anon_sym_boolean] = ACTIONS(4386),
    [anon_sym_async] = ACTIONS(4396),
    [anon_sym_public] = ACTIONS(4386),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4398),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4386),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [1434] = {
    [sym_type_annotation] = STATE(287),
    [anon_sym_EQ_GT] = ACTIONS(4400),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [1435] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACE] = ACTIONS(2589),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_RPAREN] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4373),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
  },
  [1436] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(2655),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2655),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1437] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2657),
    [anon_sym_BQUOTE] = ACTIONS(2657),
    [anon_sym_PIPE] = ACTIONS(2659),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(2659),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_GT_GT_GT] = ACTIONS(2657),
    [anon_sym_BANG_EQ] = ACTIONS(2659),
    [anon_sym_GT_EQ] = ACTIONS(2657),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_PERCENT] = ACTIONS(2657),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2657),
    [anon_sym_as] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2657),
    [anon_sym_instanceof] = ACTIONS(2657),
    [anon_sym_COLON] = ACTIONS(2657),
    [anon_sym_DOT] = ACTIONS(2657),
    [anon_sym_STAR_STAR] = ACTIONS(2657),
    [anon_sym_PLUS_PLUS] = ACTIONS(2657),
    [anon_sym_in] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2657),
    [anon_sym_LT_EQ] = ACTIONS(2657),
    [anon_sym_LPAREN] = ACTIONS(2657),
    [anon_sym_RBRACK] = ACTIONS(2657),
    [anon_sym_GT] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_QMARK] = ACTIONS(2657),
    [anon_sym_PIPE_PIPE] = ACTIONS(2657),
    [anon_sym_EQ_EQ] = ACTIONS(2659),
    [anon_sym_RPAREN] = ACTIONS(2657),
    [anon_sym_LT] = ACTIONS(2659),
    [anon_sym_SLASH] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2659),
    [anon_sym_implements] = ACTIONS(2657),
    [anon_sym_GT_GT] = ACTIONS(2659),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2657),
  },
  [1438] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(2657),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(2657),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2657),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2657),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1439] = {
    [sym__automatic_semicolon] = ACTIONS(2661),
    [anon_sym_RBRACE] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2661),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2661),
    [anon_sym_COMMA] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2661),
  },
  [1440] = {
    [sym__automatic_semicolon] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(2663),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_EQ] = ACTIONS(2663),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2663),
  },
  [1441] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1442] = {
    [sym__automatic_semicolon] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym_COMMA] = ACTIONS(2675),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
  },
  [1443] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2073),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_DASH] = ACTIONS(2073),
    [anon_sym_STAR] = ACTIONS(2073),
    [anon_sym_GT_GT_GT] = ACTIONS(2065),
    [anon_sym_BANG_EQ] = ACTIONS(2073),
    [anon_sym_GT_EQ] = ACTIONS(2065),
    [anon_sym_RBRACE] = ACTIONS(2065),
    [anon_sym_PERCENT] = ACTIONS(2065),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2065),
    [anon_sym_as] = ACTIONS(2065),
    [anon_sym_DASH_DASH] = ACTIONS(2065),
    [anon_sym_instanceof] = ACTIONS(2065),
    [anon_sym_COLON] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_STAR_STAR] = ACTIONS(2065),
    [anon_sym_PLUS_PLUS] = ACTIONS(2065),
    [anon_sym_in] = ACTIONS(2073),
    [anon_sym_BANG] = ACTIONS(2073),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_AMP_AMP] = ACTIONS(2065),
    [anon_sym_LT_EQ] = ACTIONS(2065),
    [anon_sym_LPAREN] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2073),
    [anon_sym_AMP] = ACTIONS(2073),
    [anon_sym_QMARK] = ACTIONS(2065),
    [anon_sym_PIPE_PIPE] = ACTIONS(2065),
    [anon_sym_EQ_EQ] = ACTIONS(2073),
    [anon_sym_RPAREN] = ACTIONS(2065),
    [anon_sym_LT] = ACTIONS(2073),
    [anon_sym_SLASH] = ACTIONS(2073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2065),
    [anon_sym_PLUS] = ACTIONS(2073),
    [anon_sym_implements] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2065),
  },
  [1444] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2701),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_RBRACE] = ACTIONS(2701),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(2701),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1445] = {
    [sym__automatic_semicolon] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_COMMA] = ACTIONS(2707),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
  },
  [1446] = {
    [sym__automatic_semicolon] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym_COMMA] = ACTIONS(2715),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
  },
  [1447] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2722),
    [anon_sym_BQUOTE] = ACTIONS(2722),
    [anon_sym_PERCENT_EQ] = ACTIONS(2722),
    [anon_sym_AMP_EQ] = ACTIONS(2722),
    [anon_sym_PLUS_EQ] = ACTIONS(2722),
    [anon_sym_PIPE] = ACTIONS(2724),
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2724),
    [anon_sym_STAR] = ACTIONS(2724),
    [anon_sym_GT_GT_GT] = ACTIONS(2724),
    [anon_sym_EQ] = ACTIONS(2724),
    [anon_sym_BANG_EQ] = ACTIONS(2724),
    [anon_sym_GT_EQ] = ACTIONS(2722),
    [anon_sym_CARET_EQ] = ACTIONS(2722),
    [anon_sym_PIPE_EQ] = ACTIONS(2722),
    [anon_sym_DASH_EQ] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_PERCENT] = ACTIONS(2724),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2722),
    [anon_sym_LT_LT_EQ] = ACTIONS(2722),
    [anon_sym_as] = ACTIONS(2722),
    [anon_sym_DASH_DASH] = ACTIONS(2722),
    [anon_sym_instanceof] = ACTIONS(2722),
    [anon_sym_COLON] = ACTIONS(2722),
    [anon_sym_GT_GT_EQ] = ACTIONS(2722),
    [anon_sym_DOT] = ACTIONS(2722),
    [anon_sym_STAR_STAR] = ACTIONS(2724),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2722),
    [anon_sym_PLUS_PLUS] = ACTIONS(2722),
    [anon_sym_in] = ACTIONS(2724),
    [anon_sym_BANG] = ACTIONS(2724),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2722),
    [anon_sym_LT_LT] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2724),
    [anon_sym_AMP_AMP] = ACTIONS(2722),
    [anon_sym_of] = ACTIONS(2722),
    [anon_sym_LT_EQ] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_RBRACK] = ACTIONS(2722),
    [anon_sym_GT] = ACTIONS(2724),
    [anon_sym_STAR_EQ] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2724),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_PIPE_PIPE] = ACTIONS(2722),
    [anon_sym_EQ_EQ] = ACTIONS(2724),
    [anon_sym_RPAREN] = ACTIONS(2722),
    [anon_sym_LT] = ACTIONS(2724),
    [anon_sym_SLASH] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2722),
    [anon_sym_CARET] = ACTIONS(2724),
    [anon_sym_PLUS] = ACTIONS(2724),
    [anon_sym_implements] = ACTIONS(2722),
    [anon_sym_GT_GT] = ACTIONS(2724),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2722),
  },
  [1448] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_COMMA] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_STAR] = ACTIONS(2728),
    [anon_sym_GT_GT_GT] = ACTIONS(2726),
    [anon_sym_BANG_EQ] = ACTIONS(2728),
    [anon_sym_GT_EQ] = ACTIONS(2726),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_PERCENT] = ACTIONS(2726),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2726),
    [anon_sym_as] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_instanceof] = ACTIONS(2726),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_DOT] = ACTIONS(2726),
    [anon_sym_STAR_STAR] = ACTIONS(2726),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_class] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_LT_EQ] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_RBRACK] = ACTIONS(2726),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_EQ_EQ] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_SLASH] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2726),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2726),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_implements] = ACTIONS(2726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2726),
  },
  [1449] = {
    [sym__automatic_semicolon] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2734),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
  },
  [1450] = {
    [sym__automatic_semicolon] = ACTIONS(2738),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
  },
  [1451] = {
    [sym__automatic_semicolon] = ACTIONS(2742),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_SEMI] = ACTIONS(2742),
    [anon_sym_COMMA] = ACTIONS(2742),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
  },
  [1452] = {
    [sym__automatic_semicolon] = ACTIONS(2750),
    [anon_sym_RBRACE] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2750),
    [sym_comment] = ACTIONS(3),
  },
  [1453] = {
    [anon_sym_BQUOTE] = ACTIONS(2792),
    [anon_sym_symbol] = ACTIONS(2794),
    [anon_sym_PIPE] = ACTIONS(2792),
    [anon_sym_break] = ACTIONS(2794),
    [anon_sym_return] = ACTIONS(2794),
    [anon_sym_static] = ACTIONS(2794),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_interface] = ACTIONS(2794),
    [anon_sym_delete] = ACTIONS(2794),
    [anon_sym_if] = ACTIONS(2794),
    [anon_sym_yield] = ACTIONS(2794),
    [sym_true] = ACTIONS(2794),
    [anon_sym_protected] = ACTIONS(2794),
    [anon_sym_DOT] = ACTIONS(2794),
    [anon_sym_set] = ACTIONS(2794),
    [anon_sym_import] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(2792),
    [anon_sym_for] = ACTIONS(2794),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym_number] = ACTIONS(2794),
    [anon_sym_typeof] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_switch] = ACTIONS(2794),
    [anon_sym_RBRACK] = ACTIONS(2792),
    [sym_null] = ACTIONS(2794),
    [anon_sym_any] = ACTIONS(2794),
    [anon_sym_async] = ACTIONS(2794),
    [anon_sym_public] = ACTIONS(2794),
    [anon_sym_var] = ACTIONS(2794),
    [anon_sym_while] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2792),
    [anon_sym_RPAREN] = ACTIONS(2792),
    [anon_sym_SLASH] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2794),
    [anon_sym_new] = ACTIONS(2794),
    [anon_sym_export] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2794),
    [sym_identifier] = ACTIONS(2794),
    [anon_sym_debugger] = ACTIONS(2794),
    [anon_sym_AT] = ACTIONS(2792),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_EQ] = ACTIONS(2794),
    [anon_sym_void] = ACTIONS(2794),
    [anon_sym_const] = ACTIONS(2794),
    [sym_super] = ACTIONS(2794),
    [anon_sym_private] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2794),
    [anon_sym_default] = ACTIONS(2794),
    [anon_sym_enum] = ACTIONS(2794),
    [anon_sym_continue] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2792),
    [sym_this] = ACTIONS(2794),
    [anon_sym_throw] = ACTIONS(2794),
    [anon_sym_abstract] = ACTIONS(2794),
    [anon_sym_type] = ACTIONS(2794),
    [anon_sym_namespace] = ACTIONS(2794),
    [anon_sym_PLUS_PLUS] = ACTIONS(2792),
    [anon_sym_else] = ACTIONS(2794),
    [anon_sym_BANG] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [sym_false] = ACTIONS(2794),
    [anon_sym_case] = ACTIONS(2794),
    [anon_sym_module] = ACTIONS(2794),
    [anon_sym_class] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2792),
    [anon_sym_boolean] = ACTIONS(2794),
    [anon_sym_EQ_GT] = ACTIONS(2792),
    [anon_sym_AMP] = ACTIONS(2792),
    [anon_sym_try] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2792),
    [sym_number] = ACTIONS(2792),
    [ts_builtin_sym_end] = ACTIONS(2792),
    [anon_sym_function] = ACTIONS(2794),
    [sym_undefined] = ACTIONS(2794),
    [anon_sym_let] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2794),
    [anon_sym_do] = ACTIONS(2794),
    [anon_sym_TILDE] = ACTIONS(2792),
    [anon_sym_await] = ACTIONS(2794),
  },
  [1454] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2862),
    [anon_sym_BQUOTE] = ACTIONS(2862),
    [anon_sym_PIPE] = ACTIONS(2864),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_GT_GT_GT] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(2864),
    [anon_sym_BANG_EQ] = ACTIONS(2864),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_PERCENT] = ACTIONS(2862),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2862),
    [anon_sym_as] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_instanceof] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [anon_sym_DOT] = ACTIONS(2862),
    [anon_sym_STAR_STAR] = ACTIONS(2862),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_in] = ACTIONS(2864),
    [anon_sym_BANG] = ACTIONS(2864),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_LT_LT] = ACTIONS(2862),
    [anon_sym_LBRACE] = ACTIONS(2864),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_of] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_RBRACK] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(2864),
    [anon_sym_AMP] = ACTIONS(2864),
    [anon_sym_QMARK] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_EQ_EQ] = ACTIONS(2864),
    [anon_sym_RPAREN] = ACTIONS(2862),
    [anon_sym_LT] = ACTIONS(2864),
    [anon_sym_SLASH] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2864),
    [anon_sym_implements] = ACTIONS(2862),
    [anon_sym_GT_GT] = ACTIONS(2864),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2862),
  },
  [1455] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2884),
    [sym__automatic_semicolon] = ACTIONS(2886),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_GT_GT_GT] = ACTIONS(2884),
    [anon_sym_BANG_EQ] = ACTIONS(2892),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [anon_sym_DASH_DASH] = ACTIONS(2884),
    [anon_sym_instanceof] = ACTIONS(2884),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_STAR_STAR] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2884),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_else] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_while] = ACTIONS(2888),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2884),
  },
  [1456] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2894),
    [sym__automatic_semicolon] = ACTIONS(2896),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT] = ACTIONS(2894),
    [anon_sym_as] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_instanceof] = ACTIONS(2894),
    [anon_sym_DOT] = ACTIONS(2894),
    [anon_sym_STAR_STAR] = ACTIONS(2894),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_else] = ACTIONS(2898),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_LT_LT] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_while] = ACTIONS(2898),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2894),
  },
  [1457] = {
    [sym_string] = STATE(932),
    [sym__property_name] = STATE(932),
    [sym_computed_property_name] = STATE(932),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_GT_GT_GT] = ACTIONS(2944),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2944),
    [anon_sym_as] = ACTIONS(2944),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_instanceof] = ACTIONS(2944),
    [anon_sym_COLON] = ACTIONS(2944),
    [anon_sym_DOT] = ACTIONS(2944),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_in] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2944),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_RBRACK] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2944),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2944),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_RPAREN] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2944),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_implements] = ACTIONS(2944),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2944),
  },
  [1459] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BQUOTE] = ACTIONS(3007),
    [anon_sym_PIPE] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3009),
    [anon_sym_GT_GT_GT] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3009),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_PERCENT] = ACTIONS(3007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3007),
    [anon_sym_as] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_instanceof] = ACTIONS(3007),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_DOT] = ACTIONS(3007),
    [anon_sym_STAR_STAR] = ACTIONS(3007),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT_LT] = ACTIONS(3007),
    [anon_sym_LBRACE] = ACTIONS(3009),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_EQ_EQ] = ACTIONS(3009),
    [anon_sym_RPAREN] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_SLASH] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_implements] = ACTIONS(3007),
    [anon_sym_GT_GT] = ACTIONS(3009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3007),
  },
  [1460] = {
    [sym__automatic_semicolon] = ACTIONS(2069),
    [anon_sym_RBRACE] = ACTIONS(2069),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_COMMA] = ACTIONS(2069),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2069),
    [sym_comment] = ACTIONS(3),
  },
  [1461] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3024),
    [anon_sym_BQUOTE] = ACTIONS(3024),
    [anon_sym_PIPE] = ACTIONS(3026),
    [anon_sym_COMMA] = ACTIONS(3024),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3026),
    [anon_sym_GT_GT_GT] = ACTIONS(3024),
    [anon_sym_EQ] = ACTIONS(3026),
    [anon_sym_BANG_EQ] = ACTIONS(3026),
    [anon_sym_GT_EQ] = ACTIONS(3024),
    [anon_sym_RBRACE] = ACTIONS(3024),
    [anon_sym_PERCENT] = ACTIONS(3024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3024),
    [anon_sym_as] = ACTIONS(3024),
    [anon_sym_DASH_DASH] = ACTIONS(3024),
    [anon_sym_instanceof] = ACTIONS(3024),
    [anon_sym_COLON] = ACTIONS(3024),
    [anon_sym_DOT] = ACTIONS(3024),
    [anon_sym_STAR_STAR] = ACTIONS(3024),
    [anon_sym_PLUS_PLUS] = ACTIONS(3024),
    [anon_sym_in] = ACTIONS(3026),
    [anon_sym_BANG] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_LT_LT] = ACTIONS(3024),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_AMP_AMP] = ACTIONS(3024),
    [anon_sym_of] = ACTIONS(3024),
    [anon_sym_LT_EQ] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(3024),
    [anon_sym_RBRACK] = ACTIONS(3024),
    [anon_sym_GT] = ACTIONS(3026),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_QMARK] = ACTIONS(3024),
    [anon_sym_PIPE_PIPE] = ACTIONS(3024),
    [anon_sym_EQ_EQ] = ACTIONS(3026),
    [anon_sym_RPAREN] = ACTIONS(3024),
    [anon_sym_LT] = ACTIONS(3026),
    [anon_sym_SLASH] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3024),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_implements] = ACTIONS(3024),
    [anon_sym_GT_GT] = ACTIONS(3026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3024),
  },
  [1462] = {
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
  },
  [1463] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3047),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3047),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3047),
    [anon_sym_as] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_instanceof] = ACTIONS(3047),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_STAR_STAR] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_of] = ACTIONS(3047),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_EQ_EQ] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_SLASH] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_implements] = ACTIONS(3047),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3047),
  },
  [1464] = {
    [sym__automatic_semicolon] = ACTIONS(3058),
    [anon_sym_LBRACK] = ACTIONS(3058),
    [sym_identifier] = ACTIONS(4405),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym_module] = ACTIONS(4405),
    [anon_sym_symbol] = ACTIONS(4405),
    [anon_sym_number] = ACTIONS(4405),
    [anon_sym_AT] = ACTIONS(3058),
    [anon_sym_declare] = ACTIONS(4405),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_void] = ACTIONS(4405),
    [anon_sym_any] = ACTIONS(4405),
    [anon_sym_private] = ACTIONS(4405),
    [anon_sym_boolean] = ACTIONS(4405),
    [anon_sym_async] = ACTIONS(4405),
    [anon_sym_public] = ACTIONS(4405),
    [anon_sym_get] = ACTIONS(4405),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_static] = ACTIONS(4405),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4405),
    [anon_sym_string] = ACTIONS(4405),
    [anon_sym_abstract] = ACTIONS(4405),
    [anon_sym_set] = ACTIONS(4405),
    [anon_sym_type] = ACTIONS(4405),
    [anon_sym_export] = ACTIONS(4405),
    [anon_sym_namespace] = ACTIONS(4405),
    [sym_readonly] = ACTIONS(4405),
    [anon_sym_DQUOTE] = ACTIONS(3058),
  },
  [1465] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3060),
    [sym__automatic_semicolon] = ACTIONS(3060),
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [anon_sym_PIPE] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_GT_GT_GT] = ACTIONS(3060),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_GT_EQ] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_as] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_instanceof] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3060),
    [anon_sym_STAR_STAR] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_else] = ACTIONS(3060),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3060),
    [anon_sym_PIPE_PIPE] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3062),
    [anon_sym_SLASH] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_GT_GT] = ACTIONS(3062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3060),
  },
  [1466] = {
    [anon_sym_COLON] = ACTIONS(3085),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [sym__automatic_semicolon] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3085),
    [anon_sym_COMMA] = ACTIONS(3085),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3085),
  },
  [1467] = {
    [sym_identifier] = ACTIONS(3104),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [anon_sym_debugger] = ACTIONS(3104),
    [anon_sym_symbol] = ACTIONS(3104),
    [anon_sym_AT] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_void] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [sym_super] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_get] = ACTIONS(3104),
    [anon_sym_interface] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_if] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
    [anon_sym_yield] = ACTIONS(3104),
    [sym_true] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_abstract] = ACTIONS(3104),
    [anon_sym_set] = ACTIONS(3104),
    [anon_sym_type] = ACTIONS(3104),
    [anon_sym_import] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_DQUOTE] = ACTIONS(3102),
    [anon_sym_BANG] = ACTIONS(3102),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [sym_false] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3102),
    [anon_sym_module] = ACTIONS(3104),
    [anon_sym_number] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_declare] = ACTIONS(3104),
    [anon_sym_typeof] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3102),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [sym_null] = ACTIONS(3104),
    [anon_sym_any] = ACTIONS(3104),
    [anon_sym_boolean] = ACTIONS(3104),
    [anon_sym_async] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_var] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_SQUOTE] = ACTIONS(3102),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_LT] = ACTIONS(3102),
    [sym_number] = ACTIONS(3102),
    [anon_sym_SLASH] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3104),
    [anon_sym_function] = ACTIONS(3104),
    [sym_undefined] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_let] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_export] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_TILDE] = ACTIONS(3102),
    [anon_sym_with] = ACTIONS(3104),
    [anon_sym_await] = ACTIONS(3104),
  },
  [1468] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_GT_GT_GT] = ACTIONS(3116),
    [anon_sym_BANG_EQ] = ACTIONS(3118),
    [anon_sym_GT_EQ] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_PERCENT] = ACTIONS(3116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_instanceof] = ACTIONS(3116),
    [anon_sym_COLON] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_STAR_STAR] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_in] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_LT_EQ] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
    [anon_sym_QMARK] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_EQ_EQ] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_SLASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_implements] = ACTIONS(3116),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3116),
  },
  [1469] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1470] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3122),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_GT_GT_GT] = ACTIONS(3120),
    [anon_sym_BANG_EQ] = ACTIONS(3122),
    [anon_sym_GT_EQ] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_PERCENT] = ACTIONS(3120),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(3120),
    [anon_sym_DASH_DASH] = ACTIONS(3120),
    [anon_sym_instanceof] = ACTIONS(3120),
    [anon_sym_COLON] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(3120),
    [anon_sym_STAR_STAR] = ACTIONS(3120),
    [anon_sym_PLUS_PLUS] = ACTIONS(3120),
    [anon_sym_in] = ACTIONS(3122),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_LT_EQ] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3120),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3122),
    [anon_sym_QMARK] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_EQ_EQ] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_SLASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_implements] = ACTIONS(3120),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3120),
  },
  [1471] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1472] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3126),
    [anon_sym_BQUOTE] = ACTIONS(3126),
    [anon_sym_PIPE] = ACTIONS(3128),
    [anon_sym_COMMA] = ACTIONS(3126),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3128),
    [anon_sym_GT_GT_GT] = ACTIONS(3126),
    [anon_sym_BANG_EQ] = ACTIONS(3128),
    [anon_sym_GT_EQ] = ACTIONS(3126),
    [anon_sym_RBRACE] = ACTIONS(3126),
    [anon_sym_PERCENT] = ACTIONS(3126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3126),
    [anon_sym_as] = ACTIONS(3126),
    [anon_sym_DASH_DASH] = ACTIONS(3126),
    [anon_sym_instanceof] = ACTIONS(3126),
    [anon_sym_COLON] = ACTIONS(3126),
    [anon_sym_DOT] = ACTIONS(3126),
    [anon_sym_STAR_STAR] = ACTIONS(3126),
    [anon_sym_PLUS_PLUS] = ACTIONS(3126),
    [anon_sym_in] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3126),
    [anon_sym_LT_LT] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(3128),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_LT_EQ] = ACTIONS(3126),
    [anon_sym_LPAREN] = ACTIONS(3126),
    [anon_sym_RBRACK] = ACTIONS(3126),
    [anon_sym_GT] = ACTIONS(3128),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_QMARK] = ACTIONS(3126),
    [anon_sym_PIPE_PIPE] = ACTIONS(3126),
    [anon_sym_EQ_EQ] = ACTIONS(3128),
    [anon_sym_RPAREN] = ACTIONS(3126),
    [anon_sym_LT] = ACTIONS(3128),
    [anon_sym_SLASH] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3126),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_implements] = ACTIONS(3126),
    [anon_sym_GT_GT] = ACTIONS(3128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3126),
  },
  [1473] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3130),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [anon_sym_PIPE] = ACTIONS(3132),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3132),
    [anon_sym_STAR] = ACTIONS(3132),
    [anon_sym_GT_GT_GT] = ACTIONS(3130),
    [anon_sym_BANG_EQ] = ACTIONS(3132),
    [anon_sym_GT_EQ] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_PERCENT] = ACTIONS(3130),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3130),
    [anon_sym_as] = ACTIONS(3130),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_instanceof] = ACTIONS(3130),
    [anon_sym_COLON] = ACTIONS(3130),
    [anon_sym_DOT] = ACTIONS(3130),
    [anon_sym_STAR_STAR] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_in] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(3130),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_LT_EQ] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [anon_sym_RBRACK] = ACTIONS(3130),
    [anon_sym_GT] = ACTIONS(3132),
    [anon_sym_AMP] = ACTIONS(3132),
    [anon_sym_QMARK] = ACTIONS(3130),
    [anon_sym_PIPE_PIPE] = ACTIONS(3130),
    [anon_sym_EQ_EQ] = ACTIONS(3132),
    [anon_sym_RPAREN] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3130),
    [anon_sym_PLUS] = ACTIONS(3132),
    [anon_sym_implements] = ACTIONS(3130),
    [anon_sym_GT_GT] = ACTIONS(3132),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3130),
  },
  [1474] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(3130),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(3130),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1475] = {
    [sym__automatic_semicolon] = ACTIONS(3136),
    [anon_sym_RBRACE] = ACTIONS(3136),
    [anon_sym_SEMI] = ACTIONS(3136),
    [anon_sym_COMMA] = ACTIONS(3136),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
  },
  [1476] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [sym__automatic_semicolon] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3156),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_GT_GT_GT] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_GT_EQ] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_PIPE_PIPE] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3158),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4407),
    [anon_sym_CARET] = ACTIONS(3156),
    [anon_sym_STAR_STAR] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3158),
  },
  [1477] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [sym__automatic_semicolon] = ACTIONS(3160),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(3160),
    [anon_sym_LT_LT] = ACTIONS(3160),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_GT_GT_GT] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_BANG_EQ] = ACTIONS(3162),
    [anon_sym_LT_EQ] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_GT_EQ] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_as] = ACTIONS(3160),
    [anon_sym_PIPE_PIPE] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_EQ_EQ] = ACTIONS(3162),
    [anon_sym_instanceof] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_CARET] = ACTIONS(3160),
    [anon_sym_STAR_STAR] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_GT_GT] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3162),
  },
  [1478] = {
    [sym_string] = STATE(989),
    [sym__property_name] = STATE(989),
    [sym_computed_property_name] = STATE(989),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1479] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [sym__automatic_semicolon] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_COMMA] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_QMARK] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_instanceof] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
  },
  [1480] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [sym__automatic_semicolon] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [anon_sym_PIPE] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3202),
    [anon_sym_LT_LT] = ACTIONS(3202),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_GT_GT_GT] = ACTIONS(3202),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_BANG_EQ] = ACTIONS(3204),
    [anon_sym_LT_EQ] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_GT_EQ] = ACTIONS(3202),
    [anon_sym_GT] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3204),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [anon_sym_EQ_EQ] = ACTIONS(3204),
    [anon_sym_instanceof] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3202),
    [anon_sym_CARET] = ACTIONS(3202),
    [anon_sym_STAR_STAR] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_GT_GT] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3202),
    [anon_sym_BANG] = ACTIONS(3204),
  },
  [1481] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1533),
    [sym_function_type] = STATE(1533),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1533),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1533),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1533),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1482] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [sym__automatic_semicolon] = ACTIONS(1069),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
  },
  [1483] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [sym__automatic_semicolon] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3260),
    [anon_sym_COMMA] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3258),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_GT_GT_GT] = ACTIONS(3258),
    [anon_sym_AMP_AMP] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_BANG_EQ] = ACTIONS(3260),
    [anon_sym_LT_EQ] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_GT_EQ] = ACTIONS(3258),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3260),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_QMARK] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_as] = ACTIONS(3258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3260),
    [anon_sym_instanceof] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3258),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_STAR_STAR] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_GT_GT] = ACTIONS(3260),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_in] = ACTIONS(3260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BANG] = ACTIONS(3260),
  },
  [1484] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [sym__automatic_semicolon] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_BANG_EQ] = ACTIONS(3264),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_instanceof] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_STAR_STAR] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG] = ACTIONS(3264),
  },
  [1485] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [sym__automatic_semicolon] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_instanceof] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_STAR_STAR] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3268),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG] = ACTIONS(3268),
  },
  [1486] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [sym__automatic_semicolon] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_LT_EQ] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_GT_EQ] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_QMARK] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_EQ_EQ] = ACTIONS(3285),
    [anon_sym_instanceof] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3283),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_GT_GT] = ACTIONS(3285),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_in] = ACTIONS(3285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3283),
    [anon_sym_BANG] = ACTIONS(3285),
  },
  [1487] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [sym__automatic_semicolon] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [anon_sym_PIPE] = ACTIONS(3289),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_LT_LT] = ACTIONS(3287),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_GT_GT_GT] = ACTIONS(3287),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_BANG_EQ] = ACTIONS(3289),
    [anon_sym_LT_EQ] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_GT_EQ] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_QMARK] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_instanceof] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_CARET] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_GT_GT] = ACTIONS(3289),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_in] = ACTIONS(3289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3287),
    [anon_sym_BANG] = ACTIONS(3289),
  },
  [1488] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [sym__automatic_semicolon] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [anon_sym_PIPE] = ACTIONS(3293),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_LT_LT] = ACTIONS(3291),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_GT_GT_GT] = ACTIONS(3291),
    [anon_sym_AMP_AMP] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_GT_EQ] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_PERCENT] = ACTIONS(3291),
    [anon_sym_QMARK] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_as] = ACTIONS(3291),
    [anon_sym_PIPE_PIPE] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_instanceof] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3291),
    [anon_sym_CARET] = ACTIONS(3291),
    [anon_sym_STAR_STAR] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_GT_GT] = ACTIONS(3293),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_in] = ACTIONS(3293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(3293),
  },
  [1489] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1537),
    [sym_function_type] = STATE(1537),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1537),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1537),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1537),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1490] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3302),
    [anon_sym_BQUOTE] = ACTIONS(3302),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3304),
    [anon_sym_GT_GT_GT] = ACTIONS(3302),
    [anon_sym_BANG_EQ] = ACTIONS(3304),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_PERCENT] = ACTIONS(3302),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3302),
    [anon_sym_as] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_instanceof] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3302),
    [anon_sym_DOT] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3302),
    [anon_sym_LT_LT] = ACTIONS(3302),
    [anon_sym_LBRACE] = ACTIONS(3304),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_QMARK] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3302),
    [anon_sym_EQ_EQ] = ACTIONS(3304),
    [anon_sym_RPAREN] = ACTIONS(3302),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_SLASH] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_implements] = ACTIONS(3302),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3302),
  },
  [1491] = {
    [sym__automatic_semicolon] = ACTIONS(3308),
    [anon_sym_RBRACE] = ACTIONS(3308),
    [anon_sym_SEMI] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3308),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3308),
    [sym_comment] = ACTIONS(3),
  },
  [1492] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3310),
    [sym__automatic_semicolon] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3310),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3310),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_instanceof] = ACTIONS(3310),
    [anon_sym_DOT] = ACTIONS(3310),
    [anon_sym_STAR_STAR] = ACTIONS(3310),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_SEMI] = ACTIONS(3310),
    [anon_sym_LT_LT] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_while] = ACTIONS(3314),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3310),
  },
  [1493] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BQUOTE] = ACTIONS(3320),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_GT_GT_GT] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3322),
    [anon_sym_GT_EQ] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_PERCENT] = ACTIONS(3320),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3320),
    [anon_sym_as] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_instanceof] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3320),
    [anon_sym_DOT] = ACTIONS(3320),
    [anon_sym_STAR_STAR] = ACTIONS(3320),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_LT_LT] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3322),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_LT_EQ] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_QMARK] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_EQ_EQ] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(3320),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_implements] = ACTIONS(3320),
    [anon_sym_GT_GT] = ACTIONS(3322),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3320),
  },
  [1494] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_GT_GT_GT] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1831),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_PERCENT] = ACTIONS(1829),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_instanceof] = ACTIONS(1829),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_STAR_STAR] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_in] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1831),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_RBRACK] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_EQ_EQ] = ACTIONS(1831),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_implements] = ACTIONS(1829),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1829),
  },
  [1495] = {
    [sym__automatic_semicolon] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
  },
  [1496] = {
    [sym__automatic_semicolon] = ACTIONS(3344),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_COMMA] = ACTIONS(3344),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3344),
    [sym_comment] = ACTIONS(3),
  },
  [1497] = {
    [sym_arrow_function] = STATE(1542),
    [sym_await_expression] = STATE(1542),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1542),
    [sym_meta_property] = STATE(1542),
    [sym__expression] = STATE(1542),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1542),
    [sym_call_expression] = STATE(1542),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1542),
    [sym_string] = STATE(1542),
    [sym_template_string] = STATE(1542),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1542),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1542),
    [sym_generator_function] = STATE(1542),
    [sym_new_expression] = STATE(1542),
    [sym_assignment_expression] = STATE(1542),
    [sym_augmented_assignment_expression] = STATE(1542),
    [sym_binary_expression] = STATE(1542),
    [sym_unary_expression] = STATE(1542),
    [sym_regex] = STATE(1542),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1542),
    [sym_as_expression] = STATE(1542),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1542),
    [sym_class] = STATE(1542),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4414),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4414),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4414),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4414),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4414),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1498] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1499] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1500] = {
    [sym_type_annotation] = STATE(287),
    [anon_sym_EQ_GT] = ACTIONS(4420),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [1501] = {
    [sym_type_annotation] = STATE(593),
    [anon_sym_EQ_GT] = ACTIONS(4423),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [1502] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3378),
    [sym__automatic_semicolon] = ACTIONS(3380),
    [anon_sym_BQUOTE] = ACTIONS(3378),
    [anon_sym_PIPE] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_DASH] = ACTIONS(3386),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_GT_GT_GT] = ACTIONS(3378),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [anon_sym_PERCENT] = ACTIONS(3378),
    [anon_sym_as] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3378),
    [anon_sym_instanceof] = ACTIONS(3378),
    [anon_sym_DOT] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3378),
    [anon_sym_PLUS_PLUS] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3386),
    [anon_sym_else] = ACTIONS(3382),
    [anon_sym_BANG] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_LT_LT] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_GT] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3386),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_while] = ACTIONS(3382),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_LT] = ACTIONS(3386),
    [anon_sym_SLASH] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3386),
    [anon_sym_GT_GT] = ACTIONS(3386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3378),
  },
  [1503] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3388),
    [anon_sym_BQUOTE] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(3390),
    [anon_sym_COMMA] = ACTIONS(3388),
    [anon_sym_DASH] = ACTIONS(3390),
    [anon_sym_STAR] = ACTIONS(3390),
    [anon_sym_GT_GT_GT] = ACTIONS(3388),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT_EQ] = ACTIONS(3388),
    [anon_sym_RBRACE] = ACTIONS(3388),
    [anon_sym_PERCENT] = ACTIONS(3388),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3388),
    [anon_sym_DASH_DASH] = ACTIONS(3388),
    [anon_sym_instanceof] = ACTIONS(3388),
    [anon_sym_COLON] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_STAR_STAR] = ACTIONS(3388),
    [anon_sym_PLUS_PLUS] = ACTIONS(3388),
    [anon_sym_in] = ACTIONS(3390),
    [anon_sym_BANG] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3388),
    [anon_sym_LBRACE] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3388),
    [anon_sym_LT_EQ] = ACTIONS(3388),
    [anon_sym_LPAREN] = ACTIONS(3388),
    [anon_sym_RBRACK] = ACTIONS(3388),
    [anon_sym_GT] = ACTIONS(3390),
    [anon_sym_AMP] = ACTIONS(3390),
    [anon_sym_QMARK] = ACTIONS(3388),
    [anon_sym_PIPE_PIPE] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3390),
    [anon_sym_SLASH] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3388),
    [anon_sym_PLUS] = ACTIONS(3390),
    [anon_sym_implements] = ACTIONS(3388),
    [anon_sym_GT_GT] = ACTIONS(3390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3388),
  },
  [1504] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3392),
    [anon_sym_BQUOTE] = ACTIONS(3392),
    [anon_sym_PIPE] = ACTIONS(3394),
    [anon_sym_COMMA] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3394),
    [anon_sym_STAR] = ACTIONS(3394),
    [anon_sym_GT_GT_GT] = ACTIONS(3392),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_GT_EQ] = ACTIONS(3392),
    [anon_sym_RBRACE] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3392),
    [anon_sym_DASH_DASH] = ACTIONS(3392),
    [anon_sym_instanceof] = ACTIONS(3392),
    [anon_sym_COLON] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_STAR_STAR] = ACTIONS(3392),
    [anon_sym_PLUS_PLUS] = ACTIONS(3392),
    [anon_sym_in] = ACTIONS(3394),
    [anon_sym_BANG] = ACTIONS(3394),
    [anon_sym_LBRACK] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3392),
    [anon_sym_LT_EQ] = ACTIONS(3392),
    [anon_sym_LPAREN] = ACTIONS(3392),
    [anon_sym_RBRACK] = ACTIONS(3392),
    [anon_sym_GT] = ACTIONS(3394),
    [anon_sym_AMP] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(3392),
    [anon_sym_PIPE_PIPE] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3394),
    [anon_sym_SLASH] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_PLUS] = ACTIONS(3394),
    [anon_sym_implements] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3392),
  },
  [1505] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2884),
    [anon_sym_BQUOTE] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_GT_GT_GT] = ACTIONS(2884),
    [anon_sym_BANG_EQ] = ACTIONS(2892),
    [anon_sym_GT_EQ] = ACTIONS(2884),
    [anon_sym_RBRACE] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [anon_sym_DASH_DASH] = ACTIONS(2884),
    [anon_sym_instanceof] = ACTIONS(2884),
    [anon_sym_COLON] = ACTIONS(2884),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_STAR_STAR] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2884),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_LT_EQ] = ACTIONS(2884),
    [anon_sym_LPAREN] = ACTIONS(2884),
    [anon_sym_RBRACK] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2892),
    [anon_sym_RPAREN] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_implements] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2884),
  },
  [1506] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BQUOTE] = ACTIONS(2894),
    [anon_sym_PIPE] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_DASH] = ACTIONS(2902),
    [anon_sym_STAR] = ACTIONS(2902),
    [anon_sym_GT_GT_GT] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2902),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_PERCENT] = ACTIONS(2894),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2894),
    [anon_sym_as] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_instanceof] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_DOT] = ACTIONS(2894),
    [anon_sym_STAR_STAR] = ACTIONS(2894),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2902),
    [anon_sym_BANG] = ACTIONS(2902),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LT_LT] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2902),
    [anon_sym_AMP] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_EQ_EQ] = ACTIONS(2902),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LT] = ACTIONS(2902),
    [anon_sym_SLASH] = ACTIONS(2902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2902),
    [anon_sym_implements] = ACTIONS(2894),
    [anon_sym_GT_GT] = ACTIONS(2902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2894),
  },
  [1507] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3310),
    [anon_sym_BQUOTE] = ACTIONS(3310),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_GT_GT_GT] = ACTIONS(3310),
    [anon_sym_BANG_EQ] = ACTIONS(3318),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_PERCENT] = ACTIONS(3310),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3310),
    [anon_sym_as] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_instanceof] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3310),
    [anon_sym_DOT] = ACTIONS(3310),
    [anon_sym_STAR_STAR] = ACTIONS(3310),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_LT_LT] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3318),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_EQ_EQ] = ACTIONS(3318),
    [anon_sym_RPAREN] = ACTIONS(3310),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_implements] = ACTIONS(3310),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3310),
  },
  [1508] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3378),
    [anon_sym_BQUOTE] = ACTIONS(3378),
    [anon_sym_PIPE] = ACTIONS(3386),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_DASH] = ACTIONS(3386),
    [anon_sym_STAR] = ACTIONS(3386),
    [anon_sym_GT_GT_GT] = ACTIONS(3378),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_PERCENT] = ACTIONS(3378),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3378),
    [anon_sym_as] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3378),
    [anon_sym_instanceof] = ACTIONS(3378),
    [anon_sym_COLON] = ACTIONS(3378),
    [anon_sym_DOT] = ACTIONS(3378),
    [anon_sym_STAR_STAR] = ACTIONS(3378),
    [anon_sym_PLUS_PLUS] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3386),
    [anon_sym_BANG] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_LT_LT] = ACTIONS(3378),
    [anon_sym_LBRACE] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_RBRACK] = ACTIONS(3378),
    [anon_sym_GT] = ACTIONS(3386),
    [anon_sym_AMP] = ACTIONS(3386),
    [anon_sym_QMARK] = ACTIONS(3378),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_LT] = ACTIONS(3386),
    [anon_sym_SLASH] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3386),
    [anon_sym_implements] = ACTIONS(3378),
    [anon_sym_GT_GT] = ACTIONS(3386),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3378),
  },
  [1509] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3396),
    [anon_sym_BQUOTE] = ACTIONS(3396),
    [anon_sym_AT] = ACTIONS(3396),
    [anon_sym_PIPE] = ACTIONS(3398),
    [anon_sym_COMMA] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3398),
    [anon_sym_STAR] = ACTIONS(3398),
    [anon_sym_GT_GT_GT] = ACTIONS(3396),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_GT_EQ] = ACTIONS(3396),
    [anon_sym_RBRACE] = ACTIONS(3396),
    [anon_sym_PERCENT] = ACTIONS(3396),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3396),
    [anon_sym_DASH_DASH] = ACTIONS(3396),
    [anon_sym_instanceof] = ACTIONS(3396),
    [anon_sym_COLON] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_STAR_STAR] = ACTIONS(3396),
    [anon_sym_PLUS_PLUS] = ACTIONS(3396),
    [anon_sym_in] = ACTIONS(3398),
    [anon_sym_BANG] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(3396),
    [anon_sym_class] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3396),
    [anon_sym_LT_EQ] = ACTIONS(3396),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_RBRACK] = ACTIONS(3396),
    [anon_sym_GT] = ACTIONS(3398),
    [anon_sym_AMP] = ACTIONS(3398),
    [anon_sym_QMARK] = ACTIONS(3396),
    [anon_sym_PIPE_PIPE] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3398),
    [anon_sym_SLASH] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3396),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_export] = ACTIONS(3396),
    [anon_sym_GT_GT] = ACTIONS(3398),
    [anon_sym_implements] = ACTIONS(3396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3396),
  },
  [1510] = {
    [sym__automatic_semicolon] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
  },
  [1511] = {
    [sym__automatic_semicolon] = ACTIONS(3410),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_COMMA] = ACTIONS(3410),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
  },
  [1512] = {
    [sym__automatic_semicolon] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_SEMI] = ACTIONS(3422),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
  },
  [1513] = {
    [sym__automatic_semicolon] = ACTIONS(3426),
    [anon_sym_RBRACE] = ACTIONS(3426),
    [anon_sym_SEMI] = ACTIONS(3426),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
  },
  [1514] = {
    [sym__automatic_semicolon] = ACTIONS(3430),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_SEMI] = ACTIONS(3430),
    [anon_sym_COMMA] = ACTIONS(3430),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3430),
    [sym_comment] = ACTIONS(3),
  },
  [1515] = {
    [sym__automatic_semicolon] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(3436),
    [anon_sym_SEMI] = ACTIONS(3436),
    [anon_sym_COMMA] = ACTIONS(3436),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3436),
    [sym_comment] = ACTIONS(3),
  },
  [1516] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1517] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3521),
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3521),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3521),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3521),
    [anon_sym_instanceof] = ACTIONS(3521),
    [anon_sym_DOT] = ACTIONS(3521),
    [anon_sym_STAR_STAR] = ACTIONS(3521),
    [anon_sym_PLUS_PLUS] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_else] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_SEMI] = ACTIONS(3521),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3521),
  },
  [1518] = {
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(3045),
  },
  [1519] = {
    [sym_string] = STATE(1093),
    [sym__property_name] = STATE(1093),
    [sym_computed_property_name] = STATE(1093),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [1520] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1557),
    [sym_function_type] = STATE(1557),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1557),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1557),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1557),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1521] = {
    [sym__automatic_semicolon] = ACTIONS(2888),
    [anon_sym_RBRACE] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2888),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
  },
  [1522] = {
    [sym__automatic_semicolon] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2898),
    [sym_comment] = ACTIONS(3),
  },
  [1523] = {
    [sym__automatic_semicolon] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3382),
    [sym_comment] = ACTIONS(3),
  },
  [1524] = {
    [sym__automatic_semicolon] = ACTIONS(3589),
    [anon_sym_LBRACK] = ACTIONS(3589),
    [sym_identifier] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(3589),
    [anon_sym_module] = ACTIONS(4426),
    [anon_sym_symbol] = ACTIONS(4426),
    [anon_sym_number] = ACTIONS(4426),
    [anon_sym_AT] = ACTIONS(3589),
    [anon_sym_declare] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_void] = ACTIONS(4426),
    [anon_sym_any] = ACTIONS(4426),
    [anon_sym_private] = ACTIONS(4426),
    [anon_sym_boolean] = ACTIONS(4426),
    [anon_sym_async] = ACTIONS(4426),
    [anon_sym_public] = ACTIONS(4426),
    [anon_sym_get] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_static] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(3589),
    [sym_number] = ACTIONS(3589),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4426),
    [anon_sym_string] = ACTIONS(4426),
    [anon_sym_abstract] = ACTIONS(4426),
    [anon_sym_set] = ACTIONS(4426),
    [anon_sym_type] = ACTIONS(4426),
    [anon_sym_export] = ACTIONS(4426),
    [anon_sym_namespace] = ACTIONS(4426),
    [sym_readonly] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(3589),
  },
  [1525] = {
    [sym__automatic_semicolon] = ACTIONS(3595),
    [anon_sym_LBRACK] = ACTIONS(3595),
    [sym_identifier] = ACTIONS(4428),
    [anon_sym_SEMI] = ACTIONS(3595),
    [anon_sym_module] = ACTIONS(4428),
    [anon_sym_symbol] = ACTIONS(4428),
    [anon_sym_number] = ACTIONS(4428),
    [anon_sym_AT] = ACTIONS(3595),
    [anon_sym_declare] = ACTIONS(4428),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_void] = ACTIONS(4428),
    [anon_sym_any] = ACTIONS(4428),
    [anon_sym_private] = ACTIONS(4428),
    [anon_sym_boolean] = ACTIONS(4428),
    [anon_sym_async] = ACTIONS(4428),
    [anon_sym_public] = ACTIONS(4428),
    [anon_sym_get] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(3595),
    [anon_sym_static] = ACTIONS(4428),
    [anon_sym_SQUOTE] = ACTIONS(3595),
    [sym_number] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4428),
    [anon_sym_string] = ACTIONS(4428),
    [anon_sym_abstract] = ACTIONS(4428),
    [anon_sym_set] = ACTIONS(4428),
    [anon_sym_type] = ACTIONS(4428),
    [anon_sym_export] = ACTIONS(4428),
    [anon_sym_namespace] = ACTIONS(4428),
    [sym_readonly] = ACTIONS(4428),
    [anon_sym_DQUOTE] = ACTIONS(3595),
  },
  [1526] = {
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [sym__automatic_semicolon] = ACTIONS(3621),
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3621),
    [anon_sym_COMMA] = ACTIONS(3621),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3621),
  },
  [1527] = {
    [sym__automatic_semicolon] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3629),
    [anon_sym_COMMA] = ACTIONS(3629),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
  },
  [1528] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3631),
    [sym__automatic_semicolon] = ACTIONS(3633),
    [anon_sym_BQUOTE] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3631),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_GT_EQ] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_instanceof] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3631),
    [anon_sym_STAR_STAR] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_else] = ACTIONS(3635),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_LT_EQ] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_QMARK] = ACTIONS(3631),
    [anon_sym_PIPE_PIPE] = ACTIONS(3631),
    [anon_sym_while] = ACTIONS(3635),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3631),
  },
  [1529] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3641),
    [anon_sym_BQUOTE] = ACTIONS(3641),
    [anon_sym_PIPE] = ACTIONS(3643),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3643),
    [anon_sym_STAR] = ACTIONS(3643),
    [anon_sym_GT_GT_GT] = ACTIONS(3641),
    [anon_sym_BANG_EQ] = ACTIONS(3643),
    [anon_sym_GT_EQ] = ACTIONS(3641),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_PERCENT] = ACTIONS(3641),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3641),
    [anon_sym_as] = ACTIONS(3641),
    [anon_sym_DASH_DASH] = ACTIONS(3641),
    [anon_sym_instanceof] = ACTIONS(3641),
    [anon_sym_COLON] = ACTIONS(3641),
    [anon_sym_DOT] = ACTIONS(3641),
    [anon_sym_STAR_STAR] = ACTIONS(3641),
    [anon_sym_PLUS_PLUS] = ACTIONS(3641),
    [anon_sym_in] = ACTIONS(3643),
    [anon_sym_BANG] = ACTIONS(3643),
    [anon_sym_LBRACK] = ACTIONS(3641),
    [anon_sym_LT_LT] = ACTIONS(3641),
    [anon_sym_LBRACE] = ACTIONS(3643),
    [anon_sym_AMP_AMP] = ACTIONS(3641),
    [anon_sym_LT_EQ] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(3641),
    [anon_sym_RBRACK] = ACTIONS(3641),
    [anon_sym_GT] = ACTIONS(3643),
    [anon_sym_AMP] = ACTIONS(3643),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3641),
    [anon_sym_EQ_EQ] = ACTIONS(3643),
    [anon_sym_RPAREN] = ACTIONS(3641),
    [anon_sym_LT] = ACTIONS(3643),
    [anon_sym_SLASH] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3641),
    [anon_sym_PLUS] = ACTIONS(3643),
    [anon_sym_implements] = ACTIONS(3641),
    [anon_sym_GT_GT] = ACTIONS(3643),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3641),
  },
  [1530] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [sym__automatic_semicolon] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_BQUOTE] = ACTIONS(3653),
    [anon_sym_PIPE] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3653),
    [anon_sym_LT_LT] = ACTIONS(3653),
    [anon_sym_STAR] = ACTIONS(3655),
    [anon_sym_GT_GT_GT] = ACTIONS(3653),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_BANG_EQ] = ACTIONS(3655),
    [anon_sym_LT_EQ] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_GT_EQ] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_PERCENT] = ACTIONS(3653),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3653),
    [anon_sym_PIPE_PIPE] = ACTIONS(3653),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_EQ_EQ] = ACTIONS(3655),
    [anon_sym_instanceof] = ACTIONS(3653),
    [anon_sym_LT] = ACTIONS(3655),
    [anon_sym_SLASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3653),
    [anon_sym_CARET] = ACTIONS(3653),
    [anon_sym_STAR_STAR] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3653),
    [anon_sym_GT_GT] = ACTIONS(3655),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3653),
    [anon_sym_BANG] = ACTIONS(3655),
  },
  [1531] = {
    [sym_string] = STATE(1132),
    [sym__property_name] = STATE(1132),
    [sym_computed_property_name] = STATE(1132),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3692),
    [anon_sym_LBRACK] = ACTIONS(3692),
    [sym__automatic_semicolon] = ACTIONS(3692),
    [anon_sym_SEMI] = ACTIONS(3692),
    [anon_sym_BQUOTE] = ACTIONS(3692),
    [anon_sym_PIPE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3692),
    [anon_sym_LT_LT] = ACTIONS(3692),
    [anon_sym_STAR] = ACTIONS(3694),
    [anon_sym_GT_GT_GT] = ACTIONS(3692),
    [anon_sym_AMP_AMP] = ACTIONS(3692),
    [anon_sym_DASH] = ACTIONS(3694),
    [anon_sym_BANG_EQ] = ACTIONS(3694),
    [anon_sym_LT_EQ] = ACTIONS(3692),
    [anon_sym_LPAREN] = ACTIONS(3692),
    [anon_sym_GT_EQ] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3694),
    [anon_sym_AMP] = ACTIONS(3694),
    [anon_sym_PERCENT] = ACTIONS(3692),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [anon_sym_as] = ACTIONS(3692),
    [anon_sym_PIPE_PIPE] = ACTIONS(3692),
    [anon_sym_DASH_DASH] = ACTIONS(3692),
    [anon_sym_EQ_EQ] = ACTIONS(3694),
    [anon_sym_instanceof] = ACTIONS(3692),
    [anon_sym_LT] = ACTIONS(3694),
    [anon_sym_SLASH] = ACTIONS(3694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3692),
    [anon_sym_CARET] = ACTIONS(3692),
    [anon_sym_STAR_STAR] = ACTIONS(3692),
    [anon_sym_PLUS] = ACTIONS(3694),
    [anon_sym_GT_GT] = ACTIONS(3694),
    [anon_sym_PLUS_PLUS] = ACTIONS(3692),
    [anon_sym_in] = ACTIONS(3694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3692),
    [anon_sym_BANG] = ACTIONS(3694),
  },
  [1533] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3696),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [sym__automatic_semicolon] = ACTIONS(3696),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(3696),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(3696),
    [anon_sym_LT_LT] = ACTIONS(3696),
    [anon_sym_STAR] = ACTIONS(3698),
    [anon_sym_GT_GT_GT] = ACTIONS(3696),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_DASH] = ACTIONS(3698),
    [anon_sym_BANG_EQ] = ACTIONS(3698),
    [anon_sym_LT_EQ] = ACTIONS(3696),
    [anon_sym_LPAREN] = ACTIONS(3696),
    [anon_sym_GT_EQ] = ACTIONS(3696),
    [anon_sym_GT] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(3696),
    [anon_sym_QMARK] = ACTIONS(3696),
    [anon_sym_RBRACE] = ACTIONS(3696),
    [anon_sym_as] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(3696),
    [anon_sym_EQ_EQ] = ACTIONS(3698),
    [anon_sym_instanceof] = ACTIONS(3696),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_SLASH] = ACTIONS(3698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3696),
    [anon_sym_CARET] = ACTIONS(3696),
    [anon_sym_STAR_STAR] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_GT_GT] = ACTIONS(3698),
    [anon_sym_PLUS_PLUS] = ACTIONS(3696),
    [anon_sym_in] = ACTIONS(3698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3696),
    [anon_sym_BANG] = ACTIONS(3698),
  },
  [1534] = {
    [sym_generic_type] = STATE(1307),
    [sym_type_predicate] = STATE(1307),
    [sym_literal_type] = STATE(1307),
    [sym__number] = STATE(1301),
    [sym_object_type] = STATE(1307),
    [sym_intersection_type] = STATE(1568),
    [sym_function_type] = STATE(1568),
    [sym_nested_identifier] = STATE(2256),
    [sym_nested_type_identifier] = STATE(1308),
    [sym__type] = STATE(1568),
    [sym_type_query] = STATE(1307),
    [sym_index_type_query] = STATE(1307),
    [sym_existential_type] = STATE(1307),
    [sym_flow_maybe_type] = STATE(1307),
    [sym_string] = STATE(1301),
    [sym_type_parameters] = STATE(2257),
    [sym_array_type] = STATE(1307),
    [sym_formal_parameters] = STATE(1849),
    [sym_constructor_type] = STATE(1568),
    [sym__primary_type] = STATE(1307),
    [sym_lookup_type] = STATE(1307),
    [sym_parenthesized_type] = STATE(1307),
    [sym_predefined_type] = STATE(1307),
    [sym_tuple_type] = STATE(1307),
    [sym_union_type] = STATE(1568),
    [sym_identifier] = ACTIONS(1476),
    [sym_false] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(1480),
    [anon_sym_symbol] = ACTIONS(1482),
    [anon_sym_number] = ACTIONS(1482),
    [anon_sym_typeof] = ACTIONS(1484),
    [anon_sym_keyof] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1490),
    [anon_sym_LBRACE] = ACTIONS(1492),
    [anon_sym_PIPE] = ACTIONS(1494),
    [anon_sym_void] = ACTIONS(1482),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_any] = ACTIONS(1482),
    [anon_sym_boolean] = ACTIONS(1482),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_AMP] = ACTIONS(1500),
    [anon_sym_QMARK] = ACTIONS(1502),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [sym_this] = ACTIONS(1504),
    [sym_number] = ACTIONS(1506),
    [sym_true] = ACTIONS(1478),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1482),
    [anon_sym_new] = ACTIONS(1508),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_DQUOTE] = ACTIONS(53),
  },
  [1535] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3741),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [sym__automatic_semicolon] = ACTIONS(3741),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_BQUOTE] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(3741),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_GT_GT_GT] = ACTIONS(3741),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_LT_EQ] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_GT_EQ] = ACTIONS(3741),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_PERCENT] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(3741),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_EQ_EQ] = ACTIONS(3743),
    [anon_sym_instanceof] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3743),
    [anon_sym_SLASH] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3741),
    [anon_sym_CARET] = ACTIONS(3741),
    [anon_sym_STAR_STAR] = ACTIONS(3741),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_GT_GT] = ACTIONS(3743),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3741),
    [anon_sym_BANG] = ACTIONS(3743),
  },
  [1536] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [sym__automatic_semicolon] = ACTIONS(3749),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(3749),
    [anon_sym_STAR] = ACTIONS(3751),
    [anon_sym_GT_GT_GT] = ACTIONS(3749),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_BANG_EQ] = ACTIONS(3751),
    [anon_sym_LT_EQ] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_as] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(3751),
    [anon_sym_instanceof] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_SLASH] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3749),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_STAR_STAR] = ACTIONS(3749),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_GT_GT] = ACTIONS(3751),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BANG] = ACTIONS(3751),
  },
  [1537] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [sym__automatic_semicolon] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(3753),
    [anon_sym_LT_LT] = ACTIONS(3753),
    [anon_sym_STAR] = ACTIONS(3755),
    [anon_sym_GT_GT_GT] = ACTIONS(3753),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_BANG_EQ] = ACTIONS(3755),
    [anon_sym_LT_EQ] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_GT_EQ] = ACTIONS(3753),
    [anon_sym_GT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_EQ_EQ] = ACTIONS(3755),
    [anon_sym_instanceof] = ACTIONS(3753),
    [anon_sym_LT] = ACTIONS(3755),
    [anon_sym_SLASH] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_CARET] = ACTIONS(3753),
    [anon_sym_STAR_STAR] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_GT_GT] = ACTIONS(3755),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3753),
    [anon_sym_BANG] = ACTIONS(3755),
  },
  [1538] = {
    [sym__automatic_semicolon] = ACTIONS(3759),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_SEMI] = ACTIONS(3759),
    [anon_sym_COMMA] = ACTIONS(3759),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3759),
    [sym_comment] = ACTIONS(3),
  },
  [1539] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3761),
    [sym__automatic_semicolon] = ACTIONS(3763),
    [anon_sym_BQUOTE] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_GT_GT_GT] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_PERCENT] = ACTIONS(3761),
    [anon_sym_as] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_instanceof] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3761),
    [anon_sym_STAR_STAR] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_in] = ACTIONS(3769),
    [anon_sym_else] = ACTIONS(3765),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_SEMI] = ACTIONS(3761),
    [anon_sym_LT_LT] = ACTIONS(3761),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_while] = ACTIONS(3765),
    [anon_sym_EQ_EQ] = ACTIONS(3769),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3761),
  },
  [1540] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2726),
    [anon_sym_BQUOTE] = ACTIONS(2726),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_COMMA] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_STAR] = ACTIONS(2728),
    [anon_sym_GT_GT_GT] = ACTIONS(2728),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_BANG_EQ] = ACTIONS(2728),
    [anon_sym_GT_EQ] = ACTIONS(2726),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_PERCENT] = ACTIONS(2728),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2726),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_instanceof] = ACTIONS(2726),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2726),
    [anon_sym_STAR_STAR] = ACTIONS(2728),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2728),
    [anon_sym_LBRACE] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_LT_EQ] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_RBRACK] = ACTIONS(2726),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_EQ_EQ] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_SLASH] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_implements] = ACTIONS(2726),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2726),
  },
  [1541] = {
    [sym__automatic_semicolon] = ACTIONS(3793),
    [anon_sym_RBRACE] = ACTIONS(3793),
    [anon_sym_SEMI] = ACTIONS(3793),
    [anon_sym_COMMA] = ACTIONS(3793),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3793),
    [sym_comment] = ACTIONS(3),
  },
  [1542] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACE] = ACTIONS(3799),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_BANG] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_RPAREN] = ACTIONS(3799),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
  },
  [1543] = {
    [sym_type_annotation] = STATE(593),
    [anon_sym_EQ_GT] = ACTIONS(4430),
    [anon_sym_COLON] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [1544] = {
    [sym__automatic_semicolon] = ACTIONS(3808),
    [anon_sym_RBRACE] = ACTIONS(3808),
    [anon_sym_SEMI] = ACTIONS(3808),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
  },
  [1545] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [sym__automatic_semicolon] = ACTIONS(3816),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_else] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_SEMI] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
  },
  [1546] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [sym__automatic_semicolon] = ACTIONS(3826),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_else] = ACTIONS(3828),
    [anon_sym_BANG] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_while] = ACTIONS(3828),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_SLASH] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
  },
  [1547] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(3834),
    [anon_sym_PIPE] = ACTIONS(3836),
    [anon_sym_COMMA] = ACTIONS(3834),
    [anon_sym_DASH] = ACTIONS(3836),
    [anon_sym_STAR] = ACTIONS(3836),
    [anon_sym_GT_GT_GT] = ACTIONS(3834),
    [anon_sym_BANG_EQ] = ACTIONS(3836),
    [anon_sym_GT_EQ] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(3834),
    [anon_sym_PERCENT] = ACTIONS(3834),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3834),
    [anon_sym_as] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(3834),
    [anon_sym_instanceof] = ACTIONS(3834),
    [anon_sym_COLON] = ACTIONS(3834),
    [anon_sym_DOT] = ACTIONS(3834),
    [anon_sym_STAR_STAR] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3834),
    [anon_sym_in] = ACTIONS(3836),
    [anon_sym_BANG] = ACTIONS(3836),
    [anon_sym_LBRACK] = ACTIONS(3834),
    [anon_sym_LT_LT] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_AMP_AMP] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3834),
    [anon_sym_RBRACK] = ACTIONS(3834),
    [anon_sym_GT] = ACTIONS(3836),
    [anon_sym_AMP] = ACTIONS(3836),
    [anon_sym_QMARK] = ACTIONS(3834),
    [anon_sym_PIPE_PIPE] = ACTIONS(3834),
    [anon_sym_EQ_EQ] = ACTIONS(3836),
    [anon_sym_RPAREN] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(3836),
    [anon_sym_SLASH] = ACTIONS(3836),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3836),
    [anon_sym_implements] = ACTIONS(3834),
    [anon_sym_GT_GT] = ACTIONS(3836),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3834),
  },
  [1548] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3521),
    [anon_sym_BQUOTE] = ACTIONS(3521),
    [anon_sym_PIPE] = ACTIONS(3529),
    [anon_sym_COMMA] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3521),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3521),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_PERCENT] = ACTIONS(3521),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3521),
    [anon_sym_as] = ACTIONS(3521),
    [anon_sym_DASH_DASH] = ACTIONS(3521),
    [anon_sym_instanceof] = ACTIONS(3521),
    [anon_sym_COLON] = ACTIONS(3521),
    [anon_sym_DOT] = ACTIONS(3521),
    [anon_sym_STAR_STAR] = ACTIONS(3521),
    [anon_sym_PLUS_PLUS] = ACTIONS(3521),
    [anon_sym_in] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3521),
    [anon_sym_LT_LT] = ACTIONS(3521),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3521),
    [anon_sym_LT_EQ] = ACTIONS(3521),
    [anon_sym_LPAREN] = ACTIONS(3521),
    [anon_sym_RBRACK] = ACTIONS(3521),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3529),
    [anon_sym_QMARK] = ACTIONS(3521),
    [anon_sym_PIPE_PIPE] = ACTIONS(3521),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3521),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_implements] = ACTIONS(3521),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3521),
  },
  [1549] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3631),
    [anon_sym_BQUOTE] = ACTIONS(3631),
    [anon_sym_PIPE] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_STAR] = ACTIONS(3639),
    [anon_sym_GT_GT_GT] = ACTIONS(3631),
    [anon_sym_BANG_EQ] = ACTIONS(3639),
    [anon_sym_GT_EQ] = ACTIONS(3631),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_PERCENT] = ACTIONS(3631),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3631),
    [anon_sym_as] = ACTIONS(3631),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_instanceof] = ACTIONS(3631),
    [anon_sym_COLON] = ACTIONS(3631),
    [anon_sym_DOT] = ACTIONS(3631),
    [anon_sym_STAR_STAR] = ACTIONS(3631),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_in] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3639),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [anon_sym_LT_LT] = ACTIONS(3631),
    [anon_sym_LBRACE] = ACTIONS(3639),
    [anon_sym_AMP_AMP] = ACTIONS(3631),
    [anon_sym_LT_EQ] = ACTIONS(3631),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [anon_sym_RBRACK] = ACTIONS(3631),
    [anon_sym_GT] = ACTIONS(3639),
    [anon_sym_AMP] = ACTIONS(3639),
    [anon_sym_QMARK] = ACTIONS(3631),
    [anon_sym_PIPE_PIPE] = ACTIONS(3631),
    [anon_sym_EQ_EQ] = ACTIONS(3639),
    [anon_sym_RPAREN] = ACTIONS(3631),
    [anon_sym_LT] = ACTIONS(3639),
    [anon_sym_SLASH] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3631),
    [anon_sym_PLUS] = ACTIONS(3639),
    [anon_sym_implements] = ACTIONS(3631),
    [anon_sym_GT_GT] = ACTIONS(3639),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3631),
  },
  [1550] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3761),
    [anon_sym_BQUOTE] = ACTIONS(3761),
    [anon_sym_PIPE] = ACTIONS(3769),
    [anon_sym_COMMA] = ACTIONS(3761),
    [anon_sym_DASH] = ACTIONS(3769),
    [anon_sym_STAR] = ACTIONS(3769),
    [anon_sym_GT_GT_GT] = ACTIONS(3761),
    [anon_sym_BANG_EQ] = ACTIONS(3769),
    [anon_sym_GT_EQ] = ACTIONS(3761),
    [anon_sym_RBRACE] = ACTIONS(3761),
    [anon_sym_PERCENT] = ACTIONS(3761),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3761),
    [anon_sym_as] = ACTIONS(3761),
    [anon_sym_DASH_DASH] = ACTIONS(3761),
    [anon_sym_instanceof] = ACTIONS(3761),
    [anon_sym_COLON] = ACTIONS(3761),
    [anon_sym_DOT] = ACTIONS(3761),
    [anon_sym_STAR_STAR] = ACTIONS(3761),
    [anon_sym_PLUS_PLUS] = ACTIONS(3761),
    [anon_sym_in] = ACTIONS(3769),
    [anon_sym_BANG] = ACTIONS(3769),
    [anon_sym_LBRACK] = ACTIONS(3761),
    [anon_sym_LT_LT] = ACTIONS(3761),
    [anon_sym_LBRACE] = ACTIONS(3769),
    [anon_sym_AMP_AMP] = ACTIONS(3761),
    [anon_sym_LT_EQ] = ACTIONS(3761),
    [anon_sym_LPAREN] = ACTIONS(3761),
    [anon_sym_RBRACK] = ACTIONS(3761),
    [anon_sym_GT] = ACTIONS(3769),
    [anon_sym_AMP] = ACTIONS(3769),
    [anon_sym_QMARK] = ACTIONS(3761),
    [anon_sym_PIPE_PIPE] = ACTIONS(3761),
    [anon_sym_EQ_EQ] = ACTIONS(3769),
    [anon_sym_RPAREN] = ACTIONS(3761),
    [anon_sym_LT] = ACTIONS(3769),
    [anon_sym_SLASH] = ACTIONS(3769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3761),
    [anon_sym_PLUS] = ACTIONS(3769),
    [anon_sym_implements] = ACTIONS(3761),
    [anon_sym_GT_GT] = ACTIONS(3769),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3761),
  },
  [1551] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3814),
    [anon_sym_BQUOTE] = ACTIONS(3814),
    [anon_sym_PIPE] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3814),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3822),
    [anon_sym_GT_GT_GT] = ACTIONS(3814),
    [anon_sym_BANG_EQ] = ACTIONS(3822),
    [anon_sym_GT_EQ] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3814),
    [anon_sym_PERCENT] = ACTIONS(3814),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3814),
    [anon_sym_as] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3814),
    [anon_sym_instanceof] = ACTIONS(3814),
    [anon_sym_COLON] = ACTIONS(3814),
    [anon_sym_DOT] = ACTIONS(3814),
    [anon_sym_STAR_STAR] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3814),
    [anon_sym_in] = ACTIONS(3822),
    [anon_sym_BANG] = ACTIONS(3822),
    [anon_sym_LBRACK] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3814),
    [anon_sym_LBRACE] = ACTIONS(3822),
    [anon_sym_AMP_AMP] = ACTIONS(3814),
    [anon_sym_LT_EQ] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3814),
    [anon_sym_RBRACK] = ACTIONS(3814),
    [anon_sym_GT] = ACTIONS(3822),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_QMARK] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE] = ACTIONS(3814),
    [anon_sym_EQ_EQ] = ACTIONS(3822),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(3822),
    [anon_sym_SLASH] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_implements] = ACTIONS(3814),
    [anon_sym_GT_GT] = ACTIONS(3822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3814),
  },
  [1552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3824),
    [anon_sym_BQUOTE] = ACTIONS(3824),
    [anon_sym_PIPE] = ACTIONS(3832),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3832),
    [anon_sym_STAR] = ACTIONS(3832),
    [anon_sym_GT_GT_GT] = ACTIONS(3824),
    [anon_sym_BANG_EQ] = ACTIONS(3832),
    [anon_sym_GT_EQ] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_PERCENT] = ACTIONS(3824),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3824),
    [anon_sym_as] = ACTIONS(3824),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [anon_sym_instanceof] = ACTIONS(3824),
    [anon_sym_COLON] = ACTIONS(3824),
    [anon_sym_DOT] = ACTIONS(3824),
    [anon_sym_STAR_STAR] = ACTIONS(3824),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_in] = ACTIONS(3832),
    [anon_sym_BANG] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3824),
    [anon_sym_LT_LT] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_LT_EQ] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(3824),
    [anon_sym_RBRACK] = ACTIONS(3824),
    [anon_sym_GT] = ACTIONS(3832),
    [anon_sym_AMP] = ACTIONS(3832),
    [anon_sym_QMARK] = ACTIONS(3824),
    [anon_sym_PIPE_PIPE] = ACTIONS(3824),
    [anon_sym_EQ_EQ] = ACTIONS(3832),
    [anon_sym_RPAREN] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3832),
    [anon_sym_SLASH] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3824),
    [anon_sym_PLUS] = ACTIONS(3832),
    [anon_sym_implements] = ACTIONS(3824),
    [anon_sym_GT_GT] = ACTIONS(3832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3824),
  },
  [1553] = {
    [sym__automatic_semicolon] = ACTIONS(3840),
    [anon_sym_RBRACE] = ACTIONS(3840),
    [anon_sym_SEMI] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3840),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3840),
    [sym_comment] = ACTIONS(3),
  },
  [1554] = {
    [sym__automatic_semicolon] = ACTIONS(3851),
    [anon_sym_RBRACE] = ACTIONS(3851),
    [anon_sym_SEMI] = ACTIONS(3851),
    [anon_sym_COMMA] = ACTIONS(3851),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3851),
    [sym_comment] = ACTIONS(3),
  },
  [1555] = {
    [sym__automatic_semicolon] = ACTIONS(3855),
    [anon_sym_RBRACE] = ACTIONS(3855),
    [anon_sym_SEMI] = ACTIONS(3855),
    [anon_sym_COMMA] = ACTIONS(3855),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3855),
    [sym_comment] = ACTIONS(3),
  },
  [1556] = {
    [sym_string] = STATE(1174),
    [sym__property_name] = STATE(1174),
    [sym_computed_property_name] = STATE(1174),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(1783),
  },
  [1557] = {
    [anon_sym_else] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
  },
  [1558] = {
    [sym__automatic_semicolon] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3525),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
  },
  [1559] = {
    [sym__automatic_semicolon] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3818),
    [sym_comment] = ACTIONS(3),
  },
  [1560] = {
    [sym__automatic_semicolon] = ACTIONS(3828),
    [anon_sym_RBRACE] = ACTIONS(3828),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_COMMA] = ACTIONS(3828),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3828),
    [sym_comment] = ACTIONS(3),
  },
  [1561] = {
    [sym__automatic_semicolon] = ACTIONS(3949),
    [anon_sym_LBRACK] = ACTIONS(3949),
    [sym_identifier] = ACTIONS(4433),
    [anon_sym_SEMI] = ACTIONS(3949),
    [anon_sym_module] = ACTIONS(4433),
    [anon_sym_symbol] = ACTIONS(4433),
    [anon_sym_number] = ACTIONS(4433),
    [anon_sym_AT] = ACTIONS(3949),
    [anon_sym_declare] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(3949),
    [anon_sym_void] = ACTIONS(4433),
    [anon_sym_any] = ACTIONS(4433),
    [anon_sym_private] = ACTIONS(4433),
    [anon_sym_boolean] = ACTIONS(4433),
    [anon_sym_async] = ACTIONS(4433),
    [anon_sym_public] = ACTIONS(4433),
    [anon_sym_get] = ACTIONS(4433),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_static] = ACTIONS(4433),
    [anon_sym_SQUOTE] = ACTIONS(3949),
    [sym_number] = ACTIONS(3949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4433),
    [anon_sym_string] = ACTIONS(4433),
    [anon_sym_abstract] = ACTIONS(4433),
    [anon_sym_set] = ACTIONS(4433),
    [anon_sym_type] = ACTIONS(4433),
    [anon_sym_export] = ACTIONS(4433),
    [anon_sym_namespace] = ACTIONS(4433),
    [sym_readonly] = ACTIONS(4433),
    [anon_sym_DQUOTE] = ACTIONS(3949),
  },
  [1562] = {
    [sym__automatic_semicolon] = ACTIONS(3951),
    [anon_sym_LBRACK] = ACTIONS(3951),
    [sym_identifier] = ACTIONS(4435),
    [anon_sym_SEMI] = ACTIONS(3951),
    [anon_sym_module] = ACTIONS(4435),
    [anon_sym_symbol] = ACTIONS(4435),
    [anon_sym_number] = ACTIONS(4435),
    [anon_sym_AT] = ACTIONS(3951),
    [anon_sym_declare] = ACTIONS(4435),
    [anon_sym_STAR] = ACTIONS(3951),
    [anon_sym_void] = ACTIONS(4435),
    [anon_sym_any] = ACTIONS(4435),
    [anon_sym_private] = ACTIONS(4435),
    [anon_sym_boolean] = ACTIONS(4435),
    [anon_sym_async] = ACTIONS(4435),
    [anon_sym_public] = ACTIONS(4435),
    [anon_sym_get] = ACTIONS(4435),
    [anon_sym_RBRACE] = ACTIONS(3951),
    [anon_sym_static] = ACTIONS(4435),
    [anon_sym_SQUOTE] = ACTIONS(3951),
    [sym_number] = ACTIONS(3951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4435),
    [anon_sym_string] = ACTIONS(4435),
    [anon_sym_abstract] = ACTIONS(4435),
    [anon_sym_set] = ACTIONS(4435),
    [anon_sym_type] = ACTIONS(4435),
    [anon_sym_export] = ACTIONS(4435),
    [anon_sym_namespace] = ACTIONS(4435),
    [sym_readonly] = ACTIONS(4435),
    [anon_sym_DQUOTE] = ACTIONS(3951),
  },
  [1563] = {
    [anon_sym_COLON] = ACTIONS(3965),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [sym__automatic_semicolon] = ACTIONS(3965),
    [anon_sym_SEMI] = ACTIONS(3965),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3965),
    [anon_sym_COMMA] = ACTIONS(3965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3965),
  },
  [1564] = {
    [sym__automatic_semicolon] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_SEMI] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3969),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
  },
  [1565] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3971),
    [sym__automatic_semicolon] = ACTIONS(3973),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3971),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_GT_EQ] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [anon_sym_instanceof] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_else] = ACTIONS(3975),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_SEMI] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_while] = ACTIONS(3975),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3971),
  },
  [1566] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [sym__automatic_semicolon] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_BANG_EQ] = ACTIONS(3983),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_as] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3983),
    [anon_sym_instanceof] = ACTIONS(3981),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_SLASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_STAR_STAR] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BANG] = ACTIONS(3983),
  },
  [1567] = {
    [sym_string] = STATE(1200),
    [sym__property_name] = STATE(1200),
    [sym_computed_property_name] = STATE(1200),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1568] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [sym__automatic_semicolon] = ACTIONS(4007),
    [anon_sym_SEMI] = ACTIONS(4007),
    [anon_sym_BQUOTE] = ACTIONS(4007),
    [anon_sym_PIPE] = ACTIONS(4410),
    [anon_sym_COMMA] = ACTIONS(4007),
    [anon_sym_LT_LT] = ACTIONS(4007),
    [anon_sym_STAR] = ACTIONS(4009),
    [anon_sym_GT_GT_GT] = ACTIONS(4007),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_BANG_EQ] = ACTIONS(4009),
    [anon_sym_LT_EQ] = ACTIONS(4007),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_GT_EQ] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4412),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_as] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_DASH_DASH] = ACTIONS(4007),
    [anon_sym_EQ_EQ] = ACTIONS(4009),
    [anon_sym_instanceof] = ACTIONS(4007),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_SLASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_CARET] = ACTIONS(4007),
    [anon_sym_STAR_STAR] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym_PLUS_PLUS] = ACTIONS(4007),
    [anon_sym_in] = ACTIONS(4009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4007),
    [anon_sym_BANG] = ACTIONS(4009),
  },
  [1569] = {
    [sym__automatic_semicolon] = ACTIONS(4023),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_SEMI] = ACTIONS(4023),
    [anon_sym_COMMA] = ACTIONS(4023),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4023),
    [sym_comment] = ACTIONS(3),
  },
  [1570] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_RPAREN] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_implements] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1571] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [sym__automatic_semicolon] = ACTIONS(4040),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_BANG_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4046),
    [anon_sym_else] = ACTIONS(4042),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [anon_sym_SEMI] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_while] = ACTIONS(4042),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_PLUS] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
  },
  [1572] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3971),
    [anon_sym_BQUOTE] = ACTIONS(3971),
    [anon_sym_PIPE] = ACTIONS(3979),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_DASH] = ACTIONS(3979),
    [anon_sym_STAR] = ACTIONS(3979),
    [anon_sym_GT_GT_GT] = ACTIONS(3971),
    [anon_sym_BANG_EQ] = ACTIONS(3979),
    [anon_sym_GT_EQ] = ACTIONS(3971),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_PERCENT] = ACTIONS(3971),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3971),
    [anon_sym_as] = ACTIONS(3971),
    [anon_sym_DASH_DASH] = ACTIONS(3971),
    [anon_sym_instanceof] = ACTIONS(3971),
    [anon_sym_COLON] = ACTIONS(3971),
    [anon_sym_DOT] = ACTIONS(3971),
    [anon_sym_STAR_STAR] = ACTIONS(3971),
    [anon_sym_PLUS_PLUS] = ACTIONS(3971),
    [anon_sym_in] = ACTIONS(3979),
    [anon_sym_BANG] = ACTIONS(3979),
    [anon_sym_LBRACK] = ACTIONS(3971),
    [anon_sym_LT_LT] = ACTIONS(3971),
    [anon_sym_LBRACE] = ACTIONS(3979),
    [anon_sym_AMP_AMP] = ACTIONS(3971),
    [anon_sym_LT_EQ] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3971),
    [anon_sym_RBRACK] = ACTIONS(3971),
    [anon_sym_GT] = ACTIONS(3979),
    [anon_sym_AMP] = ACTIONS(3979),
    [anon_sym_QMARK] = ACTIONS(3971),
    [anon_sym_PIPE_PIPE] = ACTIONS(3971),
    [anon_sym_EQ_EQ] = ACTIONS(3979),
    [anon_sym_RPAREN] = ACTIONS(3971),
    [anon_sym_LT] = ACTIONS(3979),
    [anon_sym_SLASH] = ACTIONS(3979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3971),
    [anon_sym_PLUS] = ACTIONS(3979),
    [anon_sym_implements] = ACTIONS(3971),
    [anon_sym_GT_GT] = ACTIONS(3979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3971),
  },
  [1573] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4038),
    [anon_sym_BQUOTE] = ACTIONS(4038),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_COMMA] = ACTIONS(4038),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_STAR] = ACTIONS(4046),
    [anon_sym_GT_GT_GT] = ACTIONS(4038),
    [anon_sym_BANG_EQ] = ACTIONS(4046),
    [anon_sym_GT_EQ] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_PERCENT] = ACTIONS(4038),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4038),
    [anon_sym_as] = ACTIONS(4038),
    [anon_sym_DASH_DASH] = ACTIONS(4038),
    [anon_sym_instanceof] = ACTIONS(4038),
    [anon_sym_COLON] = ACTIONS(4038),
    [anon_sym_DOT] = ACTIONS(4038),
    [anon_sym_STAR_STAR] = ACTIONS(4038),
    [anon_sym_PLUS_PLUS] = ACTIONS(4038),
    [anon_sym_in] = ACTIONS(4046),
    [anon_sym_BANG] = ACTIONS(4046),
    [anon_sym_LBRACK] = ACTIONS(4038),
    [anon_sym_LT_LT] = ACTIONS(4038),
    [anon_sym_LBRACE] = ACTIONS(4046),
    [anon_sym_AMP_AMP] = ACTIONS(4038),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4038),
    [anon_sym_RBRACK] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_AMP] = ACTIONS(4046),
    [anon_sym_QMARK] = ACTIONS(4038),
    [anon_sym_PIPE_PIPE] = ACTIONS(4038),
    [anon_sym_EQ_EQ] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(4038),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4038),
    [anon_sym_PLUS] = ACTIONS(4046),
    [anon_sym_implements] = ACTIONS(4038),
    [anon_sym_GT_GT] = ACTIONS(4046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4038),
  },
  [1574] = {
    [sym__automatic_semicolon] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [anon_sym_SEMI] = ACTIONS(4050),
    [anon_sym_COMMA] = ACTIONS(4050),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(3),
  },
  [1575] = {
    [sym__automatic_semicolon] = ACTIONS(4042),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_SEMI] = ACTIONS(4042),
    [anon_sym_COMMA] = ACTIONS(4042),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(3),
  },
  [1576] = {
    [sym__automatic_semicolon] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4100),
    [sym_identifier] = ACTIONS(4437),
    [anon_sym_SEMI] = ACTIONS(4100),
    [anon_sym_module] = ACTIONS(4437),
    [anon_sym_symbol] = ACTIONS(4437),
    [anon_sym_number] = ACTIONS(4437),
    [anon_sym_AT] = ACTIONS(4100),
    [anon_sym_declare] = ACTIONS(4437),
    [anon_sym_STAR] = ACTIONS(4100),
    [anon_sym_void] = ACTIONS(4437),
    [anon_sym_any] = ACTIONS(4437),
    [anon_sym_private] = ACTIONS(4437),
    [anon_sym_boolean] = ACTIONS(4437),
    [anon_sym_async] = ACTIONS(4437),
    [anon_sym_public] = ACTIONS(4437),
    [anon_sym_get] = ACTIONS(4437),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4437),
    [anon_sym_SQUOTE] = ACTIONS(4100),
    [sym_number] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4437),
    [anon_sym_string] = ACTIONS(4437),
    [anon_sym_abstract] = ACTIONS(4437),
    [anon_sym_set] = ACTIONS(4437),
    [anon_sym_type] = ACTIONS(4437),
    [anon_sym_export] = ACTIONS(4437),
    [anon_sym_namespace] = ACTIONS(4437),
    [sym_readonly] = ACTIONS(4437),
    [anon_sym_DQUOTE] = ACTIONS(4100),
  },
  [1577] = {
    [sym__automatic_semicolon] = ACTIONS(4102),
    [anon_sym_LBRACK] = ACTIONS(4102),
    [sym_identifier] = ACTIONS(4439),
    [anon_sym_SEMI] = ACTIONS(4102),
    [anon_sym_module] = ACTIONS(4439),
    [anon_sym_symbol] = ACTIONS(4439),
    [anon_sym_number] = ACTIONS(4439),
    [anon_sym_AT] = ACTIONS(4102),
    [anon_sym_declare] = ACTIONS(4439),
    [anon_sym_STAR] = ACTIONS(4102),
    [anon_sym_void] = ACTIONS(4439),
    [anon_sym_any] = ACTIONS(4439),
    [anon_sym_private] = ACTIONS(4439),
    [anon_sym_boolean] = ACTIONS(4439),
    [anon_sym_async] = ACTIONS(4439),
    [anon_sym_public] = ACTIONS(4439),
    [anon_sym_get] = ACTIONS(4439),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_static] = ACTIONS(4439),
    [anon_sym_SQUOTE] = ACTIONS(4102),
    [sym_number] = ACTIONS(4102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4439),
    [anon_sym_string] = ACTIONS(4439),
    [anon_sym_abstract] = ACTIONS(4439),
    [anon_sym_set] = ACTIONS(4439),
    [anon_sym_type] = ACTIONS(4439),
    [anon_sym_export] = ACTIONS(4439),
    [anon_sym_namespace] = ACTIONS(4439),
    [sym_readonly] = ACTIONS(4439),
    [anon_sym_DQUOTE] = ACTIONS(4102),
  },
  [1578] = {
    [sym__automatic_semicolon] = ACTIONS(4112),
    [anon_sym_RBRACE] = ACTIONS(4112),
    [anon_sym_SEMI] = ACTIONS(4112),
    [anon_sym_COMMA] = ACTIONS(4112),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4112),
    [sym_comment] = ACTIONS(3),
  },
  [1579] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [sym__automatic_semicolon] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_BQUOTE] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4128),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_LT_EQ] = ACTIONS(4126),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_GT_EQ] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4128),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_RBRACE] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_DASH_DASH] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_instanceof] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_STAR_STAR] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4128),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_PLUS_PLUS] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4126),
    [anon_sym_BANG] = ACTIONS(4128),
  },
  [1580] = {
    [sym__automatic_semicolon] = ACTIONS(4166),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [sym_identifier] = ACTIONS(4441),
    [anon_sym_SEMI] = ACTIONS(4166),
    [anon_sym_module] = ACTIONS(4441),
    [anon_sym_symbol] = ACTIONS(4441),
    [anon_sym_number] = ACTIONS(4441),
    [anon_sym_AT] = ACTIONS(4166),
    [anon_sym_declare] = ACTIONS(4441),
    [anon_sym_STAR] = ACTIONS(4166),
    [anon_sym_void] = ACTIONS(4441),
    [anon_sym_any] = ACTIONS(4441),
    [anon_sym_private] = ACTIONS(4441),
    [anon_sym_boolean] = ACTIONS(4441),
    [anon_sym_async] = ACTIONS(4441),
    [anon_sym_public] = ACTIONS(4441),
    [anon_sym_get] = ACTIONS(4441),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_static] = ACTIONS(4441),
    [anon_sym_SQUOTE] = ACTIONS(4166),
    [sym_number] = ACTIONS(4166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4441),
    [anon_sym_string] = ACTIONS(4441),
    [anon_sym_abstract] = ACTIONS(4441),
    [anon_sym_set] = ACTIONS(4441),
    [anon_sym_type] = ACTIONS(4441),
    [anon_sym_export] = ACTIONS(4441),
    [anon_sym_namespace] = ACTIONS(4441),
    [sym_readonly] = ACTIONS(4441),
    [anon_sym_DQUOTE] = ACTIONS(4166),
  },
  [1581] = {
    [sym__automatic_semicolon] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4168),
    [sym_identifier] = ACTIONS(4443),
    [anon_sym_SEMI] = ACTIONS(4168),
    [anon_sym_module] = ACTIONS(4443),
    [anon_sym_symbol] = ACTIONS(4443),
    [anon_sym_number] = ACTIONS(4443),
    [anon_sym_AT] = ACTIONS(4168),
    [anon_sym_declare] = ACTIONS(4443),
    [anon_sym_STAR] = ACTIONS(4168),
    [anon_sym_void] = ACTIONS(4443),
    [anon_sym_any] = ACTIONS(4443),
    [anon_sym_private] = ACTIONS(4443),
    [anon_sym_boolean] = ACTIONS(4443),
    [anon_sym_async] = ACTIONS(4443),
    [anon_sym_public] = ACTIONS(4443),
    [anon_sym_get] = ACTIONS(4443),
    [anon_sym_RBRACE] = ACTIONS(4168),
    [anon_sym_static] = ACTIONS(4443),
    [anon_sym_SQUOTE] = ACTIONS(4168),
    [sym_number] = ACTIONS(4168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4443),
    [anon_sym_string] = ACTIONS(4443),
    [anon_sym_abstract] = ACTIONS(4443),
    [anon_sym_set] = ACTIONS(4443),
    [anon_sym_type] = ACTIONS(4443),
    [anon_sym_export] = ACTIONS(4443),
    [anon_sym_namespace] = ACTIONS(4443),
    [sym_readonly] = ACTIONS(4443),
    [anon_sym_DQUOTE] = ACTIONS(4168),
  },
  [1582] = {
    [sym__automatic_semicolon] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4180),
    [sym_identifier] = ACTIONS(4445),
    [anon_sym_SEMI] = ACTIONS(4180),
    [anon_sym_module] = ACTIONS(4445),
    [anon_sym_symbol] = ACTIONS(4445),
    [anon_sym_number] = ACTIONS(4445),
    [anon_sym_AT] = ACTIONS(4180),
    [anon_sym_declare] = ACTIONS(4445),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_void] = ACTIONS(4445),
    [anon_sym_any] = ACTIONS(4445),
    [anon_sym_private] = ACTIONS(4445),
    [anon_sym_boolean] = ACTIONS(4445),
    [anon_sym_async] = ACTIONS(4445),
    [anon_sym_public] = ACTIONS(4445),
    [anon_sym_get] = ACTIONS(4445),
    [anon_sym_RBRACE] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4445),
    [anon_sym_SQUOTE] = ACTIONS(4180),
    [sym_number] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4445),
    [anon_sym_string] = ACTIONS(4445),
    [anon_sym_abstract] = ACTIONS(4445),
    [anon_sym_set] = ACTIONS(4445),
    [anon_sym_type] = ACTIONS(4445),
    [anon_sym_export] = ACTIONS(4445),
    [anon_sym_namespace] = ACTIONS(4445),
    [sym_readonly] = ACTIONS(4445),
    [anon_sym_DQUOTE] = ACTIONS(4180),
  },
  [1583] = {
    [sym__automatic_semicolon] = ACTIONS(4182),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [sym_identifier] = ACTIONS(4447),
    [anon_sym_SEMI] = ACTIONS(4182),
    [anon_sym_module] = ACTIONS(4447),
    [anon_sym_symbol] = ACTIONS(4447),
    [anon_sym_number] = ACTIONS(4447),
    [anon_sym_AT] = ACTIONS(4182),
    [anon_sym_declare] = ACTIONS(4447),
    [anon_sym_STAR] = ACTIONS(4182),
    [anon_sym_void] = ACTIONS(4447),
    [anon_sym_any] = ACTIONS(4447),
    [anon_sym_private] = ACTIONS(4447),
    [anon_sym_boolean] = ACTIONS(4447),
    [anon_sym_async] = ACTIONS(4447),
    [anon_sym_public] = ACTIONS(4447),
    [anon_sym_get] = ACTIONS(4447),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_static] = ACTIONS(4447),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [sym_number] = ACTIONS(4182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4447),
    [anon_sym_string] = ACTIONS(4447),
    [anon_sym_abstract] = ACTIONS(4447),
    [anon_sym_set] = ACTIONS(4447),
    [anon_sym_type] = ACTIONS(4447),
    [anon_sym_export] = ACTIONS(4447),
    [anon_sym_namespace] = ACTIONS(4447),
    [sym_readonly] = ACTIONS(4447),
    [anon_sym_DQUOTE] = ACTIONS(4182),
  },
  [1584] = {
    [sym__automatic_semicolon] = ACTIONS(4186),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [sym_identifier] = ACTIONS(4449),
    [anon_sym_SEMI] = ACTIONS(4186),
    [anon_sym_module] = ACTIONS(4449),
    [anon_sym_symbol] = ACTIONS(4449),
    [anon_sym_number] = ACTIONS(4449),
    [anon_sym_AT] = ACTIONS(4186),
    [anon_sym_declare] = ACTIONS(4449),
    [anon_sym_STAR] = ACTIONS(4186),
    [anon_sym_void] = ACTIONS(4449),
    [anon_sym_any] = ACTIONS(4449),
    [anon_sym_private] = ACTIONS(4449),
    [anon_sym_boolean] = ACTIONS(4449),
    [anon_sym_async] = ACTIONS(4449),
    [anon_sym_public] = ACTIONS(4449),
    [anon_sym_get] = ACTIONS(4449),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_static] = ACTIONS(4449),
    [anon_sym_SQUOTE] = ACTIONS(4186),
    [sym_number] = ACTIONS(4186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4449),
    [anon_sym_string] = ACTIONS(4449),
    [anon_sym_abstract] = ACTIONS(4449),
    [anon_sym_set] = ACTIONS(4449),
    [anon_sym_type] = ACTIONS(4449),
    [anon_sym_export] = ACTIONS(4449),
    [anon_sym_namespace] = ACTIONS(4449),
    [sym_readonly] = ACTIONS(4449),
    [anon_sym_DQUOTE] = ACTIONS(4186),
  },
  [1585] = {
    [sym_statement_block] = STATE(1601),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_as] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_instanceof] = ACTIONS(830),
    [anon_sym_DOT] = ACTIONS(4359),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_else] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(830),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(832),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
  },
  [1586] = {
    [sym_statement_block] = STATE(1601),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_as] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_instanceof] = ACTIONS(830),
    [anon_sym_DOT] = ACTIONS(830),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_else] = ACTIONS(830),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_while] = ACTIONS(830),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(832),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
  },
  [1587] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(838),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_COMMA] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_STAR] = ACTIONS(840),
    [anon_sym_GT_GT_GT] = ACTIONS(838),
    [anon_sym_BANG_EQ] = ACTIONS(840),
    [anon_sym_GT_EQ] = ACTIONS(838),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_PERCENT] = ACTIONS(838),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
    [anon_sym_as] = ACTIONS(838),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_instanceof] = ACTIONS(838),
    [anon_sym_COLON] = ACTIONS(838),
    [anon_sym_DOT] = ACTIONS(838),
    [anon_sym_STAR_STAR] = ACTIONS(838),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_in] = ACTIONS(840),
    [anon_sym_else] = ACTIONS(838),
    [anon_sym_BANG] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_LT_EQ] = ACTIONS(838),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_RBRACK] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
    [anon_sym_QMARK] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_while] = ACTIONS(838),
    [anon_sym_EQ_EQ] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(840),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(838),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_implements] = ACTIONS(838),
    [anon_sym_GT_GT] = ACTIONS(840),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(838),
  },
  [1588] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(842),
    [anon_sym_BQUOTE] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(844),
    [anon_sym_COMMA] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_STAR] = ACTIONS(844),
    [anon_sym_GT_GT_GT] = ACTIONS(842),
    [anon_sym_EQ] = ACTIONS(844),
    [anon_sym_BANG_EQ] = ACTIONS(844),
    [anon_sym_GT_EQ] = ACTIONS(842),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_PERCENT] = ACTIONS(842),
    [anon_sym_LBRACE_PIPE] = ACTIONS(842),
    [anon_sym_as] = ACTIONS(842),
    [anon_sym_DASH_DASH] = ACTIONS(842),
    [anon_sym_instanceof] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(842),
    [anon_sym_DOT] = ACTIONS(842),
    [anon_sym_STAR_STAR] = ACTIONS(842),
    [anon_sym_PLUS_PLUS] = ACTIONS(842),
    [anon_sym_in] = ACTIONS(844),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(842),
    [anon_sym_LT_LT] = ACTIONS(842),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_AMP_AMP] = ACTIONS(842),
    [anon_sym_LT_EQ] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_RBRACK] = ACTIONS(842),
    [anon_sym_GT] = ACTIONS(844),
    [anon_sym_AMP] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(842),
    [anon_sym_PIPE_PIPE] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_EQ_EQ] = ACTIONS(844),
    [anon_sym_RPAREN] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(844),
    [anon_sym_SLASH] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_implements] = ACTIONS(842),
    [anon_sym_GT_GT] = ACTIONS(844),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(842),
  },
  [1589] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(4451),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
  },
  [1590] = {
    [sym__automatic_semicolon] = ACTIONS(1252),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1252),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_EQ] = ACTIONS(1252),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1252),
  },
  [1591] = {
    [sym_array_type] = STATE(1610),
    [sym_generic_type] = STATE(1610),
    [sym_type_predicate] = STATE(1610),
    [sym_literal_type] = STATE(1610),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1610),
    [sym__primary_type] = STATE(1610),
    [sym_lookup_type] = STATE(1610),
    [sym_parenthesized_type] = STATE(1610),
    [sym_nested_identifier] = STATE(2397),
    [sym_predefined_type] = STATE(1610),
    [sym_nested_type_identifier] = STATE(1597),
    [sym_tuple_type] = STATE(1610),
    [sym_type_query] = STATE(1610),
    [sym_index_type_query] = STATE(1610),
    [sym_existential_type] = STATE(1610),
    [sym_flow_maybe_type] = STATE(1610),
    [sym_string] = STATE(1590),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(4453),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(4455),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1592] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1612),
    [sym_function_type] = STATE(1612),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1612),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1612),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1612),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1593] = {
    [sym__automatic_semicolon] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1282),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1282),
  },
  [1594] = {
    [sym__automatic_semicolon] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_AMP] = ACTIONS(1290),
    [anon_sym_SEMI] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1290),
    [anon_sym_EQ] = ACTIONS(1290),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1290),
  },
  [1595] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1617),
    [sym_function_type] = STATE(1617),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1617),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1617),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1617),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1596] = {
    [sym__automatic_semicolon] = ACTIONS(1308),
    [anon_sym_AMP] = ACTIONS(1308),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_SEMI] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_EQ] = ACTIONS(1308),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1308),
  },
  [1597] = {
    [sym_type_arguments] = STATE(1619),
    [sym__automatic_semicolon] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_SEMI] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(4459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_EQ] = ACTIONS(1314),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1314),
  },
  [1598] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(1413),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_implements] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(525),
  },
  [1599] = {
    [sym_type_arguments] = STATE(1609),
    [sym__automatic_semicolon] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(4459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4463),
    [anon_sym_EQ] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1239),
  },
  [1600] = {
    [anon_sym_LBRACK] = ACTIONS(1829),
    [sym_identifier] = ACTIONS(1831),
    [anon_sym_module] = ACTIONS(1831),
    [anon_sym_symbol] = ACTIONS(1831),
    [anon_sym_number] = ACTIONS(1831),
    [anon_sym_class] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(1829),
    [anon_sym_declare] = ACTIONS(1831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1829),
    [anon_sym_LBRACE] = ACTIONS(1829),
    [anon_sym_STAR] = ACTIONS(1829),
    [anon_sym_void] = ACTIONS(1831),
    [anon_sym_any] = ACTIONS(1831),
    [anon_sym_private] = ACTIONS(1831),
    [anon_sym_boolean] = ACTIONS(1831),
    [anon_sym_static] = ACTIONS(1831),
    [anon_sym_public] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(1831),
    [anon_sym_async] = ACTIONS(1831),
    [anon_sym_RBRACE] = ACTIONS(1829),
    [anon_sym_SQUOTE] = ACTIONS(1829),
    [sym_this] = ACTIONS(1831),
    [sym_number] = ACTIONS(1829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1831),
    [anon_sym_string] = ACTIONS(1831),
    [anon_sym_abstract] = ACTIONS(1831),
    [anon_sym_set] = ACTIONS(1831),
    [anon_sym_type] = ACTIONS(1831),
    [anon_sym_export] = ACTIONS(1831),
    [sym_readonly] = ACTIONS(1831),
    [anon_sym_namespace] = ACTIONS(1831),
    [anon_sym_DQUOTE] = ACTIONS(1829),
  },
  [1601] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1939),
    [sym__automatic_semicolon] = ACTIONS(1939),
    [anon_sym_BQUOTE] = ACTIONS(1939),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_COMMA] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1939),
    [anon_sym_BANG_EQ] = ACTIONS(1941),
    [anon_sym_GT_EQ] = ACTIONS(1939),
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_as] = ACTIONS(1939),
    [anon_sym_DASH_DASH] = ACTIONS(1939),
    [anon_sym_instanceof] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1939),
    [anon_sym_PLUS_PLUS] = ACTIONS(1939),
    [anon_sym_in] = ACTIONS(1941),
    [anon_sym_else] = ACTIONS(1939),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_LT_LT] = ACTIONS(1939),
    [anon_sym_AMP_AMP] = ACTIONS(1939),
    [anon_sym_LT_EQ] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_QMARK] = ACTIONS(1939),
    [anon_sym_PIPE_PIPE] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1939),
    [anon_sym_EQ_EQ] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_SLASH] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1939),
  },
  [1602] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1943),
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_GT_GT_GT] = ACTIONS(1943),
    [anon_sym_EQ] = ACTIONS(1945),
    [anon_sym_BANG_EQ] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_PERCENT] = ACTIONS(1943),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1943),
    [anon_sym_as] = ACTIONS(1943),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [anon_sym_instanceof] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1943),
    [anon_sym_STAR_STAR] = ACTIONS(1943),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1945),
    [anon_sym_else] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_AMP_AMP] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1943),
    [anon_sym_PIPE_PIPE] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_EQ_EQ] = ACTIONS(1945),
    [anon_sym_RPAREN] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1945),
    [anon_sym_implements] = ACTIONS(1943),
    [anon_sym_GT_GT] = ACTIONS(1945),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1943),
  },
  [1603] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2093),
    [sym__automatic_semicolon] = ACTIONS(2093),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [anon_sym_symbol] = ACTIONS(2095),
    [anon_sym_PIPE] = ACTIONS(2095),
    [anon_sym_STAR] = ACTIONS(2095),
    [anon_sym_GT_GT_GT] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_BANG_EQ] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_PERCENT] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_as] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_if] = ACTIONS(2095),
    [anon_sym_instanceof] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_DOT] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_in] = ACTIONS(2095),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_number] = ACTIONS(2095),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_LT_LT] = ACTIONS(2093),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_AMP_AMP] = ACTIONS(2093),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_LT_EQ] = ACTIONS(2093),
    [sym_null] = ACTIONS(2095),
    [anon_sym_any] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2093),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [anon_sym_CARET] = ACTIONS(2093),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_GT_GT] = ACTIONS(2095),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_COMMA] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [anon_sym_GT_EQ] = ACTIONS(2093),
    [sym_super] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [sym_this] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_STAR_STAR] = ACTIONS(2093),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [sym_false] = ACTIONS(2095),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [anon_sym_GT] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2095),
    [anon_sym_PIPE_PIPE] = ACTIONS(2093),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_EQ_EQ] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2095),
    [sym_number] = ACTIONS(2093),
    [ts_builtin_sym_end] = ACTIONS(2093),
    [anon_sym_function] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_await] = ACTIONS(2095),
  },
  [1604] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [sym__automatic_semicolon] = ACTIONS(2199),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_as] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_instanceof] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_DOT] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [sym_null] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [sym_super] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [sym_number] = ACTIONS(2199),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
  },
  [1605] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [sym__automatic_semicolon] = ACTIONS(4467),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_as] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_instanceof] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_DOT] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [sym_null] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [sym_super] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [sym_this] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2201),
    [sym_number] = ACTIONS(2199),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_await] = ACTIONS(2201),
  },
  [1606] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2262),
    [anon_sym_BQUOTE] = ACTIONS(2262),
    [anon_sym_PERCENT_EQ] = ACTIONS(2262),
    [anon_sym_AMP_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_EQ] = ACTIONS(2262),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2264),
    [anon_sym_GT_GT_GT] = ACTIONS(2264),
    [anon_sym_EQ] = ACTIONS(2264),
    [anon_sym_BANG_EQ] = ACTIONS(2264),
    [anon_sym_GT_EQ] = ACTIONS(2262),
    [anon_sym_CARET_EQ] = ACTIONS(2262),
    [anon_sym_PIPE_EQ] = ACTIONS(2262),
    [anon_sym_DASH_EQ] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2262),
    [anon_sym_LT_LT_EQ] = ACTIONS(2262),
    [anon_sym_as] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_instanceof] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2262),
    [anon_sym_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_DOT] = ACTIONS(2262),
    [anon_sym_STAR_STAR] = ACTIONS(2264),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_in] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2262),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2264),
    [anon_sym_AMP_AMP] = ACTIONS(2262),
    [anon_sym_of] = ACTIONS(2262),
    [anon_sym_LT_EQ] = ACTIONS(2262),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_RBRACK] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_STAR_EQ] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [anon_sym_QMARK] = ACTIONS(2262),
    [anon_sym_PIPE_PIPE] = ACTIONS(2262),
    [anon_sym_EQ_EQ] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_implements] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(2264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2262),
  },
  [1607] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(4451),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1075),
    [anon_sym_else] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
  },
  [1608] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1637),
    [sym_function_type] = STATE(1637),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1637),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1637),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1637),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1609] = {
    [sym__automatic_semicolon] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [anon_sym_AMP] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2324),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_COMMA] = ACTIONS(2324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2324),
    [anon_sym_EQ] = ACTIONS(2324),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2324),
  },
  [1610] = {
    [sym__automatic_semicolon] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(4457),
    [anon_sym_AMP] = ACTIONS(2328),
    [anon_sym_SEMI] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_COMMA] = ACTIONS(2328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2328),
    [anon_sym_EQ] = ACTIONS(2328),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2328),
  },
  [1611] = {
    [sym__automatic_semicolon] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2346),
  },
  [1612] = {
    [sym__automatic_semicolon] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_EQ] = ACTIONS(2400),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2400),
  },
  [1613] = {
    [sym__automatic_semicolon] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_DOT] = ACTIONS(4469),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2404),
  },
  [1614] = {
    [sym__automatic_semicolon] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_EQ] = ACTIONS(2410),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2410),
  },
  [1615] = {
    [sym__automatic_semicolon] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_AMP] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_EQ] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(4465),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2414),
  },
  [1616] = {
    [sym__automatic_semicolon] = ACTIONS(2420),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_EQ] = ACTIONS(2420),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2420),
  },
  [1617] = {
    [sym__automatic_semicolon] = ACTIONS(2489),
    [anon_sym_AMP] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2489),
    [anon_sym_EQ] = ACTIONS(2489),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2489),
  },
  [1618] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1643),
    [sym_function_type] = STATE(1643),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1643),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1643),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1643),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1619] = {
    [sym__automatic_semicolon] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_AMP] = ACTIONS(2495),
    [anon_sym_SEMI] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2495),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2495),
    [anon_sym_EQ] = ACTIONS(2495),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2495),
  },
  [1620] = {
    [sym__automatic_semicolon] = ACTIONS(2507),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_AMP] = ACTIONS(2507),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(2507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(2507),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2507),
  },
  [1621] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1645),
    [sym_function_type] = STATE(1645),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1645),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1645),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1645),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1622] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1646),
    [sym_function_type] = STATE(1646),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1646),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1646),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1646),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1623] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2517),
    [anon_sym_LBRACK] = ACTIONS(2517),
    [anon_sym_BQUOTE] = ACTIONS(2517),
    [anon_sym_PIPE] = ACTIONS(2519),
    [anon_sym_COMMA] = ACTIONS(2517),
    [anon_sym_LT_LT] = ACTIONS(2517),
    [anon_sym_STAR] = ACTIONS(2519),
    [anon_sym_LBRACE] = ACTIONS(2517),
    [anon_sym_AMP_AMP] = ACTIONS(2517),
    [anon_sym_GT_GT_GT] = ACTIONS(2517),
    [anon_sym_DASH] = ACTIONS(2519),
    [anon_sym_BANG_EQ] = ACTIONS(2519),
    [anon_sym_LT_EQ] = ACTIONS(2517),
    [anon_sym_LPAREN] = ACTIONS(2517),
    [anon_sym_GT_EQ] = ACTIONS(2517),
    [anon_sym_GT] = ACTIONS(2519),
    [anon_sym_AMP] = ACTIONS(2519),
    [anon_sym_PERCENT] = ACTIONS(2517),
    [anon_sym_QMARK] = ACTIONS(2517),
    [anon_sym_as] = ACTIONS(2519),
    [anon_sym_PIPE_PIPE] = ACTIONS(2517),
    [anon_sym_DASH_DASH] = ACTIONS(2517),
    [anon_sym_EQ_EQ] = ACTIONS(2519),
    [anon_sym_instanceof] = ACTIONS(2519),
    [anon_sym_LT] = ACTIONS(2519),
    [anon_sym_SLASH] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4369),
    [anon_sym_DOT] = ACTIONS(2517),
    [anon_sym_CARET] = ACTIONS(2517),
    [anon_sym_STAR_STAR] = ACTIONS(2517),
    [anon_sym_PLUS] = ACTIONS(2519),
    [anon_sym_implements] = ACTIONS(2519),
    [anon_sym_GT_GT] = ACTIONS(2519),
    [anon_sym_PLUS_PLUS] = ACTIONS(2517),
    [anon_sym_in] = ACTIONS(2519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(2519),
  },
  [1624] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2607),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4471),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1625] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2612),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1626] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(2621),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1627] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(2621),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [1628] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2646),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1629] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4473),
    [sym_false] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(4475),
    [anon_sym_symbol] = ACTIONS(4475),
    [anon_sym_number] = ACTIONS(4475),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4475),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4477),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4475),
    [anon_sym_private] = ACTIONS(4475),
    [anon_sym_boolean] = ACTIONS(4475),
    [anon_sym_static] = ACTIONS(4475),
    [anon_sym_public] = ACTIONS(4475),
    [anon_sym_get] = ACTIONS(4475),
    [anon_sym_async] = ACTIONS(4479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [sym_number] = ACTIONS(4398),
    [sym_true] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(4475),
    [anon_sym_string] = ACTIONS(4475),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_DOT] = ACTIONS(4392),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_set] = ACTIONS(4475),
    [anon_sym_type] = ACTIONS(4475),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4475),
    [anon_sym_namespace] = ACTIONS(4481),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [1630] = {
    [anon_sym_LBRACK] = ACTIONS(2726),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_symbol] = ACTIONS(2728),
    [anon_sym_number] = ACTIONS(2728),
    [anon_sym_class] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_declare] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2726),
    [anon_sym_STAR] = ACTIONS(2726),
    [anon_sym_void] = ACTIONS(2728),
    [anon_sym_any] = ACTIONS(2728),
    [anon_sym_private] = ACTIONS(2728),
    [anon_sym_boolean] = ACTIONS(2728),
    [anon_sym_static] = ACTIONS(2728),
    [anon_sym_public] = ACTIONS(2728),
    [anon_sym_get] = ACTIONS(2728),
    [anon_sym_async] = ACTIONS(2728),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_SQUOTE] = ACTIONS(2726),
    [sym_this] = ACTIONS(2728),
    [sym_number] = ACTIONS(2726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2728),
    [anon_sym_string] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_set] = ACTIONS(2728),
    [anon_sym_type] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [sym_readonly] = ACTIONS(2728),
    [anon_sym_namespace] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2726),
  },
  [1631] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2792),
    [sym__automatic_semicolon] = ACTIONS(2792),
    [anon_sym_BQUOTE] = ACTIONS(2792),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_GT_GT_GT] = ACTIONS(2792),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_PERCENT] = ACTIONS(2792),
    [anon_sym_as] = ACTIONS(2792),
    [anon_sym_DASH_DASH] = ACTIONS(2792),
    [anon_sym_instanceof] = ACTIONS(2792),
    [anon_sym_DOT] = ACTIONS(2792),
    [anon_sym_STAR_STAR] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2792),
    [anon_sym_in] = ACTIONS(2794),
    [anon_sym_else] = ACTIONS(2792),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym_LT_LT] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_AMP_AMP] = ACTIONS(2792),
    [anon_sym_LT_EQ] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2794),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_PIPE_PIPE] = ACTIONS(2792),
    [anon_sym_while] = ACTIONS(2792),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2794),
    [anon_sym_GT_GT] = ACTIONS(2794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2792),
  },
  [1632] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2944),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2946),
    [anon_sym_STAR] = ACTIONS(2946),
    [anon_sym_GT_GT_GT] = ACTIONS(2944),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_PERCENT] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_as] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2946),
    [anon_sym_instanceof] = ACTIONS(2946),
    [anon_sym_yield] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_in] = ACTIONS(2946),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_LT_LT] = ACTIONS(2944),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_AMP_AMP] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2944),
    [sym_null] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_QMARK] = ACTIONS(2944),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [anon_sym_CARET] = ACTIONS(2944),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2944),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2944),
    [anon_sym_COMMA] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [anon_sym_GT_EQ] = ACTIONS(2944),
    [sym_super] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [sym_this] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_STAR_STAR] = ACTIONS(2944),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [sym_false] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [anon_sym_GT] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_AMP] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2946),
    [sym_number] = ACTIONS(2944),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_function] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2944),
    [anon_sym_await] = ACTIONS(2946),
  },
  [1633] = {
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [anon_sym_COLON] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(3045),
    [anon_sym_QMARK] = ACTIONS(3045),
    [anon_sym_LPAREN] = ACTIONS(3045),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3045),
    [sym__automatic_semicolon] = ACTIONS(3045),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_COMMA] = ACTIONS(3045),
    [sym_comment] = ACTIONS(3),
  },
  [1634] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3060),
    [sym__automatic_semicolon] = ACTIONS(3060),
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [anon_sym_symbol] = ACTIONS(3062),
    [anon_sym_PIPE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_GT_GT_GT] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3062),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_return] = ACTIONS(3062),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3062),
    [anon_sym_as] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3062),
    [anon_sym_if] = ACTIONS(3062),
    [anon_sym_instanceof] = ACTIONS(3062),
    [anon_sym_yield] = ACTIONS(3062),
    [sym_true] = ACTIONS(3062),
    [anon_sym_protected] = ACTIONS(3062),
    [anon_sym_DOT] = ACTIONS(3062),
    [anon_sym_set] = ACTIONS(3062),
    [anon_sym_import] = ACTIONS(3062),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_number] = ACTIONS(3062),
    [anon_sym_typeof] = ACTIONS(3062),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3062),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [sym_null] = ACTIONS(3062),
    [anon_sym_any] = ACTIONS(3062),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(3062),
    [anon_sym_var] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3062),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_GT_GT] = ACTIONS(3062),
    [anon_sym_with] = ACTIONS(3062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_debugger] = ACTIONS(3062),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_void] = ACTIONS(3062),
    [anon_sym_const] = ACTIONS(3062),
    [anon_sym_GT_EQ] = ACTIONS(3060),
    [sym_super] = ACTIONS(3062),
    [anon_sym_private] = ACTIONS(3062),
    [anon_sym_get] = ACTIONS(3062),
    [anon_sym_default] = ACTIONS(3062),
    [anon_sym_enum] = ACTIONS(3062),
    [anon_sym_continue] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [sym_this] = ACTIONS(3062),
    [anon_sym_throw] = ACTIONS(3062),
    [anon_sym_abstract] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3062),
    [anon_sym_STAR_STAR] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [sym_false] = ACTIONS(3062),
    [anon_sym_case] = ACTIONS(3062),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_class] = ACTIONS(3062),
    [anon_sym_declare] = ACTIONS(3062),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3062),
    [anon_sym_boolean] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3062),
    [anon_sym_PIPE_PIPE] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3062),
    [anon_sym_EQ_EQ] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3062),
    [sym_number] = ACTIONS(3060),
    [ts_builtin_sym_end] = ACTIONS(3060),
    [anon_sym_function] = ACTIONS(3062),
    [sym_undefined] = ACTIONS(3062),
    [anon_sym_let] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_await] = ACTIONS(3062),
  },
  [1635] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3102),
    [anon_sym_BQUOTE] = ACTIONS(3102),
    [anon_sym_PERCENT_EQ] = ACTIONS(3102),
    [anon_sym_AMP_EQ] = ACTIONS(3102),
    [anon_sym_PLUS_EQ] = ACTIONS(3102),
    [anon_sym_PIPE] = ACTIONS(3104),
    [anon_sym_COMMA] = ACTIONS(3102),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3104),
    [anon_sym_GT_GT_GT] = ACTIONS(3104),
    [anon_sym_EQ] = ACTIONS(3104),
    [anon_sym_BANG_EQ] = ACTIONS(3104),
    [anon_sym_GT_EQ] = ACTIONS(3102),
    [anon_sym_CARET_EQ] = ACTIONS(3102),
    [anon_sym_PIPE_EQ] = ACTIONS(3102),
    [anon_sym_DASH_EQ] = ACTIONS(3102),
    [anon_sym_RBRACE] = ACTIONS(3102),
    [anon_sym_PERCENT] = ACTIONS(3104),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3102),
    [anon_sym_LT_LT_EQ] = ACTIONS(3102),
    [anon_sym_as] = ACTIONS(3102),
    [anon_sym_DASH_DASH] = ACTIONS(3102),
    [anon_sym_instanceof] = ACTIONS(3102),
    [anon_sym_COLON] = ACTIONS(3102),
    [anon_sym_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_DOT] = ACTIONS(3102),
    [anon_sym_STAR_STAR] = ACTIONS(3104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3102),
    [anon_sym_PLUS_PLUS] = ACTIONS(3102),
    [anon_sym_in] = ACTIONS(3104),
    [anon_sym_BANG] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3102),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3102),
    [anon_sym_LT_LT] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3104),
    [anon_sym_AMP_AMP] = ACTIONS(3102),
    [anon_sym_of] = ACTIONS(3102),
    [anon_sym_LT_EQ] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(3102),
    [anon_sym_RBRACK] = ACTIONS(3102),
    [anon_sym_GT] = ACTIONS(3104),
    [anon_sym_STAR_EQ] = ACTIONS(3102),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_QMARK] = ACTIONS(3102),
    [anon_sym_PIPE_PIPE] = ACTIONS(3102),
    [anon_sym_EQ_EQ] = ACTIONS(3104),
    [anon_sym_RPAREN] = ACTIONS(3102),
    [anon_sym_LT] = ACTIONS(3104),
    [anon_sym_SLASH] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(3102),
    [anon_sym_CARET] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_implements] = ACTIONS(3102),
    [anon_sym_GT_GT] = ACTIONS(3104),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3102),
  },
  [1636] = {
    [sym__automatic_semicolon] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3156),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_PIPE] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_EQ] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(2792),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3156),
  },
  [1637] = {
    [sym__automatic_semicolon] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(3160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_EQ] = ACTIONS(3160),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3160),
  },
  [1638] = {
    [sym__automatic_semicolon] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_COMMA] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_EQ] = ACTIONS(3192),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3192),
  },
  [1639] = {
    [sym__automatic_semicolon] = ACTIONS(3202),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_AMP] = ACTIONS(3202),
    [anon_sym_SEMI] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_PIPE] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3202),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3202),
    [anon_sym_EQ] = ACTIONS(3202),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3202),
  },
  [1640] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1657),
    [sym_function_type] = STATE(1657),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1657),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1657),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1657),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1641] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_implements] = ACTIONS(1069),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
  },
  [1642] = {
    [sym__automatic_semicolon] = ACTIONS(3258),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_AMP] = ACTIONS(3258),
    [anon_sym_SEMI] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3260),
    [anon_sym_COMMA] = ACTIONS(3258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3258),
    [anon_sym_EQ] = ACTIONS(3258),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3258),
  },
  [1643] = {
    [sym__automatic_semicolon] = ACTIONS(3262),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3262),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3262),
  },
  [1644] = {
    [sym__automatic_semicolon] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_AMP] = ACTIONS(3266),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3266),
    [anon_sym_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3266),
  },
  [1645] = {
    [sym__automatic_semicolon] = ACTIONS(3283),
    [anon_sym_AMP] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_SEMI] = ACTIONS(3283),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3283),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3283),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3283),
  },
  [1646] = {
    [sym__automatic_semicolon] = ACTIONS(3287),
    [anon_sym_AMP] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_SEMI] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_PIPE] = ACTIONS(3289),
    [anon_sym_COMMA] = ACTIONS(3287),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3287),
    [anon_sym_EQ] = ACTIONS(3287),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3287),
  },
  [1647] = {
    [sym__automatic_semicolon] = ACTIONS(3291),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_PIPE] = ACTIONS(3293),
    [anon_sym_COMMA] = ACTIONS(3291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3291),
    [anon_sym_EQ] = ACTIONS(3291),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3291),
  },
  [1648] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1661),
    [sym_function_type] = STATE(1661),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1661),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1661),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1661),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1649] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1829),
    [anon_sym_BQUOTE] = ACTIONS(1829),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_COMMA] = ACTIONS(1829),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_GT_GT_GT] = ACTIONS(1829),
    [anon_sym_BANG_EQ] = ACTIONS(1831),
    [anon_sym_GT_EQ] = ACTIONS(1829),
    [anon_sym_PERCENT] = ACTIONS(1829),
    [anon_sym_as] = ACTIONS(1829),
    [anon_sym_DASH_DASH] = ACTIONS(1829),
    [anon_sym_instanceof] = ACTIONS(1829),
    [anon_sym_COLON] = ACTIONS(1829),
    [anon_sym_DOT] = ACTIONS(1829),
    [anon_sym_STAR_STAR] = ACTIONS(1829),
    [anon_sym_PLUS_PLUS] = ACTIONS(1829),
    [anon_sym_in] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1829),
    [anon_sym_AMP_AMP] = ACTIONS(1829),
    [anon_sym_LT_EQ] = ACTIONS(1829),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_GT] = ACTIONS(1831),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_QMARK] = ACTIONS(1829),
    [anon_sym_PIPE_PIPE] = ACTIONS(1829),
    [anon_sym_EQ_EQ] = ACTIONS(1831),
    [anon_sym_RPAREN] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_SLASH] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1829),
    [anon_sym_PLUS] = ACTIONS(1831),
    [anon_sym_GT_GT] = ACTIONS(1831),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1829),
  },
  [1650] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4483),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1651] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1652] = {
    [anon_sym_LBRACK] = ACTIONS(3396),
    [sym_identifier] = ACTIONS(3398),
    [anon_sym_module] = ACTIONS(3398),
    [anon_sym_symbol] = ACTIONS(3398),
    [anon_sym_number] = ACTIONS(3398),
    [anon_sym_class] = ACTIONS(3398),
    [anon_sym_AT] = ACTIONS(3396),
    [anon_sym_declare] = ACTIONS(3398),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3396),
    [anon_sym_LBRACE] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3396),
    [anon_sym_void] = ACTIONS(3398),
    [anon_sym_any] = ACTIONS(3398),
    [anon_sym_private] = ACTIONS(3398),
    [anon_sym_boolean] = ACTIONS(3398),
    [anon_sym_static] = ACTIONS(3398),
    [anon_sym_public] = ACTIONS(3398),
    [anon_sym_get] = ACTIONS(3398),
    [anon_sym_async] = ACTIONS(3398),
    [anon_sym_RBRACE] = ACTIONS(3396),
    [anon_sym_SQUOTE] = ACTIONS(3396),
    [sym_this] = ACTIONS(3398),
    [sym_number] = ACTIONS(3396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3398),
    [anon_sym_string] = ACTIONS(3398),
    [anon_sym_abstract] = ACTIONS(3398),
    [anon_sym_set] = ACTIONS(3398),
    [anon_sym_type] = ACTIONS(3398),
    [anon_sym_export] = ACTIONS(3398),
    [sym_readonly] = ACTIONS(3398),
    [anon_sym_namespace] = ACTIONS(3398),
    [anon_sym_DQUOTE] = ACTIONS(3396),
  },
  [1653] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_RPAREN] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_implements] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1654] = {
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1662),
    [sym_function_type] = STATE(1662),
    [sym_constructor_type] = STATE(1662),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_nested_identifier] = STATE(2397),
    [sym_predefined_type] = STATE(1596),
    [sym_nested_type_identifier] = STATE(1597),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1662),
    [sym__type] = STATE(1662),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_symbol] = ACTIONS(1879),
    [sym_this] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1881),
    [sym_true] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_keyof] = ACTIONS(1883),
    [sym_number] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_boolean] = ACTIONS(1879),
  },
  [1655] = {
    [sym__automatic_semicolon] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_AMP] = ACTIONS(3653),
    [anon_sym_SEMI] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_PIPE] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3653),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3653),
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3653),
  },
  [1656] = {
    [sym__automatic_semicolon] = ACTIONS(3692),
    [anon_sym_LBRACK] = ACTIONS(3692),
    [anon_sym_AMP] = ACTIONS(3692),
    [anon_sym_SEMI] = ACTIONS(3692),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [anon_sym_PIPE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3692),
    [anon_sym_EQ] = ACTIONS(3692),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3692),
  },
  [1657] = {
    [sym__automatic_semicolon] = ACTIONS(3696),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(3696),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(3696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3696),
    [anon_sym_EQ] = ACTIONS(3696),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3696),
  },
  [1658] = {
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1664),
    [sym_function_type] = STATE(1664),
    [sym_nested_identifier] = STATE(2397),
    [sym_nested_type_identifier] = STATE(1597),
    [sym__type] = STATE(1664),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_constructor_type] = STATE(1664),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_predefined_type] = STATE(1596),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1664),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_symbol] = ACTIONS(1879),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_typeof] = ACTIONS(1881),
    [anon_sym_keyof] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1891),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_boolean] = ACTIONS(1879),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_this] = ACTIONS(1901),
    [sym_number] = ACTIONS(1903),
    [sym_true] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1659] = {
    [sym__automatic_semicolon] = ACTIONS(3741),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_SEMI] = ACTIONS(3741),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3741),
  },
  [1660] = {
    [sym__automatic_semicolon] = ACTIONS(3749),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_AMP] = ACTIONS(3749),
    [anon_sym_SEMI] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_COMMA] = ACTIONS(3749),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3749),
    [anon_sym_EQ] = ACTIONS(3749),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3749),
  },
  [1661] = {
    [sym__automatic_semicolon] = ACTIONS(3753),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(3753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_EQ] = ACTIONS(3753),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3753),
  },
  [1662] = {
    [sym__automatic_semicolon] = ACTIONS(3941),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(3941),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3941),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(3941),
    [sym_comment] = ACTIONS(3),
  },
  [1663] = {
    [sym__automatic_semicolon] = ACTIONS(3981),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_AMP] = ACTIONS(3981),
    [anon_sym_SEMI] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_COMMA] = ACTIONS(3981),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3981),
    [anon_sym_EQ] = ACTIONS(3981),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3981),
  },
  [1664] = {
    [sym__automatic_semicolon] = ACTIONS(4007),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_SEMI] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_COMMA] = ACTIONS(4007),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_EQ] = ACTIONS(4007),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4007),
  },
  [1665] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1666] = {
    [sym__automatic_semicolon] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_AMP] = ACTIONS(4126),
    [anon_sym_SEMI] = ACTIONS(4126),
    [anon_sym_RBRACE] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4126),
    [anon_sym_EQ] = ACTIONS(4126),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4126),
  },
  [1667] = {
    [sym_statement_block] = STATE(1681),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_LBRACE_PIPE] = ACTIONS(830),
    [anon_sym_as] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_instanceof] = ACTIONS(830),
    [anon_sym_COLON] = ACTIONS(830),
    [anon_sym_DOT] = ACTIONS(4485),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(4487),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RBRACK] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_RPAREN] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(832),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_implements] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
  },
  [1668] = {
    [sym_statement_block] = STATE(1681),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_PIPE] = ACTIONS(832),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_DASH] = ACTIONS(832),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_GT_GT_GT] = ACTIONS(830),
    [anon_sym_BANG_EQ] = ACTIONS(832),
    [anon_sym_GT_EQ] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_PERCENT] = ACTIONS(830),
    [anon_sym_LBRACE_PIPE] = ACTIONS(830),
    [anon_sym_as] = ACTIONS(830),
    [anon_sym_DASH_DASH] = ACTIONS(830),
    [anon_sym_instanceof] = ACTIONS(830),
    [anon_sym_COLON] = ACTIONS(830),
    [anon_sym_DOT] = ACTIONS(830),
    [anon_sym_STAR_STAR] = ACTIONS(830),
    [anon_sym_PLUS_PLUS] = ACTIONS(830),
    [anon_sym_in] = ACTIONS(832),
    [anon_sym_BANG] = ACTIONS(832),
    [anon_sym_LBRACK] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(4487),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_LT_EQ] = ACTIONS(830),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RBRACK] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(832),
    [anon_sym_AMP] = ACTIONS(832),
    [anon_sym_QMARK] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_EQ_EQ] = ACTIONS(832),
    [anon_sym_RPAREN] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(832),
    [anon_sym_SLASH] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(830),
    [anon_sym_PLUS] = ACTIONS(832),
    [anon_sym_implements] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(830),
  },
  [1669] = {
    [sym_identifier] = ACTIONS(840),
    [anon_sym_BQUOTE] = ACTIONS(838),
    [anon_sym_debugger] = ACTIONS(840),
    [anon_sym_symbol] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_void] = ACTIONS(840),
    [anon_sym_break] = ACTIONS(840),
    [anon_sym_const] = ACTIONS(840),
    [sym_super] = ACTIONS(840),
    [anon_sym_return] = ACTIONS(840),
    [anon_sym_private] = ACTIONS(840),
    [anon_sym_static] = ACTIONS(840),
    [anon_sym_get] = ACTIONS(840),
    [anon_sym_RBRACE] = ACTIONS(838),
    [anon_sym_interface] = ACTIONS(840),
    [anon_sym_default] = ACTIONS(840),
    [anon_sym_enum] = ACTIONS(840),
    [anon_sym_delete] = ACTIONS(840),
    [anon_sym_continue] = ACTIONS(840),
    [anon_sym_DASH_DASH] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(840),
    [sym_this] = ACTIONS(840),
    [anon_sym_yield] = ACTIONS(840),
    [sym_true] = ACTIONS(840),
    [anon_sym_throw] = ACTIONS(840),
    [anon_sym_protected] = ACTIONS(840),
    [anon_sym_abstract] = ACTIONS(840),
    [anon_sym_set] = ACTIONS(840),
    [anon_sym_type] = ACTIONS(840),
    [anon_sym_import] = ACTIONS(840),
    [anon_sym_namespace] = ACTIONS(840),
    [anon_sym_PLUS_PLUS] = ACTIONS(838),
    [anon_sym_DQUOTE] = ACTIONS(838),
    [anon_sym_else] = ACTIONS(840),
    [anon_sym_BANG] = ACTIONS(838),
    [anon_sym_for] = ACTIONS(840),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_false] = ACTIONS(840),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_case] = ACTIONS(840),
    [anon_sym_module] = ACTIONS(840),
    [anon_sym_number] = ACTIONS(840),
    [anon_sym_class] = ACTIONS(840),
    [anon_sym_declare] = ACTIONS(840),
    [anon_sym_typeof] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_switch] = ACTIONS(840),
    [anon_sym_LPAREN] = ACTIONS(838),
    [sym_null] = ACTIONS(840),
    [anon_sym_any] = ACTIONS(840),
    [anon_sym_boolean] = ACTIONS(840),
    [anon_sym_async] = ACTIONS(840),
    [anon_sym_public] = ACTIONS(840),
    [anon_sym_var] = ACTIONS(840),
    [anon_sym_while] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(838),
    [anon_sym_try] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(838),
    [sym_number] = ACTIONS(838),
    [anon_sym_SLASH] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(840),
    [anon_sym_function] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_new] = ACTIONS(840),
    [ts_builtin_sym_end] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_export] = ACTIONS(840),
    [anon_sym_do] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_with] = ACTIONS(840),
    [anon_sym_await] = ACTIONS(840),
  },
  [1670] = {
    [anon_sym_BQUOTE] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(844),
    [anon_sym_PIPE] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_static] = ACTIONS(844),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_interface] = ACTIONS(844),
    [anon_sym_delete] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_yield] = ACTIONS(844),
    [sym_true] = ACTIONS(844),
    [anon_sym_COLON] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(844),
    [anon_sym_set] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(844),
    [anon_sym_DQUOTE] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_SEMI] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(844),
    [anon_sym_typeof] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(842),
    [anon_sym_switch] = ACTIONS(844),
    [anon_sym_RBRACK] = ACTIONS(842),
    [sym_null] = ACTIONS(844),
    [anon_sym_any] = ACTIONS(844),
    [anon_sym_async] = ACTIONS(844),
    [anon_sym_public] = ACTIONS(844),
    [anon_sym_var] = ACTIONS(844),
    [anon_sym_QMARK] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_RPAREN] = ACTIONS(842),
    [anon_sym_SLASH] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(844),
    [anon_sym_new] = ACTIONS(844),
    [anon_sym_export] = ACTIONS(844),
    [anon_sym_with] = ACTIONS(844),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_debugger] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(842),
    [anon_sym_COMMA] = ACTIONS(842),
    [anon_sym_DASH] = ACTIONS(844),
    [anon_sym_EQ] = ACTIONS(844),
    [anon_sym_void] = ACTIONS(844),
    [anon_sym_const] = ACTIONS(844),
    [sym_super] = ACTIONS(844),
    [anon_sym_private] = ACTIONS(844),
    [anon_sym_get] = ACTIONS(844),
    [anon_sym_default] = ACTIONS(844),
    [anon_sym_enum] = ACTIONS(844),
    [anon_sym_continue] = ACTIONS(844),
    [anon_sym_DASH_DASH] = ACTIONS(842),
    [sym_this] = ACTIONS(844),
    [anon_sym_throw] = ACTIONS(844),
    [anon_sym_abstract] = ACTIONS(844),
    [anon_sym_type] = ACTIONS(844),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_PLUS_PLUS] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(844),
    [anon_sym_BANG] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(842),
    [sym_false] = ACTIONS(844),
    [anon_sym_case] = ACTIONS(844),
    [anon_sym_module] = ACTIONS(844),
    [anon_sym_class] = ACTIONS(844),
    [anon_sym_declare] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_GT] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(844),
    [anon_sym_EQ_GT] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(844),
    [anon_sym_LT] = ACTIONS(842),
    [sym_number] = ACTIONS(842),
    [ts_builtin_sym_end] = ACTIONS(842),
    [anon_sym_function] = ACTIONS(844),
    [sym_undefined] = ACTIONS(844),
    [anon_sym_let] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(844),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_await] = ACTIONS(844),
  },
  [1671] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(4489),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RBRACK] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_implements] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
  },
  [1672] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1252),
    [anon_sym_BQUOTE] = ACTIONS(1252),
    [anon_sym_PIPE] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1254),
    [anon_sym_STAR] = ACTIONS(1254),
    [anon_sym_GT_GT_GT] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(1254),
    [anon_sym_GT_EQ] = ACTIONS(1252),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_PERCENT] = ACTIONS(1252),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1252),
    [anon_sym_as] = ACTIONS(1252),
    [anon_sym_DASH_DASH] = ACTIONS(1252),
    [anon_sym_instanceof] = ACTIONS(1252),
    [anon_sym_COLON] = ACTIONS(1252),
    [anon_sym_DOT] = ACTIONS(1252),
    [anon_sym_STAR_STAR] = ACTIONS(1252),
    [anon_sym_PLUS_PLUS] = ACTIONS(1252),
    [anon_sym_in] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_LT_LT] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1254),
    [anon_sym_AMP_AMP] = ACTIONS(1252),
    [anon_sym_LT_EQ] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_RBRACK] = ACTIONS(1252),
    [anon_sym_GT] = ACTIONS(1254),
    [anon_sym_AMP] = ACTIONS(1254),
    [anon_sym_QMARK] = ACTIONS(1252),
    [anon_sym_PIPE_PIPE] = ACTIONS(1252),
    [anon_sym_EQ_EQ] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_LT] = ACTIONS(1254),
    [anon_sym_SLASH] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1254),
    [anon_sym_implements] = ACTIONS(1252),
    [anon_sym_GT_GT] = ACTIONS(1254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1252),
  },
  [1673] = {
    [sym_array_type] = STATE(1689),
    [sym_generic_type] = STATE(1689),
    [sym_type_predicate] = STATE(1689),
    [sym_literal_type] = STATE(1689),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1689),
    [sym__primary_type] = STATE(1689),
    [sym_lookup_type] = STATE(1689),
    [sym_parenthesized_type] = STATE(1689),
    [sym_nested_identifier] = STATE(2463),
    [sym_predefined_type] = STATE(1689),
    [sym_nested_type_identifier] = STATE(1679),
    [sym_tuple_type] = STATE(1689),
    [sym_type_query] = STATE(1689),
    [sym_index_type_query] = STATE(1689),
    [sym_existential_type] = STATE(1689),
    [sym_flow_maybe_type] = STATE(1689),
    [sym_string] = STATE(1672),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4509),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4515),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1674] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1691),
    [sym_function_type] = STATE(1691),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1691),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1691),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1691),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1675] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(1282),
    [anon_sym_PIPE] = ACTIONS(1284),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_STAR] = ACTIONS(1284),
    [anon_sym_GT_GT_GT] = ACTIONS(1282),
    [anon_sym_BANG_EQ] = ACTIONS(1284),
    [anon_sym_GT_EQ] = ACTIONS(1282),
    [anon_sym_RBRACE] = ACTIONS(1282),
    [anon_sym_PERCENT] = ACTIONS(1282),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1282),
    [anon_sym_as] = ACTIONS(1282),
    [anon_sym_DASH_DASH] = ACTIONS(1282),
    [anon_sym_instanceof] = ACTIONS(1282),
    [anon_sym_COLON] = ACTIONS(1282),
    [anon_sym_DOT] = ACTIONS(1282),
    [anon_sym_STAR_STAR] = ACTIONS(1282),
    [anon_sym_PLUS_PLUS] = ACTIONS(1282),
    [anon_sym_in] = ACTIONS(1284),
    [anon_sym_BANG] = ACTIONS(1284),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_LT_LT] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_AMP_AMP] = ACTIONS(1282),
    [anon_sym_LT_EQ] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1282),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_GT] = ACTIONS(1284),
    [anon_sym_AMP] = ACTIONS(1284),
    [anon_sym_QMARK] = ACTIONS(1282),
    [anon_sym_PIPE_PIPE] = ACTIONS(1282),
    [anon_sym_EQ_EQ] = ACTIONS(1284),
    [anon_sym_RPAREN] = ACTIONS(1282),
    [anon_sym_LT] = ACTIONS(1284),
    [anon_sym_SLASH] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1282),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_implements] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(1284),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1282),
  },
  [1676] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1290),
    [anon_sym_BQUOTE] = ACTIONS(1290),
    [anon_sym_PIPE] = ACTIONS(1292),
    [anon_sym_COMMA] = ACTIONS(1290),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_GT_GT_GT] = ACTIONS(1290),
    [anon_sym_BANG_EQ] = ACTIONS(1292),
    [anon_sym_GT_EQ] = ACTIONS(1290),
    [anon_sym_RBRACE] = ACTIONS(1290),
    [anon_sym_PERCENT] = ACTIONS(1290),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1290),
    [anon_sym_as] = ACTIONS(1290),
    [anon_sym_DASH_DASH] = ACTIONS(1290),
    [anon_sym_instanceof] = ACTIONS(1290),
    [anon_sym_COLON] = ACTIONS(1290),
    [anon_sym_DOT] = ACTIONS(1290),
    [anon_sym_STAR_STAR] = ACTIONS(1290),
    [anon_sym_PLUS_PLUS] = ACTIONS(1290),
    [anon_sym_in] = ACTIONS(1292),
    [anon_sym_BANG] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(1290),
    [anon_sym_LT_LT] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_AMP_AMP] = ACTIONS(1290),
    [anon_sym_LT_EQ] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1290),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_GT] = ACTIONS(1292),
    [anon_sym_AMP] = ACTIONS(1292),
    [anon_sym_QMARK] = ACTIONS(1290),
    [anon_sym_PIPE_PIPE] = ACTIONS(1290),
    [anon_sym_EQ_EQ] = ACTIONS(1292),
    [anon_sym_RPAREN] = ACTIONS(1290),
    [anon_sym_LT] = ACTIONS(1292),
    [anon_sym_SLASH] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1290),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_implements] = ACTIONS(1290),
    [anon_sym_GT_GT] = ACTIONS(1292),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1290),
  },
  [1677] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1696),
    [sym_function_type] = STATE(1696),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1696),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1696),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1696),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1678] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1308),
    [anon_sym_BQUOTE] = ACTIONS(1308),
    [anon_sym_PIPE] = ACTIONS(1310),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1310),
    [anon_sym_STAR] = ACTIONS(1310),
    [anon_sym_GT_GT_GT] = ACTIONS(1308),
    [anon_sym_BANG_EQ] = ACTIONS(1310),
    [anon_sym_GT_EQ] = ACTIONS(1308),
    [anon_sym_RBRACE] = ACTIONS(1308),
    [anon_sym_PERCENT] = ACTIONS(1308),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1308),
    [anon_sym_as] = ACTIONS(1308),
    [anon_sym_DASH_DASH] = ACTIONS(1308),
    [anon_sym_instanceof] = ACTIONS(1308),
    [anon_sym_COLON] = ACTIONS(1308),
    [anon_sym_DOT] = ACTIONS(1308),
    [anon_sym_STAR_STAR] = ACTIONS(1308),
    [anon_sym_PLUS_PLUS] = ACTIONS(1308),
    [anon_sym_in] = ACTIONS(1310),
    [anon_sym_BANG] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(4529),
    [anon_sym_LT_LT] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1310),
    [anon_sym_AMP_AMP] = ACTIONS(1308),
    [anon_sym_LT_EQ] = ACTIONS(1308),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_RBRACK] = ACTIONS(1308),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_AMP] = ACTIONS(1310),
    [anon_sym_QMARK] = ACTIONS(1308),
    [anon_sym_PIPE_PIPE] = ACTIONS(1308),
    [anon_sym_EQ_EQ] = ACTIONS(1310),
    [anon_sym_RPAREN] = ACTIONS(1308),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_SLASH] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1310),
    [anon_sym_implements] = ACTIONS(1308),
    [anon_sym_GT_GT] = ACTIONS(1310),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1308),
  },
  [1679] = {
    [sym_type_arguments] = STATE(1698),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1314),
    [anon_sym_BQUOTE] = ACTIONS(1314),
    [anon_sym_PIPE] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_GT_GT_GT] = ACTIONS(1314),
    [anon_sym_BANG_EQ] = ACTIONS(1316),
    [anon_sym_GT_EQ] = ACTIONS(1314),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_PERCENT] = ACTIONS(1314),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1314),
    [anon_sym_as] = ACTIONS(1314),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [anon_sym_instanceof] = ACTIONS(1314),
    [anon_sym_COLON] = ACTIONS(1314),
    [anon_sym_DOT] = ACTIONS(1314),
    [anon_sym_STAR_STAR] = ACTIONS(1314),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [anon_sym_in] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1316),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [anon_sym_LT_LT] = ACTIONS(1314),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_AMP_AMP] = ACTIONS(1314),
    [anon_sym_LT_EQ] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_GT] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1316),
    [anon_sym_QMARK] = ACTIONS(1314),
    [anon_sym_PIPE_PIPE] = ACTIONS(1314),
    [anon_sym_EQ_EQ] = ACTIONS(1316),
    [anon_sym_RPAREN] = ACTIONS(1314),
    [anon_sym_LT] = ACTIONS(4531),
    [anon_sym_SLASH] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1314),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_implements] = ACTIONS(1314),
    [anon_sym_GT_GT] = ACTIONS(1316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1314),
  },
  [1680] = {
    [sym_type_arguments] = STATE(1688),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1239),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_GT_GT_GT] = ACTIONS(1239),
    [anon_sym_BANG_EQ] = ACTIONS(1827),
    [anon_sym_GT_EQ] = ACTIONS(1239),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1239),
    [anon_sym_as] = ACTIONS(1239),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [anon_sym_instanceof] = ACTIONS(1239),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_STAR_STAR] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_in] = ACTIONS(1827),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_is] = ACTIONS(4536),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1827),
    [anon_sym_LT_EQ] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_RBRACK] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_QMARK] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1827),
    [anon_sym_RPAREN] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(1827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_implements] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1827),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1239),
  },
  [1681] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1939),
    [anon_sym_BQUOTE] = ACTIONS(1939),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_COMMA] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_GT_GT_GT] = ACTIONS(1939),
    [anon_sym_BANG_EQ] = ACTIONS(1941),
    [anon_sym_GT_EQ] = ACTIONS(1939),
    [anon_sym_RBRACE] = ACTIONS(1939),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1939),
    [anon_sym_as] = ACTIONS(1939),
    [anon_sym_DASH_DASH] = ACTIONS(1939),
    [anon_sym_instanceof] = ACTIONS(1939),
    [anon_sym_COLON] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1939),
    [anon_sym_PLUS_PLUS] = ACTIONS(1939),
    [anon_sym_in] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [anon_sym_LT_LT] = ACTIONS(1939),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_AMP_AMP] = ACTIONS(1939),
    [anon_sym_LT_EQ] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_RBRACK] = ACTIONS(1939),
    [anon_sym_GT] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_QMARK] = ACTIONS(1939),
    [anon_sym_PIPE_PIPE] = ACTIONS(1939),
    [anon_sym_EQ_EQ] = ACTIONS(1941),
    [anon_sym_RPAREN] = ACTIONS(1939),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_SLASH] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1939),
    [anon_sym_PLUS] = ACTIONS(1941),
    [anon_sym_implements] = ACTIONS(1939),
    [anon_sym_GT_GT] = ACTIONS(1941),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1939),
  },
  [1682] = {
    [anon_sym_BQUOTE] = ACTIONS(1943),
    [anon_sym_symbol] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1945),
    [anon_sym_return] = ACTIONS(1945),
    [anon_sym_static] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_interface] = ACTIONS(1945),
    [anon_sym_delete] = ACTIONS(1945),
    [anon_sym_if] = ACTIONS(1945),
    [anon_sym_yield] = ACTIONS(1945),
    [sym_true] = ACTIONS(1945),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_protected] = ACTIONS(1945),
    [anon_sym_set] = ACTIONS(1945),
    [anon_sym_import] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_number] = ACTIONS(1945),
    [anon_sym_typeof] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_switch] = ACTIONS(1945),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [sym_null] = ACTIONS(1945),
    [anon_sym_any] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(1945),
    [anon_sym_public] = ACTIONS(1945),
    [anon_sym_var] = ACTIONS(1945),
    [anon_sym_QMARK] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1945),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_RPAREN] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1945),
    [anon_sym_new] = ACTIONS(1945),
    [anon_sym_export] = ACTIONS(1945),
    [anon_sym_with] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1945),
    [anon_sym_debugger] = ACTIONS(1945),
    [anon_sym_AT] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_EQ] = ACTIONS(1945),
    [anon_sym_void] = ACTIONS(1945),
    [anon_sym_const] = ACTIONS(1945),
    [sym_super] = ACTIONS(1945),
    [anon_sym_private] = ACTIONS(1945),
    [anon_sym_get] = ACTIONS(1945),
    [anon_sym_default] = ACTIONS(1945),
    [anon_sym_enum] = ACTIONS(1945),
    [anon_sym_continue] = ACTIONS(1945),
    [anon_sym_DASH_DASH] = ACTIONS(1943),
    [sym_this] = ACTIONS(1945),
    [anon_sym_throw] = ACTIONS(1945),
    [anon_sym_abstract] = ACTIONS(1945),
    [anon_sym_type] = ACTIONS(1945),
    [anon_sym_namespace] = ACTIONS(1945),
    [anon_sym_PLUS_PLUS] = ACTIONS(1943),
    [anon_sym_else] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [sym_false] = ACTIONS(1945),
    [anon_sym_case] = ACTIONS(1945),
    [anon_sym_module] = ACTIONS(1945),
    [anon_sym_class] = ACTIONS(1945),
    [anon_sym_declare] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(1943),
    [anon_sym_boolean] = ACTIONS(1945),
    [anon_sym_EQ_GT] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_try] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1943),
    [sym_number] = ACTIONS(1943),
    [ts_builtin_sym_end] = ACTIONS(1943),
    [anon_sym_function] = ACTIONS(1945),
    [sym_undefined] = ACTIONS(1945),
    [anon_sym_let] = ACTIONS(1945),
    [anon_sym_PLUS] = ACTIONS(1945),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1943),
    [anon_sym_await] = ACTIONS(1945),
  },
  [1683] = {
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_symbol] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [sym_super] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2095),
    [sym_this] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [sym_false] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_number] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [sym_null] = ACTIONS(2095),
    [anon_sym_any] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2093),
    [sym_number] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_function] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [ts_builtin_sym_end] = ACTIONS(2093),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_await] = ACTIONS(2095),
  },
  [1684] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2199),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_COLON] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_implements] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
  },
  [1685] = {
    [sym__automatic_semicolon] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [sym_readonly] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
  },
  [1686] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1073),
    [sym__automatic_semicolon] = ACTIONS(4489),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_PIPE] = ACTIONS(1075),
    [anon_sym_COMMA] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1075),
    [anon_sym_GT_GT_GT] = ACTIONS(1073),
    [anon_sym_BANG_EQ] = ACTIONS(1075),
    [anon_sym_GT_EQ] = ACTIONS(1073),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_PERCENT] = ACTIONS(1073),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1073),
    [anon_sym_as] = ACTIONS(1073),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_instanceof] = ACTIONS(1073),
    [anon_sym_COLON] = ACTIONS(1073),
    [anon_sym_DOT] = ACTIONS(1073),
    [anon_sym_STAR_STAR] = ACTIONS(1073),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_in] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [anon_sym_LT_LT] = ACTIONS(1073),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [anon_sym_AMP_AMP] = ACTIONS(1073),
    [anon_sym_LT_EQ] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_RBRACK] = ACTIONS(1073),
    [anon_sym_GT] = ACTIONS(1075),
    [anon_sym_AMP] = ACTIONS(1075),
    [anon_sym_QMARK] = ACTIONS(1073),
    [anon_sym_PIPE_PIPE] = ACTIONS(1073),
    [anon_sym_EQ_EQ] = ACTIONS(1075),
    [anon_sym_RPAREN] = ACTIONS(1073),
    [anon_sym_LT] = ACTIONS(1075),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_implements] = ACTIONS(1073),
    [anon_sym_GT_GT] = ACTIONS(1075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1073),
  },
  [1687] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1711),
    [sym_function_type] = STATE(1711),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1711),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1711),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1711),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1688] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2324),
    [anon_sym_BQUOTE] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(2326),
    [anon_sym_COMMA] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2326),
    [anon_sym_STAR] = ACTIONS(2326),
    [anon_sym_GT_GT_GT] = ACTIONS(2324),
    [anon_sym_BANG_EQ] = ACTIONS(2326),
    [anon_sym_GT_EQ] = ACTIONS(2324),
    [anon_sym_RBRACE] = ACTIONS(2324),
    [anon_sym_PERCENT] = ACTIONS(2324),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2324),
    [anon_sym_as] = ACTIONS(2324),
    [anon_sym_DASH_DASH] = ACTIONS(2324),
    [anon_sym_instanceof] = ACTIONS(2324),
    [anon_sym_COLON] = ACTIONS(2324),
    [anon_sym_DOT] = ACTIONS(2324),
    [anon_sym_STAR_STAR] = ACTIONS(2324),
    [anon_sym_PLUS_PLUS] = ACTIONS(2324),
    [anon_sym_in] = ACTIONS(2326),
    [anon_sym_BANG] = ACTIONS(2326),
    [anon_sym_LBRACK] = ACTIONS(2324),
    [anon_sym_LT_LT] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_AMP_AMP] = ACTIONS(2324),
    [anon_sym_LT_EQ] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2324),
    [anon_sym_RBRACK] = ACTIONS(2324),
    [anon_sym_GT] = ACTIONS(2326),
    [anon_sym_AMP] = ACTIONS(2326),
    [anon_sym_QMARK] = ACTIONS(2324),
    [anon_sym_PIPE_PIPE] = ACTIONS(2324),
    [anon_sym_EQ_EQ] = ACTIONS(2326),
    [anon_sym_RPAREN] = ACTIONS(2324),
    [anon_sym_LT] = ACTIONS(2326),
    [anon_sym_SLASH] = ACTIONS(2326),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2326),
    [anon_sym_implements] = ACTIONS(2324),
    [anon_sym_GT_GT] = ACTIONS(2326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2324),
  },
  [1689] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2328),
    [anon_sym_BQUOTE] = ACTIONS(2328),
    [anon_sym_PIPE] = ACTIONS(2330),
    [anon_sym_COMMA] = ACTIONS(2328),
    [anon_sym_DASH] = ACTIONS(2330),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_GT_GT_GT] = ACTIONS(2328),
    [anon_sym_BANG_EQ] = ACTIONS(2330),
    [anon_sym_GT_EQ] = ACTIONS(2328),
    [anon_sym_RBRACE] = ACTIONS(2328),
    [anon_sym_PERCENT] = ACTIONS(2328),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2328),
    [anon_sym_as] = ACTIONS(2328),
    [anon_sym_DASH_DASH] = ACTIONS(2328),
    [anon_sym_instanceof] = ACTIONS(2328),
    [anon_sym_COLON] = ACTIONS(2328),
    [anon_sym_DOT] = ACTIONS(2328),
    [anon_sym_STAR_STAR] = ACTIONS(2328),
    [anon_sym_PLUS_PLUS] = ACTIONS(2328),
    [anon_sym_in] = ACTIONS(2330),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_LBRACK] = ACTIONS(4529),
    [anon_sym_LT_LT] = ACTIONS(2328),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_AMP_AMP] = ACTIONS(2328),
    [anon_sym_LT_EQ] = ACTIONS(2328),
    [anon_sym_LPAREN] = ACTIONS(2328),
    [anon_sym_RBRACK] = ACTIONS(2328),
    [anon_sym_GT] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_QMARK] = ACTIONS(2328),
    [anon_sym_PIPE_PIPE] = ACTIONS(2328),
    [anon_sym_EQ_EQ] = ACTIONS(2330),
    [anon_sym_RPAREN] = ACTIONS(2328),
    [anon_sym_LT] = ACTIONS(2330),
    [anon_sym_SLASH] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2328),
    [anon_sym_PLUS] = ACTIONS(2330),
    [anon_sym_implements] = ACTIONS(2328),
    [anon_sym_GT_GT] = ACTIONS(2330),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2328),
  },
  [1690] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2346),
    [anon_sym_BQUOTE] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2348),
    [anon_sym_GT_GT_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2348),
    [anon_sym_GT_EQ] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2346),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_instanceof] = ACTIONS(2346),
    [anon_sym_COLON] = ACTIONS(2346),
    [anon_sym_DOT] = ACTIONS(2346),
    [anon_sym_STAR_STAR] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_in] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_AMP_AMP] = ACTIONS(2346),
    [anon_sym_LT_EQ] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_RBRACK] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2348),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(2346),
    [anon_sym_PIPE_PIPE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2348),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2348),
    [anon_sym_SLASH] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_implements] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2346),
  },
  [1691] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2400),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2400),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2402),
    [anon_sym_GT_GT_GT] = ACTIONS(2400),
    [anon_sym_BANG_EQ] = ACTIONS(2402),
    [anon_sym_GT_EQ] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_PERCENT] = ACTIONS(2400),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_instanceof] = ACTIONS(2400),
    [anon_sym_COLON] = ACTIONS(2400),
    [anon_sym_DOT] = ACTIONS(2400),
    [anon_sym_STAR_STAR] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_in] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LT_LT] = ACTIONS(2400),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2400),
    [anon_sym_LT_EQ] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_QMARK] = ACTIONS(2400),
    [anon_sym_PIPE_PIPE] = ACTIONS(2400),
    [anon_sym_EQ_EQ] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_implements] = ACTIONS(2400),
    [anon_sym_GT_GT] = ACTIONS(2402),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2400),
  },
  [1692] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2406),
    [anon_sym_GT_GT_GT] = ACTIONS(2404),
    [anon_sym_BANG_EQ] = ACTIONS(2406),
    [anon_sym_GT_EQ] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_PERCENT] = ACTIONS(2404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_instanceof] = ACTIONS(2404),
    [anon_sym_COLON] = ACTIONS(2404),
    [anon_sym_DOT] = ACTIONS(4485),
    [anon_sym_STAR_STAR] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_in] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_AMP_AMP] = ACTIONS(2404),
    [anon_sym_LT_EQ] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(2404),
    [anon_sym_PIPE_PIPE] = ACTIONS(2404),
    [anon_sym_EQ_EQ] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_implements] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2404),
  },
  [1693] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2412),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_GT_GT_GT] = ACTIONS(2410),
    [anon_sym_BANG_EQ] = ACTIONS(2412),
    [anon_sym_GT_EQ] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_PERCENT] = ACTIONS(2410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2410),
    [anon_sym_as] = ACTIONS(2410),
    [anon_sym_DASH_DASH] = ACTIONS(2410),
    [anon_sym_instanceof] = ACTIONS(2410),
    [anon_sym_COLON] = ACTIONS(2410),
    [anon_sym_DOT] = ACTIONS(2410),
    [anon_sym_STAR_STAR] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2410),
    [anon_sym_in] = ACTIONS(2412),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_AMP_AMP] = ACTIONS(2410),
    [anon_sym_LT_EQ] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [anon_sym_GT] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(2410),
    [anon_sym_PIPE_PIPE] = ACTIONS(2410),
    [anon_sym_EQ_EQ] = ACTIONS(2412),
    [anon_sym_RPAREN] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(2412),
    [anon_sym_SLASH] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2412),
    [anon_sym_implements] = ACTIONS(2410),
    [anon_sym_GT_GT] = ACTIONS(2412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2410),
  },
  [1694] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2414),
    [anon_sym_BQUOTE] = ACTIONS(2414),
    [anon_sym_PIPE] = ACTIONS(2416),
    [anon_sym_COMMA] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_GT_GT_GT] = ACTIONS(2414),
    [anon_sym_BANG_EQ] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_PERCENT] = ACTIONS(2414),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2414),
    [anon_sym_as] = ACTIONS(2414),
    [anon_sym_DASH_DASH] = ACTIONS(2414),
    [anon_sym_instanceof] = ACTIONS(2414),
    [anon_sym_COLON] = ACTIONS(2414),
    [anon_sym_DOT] = ACTIONS(4534),
    [anon_sym_STAR_STAR] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2414),
    [anon_sym_in] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_LT_LT] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2414),
    [anon_sym_LT_EQ] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_RBRACK] = ACTIONS(2414),
    [anon_sym_GT] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2414),
    [anon_sym_PIPE_PIPE] = ACTIONS(2414),
    [anon_sym_EQ_EQ] = ACTIONS(2416),
    [anon_sym_RPAREN] = ACTIONS(2414),
    [anon_sym_LT] = ACTIONS(2416),
    [anon_sym_SLASH] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2416),
    [anon_sym_implements] = ACTIONS(2414),
    [anon_sym_GT_GT] = ACTIONS(2416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2414),
  },
  [1695] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [anon_sym_PIPE] = ACTIONS(2422),
    [anon_sym_COMMA] = ACTIONS(2420),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2422),
    [anon_sym_GT_GT_GT] = ACTIONS(2420),
    [anon_sym_BANG_EQ] = ACTIONS(2422),
    [anon_sym_GT_EQ] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_PERCENT] = ACTIONS(2420),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2420),
    [anon_sym_as] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_instanceof] = ACTIONS(2420),
    [anon_sym_COLON] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2420),
    [anon_sym_STAR_STAR] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_in] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LT_LT] = ACTIONS(2420),
    [anon_sym_LBRACE] = ACTIONS(2422),
    [anon_sym_AMP_AMP] = ACTIONS(2420),
    [anon_sym_LT_EQ] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_GT] = ACTIONS(2422),
    [anon_sym_AMP] = ACTIONS(2422),
    [anon_sym_QMARK] = ACTIONS(2420),
    [anon_sym_PIPE_PIPE] = ACTIONS(2420),
    [anon_sym_EQ_EQ] = ACTIONS(2422),
    [anon_sym_RPAREN] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_implements] = ACTIONS(2420),
    [anon_sym_GT_GT] = ACTIONS(2422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2420),
  },
  [1696] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2489),
    [anon_sym_BQUOTE] = ACTIONS(2489),
    [anon_sym_PIPE] = ACTIONS(2491),
    [anon_sym_COMMA] = ACTIONS(2489),
    [anon_sym_DASH] = ACTIONS(2491),
    [anon_sym_STAR] = ACTIONS(2491),
    [anon_sym_GT_GT_GT] = ACTIONS(2489),
    [anon_sym_BANG_EQ] = ACTIONS(2491),
    [anon_sym_GT_EQ] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_PERCENT] = ACTIONS(2489),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2489),
    [anon_sym_as] = ACTIONS(2489),
    [anon_sym_DASH_DASH] = ACTIONS(2489),
    [anon_sym_instanceof] = ACTIONS(2489),
    [anon_sym_COLON] = ACTIONS(2489),
    [anon_sym_DOT] = ACTIONS(2489),
    [anon_sym_STAR_STAR] = ACTIONS(2489),
    [anon_sym_PLUS_PLUS] = ACTIONS(2489),
    [anon_sym_in] = ACTIONS(2491),
    [anon_sym_BANG] = ACTIONS(2491),
    [anon_sym_LBRACK] = ACTIONS(2489),
    [anon_sym_LT_LT] = ACTIONS(2489),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_AMP_AMP] = ACTIONS(2489),
    [anon_sym_LT_EQ] = ACTIONS(2489),
    [anon_sym_LPAREN] = ACTIONS(2489),
    [anon_sym_RBRACK] = ACTIONS(2489),
    [anon_sym_GT] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(2489),
    [anon_sym_PIPE_PIPE] = ACTIONS(2489),
    [anon_sym_EQ_EQ] = ACTIONS(2491),
    [anon_sym_RPAREN] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(2491),
    [anon_sym_SLASH] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2489),
    [anon_sym_PLUS] = ACTIONS(2491),
    [anon_sym_implements] = ACTIONS(2489),
    [anon_sym_GT_GT] = ACTIONS(2491),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2489),
  },
  [1697] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1717),
    [sym_function_type] = STATE(1717),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1717),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1717),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1717),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1698] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2495),
    [anon_sym_BQUOTE] = ACTIONS(2495),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2495),
    [anon_sym_DASH] = ACTIONS(2497),
    [anon_sym_STAR] = ACTIONS(2497),
    [anon_sym_GT_GT_GT] = ACTIONS(2495),
    [anon_sym_BANG_EQ] = ACTIONS(2497),
    [anon_sym_GT_EQ] = ACTIONS(2495),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_PERCENT] = ACTIONS(2495),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2495),
    [anon_sym_as] = ACTIONS(2495),
    [anon_sym_DASH_DASH] = ACTIONS(2495),
    [anon_sym_instanceof] = ACTIONS(2495),
    [anon_sym_COLON] = ACTIONS(2495),
    [anon_sym_DOT] = ACTIONS(2495),
    [anon_sym_STAR_STAR] = ACTIONS(2495),
    [anon_sym_PLUS_PLUS] = ACTIONS(2495),
    [anon_sym_in] = ACTIONS(2497),
    [anon_sym_BANG] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2495),
    [anon_sym_LT_LT] = ACTIONS(2495),
    [anon_sym_LBRACE] = ACTIONS(2497),
    [anon_sym_AMP_AMP] = ACTIONS(2495),
    [anon_sym_LT_EQ] = ACTIONS(2495),
    [anon_sym_LPAREN] = ACTIONS(2495),
    [anon_sym_RBRACK] = ACTIONS(2495),
    [anon_sym_GT] = ACTIONS(2497),
    [anon_sym_AMP] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(2495),
    [anon_sym_PIPE_PIPE] = ACTIONS(2495),
    [anon_sym_EQ_EQ] = ACTIONS(2497),
    [anon_sym_RPAREN] = ACTIONS(2495),
    [anon_sym_LT] = ACTIONS(2497),
    [anon_sym_SLASH] = ACTIONS(2497),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2495),
    [anon_sym_PLUS] = ACTIONS(2497),
    [anon_sym_implements] = ACTIONS(2495),
    [anon_sym_GT_GT] = ACTIONS(2497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2495),
  },
  [1699] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2507),
    [anon_sym_BQUOTE] = ACTIONS(2507),
    [anon_sym_PIPE] = ACTIONS(2509),
    [anon_sym_COMMA] = ACTIONS(2507),
    [anon_sym_DASH] = ACTIONS(2509),
    [anon_sym_STAR] = ACTIONS(2509),
    [anon_sym_GT_GT_GT] = ACTIONS(2507),
    [anon_sym_BANG_EQ] = ACTIONS(2509),
    [anon_sym_GT_EQ] = ACTIONS(2507),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_PERCENT] = ACTIONS(2507),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2507),
    [anon_sym_as] = ACTIONS(2507),
    [anon_sym_DASH_DASH] = ACTIONS(2507),
    [anon_sym_instanceof] = ACTIONS(2507),
    [anon_sym_COLON] = ACTIONS(2507),
    [anon_sym_DOT] = ACTIONS(2507),
    [anon_sym_STAR_STAR] = ACTIONS(2507),
    [anon_sym_PLUS_PLUS] = ACTIONS(2507),
    [anon_sym_in] = ACTIONS(2509),
    [anon_sym_BANG] = ACTIONS(2509),
    [anon_sym_LBRACK] = ACTIONS(2507),
    [anon_sym_LT_LT] = ACTIONS(2507),
    [anon_sym_LBRACE] = ACTIONS(2509),
    [anon_sym_AMP_AMP] = ACTIONS(2507),
    [anon_sym_LT_EQ] = ACTIONS(2507),
    [anon_sym_LPAREN] = ACTIONS(2507),
    [anon_sym_RBRACK] = ACTIONS(2507),
    [anon_sym_GT] = ACTIONS(2509),
    [anon_sym_AMP] = ACTIONS(2509),
    [anon_sym_QMARK] = ACTIONS(2507),
    [anon_sym_PIPE_PIPE] = ACTIONS(2507),
    [anon_sym_EQ_EQ] = ACTIONS(2509),
    [anon_sym_RPAREN] = ACTIONS(2507),
    [anon_sym_LT] = ACTIONS(2509),
    [anon_sym_SLASH] = ACTIONS(2509),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2507),
    [anon_sym_PLUS] = ACTIONS(2509),
    [anon_sym_implements] = ACTIONS(2507),
    [anon_sym_GT_GT] = ACTIONS(2509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2507),
  },
  [1700] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1719),
    [sym_function_type] = STATE(1719),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1719),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1719),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1719),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1701] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1720),
    [sym_function_type] = STATE(1720),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1720),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1720),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1720),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1702] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(4543),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1703] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1704] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1705] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [1706] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1707] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2792),
    [anon_sym_BQUOTE] = ACTIONS(2792),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(2794),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_GT_GT_GT] = ACTIONS(2792),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_PERCENT] = ACTIONS(2792),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2792),
    [anon_sym_as] = ACTIONS(2792),
    [anon_sym_DASH_DASH] = ACTIONS(2792),
    [anon_sym_instanceof] = ACTIONS(2792),
    [anon_sym_COLON] = ACTIONS(2792),
    [anon_sym_DOT] = ACTIONS(2792),
    [anon_sym_STAR_STAR] = ACTIONS(2792),
    [anon_sym_PLUS_PLUS] = ACTIONS(2792),
    [anon_sym_in] = ACTIONS(2794),
    [anon_sym_BANG] = ACTIONS(2794),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [anon_sym_LT_LT] = ACTIONS(2792),
    [anon_sym_LBRACE] = ACTIONS(2794),
    [anon_sym_AMP_AMP] = ACTIONS(2792),
    [anon_sym_LT_EQ] = ACTIONS(2792),
    [anon_sym_LPAREN] = ACTIONS(2792),
    [anon_sym_RBRACK] = ACTIONS(2792),
    [anon_sym_GT] = ACTIONS(2794),
    [anon_sym_AMP] = ACTIONS(2794),
    [anon_sym_QMARK] = ACTIONS(2792),
    [anon_sym_PIPE_PIPE] = ACTIONS(2792),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_RPAREN] = ACTIONS(2792),
    [anon_sym_LT] = ACTIONS(2794),
    [anon_sym_SLASH] = ACTIONS(2794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2792),
    [anon_sym_PLUS] = ACTIONS(2794),
    [anon_sym_implements] = ACTIONS(2792),
    [anon_sym_GT_GT] = ACTIONS(2794),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2792),
  },
  [1708] = {
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [sym_super] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
    [anon_sym_yield] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [sym_false] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [sym_null] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2944),
    [sym_number] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2944),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_await] = ACTIONS(2946),
  },
  [1709] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3060),
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [anon_sym_PIPE] = ACTIONS(3062),
    [anon_sym_COMMA] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_GT_GT_GT] = ACTIONS(3060),
    [anon_sym_BANG_EQ] = ACTIONS(3062),
    [anon_sym_GT_EQ] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_PERCENT] = ACTIONS(3060),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3060),
    [anon_sym_as] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_instanceof] = ACTIONS(3060),
    [anon_sym_COLON] = ACTIONS(3060),
    [anon_sym_DOT] = ACTIONS(3060),
    [anon_sym_STAR_STAR] = ACTIONS(3060),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_in] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_LT_LT] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3060),
    [anon_sym_LT_EQ] = ACTIONS(3060),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_RBRACK] = ACTIONS(3060),
    [anon_sym_GT] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3062),
    [anon_sym_QMARK] = ACTIONS(3060),
    [anon_sym_PIPE_PIPE] = ACTIONS(3060),
    [anon_sym_EQ_EQ] = ACTIONS(3062),
    [anon_sym_RPAREN] = ACTIONS(3060),
    [anon_sym_LT] = ACTIONS(3062),
    [anon_sym_SLASH] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_implements] = ACTIONS(3060),
    [anon_sym_GT_GT] = ACTIONS(3062),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3060),
  },
  [1710] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3156),
    [anon_sym_BQUOTE] = ACTIONS(3156),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_GT_GT_GT] = ACTIONS(3156),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_GT_EQ] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_PERCENT] = ACTIONS(3156),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3156),
    [anon_sym_as] = ACTIONS(3156),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_instanceof] = ACTIONS(3156),
    [anon_sym_COLON] = ACTIONS(3156),
    [anon_sym_DOT] = ACTIONS(4407),
    [anon_sym_STAR_STAR] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3156),
    [anon_sym_LT_LT] = ACTIONS(3156),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_LT_EQ] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3156),
    [anon_sym_RBRACK] = ACTIONS(3156),
    [anon_sym_GT] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3156),
    [anon_sym_PIPE_PIPE] = ACTIONS(3156),
    [anon_sym_EQ_EQ] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3156),
    [anon_sym_LT] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_implements] = ACTIONS(3156),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3156),
  },
  [1711] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3160),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3162),
    [anon_sym_GT_GT_GT] = ACTIONS(3160),
    [anon_sym_BANG_EQ] = ACTIONS(3162),
    [anon_sym_GT_EQ] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_PERCENT] = ACTIONS(3160),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3160),
    [anon_sym_as] = ACTIONS(3160),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_instanceof] = ACTIONS(3160),
    [anon_sym_COLON] = ACTIONS(3160),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_STAR_STAR] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_in] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_LT_LT] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3162),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_LT_EQ] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_RBRACK] = ACTIONS(3160),
    [anon_sym_GT] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_QMARK] = ACTIONS(3160),
    [anon_sym_PIPE_PIPE] = ACTIONS(3160),
    [anon_sym_EQ_EQ] = ACTIONS(3162),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3162),
    [anon_sym_SLASH] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_implements] = ACTIONS(3160),
    [anon_sym_GT_GT] = ACTIONS(3162),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3160),
  },
  [1712] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_COMMA] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3192),
    [anon_sym_COLON] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3194),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_RBRACK] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_RPAREN] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_implements] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
  },
  [1713] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3202),
    [anon_sym_BQUOTE] = ACTIONS(3202),
    [anon_sym_PIPE] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3202),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_STAR] = ACTIONS(3204),
    [anon_sym_GT_GT_GT] = ACTIONS(3202),
    [anon_sym_BANG_EQ] = ACTIONS(3204),
    [anon_sym_GT_EQ] = ACTIONS(3202),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_PERCENT] = ACTIONS(3202),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3202),
    [anon_sym_as] = ACTIONS(3202),
    [anon_sym_DASH_DASH] = ACTIONS(3202),
    [anon_sym_instanceof] = ACTIONS(3202),
    [anon_sym_COLON] = ACTIONS(3202),
    [anon_sym_DOT] = ACTIONS(3202),
    [anon_sym_STAR_STAR] = ACTIONS(3202),
    [anon_sym_PLUS_PLUS] = ACTIONS(3202),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3202),
    [anon_sym_LT_LT] = ACTIONS(3202),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_AMP_AMP] = ACTIONS(3202),
    [anon_sym_LT_EQ] = ACTIONS(3202),
    [anon_sym_LPAREN] = ACTIONS(3202),
    [anon_sym_RBRACK] = ACTIONS(3202),
    [anon_sym_GT] = ACTIONS(3204),
    [anon_sym_AMP] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3202),
    [anon_sym_PIPE_PIPE] = ACTIONS(3202),
    [anon_sym_EQ_EQ] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3202),
    [anon_sym_LT] = ACTIONS(3204),
    [anon_sym_SLASH] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3202),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_implements] = ACTIONS(3202),
    [anon_sym_GT_GT] = ACTIONS(3204),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3202),
  },
  [1714] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1728),
    [sym_function_type] = STATE(1728),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1728),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1728),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1728),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1715] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_RBRACK] = ACTIONS(2346),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1077),
  },
  [1716] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3258),
    [anon_sym_BQUOTE] = ACTIONS(3258),
    [anon_sym_PIPE] = ACTIONS(3260),
    [anon_sym_COMMA] = ACTIONS(3258),
    [anon_sym_DASH] = ACTIONS(3260),
    [anon_sym_STAR] = ACTIONS(3260),
    [anon_sym_GT_GT_GT] = ACTIONS(3258),
    [anon_sym_BANG_EQ] = ACTIONS(3260),
    [anon_sym_GT_EQ] = ACTIONS(3258),
    [anon_sym_RBRACE] = ACTIONS(3258),
    [anon_sym_PERCENT] = ACTIONS(3258),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3258),
    [anon_sym_as] = ACTIONS(3258),
    [anon_sym_DASH_DASH] = ACTIONS(3258),
    [anon_sym_instanceof] = ACTIONS(3258),
    [anon_sym_COLON] = ACTIONS(3258),
    [anon_sym_DOT] = ACTIONS(3258),
    [anon_sym_STAR_STAR] = ACTIONS(3258),
    [anon_sym_PLUS_PLUS] = ACTIONS(3258),
    [anon_sym_in] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_LBRACK] = ACTIONS(3258),
    [anon_sym_LT_LT] = ACTIONS(3258),
    [anon_sym_LBRACE] = ACTIONS(3260),
    [anon_sym_AMP_AMP] = ACTIONS(3258),
    [anon_sym_LT_EQ] = ACTIONS(3258),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_RBRACK] = ACTIONS(3258),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_AMP] = ACTIONS(3260),
    [anon_sym_QMARK] = ACTIONS(3258),
    [anon_sym_PIPE_PIPE] = ACTIONS(3258),
    [anon_sym_EQ_EQ] = ACTIONS(3260),
    [anon_sym_RPAREN] = ACTIONS(3258),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_SLASH] = ACTIONS(3260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3258),
    [anon_sym_PLUS] = ACTIONS(3260),
    [anon_sym_implements] = ACTIONS(3258),
    [anon_sym_GT_GT] = ACTIONS(3260),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3258),
  },
  [1717] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_GT_GT_GT] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3264),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_PERCENT] = ACTIONS(3262),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3262),
    [anon_sym_as] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_instanceof] = ACTIONS(3262),
    [anon_sym_COLON] = ACTIONS(3262),
    [anon_sym_DOT] = ACTIONS(3262),
    [anon_sym_STAR_STAR] = ACTIONS(3262),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_LT_LT] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(3264),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_RBRACK] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_QMARK] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_EQ_EQ] = ACTIONS(3264),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_implements] = ACTIONS(3262),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3262),
  },
  [1718] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BQUOTE] = ACTIONS(3266),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(3268),
    [anon_sym_GT_GT_GT] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3268),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_PERCENT] = ACTIONS(3266),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3266),
    [anon_sym_as] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_instanceof] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3266),
    [anon_sym_DOT] = ACTIONS(3266),
    [anon_sym_STAR_STAR] = ACTIONS(3266),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3266),
    [anon_sym_LT_LT] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(3268),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_QMARK] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_EQ_EQ] = ACTIONS(3268),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_SLASH] = ACTIONS(3268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_implements] = ACTIONS(3266),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3266),
  },
  [1719] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3283),
    [anon_sym_BQUOTE] = ACTIONS(3283),
    [anon_sym_PIPE] = ACTIONS(3285),
    [anon_sym_COMMA] = ACTIONS(3283),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_STAR] = ACTIONS(3285),
    [anon_sym_GT_GT_GT] = ACTIONS(3283),
    [anon_sym_BANG_EQ] = ACTIONS(3285),
    [anon_sym_GT_EQ] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3283),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3283),
    [anon_sym_as] = ACTIONS(3283),
    [anon_sym_DASH_DASH] = ACTIONS(3283),
    [anon_sym_instanceof] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3283),
    [anon_sym_DOT] = ACTIONS(3283),
    [anon_sym_STAR_STAR] = ACTIONS(3283),
    [anon_sym_PLUS_PLUS] = ACTIONS(3283),
    [anon_sym_in] = ACTIONS(3285),
    [anon_sym_BANG] = ACTIONS(3285),
    [anon_sym_LBRACK] = ACTIONS(3283),
    [anon_sym_LT_LT] = ACTIONS(3283),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_AMP_AMP] = ACTIONS(3283),
    [anon_sym_LT_EQ] = ACTIONS(3283),
    [anon_sym_LPAREN] = ACTIONS(3283),
    [anon_sym_RBRACK] = ACTIONS(3283),
    [anon_sym_GT] = ACTIONS(3285),
    [anon_sym_AMP] = ACTIONS(3285),
    [anon_sym_QMARK] = ACTIONS(3283),
    [anon_sym_PIPE_PIPE] = ACTIONS(3283),
    [anon_sym_EQ_EQ] = ACTIONS(3285),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_LT] = ACTIONS(3285),
    [anon_sym_SLASH] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3283),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_implements] = ACTIONS(3283),
    [anon_sym_GT_GT] = ACTIONS(3285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3283),
  },
  [1720] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3287),
    [anon_sym_BQUOTE] = ACTIONS(3287),
    [anon_sym_PIPE] = ACTIONS(3289),
    [anon_sym_COMMA] = ACTIONS(3287),
    [anon_sym_DASH] = ACTIONS(3289),
    [anon_sym_STAR] = ACTIONS(3289),
    [anon_sym_GT_GT_GT] = ACTIONS(3287),
    [anon_sym_BANG_EQ] = ACTIONS(3289),
    [anon_sym_GT_EQ] = ACTIONS(3287),
    [anon_sym_RBRACE] = ACTIONS(3287),
    [anon_sym_PERCENT] = ACTIONS(3287),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3287),
    [anon_sym_as] = ACTIONS(3287),
    [anon_sym_DASH_DASH] = ACTIONS(3287),
    [anon_sym_instanceof] = ACTIONS(3287),
    [anon_sym_COLON] = ACTIONS(3287),
    [anon_sym_DOT] = ACTIONS(3287),
    [anon_sym_STAR_STAR] = ACTIONS(3287),
    [anon_sym_PLUS_PLUS] = ACTIONS(3287),
    [anon_sym_in] = ACTIONS(3289),
    [anon_sym_BANG] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3287),
    [anon_sym_LT_LT] = ACTIONS(3287),
    [anon_sym_LBRACE] = ACTIONS(3289),
    [anon_sym_AMP_AMP] = ACTIONS(3287),
    [anon_sym_LT_EQ] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3287),
    [anon_sym_RBRACK] = ACTIONS(3287),
    [anon_sym_GT] = ACTIONS(3289),
    [anon_sym_AMP] = ACTIONS(3289),
    [anon_sym_QMARK] = ACTIONS(3287),
    [anon_sym_PIPE_PIPE] = ACTIONS(3287),
    [anon_sym_EQ_EQ] = ACTIONS(3289),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_LT] = ACTIONS(3289),
    [anon_sym_SLASH] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3289),
    [anon_sym_implements] = ACTIONS(3287),
    [anon_sym_GT_GT] = ACTIONS(3289),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3287),
  },
  [1721] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3291),
    [anon_sym_BQUOTE] = ACTIONS(3291),
    [anon_sym_PIPE] = ACTIONS(3293),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(3293),
    [anon_sym_STAR] = ACTIONS(3293),
    [anon_sym_GT_GT_GT] = ACTIONS(3291),
    [anon_sym_BANG_EQ] = ACTIONS(3293),
    [anon_sym_GT_EQ] = ACTIONS(3291),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_PERCENT] = ACTIONS(3291),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3291),
    [anon_sym_as] = ACTIONS(3291),
    [anon_sym_DASH_DASH] = ACTIONS(3291),
    [anon_sym_instanceof] = ACTIONS(3291),
    [anon_sym_COLON] = ACTIONS(3291),
    [anon_sym_DOT] = ACTIONS(3291),
    [anon_sym_STAR_STAR] = ACTIONS(3291),
    [anon_sym_PLUS_PLUS] = ACTIONS(3291),
    [anon_sym_in] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(3293),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_LT_LT] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(3293),
    [anon_sym_AMP_AMP] = ACTIONS(3291),
    [anon_sym_LT_EQ] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(3291),
    [anon_sym_RBRACK] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(3293),
    [anon_sym_AMP] = ACTIONS(3293),
    [anon_sym_QMARK] = ACTIONS(3291),
    [anon_sym_PIPE_PIPE] = ACTIONS(3291),
    [anon_sym_EQ_EQ] = ACTIONS(3293),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3293),
    [anon_sym_SLASH] = ACTIONS(3293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3291),
    [anon_sym_PLUS] = ACTIONS(3293),
    [anon_sym_implements] = ACTIONS(3291),
    [anon_sym_GT_GT] = ACTIONS(3293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3291),
  },
  [1722] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1732),
    [sym_function_type] = STATE(1732),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1732),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1732),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1732),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1723] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4549),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1724] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2410),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1725] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(3501),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1726] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3653),
    [anon_sym_BQUOTE] = ACTIONS(3653),
    [anon_sym_PIPE] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3653),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3655),
    [anon_sym_GT_GT_GT] = ACTIONS(3653),
    [anon_sym_BANG_EQ] = ACTIONS(3655),
    [anon_sym_GT_EQ] = ACTIONS(3653),
    [anon_sym_RBRACE] = ACTIONS(3653),
    [anon_sym_PERCENT] = ACTIONS(3653),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3653),
    [anon_sym_as] = ACTIONS(3653),
    [anon_sym_DASH_DASH] = ACTIONS(3653),
    [anon_sym_instanceof] = ACTIONS(3653),
    [anon_sym_COLON] = ACTIONS(3653),
    [anon_sym_DOT] = ACTIONS(3653),
    [anon_sym_STAR_STAR] = ACTIONS(3653),
    [anon_sym_PLUS_PLUS] = ACTIONS(3653),
    [anon_sym_in] = ACTIONS(3655),
    [anon_sym_BANG] = ACTIONS(3655),
    [anon_sym_LBRACK] = ACTIONS(3653),
    [anon_sym_LT_LT] = ACTIONS(3653),
    [anon_sym_LBRACE] = ACTIONS(3655),
    [anon_sym_AMP_AMP] = ACTIONS(3653),
    [anon_sym_LT_EQ] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(3653),
    [anon_sym_RBRACK] = ACTIONS(3653),
    [anon_sym_GT] = ACTIONS(3655),
    [anon_sym_AMP] = ACTIONS(3655),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_PIPE_PIPE] = ACTIONS(3653),
    [anon_sym_EQ_EQ] = ACTIONS(3655),
    [anon_sym_RPAREN] = ACTIONS(3653),
    [anon_sym_LT] = ACTIONS(3655),
    [anon_sym_SLASH] = ACTIONS(3655),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3653),
    [anon_sym_PLUS] = ACTIONS(3655),
    [anon_sym_implements] = ACTIONS(3653),
    [anon_sym_GT_GT] = ACTIONS(3655),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3653),
  },
  [1727] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3692),
    [anon_sym_BQUOTE] = ACTIONS(3692),
    [anon_sym_PIPE] = ACTIONS(3694),
    [anon_sym_COMMA] = ACTIONS(3692),
    [anon_sym_DASH] = ACTIONS(3694),
    [anon_sym_STAR] = ACTIONS(3694),
    [anon_sym_GT_GT_GT] = ACTIONS(3692),
    [anon_sym_BANG_EQ] = ACTIONS(3694),
    [anon_sym_GT_EQ] = ACTIONS(3692),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [anon_sym_PERCENT] = ACTIONS(3692),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3692),
    [anon_sym_as] = ACTIONS(3692),
    [anon_sym_DASH_DASH] = ACTIONS(3692),
    [anon_sym_instanceof] = ACTIONS(3692),
    [anon_sym_COLON] = ACTIONS(3692),
    [anon_sym_DOT] = ACTIONS(3692),
    [anon_sym_STAR_STAR] = ACTIONS(3692),
    [anon_sym_PLUS_PLUS] = ACTIONS(3692),
    [anon_sym_in] = ACTIONS(3694),
    [anon_sym_BANG] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3692),
    [anon_sym_LT_LT] = ACTIONS(3692),
    [anon_sym_LBRACE] = ACTIONS(3694),
    [anon_sym_AMP_AMP] = ACTIONS(3692),
    [anon_sym_LT_EQ] = ACTIONS(3692),
    [anon_sym_LPAREN] = ACTIONS(3692),
    [anon_sym_RBRACK] = ACTIONS(3692),
    [anon_sym_GT] = ACTIONS(3694),
    [anon_sym_AMP] = ACTIONS(3694),
    [anon_sym_QMARK] = ACTIONS(3692),
    [anon_sym_PIPE_PIPE] = ACTIONS(3692),
    [anon_sym_EQ_EQ] = ACTIONS(3694),
    [anon_sym_RPAREN] = ACTIONS(3692),
    [anon_sym_LT] = ACTIONS(3694),
    [anon_sym_SLASH] = ACTIONS(3694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3692),
    [anon_sym_PLUS] = ACTIONS(3694),
    [anon_sym_implements] = ACTIONS(3692),
    [anon_sym_GT_GT] = ACTIONS(3694),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3692),
  },
  [1728] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3696),
    [anon_sym_BQUOTE] = ACTIONS(3696),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(3696),
    [anon_sym_DASH] = ACTIONS(3698),
    [anon_sym_STAR] = ACTIONS(3698),
    [anon_sym_GT_GT_GT] = ACTIONS(3696),
    [anon_sym_BANG_EQ] = ACTIONS(3698),
    [anon_sym_GT_EQ] = ACTIONS(3696),
    [anon_sym_RBRACE] = ACTIONS(3696),
    [anon_sym_PERCENT] = ACTIONS(3696),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3696),
    [anon_sym_as] = ACTIONS(3696),
    [anon_sym_DASH_DASH] = ACTIONS(3696),
    [anon_sym_instanceof] = ACTIONS(3696),
    [anon_sym_COLON] = ACTIONS(3696),
    [anon_sym_DOT] = ACTIONS(3696),
    [anon_sym_STAR_STAR] = ACTIONS(3696),
    [anon_sym_PLUS_PLUS] = ACTIONS(3696),
    [anon_sym_in] = ACTIONS(3698),
    [anon_sym_BANG] = ACTIONS(3698),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [anon_sym_LT_LT] = ACTIONS(3696),
    [anon_sym_LBRACE] = ACTIONS(3698),
    [anon_sym_AMP_AMP] = ACTIONS(3696),
    [anon_sym_LT_EQ] = ACTIONS(3696),
    [anon_sym_LPAREN] = ACTIONS(3696),
    [anon_sym_RBRACK] = ACTIONS(3696),
    [anon_sym_GT] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_QMARK] = ACTIONS(3696),
    [anon_sym_PIPE_PIPE] = ACTIONS(3696),
    [anon_sym_EQ_EQ] = ACTIONS(3698),
    [anon_sym_RPAREN] = ACTIONS(3696),
    [anon_sym_LT] = ACTIONS(3698),
    [anon_sym_SLASH] = ACTIONS(3698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3696),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_implements] = ACTIONS(3696),
    [anon_sym_GT_GT] = ACTIONS(3698),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3696),
  },
  [1729] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1734),
    [sym_function_type] = STATE(1734),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1734),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1734),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1734),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1730] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3741),
    [anon_sym_BQUOTE] = ACTIONS(3741),
    [anon_sym_PIPE] = ACTIONS(3743),
    [anon_sym_COMMA] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3743),
    [anon_sym_STAR] = ACTIONS(3743),
    [anon_sym_GT_GT_GT] = ACTIONS(3741),
    [anon_sym_BANG_EQ] = ACTIONS(3743),
    [anon_sym_GT_EQ] = ACTIONS(3741),
    [anon_sym_RBRACE] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(3741),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3741),
    [anon_sym_as] = ACTIONS(3741),
    [anon_sym_DASH_DASH] = ACTIONS(3741),
    [anon_sym_instanceof] = ACTIONS(3741),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_DOT] = ACTIONS(3741),
    [anon_sym_STAR_STAR] = ACTIONS(3741),
    [anon_sym_PLUS_PLUS] = ACTIONS(3741),
    [anon_sym_in] = ACTIONS(3743),
    [anon_sym_BANG] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [anon_sym_LT_LT] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3743),
    [anon_sym_AMP_AMP] = ACTIONS(3741),
    [anon_sym_LT_EQ] = ACTIONS(3741),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_RBRACK] = ACTIONS(3741),
    [anon_sym_GT] = ACTIONS(3743),
    [anon_sym_AMP] = ACTIONS(3743),
    [anon_sym_QMARK] = ACTIONS(3741),
    [anon_sym_PIPE_PIPE] = ACTIONS(3741),
    [anon_sym_EQ_EQ] = ACTIONS(3743),
    [anon_sym_RPAREN] = ACTIONS(3741),
    [anon_sym_LT] = ACTIONS(3743),
    [anon_sym_SLASH] = ACTIONS(3743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3741),
    [anon_sym_PLUS] = ACTIONS(3743),
    [anon_sym_implements] = ACTIONS(3741),
    [anon_sym_GT_GT] = ACTIONS(3743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3741),
  },
  [1731] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3749),
    [anon_sym_BQUOTE] = ACTIONS(3749),
    [anon_sym_PIPE] = ACTIONS(3751),
    [anon_sym_COMMA] = ACTIONS(3749),
    [anon_sym_DASH] = ACTIONS(3751),
    [anon_sym_STAR] = ACTIONS(3751),
    [anon_sym_GT_GT_GT] = ACTIONS(3749),
    [anon_sym_BANG_EQ] = ACTIONS(3751),
    [anon_sym_GT_EQ] = ACTIONS(3749),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_PERCENT] = ACTIONS(3749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3749),
    [anon_sym_as] = ACTIONS(3749),
    [anon_sym_DASH_DASH] = ACTIONS(3749),
    [anon_sym_instanceof] = ACTIONS(3749),
    [anon_sym_COLON] = ACTIONS(3749),
    [anon_sym_DOT] = ACTIONS(3749),
    [anon_sym_STAR_STAR] = ACTIONS(3749),
    [anon_sym_PLUS_PLUS] = ACTIONS(3749),
    [anon_sym_in] = ACTIONS(3751),
    [anon_sym_BANG] = ACTIONS(3751),
    [anon_sym_LBRACK] = ACTIONS(3749),
    [anon_sym_LT_LT] = ACTIONS(3749),
    [anon_sym_LBRACE] = ACTIONS(3751),
    [anon_sym_AMP_AMP] = ACTIONS(3749),
    [anon_sym_LT_EQ] = ACTIONS(3749),
    [anon_sym_LPAREN] = ACTIONS(3749),
    [anon_sym_RBRACK] = ACTIONS(3749),
    [anon_sym_GT] = ACTIONS(3751),
    [anon_sym_AMP] = ACTIONS(3751),
    [anon_sym_QMARK] = ACTIONS(3749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3749),
    [anon_sym_EQ_EQ] = ACTIONS(3751),
    [anon_sym_RPAREN] = ACTIONS(3749),
    [anon_sym_LT] = ACTIONS(3751),
    [anon_sym_SLASH] = ACTIONS(3751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3749),
    [anon_sym_PLUS] = ACTIONS(3751),
    [anon_sym_implements] = ACTIONS(3749),
    [anon_sym_GT_GT] = ACTIONS(3751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3749),
  },
  [1732] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3753),
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_STAR] = ACTIONS(3755),
    [anon_sym_GT_GT_GT] = ACTIONS(3753),
    [anon_sym_BANG_EQ] = ACTIONS(3755),
    [anon_sym_GT_EQ] = ACTIONS(3753),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_PERCENT] = ACTIONS(3753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3753),
    [anon_sym_as] = ACTIONS(3753),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [anon_sym_instanceof] = ACTIONS(3753),
    [anon_sym_COLON] = ACTIONS(3753),
    [anon_sym_DOT] = ACTIONS(3753),
    [anon_sym_STAR_STAR] = ACTIONS(3753),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_in] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3755),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [anon_sym_LT_LT] = ACTIONS(3753),
    [anon_sym_LBRACE] = ACTIONS(3755),
    [anon_sym_AMP_AMP] = ACTIONS(3753),
    [anon_sym_LT_EQ] = ACTIONS(3753),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_RBRACK] = ACTIONS(3753),
    [anon_sym_GT] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_QMARK] = ACTIONS(3753),
    [anon_sym_PIPE_PIPE] = ACTIONS(3753),
    [anon_sym_EQ_EQ] = ACTIONS(3755),
    [anon_sym_RPAREN] = ACTIONS(3753),
    [anon_sym_LT] = ACTIONS(3755),
    [anon_sym_SLASH] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3753),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_implements] = ACTIONS(3753),
    [anon_sym_GT_GT] = ACTIONS(3755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3753),
  },
  [1733] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3981),
    [anon_sym_BQUOTE] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(3983),
    [anon_sym_COMMA] = ACTIONS(3981),
    [anon_sym_DASH] = ACTIONS(3983),
    [anon_sym_STAR] = ACTIONS(3983),
    [anon_sym_GT_GT_GT] = ACTIONS(3981),
    [anon_sym_BANG_EQ] = ACTIONS(3983),
    [anon_sym_GT_EQ] = ACTIONS(3981),
    [anon_sym_RBRACE] = ACTIONS(3981),
    [anon_sym_PERCENT] = ACTIONS(3981),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3981),
    [anon_sym_as] = ACTIONS(3981),
    [anon_sym_DASH_DASH] = ACTIONS(3981),
    [anon_sym_instanceof] = ACTIONS(3981),
    [anon_sym_COLON] = ACTIONS(3981),
    [anon_sym_DOT] = ACTIONS(3981),
    [anon_sym_STAR_STAR] = ACTIONS(3981),
    [anon_sym_PLUS_PLUS] = ACTIONS(3981),
    [anon_sym_in] = ACTIONS(3983),
    [anon_sym_BANG] = ACTIONS(3983),
    [anon_sym_LBRACK] = ACTIONS(3981),
    [anon_sym_LT_LT] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(3983),
    [anon_sym_AMP_AMP] = ACTIONS(3981),
    [anon_sym_LT_EQ] = ACTIONS(3981),
    [anon_sym_LPAREN] = ACTIONS(3981),
    [anon_sym_RBRACK] = ACTIONS(3981),
    [anon_sym_GT] = ACTIONS(3983),
    [anon_sym_AMP] = ACTIONS(3983),
    [anon_sym_QMARK] = ACTIONS(3981),
    [anon_sym_PIPE_PIPE] = ACTIONS(3981),
    [anon_sym_EQ_EQ] = ACTIONS(3983),
    [anon_sym_RPAREN] = ACTIONS(3981),
    [anon_sym_LT] = ACTIONS(3983),
    [anon_sym_SLASH] = ACTIONS(3983),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3981),
    [anon_sym_PLUS] = ACTIONS(3983),
    [anon_sym_implements] = ACTIONS(3981),
    [anon_sym_GT_GT] = ACTIONS(3983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3981),
  },
  [1734] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4007),
    [anon_sym_BQUOTE] = ACTIONS(4007),
    [anon_sym_PIPE] = ACTIONS(4545),
    [anon_sym_COMMA] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_STAR] = ACTIONS(4009),
    [anon_sym_GT_GT_GT] = ACTIONS(4007),
    [anon_sym_BANG_EQ] = ACTIONS(4009),
    [anon_sym_GT_EQ] = ACTIONS(4007),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_PERCENT] = ACTIONS(4007),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4007),
    [anon_sym_as] = ACTIONS(4007),
    [anon_sym_DASH_DASH] = ACTIONS(4007),
    [anon_sym_instanceof] = ACTIONS(4007),
    [anon_sym_COLON] = ACTIONS(4007),
    [anon_sym_DOT] = ACTIONS(4007),
    [anon_sym_STAR_STAR] = ACTIONS(4007),
    [anon_sym_PLUS_PLUS] = ACTIONS(4007),
    [anon_sym_in] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(4009),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [anon_sym_LT_LT] = ACTIONS(4007),
    [anon_sym_LBRACE] = ACTIONS(4009),
    [anon_sym_AMP_AMP] = ACTIONS(4007),
    [anon_sym_LT_EQ] = ACTIONS(4007),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_RBRACK] = ACTIONS(4007),
    [anon_sym_GT] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(4547),
    [anon_sym_QMARK] = ACTIONS(4007),
    [anon_sym_PIPE_PIPE] = ACTIONS(4007),
    [anon_sym_EQ_EQ] = ACTIONS(4009),
    [anon_sym_RPAREN] = ACTIONS(4007),
    [anon_sym_LT] = ACTIONS(4009),
    [anon_sym_SLASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4007),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_implements] = ACTIONS(4007),
    [anon_sym_GT_GT] = ACTIONS(4009),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4007),
  },
  [1735] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1736] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(4126),
    [anon_sym_BQUOTE] = ACTIONS(4126),
    [anon_sym_PIPE] = ACTIONS(4128),
    [anon_sym_COMMA] = ACTIONS(4126),
    [anon_sym_DASH] = ACTIONS(4128),
    [anon_sym_STAR] = ACTIONS(4128),
    [anon_sym_GT_GT_GT] = ACTIONS(4126),
    [anon_sym_BANG_EQ] = ACTIONS(4128),
    [anon_sym_GT_EQ] = ACTIONS(4126),
    [anon_sym_RBRACE] = ACTIONS(4126),
    [anon_sym_PERCENT] = ACTIONS(4126),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4126),
    [anon_sym_as] = ACTIONS(4126),
    [anon_sym_DASH_DASH] = ACTIONS(4126),
    [anon_sym_instanceof] = ACTIONS(4126),
    [anon_sym_COLON] = ACTIONS(4126),
    [anon_sym_DOT] = ACTIONS(4126),
    [anon_sym_STAR_STAR] = ACTIONS(4126),
    [anon_sym_PLUS_PLUS] = ACTIONS(4126),
    [anon_sym_in] = ACTIONS(4128),
    [anon_sym_BANG] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_LT_LT] = ACTIONS(4126),
    [anon_sym_LBRACE] = ACTIONS(4128),
    [anon_sym_AMP_AMP] = ACTIONS(4126),
    [anon_sym_LT_EQ] = ACTIONS(4126),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_RBRACK] = ACTIONS(4126),
    [anon_sym_GT] = ACTIONS(4128),
    [anon_sym_AMP] = ACTIONS(4128),
    [anon_sym_QMARK] = ACTIONS(4126),
    [anon_sym_PIPE_PIPE] = ACTIONS(4126),
    [anon_sym_EQ_EQ] = ACTIONS(4128),
    [anon_sym_RPAREN] = ACTIONS(4126),
    [anon_sym_LT] = ACTIONS(4128),
    [anon_sym_SLASH] = ACTIONS(4128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(4126),
    [anon_sym_PLUS] = ACTIONS(4128),
    [anon_sym_implements] = ACTIONS(4126),
    [anon_sym_GT_GT] = ACTIONS(4128),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4126),
  },
  [1737] = {
    [sym__automatic_semicolon] = ACTIONS(842),
    [anon_sym_RBRACE] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(842),
    [anon_sym_QMARK] = ACTIONS(842),
    [anon_sym_AMP] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(842),
    [anon_sym_COMMA] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(842),
    [anon_sym_EQ] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(842),
    [anon_sym_PIPE_RBRACE] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(842),
  },
  [1738] = {
    [sym_type_arguments] = STATE(539),
    [anon_sym_BQUOTE] = ACTIONS(1314),
    [anon_sym_symbol] = ACTIONS(1316),
    [anon_sym_PIPE] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1316),
    [anon_sym_return] = ACTIONS(1316),
    [anon_sym_static] = ACTIONS(1316),
    [anon_sym_RBRACE] = ACTIONS(1314),
    [anon_sym_interface] = ACTIONS(1316),
    [anon_sym_delete] = ACTIONS(1316),
    [anon_sym_if] = ACTIONS(1316),
    [anon_sym_yield] = ACTIONS(1316),
    [sym_true] = ACTIONS(1316),
    [anon_sym_protected] = ACTIONS(1316),
    [anon_sym_set] = ACTIONS(1316),
    [anon_sym_import] = ACTIONS(1316),
    [anon_sym_DQUOTE] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1316),
    [anon_sym_SEMI] = ACTIONS(1314),
    [anon_sym_number] = ACTIONS(1316),
    [anon_sym_typeof] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1314),
    [anon_sym_switch] = ACTIONS(1316),
    [sym_null] = ACTIONS(1316),
    [anon_sym_any] = ACTIONS(1316),
    [anon_sym_async] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(1316),
    [anon_sym_var] = ACTIONS(1316),
    [anon_sym_while] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(1314),
    [anon_sym_SLASH] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1316),
    [anon_sym_new] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(1316),
    [anon_sym_with] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1316),
    [anon_sym_debugger] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1314),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_void] = ACTIONS(1316),
    [anon_sym_const] = ACTIONS(1316),
    [sym_super] = ACTIONS(1316),
    [anon_sym_private] = ACTIONS(1316),
    [anon_sym_get] = ACTIONS(1316),
    [anon_sym_default] = ACTIONS(1316),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_continue] = ACTIONS(1316),
    [anon_sym_DASH_DASH] = ACTIONS(1314),
    [sym_this] = ACTIONS(1316),
    [anon_sym_throw] = ACTIONS(1316),
    [anon_sym_abstract] = ACTIONS(1316),
    [anon_sym_type] = ACTIONS(1316),
    [anon_sym_namespace] = ACTIONS(1316),
    [anon_sym_PLUS_PLUS] = ACTIONS(1314),
    [anon_sym_else] = ACTIONS(1316),
    [anon_sym_BANG] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1314),
    [sym_false] = ACTIONS(1316),
    [anon_sym_case] = ACTIONS(1316),
    [anon_sym_module] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1316),
    [anon_sym_declare] = ACTIONS(1316),
    [anon_sym_LPAREN] = ACTIONS(1314),
    [anon_sym_boolean] = ACTIONS(1316),
    [anon_sym_AMP] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1316),
    [anon_sym_LT] = ACTIONS(4551),
    [sym_number] = ACTIONS(1314),
    [ts_builtin_sym_end] = ACTIONS(1314),
    [anon_sym_function] = ACTIONS(1316),
    [sym_undefined] = ACTIONS(1316),
    [anon_sym_let] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_do] = ACTIONS(1316),
    [anon_sym_TILDE] = ACTIONS(1314),
    [anon_sym_await] = ACTIONS(1316),
  },
  [1739] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BQUOTE] = ACTIONS(1239),
    [anon_sym_symbol] = ACTIONS(1827),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_break] = ACTIONS(1827),
    [anon_sym_return] = ACTIONS(1827),
    [anon_sym_static] = ACTIONS(1827),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_interface] = ACTIONS(1827),
    [anon_sym_delete] = ACTIONS(1827),
    [anon_sym_if] = ACTIONS(1827),
    [anon_sym_yield] = ACTIONS(1827),
    [sym_true] = ACTIONS(1827),
    [anon_sym_protected] = ACTIONS(1827),
    [anon_sym_DOT] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(1827),
    [anon_sym_import] = ACTIONS(1827),
    [anon_sym_DQUOTE] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1827),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_number] = ACTIONS(1827),
    [anon_sym_typeof] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(1239),
    [anon_sym_switch] = ACTIONS(1827),
    [sym_null] = ACTIONS(1827),
    [anon_sym_any] = ACTIONS(1827),
    [anon_sym_async] = ACTIONS(1827),
    [anon_sym_public] = ACTIONS(1827),
    [anon_sym_var] = ACTIONS(1827),
    [anon_sym_while] = ACTIONS(1827),
    [anon_sym_SQUOTE] = ACTIONS(1239),
    [anon_sym_SLASH] = ACTIONS(1827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1827),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_export] = ACTIONS(1827),
    [anon_sym_with] = ACTIONS(1827),
    [sym_identifier] = ACTIONS(1827),
    [anon_sym_debugger] = ACTIONS(1827),
    [anon_sym_AT] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_void] = ACTIONS(1827),
    [anon_sym_const] = ACTIONS(1827),
    [sym_super] = ACTIONS(1827),
    [anon_sym_private] = ACTIONS(1827),
    [anon_sym_get] = ACTIONS(1827),
    [anon_sym_default] = ACTIONS(1827),
    [anon_sym_enum] = ACTIONS(1827),
    [anon_sym_continue] = ACTIONS(1827),
    [anon_sym_DASH_DASH] = ACTIONS(1239),
    [sym_this] = ACTIONS(1827),
    [anon_sym_throw] = ACTIONS(1827),
    [anon_sym_abstract] = ACTIONS(1827),
    [anon_sym_type] = ACTIONS(1827),
    [anon_sym_namespace] = ACTIONS(1827),
    [anon_sym_PLUS_PLUS] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1827),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [sym_false] = ACTIONS(1827),
    [anon_sym_case] = ACTIONS(1827),
    [anon_sym_module] = ACTIONS(1827),
    [anon_sym_class] = ACTIONS(1827),
    [anon_sym_declare] = ACTIONS(1827),
    [anon_sym_is] = ACTIONS(4554),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_boolean] = ACTIONS(1827),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_try] = ACTIONS(1827),
    [anon_sym_LT] = ACTIONS(4556),
    [sym_number] = ACTIONS(1239),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1827),
    [sym_undefined] = ACTIONS(1827),
    [anon_sym_let] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1827),
    [anon_sym_do] = ACTIONS(1827),
    [anon_sym_TILDE] = ACTIONS(1239),
    [anon_sym_await] = ACTIONS(1827),
  },
  [1740] = {
    [sym__automatic_semicolon] = ACTIONS(1943),
    [anon_sym_RBRACE] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1943),
    [anon_sym_QMARK] = ACTIONS(1943),
    [anon_sym_AMP] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_PIPE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1943),
    [anon_sym_EQ] = ACTIONS(1943),
    [anon_sym_COLON] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1943),
  },
  [1741] = {
    [sym__automatic_semicolon] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2095),
    [anon_sym_BQUOTE] = ACTIONS(2093),
    [anon_sym_debugger] = ACTIONS(2095),
    [anon_sym_symbol] = ACTIONS(2095),
    [anon_sym_AT] = ACTIONS(2093),
    [anon_sym_DASH] = ACTIONS(2095),
    [anon_sym_void] = ACTIONS(2095),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_const] = ACTIONS(2095),
    [sym_super] = ACTIONS(2095),
    [anon_sym_return] = ACTIONS(2095),
    [anon_sym_private] = ACTIONS(2095),
    [anon_sym_static] = ACTIONS(2095),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_interface] = ACTIONS(2095),
    [anon_sym_default] = ACTIONS(2095),
    [anon_sym_enum] = ACTIONS(2095),
    [anon_sym_delete] = ACTIONS(2095),
    [anon_sym_continue] = ACTIONS(2095),
    [anon_sym_DASH_DASH] = ACTIONS(2093),
    [anon_sym_if] = ACTIONS(2095),
    [sym_this] = ACTIONS(2095),
    [anon_sym_yield] = ACTIONS(2095),
    [sym_true] = ACTIONS(2095),
    [anon_sym_throw] = ACTIONS(2095),
    [anon_sym_protected] = ACTIONS(2095),
    [anon_sym_abstract] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_type] = ACTIONS(2095),
    [anon_sym_import] = ACTIONS(2095),
    [anon_sym_namespace] = ACTIONS(2095),
    [anon_sym_PLUS_PLUS] = ACTIONS(2093),
    [anon_sym_DQUOTE] = ACTIONS(2093),
    [anon_sym_else] = ACTIONS(2095),
    [anon_sym_BANG] = ACTIONS(2093),
    [anon_sym_for] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2093),
    [sym_false] = ACTIONS(2095),
    [anon_sym_SEMI] = ACTIONS(2093),
    [anon_sym_case] = ACTIONS(2095),
    [anon_sym_module] = ACTIONS(2095),
    [anon_sym_number] = ACTIONS(2095),
    [anon_sym_class] = ACTIONS(2095),
    [anon_sym_declare] = ACTIONS(2095),
    [anon_sym_typeof] = ACTIONS(2095),
    [anon_sym_LBRACE] = ACTIONS(2093),
    [anon_sym_switch] = ACTIONS(2095),
    [anon_sym_LPAREN] = ACTIONS(2093),
    [sym_null] = ACTIONS(2095),
    [anon_sym_any] = ACTIONS(2095),
    [anon_sym_boolean] = ACTIONS(2095),
    [anon_sym_async] = ACTIONS(2095),
    [anon_sym_public] = ACTIONS(2095),
    [anon_sym_var] = ACTIONS(2095),
    [anon_sym_while] = ACTIONS(2095),
    [anon_sym_SQUOTE] = ACTIONS(2093),
    [anon_sym_try] = ACTIONS(2095),
    [anon_sym_LT] = ACTIONS(2093),
    [sym_number] = ACTIONS(2093),
    [anon_sym_SLASH] = ACTIONS(2095),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2095),
    [anon_sym_function] = ACTIONS(2095),
    [sym_undefined] = ACTIONS(2095),
    [anon_sym_new] = ACTIONS(2095),
    [ts_builtin_sym_end] = ACTIONS(2093),
    [anon_sym_let] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(2095),
    [anon_sym_export] = ACTIONS(2095),
    [anon_sym_do] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(2093),
    [anon_sym_with] = ACTIONS(2095),
    [anon_sym_await] = ACTIONS(2095),
  },
  [1742] = {
    [sym__automatic_semicolon] = ACTIONS(2199),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [sym_readonly] = ACTIONS(2201),
    [anon_sym_DQUOTE] = ACTIONS(2199),
  },
  [1743] = {
    [sym__automatic_semicolon] = ACTIONS(4559),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1073),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_namespace] = ACTIONS(1075),
    [sym_readonly] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1073),
  },
  [1744] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1756),
    [sym_function_type] = STATE(1756),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1756),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1756),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1756),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1745] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1759),
    [sym_function_type] = STATE(1759),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1759),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1759),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1759),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1746] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(814),
    [sym_function_type] = STATE(814),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(814),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(814),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(814),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1747] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(815),
    [sym_function_type] = STATE(815),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(815),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(815),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(815),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1748] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1239),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_EQ_GT] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(4567),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1749] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1750] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1751] = {
    [sym_arrow_function] = STATE(2237),
    [sym_await_expression] = STATE(2237),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2237),
    [sym_meta_property] = STATE(2237),
    [sym__expression] = STATE(2237),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2237),
    [sym_call_expression] = STATE(2237),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2237),
    [sym_string] = STATE(2237),
    [sym_template_string] = STATE(2237),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2237),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2237),
    [sym_generator_function] = STATE(2237),
    [sym_new_expression] = STATE(2237),
    [sym_assignment_expression] = STATE(2237),
    [sym_augmented_assignment_expression] = STATE(2237),
    [sym_binary_expression] = STATE(2237),
    [sym_unary_expression] = STATE(2237),
    [sym_regex] = STATE(2237),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2237),
    [sym_as_expression] = STATE(2237),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2237),
    [sym_class] = STATE(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(1282),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(4575),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_true] = ACTIONS(4575),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4575),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4575),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(1430),
  },
  [1752] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2649),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1753] = {
    [sym__automatic_semicolon] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(2792),
    [anon_sym_AMP] = ACTIONS(2792),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2792),
    [anon_sym_PIPE] = ACTIONS(2794),
    [anon_sym_COMMA] = ACTIONS(2792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2792),
    [anon_sym_EQ] = ACTIONS(2792),
    [anon_sym_DOT] = ACTIONS(2792),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2792),
  },
  [1754] = {
    [sym__automatic_semicolon] = ACTIONS(2944),
    [sym_identifier] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2944),
    [anon_sym_debugger] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2946),
    [anon_sym_AT] = ACTIONS(2944),
    [anon_sym_DASH] = ACTIONS(2946),
    [anon_sym_void] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2946),
    [anon_sym_const] = ACTIONS(2946),
    [sym_super] = ACTIONS(2946),
    [anon_sym_return] = ACTIONS(2946),
    [anon_sym_private] = ACTIONS(2946),
    [anon_sym_static] = ACTIONS(2946),
    [anon_sym_get] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2944),
    [anon_sym_interface] = ACTIONS(2946),
    [anon_sym_default] = ACTIONS(2946),
    [anon_sym_enum] = ACTIONS(2946),
    [anon_sym_delete] = ACTIONS(2946),
    [anon_sym_continue] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2944),
    [anon_sym_if] = ACTIONS(2946),
    [sym_this] = ACTIONS(2946),
    [anon_sym_yield] = ACTIONS(2946),
    [sym_true] = ACTIONS(2946),
    [anon_sym_throw] = ACTIONS(2946),
    [anon_sym_protected] = ACTIONS(2946),
    [anon_sym_abstract] = ACTIONS(2946),
    [anon_sym_set] = ACTIONS(2946),
    [anon_sym_type] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2944),
    [anon_sym_DQUOTE] = ACTIONS(2944),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2944),
    [anon_sym_for] = ACTIONS(2946),
    [anon_sym_LBRACK] = ACTIONS(2944),
    [sym_false] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2944),
    [anon_sym_case] = ACTIONS(2946),
    [anon_sym_module] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2946),
    [anon_sym_class] = ACTIONS(2946),
    [anon_sym_declare] = ACTIONS(2946),
    [anon_sym_typeof] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2944),
    [anon_sym_switch] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2944),
    [sym_null] = ACTIONS(2946),
    [anon_sym_any] = ACTIONS(2946),
    [anon_sym_boolean] = ACTIONS(2946),
    [anon_sym_async] = ACTIONS(2946),
    [anon_sym_public] = ACTIONS(2946),
    [anon_sym_var] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_SQUOTE] = ACTIONS(2944),
    [anon_sym_try] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2944),
    [sym_number] = ACTIONS(2944),
    [anon_sym_SLASH] = ACTIONS(2946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2946),
    [sym_undefined] = ACTIONS(2946),
    [anon_sym_new] = ACTIONS(2946),
    [ts_builtin_sym_end] = ACTIONS(2944),
    [anon_sym_let] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2946),
    [anon_sym_do] = ACTIONS(2946),
    [anon_sym_TILDE] = ACTIONS(2944),
    [anon_sym_with] = ACTIONS(2946),
    [anon_sym_await] = ACTIONS(2946),
  },
  [1755] = {
    [sym__automatic_semicolon] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_symbol] = ACTIONS(3062),
    [anon_sym_number] = ACTIONS(3062),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_declare] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3060),
    [anon_sym_void] = ACTIONS(3062),
    [anon_sym_any] = ACTIONS(3062),
    [anon_sym_private] = ACTIONS(3062),
    [anon_sym_boolean] = ACTIONS(3062),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(3062),
    [anon_sym_get] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [sym_number] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3062),
    [anon_sym_string] = ACTIONS(3062),
    [anon_sym_abstract] = ACTIONS(3062),
    [anon_sym_set] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3062),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_namespace] = ACTIONS(3062),
    [sym_readonly] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3060),
  },
  [1756] = {
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_symbol] = ACTIONS(3162),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_interface] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [anon_sym_protected] = ACTIONS(3162),
    [anon_sym_set] = ACTIONS(3162),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_number] = ACTIONS(3162),
    [anon_sym_typeof] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_switch] = ACTIONS(3162),
    [sym_null] = ACTIONS(3162),
    [anon_sym_any] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_public] = ACTIONS(3162),
    [anon_sym_var] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_export] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [sym_identifier] = ACTIONS(3162),
    [anon_sym_debugger] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_void] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [sym_super] = ACTIONS(3162),
    [anon_sym_private] = ACTIONS(3162),
    [anon_sym_get] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [sym_this] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_abstract] = ACTIONS(3162),
    [anon_sym_type] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_else] = ACTIONS(3162),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [sym_false] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_module] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_declare] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_boolean] = ACTIONS(3162),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_LT] = ACTIONS(3160),
    [sym_number] = ACTIONS(3160),
    [ts_builtin_sym_end] = ACTIONS(3160),
    [anon_sym_function] = ACTIONS(3162),
    [sym_undefined] = ACTIONS(3162),
    [anon_sym_let] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_await] = ACTIONS(3162),
  },
  [1757] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1764),
    [sym_function_type] = STATE(1764),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1764),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1764),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1764),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1758] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(1069),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1069),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1077),
  },
  [1759] = {
    [anon_sym_BQUOTE] = ACTIONS(3262),
    [anon_sym_symbol] = ACTIONS(3264),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3264),
    [anon_sym_return] = ACTIONS(3264),
    [anon_sym_static] = ACTIONS(3264),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_interface] = ACTIONS(3264),
    [anon_sym_delete] = ACTIONS(3264),
    [anon_sym_if] = ACTIONS(3264),
    [anon_sym_yield] = ACTIONS(3264),
    [sym_true] = ACTIONS(3264),
    [anon_sym_protected] = ACTIONS(3264),
    [anon_sym_set] = ACTIONS(3264),
    [anon_sym_import] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(3262),
    [anon_sym_for] = ACTIONS(3264),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_number] = ACTIONS(3264),
    [anon_sym_typeof] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3264),
    [sym_null] = ACTIONS(3264),
    [anon_sym_any] = ACTIONS(3264),
    [anon_sym_async] = ACTIONS(3264),
    [anon_sym_public] = ACTIONS(3264),
    [anon_sym_var] = ACTIONS(3264),
    [anon_sym_while] = ACTIONS(3264),
    [anon_sym_SQUOTE] = ACTIONS(3262),
    [anon_sym_SLASH] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3264),
    [anon_sym_new] = ACTIONS(3264),
    [anon_sym_export] = ACTIONS(3264),
    [anon_sym_with] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(3264),
    [anon_sym_debugger] = ACTIONS(3264),
    [anon_sym_AT] = ACTIONS(3262),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_void] = ACTIONS(3264),
    [anon_sym_const] = ACTIONS(3264),
    [sym_super] = ACTIONS(3264),
    [anon_sym_private] = ACTIONS(3264),
    [anon_sym_get] = ACTIONS(3264),
    [anon_sym_default] = ACTIONS(3264),
    [anon_sym_enum] = ACTIONS(3264),
    [anon_sym_continue] = ACTIONS(3264),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [sym_this] = ACTIONS(3264),
    [anon_sym_throw] = ACTIONS(3264),
    [anon_sym_abstract] = ACTIONS(3264),
    [anon_sym_type] = ACTIONS(3264),
    [anon_sym_namespace] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_else] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3262),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [sym_false] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(3264),
    [anon_sym_module] = ACTIONS(3264),
    [anon_sym_class] = ACTIONS(3264),
    [anon_sym_declare] = ACTIONS(3264),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_boolean] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3262),
    [sym_number] = ACTIONS(3262),
    [ts_builtin_sym_end] = ACTIONS(3262),
    [anon_sym_function] = ACTIONS(3264),
    [sym_undefined] = ACTIONS(3264),
    [anon_sym_let] = ACTIONS(3264),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_TILDE] = ACTIONS(3262),
    [anon_sym_await] = ACTIONS(3264),
  },
  [1760] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1766),
    [sym_function_type] = STATE(1766),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1766),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1766),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1766),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1761] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4581),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1762] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym__automatic_semicolon] = ACTIONS(2410),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(2410),
    [anon_sym_PIPE] = ACTIONS(2412),
    [anon_sym_COMMA] = ACTIONS(2410),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2410),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1763] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
  },
  [1764] = {
    [anon_sym_BQUOTE] = ACTIONS(3696),
    [anon_sym_symbol] = ACTIONS(3698),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3698),
    [anon_sym_return] = ACTIONS(3698),
    [anon_sym_static] = ACTIONS(3698),
    [anon_sym_RBRACE] = ACTIONS(3696),
    [anon_sym_interface] = ACTIONS(3698),
    [anon_sym_delete] = ACTIONS(3698),
    [anon_sym_if] = ACTIONS(3698),
    [anon_sym_yield] = ACTIONS(3698),
    [sym_true] = ACTIONS(3698),
    [anon_sym_protected] = ACTIONS(3698),
    [anon_sym_set] = ACTIONS(3698),
    [anon_sym_import] = ACTIONS(3698),
    [anon_sym_DQUOTE] = ACTIONS(3696),
    [anon_sym_for] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_number] = ACTIONS(3698),
    [anon_sym_typeof] = ACTIONS(3698),
    [anon_sym_LBRACE] = ACTIONS(3696),
    [anon_sym_switch] = ACTIONS(3698),
    [sym_null] = ACTIONS(3698),
    [anon_sym_any] = ACTIONS(3698),
    [anon_sym_async] = ACTIONS(3698),
    [anon_sym_public] = ACTIONS(3698),
    [anon_sym_var] = ACTIONS(3698),
    [anon_sym_while] = ACTIONS(3698),
    [anon_sym_SQUOTE] = ACTIONS(3696),
    [anon_sym_SLASH] = ACTIONS(3698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3698),
    [anon_sym_new] = ACTIONS(3698),
    [anon_sym_export] = ACTIONS(3698),
    [anon_sym_with] = ACTIONS(3698),
    [sym_identifier] = ACTIONS(3698),
    [anon_sym_debugger] = ACTIONS(3698),
    [anon_sym_AT] = ACTIONS(3696),
    [anon_sym_DASH] = ACTIONS(3698),
    [anon_sym_void] = ACTIONS(3698),
    [anon_sym_const] = ACTIONS(3698),
    [sym_super] = ACTIONS(3698),
    [anon_sym_private] = ACTIONS(3698),
    [anon_sym_get] = ACTIONS(3698),
    [anon_sym_default] = ACTIONS(3698),
    [anon_sym_enum] = ACTIONS(3698),
    [anon_sym_continue] = ACTIONS(3698),
    [anon_sym_DASH_DASH] = ACTIONS(3696),
    [sym_this] = ACTIONS(3698),
    [anon_sym_throw] = ACTIONS(3698),
    [anon_sym_abstract] = ACTIONS(3698),
    [anon_sym_type] = ACTIONS(3698),
    [anon_sym_namespace] = ACTIONS(3698),
    [anon_sym_PLUS_PLUS] = ACTIONS(3696),
    [anon_sym_else] = ACTIONS(3698),
    [anon_sym_BANG] = ACTIONS(3696),
    [anon_sym_LBRACK] = ACTIONS(3696),
    [sym_false] = ACTIONS(3698),
    [anon_sym_case] = ACTIONS(3698),
    [anon_sym_module] = ACTIONS(3698),
    [anon_sym_class] = ACTIONS(3698),
    [anon_sym_declare] = ACTIONS(3698),
    [anon_sym_LPAREN] = ACTIONS(3696),
    [anon_sym_boolean] = ACTIONS(3698),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3698),
    [anon_sym_LT] = ACTIONS(3696),
    [sym_number] = ACTIONS(3696),
    [ts_builtin_sym_end] = ACTIONS(3696),
    [anon_sym_function] = ACTIONS(3698),
    [sym_undefined] = ACTIONS(3698),
    [anon_sym_let] = ACTIONS(3698),
    [anon_sym_PLUS] = ACTIONS(3698),
    [anon_sym_do] = ACTIONS(3698),
    [anon_sym_TILDE] = ACTIONS(3696),
    [anon_sym_await] = ACTIONS(3698),
  },
  [1765] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1767),
    [sym_function_type] = STATE(1767),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(1767),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(1767),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1767),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1766] = {
    [anon_sym_BQUOTE] = ACTIONS(3753),
    [anon_sym_symbol] = ACTIONS(3755),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(3755),
    [anon_sym_return] = ACTIONS(3755),
    [anon_sym_static] = ACTIONS(3755),
    [anon_sym_RBRACE] = ACTIONS(3753),
    [anon_sym_interface] = ACTIONS(3755),
    [anon_sym_delete] = ACTIONS(3755),
    [anon_sym_if] = ACTIONS(3755),
    [anon_sym_yield] = ACTIONS(3755),
    [sym_true] = ACTIONS(3755),
    [anon_sym_protected] = ACTIONS(3755),
    [anon_sym_set] = ACTIONS(3755),
    [anon_sym_import] = ACTIONS(3755),
    [anon_sym_DQUOTE] = ACTIONS(3753),
    [anon_sym_for] = ACTIONS(3755),
    [anon_sym_SEMI] = ACTIONS(3753),
    [anon_sym_number] = ACTIONS(3755),
    [anon_sym_typeof] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(3753),
    [anon_sym_switch] = ACTIONS(3755),
    [sym_null] = ACTIONS(3755),
    [anon_sym_any] = ACTIONS(3755),
    [anon_sym_async] = ACTIONS(3755),
    [anon_sym_public] = ACTIONS(3755),
    [anon_sym_var] = ACTIONS(3755),
    [anon_sym_while] = ACTIONS(3755),
    [anon_sym_SQUOTE] = ACTIONS(3753),
    [anon_sym_SLASH] = ACTIONS(3755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3755),
    [anon_sym_new] = ACTIONS(3755),
    [anon_sym_export] = ACTIONS(3755),
    [anon_sym_with] = ACTIONS(3755),
    [sym_identifier] = ACTIONS(3755),
    [anon_sym_debugger] = ACTIONS(3755),
    [anon_sym_AT] = ACTIONS(3753),
    [anon_sym_DASH] = ACTIONS(3755),
    [anon_sym_void] = ACTIONS(3755),
    [anon_sym_const] = ACTIONS(3755),
    [sym_super] = ACTIONS(3755),
    [anon_sym_private] = ACTIONS(3755),
    [anon_sym_get] = ACTIONS(3755),
    [anon_sym_default] = ACTIONS(3755),
    [anon_sym_enum] = ACTIONS(3755),
    [anon_sym_continue] = ACTIONS(3755),
    [anon_sym_DASH_DASH] = ACTIONS(3753),
    [sym_this] = ACTIONS(3755),
    [anon_sym_throw] = ACTIONS(3755),
    [anon_sym_abstract] = ACTIONS(3755),
    [anon_sym_type] = ACTIONS(3755),
    [anon_sym_namespace] = ACTIONS(3755),
    [anon_sym_PLUS_PLUS] = ACTIONS(3753),
    [anon_sym_else] = ACTIONS(3755),
    [anon_sym_BANG] = ACTIONS(3753),
    [anon_sym_LBRACK] = ACTIONS(3753),
    [sym_false] = ACTIONS(3755),
    [anon_sym_case] = ACTIONS(3755),
    [anon_sym_module] = ACTIONS(3755),
    [anon_sym_class] = ACTIONS(3755),
    [anon_sym_declare] = ACTIONS(3755),
    [anon_sym_LPAREN] = ACTIONS(3753),
    [anon_sym_boolean] = ACTIONS(3755),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_LT] = ACTIONS(3753),
    [sym_number] = ACTIONS(3753),
    [ts_builtin_sym_end] = ACTIONS(3753),
    [anon_sym_function] = ACTIONS(3755),
    [sym_undefined] = ACTIONS(3755),
    [anon_sym_let] = ACTIONS(3755),
    [anon_sym_PLUS] = ACTIONS(3755),
    [anon_sym_do] = ACTIONS(3755),
    [anon_sym_TILDE] = ACTIONS(3753),
    [anon_sym_await] = ACTIONS(3755),
  },
  [1767] = {
    [anon_sym_BQUOTE] = ACTIONS(4007),
    [anon_sym_symbol] = ACTIONS(4009),
    [anon_sym_PIPE] = ACTIONS(3945),
    [anon_sym_break] = ACTIONS(4009),
    [anon_sym_return] = ACTIONS(4009),
    [anon_sym_static] = ACTIONS(4009),
    [anon_sym_RBRACE] = ACTIONS(4007),
    [anon_sym_interface] = ACTIONS(4009),
    [anon_sym_delete] = ACTIONS(4009),
    [anon_sym_if] = ACTIONS(4009),
    [anon_sym_yield] = ACTIONS(4009),
    [sym_true] = ACTIONS(4009),
    [anon_sym_protected] = ACTIONS(4009),
    [anon_sym_set] = ACTIONS(4009),
    [anon_sym_import] = ACTIONS(4009),
    [anon_sym_DQUOTE] = ACTIONS(4007),
    [anon_sym_for] = ACTIONS(4009),
    [anon_sym_SEMI] = ACTIONS(4007),
    [anon_sym_number] = ACTIONS(4009),
    [anon_sym_typeof] = ACTIONS(4009),
    [anon_sym_LBRACE] = ACTIONS(4007),
    [anon_sym_switch] = ACTIONS(4009),
    [sym_null] = ACTIONS(4009),
    [anon_sym_any] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(4009),
    [anon_sym_public] = ACTIONS(4009),
    [anon_sym_var] = ACTIONS(4009),
    [anon_sym_while] = ACTIONS(4009),
    [anon_sym_SQUOTE] = ACTIONS(4007),
    [anon_sym_SLASH] = ACTIONS(4009),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4009),
    [anon_sym_new] = ACTIONS(4009),
    [anon_sym_export] = ACTIONS(4009),
    [anon_sym_with] = ACTIONS(4009),
    [sym_identifier] = ACTIONS(4009),
    [anon_sym_debugger] = ACTIONS(4009),
    [anon_sym_AT] = ACTIONS(4007),
    [anon_sym_DASH] = ACTIONS(4009),
    [anon_sym_void] = ACTIONS(4009),
    [anon_sym_const] = ACTIONS(4009),
    [sym_super] = ACTIONS(4009),
    [anon_sym_private] = ACTIONS(4009),
    [anon_sym_get] = ACTIONS(4009),
    [anon_sym_default] = ACTIONS(4009),
    [anon_sym_enum] = ACTIONS(4009),
    [anon_sym_continue] = ACTIONS(4009),
    [anon_sym_DASH_DASH] = ACTIONS(4007),
    [sym_this] = ACTIONS(4009),
    [anon_sym_throw] = ACTIONS(4009),
    [anon_sym_abstract] = ACTIONS(4009),
    [anon_sym_type] = ACTIONS(4009),
    [anon_sym_namespace] = ACTIONS(4009),
    [anon_sym_PLUS_PLUS] = ACTIONS(4007),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_LBRACK] = ACTIONS(4007),
    [sym_false] = ACTIONS(4009),
    [anon_sym_case] = ACTIONS(4009),
    [anon_sym_module] = ACTIONS(4009),
    [anon_sym_class] = ACTIONS(4009),
    [anon_sym_declare] = ACTIONS(4009),
    [anon_sym_LPAREN] = ACTIONS(4007),
    [anon_sym_boolean] = ACTIONS(4009),
    [anon_sym_AMP] = ACTIONS(3947),
    [anon_sym_try] = ACTIONS(4009),
    [anon_sym_LT] = ACTIONS(4007),
    [sym_number] = ACTIONS(4007),
    [ts_builtin_sym_end] = ACTIONS(4007),
    [anon_sym_function] = ACTIONS(4009),
    [sym_undefined] = ACTIONS(4009),
    [anon_sym_let] = ACTIONS(4009),
    [anon_sym_PLUS] = ACTIONS(4009),
    [anon_sym_do] = ACTIONS(4009),
    [anon_sym_TILDE] = ACTIONS(4007),
    [anon_sym_await] = ACTIONS(4009),
  },
  [1768] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1769] = {
    [sym__automatic_semicolon] = ACTIONS(2199),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2201),
    [sym_this] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [sym_null] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_await] = ACTIONS(2201),
  },
  [1770] = {
    [sym__automatic_semicolon] = ACTIONS(4583),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_BQUOTE] = ACTIONS(1073),
    [anon_sym_debugger] = ACTIONS(1075),
    [anon_sym_symbol] = ACTIONS(1075),
    [anon_sym_AT] = ACTIONS(1073),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_void] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_const] = ACTIONS(1075),
    [sym_super] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_private] = ACTIONS(1075),
    [anon_sym_static] = ACTIONS(1075),
    [anon_sym_get] = ACTIONS(1075),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym_interface] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1075),
    [anon_sym_delete] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_DASH_DASH] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1075),
    [sym_this] = ACTIONS(1075),
    [anon_sym_yield] = ACTIONS(1075),
    [sym_true] = ACTIONS(1075),
    [anon_sym_throw] = ACTIONS(1075),
    [anon_sym_protected] = ACTIONS(1075),
    [anon_sym_abstract] = ACTIONS(1075),
    [anon_sym_set] = ACTIONS(1075),
    [anon_sym_type] = ACTIONS(1075),
    [anon_sym_import] = ACTIONS(1075),
    [anon_sym_namespace] = ACTIONS(1075),
    [anon_sym_PLUS_PLUS] = ACTIONS(1073),
    [anon_sym_DQUOTE] = ACTIONS(1073),
    [anon_sym_else] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_LBRACK] = ACTIONS(1073),
    [sym_false] = ACTIONS(1075),
    [anon_sym_SEMI] = ACTIONS(1073),
    [anon_sym_case] = ACTIONS(1075),
    [anon_sym_module] = ACTIONS(1075),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_class] = ACTIONS(1075),
    [anon_sym_declare] = ACTIONS(1075),
    [anon_sym_typeof] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1073),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [sym_null] = ACTIONS(1075),
    [anon_sym_any] = ACTIONS(1075),
    [anon_sym_boolean] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_public] = ACTIONS(1075),
    [anon_sym_var] = ACTIONS(1075),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1075),
    [anon_sym_LT] = ACTIONS(1073),
    [sym_number] = ACTIONS(1073),
    [anon_sym_SLASH] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1075),
    [anon_sym_function] = ACTIONS(1075),
    [sym_undefined] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(1075),
    [ts_builtin_sym_end] = ACTIONS(1073),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_export] = ACTIONS(1075),
    [anon_sym_do] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1075),
    [anon_sym_await] = ACTIONS(1075),
  },
  [1771] = {
    [sym_type_arguments] = STATE(1609),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [sym__automatic_semicolon] = ACTIONS(1239),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1239),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_is] = ACTIONS(4463),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(4585),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1772] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(1252),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1773] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [sym__automatic_semicolon] = ACTIONS(1282),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1282),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [1774] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(1282),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_RBRACE] = ACTIONS(2621),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1282),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [1775] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2646),
    [sym__automatic_semicolon] = ACTIONS(1314),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1314),
    [anon_sym_PIPE] = ACTIONS(2649),
    [anon_sym_COMMA] = ACTIONS(2646),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2646),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1314),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1776] = {
    [sym__automatic_semicolon] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(3062),
    [anon_sym_BQUOTE] = ACTIONS(3060),
    [anon_sym_debugger] = ACTIONS(3062),
    [anon_sym_symbol] = ACTIONS(3062),
    [anon_sym_AT] = ACTIONS(3060),
    [anon_sym_DASH] = ACTIONS(3062),
    [anon_sym_void] = ACTIONS(3062),
    [anon_sym_break] = ACTIONS(3062),
    [anon_sym_const] = ACTIONS(3062),
    [sym_super] = ACTIONS(3062),
    [anon_sym_return] = ACTIONS(3062),
    [anon_sym_private] = ACTIONS(3062),
    [anon_sym_static] = ACTIONS(3062),
    [anon_sym_get] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3060),
    [anon_sym_interface] = ACTIONS(3062),
    [anon_sym_default] = ACTIONS(3062),
    [anon_sym_enum] = ACTIONS(3062),
    [anon_sym_delete] = ACTIONS(3062),
    [anon_sym_continue] = ACTIONS(3062),
    [anon_sym_DASH_DASH] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3062),
    [sym_this] = ACTIONS(3062),
    [anon_sym_yield] = ACTIONS(3062),
    [sym_true] = ACTIONS(3062),
    [anon_sym_throw] = ACTIONS(3062),
    [anon_sym_protected] = ACTIONS(3062),
    [anon_sym_abstract] = ACTIONS(3062),
    [anon_sym_set] = ACTIONS(3062),
    [anon_sym_type] = ACTIONS(3062),
    [anon_sym_import] = ACTIONS(3062),
    [anon_sym_namespace] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3060),
    [anon_sym_DQUOTE] = ACTIONS(3060),
    [anon_sym_else] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [sym_false] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3062),
    [anon_sym_module] = ACTIONS(3062),
    [anon_sym_number] = ACTIONS(3062),
    [anon_sym_class] = ACTIONS(3062),
    [anon_sym_declare] = ACTIONS(3062),
    [anon_sym_typeof] = ACTIONS(3062),
    [anon_sym_LBRACE] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3062),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [sym_null] = ACTIONS(3062),
    [anon_sym_any] = ACTIONS(3062),
    [anon_sym_boolean] = ACTIONS(3062),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(3062),
    [anon_sym_var] = ACTIONS(3062),
    [anon_sym_while] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3062),
    [anon_sym_LT] = ACTIONS(3060),
    [sym_number] = ACTIONS(3060),
    [anon_sym_SLASH] = ACTIONS(3062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3062),
    [anon_sym_function] = ACTIONS(3062),
    [sym_undefined] = ACTIONS(3062),
    [anon_sym_new] = ACTIONS(3062),
    [ts_builtin_sym_end] = ACTIONS(3060),
    [anon_sym_let] = ACTIONS(3062),
    [anon_sym_PLUS] = ACTIONS(3062),
    [anon_sym_export] = ACTIONS(3062),
    [anon_sym_do] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3060),
    [anon_sym_with] = ACTIONS(3062),
    [anon_sym_await] = ACTIONS(3062),
  },
  [1777] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [sym__automatic_semicolon] = ACTIONS(2346),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2348),
    [anon_sym_COMMA] = ACTIONS(2346),
    [anon_sym_LT_LT] = ACTIONS(1069),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_GT_GT_GT] = ACTIONS(1069),
    [anon_sym_EQ] = ACTIONS(1077),
    [anon_sym_AMP_AMP] = ACTIONS(1069),
    [anon_sym_DASH] = ACTIONS(1077),
    [anon_sym_BANG_EQ] = ACTIONS(1077),
    [anon_sym_LT_EQ] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1069),
    [anon_sym_GT_EQ] = ACTIONS(1069),
    [anon_sym_GT] = ACTIONS(1077),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2348),
    [anon_sym_QMARK] = ACTIONS(1069),
    [anon_sym_PERCENT] = ACTIONS(1069),
    [anon_sym_as] = ACTIONS(1069),
    [anon_sym_PIPE_PIPE] = ACTIONS(1069),
    [anon_sym_DASH_DASH] = ACTIONS(1069),
    [anon_sym_EQ_EQ] = ACTIONS(1077),
    [anon_sym_instanceof] = ACTIONS(1069),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_SLASH] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1069),
    [anon_sym_CARET] = ACTIONS(1069),
    [anon_sym_STAR_STAR] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1077),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(1077),
    [anon_sym_PLUS_PLUS] = ACTIONS(1069),
    [anon_sym_in] = ACTIONS(1077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1069),
    [anon_sym_BANG] = ACTIONS(1077),
  },
  [1778] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_RPAREN] = ACTIONS(3501),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1741),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1779] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(4027),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1780] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [sym__automatic_semicolon] = ACTIONS(1252),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(1252),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1252),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [1781] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_COMMA] = ACTIONS(3156),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(3507),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1782] = {
    [sym__automatic_semicolon] = ACTIONS(2792),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(2792),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(4027),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(4027),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2792),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1783] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [sym__automatic_semicolon] = ACTIONS(3156),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym_PERCENT_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_AMP_EQ] = ACTIONS(1741),
    [anon_sym_PLUS_EQ] = ACTIONS(1741),
    [anon_sym_PIPE] = ACTIONS(3507),
    [anon_sym_COMMA] = ACTIONS(3501),
    [anon_sym_LT_LT] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_GT_GT_GT] = ACTIONS(1743),
    [anon_sym_EQ] = ACTIONS(1743),
    [anon_sym_AMP_AMP] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_BANG_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1741),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_GT_EQ] = ACTIONS(1741),
    [anon_sym_GT] = ACTIONS(1743),
    [anon_sym_CARET_EQ] = ACTIONS(1741),
    [anon_sym_STAR_EQ] = ACTIONS(1741),
    [anon_sym_PIPE_EQ] = ACTIONS(1741),
    [anon_sym_DASH_EQ] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(3501),
    [anon_sym_AMP] = ACTIONS(3507),
    [anon_sym_QMARK] = ACTIONS(1741),
    [anon_sym_LT_LT_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(1741),
    [anon_sym_PIPE_PIPE] = ACTIONS(1741),
    [anon_sym_PERCENT] = ACTIONS(1743),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_EQ_EQ] = ACTIONS(1743),
    [anon_sym_instanceof] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(3507),
    [anon_sym_SLASH] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT_EQ] = ACTIONS(1741),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(1743),
    [anon_sym_STAR_STAR] = ACTIONS(1743),
    [anon_sym_PLUS] = ACTIONS(1743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1741),
    [anon_sym_GT_GT] = ACTIONS(1743),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_in] = ACTIONS(1743),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1741),
    [anon_sym_BANG] = ACTIONS(1743),
  },
  [1784] = {
    [aux_sym_template_string_repeat1] = STATE(1796),
    [sym_template_substitution] = STATE(1796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(4590),
    [sym__template_chars] = ACTIONS(4592),
    [sym_escape_sequence] = ACTIONS(4592),
    [sym_comment] = ACTIONS(3),
  },
  [1785] = {
    [sym_arrow_function] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym__expression] = STATE(1270),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1270),
    [sym_generator_function] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_regex] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1270),
    [sym_class] = STATE(1270),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4380),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4380),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4380),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4594),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4380),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1786] = {
    [sym_nested_identifier] = STATE(1585),
    [sym_string] = STATE(1586),
    [sym__module] = STATE(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(721),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1787] = {
    [aux_sym_string_repeat1] = STATE(1806),
    [sym_escape_sequence] = ACTIONS(4598),
    [aux_sym_string_token1] = ACTIONS(4600),
    [anon_sym_DQUOTE] = ACTIONS(4602),
    [sym_comment] = ACTIONS(255),
  },
  [1788] = {
    [sym_arrow_function] = STATE(1808),
    [sym_await_expression] = STATE(1808),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1808),
    [sym_meta_property] = STATE(1808),
    [sym__expression] = STATE(1808),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(1809),
    [sym_ternary_expression] = STATE(1808),
    [sym_string] = STATE(1808),
    [sym_template_string] = STATE(1808),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1808),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1808),
    [sym_generator_function] = STATE(1808),
    [sym_new_expression] = STATE(1808),
    [sym_assignment_expression] = STATE(1808),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_binary_expression] = STATE(1808),
    [sym_unary_expression] = STATE(1808),
    [sym_regex] = STATE(1808),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(1810),
    [sym_non_null_expression] = STATE(1808),
    [sym_as_expression] = STATE(1808),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1808),
    [sym_class] = STATE(1808),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2446),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [sym_null] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4604),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1789] = {
    [sym_generator_function_declaration] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(187),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(187),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_enum_declaration] = STATE(187),
    [sym_arrow_function] = STATE(51),
    [sym_type_arguments] = STATE(56),
    [sym_continue_statement] = STATE(187),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(187),
    [sym_type_alias_declaration] = STATE(187),
    [sym_import_statement] = STATE(187),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(187),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(187),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(187),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_export_statement] = STATE(187),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(187),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(187),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(187),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(187),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(187),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(187),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(187),
    [sym_template_string] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(187),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(187),
    [sym_parenthesized_expression] = STATE(53),
    [sym_internal_module] = STATE(55),
    [sym_class_declaration] = STATE(187),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(187),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(187),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(187),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(187),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(187),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(373),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_void] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_static] = ACTIONS(383),
    [anon_sym_get] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(4606),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(389),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(391),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(395),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_number] = ACTIONS(373),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(399),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(373),
    [anon_sym_boolean] = ACTIONS(373),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_public] = ACTIONS(381),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(373),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(405),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1790] = {
    [aux_sym_string_repeat2] = STATE(1840),
    [sym_escape_sequence] = ACTIONS(4608),
    [aux_sym_string_token2] = ACTIONS(4610),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4602),
  },
  [1791] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [sym_identifier] = ACTIONS(4384),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4386),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(4388),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(4386),
    [anon_sym_static] = ACTIONS(4386),
    [anon_sym_get] = ACTIONS(4386),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4390),
    [anon_sym_protected] = ACTIONS(4386),
    [anon_sym_DOT] = ACTIONS(4392),
    [anon_sym_set] = ACTIONS(4386),
    [anon_sym_type] = ACTIONS(4386),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4390),
    [anon_sym_module] = ACTIONS(4386),
    [anon_sym_number] = ACTIONS(4386),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4386),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [anon_sym_any] = ACTIONS(4386),
    [anon_sym_boolean] = ACTIONS(4386),
    [anon_sym_async] = ACTIONS(4396),
    [anon_sym_public] = ACTIONS(4386),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4398),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4386),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [1792] = {
    [anon_sym_EQ_GT] = ACTIONS(4612),
    [sym_comment] = ACTIONS(3),
  },
  [1793] = {
    [sym_formal_parameters] = STATE(1335),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [1794] = {
    [sym_generator_function_declaration] = STATE(296),
    [sym__declaration] = STATE(296),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(296),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(296),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(296),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(296),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(296),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(296),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(296),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(296),
    [sym_function_declaration] = STATE(296),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(296),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(296),
    [sym_break_statement] = STATE(296),
    [sym_labeled_statement] = STATE(296),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(296),
    [sym_class_declaration] = STATE(296),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(296),
    [sym_ambient_declaration] = STATE(296),
    [sym_type_alias_declaration] = STATE(296),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(296),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(296),
    [sym_switch_statement] = STATE(296),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(296),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(296),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(296),
    [sym_abstract_class_declaration] = STATE(296),
    [sym_interface_declaration] = STATE(296),
    [sym_export_statement] = STATE(296),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(296),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(296),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(296),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(296),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(4614),
    [sym_comment] = ACTIONS(3),
  },
  [1796] = {
    [aux_sym_template_string_repeat1] = STATE(302),
    [sym_template_substitution] = STATE(302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(4616),
    [sym__template_chars] = ACTIONS(665),
    [sym_escape_sequence] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(4618),
    [sym_comment] = ACTIONS(3),
  },
  [1798] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1813),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1283),
    [sym_type_parameters] = STATE(1814),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(4620),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1799] = {
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_object] = STATE(319),
    [sym_accessibility_modifier] = STATE(190),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(186),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(1829),
    [sym_string] = STATE(186),
    [sym_identifier] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_module] = ACTIONS(4624),
    [anon_sym_symbol] = ACTIONS(4624),
    [anon_sym_number] = ACTIONS(4624),
    [anon_sym_declare] = ACTIONS(4624),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4624),
    [anon_sym_any] = ACTIONS(4624),
    [anon_sym_private] = ACTIONS(4626),
    [anon_sym_boolean] = ACTIONS(4624),
    [anon_sym_async] = ACTIONS(4628),
    [anon_sym_public] = ACTIONS(4626),
    [anon_sym_get] = ACTIONS(4630),
    [anon_sym_RBRACE] = ACTIONS(4632),
    [anon_sym_static] = ACTIONS(4634),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_number] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4626),
    [anon_sym_string] = ACTIONS(4624),
    [anon_sym_set] = ACTIONS(4630),
    [anon_sym_type] = ACTIONS(4624),
    [anon_sym_export] = ACTIONS(4624),
    [anon_sym_namespace] = ACTIONS(4624),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1800] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1874),
    [sym__automatic_semicolon] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [1801] = {
    [sym_arrow_function] = STATE(1877),
    [sym_await_expression] = STATE(1877),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1877),
    [sym_meta_property] = STATE(1877),
    [sym__expression] = STATE(1877),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1877),
    [sym_call_expression] = STATE(1877),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(1878),
    [sym_ternary_expression] = STATE(1877),
    [sym_string] = STATE(1877),
    [sym_template_string] = STATE(1877),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1877),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1877),
    [sym_generator_function] = STATE(1877),
    [sym_new_expression] = STATE(1877),
    [sym_assignment_expression] = STATE(1877),
    [sym_augmented_assignment_expression] = STATE(1877),
    [sym_binary_expression] = STATE(1877),
    [sym_unary_expression] = STATE(1877),
    [sym_regex] = STATE(1877),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(1879),
    [sym_non_null_expression] = STATE(1877),
    [sym_as_expression] = STATE(1877),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1877),
    [sym_class] = STATE(1877),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4638),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4638),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4638),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4638),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4642),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4638),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1802] = {
    [sym_template_string] = STATE(1358),
    [sym_arguments] = STATE(1358),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_LPAREN] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [1803] = {
    [sym_object_type] = STATE(1359),
    [sym_extends_clause] = STATE(1880),
    [sym_type_parameters] = STATE(1881),
    [anon_sym_extends] = ACTIONS(776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1492),
  },
  [1804] = {
    [sym_enum_body] = STATE(1360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4644),
  },
  [1805] = {
    [sym_generator_function_declaration] = STATE(2282),
    [sym__declaration] = STATE(2282),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2282),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2282),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2282),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2282),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2282),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2282),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2282),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2282),
    [sym_function_declaration] = STATE(2282),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2282),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2282),
    [sym_break_statement] = STATE(2282),
    [sym_labeled_statement] = STATE(2282),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(2282),
    [sym_class_declaration] = STATE(2282),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2282),
    [sym_ambient_declaration] = STATE(2282),
    [sym_type_alias_declaration] = STATE(2282),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2282),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2282),
    [sym_switch_statement] = STATE(2282),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(2282),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(2282),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2282),
    [sym_abstract_class_declaration] = STATE(2282),
    [sym_interface_declaration] = STATE(2282),
    [sym_export_statement] = STATE(2282),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2282),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2282),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2282),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2282),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1806] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(846),
    [aux_sym_string_token1] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(4646),
    [sym_comment] = ACTIONS(255),
  },
  [1807] = {
    [sym_generator_function_declaration] = STATE(388),
    [sym__declaration] = STATE(388),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(388),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(388),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(388),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(388),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(388),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(388),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(388),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(388),
    [sym_function_declaration] = STATE(388),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(388),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(388),
    [sym_break_statement] = STATE(388),
    [sym_labeled_statement] = STATE(388),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(388),
    [sym_class_declaration] = STATE(388),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(388),
    [sym_ambient_declaration] = STATE(388),
    [sym_type_alias_declaration] = STATE(388),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(388),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(388),
    [sym_switch_statement] = STATE(388),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(388),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(388),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(388),
    [sym_abstract_class_declaration] = STATE(388),
    [sym_interface_declaration] = STATE(388),
    [sym_export_statement] = STATE(388),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(388),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(388),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(388),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1808] = {
    [aux_sym_array_repeat1] = STATE(1887),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(4648),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1809] = {
    [aux_sym_array_repeat1] = STATE(1887),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
  },
  [1810] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4648),
    [sym_comment] = ACTIONS(3),
  },
  [1811] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1888),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1373),
    [sym_type_parameters] = STATE(1889),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1812] = {
    [sym_decorator] = STATE(1890),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(1890),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(4650),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1813] = {
    [sym_class_body] = STATE(1376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1814] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1377),
    [sym_class_heritage] = STATE(1891),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1815] = {
    [sym_statement_block] = STATE(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [1816] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(1587),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [1817] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1014),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(1021),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(1024),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [1818] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1819] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [1820] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1821] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1822] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [sym_number] = ACTIONS(1051),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1823] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1824] = {
    [sym_nested_identifier] = STATE(129),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(130),
    [sym__module] = STATE(131),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(245),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(247),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1825] = {
    [sym_nested_identifier] = STATE(1276),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1826] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1827] = {
    [sym_formal_parameters] = STATE(61),
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym__call_signature] = STATE(214),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_type_parameters] = STATE(60),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(1085),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(1057),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_protected] = ACTIONS(1085),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1087),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(1085),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_any] = ACTIONS(1085),
    [anon_sym_async] = ACTIONS(1085),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(1085),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1085),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_void] = ACTIONS(1085),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(1085),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(1087),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(1085),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1085),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_module] = ACTIONS(1085),
    [anon_sym_declare] = ACTIONS(1085),
    [anon_sym_LPAREN] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(1085),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1095),
    [sym_number] = ACTIONS(1051),
    [anon_sym_function] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(135),
  },
  [1828] = {
    [sym_class_declaration] = STATE(264),
    [sym_generator_function_declaration] = STATE(264),
    [sym__declaration] = STATE(264),
    [sym_ambient_declaration] = STATE(264),
    [sym_import_alias] = STATE(264),
    [sym_type_alias_declaration] = STATE(264),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_function_signature] = STATE(264),
    [sym_abstract_class_declaration] = STATE(264),
    [sym_module] = STATE(264),
    [sym_interface_declaration] = STATE(264),
    [sym_function_declaration] = STATE(264),
    [sym_export_clause] = STATE(265),
    [sym_variable_declaration] = STATE(264),
    [sym_lexical_declaration] = STATE(264),
    [aux_sym_export_statement_repeat1] = STATE(165),
    [sym_internal_module] = STATE(264),
    [sym_enum_declaration] = STATE(264),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(531),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(1018),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(535),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(359),
    [anon_sym_declare] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(1029),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(363),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(1032),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [1829] = {
    [aux_sym_object_repeat1] = STATE(1895),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [1830] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1831] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [1832] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1898),
    [anon_sym_RPAREN] = ACTIONS(4660),
    [anon_sym_COMMA] = ACTIONS(4662),
    [sym_comment] = ACTIONS(3),
  },
  [1833] = {
    [anon_sym_RPAREN] = ACTIONS(4664),
    [sym_comment] = ACTIONS(3),
  },
  [1834] = {
    [sym_type_arguments] = STATE(1802),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_annotation] = STATE(1899),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(4664),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1835] = {
    [anon_sym_EQ_GT] = ACTIONS(4666),
    [sym_comment] = ACTIONS(3),
  },
  [1836] = {
    [anon_sym_EQ_GT] = ACTIONS(4668),
    [sym_comment] = ACTIONS(3),
  },
  [1837] = {
    [anon_sym_EQ_GT] = ACTIONS(4670),
    [sym_comment] = ACTIONS(3),
  },
  [1838] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1903),
    [sym__automatic_semicolon] = ACTIONS(4672),
    [anon_sym_SEMI] = ACTIONS(4672),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [1839] = {
    [sym_generator_function_declaration] = STATE(493),
    [sym__declaration] = STATE(493),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(493),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(493),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(493),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(493),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(493),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(493),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(493),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(493),
    [sym_function_declaration] = STATE(493),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(493),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(493),
    [sym_break_statement] = STATE(493),
    [sym_labeled_statement] = STATE(493),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(493),
    [sym_class_declaration] = STATE(493),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(493),
    [sym_ambient_declaration] = STATE(493),
    [sym_type_alias_declaration] = STATE(493),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(493),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(493),
    [sym_switch_statement] = STATE(493),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(493),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(493),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(493),
    [sym_abstract_class_declaration] = STATE(493),
    [sym_interface_declaration] = STATE(493),
    [sym_export_statement] = STATE(493),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(493),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(493),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(493),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(493),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1840] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(1223),
    [aux_sym_string_token2] = ACTIONS(1225),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4646),
  },
  [1841] = {
    [sym_generator_function_declaration] = STATE(2061),
    [sym__declaration] = STATE(2061),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2061),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2061),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2061),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2061),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2061),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2061),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2061),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2061),
    [sym_function_declaration] = STATE(2061),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2061),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2061),
    [sym_break_statement] = STATE(2061),
    [sym_labeled_statement] = STATE(2061),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(2061),
    [sym_class_declaration] = STATE(2061),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2061),
    [sym_ambient_declaration] = STATE(2061),
    [sym_type_alias_declaration] = STATE(2061),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2061),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2061),
    [sym_switch_statement] = STATE(2061),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2061),
    [sym_throw_statement] = STATE(2061),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2061),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2061),
    [sym_abstract_class_declaration] = STATE(2061),
    [sym_interface_declaration] = STATE(2061),
    [sym_export_statement] = STATE(2061),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2061),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2061),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2061),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2061),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4674),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [1842] = {
    [sym_array_type] = STATE(508),
    [sym_generic_type] = STATE(508),
    [sym_type_predicate] = STATE(508),
    [sym_literal_type] = STATE(508),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(508),
    [sym__primary_type] = STATE(508),
    [sym_lookup_type] = STATE(508),
    [sym_parenthesized_type] = STATE(508),
    [sym_nested_identifier] = STATE(237),
    [sym_predefined_type] = STATE(508),
    [sym_nested_type_identifier] = STATE(1738),
    [sym_tuple_type] = STATE(508),
    [sym_type_query] = STATE(508),
    [sym_index_type_query] = STATE(508),
    [sym_existential_type] = STATE(508),
    [sym_flow_maybe_type] = STATE(508),
    [sym_string] = STATE(222),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(1258),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1843] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(1905),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(1905),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(1905),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(1905),
    [sym_property_signature] = STATE(1905),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(1905),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(4676),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(4676),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4678),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4678),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1844] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(523),
    [sym_function_type] = STATE(523),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(523),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(523),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(523),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1845] = {
    [sym_nested_identifier] = STATE(1397),
    [sym_identifier] = ACTIONS(4680),
    [sym_comment] = ACTIONS(3),
  },
  [1846] = {
    [sym_number] = ACTIONS(4682),
    [sym_comment] = ACTIONS(3),
  },
  [1847] = {
    [sym_nested_type_identifier] = STATE(1400),
    [sym_nested_identifier] = STATE(2256),
    [sym_identifier] = ACTIONS(4684),
    [sym_comment] = ACTIONS(3),
  },
  [1848] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(536),
    [sym_function_type] = STATE(536),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(1738),
    [sym__type] = STATE(536),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(2508),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(2184),
    [sym_constructor_type] = STATE(536),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(536),
    [sym_identifier] = ACTIONS(3579),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(3581),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(3585),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1849] = {
    [anon_sym_EQ_GT] = ACTIONS(4686),
    [sym_comment] = ACTIONS(3),
  },
  [1850] = {
    [aux_sym_implements_clause_repeat1] = STATE(1913),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(4688),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(4690),
    [sym_comment] = ACTIONS(3),
  },
  [1851] = {
    [anon_sym_SLASH2] = ACTIONS(4692),
    [sym_comment] = ACTIONS(3),
  },
  [1852] = {
    [sym_statement_block] = STATE(1410),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1853] = {
    [anon_sym_target] = ACTIONS(4696),
    [sym_comment] = ACTIONS(3),
  },
  [1854] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1855] = {
    [sym__from_clause] = STATE(1917),
    [sym__automatic_semicolon] = ACTIONS(4698),
    [anon_sym_SEMI] = ACTIONS(4698),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [1856] = {
    [sym_generator_function_declaration] = STATE(567),
    [sym__declaration] = STATE(567),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(567),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(567),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(567),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(567),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(567),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(567),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(567),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(567),
    [sym_function_declaration] = STATE(567),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(567),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(567),
    [sym_break_statement] = STATE(567),
    [sym_labeled_statement] = STATE(567),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(567),
    [sym_class_declaration] = STATE(567),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(567),
    [sym_ambient_declaration] = STATE(567),
    [sym_type_alias_declaration] = STATE(567),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(567),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(567),
    [sym_switch_statement] = STATE(567),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(567),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(567),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(567),
    [sym_abstract_class_declaration] = STATE(567),
    [sym_interface_declaration] = STATE(567),
    [sym_export_statement] = STATE(567),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(567),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(567),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(567),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1857] = {
    [sym_generic_type] = STATE(1678),
    [sym_type_predicate] = STATE(1678),
    [sym_literal_type] = STATE(1678),
    [sym__number] = STATE(1672),
    [sym_object_type] = STATE(1678),
    [sym_intersection_type] = STATE(1424),
    [sym_function_type] = STATE(1424),
    [sym_nested_identifier] = STATE(2463),
    [sym_nested_type_identifier] = STATE(1679),
    [sym__type] = STATE(1424),
    [sym_type_query] = STATE(1678),
    [sym_index_type_query] = STATE(1678),
    [sym_existential_type] = STATE(1678),
    [sym_flow_maybe_type] = STATE(1678),
    [sym_string] = STATE(1672),
    [sym_type_parameters] = STATE(2464),
    [sym_template_string] = STATE(1425),
    [sym_array_type] = STATE(1678),
    [sym_formal_parameters] = STATE(2149),
    [sym_constructor_type] = STATE(1424),
    [sym__primary_type] = STATE(1678),
    [sym_lookup_type] = STATE(1678),
    [sym_parenthesized_type] = STATE(1678),
    [sym_predefined_type] = STATE(1678),
    [sym_tuple_type] = STATE(1678),
    [sym_union_type] = STATE(1424),
    [sym_identifier] = ACTIONS(4491),
    [sym_false] = ACTIONS(4493),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(4495),
    [anon_sym_symbol] = ACTIONS(4497),
    [anon_sym_number] = ACTIONS(4497),
    [anon_sym_typeof] = ACTIONS(4499),
    [anon_sym_keyof] = ACTIONS(4501),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_LBRACE] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(4519),
    [anon_sym_void] = ACTIONS(4497),
    [anon_sym_LPAREN] = ACTIONS(4521),
    [anon_sym_any] = ACTIONS(4497),
    [anon_sym_boolean] = ACTIONS(4497),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4511),
    [anon_sym_AMP] = ACTIONS(4523),
    [anon_sym_QMARK] = ACTIONS(4513),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [sym_this] = ACTIONS(4525),
    [sym_number] = ACTIONS(4517),
    [sym_true] = ACTIONS(4493),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4497),
    [anon_sym_new] = ACTIONS(4527),
    [anon_sym_PLUS] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1858] = {
    [sym_await_expression] = STATE(1919),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(1919),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(1919),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(1919),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(1919),
    [sym_template_string] = STATE(1919),
    [sym_yield_expression] = STATE(1919),
    [sym_type_assertion] = STATE(1919),
    [sym_new_expression] = STATE(1919),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(1919),
    [sym_binary_expression] = STATE(1919),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_array] = STATE(2522),
    [sym_as_expression] = STATE(1919),
    [sym_internal_module] = STATE(1919),
    [sym_arrow_function] = STATE(1919),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(2521),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(2523),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(2524),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(2521),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1772),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(2525),
    [sym_generator_function] = STATE(1919),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(1919),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(1919),
    [sym_regex] = STATE(1919),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(1919),
    [sym_class] = STATE(1919),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(4700),
    [sym_false] = ACTIONS(4702),
    [anon_sym_LBRACK] = ACTIONS(1526),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(4704),
    [anon_sym_number] = ACTIONS(4704),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(4706),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4708),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(1530),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(4710),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [sym_null] = ACTIONS(4712),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4704),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(4704),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(4714),
    [sym_number] = ACTIONS(4716),
    [sym_true] = ACTIONS(4702),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(4704),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4712),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(4718),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(4708),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [1859] = {
    [sym_class_declaration] = STATE(597),
    [sym_generator_function_declaration] = STATE(597),
    [sym__declaration] = STATE(597),
    [sym_enum_declaration] = STATE(597),
    [sym_function_signature] = STATE(597),
    [sym_abstract_class_declaration] = STATE(597),
    [sym_module] = STATE(597),
    [sym_interface_declaration] = STATE(597),
    [sym_function_declaration] = STATE(597),
    [sym_variable_declaration] = STATE(597),
    [sym_lexical_declaration] = STATE(597),
    [sym_ambient_declaration] = STATE(597),
    [sym_import_alias] = STATE(597),
    [sym_type_alias_declaration] = STATE(597),
    [aux_sym_export_statement_repeat1] = STATE(2532),
    [sym_internal_module] = STATE(597),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(1720),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_module] = ACTIONS(4720),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4726),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(4728),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(4730),
    [anon_sym_async] = ACTIONS(4732),
  },
  [1860] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1861] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1862] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1863] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1864] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1865] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1866] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1934),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1443),
    [sym_type_parameters] = STATE(1935),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1867] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [1868] = {
    [aux_sym_object_repeat1] = STATE(1893),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [1869] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1870] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_get] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [sym_readonly] = ACTIONS(1062),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1871] = {
    [sym_computed_property_name] = STATE(442),
    [aux_sym_object_repeat1] = STATE(1893),
    [sym_string] = STATE(442),
    [sym__property_name] = STATE(442),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1872] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1932),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1376),
    [sym_type_parameters] = STATE(1933),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(4734),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1873] = {
    [sym_enum_body] = STATE(1445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4644),
  },
  [1874] = {
    [aux_sym_variable_declaration_repeat1] = STATE(621),
    [sym__automatic_semicolon] = ACTIONS(4736),
    [anon_sym_SEMI] = ACTIONS(4736),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [1875] = {
    [anon_sym_RBRACK] = ACTIONS(4738),
    [sym_comment] = ACTIONS(3),
  },
  [1876] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(4738),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1877] = {
    [aux_sym_array_repeat1] = STATE(1938),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1878] = {
    [aux_sym_array_repeat1] = STATE(1938),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [1879] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(4740),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [1880] = {
    [sym_object_type] = STATE(1449),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1492),
  },
  [1881] = {
    [sym_object_type] = STATE(1450),
    [sym_extends_clause] = STATE(1939),
    [anon_sym_extends] = ACTIONS(776),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1492),
  },
  [1882] = {
    [sym_computed_property_name] = STATE(1940),
    [sym_string] = STATE(1940),
    [sym__property_name] = STATE(1940),
    [sym_enum_assignment] = STATE(1941),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(4744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1883] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1884] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1452),
    [sym_class_heritage] = STATE(1943),
    [sym_type_parameters] = STATE(1944),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(4746),
    [sym_comment] = ACTIONS(3),
  },
  [1886] = {
    [sym_generator_function_declaration] = STATE(667),
    [sym__declaration] = STATE(667),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(667),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(667),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(667),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(667),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(667),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(667),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(667),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(667),
    [sym_function_declaration] = STATE(667),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(667),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(667),
    [sym_break_statement] = STATE(667),
    [sym_labeled_statement] = STATE(667),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(667),
    [sym_class_declaration] = STATE(667),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(667),
    [sym_ambient_declaration] = STATE(667),
    [sym_type_alias_declaration] = STATE(667),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(667),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(667),
    [sym_switch_statement] = STATE(667),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(667),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(667),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(667),
    [sym_abstract_class_declaration] = STATE(667),
    [sym_interface_declaration] = STATE(667),
    [sym_export_statement] = STATE(667),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(667),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(667),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(667),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(667),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1887] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_RBRACK] = ACTIONS(4748),
    [sym_comment] = ACTIONS(3),
  },
  [1888] = {
    [sym_class_body] = STATE(1455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1889] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1456),
    [sym_class_heritage] = STATE(1948),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1890] = {
    [sym_decorator] = STATE(698),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(4750),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1891] = {
    [sym_class_body] = STATE(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1892] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1952),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(709),
    [sym_type_parameters] = STATE(1953),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1893] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [1894] = {
    [aux_sym_array_repeat1] = STATE(1887),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(4754),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1895] = {
    [aux_sym_object_repeat1] = STATE(461),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_COMMA] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [1896] = {
    [sym__automatic_semicolon] = ACTIONS(4758),
    [sym_identifier] = ACTIONS(2201),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_debugger] = ACTIONS(2201),
    [anon_sym_symbol] = ACTIONS(2201),
    [anon_sym_AT] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_void] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_delete] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_if] = ACTIONS(2201),
    [sym_this] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [sym_true] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_type] = ACTIONS(2201),
    [anon_sym_import] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [sym_false] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_module] = ACTIONS(2201),
    [anon_sym_number] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_declare] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [sym_null] = ACTIONS(2201),
    [anon_sym_any] = ACTIONS(2201),
    [anon_sym_boolean] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_LT] = ACTIONS(2199),
    [sym_number] = ACTIONS(2199),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2201),
    [anon_sym_function] = ACTIONS(2201),
    [sym_undefined] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_export] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_with] = ACTIONS(2201),
    [anon_sym_await] = ACTIONS(2201),
  },
  [1897] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(4760),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [1898] = {
    [aux_sym_formal_parameters_repeat1] = STATE(745),
    [anon_sym_RPAREN] = ACTIONS(4760),
    [anon_sym_COMMA] = ACTIONS(4762),
    [sym_comment] = ACTIONS(3),
  },
  [1899] = {
    [anon_sym_RPAREN] = ACTIONS(4764),
    [sym_comment] = ACTIONS(3),
  },
  [1900] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1958),
    [anon_sym_RPAREN] = ACTIONS(4760),
    [anon_sym_COMMA] = ACTIONS(4762),
    [sym_comment] = ACTIONS(3),
  },
  [1901] = {
    [sym_optional_parameter] = STATE(1900),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(1900),
    [aux_sym_export_statement_repeat1] = STATE(2539),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(1900),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [1902] = {
    [sym_statement_block] = STATE(1472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1903] = {
    [aux_sym_variable_declaration_repeat1] = STATE(621),
    [sym__automatic_semicolon] = ACTIONS(4766),
    [anon_sym_SEMI] = ACTIONS(4766),
    [anon_sym_COMMA] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(4768),
    [sym_comment] = ACTIONS(3),
  },
  [1905] = {
    [aux_sym_object_type_repeat1] = STATE(1966),
    [sym__automatic_semicolon] = ACTIONS(4770),
    [anon_sym_RBRACE] = ACTIONS(4772),
    [anon_sym_SEMI] = ACTIONS(4770),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4772),
    [anon_sym_COMMA] = ACTIONS(4770),
    [sym_comment] = ACTIONS(3),
  },
  [1906] = {
    [aux_sym_implements_clause_repeat1] = STATE(1967),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RBRACK] = ACTIONS(4774),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
  },
  [1907] = {
    [anon_sym_EQ_GT] = ACTIONS(4776),
    [sym_comment] = ACTIONS(3),
  },
  [1908] = {
    [sym_await_expression] = STATE(1808),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(1808),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(1808),
    [sym_function_type] = STATE(2084),
    [sym__expression] = STATE(1808),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(1808),
    [sym_template_string] = STATE(1808),
    [sym_yield_expression] = STATE(1808),
    [sym_type_assertion] = STATE(1808),
    [sym_new_expression] = STATE(1808),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(1808),
    [sym_binary_expression] = STATE(1808),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(2084),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(1252),
    [sym_as_expression] = STATE(1808),
    [sym_internal_module] = STATE(1808),
    [sym_arrow_function] = STATE(1808),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_intersection_type] = STATE(2084),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(2084),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_spread_element] = STATE(1809),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1625),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(1256),
    [sym_generator_function] = STATE(1808),
    [sym_constructor_type] = STATE(2084),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(1808),
    [sym_regex] = STATE(1808),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [aux_sym_array_repeat1] = STATE(1810),
    [sym_non_null_expression] = STATE(1808),
    [sym_class] = STATE(1808),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2428),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_void] = ACTIONS(2432),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2436),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2436),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(2428),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2444),
    [sym_null] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2428),
    [anon_sym_boolean] = ACTIONS(2428),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2448),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2428),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1909] = {
    [sym_construct_signature] = STATE(518),
    [sym_pair] = STATE(184),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(518),
    [sym__call_signature] = STATE(518),
    [sym_spread_element] = STATE(184),
    [sym_property_signature] = STATE(518),
    [sym_type_parameters] = STATE(1793),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(805),
    [sym_formal_parameters] = STATE(1255),
    [sym_index_signature] = STATE(518),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(184),
    [sym_assignment_pattern] = STATE(184),
    [sym_array] = STATE(320),
    [sym_identifier] = ACTIONS(4778),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(4778),
    [anon_sym_symbol] = ACTIONS(4778),
    [anon_sym_number] = ACTIONS(4778),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4778),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4778),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(4778),
    [anon_sym_private] = ACTIONS(4780),
    [anon_sym_boolean] = ACTIONS(4778),
    [anon_sym_async] = ACTIONS(4782),
    [anon_sym_public] = ACTIONS(4780),
    [anon_sym_get] = ACTIONS(4784),
    [anon_sym_RBRACE] = ACTIONS(4786),
    [anon_sym_static] = ACTIONS(4788),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4780),
    [anon_sym_string] = ACTIONS(4778),
    [anon_sym_set] = ACTIONS(4784),
    [anon_sym_type] = ACTIONS(4778),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(4790),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(4778),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1910] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(4792),
    [anon_sym_PIPE] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [1911] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1974),
    [sym_function_type] = STATE(1974),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1974),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1974),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1974),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(4794),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1912] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1913] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_GT] = ACTIONS(4796),
    [anon_sym_COMMA] = ACTIONS(4798),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [anon_sym_EQ_GT] = ACTIONS(4800),
    [sym_comment] = ACTIONS(3),
  },
  [1915] = {
    [sym_statement_block] = STATE(1492),
    [sym__automatic_semicolon] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [1916] = {
    [sym_statement_block] = STATE(1493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1917] = {
    [sym__automatic_semicolon] = ACTIONS(4371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4371),
  },
  [1918] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(4802),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4802),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1919] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1920] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1921] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1922] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1923] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1924] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1925] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2063),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(2063),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(2063),
    [sym_function_type] = STATE(535),
    [sym__expression] = STATE(2063),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2063),
    [sym_call_expression] = STATE(2063),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(2063),
    [sym_template_string] = STATE(2063),
    [sym_yield_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2063),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2063),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(2063),
    [sym_binary_expression] = STATE(2063),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(535),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2063),
    [sym_internal_module] = STATE(2063),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2063),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(2062),
    [sym_intersection_type] = STATE(535),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(535),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2063),
    [sym_constructor_type] = STATE(535),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(2063),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(2063),
    [sym_regex] = STATE(2063),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2063),
    [sym_class] = STATE(2063),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(2634),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(409),
    [anon_sym_get] = ACTIONS(409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_set] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(409),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(423),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(409),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(4809),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4809),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [1926] = {
    [sym_formal_parameters] = STATE(1501),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [1927] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2589),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4804),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1928] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1929] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2657),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1930] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1931] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1981),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1502),
    [sym_type_parameters] = STATE(1982),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1932] = {
    [sym_class_body] = STATE(1503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1933] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1504),
    [sym_class_heritage] = STATE(1983),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1934] = {
    [sym_class_body] = STATE(1505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1935] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1506),
    [sym_class_heritage] = STATE(1984),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1936] = {
    [sym_statement_block] = STATE(1507),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1937] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1987),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1508),
    [sym_type_parameters] = STATE(1988),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1938] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [1939] = {
    [sym_object_type] = STATE(1510),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1492),
  },
  [1940] = {
    [sym__initializer] = STATE(871),
    [aux_sym_enum_body_repeat1] = STATE(1990),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(4813),
    [anon_sym_COMMA] = ACTIONS(4815),
    [sym_comment] = ACTIONS(3),
  },
  [1941] = {
    [aux_sym_enum_body_repeat1] = STATE(1990),
    [anon_sym_COMMA] = ACTIONS(4815),
    [anon_sym_RBRACE] = ACTIONS(4813),
    [sym_comment] = ACTIONS(3),
  },
  [1942] = {
    [sym_generator_function_declaration] = STATE(873),
    [sym__declaration] = STATE(873),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(873),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(873),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(873),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(873),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(873),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(873),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(873),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(873),
    [sym_function_declaration] = STATE(873),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(873),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(873),
    [sym_break_statement] = STATE(873),
    [sym_labeled_statement] = STATE(873),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(873),
    [sym_class_declaration] = STATE(873),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(873),
    [sym_ambient_declaration] = STATE(873),
    [sym_type_alias_declaration] = STATE(873),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(873),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(873),
    [sym_switch_statement] = STATE(873),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(873),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(873),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(873),
    [sym_abstract_class_declaration] = STATE(873),
    [sym_interface_declaration] = STATE(873),
    [sym_export_statement] = STATE(873),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(873),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(873),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(873),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(873),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1943] = {
    [sym_class_body] = STATE(1512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1944] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1513),
    [sym_class_heritage] = STATE(1991),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1945] = {
    [sym__automatic_semicolon] = ACTIONS(4817),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(4817),
    [sym_comment] = ACTIONS(3),
  },
  [1946] = {
    [sym__automatic_semicolon] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_DOT] = ACTIONS(2764),
    [sym_comment] = ACTIONS(3),
  },
  [1947] = {
    [sym_identifier] = ACTIONS(4821),
    [sym_comment] = ACTIONS(3),
  },
  [1948] = {
    [sym_class_body] = STATE(1517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1949] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(4823),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1950] = {
    [sym_statement_block] = STATE(732),
    [sym__automatic_semicolon] = ACTIONS(2999),
    [anon_sym_RBRACE] = ACTIONS(2999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1951] = {
    [anon_sym_COLON] = ACTIONS(4825),
    [sym_comment] = ACTIONS(3),
  },
  [1952] = {
    [sym_class_body] = STATE(948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1953] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(949),
    [sym_class_heritage] = STATE(1996),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1954] = {
    [sym_statement_block] = STATE(1998),
    [sym__automatic_semicolon] = ACTIONS(4827),
    [anon_sym_SEMI] = ACTIONS(4827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [1955] = {
    [sym_nested_identifier] = STATE(1946),
    [sym_identifier] = ACTIONS(4829),
    [sym_comment] = ACTIONS(3),
  },
  [1956] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(1999),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(955),
    [sym_type_parameters] = STATE(2000),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1957] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [1958] = {
    [aux_sym_formal_parameters_repeat1] = STATE(745),
    [anon_sym_RPAREN] = ACTIONS(4831),
    [anon_sym_COMMA] = ACTIONS(4833),
    [sym_comment] = ACTIONS(3),
  },
  [1959] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1960] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1961] = {
    [sym_statement_block] = STATE(1528),
    [sym__automatic_semicolon] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [1962] = {
    [sym_statement_block] = STATE(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1963] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1964] = {
    [aux_sym_object_type_repeat1] = STATE(2004),
    [sym__automatic_semicolon] = ACTIONS(4835),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4835),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4837),
    [anon_sym_COMMA] = ACTIONS(4835),
    [sym_comment] = ACTIONS(3),
  },
  [1965] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4837),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1966] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(4835),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4835),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4837),
    [anon_sym_COMMA] = ACTIONS(4835),
    [sym_comment] = ACTIONS(3),
  },
  [1967] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(4839),
    [sym_comment] = ACTIONS(3),
  },
  [1968] = {
    [anon_sym_EQ_GT] = ACTIONS(4841),
    [sym_comment] = ACTIONS(3),
  },
  [1969] = {
    [sym_type_parameters] = STATE(1793),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [sym_construct_signature] = STATE(2099),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(2099),
    [sym_pair] = STATE(440),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(2099),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(440),
    [sym_assignment_pattern] = STATE(440),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(440),
    [sym__call_signature] = STATE(2099),
    [sym_property_signature] = STATE(2099),
    [sym_string] = STATE(805),
    [sym_index_signature] = STATE(2099),
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_COMMA] = ACTIONS(1037),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3226),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3226),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_static] = ACTIONS(3232),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3226),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(3234),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1970] = {
    [sym_computed_property_name] = STATE(2310),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(3238),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1971] = {
    [sym_computed_property_name] = STATE(1011),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(1011),
    [sym__property_name] = STATE(1011),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(2099),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3236),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(960),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(3242),
    [anon_sym_get] = ACTIONS(3244),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(960),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(960),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(3244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(3248),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [1972] = {
    [sym_computed_property_name] = STATE(2310),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1973] = {
    [sym_class_declaration] = STATE(1320),
    [sym_generator_function_declaration] = STATE(1320),
    [sym__declaration] = STATE(1320),
    [sym_ambient_declaration] = STATE(1320),
    [sym_import_alias] = STATE(1320),
    [sym_type_alias_declaration] = STATE(1320),
    [sym_decorator] = STATE(63),
    [aux_sym_object_repeat1] = STATE(433),
    [sym_function_signature] = STATE(1320),
    [sym_abstract_class_declaration] = STATE(1320),
    [sym_module] = STATE(1320),
    [sym_interface_declaration] = STATE(1320),
    [sym_function_declaration] = STATE(1320),
    [sym_export_clause] = STATE(1855),
    [sym_variable_declaration] = STATE(1320),
    [sym_lexical_declaration] = STATE(1320),
    [aux_sym_export_statement_repeat1] = STATE(2612),
    [sym_internal_module] = STATE(1320),
    [sym_enum_declaration] = STATE(1320),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(3250),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_var] = ACTIONS(2364),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2370),
    [anon_sym_as] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2384),
  },
  [1974] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
  },
  [1975] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(4845),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [1976] = {
    [sym_statement_block] = STATE(1539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [1977] = {
    [sym_type_arguments] = STATE(1802),
    [sym_type_annotation] = STATE(2081),
    [aux_sym_array_repeat1] = STATE(1938),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(4847),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [1978] = {
    [sym__automatic_semicolon] = ACTIONS(4849),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4849),
  },
  [1979] = {
    [sym_formal_parameters] = STATE(1543),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [1980] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(4851),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4851),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [1981] = {
    [sym_class_body] = STATE(1545),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1982] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1546),
    [sym_class_heritage] = STATE(2007),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1983] = {
    [sym_class_body] = STATE(1547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1984] = {
    [sym_class_body] = STATE(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1985] = {
    [sym_statement_block] = STATE(1549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1986] = {
    [sym_statement_block] = STATE(1550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [1987] = {
    [sym_class_body] = STATE(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1988] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1552),
    [sym_class_heritage] = STATE(2009),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [1989] = {
    [sym_computed_property_name] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym__property_name] = STATE(1049),
    [sym_enum_assignment] = STATE(1050),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [1990] = {
    [aux_sym_enum_body_repeat1] = STATE(1052),
    [anon_sym_COMMA] = ACTIONS(4855),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [sym_comment] = ACTIONS(3),
  },
  [1991] = {
    [sym_class_body] = STATE(1554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1992] = {
    [sym__automatic_semicolon] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(2754),
    [anon_sym_PIPE] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
  },
  [1993] = {
    [sym_generator_function_declaration] = STATE(1072),
    [sym__declaration] = STATE(1072),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1072),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1072),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1072),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1072),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1072),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1072),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1072),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1072),
    [sym_function_declaration] = STATE(1072),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1072),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1072),
    [sym_break_statement] = STATE(1072),
    [sym_labeled_statement] = STATE(1072),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(1072),
    [sym_class_declaration] = STATE(1072),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1072),
    [sym_ambient_declaration] = STATE(1072),
    [sym_type_alias_declaration] = STATE(1072),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1072),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1072),
    [sym_switch_statement] = STATE(1072),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1072),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1072),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1072),
    [sym_abstract_class_declaration] = STATE(1072),
    [sym_interface_declaration] = STATE(1072),
    [sym_export_statement] = STATE(1072),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1072),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1072),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1072),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1072),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [1994] = {
    [sym_statement_block] = STATE(959),
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1995] = {
    [sym_statement_block] = STATE(965),
    [sym__automatic_semicolon] = ACTIONS(3571),
    [anon_sym_RBRACE] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3571),
    [anon_sym_COMMA] = ACTIONS(3571),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3571),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [1996] = {
    [sym_class_body] = STATE(1104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [1997] = {
    [sym_statement_block] = STATE(2014),
    [sym__automatic_semicolon] = ACTIONS(4859),
    [anon_sym_SEMI] = ACTIONS(4859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [1998] = {
    [sym__automatic_semicolon] = ACTIONS(4861),
    [anon_sym_RBRACE] = ACTIONS(3314),
    [anon_sym_SEMI] = ACTIONS(3314),
    [anon_sym_COMMA] = ACTIONS(3314),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3314),
    [sym_comment] = ACTIONS(3),
  },
  [1999] = {
    [sym_class_body] = STATE(1108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2000] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1109),
    [sym_class_heritage] = STATE(2016),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2001] = {
    [sym_optional_parameter] = STATE(742),
    [sym__parameter_name] = STATE(203),
    [sym_object] = STATE(482),
    [sym_rest_parameter] = STATE(742),
    [aux_sym_export_statement_repeat1] = STATE(743),
    [sym_array] = STATE(483),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(742),
    [sym_decorator] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_identifier] = ACTIONS(1195),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_symbol] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1197),
    [anon_sym_any] = ACTIONS(1197),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(4863),
    [sym_this] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_string] = ACTIONS(1197),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [anon_sym_export] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
  },
  [2002] = {
    [sym_statement_block] = STATE(1565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1334),
  },
  [2003] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4865),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2004] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(4867),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4865),
    [anon_sym_COMMA] = ACTIONS(4867),
    [sym_comment] = ACTIONS(3),
  },
  [2005] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3799),
    [anon_sym_SEMI] = ACTIONS(3799),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(4869),
    [sym_comment] = ACTIONS(3),
  },
  [2007] = {
    [sym_class_body] = STATE(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2008] = {
    [sym_statement_block] = STATE(1572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4694),
  },
  [2009] = {
    [sym_class_body] = STATE(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [2010] = {
    [sym_computed_property_name] = STATE(1049),
    [sym_string] = STATE(1049),
    [sym__property_name] = STATE(1049),
    [sym_enum_assignment] = STATE(1050),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(291),
  },
  [2011] = {
    [sym_generator_function_declaration] = STATE(1163),
    [sym__declaration] = STATE(1163),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1163),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1163),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1163),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1163),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1163),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1163),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1163),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1163),
    [sym_function_declaration] = STATE(1163),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1163),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1163),
    [sym_break_statement] = STATE(1163),
    [sym_labeled_statement] = STATE(1163),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(1253),
    [sym_enum_declaration] = STATE(1163),
    [sym_class_declaration] = STATE(1163),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1163),
    [sym_ambient_declaration] = STATE(1163),
    [sym_type_alias_declaration] = STATE(1163),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1163),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1163),
    [sym_switch_statement] = STATE(1163),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_try_statement] = STATE(1163),
    [sym_formal_parameters] = STATE(61),
    [sym_throw_statement] = STATE(1163),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1163),
    [sym_abstract_class_declaration] = STATE(1163),
    [sym_interface_declaration] = STATE(1163),
    [sym_export_statement] = STATE(1163),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1163),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1163),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1163),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1163),
    [aux_sym_export_statement_repeat1] = STATE(2220),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(539),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(541),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(545),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(541),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_set] = ACTIONS(541),
    [anon_sym_type] = ACTIONS(549),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(551),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(553),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_number] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(557),
    [anon_sym_declare] = ACTIONS(559),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(541),
    [anon_sym_boolean] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(567),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(571),
    [anon_sym_await] = ACTIONS(107),
  },
  [2012] = {
    [sym_statement_block] = STATE(1111),
    [sym__automatic_semicolon] = ACTIONS(3895),
    [anon_sym_RBRACE] = ACTIONS(3895),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3895),
    [anon_sym_COMMA] = ACTIONS(3895),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3895),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2013] = {
    [sym_statement_block] = STATE(1113),
    [sym__automatic_semicolon] = ACTIONS(3921),
    [anon_sym_RBRACE] = ACTIONS(3921),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3921),
    [anon_sym_COMMA] = ACTIONS(3921),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3921),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2014] = {
    [sym__automatic_semicolon] = ACTIONS(4873),
    [anon_sym_RBRACE] = ACTIONS(3635),
    [anon_sym_SEMI] = ACTIONS(3635),
    [anon_sym_COMMA] = ACTIONS(3635),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
  },
  [2015] = {
    [sym__automatic_semicolon] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_SEMI] = ACTIONS(3765),
    [anon_sym_COMMA] = ACTIONS(3765),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3765),
    [sym_comment] = ACTIONS(3),
  },
  [2016] = {
    [sym_class_body] = STATE(1184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2017] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4877),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2018] = {
    [sym_statement_block] = STATE(1185),
    [sym__automatic_semicolon] = ACTIONS(4084),
    [anon_sym_RBRACE] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4084),
    [anon_sym_COMMA] = ACTIONS(4084),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4084),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2019] = {
    [sym_statement_block] = STATE(1187),
    [sym__automatic_semicolon] = ACTIONS(4086),
    [anon_sym_RBRACE] = ACTIONS(4086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_COMMA] = ACTIONS(4086),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4086),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2020] = {
    [sym__automatic_semicolon] = ACTIONS(4879),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [anon_sym_SEMI] = ACTIONS(3975),
    [anon_sym_COMMA] = ACTIONS(3975),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3975),
    [sym_comment] = ACTIONS(3),
  },
  [2021] = {
    [sym_statement_block] = STATE(1220),
    [sym__automatic_semicolon] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4152),
    [anon_sym_COMMA] = ACTIONS(4152),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2022] = {
    [sym_statement_block] = STATE(1222),
    [sym__automatic_semicolon] = ACTIONS(4154),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(4154),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4154),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2023] = {
    [sym_statement_block] = STATE(1235),
    [sym__automatic_semicolon] = ACTIONS(4174),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4174),
    [anon_sym_COMMA] = ACTIONS(4174),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4174),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2024] = {
    [sym_statement_block] = STATE(1237),
    [sym__automatic_semicolon] = ACTIONS(4176),
    [anon_sym_RBRACE] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4176),
    [anon_sym_COMMA] = ACTIONS(4176),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4176),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2025] = {
    [sym_statement_block] = STATE(1242),
    [sym__automatic_semicolon] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_COMMA] = ACTIONS(4184),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(453),
  },
  [2026] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2027] = {
    [sym_await_expression] = STATE(2038),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(2038),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(2038),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(2038),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2038),
    [sym_call_expression] = STATE(2038),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(2038),
    [sym_template_string] = STATE(2038),
    [sym_yield_expression] = STATE(2038),
    [sym_type_assertion] = STATE(2038),
    [sym_new_expression] = STATE(2038),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(2038),
    [sym_binary_expression] = STATE(2038),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_array] = STATE(2616),
    [sym_as_expression] = STATE(2038),
    [sym_internal_module] = STATE(2038),
    [sym_arrow_function] = STATE(2038),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(2615),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(2581),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(2454),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(2615),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1703),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(2617),
    [sym_generator_function] = STATE(2038),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(2038),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(2038),
    [sym_regex] = STATE(2038),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_non_null_expression] = STATE(2038),
    [sym_class] = STATE(2038),
    [sym_identifier] = ACTIONS(4881),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(4883),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(4887),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4889),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4891),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(4891),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(4883),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(4893),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(4895),
    [anon_sym_any] = ACTIONS(4883),
    [anon_sym_boolean] = ACTIONS(4883),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4897),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4883),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4895),
    [anon_sym_new] = ACTIONS(4899),
    [anon_sym_PLUS] = ACTIONS(4885),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2028] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2029] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2030] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1739),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2031] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1759),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1759),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2032] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1763),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1763),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2033] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1765),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1765),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2034] = {
    [aux_sym_object_repeat1] = STATE(433),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COMMA] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
  },
  [2035] = {
    [aux_sym_object_repeat1] = STATE(433),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1053),
    [anon_sym_symbol] = ACTIONS(1053),
    [anon_sym_number] = ACTIONS(1053),
    [anon_sym_declare] = ACTIONS(1053),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1785),
    [anon_sym_void] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1053),
    [anon_sym_private] = ACTIONS(1053),
    [anon_sym_boolean] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_public] = ACTIONS(1053),
    [anon_sym_get] = ACTIONS(1053),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_static] = ACTIONS(1053),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1053),
    [anon_sym_string] = ACTIONS(1053),
    [anon_sym_set] = ACTIONS(1053),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_namespace] = ACTIONS(1053),
    [sym_readonly] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
  },
  [2036] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2037] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2199),
    [sym__automatic_semicolon] = ACTIONS(4901),
    [anon_sym_BQUOTE] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(2201),
    [anon_sym_COMMA] = ACTIONS(2199),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2201),
    [anon_sym_GT_GT_GT] = ACTIONS(2199),
    [anon_sym_BANG_EQ] = ACTIONS(2201),
    [anon_sym_GT_EQ] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_PERCENT] = ACTIONS(2199),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2199),
    [anon_sym_as] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_instanceof] = ACTIONS(2199),
    [anon_sym_COLON] = ACTIONS(2199),
    [anon_sym_DOT] = ACTIONS(2199),
    [anon_sym_STAR_STAR] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_in] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_LT_LT] = ACTIONS(2199),
    [anon_sym_LBRACE] = ACTIONS(2201),
    [anon_sym_AMP_AMP] = ACTIONS(2199),
    [anon_sym_LT_EQ] = ACTIONS(2199),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_RBRACK] = ACTIONS(2199),
    [anon_sym_GT] = ACTIONS(2201),
    [anon_sym_AMP] = ACTIONS(2201),
    [anon_sym_QMARK] = ACTIONS(2199),
    [anon_sym_PIPE_PIPE] = ACTIONS(2199),
    [anon_sym_EQ_EQ] = ACTIONS(2201),
    [anon_sym_RPAREN] = ACTIONS(2199),
    [anon_sym_LT] = ACTIONS(2201),
    [anon_sym_SLASH] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_implements] = ACTIONS(2199),
    [anon_sym_GT_GT] = ACTIONS(2201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2199),
  },
  [2038] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2039] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2040] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2041] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2042] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2043] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(4906),
    [sym_false] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [sym_number] = ACTIONS(1159),
    [sym_true] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2044] = {
    [sym_arrow_function] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym__expression] = STATE(1270),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1270),
    [sym_generator_function] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_regex] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1270),
    [sym_class] = STATE(1270),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4380),
    [sym_number] = ACTIONS(4908),
    [sym_true] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4380),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2045] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(1979),
    [sym_formal_parameters] = STATE(1500),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4384),
    [sym_false] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(4386),
    [anon_sym_symbol] = ACTIONS(4386),
    [anon_sym_number] = ACTIONS(4386),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4386),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4388),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4386),
    [anon_sym_private] = ACTIONS(4386),
    [anon_sym_boolean] = ACTIONS(4386),
    [anon_sym_static] = ACTIONS(4386),
    [anon_sym_public] = ACTIONS(4386),
    [anon_sym_get] = ACTIONS(4386),
    [anon_sym_async] = ACTIONS(4396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [sym_number] = ACTIONS(4398),
    [sym_true] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(4386),
    [anon_sym_string] = ACTIONS(4386),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_DOT] = ACTIONS(4392),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_set] = ACTIONS(4386),
    [anon_sym_type] = ACTIONS(4386),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4386),
    [anon_sym_namespace] = ACTIONS(4394),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2046] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_RBRACK] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2589),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2047] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2655),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2048] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2657),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2657),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2049] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2667),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2667),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2050] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(3116),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2051] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(3120),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2052] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(3130),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2053] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(3799),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3799),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2054] = {
    [aux_sym_string_repeat1] = STATE(2059),
    [sym_escape_sequence] = ACTIONS(4910),
    [aux_sym_string_token1] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [sym_comment] = ACTIONS(255),
  },
  [2055] = {
    [sym_generator_function_declaration] = STATE(1830),
    [sym_while_statement] = STATE(1830),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(184),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1830),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(1830),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(1830),
    [sym_function_declaration] = STATE(1830),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1830),
    [sym_labeled_statement] = STATE(1830),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_enum_declaration] = STATE(1830),
    [sym_arrow_function] = STATE(51),
    [sym_type_arguments] = STATE(56),
    [sym_continue_statement] = STATE(1830),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(1830),
    [sym_type_alias_declaration] = STATE(1830),
    [sym_import_statement] = STATE(1830),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(1830),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(1830),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1830),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(1830),
    [sym_interface_declaration] = STATE(1830),
    [sym_export_statement] = STATE(1830),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1830),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(1830),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(184),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(1830),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1830),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(1830),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1830),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(1830),
    [sym_template_string] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1830),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(1830),
    [sym_parenthesized_expression] = STATE(53),
    [sym_internal_module] = STATE(55),
    [sym_class_declaration] = STATE(1830),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(1830),
    [sym_spread_element] = STATE(184),
    [sym_try_statement] = STATE(1830),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(189),
    [sym_abstract_class_declaration] = STATE(1830),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(1830),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(1830),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(184),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(373),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_void] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_static] = ACTIONS(383),
    [anon_sym_get] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(4916),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(389),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(391),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(395),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(397),
    [anon_sym_number] = ACTIONS(373),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(399),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(373),
    [anon_sym_boolean] = ACTIONS(373),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_public] = ACTIONS(381),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(373),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(405),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2056] = {
    [aux_sym_string_repeat2] = STATE(2064),
    [sym_escape_sequence] = ACTIONS(4918),
    [aux_sym_string_token2] = ACTIONS(4920),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4914),
  },
  [2057] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(4473),
    [sym_false] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(4475),
    [anon_sym_symbol] = ACTIONS(4475),
    [anon_sym_number] = ACTIONS(4475),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(4475),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(4477),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(4475),
    [anon_sym_private] = ACTIONS(4475),
    [anon_sym_boolean] = ACTIONS(4475),
    [anon_sym_static] = ACTIONS(4475),
    [anon_sym_public] = ACTIONS(4475),
    [anon_sym_get] = ACTIONS(4475),
    [anon_sym_async] = ACTIONS(4479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [sym_number] = ACTIONS(4398),
    [sym_true] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(4475),
    [anon_sym_string] = ACTIONS(4475),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_DOT] = ACTIONS(4392),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_set] = ACTIONS(4475),
    [anon_sym_type] = ACTIONS(4475),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(4475),
    [anon_sym_namespace] = ACTIONS(4481),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2058] = {
    [sym_arrow_function] = STATE(2073),
    [sym_await_expression] = STATE(2073),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(2073),
    [sym_meta_property] = STATE(2073),
    [sym__expression] = STATE(2073),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2073),
    [sym_call_expression] = STATE(2073),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_spread_element] = STATE(2074),
    [sym_ternary_expression] = STATE(2073),
    [sym_string] = STATE(2073),
    [sym_template_string] = STATE(2073),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2073),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(2073),
    [sym_generator_function] = STATE(2073),
    [sym_new_expression] = STATE(2073),
    [sym_assignment_expression] = STATE(2073),
    [sym_augmented_assignment_expression] = STATE(2073),
    [sym_binary_expression] = STATE(2073),
    [sym_unary_expression] = STATE(2073),
    [sym_regex] = STATE(2073),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [aux_sym_array_repeat1] = STATE(2075),
    [sym_non_null_expression] = STATE(2073),
    [sym_as_expression] = STATE(2073),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(2073),
    [sym_class] = STATE(2073),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4922),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4922),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4922),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4922),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(4924),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4926),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4922),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [2059] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(846),
    [aux_sym_string_token1] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(4928),
    [sym_comment] = ACTIONS(255),
  },
  [2060] = {
    [sym_decorator] = STATE(2077),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(2077),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(4930),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2061] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4932),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2062] = {
    [anon_sym_RPAREN] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
  },
  [2063] = {
    [sym_type_arguments] = STATE(1802),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_annotation] = STATE(2081),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(627),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2064] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(1223),
    [aux_sym_string_token2] = ACTIONS(1225),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(4928),
  },
  [2065] = {
    [sym_generator_function_declaration] = STATE(1830),
    [sym__declaration] = STATE(1830),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(1830),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(1830),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(1830),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(1830),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(1830),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(1830),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(1830),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(1830),
    [sym_function_declaration] = STATE(1830),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(1830),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(1830),
    [sym_break_statement] = STATE(1830),
    [sym_labeled_statement] = STATE(1830),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(1830),
    [sym_class_declaration] = STATE(1830),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(1830),
    [sym_ambient_declaration] = STATE(1830),
    [sym_type_alias_declaration] = STATE(1830),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(1830),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(1830),
    [sym_switch_statement] = STATE(1830),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(1830),
    [sym_throw_statement] = STATE(1830),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(1830),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(1830),
    [sym_abstract_class_declaration] = STATE(1830),
    [sym_interface_declaration] = STATE(1830),
    [sym_export_statement] = STATE(1830),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(1830),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(1830),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(1830),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(1830),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4936),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2066] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(2083),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(2083),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(2083),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(2083),
    [sym_property_signature] = STATE(2083),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(2083),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(4361),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(4361),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4367),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4367),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2067] = {
    [sym_nested_identifier] = STATE(1613),
    [sym_identifier] = ACTIONS(4938),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [sym_number] = ACTIONS(4940),
    [sym_comment] = ACTIONS(3),
  },
  [2069] = {
    [sym_nested_type_identifier] = STATE(1616),
    [sym_nested_identifier] = STATE(2397),
    [sym_identifier] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
  },
  [2070] = {
    [anon_sym_EQ_GT] = ACTIONS(4944),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [aux_sym_implements_clause_repeat1] = STATE(2090),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
  },
  [2072] = {
    [anon_sym_SLASH2] = ACTIONS(4950),
    [sym_comment] = ACTIONS(3),
  },
  [2073] = {
    [aux_sym_array_repeat1] = STATE(2093),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2074] = {
    [aux_sym_array_repeat1] = STATE(2093),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2075] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(4952),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(4954),
    [sym_comment] = ACTIONS(3),
  },
  [2077] = {
    [sym_decorator] = STATE(698),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(4956),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2078] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1460),
    [sym_class_heritage] = STATE(2096),
    [sym_type_parameters] = STATE(2097),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2079] = {
    [aux_sym_array_repeat1] = STATE(1887),
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_COMMA] = ACTIONS(271),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_RBRACK] = ACTIONS(4958),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2080] = {
    [sym__automatic_semicolon] = ACTIONS(4343),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2199),
    [anon_sym_while] = ACTIONS(2199),
    [anon_sym_COMMA] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(2199),
  },
  [2081] = {
    [anon_sym_RPAREN] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(4962),
    [sym_comment] = ACTIONS(3),
  },
  [2083] = {
    [aux_sym_object_type_repeat1] = STATE(2101),
    [sym__automatic_semicolon] = ACTIONS(4964),
    [anon_sym_RBRACE] = ACTIONS(4966),
    [anon_sym_SEMI] = ACTIONS(4964),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4966),
    [anon_sym_COMMA] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
  },
  [2084] = {
    [aux_sym_implements_clause_repeat1] = STATE(2102),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RBRACK] = ACTIONS(4968),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
  },
  [2085] = {
    [anon_sym_EQ_GT] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
  },
  [2086] = {
    [sym_construct_signature] = STATE(518),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(518),
    [sym__call_signature] = STATE(518),
    [sym_spread_element] = STATE(1829),
    [sym_property_signature] = STATE(518),
    [sym_type_parameters] = STATE(1793),
    [sym_decorator] = STATE(63),
    [sym_string] = STATE(805),
    [sym_formal_parameters] = STATE(1255),
    [sym_index_signature] = STATE(518),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(4972),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2087] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(4974),
    [anon_sym_PIPE] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [2088] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2104),
    [sym_function_type] = STATE(2104),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2104),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2104),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2104),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(4976),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2089] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(4978),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2090] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_GT] = ACTIONS(4978),
    [anon_sym_COMMA] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2091] = {
    [anon_sym_EQ_GT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
  },
  [2092] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2063),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(2063),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(2063),
    [sym_function_type] = STATE(2087),
    [sym__expression] = STATE(2063),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2063),
    [sym_call_expression] = STATE(2063),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(2063),
    [sym_template_string] = STATE(2063),
    [sym_yield_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2063),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2063),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(2063),
    [sym_binary_expression] = STATE(2063),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(2087),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2063),
    [sym_internal_module] = STATE(2063),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2063),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(1251),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(2062),
    [sym_intersection_type] = STATE(2087),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(1792),
    [sym__type] = STATE(2087),
    [sym_subscript_expression] = STATE(1251),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1749),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2063),
    [sym_constructor_type] = STATE(2087),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(2063),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(2063),
    [sym_regex] = STATE(2063),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2063),
    [sym_class] = STATE(2063),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(2634),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(409),
    [anon_sym_get] = ACTIONS(409),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(2636),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_set] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(409),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(423),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(409),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(2640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(4809),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2644),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4809),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [2093] = {
    [aux_sym_array_repeat1] = STATE(394),
    [anon_sym_RPAREN] = ACTIONS(4984),
    [anon_sym_COMMA] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
  },
  [2095] = {
    [anon_sym_COLON] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
  },
  [2096] = {
    [sym_class_body] = STATE(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2097] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1522),
    [sym_class_heritage] = STATE(2106),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2098] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1523),
    [sym_class_heritage] = STATE(2107),
    [sym_type_parameters] = STATE(2108),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2099] = {
    [aux_sym_object_type_repeat1] = STATE(2110),
    [sym__automatic_semicolon] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4992),
    [anon_sym_COMMA] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
  },
  [2100] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4992),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2101] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_SEMI] = ACTIONS(4990),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4992),
    [anon_sym_COMMA] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
  },
  [2102] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
  },
  [2103] = {
    [anon_sym_EQ_GT] = ACTIONS(4996),
    [sym_comment] = ACTIONS(3),
  },
  [2104] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
  },
  [2105] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(5000),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2106] = {
    [sym_class_body] = STATE(1558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2107] = {
    [sym_class_body] = STATE(1559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2108] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(1560),
    [sym_class_heritage] = STATE(2112),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2109] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5002),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5002),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2110] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(5004),
    [anon_sym_RBRACE] = ACTIONS(5002),
    [anon_sym_SEMI] = ACTIONS(5004),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5002),
    [anon_sym_COMMA] = ACTIONS(5004),
    [sym_comment] = ACTIONS(3),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(5006),
    [sym_comment] = ACTIONS(3),
  },
  [2112] = {
    [sym_class_body] = STATE(1575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2113] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5008),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2114] = {
    [sym_await_expression] = STATE(2122),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(2122),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(2122),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(2122),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2122),
    [sym_call_expression] = STATE(2122),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(2122),
    [sym_template_string] = STATE(2122),
    [sym_yield_expression] = STATE(2122),
    [sym_type_assertion] = STATE(2122),
    [sym_new_expression] = STATE(2122),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(2122),
    [sym_binary_expression] = STATE(2122),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_array] = STATE(2580),
    [sym_as_expression] = STATE(2122),
    [sym_internal_module] = STATE(2122),
    [sym_arrow_function] = STATE(2122),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(2579),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(2337),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(2385),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(2579),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1427),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(2582),
    [sym_generator_function] = STATE(2122),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(2122),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(2122),
    [sym_regex] = STATE(2122),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_non_null_expression] = STATE(2122),
    [sym_class] = STATE(2122),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5010),
    [sym_false] = ACTIONS(4306),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(5012),
    [anon_sym_number] = ACTIONS(5012),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(5014),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5016),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(5018),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(5020),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5012),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(5012),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(4304),
    [sym_number] = ACTIONS(4312),
    [sym_true] = ACTIONS(4306),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(5012),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5020),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(5016),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2115] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1729),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2116] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1733),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1733),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2117] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1739),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2118] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1759),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2119] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1763),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1763),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2120] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1765),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1765),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2121] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1865),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2122] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2123] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2124] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2125] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2126] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2127] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(5027),
    [sym_false] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [sym_number] = ACTIONS(1159),
    [sym_true] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2128] = {
    [sym_arrow_function] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym__expression] = STATE(1270),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1270),
    [sym_generator_function] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_regex] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1270),
    [sym_class] = STATE(1270),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4380),
    [sym_number] = ACTIONS(5029),
    [sym_true] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4380),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2129] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_LBRACE] = ACTIONS(2589),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5024),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_implements] = ACTIONS(2589),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2130] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2131] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(2657),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2657),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2132] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(2667),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2133] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2134] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2135] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(3130),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3130),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2136] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(3799),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(3799),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2137] = {
    [aux_sym_string_repeat1] = STATE(2140),
    [sym_escape_sequence] = ACTIONS(5031),
    [aux_sym_string_token1] = ACTIONS(5033),
    [anon_sym_DQUOTE] = ACTIONS(5035),
    [sym_comment] = ACTIONS(255),
  },
  [2138] = {
    [sym_generator_function_declaration] = STATE(2142),
    [sym_while_statement] = STATE(2142),
    [sym_meta_property] = STATE(51),
    [sym_pair] = STATE(1829),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2142),
    [sym_ternary_expression] = STATE(51),
    [sym_return_statement] = STATE(2142),
    [sym_yield_expression] = STATE(51),
    [sym_module] = STATE(2142),
    [sym_function_declaration] = STATE(2142),
    [sym_assignment_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2142),
    [sym_labeled_statement] = STATE(2142),
    [sym_array] = STATE(185),
    [sym_as_expression] = STATE(51),
    [sym_enum_declaration] = STATE(2142),
    [sym_arrow_function] = STATE(51),
    [sym_type_arguments] = STATE(56),
    [sym_continue_statement] = STATE(2142),
    [sym__property_name] = STATE(186),
    [sym_ambient_declaration] = STATE(2142),
    [sym_type_alias_declaration] = STATE(2142),
    [sym_import_statement] = STATE(2142),
    [sym_subscript_expression] = STATE(53),
    [sym_switch_statement] = STATE(2142),
    [sym_string] = STATE(182),
    [sym_type_parameters] = STATE(60),
    [sym_throw_statement] = STATE(2142),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2142),
    [sym_object] = STATE(188),
    [sym_function_signature] = STATE(2142),
    [sym_interface_declaration] = STATE(2142),
    [sym_export_statement] = STATE(2142),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2142),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_with_statement] = STATE(2142),
    [sym_regex] = STATE(51),
    [sym_method_definition] = STATE(1829),
    [sym_class] = STATE(51),
    [sym__declaration] = STATE(2142),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2142),
    [sym_update_expression] = STATE(51),
    [sym_debugger_statement] = STATE(2142),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2142),
    [sym_function] = STATE(52),
    [sym_do_statement] = STATE(2142),
    [sym_template_string] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2142),
    [sym_binary_expression] = STATE(51),
    [sym_break_statement] = STATE(2142),
    [sym_parenthesized_expression] = STATE(53),
    [sym_internal_module] = STATE(55),
    [sym_class_declaration] = STATE(2142),
    [sym_member_expression] = STATE(53),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_expression_statement] = STATE(2142),
    [sym_spread_element] = STATE(1829),
    [sym_try_statement] = STATE(2142),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(186),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_abstract_class_declaration] = STATE(2142),
    [sym_accessibility_modifier] = STATE(190),
    [sym_for_statement] = STATE(2142),
    [sym_unary_expression] = STATE(51),
    [sym_empty_statement] = STATE(2142),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_assignment_pattern] = STATE(1829),
    [sym_non_null_expression] = STATE(51),
    [sym_identifier] = ACTIONS(5037),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(5039),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(377),
    [anon_sym_void] = ACTIONS(5041),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(5043),
    [anon_sym_static] = ACTIONS(5045),
    [anon_sym_get] = ACTIONS(5047),
    [anon_sym_RBRACE] = ACTIONS(5049),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(5043),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(5047),
    [anon_sym_type] = ACTIONS(5051),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(5053),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [sym_readonly] = ACTIONS(393),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(395),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(5055),
    [anon_sym_number] = ACTIONS(5039),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(5057),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(5039),
    [anon_sym_boolean] = ACTIONS(5039),
    [anon_sym_async] = ACTIONS(5059),
    [anon_sym_public] = ACTIONS(5043),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(403),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5039),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(5061),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2139] = {
    [aux_sym_string_repeat2] = STATE(2143),
    [sym_escape_sequence] = ACTIONS(5063),
    [aux_sym_string_token2] = ACTIONS(5065),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5035),
  },
  [2140] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(846),
    [aux_sym_string_token1] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(5067),
    [sym_comment] = ACTIONS(255),
  },
  [2141] = {
    [sym_decorator] = STATE(2152),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(2152),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2142] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5071),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2143] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(1223),
    [aux_sym_string_token2] = ACTIONS(1225),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5067),
  },
  [2144] = {
    [sym_generator_function_declaration] = STATE(2142),
    [sym__declaration] = STATE(2142),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2142),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2142),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2142),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2142),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2142),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2142),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2142),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2142),
    [sym_function_declaration] = STATE(2142),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2142),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2142),
    [sym_break_statement] = STATE(2142),
    [sym_labeled_statement] = STATE(2142),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(2142),
    [sym_class_declaration] = STATE(2142),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2142),
    [sym_ambient_declaration] = STATE(2142),
    [sym_type_alias_declaration] = STATE(2142),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2142),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2142),
    [sym_switch_statement] = STATE(2142),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2142),
    [sym_throw_statement] = STATE(2142),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2142),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2142),
    [sym_abstract_class_declaration] = STATE(2142),
    [sym_interface_declaration] = STATE(2142),
    [sym_export_statement] = STATE(2142),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2142),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2142),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2142),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2142),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5073),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2145] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(2154),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(2154),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(2154),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(2154),
    [sym_property_signature] = STATE(2154),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(2154),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_SEMI] = ACTIONS(5075),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_COMMA] = ACTIONS(5075),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5077),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5077),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2146] = {
    [sym_nested_identifier] = STATE(1692),
    [sym_identifier] = ACTIONS(5079),
    [sym_comment] = ACTIONS(3),
  },
  [2147] = {
    [sym_number] = ACTIONS(5081),
    [sym_comment] = ACTIONS(3),
  },
  [2148] = {
    [sym_nested_type_identifier] = STATE(1695),
    [sym_nested_identifier] = STATE(2463),
    [sym_identifier] = ACTIONS(5083),
    [sym_comment] = ACTIONS(3),
  },
  [2149] = {
    [anon_sym_EQ_GT] = ACTIONS(5085),
    [sym_comment] = ACTIONS(3),
  },
  [2150] = {
    [aux_sym_implements_clause_repeat1] = STATE(2161),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(5087),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(5089),
    [sym_comment] = ACTIONS(3),
  },
  [2151] = {
    [sym_identifier] = ACTIONS(5091),
    [sym_comment] = ACTIONS(3),
  },
  [2152] = {
    [sym_decorator] = STATE(698),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(5093),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(5095),
    [sym_comment] = ACTIONS(3),
  },
  [2154] = {
    [aux_sym_object_type_repeat1] = STATE(2166),
    [sym__automatic_semicolon] = ACTIONS(5097),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [anon_sym_SEMI] = ACTIONS(5097),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5099),
    [anon_sym_COMMA] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
  },
  [2155] = {
    [aux_sym_implements_clause_repeat1] = STATE(2167),
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RBRACK] = ACTIONS(5101),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
  },
  [2156] = {
    [anon_sym_EQ_GT] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2157] = {
    [sym_type_parameters] = STATE(1793),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_construct_signature] = STATE(518),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(518),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(1829),
    [sym__call_signature] = STATE(518),
    [sym_property_signature] = STATE(518),
    [sym_string] = STATE(805),
    [sym_index_signature] = STATE(518),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2158] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_RPAREN] = ACTIONS(5107),
    [anon_sym_PIPE] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [2159] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2169),
    [sym_function_type] = STATE(2169),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2169),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2169),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2169),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(5109),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2160] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(5111),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2161] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_GT] = ACTIONS(5111),
    [anon_sym_COMMA] = ACTIONS(5113),
    [sym_comment] = ACTIONS(3),
  },
  [2162] = {
    [anon_sym_EQ_GT] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
  },
  [2164] = {
    [aux_sym_object_type_repeat1] = STATE(2172),
    [sym__automatic_semicolon] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
  },
  [2165] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5121),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2166] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(5119),
    [anon_sym_RBRACE] = ACTIONS(5121),
    [anon_sym_SEMI] = ACTIONS(5119),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5121),
    [anon_sym_COMMA] = ACTIONS(5119),
    [sym_comment] = ACTIONS(3),
  },
  [2167] = {
    [aux_sym_implements_clause_repeat1] = STATE(819),
    [anon_sym_COMMA] = ACTIONS(2061),
    [anon_sym_RBRACK] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
  },
  [2168] = {
    [anon_sym_EQ_GT] = ACTIONS(5125),
    [sym_comment] = ACTIONS(3),
  },
  [2169] = {
    [anon_sym_AMP] = ACTIONS(1322),
    [anon_sym_PIPE] = ACTIONS(1326),
    [anon_sym_RBRACK] = ACTIONS(5127),
    [sym_comment] = ACTIONS(3),
  },
  [2170] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(817),
    [sym_function_type] = STATE(817),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(817),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(817),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(817),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_GT] = ACTIONS(5129),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2171] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5131),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2172] = {
    [aux_sym_object_type_repeat1] = STATE(999),
    [sym__automatic_semicolon] = ACTIONS(5133),
    [anon_sym_RBRACE] = ACTIONS(5131),
    [anon_sym_SEMI] = ACTIONS(5133),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5131),
    [anon_sym_COMMA] = ACTIONS(5133),
    [sym_comment] = ACTIONS(3),
  },
  [2173] = {
    [sym_identifier] = ACTIONS(5135),
    [sym_comment] = ACTIONS(3),
  },
  [2174] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(998),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(998),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(998),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(998),
    [sym_property_signature] = STATE(998),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(998),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_RBRACE] = ACTIONS(5137),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(5137),
    [anon_sym_export] = ACTIONS(1278),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2175] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_nested_identifier] = STATE(1613),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(5139),
    [sym_false] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1153),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(1153),
    [sym_number] = ACTIONS(1159),
    [sym_true] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2176] = {
    [sym_arrow_function] = STATE(1270),
    [sym_await_expression] = STATE(1270),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1270),
    [sym_meta_property] = STATE(1270),
    [sym__expression] = STATE(1270),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1270),
    [sym_call_expression] = STATE(1270),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1270),
    [sym_string] = STATE(1270),
    [sym_template_string] = STATE(1270),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1270),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1270),
    [sym_generator_function] = STATE(1270),
    [sym_new_expression] = STATE(1270),
    [sym_assignment_expression] = STATE(1270),
    [sym_augmented_assignment_expression] = STATE(1270),
    [sym_binary_expression] = STATE(1270),
    [sym_unary_expression] = STATE(1270),
    [sym_regex] = STATE(1270),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1270),
    [sym_as_expression] = STATE(1270),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1270),
    [sym_class] = STATE(1270),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(4380),
    [sym_number] = ACTIONS(5141),
    [sym_true] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4380),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2177] = {
    [aux_sym_string_repeat1] = STATE(2179),
    [sym_escape_sequence] = ACTIONS(5143),
    [aux_sym_string_token1] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(5147),
    [sym_comment] = ACTIONS(255),
  },
  [2178] = {
    [aux_sym_string_repeat2] = STATE(2182),
    [sym_escape_sequence] = ACTIONS(5149),
    [aux_sym_string_token2] = ACTIONS(5151),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5147),
  },
  [2179] = {
    [aux_sym_string_repeat1] = STATE(374),
    [sym_escape_sequence] = ACTIONS(846),
    [aux_sym_string_token1] = ACTIONS(848),
    [anon_sym_DQUOTE] = ACTIONS(5153),
    [sym_comment] = ACTIONS(255),
  },
  [2180] = {
    [sym_decorator] = STATE(2186),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(2186),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(5155),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2181] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5157),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2182] = {
    [aux_sym_string_repeat2] = STATE(494),
    [sym_escape_sequence] = ACTIONS(1223),
    [aux_sym_string_token2] = ACTIONS(1225),
    [sym_comment] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(5153),
  },
  [2183] = {
    [sym_generator_function_declaration] = STATE(2181),
    [sym__declaration] = STATE(2181),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2181),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2181),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2181),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2181),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2181),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2181),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2181),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2181),
    [sym_function_declaration] = STATE(2181),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2181),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2181),
    [sym_break_statement] = STATE(2181),
    [sym_labeled_statement] = STATE(2181),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(2181),
    [sym_class_declaration] = STATE(2181),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2181),
    [sym_ambient_declaration] = STATE(2181),
    [sym_type_alias_declaration] = STATE(2181),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2181),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2181),
    [sym_switch_statement] = STATE(2181),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2181),
    [sym_throw_statement] = STATE(2181),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2181),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2181),
    [sym_abstract_class_declaration] = STATE(2181),
    [sym_interface_declaration] = STATE(2181),
    [sym_export_statement] = STATE(2181),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2181),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2181),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2181),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2181),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2184] = {
    [anon_sym_EQ_GT] = ACTIONS(5161),
    [sym_comment] = ACTIONS(3),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(5163),
    [sym_comment] = ACTIONS(3),
  },
  [2186] = {
    [sym_decorator] = STATE(698),
    [sym_computed_property_name] = STATE(418),
    [sym_accessibility_modifier] = STATE(417),
    [sym_public_field_definition] = STATE(414),
    [sym__property_name] = STATE(418),
    [sym_method_signature] = STATE(414),
    [sym_abstract_method_signature] = STATE(414),
    [sym_method_definition] = STATE(416),
    [aux_sym_class_body_repeat1] = STATE(698),
    [sym_string] = STATE(418),
    [sym_index_signature] = STATE(414),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(964),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_async] = ACTIONS(968),
    [anon_sym_static] = ACTIONS(970),
    [anon_sym_get] = ACTIONS(972),
    [anon_sym_RBRACE] = ACTIONS(5165),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [sym_number] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_abstract] = ACTIONS(980),
    [anon_sym_set] = ACTIONS(972),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_export] = ACTIONS(960),
    [sym_readonly] = ACTIONS(982),
    [anon_sym_namespace] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2187] = {
    [anon_sym_EQ_GT] = ACTIONS(5167),
    [sym_comment] = ACTIONS(3),
  },
  [2188] = {
    [sym_type_parameters] = STATE(1793),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(805),
    [sym_object] = STATE(319),
    [aux_sym_object_repeat1] = STATE(1831),
    [sym_construct_signature] = STATE(518),
    [sym_accessibility_modifier] = STATE(804),
    [sym_export_statement] = STATE(518),
    [sym_pair] = STATE(1829),
    [sym__property_name] = STATE(805),
    [sym_method_signature] = STATE(518),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym_method_definition] = STATE(1829),
    [sym_assignment_pattern] = STATE(1829),
    [sym_array] = STATE(320),
    [sym_spread_element] = STATE(1829),
    [sym__call_signature] = STATE(518),
    [sym_property_signature] = STATE(518),
    [sym_string] = STATE(805),
    [sym_index_signature] = STATE(518),
    [sym_identifier] = ACTIONS(2460),
    [anon_sym_LBRACK] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(1260),
    [anon_sym_module] = ACTIONS(2460),
    [anon_sym_symbol] = ACTIONS(2460),
    [anon_sym_number] = ACTIONS(2460),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2460),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_STAR] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(2460),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(2460),
    [anon_sym_private] = ACTIONS(2468),
    [anon_sym_boolean] = ACTIONS(2460),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(5169),
    [anon_sym_static] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2468),
    [anon_sym_string] = ACTIONS(2460),
    [anon_sym_set] = ACTIONS(2472),
    [anon_sym_type] = ACTIONS(2460),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1272),
    [anon_sym_export] = ACTIONS(2480),
    [sym_readonly] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2189] = {
    [anon_sym_EQ_GT] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2191] = {
    [anon_sym_EQ_GT] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
  },
  [2193] = {
    [sym_generator_function_declaration] = STATE(2252),
    [sym__declaration] = STATE(2252),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2252),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2252),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2252),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2252),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2252),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2252),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2252),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2252),
    [sym_function_declaration] = STATE(2252),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2252),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2252),
    [sym_break_statement] = STATE(2252),
    [sym_labeled_statement] = STATE(2252),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(2252),
    [sym_class_declaration] = STATE(2252),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2252),
    [sym_ambient_declaration] = STATE(2252),
    [sym_type_alias_declaration] = STATE(2252),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2252),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2252),
    [sym_switch_statement] = STATE(2252),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2252),
    [sym_throw_statement] = STATE(2252),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2252),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2252),
    [sym_abstract_class_declaration] = STATE(2252),
    [sym_interface_declaration] = STATE(2252),
    [sym_export_statement] = STATE(2252),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2252),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2252),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2252),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2252),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(5181),
    [sym_comment] = ACTIONS(3),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(5183),
    [sym_comment] = ACTIONS(3),
  },
  [2196] = {
    [sym_generator_function_declaration] = STATE(2393),
    [sym__declaration] = STATE(2393),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(2393),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(2393),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(2393),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(2393),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(2393),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(2393),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(2393),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(2393),
    [sym_function_declaration] = STATE(2393),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2393),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(2393),
    [sym_break_statement] = STATE(2393),
    [sym_labeled_statement] = STATE(2393),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(2393),
    [sym_class_declaration] = STATE(2393),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(2393),
    [sym_ambient_declaration] = STATE(2393),
    [sym_type_alias_declaration] = STATE(2393),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(2393),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2393),
    [sym_switch_statement] = STATE(2393),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(2393),
    [sym_throw_statement] = STATE(2393),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(2393),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(2393),
    [sym_abstract_class_declaration] = STATE(2393),
    [sym_interface_declaration] = STATE(2393),
    [sym_export_statement] = STATE(2393),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2393),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(2393),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(2393),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2393),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4936),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2197] = {
    [sym_identifier] = ACTIONS(5185),
    [sym_comment] = ACTIONS(3),
  },
  [2198] = {
    [sym_identifier] = ACTIONS(5187),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(5189),
    [sym_comment] = ACTIONS(3),
  },
  [2200] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(111),
    [anon_sym_AMP_EQ] = ACTIONS(111),
    [anon_sym_PLUS_EQ] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(111),
    [anon_sym_PIPE_EQ] = ACTIONS(111),
    [anon_sym_DASH_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(121),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2201] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2202] = {
    [sym_arrow_function] = STATE(93),
    [sym_await_expression] = STATE(93),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_update_expression] = STATE(93),
    [sym_meta_property] = STATE(93),
    [sym__expression] = STATE(93),
    [sym_function] = STATE(52),
    [sym_import] = STATE(93),
    [sym_call_expression] = STATE(93),
    [sym_subscript_expression] = STATE(53),
    [sym__call_signature] = STATE(58),
    [sym_ternary_expression] = STATE(93),
    [sym_string] = STATE(93),
    [sym_template_string] = STATE(93),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(93),
    [sym_object] = STATE(64),
    [sym_type_assertion] = STATE(93),
    [sym_generator_function] = STATE(93),
    [sym_new_expression] = STATE(93),
    [sym_assignment_expression] = STATE(93),
    [sym_augmented_assignment_expression] = STATE(93),
    [sym_binary_expression] = STATE(93),
    [sym_unary_expression] = STATE(93),
    [sym_regex] = STATE(93),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(53),
    [sym_non_null_expression] = STATE(93),
    [sym_as_expression] = STATE(93),
    [sym_array] = STATE(54),
    [sym_internal_module] = STATE(93),
    [sym_class] = STATE(93),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(169),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [sym_null] = ACTIONS(169),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(151),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(169),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(169),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(177),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [2203] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1800),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(183),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_enum] = ACTIONS(5191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(5193),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(5195),
    [sym_comment] = ACTIONS(3),
  },
  [2206] = {
    [sym_parenthesized_expression] = STATE(1805),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2207] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(229),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2208] = {
    [sym__for_header] = STATE(1807),
    [anon_sym_LPAREN] = ACTIONS(5197),
    [sym_comment] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(5199),
  },
  [2209] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2210] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(153),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(152),
    [sym_type_parameters] = STATE(154),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(5201),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2211] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2532),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_global] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4728),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4730),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5203),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_declare] = ACTIONS(4724),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4732),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4726),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2212] = {
    [sym__parameter_name] = STATE(203),
    [sym_await_expression] = STATE(2063),
    [sym_update_expression] = STATE(2063),
    [sym_meta_property] = STATE(2063),
    [sym__expression] = STATE(2063),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2063),
    [sym_call_expression] = STATE(2063),
    [sym_ternary_expression] = STATE(2063),
    [sym_template_string] = STATE(2063),
    [sym_yield_expression] = STATE(2063),
    [sym_type_assertion] = STATE(2063),
    [sym_required_parameter] = STATE(202),
    [sym_new_expression] = STATE(2063),
    [sym_assignment_expression] = STATE(2063),
    [sym_binary_expression] = STATE(2063),
    [sym_rest_parameter] = STATE(202),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_array] = STATE(209),
    [sym_as_expression] = STATE(2063),
    [sym_internal_module] = STATE(2063),
    [sym_optional_parameter] = STATE(202),
    [sym_arrow_function] = STATE(2063),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(2062),
    [sym__call_signature] = STATE(1792),
    [sym_subscript_expression] = STATE(1251),
    [sym_string] = STATE(2063),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(206),
    [sym_accessibility_modifier] = STATE(207),
    [sym_generator_function] = STATE(2063),
    [sym_augmented_assignment_expression] = STATE(2063),
    [sym_unary_expression] = STATE(2063),
    [sym_regex] = STATE(2063),
    [aux_sym_export_statement_repeat1] = STATE(208),
    [sym_non_null_expression] = STATE(2063),
    [sym_class] = STATE(2063),
    [sym_identifier] = ACTIONS(407),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(409),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(413),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(409),
    [anon_sym_get] = ACTIONS(409),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(417),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(4809),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_set] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(409),
    [anon_sym_import] = ACTIONS(287),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(423),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4809),
    [anon_sym_module] = ACTIONS(409),
    [anon_sym_number] = ACTIONS(409),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(409),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4809),
    [anon_sym_any] = ACTIONS(409),
    [anon_sym_boolean] = ACTIONS(409),
    [anon_sym_async] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(409),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4809),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [2213] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(214),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_symbol] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(137),
    [anon_sym_void] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(435),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_number] = ACTIONS(435),
    [anon_sym_declare] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_boolean] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_string] = ACTIONS(435),
    [anon_sym_function] = ACTIONS(5207),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2214] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1838),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2215] = {
    [sym_parenthesized_expression] = STATE(1839),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2216] = {
    [sym_regex_pattern] = ACTIONS(5209),
    [sym_comment] = ACTIONS(255),
  },
  [2217] = {
    [sym_object] = STATE(98),
    [sym_variable_declarator] = STATE(1800),
    [sym_array] = STATE(100),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(161),
  },
  [2218] = {
    [sym_class_declaration] = STATE(264),
    [sym_generator_function_declaration] = STATE(264),
    [sym__declaration] = STATE(264),
    [sym_enum_declaration] = STATE(264),
    [sym_function_signature] = STATE(264),
    [sym_abstract_class_declaration] = STATE(264),
    [sym_module] = STATE(264),
    [sym_interface_declaration] = STATE(264),
    [sym_function_declaration] = STATE(264),
    [sym_export_clause] = STATE(265),
    [sym_variable_declaration] = STATE(264),
    [sym_lexical_declaration] = STATE(264),
    [sym_ambient_declaration] = STATE(264),
    [sym_import_alias] = STATE(264),
    [sym_type_alias_declaration] = STATE(264),
    [aux_sym_export_statement_repeat1] = STATE(2532),
    [sym_internal_module] = STATE(264),
    [sym_decorator] = STATE(63),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(133),
    [anon_sym_AMP_EQ] = ACTIONS(133),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(133),
    [anon_sym_PIPE_EQ] = ACTIONS(133),
    [anon_sym_DASH_EQ] = ACTIONS(133),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(531),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_LT_LT_EQ] = ACTIONS(133),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(4596),
    [anon_sym_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_abstract] = ACTIONS(4728),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(133),
    [anon_sym_namespace] = ACTIONS(4730),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(4720),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(133),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_declare] = ACTIONS(4724),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(133),
    [anon_sym_async] = ACTIONS(4732),
    [anon_sym_EQ_GT] = ACTIONS(141),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(133),
    [anon_sym_function] = ACTIONS(4726),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2219] = {
    [sym_parenthesized_expression] = STATE(1856),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2220] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5211),
    [anon_sym_class] = ACTIONS(5213),
    [sym_comment] = ACTIONS(3),
  },
  [2221] = {
    [sym_arrow_function] = STATE(1860),
    [sym_await_expression] = STATE(1860),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(293),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1860),
    [sym_meta_property] = STATE(1860),
    [sym__expression] = STATE(1860),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1860),
    [sym_call_expression] = STATE(1860),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1860),
    [sym_string] = STATE(1860),
    [sym_template_string] = STATE(1860),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1860),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1860),
    [sym_generator_function] = STATE(1860),
    [sym_new_expression] = STATE(1860),
    [sym_assignment_expression] = STATE(1860),
    [sym_augmented_assignment_expression] = STATE(1860),
    [sym_binary_expression] = STATE(1860),
    [sym_unary_expression] = STATE(1860),
    [sym_regex] = STATE(1860),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1860),
    [sym_as_expression] = STATE(1860),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1860),
    [sym_class] = STATE(1860),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5215),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5215),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5215),
    [sym_number] = ACTIONS(5217),
    [sym_true] = ACTIONS(5215),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5215),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2222] = {
    [sym_arrow_function] = STATE(1861),
    [sym_await_expression] = STATE(1861),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1861),
    [sym_meta_property] = STATE(1861),
    [sym__expression] = STATE(1861),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1861),
    [sym_call_expression] = STATE(1861),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1861),
    [sym_string] = STATE(1861),
    [sym_template_string] = STATE(1861),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1861),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1861),
    [sym_generator_function] = STATE(1861),
    [sym_new_expression] = STATE(1861),
    [sym_assignment_expression] = STATE(1861),
    [sym_augmented_assignment_expression] = STATE(1861),
    [sym_binary_expression] = STATE(1861),
    [sym_unary_expression] = STATE(1861),
    [sym_regex] = STATE(1861),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1861),
    [sym_as_expression] = STATE(1861),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1861),
    [sym_class] = STATE(1861),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5219),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5219),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5219),
    [sym_number] = ACTIONS(5221),
    [sym_true] = ACTIONS(5219),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5219),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2223] = {
    [sym_arrow_function] = STATE(1862),
    [sym_await_expression] = STATE(1862),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1862),
    [sym_meta_property] = STATE(1862),
    [sym__expression] = STATE(1862),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1862),
    [sym_call_expression] = STATE(1862),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1862),
    [sym_string] = STATE(1862),
    [sym_template_string] = STATE(1862),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1862),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1862),
    [sym_generator_function] = STATE(1862),
    [sym_new_expression] = STATE(1862),
    [sym_assignment_expression] = STATE(1862),
    [sym_augmented_assignment_expression] = STATE(1862),
    [sym_binary_expression] = STATE(1862),
    [sym_unary_expression] = STATE(1862),
    [sym_regex] = STATE(1862),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1862),
    [sym_as_expression] = STATE(1862),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1862),
    [sym_class] = STATE(1862),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5223),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5223),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5223),
    [sym_number] = ACTIONS(5225),
    [sym_true] = ACTIONS(5223),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5223),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2224] = {
    [sym_arrow_function] = STATE(1863),
    [sym_await_expression] = STATE(1863),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(303),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1863),
    [sym_meta_property] = STATE(1863),
    [sym__expression] = STATE(1863),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1863),
    [sym_call_expression] = STATE(1863),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1863),
    [sym_string] = STATE(1863),
    [sym_template_string] = STATE(1863),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1863),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1863),
    [sym_generator_function] = STATE(1863),
    [sym_new_expression] = STATE(1863),
    [sym_assignment_expression] = STATE(1863),
    [sym_augmented_assignment_expression] = STATE(1863),
    [sym_binary_expression] = STATE(1863),
    [sym_unary_expression] = STATE(1863),
    [sym_regex] = STATE(1863),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1863),
    [sym_as_expression] = STATE(1863),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1863),
    [sym_class] = STATE(1863),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5227),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5227),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5227),
    [sym_number] = ACTIONS(5229),
    [sym_true] = ACTIONS(5227),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5227),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2225] = {
    [sym_arrow_function] = STATE(1864),
    [sym_await_expression] = STATE(1864),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1864),
    [sym_meta_property] = STATE(1864),
    [sym__expression] = STATE(1864),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1864),
    [sym_call_expression] = STATE(1864),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1864),
    [sym_string] = STATE(1864),
    [sym_template_string] = STATE(1864),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1864),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1864),
    [sym_generator_function] = STATE(1864),
    [sym_new_expression] = STATE(1864),
    [sym_assignment_expression] = STATE(1864),
    [sym_augmented_assignment_expression] = STATE(1864),
    [sym_binary_expression] = STATE(1864),
    [sym_unary_expression] = STATE(1864),
    [sym_regex] = STATE(1864),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1864),
    [sym_as_expression] = STATE(1864),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1864),
    [sym_class] = STATE(1864),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5231),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5231),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5231),
    [sym_number] = ACTIONS(5233),
    [sym_true] = ACTIONS(5231),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5231),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2226] = {
    [sym_arrow_function] = STATE(1865),
    [sym_await_expression] = STATE(1865),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1865),
    [sym_meta_property] = STATE(1865),
    [sym__expression] = STATE(1865),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1865),
    [sym_call_expression] = STATE(1865),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1865),
    [sym_string] = STATE(1865),
    [sym_template_string] = STATE(1865),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1865),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1865),
    [sym_generator_function] = STATE(1865),
    [sym_new_expression] = STATE(1865),
    [sym_assignment_expression] = STATE(1865),
    [sym_augmented_assignment_expression] = STATE(1865),
    [sym_binary_expression] = STATE(1865),
    [sym_unary_expression] = STATE(1865),
    [sym_regex] = STATE(1865),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1865),
    [sym_as_expression] = STATE(1865),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1865),
    [sym_class] = STATE(1865),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5235),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5235),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5235),
    [sym_number] = ACTIONS(5237),
    [sym_true] = ACTIONS(5235),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5235),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2227] = {
    [sym_arguments] = STATE(309),
    [anon_sym_LBRACK] = ACTIONS(689),
    [sym_identifier] = ACTIONS(5239),
    [anon_sym_module] = ACTIONS(5239),
    [anon_sym_symbol] = ACTIONS(5239),
    [anon_sym_number] = ACTIONS(5239),
    [anon_sym_class] = ACTIONS(5239),
    [anon_sym_AT] = ACTIONS(689),
    [anon_sym_declare] = ACTIONS(5239),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_STAR] = ACTIONS(689),
    [anon_sym_void] = ACTIONS(5239),
    [anon_sym_LPAREN] = ACTIONS(5241),
    [anon_sym_any] = ACTIONS(5239),
    [anon_sym_private] = ACTIONS(5239),
    [anon_sym_boolean] = ACTIONS(5239),
    [anon_sym_static] = ACTIONS(5239),
    [anon_sym_public] = ACTIONS(5239),
    [anon_sym_get] = ACTIONS(5239),
    [anon_sym_async] = ACTIONS(5239),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_SQUOTE] = ACTIONS(689),
    [sym_this] = ACTIONS(5239),
    [sym_number] = ACTIONS(689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5239),
    [anon_sym_string] = ACTIONS(5239),
    [anon_sym_abstract] = ACTIONS(5239),
    [anon_sym_DOT] = ACTIONS(5243),
    [anon_sym_set] = ACTIONS(5239),
    [anon_sym_type] = ACTIONS(5239),
    [anon_sym_export] = ACTIONS(5239),
    [sym_readonly] = ACTIONS(5239),
    [anon_sym_namespace] = ACTIONS(5239),
    [anon_sym_DQUOTE] = ACTIONS(689),
  },
  [2228] = {
    [sym_arguments] = STATE(311),
    [anon_sym_LBRACK] = ACTIONS(693),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_module] = ACTIONS(695),
    [anon_sym_symbol] = ACTIONS(695),
    [anon_sym_number] = ACTIONS(695),
    [anon_sym_class] = ACTIONS(695),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_declare] = ACTIONS(695),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(693),
    [anon_sym_STAR] = ACTIONS(693),
    [anon_sym_void] = ACTIONS(695),
    [anon_sym_LPAREN] = ACTIONS(5241),
    [anon_sym_any] = ACTIONS(695),
    [anon_sym_private] = ACTIONS(695),
    [anon_sym_boolean] = ACTIONS(695),
    [anon_sym_static] = ACTIONS(695),
    [anon_sym_public] = ACTIONS(695),
    [anon_sym_get] = ACTIONS(695),
    [anon_sym_async] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_SQUOTE] = ACTIONS(693),
    [sym_this] = ACTIONS(695),
    [sym_number] = ACTIONS(693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(695),
    [anon_sym_DOT] = ACTIONS(5245),
    [anon_sym_set] = ACTIONS(695),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_export] = ACTIONS(695),
    [sym_readonly] = ACTIONS(695),
    [anon_sym_namespace] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(693),
  },
  [2229] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_EQ_GT] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2230] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2231] = {
    [sym_arrow_function] = STATE(2237),
    [sym_await_expression] = STATE(2237),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2237),
    [sym_meta_property] = STATE(2237),
    [sym__expression] = STATE(2237),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2237),
    [sym_call_expression] = STATE(2237),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2237),
    [sym_string] = STATE(2237),
    [sym_template_string] = STATE(2237),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2237),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2237),
    [sym_generator_function] = STATE(2237),
    [sym_new_expression] = STATE(2237),
    [sym_assignment_expression] = STATE(2237),
    [sym_augmented_assignment_expression] = STATE(2237),
    [sym_binary_expression] = STATE(2237),
    [sym_unary_expression] = STATE(2237),
    [sym_regex] = STATE(2237),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2237),
    [sym_as_expression] = STATE(2237),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2237),
    [sym_class] = STATE(2237),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(4575),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_true] = ACTIONS(4575),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(4575),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4575),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(4579),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4575),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(1430),
  },
  [2232] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5247),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_symbol] = ACTIONS(5249),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_void] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_private] = ACTIONS(5249),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_static] = ACTIONS(5249),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_get] = ACTIONS(5249),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5249),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(5249),
    [anon_sym_type] = ACTIONS(5249),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_namespace] = ACTIONS(5249),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5249),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_number] = ACTIONS(5249),
    [anon_sym_declare] = ACTIONS(5249),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5249),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_boolean] = ACTIONS(5249),
    [anon_sym_async] = ACTIONS(5249),
    [anon_sym_public] = ACTIONS(5249),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_string] = ACTIONS(5249),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2233] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1852),
    [sym_identifier] = ACTIONS(5251),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(5253),
    [sym_comment] = ACTIONS(3),
  },
  [2234] = {
    [sym_string] = STATE(1586),
    [sym_nested_identifier] = STATE(1585),
    [sym__module] = STATE(1278),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym__automatic_semicolon] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [sym_identifier] = ACTIONS(721),
    [anon_sym_PERCENT_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_AMP_EQ] = ACTIONS(4569),
    [anon_sym_PLUS_EQ] = ACTIONS(4569),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(4571),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4569),
    [anon_sym_STAR_EQ] = ACTIONS(4569),
    [anon_sym_PIPE_EQ] = ACTIONS(4569),
    [anon_sym_DASH_EQ] = ACTIONS(4569),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(4569),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT_EQ] = ACTIONS(4569),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4569),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2235] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(725),
  },
  [2236] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(5258),
    [sym_comment] = ACTIONS(3),
  },
  [2237] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(5260),
    [sym_comment] = ACTIONS(3),
  },
  [2239] = {
    [sym_arrow_function] = STATE(1876),
    [sym_await_expression] = STATE(1876),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(1875),
    [sym_meta_property] = STATE(1876),
    [sym_update_expression] = STATE(1876),
    [sym__expression] = STATE(1876),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1876),
    [sym_call_expression] = STATE(1876),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1876),
    [sym_string] = STATE(1876),
    [sym_template_string] = STATE(1876),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1876),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1876),
    [sym_generator_function] = STATE(1876),
    [sym_new_expression] = STATE(1876),
    [sym_assignment_expression] = STATE(1876),
    [sym_augmented_assignment_expression] = STATE(1876),
    [sym_binary_expression] = STATE(1876),
    [sym_unary_expression] = STATE(1876),
    [sym_regex] = STATE(1876),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1876),
    [sym_as_expression] = STATE(1876),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1876),
    [sym_class] = STATE(1876),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(5262),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(5262),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5262),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5262),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5264),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5262),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [2240] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1850),
    [sym_function_type] = STATE(1850),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1850),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1850),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1850),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2241] = {
    [sym_arrow_function] = STATE(205),
    [sym_await_expression] = STATE(205),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(204),
    [sym_meta_property] = STATE(205),
    [sym_update_expression] = STATE(205),
    [sym__expression] = STATE(205),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(205),
    [sym_call_expression] = STATE(205),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(205),
    [sym_string] = STATE(205),
    [sym_template_string] = STATE(205),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(205),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(205),
    [sym_generator_function] = STATE(205),
    [sym_new_expression] = STATE(205),
    [sym_assignment_expression] = STATE(205),
    [sym_augmented_assignment_expression] = STATE(205),
    [sym_binary_expression] = STATE(205),
    [sym_unary_expression] = STATE(205),
    [sym_regex] = STATE(205),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(205),
    [sym_as_expression] = STATE(205),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(205),
    [sym_class] = STATE(205),
    [anon_sym_await] = ACTIONS(319),
    [sym_identifier] = ACTIONS(265),
    [sym_false] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(419),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(419),
    [sym_number] = ACTIONS(431),
    [sym_true] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(285),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(419),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
  },
  [2242] = {
    [sym_arrow_function] = STATE(1883),
    [sym_await_expression] = STATE(1883),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1883),
    [sym_meta_property] = STATE(1883),
    [sym__expression] = STATE(1883),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1883),
    [sym_call_expression] = STATE(1883),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1883),
    [sym_string] = STATE(1883),
    [sym_template_string] = STATE(1883),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1883),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1883),
    [sym_generator_function] = STATE(1883),
    [sym_new_expression] = STATE(1883),
    [sym_assignment_expression] = STATE(1883),
    [sym_augmented_assignment_expression] = STATE(1883),
    [sym_binary_expression] = STATE(1883),
    [sym_unary_expression] = STATE(1883),
    [sym_regex] = STATE(1883),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1883),
    [sym_as_expression] = STATE(1883),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1883),
    [sym_class] = STATE(1883),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5266),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5266),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5266),
    [sym_number] = ACTIONS(5268),
    [sym_true] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5266),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2243] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(798),
    [anon_sym_SEMI] = ACTIONS(798),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
  },
  [2245] = {
    [sym_statement_block] = STATE(372),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_DOT] = ACTIONS(2764),
    [anon_sym_PIPE_RBRACE] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2246] = {
    [sym_statement_block] = STATE(372),
    [sym__automatic_semicolon] = ACTIONS(830),
    [anon_sym_RBRACE] = ACTIONS(830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_COMMA] = ACTIONS(830),
    [anon_sym_PIPE_RBRACE] = ACTIONS(830),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2247] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5255),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [2248] = {
    [sym__for_header] = STATE(1886),
    [anon_sym_LPAREN] = ACTIONS(866),
    [sym_comment] = ACTIONS(3),
  },
  [2249] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(5272),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(5274),
    [sym_comment] = ACTIONS(3),
  },
  [2251] = {
    [sym_class_declaration] = STATE(164),
    [sym_generator_function_declaration] = STATE(164),
    [sym__declaration] = STATE(164),
    [sym_enum_declaration] = STATE(164),
    [sym_function_signature] = STATE(164),
    [sym_abstract_class_declaration] = STATE(164),
    [sym_module] = STATE(164),
    [sym_interface_declaration] = STATE(164),
    [sym_function_declaration] = STATE(164),
    [sym_variable_declaration] = STATE(164),
    [sym_lexical_declaration] = STATE(164),
    [sym_ambient_declaration] = STATE(164),
    [sym_import_alias] = STATE(164),
    [sym_type_alias_declaration] = STATE(164),
    [aux_sym_export_statement_repeat1] = STATE(2532),
    [sym_internal_module] = STATE(164),
    [sym_decorator] = STATE(63),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(347),
    [anon_sym_module] = ACTIONS(5203),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4724),
    [anon_sym_global] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4726),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(4728),
    [anon_sym_type] = ACTIONS(351),
    [anon_sym_let] = ACTIONS(369),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_namespace] = ACTIONS(4730),
    [anon_sym_async] = ACTIONS(4732),
  },
  [2252] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5276),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2253] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1906),
    [sym_function_type] = STATE(1906),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1906),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1906),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1906),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2254] = {
    [sym_formal_parameters] = STATE(1907),
    [sym_type_parameters] = STATE(2296),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2255] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1910),
    [sym_function_type] = STATE(1910),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1910),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_object] = STATE(482),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(1910),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1910),
    [aux_sym_export_statement_repeat1] = STATE(486),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(483),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_this] = ACTIONS(1300),
    [sym_true] = ACTIONS(457),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(457),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_export] = ACTIONS(1197),
  },
  [2256] = {
    [anon_sym_DOT] = ACTIONS(4336),
    [sym_comment] = ACTIONS(3),
  },
  [2257] = {
    [sym_formal_parameters] = STATE(1914),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2258] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1915),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2259] = {
    [sym_arguments] = STATE(554),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [sym__automatic_semicolon] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1340),
  },
  [2260] = {
    [sym_arguments] = STATE(556),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2261] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(556),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(171),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(525),
  },
  [2262] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(556),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2536),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(5247),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(5249),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(5249),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(5249),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(5249),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(5249),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(5249),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_set] = ACTIONS(5249),
    [anon_sym_type] = ACTIONS(5249),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(5249),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(5249),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(5249),
    [anon_sym_declare] = ACTIONS(5249),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(5249),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(5249),
    [anon_sym_async] = ACTIONS(5249),
    [anon_sym_public] = ACTIONS(5249),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(5249),
    [anon_sym_function] = ACTIONS(715),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(5249),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2263] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(556),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym__automatic_semicolon] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_SEMI] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(4573),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(139),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2264] = {
    [sym_nested_identifier] = STATE(1276),
    [sym_string] = STATE(1277),
    [sym__module] = STATE(144),
    [sym_identifier] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(309),
  },
  [2265] = {
    [sym__from_clause] = STATE(1917),
    [anon_sym_from] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
  },
  [2266] = {
    [sym_arrow_function] = STATE(1918),
    [sym_await_expression] = STATE(1918),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1918),
    [sym_meta_property] = STATE(1918),
    [sym__expression] = STATE(1918),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1918),
    [sym_call_expression] = STATE(1918),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1918),
    [sym_string] = STATE(1918),
    [sym_template_string] = STATE(1918),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1918),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1918),
    [sym_generator_function] = STATE(1918),
    [sym_new_expression] = STATE(1918),
    [sym_assignment_expression] = STATE(1918),
    [sym_augmented_assignment_expression] = STATE(1918),
    [sym_binary_expression] = STATE(1918),
    [sym_unary_expression] = STATE(1918),
    [sym_regex] = STATE(1918),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1918),
    [sym_as_expression] = STATE(1918),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1918),
    [sym_class] = STATE(1918),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5278),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5278),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5278),
    [sym_number] = ACTIONS(5280),
    [sym_true] = ACTIONS(5278),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5278),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2267] = {
    [sym_arguments] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(104),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2551),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(1442),
    [anon_sym_SEMI] = ACTIONS(1442),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(2555),
    [anon_sym_LT_LT] = ACTIONS(2557),
    [anon_sym_DASH] = ACTIONS(2559),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_GT_GT_GT] = ACTIONS(2557),
    [anon_sym_AMP_AMP] = ACTIONS(2563),
    [anon_sym_BANG_EQ] = ACTIONS(2565),
    [anon_sym_LT_EQ] = ACTIONS(2551),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2551),
    [anon_sym_GT] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_PERCENT] = ACTIONS(2557),
    [anon_sym_QMARK] = ACTIONS(2569),
    [anon_sym_as] = ACTIONS(601),
    [anon_sym_PIPE_PIPE] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(603),
    [anon_sym_EQ_EQ] = ACTIONS(2565),
    [anon_sym_instanceof] = ACTIONS(2551),
    [anon_sym_LT] = ACTIONS(2573),
    [anon_sym_SLASH] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2559),
    [anon_sym_GT_GT] = ACTIONS(2561),
    [anon_sym_PLUS_PLUS] = ACTIONS(603),
    [anon_sym_in] = ACTIONS(2565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2551),
    [anon_sym_BANG] = ACTIONS(609),
  },
  [2268] = {
    [sym_arrow_function] = STATE(1919),
    [sym_await_expression] = STATE(1919),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1919),
    [sym_meta_property] = STATE(1919),
    [sym__expression] = STATE(1919),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1919),
    [sym_string] = STATE(1919),
    [sym_template_string] = STATE(1919),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1919),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1919),
    [sym_generator_function] = STATE(1919),
    [sym_new_expression] = STATE(1919),
    [sym_assignment_expression] = STATE(1919),
    [sym_augmented_assignment_expression] = STATE(1919),
    [sym_binary_expression] = STATE(1919),
    [sym_unary_expression] = STATE(1919),
    [sym_regex] = STATE(1919),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1919),
    [sym_as_expression] = STATE(1919),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1919),
    [sym_class] = STATE(1919),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(4712),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4712),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(4712),
    [sym_number] = ACTIONS(5282),
    [sym_true] = ACTIONS(4712),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4712),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2269] = {
    [sym_arrow_function] = STATE(1920),
    [sym_await_expression] = STATE(1920),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1920),
    [sym_meta_property] = STATE(1920),
    [sym__expression] = STATE(1920),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1920),
    [sym_call_expression] = STATE(1920),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1920),
    [sym_string] = STATE(1920),
    [sym_template_string] = STATE(1920),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1920),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1920),
    [sym_generator_function] = STATE(1920),
    [sym_new_expression] = STATE(1920),
    [sym_assignment_expression] = STATE(1920),
    [sym_augmented_assignment_expression] = STATE(1920),
    [sym_binary_expression] = STATE(1920),
    [sym_unary_expression] = STATE(1920),
    [sym_regex] = STATE(1920),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1920),
    [sym_as_expression] = STATE(1920),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1920),
    [sym_class] = STATE(1920),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5284),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5284),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5284),
    [sym_number] = ACTIONS(5286),
    [sym_true] = ACTIONS(5284),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5284),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2270] = {
    [sym_arrow_function] = STATE(1921),
    [sym_await_expression] = STATE(1921),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1921),
    [sym_meta_property] = STATE(1921),
    [sym__expression] = STATE(1921),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1921),
    [sym_call_expression] = STATE(1921),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1921),
    [sym_string] = STATE(1921),
    [sym_template_string] = STATE(1921),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1921),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1921),
    [sym_generator_function] = STATE(1921),
    [sym_new_expression] = STATE(1921),
    [sym_assignment_expression] = STATE(1921),
    [sym_augmented_assignment_expression] = STATE(1921),
    [sym_binary_expression] = STATE(1921),
    [sym_unary_expression] = STATE(1921),
    [sym_regex] = STATE(1921),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1921),
    [sym_as_expression] = STATE(1921),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1921),
    [sym_class] = STATE(1921),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5288),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5288),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5288),
    [sym_number] = ACTIONS(5290),
    [sym_true] = ACTIONS(5288),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5288),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2271] = {
    [sym_arrow_function] = STATE(1922),
    [sym_await_expression] = STATE(1922),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1922),
    [sym_meta_property] = STATE(1922),
    [sym__expression] = STATE(1922),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1922),
    [sym_call_expression] = STATE(1922),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1922),
    [sym_string] = STATE(1922),
    [sym_template_string] = STATE(1922),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1922),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1922),
    [sym_generator_function] = STATE(1922),
    [sym_new_expression] = STATE(1922),
    [sym_assignment_expression] = STATE(1922),
    [sym_augmented_assignment_expression] = STATE(1922),
    [sym_binary_expression] = STATE(1922),
    [sym_unary_expression] = STATE(1922),
    [sym_regex] = STATE(1922),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1922),
    [sym_as_expression] = STATE(1922),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1922),
    [sym_class] = STATE(1922),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5292),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5292),
    [sym_number] = ACTIONS(5294),
    [sym_true] = ACTIONS(5292),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5292),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2272] = {
    [sym_arrow_function] = STATE(1923),
    [sym_await_expression] = STATE(1923),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1923),
    [sym_meta_property] = STATE(1923),
    [sym__expression] = STATE(1923),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1923),
    [sym_call_expression] = STATE(1923),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1923),
    [sym_string] = STATE(1923),
    [sym_template_string] = STATE(1923),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1923),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1923),
    [sym_generator_function] = STATE(1923),
    [sym_new_expression] = STATE(1923),
    [sym_assignment_expression] = STATE(1923),
    [sym_augmented_assignment_expression] = STATE(1923),
    [sym_binary_expression] = STATE(1923),
    [sym_unary_expression] = STATE(1923),
    [sym_regex] = STATE(1923),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1923),
    [sym_as_expression] = STATE(1923),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1923),
    [sym_class] = STATE(1923),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5296),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5296),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5296),
    [sym_number] = ACTIONS(5298),
    [sym_true] = ACTIONS(5296),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5296),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2273] = {
    [sym_arrow_function] = STATE(1924),
    [sym_await_expression] = STATE(1924),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1924),
    [sym_meta_property] = STATE(1924),
    [sym__expression] = STATE(1924),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1924),
    [sym_call_expression] = STATE(1924),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1924),
    [sym_string] = STATE(1924),
    [sym_template_string] = STATE(1924),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1924),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(1924),
    [sym_generator_function] = STATE(1924),
    [sym_new_expression] = STATE(1924),
    [sym_assignment_expression] = STATE(1924),
    [sym_augmented_assignment_expression] = STATE(1924),
    [sym_binary_expression] = STATE(1924),
    [sym_unary_expression] = STATE(1924),
    [sym_regex] = STATE(1924),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(1924),
    [sym_as_expression] = STATE(1924),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(1924),
    [sym_class] = STATE(1924),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5300),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5300),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5300),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5300),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5302),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5300),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2274] = {
    [sym_arrow_function] = STATE(1927),
    [sym_await_expression] = STATE(1927),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1927),
    [sym_meta_property] = STATE(1927),
    [sym__expression] = STATE(1927),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1927),
    [sym_call_expression] = STATE(1927),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1927),
    [sym_string] = STATE(1927),
    [sym_template_string] = STATE(1927),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1927),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1927),
    [sym_generator_function] = STATE(1927),
    [sym_new_expression] = STATE(1927),
    [sym_assignment_expression] = STATE(1927),
    [sym_augmented_assignment_expression] = STATE(1927),
    [sym_binary_expression] = STATE(1927),
    [sym_unary_expression] = STATE(1927),
    [sym_regex] = STATE(1927),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1927),
    [sym_as_expression] = STATE(1927),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1927),
    [sym_class] = STATE(1927),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5304),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5304),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5304),
    [sym_number] = ACTIONS(5306),
    [sym_true] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5304),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2275] = {
    [sym_arrow_function] = STATE(1928),
    [sym_await_expression] = STATE(1928),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1928),
    [sym_meta_property] = STATE(1928),
    [sym__expression] = STATE(1928),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1928),
    [sym_call_expression] = STATE(1928),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1928),
    [sym_string] = STATE(1928),
    [sym_template_string] = STATE(1928),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1928),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1928),
    [sym_generator_function] = STATE(1928),
    [sym_new_expression] = STATE(1928),
    [sym_assignment_expression] = STATE(1928),
    [sym_augmented_assignment_expression] = STATE(1928),
    [sym_binary_expression] = STATE(1928),
    [sym_unary_expression] = STATE(1928),
    [sym_regex] = STATE(1928),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1928),
    [sym_as_expression] = STATE(1928),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1928),
    [sym_class] = STATE(1928),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5308),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5308),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5308),
    [sym_number] = ACTIONS(5310),
    [sym_true] = ACTIONS(5308),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5308),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2276] = {
    [sym_arrow_function] = STATE(1929),
    [sym_await_expression] = STATE(1929),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(591),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1929),
    [sym_meta_property] = STATE(1929),
    [sym__expression] = STATE(1929),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1929),
    [sym_call_expression] = STATE(1929),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1929),
    [sym_string] = STATE(1929),
    [sym_template_string] = STATE(1929),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1929),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1929),
    [sym_generator_function] = STATE(1929),
    [sym_new_expression] = STATE(1929),
    [sym_assignment_expression] = STATE(1929),
    [sym_augmented_assignment_expression] = STATE(1929),
    [sym_binary_expression] = STATE(1929),
    [sym_unary_expression] = STATE(1929),
    [sym_regex] = STATE(1929),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1929),
    [sym_as_expression] = STATE(1929),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1929),
    [sym_class] = STATE(1929),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5312),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5312),
    [sym_number] = ACTIONS(5314),
    [sym_true] = ACTIONS(5312),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5312),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2277] = {
    [sym_arrow_function] = STATE(1930),
    [sym_await_expression] = STATE(1930),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1930),
    [sym_meta_property] = STATE(1930),
    [sym__expression] = STATE(1930),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1930),
    [sym_call_expression] = STATE(1930),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1930),
    [sym_string] = STATE(1930),
    [sym_template_string] = STATE(1930),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1930),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1930),
    [sym_generator_function] = STATE(1930),
    [sym_new_expression] = STATE(1930),
    [sym_assignment_expression] = STATE(1930),
    [sym_augmented_assignment_expression] = STATE(1930),
    [sym_binary_expression] = STATE(1930),
    [sym_unary_expression] = STATE(1930),
    [sym_regex] = STATE(1930),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1930),
    [sym_as_expression] = STATE(1930),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1930),
    [sym_class] = STATE(1930),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5316),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5316),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5316),
    [sym_number] = ACTIONS(5318),
    [sym_true] = ACTIONS(5316),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5316),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2278] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(599),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(420),
    [sym_type_parameters] = STATE(600),
    [anon_sym_extends] = ACTIONS(331),
    [sym_identifier] = ACTIONS(5320),
    [anon_sym_implements] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(339),
  },
  [2279] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1902),
    [sym_identifier] = ACTIONS(5322),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(5324),
    [sym_comment] = ACTIONS(3),
  },
  [2280] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1936),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2281] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1916),
    [sym_identifier] = ACTIONS(5326),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2282] = {
    [anon_sym_else] = ACTIONS(5328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1861),
  },
  [2283] = {
    [sym_implements_clause] = STATE(150),
    [sym_class_heritage] = STATE(2306),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(633),
    [sym_type_parameters] = STATE(2307),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [2284] = {
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1945),
    [sym_function_type] = STATE(1945),
    [sym_constructor_type] = STATE(1945),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_nested_identifier] = STATE(2397),
    [sym_predefined_type] = STATE(1596),
    [sym_nested_type_identifier] = STATE(1597),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1945),
    [sym__type] = STATE(1945),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_symbol] = ACTIONS(1879),
    [sym_this] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1881),
    [sym_true] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_keyof] = ACTIONS(1883),
    [sym_number] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_boolean] = ACTIONS(1879),
  },
  [2285] = {
    [sym_identifier] = ACTIONS(5330),
    [sym_comment] = ACTIONS(3),
  },
  [2286] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1954),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2287] = {
    [anon_sym_EQ] = ACTIONS(5332),
    [sym_comment] = ACTIONS(3),
  },
  [2288] = {
    [sym_identifier] = ACTIONS(5334),
    [sym_comment] = ACTIONS(3),
  },
  [2289] = {
    [sym_arrow_function] = STATE(685),
    [sym_await_expression] = STATE(685),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(685),
    [sym_meta_property] = STATE(685),
    [sym__expression] = STATE(685),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(685),
    [sym_call_expression] = STATE(685),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(685),
    [sym_string] = STATE(685),
    [sym_template_string] = STATE(685),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(685),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(685),
    [sym_generator_function] = STATE(685),
    [sym_new_expression] = STATE(685),
    [sym_assignment_expression] = STATE(685),
    [sym_augmented_assignment_expression] = STATE(685),
    [sym_binary_expression] = STATE(685),
    [sym_unary_expression] = STATE(685),
    [sym_regex] = STATE(685),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(685),
    [sym_as_expression] = STATE(685),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(685),
    [sym_class] = STATE(685),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(2085),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(2085),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(2085),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(2091),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2290] = {
    [sym_arrow_function] = STATE(1959),
    [sym_await_expression] = STATE(1959),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(755),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1959),
    [sym_meta_property] = STATE(1959),
    [sym__expression] = STATE(1959),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1959),
    [sym_call_expression] = STATE(1959),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1959),
    [sym_string] = STATE(1959),
    [sym_template_string] = STATE(1959),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1959),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1959),
    [sym_generator_function] = STATE(1959),
    [sym_new_expression] = STATE(1959),
    [sym_assignment_expression] = STATE(1959),
    [sym_augmented_assignment_expression] = STATE(1959),
    [sym_binary_expression] = STATE(1959),
    [sym_unary_expression] = STATE(1959),
    [sym_regex] = STATE(1959),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1959),
    [sym_as_expression] = STATE(1959),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1959),
    [sym_class] = STATE(1959),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5336),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5336),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5336),
    [sym_number] = ACTIONS(5338),
    [sym_true] = ACTIONS(5336),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5336),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2291] = {
    [sym_arrow_function] = STATE(1960),
    [sym_await_expression] = STATE(1960),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(757),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1960),
    [sym_meta_property] = STATE(1960),
    [sym__expression] = STATE(1960),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1960),
    [sym_call_expression] = STATE(1960),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1960),
    [sym_string] = STATE(1960),
    [sym_template_string] = STATE(1960),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1960),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1960),
    [sym_generator_function] = STATE(1960),
    [sym_new_expression] = STATE(1960),
    [sym_assignment_expression] = STATE(1960),
    [sym_augmented_assignment_expression] = STATE(1960),
    [sym_binary_expression] = STATE(1960),
    [sym_unary_expression] = STATE(1960),
    [sym_regex] = STATE(1960),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1960),
    [sym_as_expression] = STATE(1960),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1960),
    [sym_class] = STATE(1960),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5340),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5340),
    [sym_number] = ACTIONS(5342),
    [sym_true] = ACTIONS(5340),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5340),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2292] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1961),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2293] = {
    [sym_arrow_function] = STATE(1963),
    [sym_await_expression] = STATE(1963),
    [sym_member_expression] = STATE(2521),
    [sym_statement_block] = STATE(763),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1963),
    [sym_meta_property] = STATE(1963),
    [sym__expression] = STATE(1963),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1963),
    [sym_call_expression] = STATE(1963),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1963),
    [sym_string] = STATE(1963),
    [sym_template_string] = STATE(1963),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1963),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1963),
    [sym_generator_function] = STATE(1963),
    [sym_new_expression] = STATE(1963),
    [sym_assignment_expression] = STATE(1963),
    [sym_augmented_assignment_expression] = STATE(1963),
    [sym_binary_expression] = STATE(1963),
    [sym_unary_expression] = STATE(1963),
    [sym_regex] = STATE(1963),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1963),
    [sym_as_expression] = STATE(1963),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1963),
    [sym_class] = STATE(1963),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5344),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5344),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5344),
    [sym_number] = ACTIONS(5346),
    [sym_true] = ACTIONS(5344),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5344),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2294] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(1910),
    [sym_function_type] = STATE(1910),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(1910),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(1910),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(1910),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2295] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(1964),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(1964),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(1964),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(1964),
    [sym_property_signature] = STATE(1964),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(1964),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(960),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2296] = {
    [sym_formal_parameters] = STATE(1968),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2297] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1976),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(5348),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [sym_arrow_function] = STATE(2237),
    [sym_await_expression] = STATE(2237),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2237),
    [sym_meta_property] = STATE(2237),
    [sym__expression] = STATE(2237),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2237),
    [sym_call_expression] = STATE(2237),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2237),
    [sym_string] = STATE(2237),
    [sym_template_string] = STATE(2237),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2237),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2237),
    [sym_generator_function] = STATE(2237),
    [sym_new_expression] = STATE(2237),
    [sym_assignment_expression] = STATE(2237),
    [sym_augmented_assignment_expression] = STATE(2237),
    [sym_binary_expression] = STATE(2237),
    [sym_unary_expression] = STATE(2237),
    [sym_regex] = STATE(2237),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2237),
    [sym_as_expression] = STATE(2237),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2237),
    [sym_class] = STATE(2237),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(5350),
    [sym_false] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4575),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(4575),
    [sym_number] = ACTIONS(4579),
    [sym_true] = ACTIONS(4575),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4575),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2300] = {
    [sym_arrow_function] = STATE(2235),
    [sym_await_expression] = STATE(2235),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2235),
    [sym_meta_property] = STATE(2235),
    [sym__expression] = STATE(2235),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2235),
    [sym_call_expression] = STATE(2235),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2235),
    [sym_string] = STATE(2235),
    [sym_template_string] = STATE(2235),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2235),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2235),
    [sym_generator_function] = STATE(2235),
    [sym_new_expression] = STATE(2235),
    [sym_assignment_expression] = STATE(2235),
    [sym_augmented_assignment_expression] = STATE(2235),
    [sym_binary_expression] = STATE(2235),
    [sym_unary_expression] = STATE(2235),
    [sym_regex] = STATE(2235),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2235),
    [sym_as_expression] = STATE(2235),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2235),
    [sym_class] = STATE(2235),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5352),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5352),
    [sym_number] = ACTIONS(2626),
    [sym_true] = ACTIONS(5352),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5352),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2301] = {
    [sym_arrow_function] = STATE(247),
    [sym_await_expression] = STATE(254),
    [sym_member_expression] = STATE(253),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(254),
    [sym_meta_property] = STATE(247),
    [sym__expression] = STATE(254),
    [sym_function] = STATE(255),
    [sym_import] = STATE(247),
    [sym_call_expression] = STATE(254),
    [sym_subscript_expression] = STATE(253),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(254),
    [sym_string] = STATE(247),
    [sym_template_string] = STATE(247),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(254),
    [sym_object] = STATE(256),
    [sym_type_assertion] = STATE(254),
    [sym_generator_function] = STATE(247),
    [sym_new_expression] = STATE(247),
    [sym_assignment_expression] = STATE(254),
    [sym_augmented_assignment_expression] = STATE(254),
    [sym_binary_expression] = STATE(254),
    [sym_unary_expression] = STATE(254),
    [sym_regex] = STATE(247),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(253),
    [sym_non_null_expression] = STATE(254),
    [sym_as_expression] = STATE(254),
    [sym_array] = STATE(257),
    [sym_internal_module] = STATE(254),
    [sym_class] = STATE(247),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_identifier] = ACTIONS(5354),
    [sym_false] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(5356),
    [anon_sym_symbol] = ACTIONS(5356),
    [anon_sym_number] = ACTIONS(5356),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(5356),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(511),
    [sym_super] = ACTIONS(505),
    [anon_sym_any] = ACTIONS(5356),
    [anon_sym_private] = ACTIONS(5356),
    [anon_sym_boolean] = ACTIONS(5356),
    [anon_sym_static] = ACTIONS(5356),
    [anon_sym_public] = ACTIONS(5356),
    [anon_sym_get] = ACTIONS(5356),
    [anon_sym_async] = ACTIONS(5360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_number] = ACTIONS(523),
    [sym_true] = ACTIONS(511),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5356),
    [anon_sym_string] = ACTIONS(5356),
    [anon_sym_function] = ACTIONS(167),
    [anon_sym_DOT] = ACTIONS(515),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_set] = ACTIONS(5356),
    [anon_sym_type] = ACTIONS(5356),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(5356),
    [anon_sym_namespace] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2302] = {
    [sym_arrow_function] = STATE(1980),
    [sym_await_expression] = STATE(1980),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(1980),
    [sym_meta_property] = STATE(1980),
    [sym__expression] = STATE(1980),
    [sym_function] = STATE(52),
    [sym_import] = STATE(1980),
    [sym_call_expression] = STATE(1980),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(1980),
    [sym_string] = STATE(1980),
    [sym_template_string] = STATE(1980),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1980),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(1980),
    [sym_generator_function] = STATE(1980),
    [sym_new_expression] = STATE(1980),
    [sym_assignment_expression] = STATE(1980),
    [sym_augmented_assignment_expression] = STATE(1980),
    [sym_binary_expression] = STATE(1980),
    [sym_unary_expression] = STATE(1980),
    [sym_regex] = STATE(1980),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(1980),
    [sym_as_expression] = STATE(1980),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(1980),
    [sym_class] = STATE(1980),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5364),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5364),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5364),
    [sym_number] = ACTIONS(5366),
    [sym_true] = ACTIONS(5364),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5364),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2303] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1985),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2304] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1962),
    [sym_identifier] = ACTIONS(5368),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2305] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1986),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2306] = {
    [sym_class_body] = STATE(874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [2307] = {
    [sym_implements_clause] = STATE(150),
    [sym_extends_clause] = STATE(151),
    [sym_class_body] = STATE(875),
    [sym_class_heritage] = STATE(2317),
    [anon_sym_extends] = ACTIONS(952),
    [anon_sym_implements] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [2308] = {
    [sym_array_type] = STATE(1596),
    [sym_formal_parameters] = STATE(2070),
    [sym_generic_type] = STATE(1596),
    [sym_type_predicate] = STATE(1596),
    [sym_literal_type] = STATE(1596),
    [sym__number] = STATE(1590),
    [sym_object_type] = STATE(1596),
    [sym_intersection_type] = STATE(1992),
    [sym_function_type] = STATE(1992),
    [sym_constructor_type] = STATE(1992),
    [sym__primary_type] = STATE(1596),
    [sym_lookup_type] = STATE(1596),
    [sym_parenthesized_type] = STATE(1596),
    [sym_nested_identifier] = STATE(2397),
    [sym_predefined_type] = STATE(1596),
    [sym_nested_type_identifier] = STATE(1597),
    [sym_tuple_type] = STATE(1596),
    [sym_union_type] = STATE(1992),
    [sym__type] = STATE(1992),
    [sym_type_query] = STATE(1596),
    [sym_index_type_query] = STATE(1596),
    [sym_existential_type] = STATE(1596),
    [sym_flow_maybe_type] = STATE(1596),
    [sym_string] = STATE(1590),
    [sym_type_parameters] = STATE(2398),
    [sym_identifier] = ACTIONS(1873),
    [sym_false] = ACTIONS(1875),
    [anon_sym_QMARK] = ACTIONS(1899),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_AMP] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_number] = ACTIONS(1879),
    [anon_sym_symbol] = ACTIONS(1879),
    [sym_this] = ACTIONS(1901),
    [anon_sym_typeof] = ACTIONS(1881),
    [sym_true] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_keyof] = ACTIONS(1883),
    [sym_number] = ACTIONS(1903),
    [anon_sym_void] = ACTIONS(1879),
    [anon_sym_string] = ACTIONS(1879),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_new] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_PLUS] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1879),
    [anon_sym_DQUOTE] = ACTIONS(984),
    [anon_sym_boolean] = ACTIONS(1879),
  },
  [2309] = {
    [sym_arrow_function] = STATE(2319),
    [sym_await_expression] = STATE(2319),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_sequence_expression] = STATE(2318),
    [sym_meta_property] = STATE(2319),
    [sym_update_expression] = STATE(2319),
    [sym__expression] = STATE(2319),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2319),
    [sym_call_expression] = STATE(2319),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(2319),
    [sym_string] = STATE(2319),
    [sym_template_string] = STATE(2319),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2319),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(2319),
    [sym_generator_function] = STATE(2319),
    [sym_new_expression] = STATE(2319),
    [sym_assignment_expression] = STATE(2319),
    [sym_augmented_assignment_expression] = STATE(2319),
    [sym_binary_expression] = STATE(2319),
    [sym_unary_expression] = STATE(2319),
    [sym_regex] = STATE(2319),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(2319),
    [sym_as_expression] = STATE(2319),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(2319),
    [sym_class] = STATE(2319),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_void] = ACTIONS(275),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [sym_this] = ACTIONS(5370),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(5370),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5370),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5370),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_RPAREN] = ACTIONS(5372),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5374),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5370),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_await] = ACTIONS(319),
  },
  [2310] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1994),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(5376),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2311] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(1997),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2312] = {
    [sym_statement_block] = STATE(953),
    [sym__automatic_semicolon] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2313] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2002),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2314] = {
    [sym_arrow_function] = STATE(2005),
    [sym_await_expression] = STATE(2005),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2005),
    [sym_meta_property] = STATE(2005),
    [sym__expression] = STATE(2005),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2005),
    [sym_call_expression] = STATE(2005),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2005),
    [sym_string] = STATE(2005),
    [sym_template_string] = STATE(2005),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2005),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2005),
    [sym_generator_function] = STATE(2005),
    [sym_new_expression] = STATE(2005),
    [sym_assignment_expression] = STATE(2005),
    [sym_augmented_assignment_expression] = STATE(2005),
    [sym_binary_expression] = STATE(2005),
    [sym_unary_expression] = STATE(2005),
    [sym_regex] = STATE(2005),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2005),
    [sym_as_expression] = STATE(2005),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2005),
    [sym_class] = STATE(2005),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5378),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5378),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5378),
    [sym_number] = ACTIONS(5380),
    [sym_true] = ACTIONS(5378),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5378),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2315] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_EQ_GT] = ACTIONS(4565),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(5382),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2316] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2008),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2317] = {
    [sym_class_body] = STATE(1053),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4622),
  },
  [2318] = {
    [anon_sym_RPAREN] = ACTIONS(5384),
    [sym_comment] = ACTIONS(3),
  },
  [2319] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(890),
    [anon_sym_STAR] = ACTIONS(892),
    [anon_sym_AMP_AMP] = ACTIONS(894),
    [anon_sym_GT_GT_GT] = ACTIONS(888),
    [anon_sym_BANG_EQ] = ACTIONS(896),
    [anon_sym_LT_EQ] = ACTIONS(882),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(882),
    [anon_sym_GT] = ACTIONS(896),
    [anon_sym_AMP] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(888),
    [anon_sym_QMARK] = ACTIONS(902),
    [anon_sym_PIPE_PIPE] = ACTIONS(904),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(896),
    [anon_sym_instanceof] = ACTIONS(882),
    [anon_sym_LT] = ACTIONS(910),
    [anon_sym_RPAREN] = ACTIONS(5384),
    [anon_sym_SLASH] = ACTIONS(892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(904),
    [anon_sym_STAR_STAR] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(890),
    [anon_sym_GT_GT] = ACTIONS(892),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(882),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2320] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2012),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2321] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2013),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(5386),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2322] = {
    [sym_statement_block] = STATE(1105),
    [sym__automatic_semicolon] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2323] = {
    [sym_statement_block] = STATE(1107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2324] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2018),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2325] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2019),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(5388),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [sym_statement_block] = STATE(1183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2327] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2021),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2328] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2022),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(5390),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2329] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2023),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2330] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2024),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_QMARK] = ACTIONS(5392),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2331] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2025),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2332] = {
    [sym_arrow_function] = STATE(2425),
    [sym_await_expression] = STATE(2425),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2425),
    [sym_meta_property] = STATE(2425),
    [sym__expression] = STATE(2425),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2425),
    [sym_call_expression] = STATE(2425),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2425),
    [sym_string] = STATE(2425),
    [sym_template_string] = STATE(2425),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2425),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2425),
    [sym_generator_function] = STATE(2425),
    [sym_new_expression] = STATE(2425),
    [sym_assignment_expression] = STATE(2425),
    [sym_augmented_assignment_expression] = STATE(2425),
    [sym_binary_expression] = STATE(2425),
    [sym_unary_expression] = STATE(2425),
    [sym_regex] = STATE(2425),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2425),
    [sym_as_expression] = STATE(2425),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2425),
    [sym_class] = STATE(2425),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5396),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5396),
    [sym_number] = ACTIONS(5398),
    [sym_true] = ACTIONS(5396),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5396),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2333] = {
    [sym_arrow_function] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym__expression] = STATE(1273),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(1273),
    [sym_generator_function] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_regex] = STATE(1273),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(1273),
    [sym_class] = STATE(1273),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4188),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(4188),
    [sym_number] = ACTIONS(4190),
    [sym_true] = ACTIONS(4188),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4188),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2334] = {
    [sym_arrow_function] = STATE(2427),
    [sym_await_expression] = STATE(2427),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2427),
    [sym_meta_property] = STATE(2427),
    [sym__expression] = STATE(2427),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2427),
    [sym_call_expression] = STATE(2427),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2427),
    [sym_string] = STATE(2427),
    [sym_template_string] = STATE(2427),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2427),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2427),
    [sym_generator_function] = STATE(2427),
    [sym_new_expression] = STATE(2427),
    [sym_assignment_expression] = STATE(2427),
    [sym_augmented_assignment_expression] = STATE(2427),
    [sym_binary_expression] = STATE(2427),
    [sym_unary_expression] = STATE(2427),
    [sym_regex] = STATE(2427),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2427),
    [sym_as_expression] = STATE(2427),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2427),
    [sym_class] = STATE(2427),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(5394),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(5400),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5402),
    [anon_sym_yield] = ACTIONS(942),
    [sym_true] = ACTIONS(5402),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5402),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5402),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5406),
    [anon_sym_SLASH] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5402),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_implements] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(922),
  },
  [2335] = {
    [sym_arrow_function] = STATE(2428),
    [sym_await_expression] = STATE(2428),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2428),
    [sym_meta_property] = STATE(2428),
    [sym__expression] = STATE(2428),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2428),
    [sym_call_expression] = STATE(2428),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2428),
    [sym_string] = STATE(2428),
    [sym_template_string] = STATE(2428),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2428),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2428),
    [sym_generator_function] = STATE(2428),
    [sym_new_expression] = STATE(2428),
    [sym_assignment_expression] = STATE(2428),
    [sym_augmented_assignment_expression] = STATE(2428),
    [sym_binary_expression] = STATE(2428),
    [sym_unary_expression] = STATE(2428),
    [sym_regex] = STATE(2428),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2428),
    [sym_as_expression] = STATE(2428),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2428),
    [sym_class] = STATE(2428),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5408),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5408),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5408),
    [sym_number] = ACTIONS(5410),
    [sym_true] = ACTIONS(5408),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5408),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2336] = {
    [sym_arrow_function] = STATE(2433),
    [sym_await_expression] = STATE(2433),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2433),
    [sym_meta_property] = STATE(2433),
    [sym__expression] = STATE(2433),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2433),
    [sym_call_expression] = STATE(2433),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2433),
    [sym_string] = STATE(2433),
    [sym_template_string] = STATE(2433),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2433),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2433),
    [sym_generator_function] = STATE(2433),
    [sym_new_expression] = STATE(2433),
    [sym_assignment_expression] = STATE(2433),
    [sym_augmented_assignment_expression] = STATE(2433),
    [sym_binary_expression] = STATE(2433),
    [sym_unary_expression] = STATE(2433),
    [sym_regex] = STATE(2433),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2433),
    [sym_as_expression] = STATE(2433),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2433),
    [sym_class] = STATE(2433),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5412),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5412),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5412),
    [sym_number] = ACTIONS(5414),
    [sym_true] = ACTIONS(5412),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5412),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2337] = {
    [sym_arrow_function] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym__expression] = STATE(1333),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1333),
    [sym_call_expression] = STATE(1333),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(1333),
    [sym_generator_function] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_regex] = STATE(1333),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(1333),
    [sym_class] = STATE(1333),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4208),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(4208),
    [sym_number] = ACTIONS(4210),
    [sym_true] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2338] = {
    [sym_arrow_function] = STATE(2028),
    [sym_await_expression] = STATE(2028),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1340),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2028),
    [sym_meta_property] = STATE(2028),
    [sym__expression] = STATE(2028),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2028),
    [sym_call_expression] = STATE(2028),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2028),
    [sym_string] = STATE(2028),
    [sym_template_string] = STATE(2028),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2028),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2028),
    [sym_generator_function] = STATE(2028),
    [sym_new_expression] = STATE(2028),
    [sym_assignment_expression] = STATE(2028),
    [sym_augmented_assignment_expression] = STATE(2028),
    [sym_binary_expression] = STATE(2028),
    [sym_unary_expression] = STATE(2028),
    [sym_regex] = STATE(2028),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2028),
    [sym_as_expression] = STATE(2028),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2028),
    [sym_class] = STATE(2028),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5416),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5416),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5416),
    [sym_number] = ACTIONS(5418),
    [sym_true] = ACTIONS(5416),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5416),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2339] = {
    [sym_arrow_function] = STATE(2029),
    [sym_await_expression] = STATE(2029),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2029),
    [sym_meta_property] = STATE(2029),
    [sym__expression] = STATE(2029),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2029),
    [sym_call_expression] = STATE(2029),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2029),
    [sym_string] = STATE(2029),
    [sym_template_string] = STATE(2029),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2029),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2029),
    [sym_generator_function] = STATE(2029),
    [sym_new_expression] = STATE(2029),
    [sym_assignment_expression] = STATE(2029),
    [sym_augmented_assignment_expression] = STATE(2029),
    [sym_binary_expression] = STATE(2029),
    [sym_unary_expression] = STATE(2029),
    [sym_regex] = STATE(2029),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2029),
    [sym_as_expression] = STATE(2029),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2029),
    [sym_class] = STATE(2029),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5420),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5420),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5420),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5422),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5420),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2340] = {
    [sym_arrow_function] = STATE(2030),
    [sym_await_expression] = STATE(2030),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2030),
    [sym_meta_property] = STATE(2030),
    [sym__expression] = STATE(2030),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2030),
    [sym_call_expression] = STATE(2030),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2030),
    [sym_string] = STATE(2030),
    [sym_template_string] = STATE(2030),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2030),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2030),
    [sym_generator_function] = STATE(2030),
    [sym_new_expression] = STATE(2030),
    [sym_assignment_expression] = STATE(2030),
    [sym_augmented_assignment_expression] = STATE(2030),
    [sym_binary_expression] = STATE(2030),
    [sym_unary_expression] = STATE(2030),
    [sym_regex] = STATE(2030),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2030),
    [sym_as_expression] = STATE(2030),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2030),
    [sym_class] = STATE(2030),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5424),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5424),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5424),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5424),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5426),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5424),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2341] = {
    [sym_arrow_function] = STATE(2031),
    [sym_await_expression] = STATE(2031),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1346),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2031),
    [sym_meta_property] = STATE(2031),
    [sym__expression] = STATE(2031),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2031),
    [sym_call_expression] = STATE(2031),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2031),
    [sym_string] = STATE(2031),
    [sym_template_string] = STATE(2031),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2031),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2031),
    [sym_generator_function] = STATE(2031),
    [sym_new_expression] = STATE(2031),
    [sym_assignment_expression] = STATE(2031),
    [sym_augmented_assignment_expression] = STATE(2031),
    [sym_binary_expression] = STATE(2031),
    [sym_unary_expression] = STATE(2031),
    [sym_regex] = STATE(2031),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2031),
    [sym_as_expression] = STATE(2031),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2031),
    [sym_class] = STATE(2031),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5428),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5428),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5428),
    [sym_number] = ACTIONS(5430),
    [sym_true] = ACTIONS(5428),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5428),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2342] = {
    [sym_arrow_function] = STATE(2032),
    [sym_await_expression] = STATE(2032),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2032),
    [sym_meta_property] = STATE(2032),
    [sym__expression] = STATE(2032),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2032),
    [sym_call_expression] = STATE(2032),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2032),
    [sym_string] = STATE(2032),
    [sym_template_string] = STATE(2032),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2032),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2032),
    [sym_generator_function] = STATE(2032),
    [sym_new_expression] = STATE(2032),
    [sym_assignment_expression] = STATE(2032),
    [sym_augmented_assignment_expression] = STATE(2032),
    [sym_binary_expression] = STATE(2032),
    [sym_unary_expression] = STATE(2032),
    [sym_regex] = STATE(2032),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2032),
    [sym_as_expression] = STATE(2032),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2032),
    [sym_class] = STATE(2032),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5432),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5432),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5432),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5432),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5434),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5432),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2343] = {
    [sym_arrow_function] = STATE(2033),
    [sym_await_expression] = STATE(2033),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2033),
    [sym_meta_property] = STATE(2033),
    [sym__expression] = STATE(2033),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2033),
    [sym_call_expression] = STATE(2033),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2033),
    [sym_string] = STATE(2033),
    [sym_template_string] = STATE(2033),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2033),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2033),
    [sym_generator_function] = STATE(2033),
    [sym_new_expression] = STATE(2033),
    [sym_assignment_expression] = STATE(2033),
    [sym_augmented_assignment_expression] = STATE(2033),
    [sym_binary_expression] = STATE(2033),
    [sym_unary_expression] = STATE(2033),
    [sym_regex] = STATE(2033),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2033),
    [sym_as_expression] = STATE(2033),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2033),
    [sym_class] = STATE(2033),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5436),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5436),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5436),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5436),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5438),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5436),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2345] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2346] = {
    [sym_arrow_function] = STATE(2425),
    [sym_await_expression] = STATE(2425),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2425),
    [sym_meta_property] = STATE(2425),
    [sym__expression] = STATE(2425),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2425),
    [sym_call_expression] = STATE(2425),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2425),
    [sym_string] = STATE(2425),
    [sym_template_string] = STATE(2425),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2425),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2425),
    [sym_generator_function] = STATE(2425),
    [sym_new_expression] = STATE(2425),
    [sym_assignment_expression] = STATE(2425),
    [sym_augmented_assignment_expression] = STATE(2425),
    [sym_binary_expression] = STATE(2425),
    [sym_unary_expression] = STATE(2425),
    [sym_regex] = STATE(2425),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2425),
    [sym_as_expression] = STATE(2425),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2425),
    [sym_class] = STATE(2425),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5394),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5396),
    [anon_sym_yield] = ACTIONS(942),
    [sym_true] = ACTIONS(5396),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5396),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5396),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(922),
  },
  [2347] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2388),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5444),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_symbol] = ACTIONS(5446),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_void] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_get] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(5446),
    [anon_sym_type] = ACTIONS(5446),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_namespace] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5446),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_number] = ACTIONS(5446),
    [anon_sym_declare] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5446),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_boolean] = ACTIONS(5446),
    [anon_sym_async] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_string] = ACTIONS(5446),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(5446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2348] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2349] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(725),
  },
  [2350] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2351] = {
    [sym_arrow_function] = STATE(2036),
    [sym_await_expression] = STATE(2036),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2036),
    [sym_meta_property] = STATE(2036),
    [sym__expression] = STATE(2036),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2036),
    [sym_call_expression] = STATE(2036),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2036),
    [sym_string] = STATE(2036),
    [sym_template_string] = STATE(2036),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2036),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2036),
    [sym_generator_function] = STATE(2036),
    [sym_new_expression] = STATE(2036),
    [sym_assignment_expression] = STATE(2036),
    [sym_augmented_assignment_expression] = STATE(2036),
    [sym_binary_expression] = STATE(2036),
    [sym_unary_expression] = STATE(2036),
    [sym_regex] = STATE(2036),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2036),
    [sym_as_expression] = STATE(2036),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2036),
    [sym_class] = STATE(2036),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5451),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5451),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5451),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5451),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5453),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5451),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2352] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(798),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(798),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2353] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_RBRACK] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2354] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_implements] = ACTIONS(1336),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1340),
  },
  [2355] = {
    [sym_arguments] = STATE(1413),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_implements] = ACTIONS(1346),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2356] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(1413),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2357] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1413),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2388),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(5444),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(5446),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(5446),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(5446),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(5446),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(5446),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(5446),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(5446),
    [anon_sym_type] = ACTIONS(5446),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(5446),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(5446),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(5446),
    [anon_sym_declare] = ACTIONS(5446),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(5446),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(5446),
    [anon_sym_async] = ACTIONS(5446),
    [anon_sym_public] = ACTIONS(5446),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(5446),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_implements] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(5446),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2358] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(1413),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1346),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_implements] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2359] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_RBRACK] = ACTIONS(1442),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1442),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2360] = {
    [sym_arrow_function] = STATE(2038),
    [sym_await_expression] = STATE(2038),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2038),
    [sym_meta_property] = STATE(2038),
    [sym__expression] = STATE(2038),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2038),
    [sym_call_expression] = STATE(2038),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2038),
    [sym_string] = STATE(2038),
    [sym_template_string] = STATE(2038),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2038),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2038),
    [sym_generator_function] = STATE(2038),
    [sym_new_expression] = STATE(2038),
    [sym_assignment_expression] = STATE(2038),
    [sym_augmented_assignment_expression] = STATE(2038),
    [sym_binary_expression] = STATE(2038),
    [sym_unary_expression] = STATE(2038),
    [sym_regex] = STATE(2038),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2038),
    [sym_as_expression] = STATE(2038),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2038),
    [sym_class] = STATE(2038),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4895),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4895),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4895),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4895),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5455),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4895),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2361] = {
    [sym_arrow_function] = STATE(2039),
    [sym_await_expression] = STATE(2039),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2039),
    [sym_meta_property] = STATE(2039),
    [sym__expression] = STATE(2039),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2039),
    [sym_call_expression] = STATE(2039),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2039),
    [sym_string] = STATE(2039),
    [sym_template_string] = STATE(2039),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2039),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2039),
    [sym_generator_function] = STATE(2039),
    [sym_new_expression] = STATE(2039),
    [sym_assignment_expression] = STATE(2039),
    [sym_augmented_assignment_expression] = STATE(2039),
    [sym_binary_expression] = STATE(2039),
    [sym_unary_expression] = STATE(2039),
    [sym_regex] = STATE(2039),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2039),
    [sym_as_expression] = STATE(2039),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2039),
    [sym_class] = STATE(2039),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5457),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5457),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5457),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5457),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5459),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5457),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2362] = {
    [sym_arrow_function] = STATE(2040),
    [sym_await_expression] = STATE(2040),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2040),
    [sym_meta_property] = STATE(2040),
    [sym__expression] = STATE(2040),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2040),
    [sym_call_expression] = STATE(2040),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2040),
    [sym_string] = STATE(2040),
    [sym_template_string] = STATE(2040),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2040),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2040),
    [sym_generator_function] = STATE(2040),
    [sym_new_expression] = STATE(2040),
    [sym_assignment_expression] = STATE(2040),
    [sym_augmented_assignment_expression] = STATE(2040),
    [sym_binary_expression] = STATE(2040),
    [sym_unary_expression] = STATE(2040),
    [sym_regex] = STATE(2040),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2040),
    [sym_as_expression] = STATE(2040),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2040),
    [sym_class] = STATE(2040),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5461),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5461),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5461),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5461),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5463),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5461),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2363] = {
    [sym_arrow_function] = STATE(2041),
    [sym_await_expression] = STATE(2041),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2041),
    [sym_meta_property] = STATE(2041),
    [sym__expression] = STATE(2041),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2041),
    [sym_call_expression] = STATE(2041),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2041),
    [sym_string] = STATE(2041),
    [sym_template_string] = STATE(2041),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2041),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2041),
    [sym_generator_function] = STATE(2041),
    [sym_new_expression] = STATE(2041),
    [sym_assignment_expression] = STATE(2041),
    [sym_augmented_assignment_expression] = STATE(2041),
    [sym_binary_expression] = STATE(2041),
    [sym_unary_expression] = STATE(2041),
    [sym_regex] = STATE(2041),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2041),
    [sym_as_expression] = STATE(2041),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2041),
    [sym_class] = STATE(2041),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5465),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5465),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5465),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5465),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5467),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5465),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2364] = {
    [sym_arrow_function] = STATE(2042),
    [sym_await_expression] = STATE(2042),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2042),
    [sym_meta_property] = STATE(2042),
    [sym__expression] = STATE(2042),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2042),
    [sym_call_expression] = STATE(2042),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2042),
    [sym_string] = STATE(2042),
    [sym_template_string] = STATE(2042),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2042),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2042),
    [sym_generator_function] = STATE(2042),
    [sym_new_expression] = STATE(2042),
    [sym_assignment_expression] = STATE(2042),
    [sym_augmented_assignment_expression] = STATE(2042),
    [sym_binary_expression] = STATE(2042),
    [sym_unary_expression] = STATE(2042),
    [sym_regex] = STATE(2042),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2042),
    [sym_as_expression] = STATE(2042),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2042),
    [sym_class] = STATE(2042),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5469),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5469),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5469),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5469),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5471),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5469),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2365] = {
    [sym_arrow_function] = STATE(2046),
    [sym_await_expression] = STATE(2046),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2046),
    [sym_meta_property] = STATE(2046),
    [sym__expression] = STATE(2046),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2046),
    [sym_call_expression] = STATE(2046),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2046),
    [sym_string] = STATE(2046),
    [sym_template_string] = STATE(2046),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2046),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2046),
    [sym_generator_function] = STATE(2046),
    [sym_new_expression] = STATE(2046),
    [sym_assignment_expression] = STATE(2046),
    [sym_augmented_assignment_expression] = STATE(2046),
    [sym_binary_expression] = STATE(2046),
    [sym_unary_expression] = STATE(2046),
    [sym_regex] = STATE(2046),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2046),
    [sym_as_expression] = STATE(2046),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2046),
    [sym_class] = STATE(2046),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5473),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5473),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5473),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5473),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5475),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5473),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2366] = {
    [sym_arrow_function] = STATE(2047),
    [sym_await_expression] = STATE(2047),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2047),
    [sym_meta_property] = STATE(2047),
    [sym__expression] = STATE(2047),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2047),
    [sym_call_expression] = STATE(2047),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2047),
    [sym_string] = STATE(2047),
    [sym_template_string] = STATE(2047),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2047),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2047),
    [sym_generator_function] = STATE(2047),
    [sym_new_expression] = STATE(2047),
    [sym_assignment_expression] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(2047),
    [sym_binary_expression] = STATE(2047),
    [sym_unary_expression] = STATE(2047),
    [sym_regex] = STATE(2047),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2047),
    [sym_as_expression] = STATE(2047),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2047),
    [sym_class] = STATE(2047),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5477),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5477),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5477),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5477),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5479),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5477),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2367] = {
    [sym_arrow_function] = STATE(2048),
    [sym_await_expression] = STATE(2048),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1437),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2048),
    [sym_meta_property] = STATE(2048),
    [sym__expression] = STATE(2048),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2048),
    [sym_call_expression] = STATE(2048),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2048),
    [sym_string] = STATE(2048),
    [sym_template_string] = STATE(2048),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2048),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2048),
    [sym_generator_function] = STATE(2048),
    [sym_new_expression] = STATE(2048),
    [sym_assignment_expression] = STATE(2048),
    [sym_augmented_assignment_expression] = STATE(2048),
    [sym_binary_expression] = STATE(2048),
    [sym_unary_expression] = STATE(2048),
    [sym_regex] = STATE(2048),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2048),
    [sym_as_expression] = STATE(2048),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2048),
    [sym_class] = STATE(2048),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5481),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5481),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5481),
    [sym_number] = ACTIONS(5483),
    [sym_true] = ACTIONS(5481),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5481),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2368] = {
    [sym_arrow_function] = STATE(2049),
    [sym_await_expression] = STATE(2049),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2049),
    [sym_meta_property] = STATE(2049),
    [sym__expression] = STATE(2049),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2049),
    [sym_call_expression] = STATE(2049),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2049),
    [sym_string] = STATE(2049),
    [sym_template_string] = STATE(2049),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2049),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2049),
    [sym_generator_function] = STATE(2049),
    [sym_new_expression] = STATE(2049),
    [sym_assignment_expression] = STATE(2049),
    [sym_augmented_assignment_expression] = STATE(2049),
    [sym_binary_expression] = STATE(2049),
    [sym_unary_expression] = STATE(2049),
    [sym_regex] = STATE(2049),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2049),
    [sym_as_expression] = STATE(2049),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2049),
    [sym_class] = STATE(2049),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5485),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5485),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5485),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5485),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5487),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5485),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2369] = {
    [sym_arrow_function] = STATE(2050),
    [sym_await_expression] = STATE(2050),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1468),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2050),
    [sym_meta_property] = STATE(2050),
    [sym__expression] = STATE(2050),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2050),
    [sym_call_expression] = STATE(2050),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2050),
    [sym_string] = STATE(2050),
    [sym_template_string] = STATE(2050),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2050),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2050),
    [sym_generator_function] = STATE(2050),
    [sym_new_expression] = STATE(2050),
    [sym_assignment_expression] = STATE(2050),
    [sym_augmented_assignment_expression] = STATE(2050),
    [sym_binary_expression] = STATE(2050),
    [sym_unary_expression] = STATE(2050),
    [sym_regex] = STATE(2050),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2050),
    [sym_as_expression] = STATE(2050),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2050),
    [sym_class] = STATE(2050),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5489),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5489),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5489),
    [sym_number] = ACTIONS(5491),
    [sym_true] = ACTIONS(5489),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5489),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2370] = {
    [sym_arrow_function] = STATE(2051),
    [sym_await_expression] = STATE(2051),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1470),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2051),
    [sym_meta_property] = STATE(2051),
    [sym__expression] = STATE(2051),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2051),
    [sym_call_expression] = STATE(2051),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2051),
    [sym_string] = STATE(2051),
    [sym_template_string] = STATE(2051),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2051),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2051),
    [sym_generator_function] = STATE(2051),
    [sym_new_expression] = STATE(2051),
    [sym_assignment_expression] = STATE(2051),
    [sym_augmented_assignment_expression] = STATE(2051),
    [sym_binary_expression] = STATE(2051),
    [sym_unary_expression] = STATE(2051),
    [sym_regex] = STATE(2051),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2051),
    [sym_as_expression] = STATE(2051),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2051),
    [sym_class] = STATE(2051),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5493),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5493),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5493),
    [sym_number] = ACTIONS(5495),
    [sym_true] = ACTIONS(5493),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5493),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2371] = {
    [sym_arrow_function] = STATE(2052),
    [sym_await_expression] = STATE(2052),
    [sym_member_expression] = STATE(2579),
    [sym_statement_block] = STATE(1473),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2052),
    [sym_meta_property] = STATE(2052),
    [sym__expression] = STATE(2052),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2052),
    [sym_call_expression] = STATE(2052),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2052),
    [sym_string] = STATE(2052),
    [sym_template_string] = STATE(2052),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2052),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2052),
    [sym_generator_function] = STATE(2052),
    [sym_new_expression] = STATE(2052),
    [sym_assignment_expression] = STATE(2052),
    [sym_augmented_assignment_expression] = STATE(2052),
    [sym_binary_expression] = STATE(2052),
    [sym_unary_expression] = STATE(2052),
    [sym_regex] = STATE(2052),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2052),
    [sym_as_expression] = STATE(2052),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2052),
    [sym_class] = STATE(2052),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5497),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5497),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5497),
    [sym_number] = ACTIONS(5499),
    [sym_true] = ACTIONS(5497),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5497),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2372] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(4376),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2373] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_implements] = ACTIONS(131),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2374] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [sym_identifier] = ACTIONS(5501),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2375] = {
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym__expression] = STATE(2349),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2349),
    [sym_string] = STATE(2349),
    [sym_template_string] = STATE(2349),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2349),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_new_expression] = STATE(2349),
    [sym_assignment_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2349),
    [sym_as_expression] = STATE(2349),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2349),
    [sym_class] = STATE(2349),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5503),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5503),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5503),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5503),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4382),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5503),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2376] = {
    [sym_arrow_function] = STATE(2425),
    [sym_await_expression] = STATE(2425),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2425),
    [sym_meta_property] = STATE(2425),
    [sym__expression] = STATE(2425),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2425),
    [sym_call_expression] = STATE(2425),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2425),
    [sym_string] = STATE(2425),
    [sym_template_string] = STATE(2425),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2425),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2425),
    [sym_generator_function] = STATE(2425),
    [sym_new_expression] = STATE(2425),
    [sym_assignment_expression] = STATE(2425),
    [sym_augmented_assignment_expression] = STATE(2425),
    [sym_binary_expression] = STATE(2425),
    [sym_unary_expression] = STATE(2425),
    [sym_regex] = STATE(2425),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2425),
    [sym_as_expression] = STATE(2425),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2425),
    [sym_class] = STATE(2425),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5394),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5440),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_AMP_EQ] = ACTIONS(5440),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5440),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5442),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5440),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_PIPE_EQ] = ACTIONS(5440),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_DASH_EQ] = ACTIONS(5440),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5440),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5396),
    [anon_sym_yield] = ACTIONS(942),
    [sym_true] = ACTIONS(5396),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5440),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5404),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5396),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5440),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5396),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_STAR_EQ] = ACTIONS(5440),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_EQ_GT] = ACTIONS(4461),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5398),
    [anon_sym_SLASH] = ACTIONS(944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5440),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5396),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(922),
  },
  [2377] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [sym_identifier] = ACTIONS(5505),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(5509),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_get] = ACTIONS(5507),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4390),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_DOT] = ACTIONS(4392),
    [anon_sym_set] = ACTIONS(5507),
    [anon_sym_type] = ACTIONS(5507),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5511),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4390),
    [anon_sym_module] = ACTIONS(5507),
    [anon_sym_number] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5507),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [anon_sym_any] = ACTIONS(5507),
    [anon_sym_boolean] = ACTIONS(5507),
    [anon_sym_async] = ACTIONS(5513),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4398),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5507),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2378] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2379] = {
    [sym_arrow_function] = STATE(2053),
    [sym_await_expression] = STATE(2053),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2053),
    [sym_meta_property] = STATE(2053),
    [sym__expression] = STATE(2053),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2053),
    [sym_call_expression] = STATE(2053),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2053),
    [sym_string] = STATE(2053),
    [sym_template_string] = STATE(2053),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2053),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2053),
    [sym_generator_function] = STATE(2053),
    [sym_new_expression] = STATE(2053),
    [sym_assignment_expression] = STATE(2053),
    [sym_augmented_assignment_expression] = STATE(2053),
    [sym_binary_expression] = STATE(2053),
    [sym_unary_expression] = STATE(2053),
    [sym_regex] = STATE(2053),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2053),
    [sym_as_expression] = STATE(2053),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2053),
    [sym_class] = STATE(2053),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5517),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5517),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5517),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5517),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5519),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5517),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2380] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(5521),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2381] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2382] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2383] = {
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym__expression] = STATE(2349),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2349),
    [sym_string] = STATE(2349),
    [sym_template_string] = STATE(2349),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2349),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_new_expression] = STATE(2349),
    [sym_assignment_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2349),
    [sym_as_expression] = STATE(2349),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2349),
    [sym_class] = STATE(2349),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5503),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5503),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5503),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5503),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5527),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5503),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2384] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [sym_identifier] = ACTIONS(5505),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(5509),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5507),
    [anon_sym_static] = ACTIONS(5507),
    [anon_sym_get] = ACTIONS(5507),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4390),
    [anon_sym_protected] = ACTIONS(5507),
    [anon_sym_DOT] = ACTIONS(4392),
    [anon_sym_set] = ACTIONS(5507),
    [anon_sym_type] = ACTIONS(5507),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5511),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4390),
    [anon_sym_module] = ACTIONS(5507),
    [anon_sym_number] = ACTIONS(5507),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5507),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [anon_sym_any] = ACTIONS(5507),
    [anon_sym_boolean] = ACTIONS(5507),
    [anon_sym_async] = ACTIONS(5513),
    [anon_sym_public] = ACTIONS(5507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4398),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5507),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(5507),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2385] = {
    [anon_sym_EQ_GT] = ACTIONS(5529),
    [sym_comment] = ACTIONS(3),
  },
  [2386] = {
    [anon_sym_EQ_GT] = ACTIONS(5531),
    [sym_comment] = ACTIONS(3),
  },
  [2387] = {
    [anon_sym_EQ_GT] = ACTIONS(5533),
    [sym_comment] = ACTIONS(3),
  },
  [2388] = {
    [anon_sym_EQ_GT] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
  },
  [2389] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5537),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2390] = {
    [sym_regex_pattern] = ACTIONS(5539),
    [sym_comment] = ACTIONS(255),
  },
  [2391] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2071),
    [sym_function_type] = STATE(2071),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2071),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2071),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2071),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2392] = {
    [sym_identifier] = ACTIONS(5541),
    [sym_comment] = ACTIONS(3),
  },
  [2393] = {
    [sym_generator_function_declaration] = STATE(288),
    [sym__declaration] = STATE(288),
    [sym_await_expression] = STATE(51),
    [sym_statement_block] = STATE(288),
    [sym_update_expression] = STATE(51),
    [sym_while_statement] = STATE(288),
    [sym_meta_property] = STATE(51),
    [sym_debugger_statement] = STATE(288),
    [sym__expression] = STATE(51),
    [sym_import_alias] = STATE(288),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_if_statement] = STATE(288),
    [sym_ternary_expression] = STATE(51),
    [sym_do_statement] = STATE(288),
    [sym_template_string] = STATE(51),
    [sym_return_statement] = STATE(288),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_module] = STATE(288),
    [sym_function_declaration] = STATE(288),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(288),
    [sym_binary_expression] = STATE(51),
    [sym_for_in_statement] = STATE(288),
    [sym_break_statement] = STATE(288),
    [sym_labeled_statement] = STATE(288),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(55),
    [sym_enum_declaration] = STATE(288),
    [sym_class_declaration] = STATE(288),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym_continue_statement] = STATE(288),
    [sym_ambient_declaration] = STATE(288),
    [sym_type_alias_declaration] = STATE(288),
    [sym__call_signature] = STATE(58),
    [sym_import_statement] = STATE(288),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(288),
    [sym_switch_statement] = STATE(288),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_try_statement] = STATE(288),
    [sym_throw_statement] = STATE(288),
    [sym_formal_parameters] = STATE(61),
    [aux_sym_program_repeat1] = STATE(288),
    [sym_decorator] = STATE(63),
    [sym_object] = STATE(64),
    [sym_function_signature] = STATE(288),
    [sym_abstract_class_declaration] = STATE(288),
    [sym_interface_declaration] = STATE(288),
    [sym_export_statement] = STATE(288),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_for_statement] = STATE(288),
    [sym_unary_expression] = STATE(51),
    [sym_with_statement] = STATE(288),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(288),
    [aux_sym_export_statement_repeat1] = STATE(65),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_static] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_throw] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(45),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_import] = ACTIONS(49),
    [anon_sym_namespace] = ACTIONS(51),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(63),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_declare] = ACTIONS(67),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(69),
    [anon_sym_switch] = ACTIONS(71),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(75),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(95),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_with] = ACTIONS(105),
    [anon_sym_await] = ACTIONS(107),
  },
  [2394] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2084),
    [sym_function_type] = STATE(2084),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2084),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2084),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2084),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2395] = {
    [sym_formal_parameters] = STATE(2085),
    [sym_type_parameters] = STATE(2404),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2396] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2087),
    [sym_function_type] = STATE(2087),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2087),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_object] = STATE(482),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(2087),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2087),
    [aux_sym_export_statement_repeat1] = STATE(486),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(483),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_this] = ACTIONS(1300),
    [sym_true] = ACTIONS(457),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(457),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_export] = ACTIONS(1197),
  },
  [2397] = {
    [anon_sym_DOT] = ACTIONS(4465),
    [sym_comment] = ACTIONS(3),
  },
  [2398] = {
    [sym_formal_parameters] = STATE(2091),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2399] = {
    [sym_arrow_function] = STATE(2389),
    [sym_await_expression] = STATE(2389),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2389),
    [sym_meta_property] = STATE(2389),
    [sym__expression] = STATE(2389),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2389),
    [sym_call_expression] = STATE(2389),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2389),
    [sym_string] = STATE(2389),
    [sym_template_string] = STATE(2389),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2389),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2389),
    [sym_generator_function] = STATE(2389),
    [sym_new_expression] = STATE(2389),
    [sym_assignment_expression] = STATE(2389),
    [sym_augmented_assignment_expression] = STATE(2389),
    [sym_binary_expression] = STATE(2389),
    [sym_unary_expression] = STATE(2389),
    [sym_regex] = STATE(2389),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2389),
    [sym_as_expression] = STATE(2389),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2389),
    [sym_class] = STATE(2389),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5545),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5545),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5545),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5545),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5545),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2400] = {
    [sym_identifier] = ACTIONS(5549),
    [sym_comment] = ACTIONS(3),
  },
  [2401] = {
    [sym_identifier] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
  },
  [2402] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2087),
    [sym_function_type] = STATE(2087),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2087),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2087),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2087),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2403] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(2099),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(2099),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(2099),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(2099),
    [sym_property_signature] = STATE(2099),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(2099),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(960),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2404] = {
    [sym_formal_parameters] = STATE(2103),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym_statement_block] = STATE(2015),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2406] = {
    [sym_statement_block] = STATE(2020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4652),
  },
  [2407] = {
    [sym_arrow_function] = STATE(2608),
    [sym_await_expression] = STATE(2608),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2608),
    [sym_meta_property] = STATE(2608),
    [sym__expression] = STATE(2608),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2608),
    [sym_call_expression] = STATE(2608),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2608),
    [sym_string] = STATE(2608),
    [sym_template_string] = STATE(2608),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2608),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2608),
    [sym_generator_function] = STATE(2608),
    [sym_new_expression] = STATE(2608),
    [sym_assignment_expression] = STATE(2608),
    [sym_augmented_assignment_expression] = STATE(2608),
    [sym_binary_expression] = STATE(2608),
    [sym_unary_expression] = STATE(2608),
    [sym_regex] = STATE(2608),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2608),
    [sym_as_expression] = STATE(2608),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2608),
    [sym_class] = STATE(2608),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5557),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5557),
    [sym_number] = ACTIONS(5571),
    [sym_true] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2408] = {
    [sym_arrow_function] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym__expression] = STATE(1273),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(1273),
    [sym_generator_function] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_regex] = STATE(1273),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(1273),
    [sym_class] = STATE(1273),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4188),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(4188),
    [sym_number] = ACTIONS(4190),
    [sym_true] = ACTIONS(4188),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4188),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2409] = {
    [sym_arrow_function] = STATE(2609),
    [sym_await_expression] = STATE(2609),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2609),
    [sym_meta_property] = STATE(2609),
    [sym__expression] = STATE(2609),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2609),
    [sym_call_expression] = STATE(2609),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2609),
    [sym_string] = STATE(2609),
    [sym_template_string] = STATE(2609),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2609),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2609),
    [sym_generator_function] = STATE(2609),
    [sym_new_expression] = STATE(2609),
    [sym_assignment_expression] = STATE(2609),
    [sym_augmented_assignment_expression] = STATE(2609),
    [sym_binary_expression] = STATE(2609),
    [sym_unary_expression] = STATE(2609),
    [sym_regex] = STATE(2609),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2609),
    [sym_as_expression] = STATE(2609),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2609),
    [sym_class] = STATE(2609),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(5555),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(5581),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5583),
    [anon_sym_yield] = ACTIONS(5573),
    [sym_true] = ACTIONS(5583),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5583),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5583),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5589),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5583),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(5553),
  },
  [2410] = {
    [sym_arrow_function] = STATE(2610),
    [sym_await_expression] = STATE(2610),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2610),
    [sym_meta_property] = STATE(2610),
    [sym__expression] = STATE(2610),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2610),
    [sym_call_expression] = STATE(2610),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2610),
    [sym_string] = STATE(2610),
    [sym_template_string] = STATE(2610),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2610),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2610),
    [sym_generator_function] = STATE(2610),
    [sym_new_expression] = STATE(2610),
    [sym_assignment_expression] = STATE(2610),
    [sym_augmented_assignment_expression] = STATE(2610),
    [sym_binary_expression] = STATE(2610),
    [sym_unary_expression] = STATE(2610),
    [sym_regex] = STATE(2610),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2610),
    [sym_as_expression] = STATE(2610),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2610),
    [sym_class] = STATE(2610),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5591),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5591),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5591),
    [sym_number] = ACTIONS(5593),
    [sym_true] = ACTIONS(5591),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5591),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2411] = {
    [sym_arrow_function] = STATE(2611),
    [sym_await_expression] = STATE(2611),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2611),
    [sym_meta_property] = STATE(2611),
    [sym__expression] = STATE(2611),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2611),
    [sym_call_expression] = STATE(2611),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2611),
    [sym_string] = STATE(2611),
    [sym_template_string] = STATE(2611),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2611),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2611),
    [sym_generator_function] = STATE(2611),
    [sym_new_expression] = STATE(2611),
    [sym_assignment_expression] = STATE(2611),
    [sym_augmented_assignment_expression] = STATE(2611),
    [sym_binary_expression] = STATE(2611),
    [sym_unary_expression] = STATE(2611),
    [sym_regex] = STATE(2611),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2611),
    [sym_as_expression] = STATE(2611),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2611),
    [sym_class] = STATE(2611),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5595),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5595),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5595),
    [sym_number] = ACTIONS(5597),
    [sym_true] = ACTIONS(5595),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5595),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2412] = {
    [sym_arrow_function] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym__expression] = STATE(1333),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1333),
    [sym_call_expression] = STATE(1333),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(1333),
    [sym_generator_function] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_regex] = STATE(1333),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(1333),
    [sym_class] = STATE(1333),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4208),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(4208),
    [sym_number] = ACTIONS(4210),
    [sym_true] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2413] = {
    [sym_arrow_function] = STATE(2115),
    [sym_await_expression] = STATE(2115),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1340),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2115),
    [sym_meta_property] = STATE(2115),
    [sym__expression] = STATE(2115),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2115),
    [sym_call_expression] = STATE(2115),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2115),
    [sym_string] = STATE(2115),
    [sym_template_string] = STATE(2115),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2115),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2115),
    [sym_generator_function] = STATE(2115),
    [sym_new_expression] = STATE(2115),
    [sym_assignment_expression] = STATE(2115),
    [sym_augmented_assignment_expression] = STATE(2115),
    [sym_binary_expression] = STATE(2115),
    [sym_unary_expression] = STATE(2115),
    [sym_regex] = STATE(2115),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2115),
    [sym_as_expression] = STATE(2115),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2115),
    [sym_class] = STATE(2115),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5599),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5599),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5599),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5599),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5601),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5599),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2414] = {
    [sym_arrow_function] = STATE(2116),
    [sym_await_expression] = STATE(2116),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2116),
    [sym_meta_property] = STATE(2116),
    [sym__expression] = STATE(2116),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2116),
    [sym_call_expression] = STATE(2116),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2116),
    [sym_string] = STATE(2116),
    [sym_template_string] = STATE(2116),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2116),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2116),
    [sym_generator_function] = STATE(2116),
    [sym_new_expression] = STATE(2116),
    [sym_assignment_expression] = STATE(2116),
    [sym_augmented_assignment_expression] = STATE(2116),
    [sym_binary_expression] = STATE(2116),
    [sym_unary_expression] = STATE(2116),
    [sym_regex] = STATE(2116),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2116),
    [sym_as_expression] = STATE(2116),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2116),
    [sym_class] = STATE(2116),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5603),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5603),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5603),
    [sym_number] = ACTIONS(5605),
    [sym_true] = ACTIONS(5603),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5603),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2415] = {
    [sym_arrow_function] = STATE(2117),
    [sym_await_expression] = STATE(2117),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2117),
    [sym_meta_property] = STATE(2117),
    [sym__expression] = STATE(2117),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2117),
    [sym_call_expression] = STATE(2117),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2117),
    [sym_string] = STATE(2117),
    [sym_template_string] = STATE(2117),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2117),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2117),
    [sym_generator_function] = STATE(2117),
    [sym_new_expression] = STATE(2117),
    [sym_assignment_expression] = STATE(2117),
    [sym_augmented_assignment_expression] = STATE(2117),
    [sym_binary_expression] = STATE(2117),
    [sym_unary_expression] = STATE(2117),
    [sym_regex] = STATE(2117),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2117),
    [sym_as_expression] = STATE(2117),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2117),
    [sym_class] = STATE(2117),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5607),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5607),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5607),
    [sym_number] = ACTIONS(5609),
    [sym_true] = ACTIONS(5607),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5607),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2416] = {
    [sym_arrow_function] = STATE(2118),
    [sym_await_expression] = STATE(2118),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1346),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2118),
    [sym_meta_property] = STATE(2118),
    [sym__expression] = STATE(2118),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2118),
    [sym_call_expression] = STATE(2118),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2118),
    [sym_string] = STATE(2118),
    [sym_template_string] = STATE(2118),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2118),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2118),
    [sym_generator_function] = STATE(2118),
    [sym_new_expression] = STATE(2118),
    [sym_assignment_expression] = STATE(2118),
    [sym_augmented_assignment_expression] = STATE(2118),
    [sym_binary_expression] = STATE(2118),
    [sym_unary_expression] = STATE(2118),
    [sym_regex] = STATE(2118),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2118),
    [sym_as_expression] = STATE(2118),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2118),
    [sym_class] = STATE(2118),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5611),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5611),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5611),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5611),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5613),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5611),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2417] = {
    [sym_arrow_function] = STATE(2119),
    [sym_await_expression] = STATE(2119),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2119),
    [sym_meta_property] = STATE(2119),
    [sym__expression] = STATE(2119),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2119),
    [sym_call_expression] = STATE(2119),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2119),
    [sym_string] = STATE(2119),
    [sym_template_string] = STATE(2119),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2119),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2119),
    [sym_generator_function] = STATE(2119),
    [sym_new_expression] = STATE(2119),
    [sym_assignment_expression] = STATE(2119),
    [sym_augmented_assignment_expression] = STATE(2119),
    [sym_binary_expression] = STATE(2119),
    [sym_unary_expression] = STATE(2119),
    [sym_regex] = STATE(2119),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2119),
    [sym_as_expression] = STATE(2119),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2119),
    [sym_class] = STATE(2119),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5615),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5615),
    [sym_number] = ACTIONS(5617),
    [sym_true] = ACTIONS(5615),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5615),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2418] = {
    [sym_arrow_function] = STATE(2120),
    [sym_await_expression] = STATE(2120),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2120),
    [sym_meta_property] = STATE(2120),
    [sym__expression] = STATE(2120),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2120),
    [sym_call_expression] = STATE(2120),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2120),
    [sym_string] = STATE(2120),
    [sym_template_string] = STATE(2120),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2120),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2120),
    [sym_generator_function] = STATE(2120),
    [sym_new_expression] = STATE(2120),
    [sym_assignment_expression] = STATE(2120),
    [sym_augmented_assignment_expression] = STATE(2120),
    [sym_binary_expression] = STATE(2120),
    [sym_unary_expression] = STATE(2120),
    [sym_regex] = STATE(2120),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2120),
    [sym_as_expression] = STATE(2120),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2120),
    [sym_class] = STATE(2120),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5619),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5619),
    [sym_number] = ACTIONS(5621),
    [sym_true] = ACTIONS(5619),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5619),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2419] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2420] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2421] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1356),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1368),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2422] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2423] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2424] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5623),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_implements] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(725),
  },
  [2425] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5623),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_implements] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2426] = {
    [sym_arrow_function] = STATE(2121),
    [sym_await_expression] = STATE(2121),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2121),
    [sym_meta_property] = STATE(2121),
    [sym__expression] = STATE(2121),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2121),
    [sym_call_expression] = STATE(2121),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2121),
    [sym_string] = STATE(2121),
    [sym_template_string] = STATE(2121),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2121),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2121),
    [sym_generator_function] = STATE(2121),
    [sym_new_expression] = STATE(2121),
    [sym_assignment_expression] = STATE(2121),
    [sym_augmented_assignment_expression] = STATE(2121),
    [sym_binary_expression] = STATE(2121),
    [sym_unary_expression] = STATE(2121),
    [sym_regex] = STATE(2121),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2121),
    [sym_as_expression] = STATE(2121),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2121),
    [sym_class] = STATE(2121),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5626),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5626),
    [sym_number] = ACTIONS(5628),
    [sym_true] = ACTIONS(5626),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5626),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2427] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(798),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(798),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2428] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(5623),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_implements] = ACTIONS(723),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2429] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_BANG] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(2808),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
  },
  [2430] = {
    [sym_arguments] = STATE(1413),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2431] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1413),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2457),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(2826),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(2826),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(2826),
    [anon_sym_type] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(2826),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(2826),
    [anon_sym_declare] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(2826),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(2826),
    [anon_sym_async] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(2826),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2432] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(1413),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_COLON] = ACTIONS(1346),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2433] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2039),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(2041),
    [anon_sym_STAR] = ACTIONS(2047),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_AMP_AMP] = ACTIONS(2045),
    [anon_sym_GT_GT_GT] = ACTIONS(2041),
    [anon_sym_DASH] = ACTIONS(2043),
    [anon_sym_BANG_EQ] = ACTIONS(2049),
    [anon_sym_LT_EQ] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2037),
    [anon_sym_GT] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2041),
    [anon_sym_QMARK] = ACTIONS(2053),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2055),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2049),
    [anon_sym_instanceof] = ACTIONS(2037),
    [anon_sym_LT] = ACTIONS(2057),
    [anon_sym_SLASH] = ACTIONS(2047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2059),
    [anon_sym_PLUS] = ACTIONS(2043),
    [anon_sym_implements] = ACTIONS(1442),
    [anon_sym_GT_GT] = ACTIONS(2047),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2049),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2037),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2434] = {
    [sym_arrow_function] = STATE(2122),
    [sym_await_expression] = STATE(2122),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2122),
    [sym_meta_property] = STATE(2122),
    [sym__expression] = STATE(2122),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2122),
    [sym_call_expression] = STATE(2122),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2122),
    [sym_string] = STATE(2122),
    [sym_template_string] = STATE(2122),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2122),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2122),
    [sym_generator_function] = STATE(2122),
    [sym_new_expression] = STATE(2122),
    [sym_assignment_expression] = STATE(2122),
    [sym_augmented_assignment_expression] = STATE(2122),
    [sym_binary_expression] = STATE(2122),
    [sym_unary_expression] = STATE(2122),
    [sym_regex] = STATE(2122),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2122),
    [sym_as_expression] = STATE(2122),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2122),
    [sym_class] = STATE(2122),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5020),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5020),
    [sym_number] = ACTIONS(5630),
    [sym_true] = ACTIONS(5020),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5020),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2435] = {
    [sym_arrow_function] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2123),
    [sym_meta_property] = STATE(2123),
    [sym__expression] = STATE(2123),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2123),
    [sym_call_expression] = STATE(2123),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2123),
    [sym_string] = STATE(2123),
    [sym_template_string] = STATE(2123),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2123),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2123),
    [sym_generator_function] = STATE(2123),
    [sym_new_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_augmented_assignment_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_regex] = STATE(2123),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2123),
    [sym_class] = STATE(2123),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5632),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5632),
    [sym_number] = ACTIONS(5634),
    [sym_true] = ACTIONS(5632),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5632),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2436] = {
    [sym_arrow_function] = STATE(2124),
    [sym_await_expression] = STATE(2124),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2124),
    [sym_meta_property] = STATE(2124),
    [sym__expression] = STATE(2124),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2124),
    [sym_call_expression] = STATE(2124),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2124),
    [sym_string] = STATE(2124),
    [sym_template_string] = STATE(2124),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2124),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2124),
    [sym_generator_function] = STATE(2124),
    [sym_new_expression] = STATE(2124),
    [sym_assignment_expression] = STATE(2124),
    [sym_augmented_assignment_expression] = STATE(2124),
    [sym_binary_expression] = STATE(2124),
    [sym_unary_expression] = STATE(2124),
    [sym_regex] = STATE(2124),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2124),
    [sym_as_expression] = STATE(2124),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2124),
    [sym_class] = STATE(2124),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5636),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5636),
    [sym_number] = ACTIONS(5638),
    [sym_true] = ACTIONS(5636),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5636),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2437] = {
    [sym_arrow_function] = STATE(2125),
    [sym_await_expression] = STATE(2125),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2125),
    [sym_meta_property] = STATE(2125),
    [sym__expression] = STATE(2125),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2125),
    [sym_call_expression] = STATE(2125),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2125),
    [sym_string] = STATE(2125),
    [sym_template_string] = STATE(2125),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2125),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2125),
    [sym_generator_function] = STATE(2125),
    [sym_new_expression] = STATE(2125),
    [sym_assignment_expression] = STATE(2125),
    [sym_augmented_assignment_expression] = STATE(2125),
    [sym_binary_expression] = STATE(2125),
    [sym_unary_expression] = STATE(2125),
    [sym_regex] = STATE(2125),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2125),
    [sym_as_expression] = STATE(2125),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2125),
    [sym_class] = STATE(2125),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5640),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5640),
    [sym_number] = ACTIONS(5642),
    [sym_true] = ACTIONS(5640),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5640),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2438] = {
    [sym_arrow_function] = STATE(2126),
    [sym_await_expression] = STATE(2126),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2126),
    [sym_meta_property] = STATE(2126),
    [sym__expression] = STATE(2126),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2126),
    [sym_call_expression] = STATE(2126),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2126),
    [sym_string] = STATE(2126),
    [sym_template_string] = STATE(2126),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2126),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2126),
    [sym_generator_function] = STATE(2126),
    [sym_new_expression] = STATE(2126),
    [sym_assignment_expression] = STATE(2126),
    [sym_augmented_assignment_expression] = STATE(2126),
    [sym_binary_expression] = STATE(2126),
    [sym_unary_expression] = STATE(2126),
    [sym_regex] = STATE(2126),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2126),
    [sym_as_expression] = STATE(2126),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2126),
    [sym_class] = STATE(2126),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5644),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5644),
    [sym_number] = ACTIONS(5646),
    [sym_true] = ACTIONS(5644),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5644),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2439] = {
    [sym_arrow_function] = STATE(2129),
    [sym_await_expression] = STATE(2129),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2129),
    [sym_meta_property] = STATE(2129),
    [sym__expression] = STATE(2129),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2129),
    [sym_call_expression] = STATE(2129),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2129),
    [sym_string] = STATE(2129),
    [sym_template_string] = STATE(2129),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2129),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2129),
    [sym_generator_function] = STATE(2129),
    [sym_new_expression] = STATE(2129),
    [sym_assignment_expression] = STATE(2129),
    [sym_augmented_assignment_expression] = STATE(2129),
    [sym_binary_expression] = STATE(2129),
    [sym_unary_expression] = STATE(2129),
    [sym_regex] = STATE(2129),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2129),
    [sym_as_expression] = STATE(2129),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2129),
    [sym_class] = STATE(2129),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5648),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5648),
    [sym_number] = ACTIONS(5650),
    [sym_true] = ACTIONS(5648),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5648),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2440] = {
    [sym_arrow_function] = STATE(2130),
    [sym_await_expression] = STATE(2130),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2130),
    [sym_meta_property] = STATE(2130),
    [sym__expression] = STATE(2130),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2130),
    [sym_call_expression] = STATE(2130),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2130),
    [sym_string] = STATE(2130),
    [sym_template_string] = STATE(2130),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2130),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2130),
    [sym_generator_function] = STATE(2130),
    [sym_new_expression] = STATE(2130),
    [sym_assignment_expression] = STATE(2130),
    [sym_augmented_assignment_expression] = STATE(2130),
    [sym_binary_expression] = STATE(2130),
    [sym_unary_expression] = STATE(2130),
    [sym_regex] = STATE(2130),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2130),
    [sym_as_expression] = STATE(2130),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2130),
    [sym_class] = STATE(2130),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5652),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5652),
    [sym_number] = ACTIONS(5654),
    [sym_true] = ACTIONS(5652),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5652),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2441] = {
    [sym_arrow_function] = STATE(2131),
    [sym_await_expression] = STATE(2131),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1437),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2131),
    [sym_meta_property] = STATE(2131),
    [sym__expression] = STATE(2131),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2131),
    [sym_call_expression] = STATE(2131),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2131),
    [sym_string] = STATE(2131),
    [sym_template_string] = STATE(2131),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2131),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2131),
    [sym_generator_function] = STATE(2131),
    [sym_new_expression] = STATE(2131),
    [sym_assignment_expression] = STATE(2131),
    [sym_augmented_assignment_expression] = STATE(2131),
    [sym_binary_expression] = STATE(2131),
    [sym_unary_expression] = STATE(2131),
    [sym_regex] = STATE(2131),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2131),
    [sym_as_expression] = STATE(2131),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2131),
    [sym_class] = STATE(2131),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5656),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5656),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5656),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5656),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5658),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5656),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2442] = {
    [sym_arrow_function] = STATE(2132),
    [sym_await_expression] = STATE(2132),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2132),
    [sym_meta_property] = STATE(2132),
    [sym__expression] = STATE(2132),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2132),
    [sym_call_expression] = STATE(2132),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2132),
    [sym_string] = STATE(2132),
    [sym_template_string] = STATE(2132),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2132),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2132),
    [sym_generator_function] = STATE(2132),
    [sym_new_expression] = STATE(2132),
    [sym_assignment_expression] = STATE(2132),
    [sym_augmented_assignment_expression] = STATE(2132),
    [sym_binary_expression] = STATE(2132),
    [sym_unary_expression] = STATE(2132),
    [sym_regex] = STATE(2132),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2132),
    [sym_as_expression] = STATE(2132),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2132),
    [sym_class] = STATE(2132),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5660),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5660),
    [sym_number] = ACTIONS(5662),
    [sym_true] = ACTIONS(5660),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5660),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2443] = {
    [sym_arrow_function] = STATE(2133),
    [sym_await_expression] = STATE(2133),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1468),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2133),
    [sym_meta_property] = STATE(2133),
    [sym__expression] = STATE(2133),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2133),
    [sym_call_expression] = STATE(2133),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2133),
    [sym_string] = STATE(2133),
    [sym_template_string] = STATE(2133),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2133),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2133),
    [sym_generator_function] = STATE(2133),
    [sym_new_expression] = STATE(2133),
    [sym_assignment_expression] = STATE(2133),
    [sym_augmented_assignment_expression] = STATE(2133),
    [sym_binary_expression] = STATE(2133),
    [sym_unary_expression] = STATE(2133),
    [sym_regex] = STATE(2133),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2133),
    [sym_as_expression] = STATE(2133),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2133),
    [sym_class] = STATE(2133),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5664),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5664),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5664),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5664),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5664),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2444] = {
    [sym_arrow_function] = STATE(2134),
    [sym_await_expression] = STATE(2134),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1470),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2134),
    [sym_meta_property] = STATE(2134),
    [sym__expression] = STATE(2134),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2134),
    [sym_call_expression] = STATE(2134),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2134),
    [sym_string] = STATE(2134),
    [sym_template_string] = STATE(2134),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2134),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2134),
    [sym_generator_function] = STATE(2134),
    [sym_new_expression] = STATE(2134),
    [sym_assignment_expression] = STATE(2134),
    [sym_augmented_assignment_expression] = STATE(2134),
    [sym_binary_expression] = STATE(2134),
    [sym_unary_expression] = STATE(2134),
    [sym_regex] = STATE(2134),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2134),
    [sym_as_expression] = STATE(2134),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2134),
    [sym_class] = STATE(2134),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5668),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5668),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5668),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5668),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5670),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5668),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2445] = {
    [sym_arrow_function] = STATE(2135),
    [sym_await_expression] = STATE(2135),
    [sym_member_expression] = STATE(2615),
    [sym_statement_block] = STATE(1473),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2135),
    [sym_meta_property] = STATE(2135),
    [sym__expression] = STATE(2135),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2135),
    [sym_call_expression] = STATE(2135),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2135),
    [sym_string] = STATE(2135),
    [sym_template_string] = STATE(2135),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2135),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2135),
    [sym_generator_function] = STATE(2135),
    [sym_new_expression] = STATE(2135),
    [sym_assignment_expression] = STATE(2135),
    [sym_augmented_assignment_expression] = STATE(2135),
    [sym_binary_expression] = STATE(2135),
    [sym_unary_expression] = STATE(2135),
    [sym_regex] = STATE(2135),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2135),
    [sym_as_expression] = STATE(2135),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2135),
    [sym_class] = STATE(2135),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5672),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5672),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5672),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5672),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5674),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5672),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2446] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2607),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2607),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(1250),
    [anon_sym_GT] = ACTIONS(2604),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(2604),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(4376),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2447] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2448] = {
    [sym_arrow_function] = STATE(2425),
    [sym_await_expression] = STATE(2425),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2425),
    [sym_meta_property] = STATE(2425),
    [sym__expression] = STATE(2425),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2425),
    [sym_call_expression] = STATE(2425),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2425),
    [sym_string] = STATE(2425),
    [sym_template_string] = STATE(2425),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2425),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2425),
    [sym_generator_function] = STATE(2425),
    [sym_new_expression] = STATE(2425),
    [sym_assignment_expression] = STATE(2425),
    [sym_augmented_assignment_expression] = STATE(2425),
    [sym_binary_expression] = STATE(2425),
    [sym_unary_expression] = STATE(2425),
    [sym_regex] = STATE(2425),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2425),
    [sym_as_expression] = STATE(2425),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2425),
    [sym_class] = STATE(2425),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5688),
    [sym_false] = ACTIONS(5396),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5396),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5396),
    [sym_number] = ACTIONS(5398),
    [sym_true] = ACTIONS(5396),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5396),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2449] = {
    [sym_arrow_function] = STATE(2424),
    [sym_await_expression] = STATE(2424),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2424),
    [sym_meta_property] = STATE(2424),
    [sym__expression] = STATE(2424),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2424),
    [sym_call_expression] = STATE(2424),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2424),
    [sym_string] = STATE(2424),
    [sym_template_string] = STATE(2424),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2424),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2424),
    [sym_generator_function] = STATE(2424),
    [sym_new_expression] = STATE(2424),
    [sym_assignment_expression] = STATE(2424),
    [sym_augmented_assignment_expression] = STATE(2424),
    [sym_binary_expression] = STATE(2424),
    [sym_unary_expression] = STATE(2424),
    [sym_regex] = STATE(2424),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2424),
    [sym_as_expression] = STATE(2424),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2424),
    [sym_class] = STATE(2424),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5690),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5690),
    [sym_number] = ACTIONS(4382),
    [sym_true] = ACTIONS(5690),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5690),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2450] = {
    [sym_arrow_function] = STATE(2608),
    [sym_await_expression] = STATE(2608),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2608),
    [sym_meta_property] = STATE(2608),
    [sym__expression] = STATE(2608),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2608),
    [sym_call_expression] = STATE(2608),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2608),
    [sym_string] = STATE(2608),
    [sym_template_string] = STATE(2608),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2608),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2608),
    [sym_generator_function] = STATE(2608),
    [sym_new_expression] = STATE(2608),
    [sym_assignment_expression] = STATE(2608),
    [sym_augmented_assignment_expression] = STATE(2608),
    [sym_binary_expression] = STATE(2608),
    [sym_unary_expression] = STATE(2608),
    [sym_regex] = STATE(2608),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2608),
    [sym_as_expression] = STATE(2608),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2608),
    [sym_class] = STATE(2608),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5555),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2621),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(5573),
    [sym_true] = ACTIONS(5557),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5557),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5557),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5571),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(5553),
  },
  [2451] = {
    [sym_arrow_function] = STATE(2136),
    [sym_await_expression] = STATE(2136),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2136),
    [sym_meta_property] = STATE(2136),
    [sym__expression] = STATE(2136),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2136),
    [sym_call_expression] = STATE(2136),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2136),
    [sym_string] = STATE(2136),
    [sym_template_string] = STATE(2136),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2136),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2136),
    [sym_generator_function] = STATE(2136),
    [sym_new_expression] = STATE(2136),
    [sym_assignment_expression] = STATE(2136),
    [sym_augmented_assignment_expression] = STATE(2136),
    [sym_binary_expression] = STATE(2136),
    [sym_unary_expression] = STATE(2136),
    [sym_regex] = STATE(2136),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2136),
    [sym_as_expression] = STATE(2136),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2136),
    [sym_class] = STATE(2136),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5692),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5692),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5692),
    [sym_number] = ACTIONS(5694),
    [sym_true] = ACTIONS(5692),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5692),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2452] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_EQ_GT] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2453] = {
    [sym_arrow_function] = STATE(2424),
    [sym_await_expression] = STATE(2424),
    [sym_member_expression] = STATE(2579),
    [sym_type_arguments] = STATE(2337),
    [sym_update_expression] = STATE(2424),
    [sym_meta_property] = STATE(2424),
    [sym__expression] = STATE(2424),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2424),
    [sym_call_expression] = STATE(2424),
    [sym_subscript_expression] = STATE(2579),
    [sym__call_signature] = STATE(2385),
    [sym_ternary_expression] = STATE(2424),
    [sym_string] = STATE(2424),
    [sym_template_string] = STATE(2424),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2424),
    [sym_object] = STATE(2582),
    [sym_type_assertion] = STATE(2424),
    [sym_generator_function] = STATE(2424),
    [sym_new_expression] = STATE(2424),
    [sym_assignment_expression] = STATE(2424),
    [sym_augmented_assignment_expression] = STATE(2424),
    [sym_binary_expression] = STATE(2424),
    [sym_unary_expression] = STATE(2424),
    [sym_regex] = STATE(2424),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2579),
    [sym_non_null_expression] = STATE(2424),
    [sym_as_expression] = STATE(2424),
    [sym_array] = STATE(2580),
    [sym_internal_module] = STATE(2424),
    [sym_class] = STATE(2424),
    [anon_sym_await] = ACTIONS(922),
    [sym_identifier] = ACTIONS(5394),
    [sym_false] = ACTIONS(5690),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(928),
    [anon_sym_symbol] = ACTIONS(928),
    [anon_sym_number] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(928),
    [anon_sym_typeof] = ACTIONS(930),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5690),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(928),
    [anon_sym_private] = ACTIONS(928),
    [anon_sym_boolean] = ACTIONS(928),
    [anon_sym_static] = ACTIONS(928),
    [anon_sym_public] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(936),
    [anon_sym_delete] = ACTIONS(930),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(938),
    [sym_this] = ACTIONS(5690),
    [sym_number] = ACTIONS(5696),
    [sym_true] = ACTIONS(5690),
    [anon_sym_yield] = ACTIONS(942),
    [anon_sym_SLASH] = ACTIONS(944),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(928),
    [anon_sym_string] = ACTIONS(928),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5690),
    [anon_sym_set] = ACTIONS(928),
    [anon_sym_type] = ACTIONS(928),
    [anon_sym_new] = ACTIONS(946),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(928),
    [anon_sym_namespace] = ACTIONS(948),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(950),
    [anon_sym_PLUS_PLUS] = ACTIONS(938),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(950),
  },
  [2454] = {
    [anon_sym_EQ_GT] = ACTIONS(5698),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [anon_sym_EQ_GT] = ACTIONS(5700),
    [sym_comment] = ACTIONS(3),
  },
  [2456] = {
    [anon_sym_EQ_GT] = ACTIONS(5702),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [anon_sym_EQ_GT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(3),
  },
  [2458] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5706),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2459] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2150),
    [sym_function_type] = STATE(2150),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2150),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2150),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2150),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2460] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2155),
    [sym_function_type] = STATE(2155),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2155),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2155),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2155),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2461] = {
    [sym_formal_parameters] = STATE(2156),
    [sym_type_parameters] = STATE(2468),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [sym_optional_parameter] = STATE(202),
    [sym__parameter_name] = STATE(203),
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2158),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_object] = STATE(482),
    [sym_accessibility_modifier] = STATE(207),
    [sym_required_parameter] = STATE(202),
    [sym_constructor_type] = STATE(2158),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2158),
    [aux_sym_export_statement_repeat1] = STATE(486),
    [sym_rest_parameter] = STATE(202),
    [sym_array] = STATE(483),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_symbol] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(1298),
    [anon_sym_private] = ACTIONS(1201),
    [anon_sym_static] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(1197),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [sym_this] = ACTIONS(1300),
    [sym_true] = ACTIONS(457),
    [anon_sym_protected] = ACTIONS(1201),
    [anon_sym_set] = ACTIONS(1197),
    [anon_sym_type] = ACTIONS(1197),
    [sym_readonly] = ACTIONS(421),
    [anon_sym_namespace] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [sym_false] = ACTIONS(457),
    [anon_sym_module] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1298),
    [anon_sym_declare] = ACTIONS(1197),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(1298),
    [anon_sym_boolean] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1197),
    [anon_sym_public] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1298),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_export] = ACTIONS(1197),
  },
  [2463] = {
    [anon_sym_DOT] = ACTIONS(4534),
    [sym_comment] = ACTIONS(3),
  },
  [2464] = {
    [sym_formal_parameters] = STATE(2162),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2465] = {
    [sym_arrow_function] = STATE(2458),
    [sym_await_expression] = STATE(2458),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2458),
    [sym_meta_property] = STATE(2458),
    [sym__expression] = STATE(2458),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2458),
    [sym_call_expression] = STATE(2458),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2458),
    [sym_string] = STATE(2458),
    [sym_template_string] = STATE(2458),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2458),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2458),
    [sym_generator_function] = STATE(2458),
    [sym_new_expression] = STATE(2458),
    [sym_assignment_expression] = STATE(2458),
    [sym_augmented_assignment_expression] = STATE(2458),
    [sym_binary_expression] = STATE(2458),
    [sym_unary_expression] = STATE(2458),
    [sym_regex] = STATE(2458),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2458),
    [sym_as_expression] = STATE(2458),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2458),
    [sym_class] = STATE(2458),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(1362),
    [sym_false] = ACTIONS(5708),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5708),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5708),
    [sym_number] = ACTIONS(5710),
    [sym_true] = ACTIONS(5708),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5708),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2466] = {
    [sym_generic_type] = STATE(236),
    [sym_type_predicate] = STATE(236),
    [sym_literal_type] = STATE(236),
    [sym__number] = STATE(222),
    [sym_object_type] = STATE(236),
    [sym_intersection_type] = STATE(2158),
    [sym_function_type] = STATE(2158),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(238),
    [sym__type] = STATE(2158),
    [sym_type_query] = STATE(236),
    [sym_index_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(222),
    [sym_type_parameters] = STATE(241),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(235),
    [sym_constructor_type] = STATE(2158),
    [sym__primary_type] = STATE(236),
    [sym_lookup_type] = STATE(236),
    [sym_parenthesized_type] = STATE(236),
    [sym_predefined_type] = STATE(236),
    [sym_tuple_type] = STATE(236),
    [sym_union_type] = STATE(2158),
    [sym_identifier] = ACTIONS(758),
    [sym_false] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_symbol] = ACTIONS(467),
    [anon_sym_number] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(471),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_void] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_any] = ACTIONS(467),
    [anon_sym_boolean] = ACTIONS(467),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [sym_this] = ACTIONS(469),
    [sym_number] = ACTIONS(479),
    [sym_true] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(467),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2467] = {
    [sym_string] = STATE(521),
    [sym_formal_parameters] = STATE(1255),
    [sym_decorator] = STATE(63),
    [sym_computed_property_name] = STATE(521),
    [sym_construct_signature] = STATE(2164),
    [sym_accessibility_modifier] = STATE(520),
    [sym_export_statement] = STATE(2164),
    [sym__property_name] = STATE(521),
    [sym_method_signature] = STATE(2164),
    [aux_sym_export_statement_repeat1] = STATE(519),
    [sym__call_signature] = STATE(2164),
    [sym_property_signature] = STATE(2164),
    [sym_type_parameters] = STATE(1793),
    [sym_index_signature] = STATE(2164),
    [sym_identifier] = ACTIONS(960),
    [anon_sym_LBRACK] = ACTIONS(962),
    [anon_sym_module] = ACTIONS(960),
    [anon_sym_symbol] = ACTIONS(960),
    [anon_sym_number] = ACTIONS(960),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(960),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_void] = ACTIONS(960),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_any] = ACTIONS(960),
    [anon_sym_private] = ACTIONS(966),
    [anon_sym_boolean] = ACTIONS(960),
    [anon_sym_static] = ACTIONS(1266),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_get] = ACTIONS(1270),
    [anon_sym_public] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(337),
    [sym_number] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(966),
    [anon_sym_string] = ACTIONS(960),
    [anon_sym_set] = ACTIONS(1270),
    [anon_sym_type] = ACTIONS(960),
    [anon_sym_new] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1278),
    [anon_sym_namespace] = ACTIONS(960),
    [sym_readonly] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(984),
  },
  [2468] = {
    [sym_formal_parameters] = STATE(2168),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [sym_arrow_function] = STATE(2585),
    [sym_await_expression] = STATE(2585),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1340),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2585),
    [sym_meta_property] = STATE(2585),
    [sym__expression] = STATE(2585),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2585),
    [sym_call_expression] = STATE(2585),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2585),
    [sym_string] = STATE(2585),
    [sym_template_string] = STATE(2585),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2585),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2585),
    [sym_generator_function] = STATE(2585),
    [sym_new_expression] = STATE(2585),
    [sym_assignment_expression] = STATE(2585),
    [sym_augmented_assignment_expression] = STATE(2585),
    [sym_binary_expression] = STATE(2585),
    [sym_unary_expression] = STATE(2585),
    [sym_regex] = STATE(2585),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2585),
    [sym_as_expression] = STATE(2585),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2585),
    [sym_class] = STATE(2585),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5712),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5712),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5712),
    [sym_number] = ACTIONS(5714),
    [sym_true] = ACTIONS(5712),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5712),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2470] = {
    [sym_arrow_function] = STATE(2593),
    [sym_await_expression] = STATE(2593),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2593),
    [sym_meta_property] = STATE(2593),
    [sym__expression] = STATE(2593),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2593),
    [sym_call_expression] = STATE(2593),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2593),
    [sym_string] = STATE(2593),
    [sym_template_string] = STATE(2593),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2593),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2593),
    [sym_generator_function] = STATE(2593),
    [sym_new_expression] = STATE(2593),
    [sym_assignment_expression] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(2593),
    [sym_binary_expression] = STATE(2593),
    [sym_unary_expression] = STATE(2593),
    [sym_regex] = STATE(2593),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2593),
    [sym_as_expression] = STATE(2593),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2593),
    [sym_class] = STATE(2593),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5716),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5716),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5716),
    [sym_number] = ACTIONS(5718),
    [sym_true] = ACTIONS(5716),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5716),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2471] = {
    [sym_arrow_function] = STATE(2594),
    [sym_await_expression] = STATE(2594),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2594),
    [sym_meta_property] = STATE(2594),
    [sym__expression] = STATE(2594),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2594),
    [sym_call_expression] = STATE(2594),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2594),
    [sym_string] = STATE(2594),
    [sym_template_string] = STATE(2594),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2594),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2594),
    [sym_generator_function] = STATE(2594),
    [sym_new_expression] = STATE(2594),
    [sym_assignment_expression] = STATE(2594),
    [sym_augmented_assignment_expression] = STATE(2594),
    [sym_binary_expression] = STATE(2594),
    [sym_unary_expression] = STATE(2594),
    [sym_regex] = STATE(2594),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2594),
    [sym_as_expression] = STATE(2594),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2594),
    [sym_class] = STATE(2594),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5720),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5720),
    [sym_number] = ACTIONS(5722),
    [sym_true] = ACTIONS(5720),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5720),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2472] = {
    [sym_arrow_function] = STATE(2586),
    [sym_await_expression] = STATE(2586),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1346),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2586),
    [sym_meta_property] = STATE(2586),
    [sym__expression] = STATE(2586),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2586),
    [sym_call_expression] = STATE(2586),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2586),
    [sym_string] = STATE(2586),
    [sym_template_string] = STATE(2586),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2586),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2586),
    [sym_generator_function] = STATE(2586),
    [sym_new_expression] = STATE(2586),
    [sym_assignment_expression] = STATE(2586),
    [sym_augmented_assignment_expression] = STATE(2586),
    [sym_binary_expression] = STATE(2586),
    [sym_unary_expression] = STATE(2586),
    [sym_regex] = STATE(2586),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2586),
    [sym_as_expression] = STATE(2586),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2586),
    [sym_class] = STATE(2586),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5724),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5724),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5724),
    [sym_number] = ACTIONS(5726),
    [sym_true] = ACTIONS(5724),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5724),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2473] = {
    [sym_arrow_function] = STATE(2595),
    [sym_await_expression] = STATE(2595),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2595),
    [sym_meta_property] = STATE(2595),
    [sym__expression] = STATE(2595),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2595),
    [sym_call_expression] = STATE(2595),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2595),
    [sym_string] = STATE(2595),
    [sym_template_string] = STATE(2595),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2595),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2595),
    [sym_generator_function] = STATE(2595),
    [sym_new_expression] = STATE(2595),
    [sym_assignment_expression] = STATE(2595),
    [sym_augmented_assignment_expression] = STATE(2595),
    [sym_binary_expression] = STATE(2595),
    [sym_unary_expression] = STATE(2595),
    [sym_regex] = STATE(2595),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2595),
    [sym_as_expression] = STATE(2595),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2595),
    [sym_class] = STATE(2595),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5728),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5728),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5728),
    [sym_number] = ACTIONS(5730),
    [sym_true] = ACTIONS(5728),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5728),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2474] = {
    [sym_arrow_function] = STATE(2596),
    [sym_await_expression] = STATE(2596),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2596),
    [sym_meta_property] = STATE(2596),
    [sym__expression] = STATE(2596),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2596),
    [sym_call_expression] = STATE(2596),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2596),
    [sym_string] = STATE(2596),
    [sym_template_string] = STATE(2596),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2596),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2596),
    [sym_generator_function] = STATE(2596),
    [sym_new_expression] = STATE(2596),
    [sym_assignment_expression] = STATE(2596),
    [sym_augmented_assignment_expression] = STATE(2596),
    [sym_binary_expression] = STATE(2596),
    [sym_unary_expression] = STATE(2596),
    [sym_regex] = STATE(2596),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2596),
    [sym_as_expression] = STATE(2596),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2596),
    [sym_class] = STATE(2596),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5732),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5732),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5732),
    [sym_number] = ACTIONS(5734),
    [sym_true] = ACTIONS(5732),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5732),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2475] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2476] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2477] = {
    [sym_arrow_function] = STATE(2608),
    [sym_await_expression] = STATE(2608),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2608),
    [sym_meta_property] = STATE(2608),
    [sym__expression] = STATE(2608),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2608),
    [sym_call_expression] = STATE(2608),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2608),
    [sym_string] = STATE(2608),
    [sym_template_string] = STATE(2608),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2608),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2608),
    [sym_generator_function] = STATE(2608),
    [sym_new_expression] = STATE(2608),
    [sym_assignment_expression] = STATE(2608),
    [sym_augmented_assignment_expression] = STATE(2608),
    [sym_binary_expression] = STATE(2608),
    [sym_unary_expression] = STATE(2608),
    [sym_regex] = STATE(2608),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2608),
    [sym_as_expression] = STATE(2608),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2608),
    [sym_class] = STATE(2608),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5555),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(5573),
    [sym_true] = ACTIONS(5557),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5585),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5557),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(5587),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5557),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5571),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(5553),
  },
  [2478] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2505),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_symbol] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_void] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_private] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_static] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_get] = ACTIONS(5738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(5738),
    [anon_sym_type] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_namespace] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(5738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_number] = ACTIONS(5738),
    [anon_sym_declare] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_boolean] = ACTIONS(5738),
    [anon_sym_async] = ACTIONS(5738),
    [anon_sym_public] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_string] = ACTIONS(5738),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2479] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LBRACE_PIPE] = ACTIONS(131),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2480] = {
    [sym_arrow_function] = STATE(2597),
    [sym_await_expression] = STATE(2597),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2597),
    [sym_meta_property] = STATE(2597),
    [sym__expression] = STATE(2597),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2597),
    [sym_call_expression] = STATE(2597),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2597),
    [sym_string] = STATE(2597),
    [sym_template_string] = STATE(2597),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2597),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2597),
    [sym_generator_function] = STATE(2597),
    [sym_new_expression] = STATE(2597),
    [sym_assignment_expression] = STATE(2597),
    [sym_augmented_assignment_expression] = STATE(2597),
    [sym_binary_expression] = STATE(2597),
    [sym_unary_expression] = STATE(2597),
    [sym_regex] = STATE(2597),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2597),
    [sym_as_expression] = STATE(2597),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2597),
    [sym_class] = STATE(2597),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5740),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5740),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5740),
    [sym_number] = ACTIONS(5742),
    [sym_true] = ACTIONS(5740),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5740),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2481] = {
    [sym_arguments] = STATE(1411),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1336),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_BQUOTE] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(1340),
    [anon_sym_LT_LT] = ACTIONS(1340),
    [anon_sym_DASH] = ACTIONS(1340),
    [anon_sym_STAR] = ACTIONS(1340),
    [anon_sym_GT_GT_GT] = ACTIONS(1340),
    [anon_sym_AMP_AMP] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_BANG_EQ] = ACTIONS(1340),
    [anon_sym_LT_EQ] = ACTIONS(1336),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_GT] = ACTIONS(1340),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(1340),
    [anon_sym_PERCENT] = ACTIONS(1340),
    [anon_sym_QMARK] = ACTIONS(1336),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_PIPE_PIPE] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_DASH_DASH] = ACTIONS(1336),
    [anon_sym_EQ_EQ] = ACTIONS(1340),
    [anon_sym_instanceof] = ACTIONS(1336),
    [anon_sym_LT] = ACTIONS(1340),
    [anon_sym_SLASH] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1340),
    [anon_sym_STAR_STAR] = ACTIONS(1340),
    [anon_sym_PLUS] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT] = ACTIONS(1340),
    [anon_sym_PLUS_PLUS] = ACTIONS(1336),
    [anon_sym_in] = ACTIONS(1340),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1336),
    [anon_sym_BANG] = ACTIONS(1340),
  },
  [2482] = {
    [sym_arguments] = STATE(1413),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1346),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2483] = {
    [sym_formal_parameters] = STATE(61),
    [sym_arguments] = STATE(1413),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2505),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(5736),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(5738),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_protected] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(5738),
    [anon_sym_type] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(5738),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(5738),
    [anon_sym_declare] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(5738),
    [anon_sym_async] = ACTIONS(5738),
    [anon_sym_public] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(5738),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
  },
  [2484] = {
    [sym_nested_identifier] = STATE(1667),
    [sym_arguments] = STATE(1413),
    [sym_string] = STATE(1668),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1346),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_instanceof] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_BANG] = ACTIONS(1350),
  },
  [2485] = {
    [sym_arrow_function] = STATE(2598),
    [sym_await_expression] = STATE(2598),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2598),
    [sym_meta_property] = STATE(2598),
    [sym__expression] = STATE(2598),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2598),
    [sym_call_expression] = STATE(2598),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2598),
    [sym_string] = STATE(2598),
    [sym_template_string] = STATE(2598),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2598),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2598),
    [sym_generator_function] = STATE(2598),
    [sym_new_expression] = STATE(2598),
    [sym_assignment_expression] = STATE(2598),
    [sym_augmented_assignment_expression] = STATE(2598),
    [sym_binary_expression] = STATE(2598),
    [sym_unary_expression] = STATE(2598),
    [sym_regex] = STATE(2598),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2598),
    [sym_as_expression] = STATE(2598),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2598),
    [sym_class] = STATE(2598),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5744),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5744),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5744),
    [sym_number] = ACTIONS(5746),
    [sym_true] = ACTIONS(5744),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5744),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2486] = {
    [sym_arrow_function] = STATE(2599),
    [sym_await_expression] = STATE(2599),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2599),
    [sym_meta_property] = STATE(2599),
    [sym__expression] = STATE(2599),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2599),
    [sym_call_expression] = STATE(2599),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2599),
    [sym_string] = STATE(2599),
    [sym_template_string] = STATE(2599),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2599),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2599),
    [sym_generator_function] = STATE(2599),
    [sym_new_expression] = STATE(2599),
    [sym_assignment_expression] = STATE(2599),
    [sym_augmented_assignment_expression] = STATE(2599),
    [sym_binary_expression] = STATE(2599),
    [sym_unary_expression] = STATE(2599),
    [sym_regex] = STATE(2599),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2599),
    [sym_as_expression] = STATE(2599),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2599),
    [sym_class] = STATE(2599),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5748),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5748),
    [sym_number] = ACTIONS(5750),
    [sym_true] = ACTIONS(5748),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5748),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2487] = {
    [sym_arrow_function] = STATE(2600),
    [sym_await_expression] = STATE(2600),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2600),
    [sym_meta_property] = STATE(2600),
    [sym__expression] = STATE(2600),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2600),
    [sym_call_expression] = STATE(2600),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2600),
    [sym_string] = STATE(2600),
    [sym_template_string] = STATE(2600),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2600),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2600),
    [sym_generator_function] = STATE(2600),
    [sym_new_expression] = STATE(2600),
    [sym_assignment_expression] = STATE(2600),
    [sym_augmented_assignment_expression] = STATE(2600),
    [sym_binary_expression] = STATE(2600),
    [sym_unary_expression] = STATE(2600),
    [sym_regex] = STATE(2600),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2600),
    [sym_as_expression] = STATE(2600),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2600),
    [sym_class] = STATE(2600),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5752),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5752),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5752),
    [sym_number] = ACTIONS(5754),
    [sym_true] = ACTIONS(5752),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5752),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2488] = {
    [sym_arrow_function] = STATE(2601),
    [sym_await_expression] = STATE(2601),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2601),
    [sym_meta_property] = STATE(2601),
    [sym__expression] = STATE(2601),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2601),
    [sym_call_expression] = STATE(2601),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2601),
    [sym_string] = STATE(2601),
    [sym_template_string] = STATE(2601),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2601),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2601),
    [sym_generator_function] = STATE(2601),
    [sym_new_expression] = STATE(2601),
    [sym_assignment_expression] = STATE(2601),
    [sym_augmented_assignment_expression] = STATE(2601),
    [sym_binary_expression] = STATE(2601),
    [sym_unary_expression] = STATE(2601),
    [sym_regex] = STATE(2601),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2601),
    [sym_as_expression] = STATE(2601),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2601),
    [sym_class] = STATE(2601),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5756),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5756),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5756),
    [sym_number] = ACTIONS(5758),
    [sym_true] = ACTIONS(5756),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5756),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2489] = {
    [sym_arrow_function] = STATE(2602),
    [sym_await_expression] = STATE(2602),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2602),
    [sym_meta_property] = STATE(2602),
    [sym__expression] = STATE(2602),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2602),
    [sym_call_expression] = STATE(2602),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2602),
    [sym_string] = STATE(2602),
    [sym_template_string] = STATE(2602),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2602),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2602),
    [sym_generator_function] = STATE(2602),
    [sym_new_expression] = STATE(2602),
    [sym_assignment_expression] = STATE(2602),
    [sym_augmented_assignment_expression] = STATE(2602),
    [sym_binary_expression] = STATE(2602),
    [sym_unary_expression] = STATE(2602),
    [sym_regex] = STATE(2602),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2602),
    [sym_as_expression] = STATE(2602),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2602),
    [sym_class] = STATE(2602),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5760),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5760),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5760),
    [sym_number] = ACTIONS(5762),
    [sym_true] = ACTIONS(5760),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5760),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2490] = {
    [sym_arrow_function] = STATE(2603),
    [sym_await_expression] = STATE(2603),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2603),
    [sym_meta_property] = STATE(2603),
    [sym__expression] = STATE(2603),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2603),
    [sym_call_expression] = STATE(2603),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2603),
    [sym_string] = STATE(2603),
    [sym_template_string] = STATE(2603),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2603),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2603),
    [sym_generator_function] = STATE(2603),
    [sym_new_expression] = STATE(2603),
    [sym_assignment_expression] = STATE(2603),
    [sym_augmented_assignment_expression] = STATE(2603),
    [sym_binary_expression] = STATE(2603),
    [sym_unary_expression] = STATE(2603),
    [sym_regex] = STATE(2603),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2603),
    [sym_as_expression] = STATE(2603),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2603),
    [sym_class] = STATE(2603),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5764),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5764),
    [sym_number] = ACTIONS(5766),
    [sym_true] = ACTIONS(5764),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5764),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2491] = {
    [sym_arrow_function] = STATE(2604),
    [sym_await_expression] = STATE(2604),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2604),
    [sym_meta_property] = STATE(2604),
    [sym__expression] = STATE(2604),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2604),
    [sym_call_expression] = STATE(2604),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2604),
    [sym_string] = STATE(2604),
    [sym_template_string] = STATE(2604),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2604),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2604),
    [sym_generator_function] = STATE(2604),
    [sym_new_expression] = STATE(2604),
    [sym_assignment_expression] = STATE(2604),
    [sym_augmented_assignment_expression] = STATE(2604),
    [sym_binary_expression] = STATE(2604),
    [sym_unary_expression] = STATE(2604),
    [sym_regex] = STATE(2604),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2604),
    [sym_as_expression] = STATE(2604),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2604),
    [sym_class] = STATE(2604),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5768),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5768),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5768),
    [sym_number] = ACTIONS(5770),
    [sym_true] = ACTIONS(5768),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5768),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2492] = {
    [sym_arrow_function] = STATE(2587),
    [sym_await_expression] = STATE(2587),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1437),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2587),
    [sym_meta_property] = STATE(2587),
    [sym__expression] = STATE(2587),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2587),
    [sym_call_expression] = STATE(2587),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2587),
    [sym_string] = STATE(2587),
    [sym_template_string] = STATE(2587),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2587),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2587),
    [sym_generator_function] = STATE(2587),
    [sym_new_expression] = STATE(2587),
    [sym_assignment_expression] = STATE(2587),
    [sym_augmented_assignment_expression] = STATE(2587),
    [sym_binary_expression] = STATE(2587),
    [sym_unary_expression] = STATE(2587),
    [sym_regex] = STATE(2587),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2587),
    [sym_as_expression] = STATE(2587),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2587),
    [sym_class] = STATE(2587),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5772),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5772),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5772),
    [sym_number] = ACTIONS(5774),
    [sym_true] = ACTIONS(5772),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5772),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2493] = {
    [sym_arrow_function] = STATE(2605),
    [sym_await_expression] = STATE(2605),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2605),
    [sym_meta_property] = STATE(2605),
    [sym__expression] = STATE(2605),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2605),
    [sym_call_expression] = STATE(2605),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2605),
    [sym_string] = STATE(2605),
    [sym_template_string] = STATE(2605),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2605),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2605),
    [sym_generator_function] = STATE(2605),
    [sym_new_expression] = STATE(2605),
    [sym_assignment_expression] = STATE(2605),
    [sym_augmented_assignment_expression] = STATE(2605),
    [sym_binary_expression] = STATE(2605),
    [sym_unary_expression] = STATE(2605),
    [sym_regex] = STATE(2605),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2605),
    [sym_as_expression] = STATE(2605),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2605),
    [sym_class] = STATE(2605),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5776),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5776),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5776),
    [sym_number] = ACTIONS(5778),
    [sym_true] = ACTIONS(5776),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5776),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2494] = {
    [sym_arrow_function] = STATE(2588),
    [sym_await_expression] = STATE(2588),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1468),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2588),
    [sym_meta_property] = STATE(2588),
    [sym__expression] = STATE(2588),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2588),
    [sym_call_expression] = STATE(2588),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2588),
    [sym_string] = STATE(2588),
    [sym_template_string] = STATE(2588),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2588),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2588),
    [sym_generator_function] = STATE(2588),
    [sym_new_expression] = STATE(2588),
    [sym_assignment_expression] = STATE(2588),
    [sym_augmented_assignment_expression] = STATE(2588),
    [sym_binary_expression] = STATE(2588),
    [sym_unary_expression] = STATE(2588),
    [sym_regex] = STATE(2588),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2588),
    [sym_as_expression] = STATE(2588),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2588),
    [sym_class] = STATE(2588),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5780),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5780),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5780),
    [sym_number] = ACTIONS(5782),
    [sym_true] = ACTIONS(5780),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5780),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2495] = {
    [sym_arrow_function] = STATE(2589),
    [sym_await_expression] = STATE(2589),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1470),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2589),
    [sym_meta_property] = STATE(2589),
    [sym__expression] = STATE(2589),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2589),
    [sym_call_expression] = STATE(2589),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2589),
    [sym_string] = STATE(2589),
    [sym_template_string] = STATE(2589),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2589),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2589),
    [sym_generator_function] = STATE(2589),
    [sym_new_expression] = STATE(2589),
    [sym_assignment_expression] = STATE(2589),
    [sym_augmented_assignment_expression] = STATE(2589),
    [sym_binary_expression] = STATE(2589),
    [sym_unary_expression] = STATE(2589),
    [sym_regex] = STATE(2589),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2589),
    [sym_as_expression] = STATE(2589),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2589),
    [sym_class] = STATE(2589),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5784),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5784),
    [sym_number] = ACTIONS(5786),
    [sym_true] = ACTIONS(5784),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5784),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2496] = {
    [sym_arrow_function] = STATE(2590),
    [sym_await_expression] = STATE(2590),
    [sym_member_expression] = STATE(2618),
    [sym_statement_block] = STATE(1473),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2590),
    [sym_meta_property] = STATE(2590),
    [sym__expression] = STATE(2590),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2590),
    [sym_call_expression] = STATE(2590),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2590),
    [sym_string] = STATE(2590),
    [sym_template_string] = STATE(2590),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2590),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2590),
    [sym_generator_function] = STATE(2590),
    [sym_new_expression] = STATE(2590),
    [sym_assignment_expression] = STATE(2590),
    [sym_augmented_assignment_expression] = STATE(2590),
    [sym_binary_expression] = STATE(2590),
    [sym_unary_expression] = STATE(2590),
    [sym_regex] = STATE(2590),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2590),
    [sym_as_expression] = STATE(2590),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2590),
    [sym_class] = STATE(2590),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5788),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(4216),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5788),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5788),
    [sym_number] = ACTIONS(5790),
    [sym_true] = ACTIONS(5788),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5788),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2497] = {
    [sym_arrow_function] = STATE(2608),
    [sym_await_expression] = STATE(2608),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2608),
    [sym_meta_property] = STATE(2608),
    [sym__expression] = STATE(2608),
    [sym_nested_identifier] = STATE(524),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2608),
    [sym_call_expression] = STATE(2608),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2608),
    [sym_string] = STATE(2608),
    [sym_template_string] = STATE(2608),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2608),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2608),
    [sym_generator_function] = STATE(2608),
    [sym_new_expression] = STATE(2608),
    [sym_assignment_expression] = STATE(2608),
    [sym_augmented_assignment_expression] = STATE(2608),
    [sym_binary_expression] = STATE(2608),
    [sym_unary_expression] = STATE(2608),
    [sym_regex] = STATE(2608),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2608),
    [sym_as_expression] = STATE(2608),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2608),
    [sym_class] = STATE(2608),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5792),
    [sym_false] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5557),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5557),
    [sym_number] = ACTIONS(5571),
    [sym_true] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2498] = {
    [sym_arrow_function] = STATE(2607),
    [sym_await_expression] = STATE(2607),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2607),
    [sym_meta_property] = STATE(2607),
    [sym__expression] = STATE(2607),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2607),
    [sym_call_expression] = STATE(2607),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2607),
    [sym_string] = STATE(2607),
    [sym_template_string] = STATE(2607),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2607),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2607),
    [sym_generator_function] = STATE(2607),
    [sym_new_expression] = STATE(2607),
    [sym_assignment_expression] = STATE(2607),
    [sym_augmented_assignment_expression] = STATE(2607),
    [sym_binary_expression] = STATE(2607),
    [sym_unary_expression] = STATE(2607),
    [sym_regex] = STATE(2607),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2607),
    [sym_as_expression] = STATE(2607),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2607),
    [sym_class] = STATE(2607),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5794),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5794),
    [sym_number] = ACTIONS(4382),
    [sym_true] = ACTIONS(5794),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5794),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2499] = {
    [sym_arrow_function] = STATE(2606),
    [sym_await_expression] = STATE(2606),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2606),
    [sym_meta_property] = STATE(2606),
    [sym__expression] = STATE(2606),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2606),
    [sym_call_expression] = STATE(2606),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2606),
    [sym_string] = STATE(2606),
    [sym_template_string] = STATE(2606),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2606),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2606),
    [sym_generator_function] = STATE(2606),
    [sym_new_expression] = STATE(2606),
    [sym_assignment_expression] = STATE(2606),
    [sym_augmented_assignment_expression] = STATE(2606),
    [sym_binary_expression] = STATE(2606),
    [sym_unary_expression] = STATE(2606),
    [sym_regex] = STATE(2606),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2606),
    [sym_as_expression] = STATE(2606),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2606),
    [sym_class] = STATE(2606),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5796),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5796),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5796),
    [sym_number] = ACTIONS(5798),
    [sym_true] = ACTIONS(5796),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5796),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2500] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2404),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(2406),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2501] = {
    [sym_arrow_function] = STATE(2607),
    [sym_await_expression] = STATE(2607),
    [sym_member_expression] = STATE(2618),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2607),
    [sym_meta_property] = STATE(2607),
    [sym__expression] = STATE(2607),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2607),
    [sym_call_expression] = STATE(2607),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2607),
    [sym_string] = STATE(2607),
    [sym_template_string] = STATE(2607),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2607),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2607),
    [sym_generator_function] = STATE(2607),
    [sym_new_expression] = STATE(2607),
    [sym_assignment_expression] = STATE(2607),
    [sym_augmented_assignment_expression] = STATE(2607),
    [sym_binary_expression] = STATE(2607),
    [sym_unary_expression] = STATE(2607),
    [sym_regex] = STATE(2607),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2607),
    [sym_as_expression] = STATE(2607),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2607),
    [sym_class] = STATE(2607),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5555),
    [sym_false] = ACTIONS(5794),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5794),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5794),
    [sym_number] = ACTIONS(5800),
    [sym_true] = ACTIONS(5794),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5794),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2502] = {
    [anon_sym_EQ_GT] = ACTIONS(5802),
    [sym_comment] = ACTIONS(3),
  },
  [2503] = {
    [anon_sym_EQ_GT] = ACTIONS(5804),
    [sym_comment] = ACTIONS(3),
  },
  [2504] = {
    [anon_sym_EQ_GT] = ACTIONS(5806),
    [sym_comment] = ACTIONS(3),
  },
  [2505] = {
    [anon_sym_EQ_GT] = ACTIONS(5808),
    [sym_comment] = ACTIONS(3),
  },
  [2506] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5810),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2507] = {
    [sym_formal_parameters] = STATE(2187),
    [sym_type_parameters] = STATE(2510),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2508] = {
    [sym_formal_parameters] = STATE(2189),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2509] = {
    [sym_arrow_function] = STATE(2506),
    [sym_await_expression] = STATE(2506),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2506),
    [sym_meta_property] = STATE(2506),
    [sym__expression] = STATE(2506),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2506),
    [sym_call_expression] = STATE(2506),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2506),
    [sym_string] = STATE(2506),
    [sym_template_string] = STATE(2506),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2506),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2506),
    [sym_generator_function] = STATE(2506),
    [sym_new_expression] = STATE(2506),
    [sym_assignment_expression] = STATE(2506),
    [sym_augmented_assignment_expression] = STATE(2506),
    [sym_binary_expression] = STATE(2506),
    [sym_unary_expression] = STATE(2506),
    [sym_regex] = STATE(2506),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2506),
    [sym_as_expression] = STATE(2506),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2506),
    [sym_class] = STATE(2506),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(1362),
    [sym_false] = ACTIONS(5812),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5812),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5812),
    [sym_number] = ACTIONS(5814),
    [sym_true] = ACTIONS(5812),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5812),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2510] = {
    [sym_formal_parameters] = STATE(2191),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2511] = {
    [sym_decorator_member_expression] = STATE(2228),
    [sym_decorator_call_expression] = STATE(81),
    [sym_identifier] = ACTIONS(5816),
    [anon_sym_module] = ACTIONS(5818),
    [anon_sym_symbol] = ACTIONS(5818),
    [anon_sym_number] = ACTIONS(5818),
    [anon_sym_declare] = ACTIONS(5818),
    [anon_sym_void] = ACTIONS(5818),
    [anon_sym_any] = ACTIONS(5818),
    [anon_sym_private] = ACTIONS(5818),
    [anon_sym_boolean] = ACTIONS(5818),
    [anon_sym_async] = ACTIONS(5818),
    [anon_sym_public] = ACTIONS(5818),
    [anon_sym_get] = ACTIONS(5818),
    [anon_sym_static] = ACTIONS(5818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5818),
    [anon_sym_string] = ACTIONS(5818),
    [anon_sym_set] = ACTIONS(5818),
    [anon_sym_type] = ACTIONS(5818),
    [anon_sym_export] = ACTIONS(5818),
    [anon_sym_namespace] = ACTIONS(5818),
  },
  [2512] = {
    [sym_arrow_function] = STATE(2235),
    [sym_await_expression] = STATE(2235),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2235),
    [sym_meta_property] = STATE(2235),
    [sym__expression] = STATE(2235),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2235),
    [sym_call_expression] = STATE(2235),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2235),
    [sym_string] = STATE(2235),
    [sym_template_string] = STATE(2235),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2235),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2235),
    [sym_generator_function] = STATE(2235),
    [sym_new_expression] = STATE(2235),
    [sym_assignment_expression] = STATE(2235),
    [sym_augmented_assignment_expression] = STATE(2235),
    [sym_binary_expression] = STATE(2235),
    [sym_unary_expression] = STATE(2235),
    [sym_regex] = STATE(2235),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2235),
    [sym_as_expression] = STATE(2235),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2235),
    [sym_class] = STATE(2235),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5352),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5352),
    [sym_number] = ACTIONS(5820),
    [sym_true] = ACTIONS(5352),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5352),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2513] = {
    [sym_arrow_function] = STATE(2237),
    [sym_await_expression] = STATE(2237),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2237),
    [sym_meta_property] = STATE(2237),
    [sym__expression] = STATE(2237),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2237),
    [sym_call_expression] = STATE(2237),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2237),
    [sym_string] = STATE(2237),
    [sym_template_string] = STATE(2237),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2237),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2237),
    [sym_generator_function] = STATE(2237),
    [sym_new_expression] = STATE(2237),
    [sym_assignment_expression] = STATE(2237),
    [sym_augmented_assignment_expression] = STATE(2237),
    [sym_binary_expression] = STATE(2237),
    [sym_unary_expression] = STATE(2237),
    [sym_regex] = STATE(2237),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2237),
    [sym_as_expression] = STATE(2237),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2237),
    [sym_class] = STATE(2237),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(4575),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(4575),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(4575),
    [sym_number] = ACTIONS(4579),
    [sym_true] = ACTIONS(4575),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(4575),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2514] = {
    [sym_arrow_function] = STATE(113),
    [sym_await_expression] = STATE(113),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(113),
    [sym_meta_property] = STATE(113),
    [sym__expression] = STATE(113),
    [sym_function] = STATE(52),
    [sym_import] = STATE(113),
    [sym_call_expression] = STATE(113),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(113),
    [sym_string] = STATE(113),
    [sym_template_string] = STATE(113),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(113),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(113),
    [sym_generator_function] = STATE(113),
    [sym_new_expression] = STATE(113),
    [sym_assignment_expression] = STATE(113),
    [sym_augmented_assignment_expression] = STATE(113),
    [sym_binary_expression] = STATE(113),
    [sym_unary_expression] = STATE(113),
    [sym_regex] = STATE(113),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(113),
    [sym_as_expression] = STATE(113),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(113),
    [sym_class] = STATE(113),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(207),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(207),
    [sym_number] = ACTIONS(209),
    [sym_true] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2515] = {
    [sym_arrow_function] = STATE(2243),
    [sym_await_expression] = STATE(2243),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2243),
    [sym_meta_property] = STATE(2243),
    [sym__expression] = STATE(2243),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2243),
    [sym_call_expression] = STATE(2243),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2243),
    [sym_string] = STATE(2243),
    [sym_template_string] = STATE(2243),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2243),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2243),
    [sym_generator_function] = STATE(2243),
    [sym_new_expression] = STATE(2243),
    [sym_assignment_expression] = STATE(2243),
    [sym_augmented_assignment_expression] = STATE(2243),
    [sym_binary_expression] = STATE(2243),
    [sym_unary_expression] = STATE(2243),
    [sym_regex] = STATE(2243),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2243),
    [sym_as_expression] = STATE(2243),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2243),
    [sym_class] = STATE(2243),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [sym_identifier] = ACTIONS(1404),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(5822),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5824),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_true] = ACTIONS(5824),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(4577),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5826),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5824),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(1430),
  },
  [2516] = {
    [anon_sym_class] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
  },
  [2517] = {
    [sym_arrow_function] = STATE(2247),
    [sym_await_expression] = STATE(2247),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2247),
    [sym_meta_property] = STATE(2247),
    [sym__expression] = STATE(2247),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2247),
    [sym_call_expression] = STATE(2247),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2247),
    [sym_string] = STATE(2247),
    [sym_template_string] = STATE(2247),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2247),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2247),
    [sym_generator_function] = STATE(2247),
    [sym_new_expression] = STATE(2247),
    [sym_assignment_expression] = STATE(2247),
    [sym_augmented_assignment_expression] = STATE(2247),
    [sym_binary_expression] = STATE(2247),
    [sym_unary_expression] = STATE(2247),
    [sym_regex] = STATE(2247),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2247),
    [sym_as_expression] = STATE(2247),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2247),
    [sym_class] = STATE(2247),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5830),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5830),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5830),
    [sym_number] = ACTIONS(5832),
    [sym_true] = ACTIONS(5830),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5830),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2518] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(245),
    [sym_identifier] = ACTIONS(5834),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
  },
  [2519] = {
    [sym_arrow_function] = STATE(247),
    [sym_await_expression] = STATE(254),
    [sym_member_expression] = STATE(253),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(254),
    [sym_meta_property] = STATE(247),
    [sym__expression] = STATE(254),
    [sym_function] = STATE(255),
    [sym_import] = STATE(247),
    [sym_call_expression] = STATE(254),
    [sym_subscript_expression] = STATE(253),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(254),
    [sym_string] = STATE(247),
    [sym_template_string] = STATE(247),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(254),
    [sym_object] = STATE(256),
    [sym_type_assertion] = STATE(254),
    [sym_generator_function] = STATE(247),
    [sym_new_expression] = STATE(247),
    [sym_assignment_expression] = STATE(254),
    [sym_augmented_assignment_expression] = STATE(254),
    [sym_binary_expression] = STATE(254),
    [sym_unary_expression] = STATE(254),
    [sym_regex] = STATE(247),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(253),
    [sym_non_null_expression] = STATE(254),
    [sym_as_expression] = STATE(254),
    [sym_array] = STATE(257),
    [sym_internal_module] = STATE(254),
    [sym_class] = STATE(247),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [sym_identifier] = ACTIONS(5354),
    [sym_false] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(5356),
    [anon_sym_symbol] = ACTIONS(5356),
    [anon_sym_number] = ACTIONS(5356),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(5356),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(5358),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(511),
    [sym_super] = ACTIONS(505),
    [anon_sym_any] = ACTIONS(5356),
    [anon_sym_private] = ACTIONS(5356),
    [anon_sym_boolean] = ACTIONS(5356),
    [anon_sym_static] = ACTIONS(5356),
    [anon_sym_public] = ACTIONS(5356),
    [anon_sym_get] = ACTIONS(5356),
    [anon_sym_async] = ACTIONS(5360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(511),
    [sym_number] = ACTIONS(523),
    [sym_true] = ACTIONS(511),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5356),
    [anon_sym_string] = ACTIONS(5356),
    [anon_sym_function] = ACTIONS(167),
    [anon_sym_DOT] = ACTIONS(515),
    [sym_undefined] = ACTIONS(511),
    [anon_sym_set] = ACTIONS(5356),
    [anon_sym_type] = ACTIONS(5356),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(5356),
    [anon_sym_namespace] = ACTIONS(5362),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2520] = {
    [sym_arrow_function] = STATE(2267),
    [sym_await_expression] = STATE(2267),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(2267),
    [sym_meta_property] = STATE(2267),
    [sym__expression] = STATE(2267),
    [sym_function] = STATE(52),
    [sym_import] = STATE(2267),
    [sym_call_expression] = STATE(2267),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(2267),
    [sym_string] = STATE(2267),
    [sym_template_string] = STATE(2267),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2267),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(2267),
    [sym_generator_function] = STATE(2267),
    [sym_new_expression] = STATE(2267),
    [sym_assignment_expression] = STATE(2267),
    [sym_augmented_assignment_expression] = STATE(2267),
    [sym_binary_expression] = STATE(2267),
    [sym_unary_expression] = STATE(2267),
    [sym_regex] = STATE(2267),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(2267),
    [sym_as_expression] = STATE(2267),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(2267),
    [sym_class] = STATE(2267),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(5838),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(5838),
    [sym_number] = ACTIONS(5840),
    [sym_true] = ACTIONS(5838),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(5838),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2521] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_AMP_EQ] = ACTIONS(4561),
    [anon_sym_PLUS_EQ] = ACTIONS(4561),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(4563),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(4561),
    [anon_sym_STAR_EQ] = ACTIONS(4561),
    [anon_sym_PIPE_EQ] = ACTIONS(4561),
    [anon_sym_DASH_EQ] = ACTIONS(4561),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(4561),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT_EQ] = ACTIONS(4561),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4561),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2522] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2523] = {
    [sym_arrow_function] = STATE(283),
    [sym_await_expression] = STATE(283),
    [sym_member_expression] = STATE(2521),
    [sym_type_arguments] = STATE(2523),
    [sym_update_expression] = STATE(283),
    [sym_meta_property] = STATE(283),
    [sym__expression] = STATE(283),
    [sym_function] = STATE(52),
    [sym_import] = STATE(283),
    [sym_call_expression] = STATE(283),
    [sym_subscript_expression] = STATE(2521),
    [sym__call_signature] = STATE(2524),
    [sym_ternary_expression] = STATE(283),
    [sym_string] = STATE(283),
    [sym_template_string] = STATE(283),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(283),
    [sym_object] = STATE(2525),
    [sym_type_assertion] = STATE(283),
    [sym_generator_function] = STATE(283),
    [sym_new_expression] = STATE(283),
    [sym_assignment_expression] = STATE(283),
    [sym_augmented_assignment_expression] = STATE(283),
    [sym_binary_expression] = STATE(283),
    [sym_unary_expression] = STATE(283),
    [sym_regex] = STATE(283),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_parenthesized_expression] = STATE(2521),
    [sym_non_null_expression] = STATE(283),
    [sym_as_expression] = STATE(283),
    [sym_array] = STATE(2522),
    [sym_internal_module] = STATE(283),
    [sym_class] = STATE(283),
    [anon_sym_await] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1404),
    [sym_false] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1406),
    [anon_sym_symbol] = ACTIONS(1406),
    [anon_sym_number] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(1406),
    [anon_sym_typeof] = ACTIONS(1412),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_void] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(617),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1406),
    [anon_sym_private] = ACTIONS(1406),
    [anon_sym_boolean] = ACTIONS(1406),
    [anon_sym_static] = ACTIONS(1406),
    [anon_sym_public] = ACTIONS(1406),
    [anon_sym_get] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1424),
    [anon_sym_delete] = ACTIONS(1412),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_DASH_DASH] = ACTIONS(1414),
    [sym_this] = ACTIONS(617),
    [sym_number] = ACTIONS(619),
    [sym_true] = ACTIONS(617),
    [anon_sym_yield] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(91),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1406),
    [anon_sym_string] = ACTIONS(1406),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(617),
    [anon_sym_set] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_new] = ACTIONS(1428),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_export] = ACTIONS(1406),
    [anon_sym_namespace] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_TILDE] = ACTIONS(1422),
    [anon_sym_PLUS_PLUS] = ACTIONS(1414),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(1422),
  },
  [2524] = {
    [anon_sym_EQ_GT] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
  },
  [2525] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym__automatic_semicolon] = ACTIONS(109),
    [anon_sym_SEMI] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5846),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2526] = {
    [sym_identifier] = ACTIONS(5848),
    [sym_comment] = ACTIONS(3),
  },
  [2527] = {
    [sym_type_parameters] = STATE(2540),
    [anon_sym_EQ] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2528] = {
    [sym_arrow_function] = STATE(2543),
    [sym_await_expression] = STATE(2543),
    [sym_member_expression] = STATE(2618),
    [sym_generic_type] = STATE(2626),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2543),
    [sym_meta_property] = STATE(2543),
    [sym__expression] = STATE(2543),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(2627),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2543),
    [sym_call_expression] = STATE(2543),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2543),
    [sym_string] = STATE(2543),
    [sym_template_string] = STATE(2543),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2543),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2543),
    [sym_generator_function] = STATE(2543),
    [sym_new_expression] = STATE(2543),
    [sym_assignment_expression] = STATE(2543),
    [sym_augmented_assignment_expression] = STATE(2543),
    [sym_binary_expression] = STATE(2543),
    [sym_unary_expression] = STATE(2543),
    [sym_regex] = STATE(2543),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2543),
    [sym_as_expression] = STATE(2543),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2543),
    [sym_class] = STATE(2543),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5852),
    [sym_false] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5854),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5854),
    [sym_number] = ACTIONS(5856),
    [sym_true] = ACTIONS(5854),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5854),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2529] = {
    [sym_identifier] = ACTIONS(5858),
    [anon_sym_STAR] = ACTIONS(5860),
    [sym_comment] = ACTIONS(3),
  },
  [2530] = {
    [sym_identifier] = ACTIONS(5862),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [sym_identifier] = ACTIONS(5864),
    [sym_comment] = ACTIONS(3),
  },
  [2532] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(5866),
    [sym_comment] = ACTIONS(3),
  },
  [2533] = {
    [anon_sym_EQ_GT] = ACTIONS(5868),
    [sym_comment] = ACTIONS(3),
  },
  [2534] = {
    [anon_sym_EQ_GT] = ACTIONS(5870),
    [sym_comment] = ACTIONS(3),
  },
  [2535] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(489),
    [sym_identifier] = ACTIONS(5872),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_STAR] = ACTIONS(5874),
    [sym_comment] = ACTIONS(3),
  },
  [2536] = {
    [anon_sym_EQ_GT] = ACTIONS(5876),
    [sym_comment] = ACTIONS(3),
  },
  [2537] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(552),
    [sym_identifier] = ACTIONS(5878),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [anon_sym_namespace] = ACTIONS(5880),
    [sym_comment] = ACTIONS(3),
  },
  [2539] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(2539),
    [anon_sym_LBRACK] = ACTIONS(1724),
    [sym_identifier] = ACTIONS(5882),
    [anon_sym_module] = ACTIONS(5882),
    [anon_sym_symbol] = ACTIONS(5882),
    [anon_sym_number] = ACTIONS(5882),
    [anon_sym_class] = ACTIONS(5882),
    [anon_sym_AT] = ACTIONS(5884),
    [anon_sym_declare] = ACTIONS(5882),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(1724),
    [anon_sym_void] = ACTIONS(5882),
    [anon_sym_any] = ACTIONS(5882),
    [anon_sym_private] = ACTIONS(5882),
    [anon_sym_boolean] = ACTIONS(5882),
    [anon_sym_static] = ACTIONS(5882),
    [anon_sym_public] = ACTIONS(5882),
    [anon_sym_get] = ACTIONS(5882),
    [anon_sym_async] = ACTIONS(5882),
    [sym_this] = ACTIONS(5882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5882),
    [anon_sym_string] = ACTIONS(5882),
    [anon_sym_set] = ACTIONS(5882),
    [anon_sym_type] = ACTIONS(5882),
    [anon_sym_export] = ACTIONS(5882),
    [sym_readonly] = ACTIONS(5882),
    [anon_sym_namespace] = ACTIONS(5882),
  },
  [2540] = {
    [anon_sym_EQ] = ACTIONS(5887),
    [sym_comment] = ACTIONS(3),
  },
  [2541] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(53),
    [sym_array] = STATE(54),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(53),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(53),
    [sym_expression_statement] = STATE(2309),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(64),
    [sym_generator_function] = STATE(51),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2309),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(151),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(149),
    [anon_sym_static] = ACTIONS(149),
    [anon_sym_get] = ACTIONS(149),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(149),
    [anon_sym_set] = ACTIONS(149),
    [anon_sym_type] = ACTIONS(149),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(149),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_public] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [2542] = {
    [aux_sym_extends_clause_repeat1] = STATE(2550),
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(5891),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2024),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(2033),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2543] = {
    [sym_arguments] = STATE(1272),
    [aux_sym_extends_clause_repeat1] = STATE(2551),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5905),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2035),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2544] = {
    [sym_string] = STATE(2310),
    [sym__property_name] = STATE(2310),
    [sym_computed_property_name] = STATE(2310),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(3240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2545] = {
    [sym_identifier] = ACTIONS(5919),
    [anon_sym_STAR] = ACTIONS(5921),
    [sym_comment] = ACTIONS(3),
  },
  [2546] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2312),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2547] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(761),
    [sym_identifier] = ACTIONS(5923),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2548] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(1372),
    [anon_sym_LT_LT] = ACTIONS(1374),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1378),
    [anon_sym_GT_GT_GT] = ACTIONS(1374),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_BANG_EQ] = ACTIONS(1382),
    [anon_sym_LT_EQ] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(1370),
    [anon_sym_GT] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1374),
    [anon_sym_QMARK] = ACTIONS(1386),
    [anon_sym_PIPE_PIPE] = ACTIONS(1388),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(1382),
    [anon_sym_instanceof] = ACTIONS(1370),
    [anon_sym_LT] = ACTIONS(1390),
    [anon_sym_SLASH] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5925),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(1388),
    [anon_sym_STAR_STAR] = ACTIONS(1392),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(1382),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1370),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2549] = {
    [sym_arrow_function] = STATE(2563),
    [sym_await_expression] = STATE(2563),
    [sym_member_expression] = STATE(2618),
    [sym_generic_type] = STATE(910),
    [sym_type_arguments] = STATE(2412),
    [sym_update_expression] = STATE(2563),
    [sym_meta_property] = STATE(2563),
    [sym__expression] = STATE(2563),
    [sym_nested_identifier] = STATE(237),
    [sym_nested_type_identifier] = STATE(912),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2563),
    [sym_call_expression] = STATE(2563),
    [sym_subscript_expression] = STATE(2618),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(2563),
    [sym_string] = STATE(2563),
    [sym_template_string] = STATE(2563),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2563),
    [sym_object] = STATE(2620),
    [sym_type_assertion] = STATE(2563),
    [sym_generator_function] = STATE(2563),
    [sym_new_expression] = STATE(2563),
    [sym_assignment_expression] = STATE(2563),
    [sym_augmented_assignment_expression] = STATE(2563),
    [sym_binary_expression] = STATE(2563),
    [sym_unary_expression] = STATE(2563),
    [sym_regex] = STATE(2563),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_non_null_expression] = STATE(2563),
    [sym_as_expression] = STATE(2563),
    [sym_array] = STATE(2619),
    [sym_internal_module] = STATE(2563),
    [sym_class] = STATE(2563),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5927),
    [sym_false] = ACTIONS(5929),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5559),
    [anon_sym_number] = ACTIONS(5559),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5561),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5563),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5565),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5929),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5559),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5559),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(5929),
    [sym_number] = ACTIONS(5931),
    [sym_true] = ACTIONS(5929),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5559),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5929),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5563),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2550] = {
    [aux_sym_extends_clause_repeat1] = STATE(2564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2874),
    [anon_sym_COMMA] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5933),
  },
  [2551] = {
    [aux_sym_extends_clause_repeat1] = STATE(2564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2876),
    [anon_sym_COMMA] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5935),
  },
  [2552] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_AMP_EQ] = ACTIONS(1125),
    [anon_sym_PLUS_EQ] = ACTIONS(1125),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(3774),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(1125),
    [anon_sym_STAR_EQ] = ACTIONS(1125),
    [anon_sym_PIPE_EQ] = ACTIONS(1125),
    [anon_sym_DASH_EQ] = ACTIONS(1125),
    [anon_sym_EQ_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(1125),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2906),
    [anon_sym_SLASH_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT_EQ] = ACTIONS(1125),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1125),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2553] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(131),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2554] = {
    [sym_arrow_function] = STATE(1271),
    [sym_await_expression] = STATE(1271),
    [sym_member_expression] = STATE(1251),
    [sym_type_arguments] = STATE(1254),
    [sym_update_expression] = STATE(1271),
    [sym_meta_property] = STATE(1271),
    [sym__expression] = STATE(1271),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1271),
    [sym_call_expression] = STATE(1271),
    [sym_subscript_expression] = STATE(1251),
    [sym__call_signature] = STATE(1792),
    [sym_ternary_expression] = STATE(1271),
    [sym_string] = STATE(1271),
    [sym_template_string] = STATE(1271),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1271),
    [sym_object] = STATE(1256),
    [sym_type_assertion] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_new_expression] = STATE(1271),
    [sym_assignment_expression] = STATE(1271),
    [sym_augmented_assignment_expression] = STATE(1271),
    [sym_binary_expression] = STATE(1271),
    [sym_unary_expression] = STATE(1271),
    [sym_regex] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_non_null_expression] = STATE(1271),
    [sym_as_expression] = STATE(1271),
    [sym_array] = STATE(1252),
    [sym_internal_module] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(269),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(273),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(275),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(269),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(269),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(279),
    [anon_sym_DASH_DASH] = ACTIONS(281),
    [anon_sym_instanceof] = ACTIONS(135),
    [sym_this] = ACTIONS(1153),
    [anon_sym_yield] = ACTIONS(285),
    [sym_true] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(269),
    [anon_sym_type] = ACTIONS(269),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(289),
    [anon_sym_PLUS_PLUS] = ACTIONS(281),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1153),
    [anon_sym_module] = ACTIONS(269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(269),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(269),
    [anon_sym_typeof] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(131),
    [sym_null] = ACTIONS(1153),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(269),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(269),
    [anon_sym_async] = ACTIONS(307),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(1159),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(269),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1153),
    [anon_sym_new] = ACTIONS(317),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(273),
    [anon_sym_export] = ACTIONS(269),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_TILDE] = ACTIONS(293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_await] = ACTIONS(319),
  },
  [2555] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(1837),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1161),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_symbol] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_void] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_private] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_static] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_get] = ACTIONS(1163),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_set] = ACTIONS(1163),
    [anon_sym_type] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_namespace] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(131),
    [anon_sym_module] = ACTIONS(1163),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_declare] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_boolean] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1163),
    [anon_sym_public] = ACTIONS(1163),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(440),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_string] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(1163),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
  },
  [2556] = {
    [sym_string] = STATE(1668),
    [sym_nested_identifier] = STATE(1667),
    [sym__module] = STATE(1587),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(131),
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_BQUOTE] = ACTIONS(131),
    [anon_sym_PERCENT_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_AMP_EQ] = ACTIONS(1139),
    [anon_sym_PLUS_EQ] = ACTIONS(1139),
    [anon_sym_PIPE] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LT_LT] = ACTIONS(135),
    [anon_sym_STAR] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(131),
    [anon_sym_DASH] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4240),
    [anon_sym_BANG_EQ] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(131),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_GT_EQ] = ACTIONS(131),
    [anon_sym_GT] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1139),
    [anon_sym_STAR_EQ] = ACTIONS(1139),
    [anon_sym_PIPE_EQ] = ACTIONS(1139),
    [anon_sym_DASH_EQ] = ACTIONS(1139),
    [anon_sym_EQ_GT] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(135),
    [anon_sym_QMARK] = ACTIONS(131),
    [anon_sym_LT_LT_EQ] = ACTIONS(1139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(131),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(131),
    [anon_sym_EQ_EQ] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(135),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2910),
    [anon_sym_SLASH_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT_EQ] = ACTIONS(1139),
    [anon_sym_DOT] = ACTIONS(1149),
    [anon_sym_CARET] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(135),
    [anon_sym_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1139),
    [anon_sym_GT_GT] = ACTIONS(135),
    [anon_sym_PLUS_PLUS] = ACTIONS(131),
    [anon_sym_in] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(131),
    [anon_sym_BANG] = ACTIONS(135),
  },
  [2557] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2558] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(5515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2559] = {
    [sym_string] = STATE(2321),
    [sym__property_name] = STATE(2321),
    [sym_computed_property_name] = STATE(2321),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(3709),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(5937),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(5937),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2560] = {
    [sym_formal_parameters] = STATE(1255),
    [sym_type_parameters] = STATE(1793),
    [sym__call_signature] = STATE(2322),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [2561] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2323),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2562] = {
    [sym_type_arguments] = STATE(506),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(3495),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(5939),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_EQ_GT] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3495),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(2033),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2563] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(3497),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_LBRACE] = ACTIONS(3499),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3497),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2564] = {
    [aux_sym_extends_clause_repeat1] = STATE(2564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3497),
    [anon_sym_COMMA] = ACTIONS(5941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3499),
  },
  [2565] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2566] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(5523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2567] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(4019),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(5944),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(5944),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2568] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2326),
    [anon_sym_LT] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [2569] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2570] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2571] = {
    [sym_string] = STATE(2328),
    [sym__property_name] = STATE(2328),
    [sym_computed_property_name] = STATE(2328),
    [sym__automatic_semicolon] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(5946),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_get] = ACTIONS(5948),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(5948),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2572] = {
    [sym_string] = STATE(2330),
    [sym__property_name] = STATE(2330),
    [sym_computed_property_name] = STATE(2330),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1783),
    [sym_number] = ACTIONS(5950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2573] = {
    [sym_string] = STATE(2330),
    [sym__property_name] = STATE(2330),
    [sym_computed_property_name] = STATE(2330),
    [anon_sym_get] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1047),
    [anon_sym_public] = ACTIONS(1047),
    [anon_sym_module] = ACTIONS(1047),
    [anon_sym_SQUOTE] = ACTIONS(329),
    [anon_sym_number] = ACTIONS(1047),
    [anon_sym_symbol] = ACTIONS(1047),
    [anon_sym_declare] = ACTIONS(1047),
    [sym_number] = ACTIONS(5950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1047),
    [anon_sym_protected] = ACTIONS(1047),
    [anon_sym_string] = ACTIONS(1047),
    [anon_sym_set] = ACTIONS(1047),
    [anon_sym_type] = ACTIONS(1047),
    [anon_sym_export] = ACTIONS(1047),
    [anon_sym_namespace] = ACTIONS(1047),
    [anon_sym_any] = ACTIONS(1047),
    [anon_sym_private] = ACTIONS(1047),
    [anon_sym_boolean] = ACTIONS(1047),
    [anon_sym_static] = ACTIONS(1047),
    [anon_sym_DQUOTE] = ACTIONS(327),
  },
  [2574] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(1356),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2575] = {
    [sym_arrow_function] = STATE(1273),
    [sym_await_expression] = STATE(1273),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1273),
    [sym_meta_property] = STATE(1273),
    [sym__expression] = STATE(1273),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1273),
    [sym_call_expression] = STATE(1273),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1273),
    [sym_string] = STATE(1273),
    [sym_template_string] = STATE(1273),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1273),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(1273),
    [sym_generator_function] = STATE(1273),
    [sym_new_expression] = STATE(1273),
    [sym_assignment_expression] = STATE(1273),
    [sym_augmented_assignment_expression] = STATE(1273),
    [sym_binary_expression] = STATE(1273),
    [sym_unary_expression] = STATE(1273),
    [sym_regex] = STATE(1273),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(1273),
    [sym_as_expression] = STATE(1273),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(1273),
    [sym_class] = STATE(1273),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4188),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4188),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4188),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4188),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4190),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4188),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2576] = {
    [sym_arrow_function] = STATE(2352),
    [sym_await_expression] = STATE(2352),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2352),
    [sym_meta_property] = STATE(2352),
    [sym__expression] = STATE(2352),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2352),
    [sym_call_expression] = STATE(2352),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2352),
    [sym_string] = STATE(2352),
    [sym_template_string] = STATE(2352),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2352),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2352),
    [sym_generator_function] = STATE(2352),
    [sym_new_expression] = STATE(2352),
    [sym_assignment_expression] = STATE(2352),
    [sym_augmented_assignment_expression] = STATE(2352),
    [sym_binary_expression] = STATE(2352),
    [sym_unary_expression] = STATE(2352),
    [sym_regex] = STATE(2352),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2352),
    [sym_as_expression] = STATE(2352),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2352),
    [sym_class] = STATE(2352),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_STAR] = ACTIONS(5952),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(215),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [anon_sym_instanceof] = ACTIONS(215),
    [sym_this] = ACTIONS(5954),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_DOT] = ACTIONS(215),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5954),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_RBRACK] = ACTIONS(213),
    [sym_null] = ACTIONS(5954),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(175),
    [sym_number] = ACTIONS(5956),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5954),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_await] = ACTIONS(525),
  },
  [2577] = {
    [sym_arrow_function] = STATE(2353),
    [sym_await_expression] = STATE(2353),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2353),
    [sym_meta_property] = STATE(2353),
    [sym__expression] = STATE(2353),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2353),
    [sym_call_expression] = STATE(2353),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2353),
    [sym_string] = STATE(2353),
    [sym_template_string] = STATE(2353),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2353),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2353),
    [sym_generator_function] = STATE(2353),
    [sym_new_expression] = STATE(2353),
    [sym_assignment_expression] = STATE(2353),
    [sym_augmented_assignment_expression] = STATE(2353),
    [sym_binary_expression] = STATE(2353),
    [sym_unary_expression] = STATE(2353),
    [sym_regex] = STATE(2353),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2353),
    [sym_as_expression] = STATE(2353),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2353),
    [sym_class] = STATE(2353),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5958),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5958),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5958),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5958),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5960),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5958),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2578] = {
    [sym_arrow_function] = STATE(2359),
    [sym_await_expression] = STATE(2359),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2359),
    [sym_meta_property] = STATE(2359),
    [sym__expression] = STATE(2359),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2359),
    [sym_call_expression] = STATE(2359),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2359),
    [sym_string] = STATE(2359),
    [sym_template_string] = STATE(2359),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2359),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2359),
    [sym_generator_function] = STATE(2359),
    [sym_new_expression] = STATE(2359),
    [sym_assignment_expression] = STATE(2359),
    [sym_augmented_assignment_expression] = STATE(2359),
    [sym_binary_expression] = STATE(2359),
    [sym_unary_expression] = STATE(2359),
    [sym_regex] = STATE(2359),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2359),
    [sym_as_expression] = STATE(2359),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2359),
    [sym_class] = STATE(2359),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(5962),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(5962),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(5962),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(5962),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(5964),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5962),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2579] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_AMP_EQ] = ACTIONS(2020),
    [anon_sym_PLUS_EQ] = ACTIONS(2020),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(2020),
    [anon_sym_STAR_EQ] = ACTIONS(2020),
    [anon_sym_PIPE_EQ] = ACTIONS(2020),
    [anon_sym_DASH_EQ] = ACTIONS(2020),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(2020),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2020),
    [anon_sym_GT_GT_EQ] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2580] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5966),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2581] = {
    [sym_arrow_function] = STATE(1333),
    [sym_await_expression] = STATE(1333),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1333),
    [sym_meta_property] = STATE(1333),
    [sym__expression] = STATE(1333),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(1333),
    [sym_call_expression] = STATE(1333),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(1333),
    [sym_string] = STATE(1333),
    [sym_template_string] = STATE(1333),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1333),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(1333),
    [sym_generator_function] = STATE(1333),
    [sym_new_expression] = STATE(1333),
    [sym_assignment_expression] = STATE(1333),
    [sym_augmented_assignment_expression] = STATE(1333),
    [sym_binary_expression] = STATE(1333),
    [sym_unary_expression] = STATE(1333),
    [sym_regex] = STATE(1333),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(1333),
    [sym_as_expression] = STATE(1333),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(1333),
    [sym_class] = STATE(1333),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_void] = ACTIONS(1364),
    [sym_super] = ACTIONS(277),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(4208),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(295),
    [sym_false] = ACTIONS(4208),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(4210),
    [anon_sym_SLASH] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(4208),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_await] = ACTIONS(525),
  },
  [2582] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5968),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_implements] = ACTIONS(109),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2583] = {
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_arguments] = STATE(1413),
    [sym__expression] = STATE(2350),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2350),
    [sym_string] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2350),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_new_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1346),
    [sym_identifier] = ACTIONS(1362),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_PERCENT_EQ] = ACTIONS(1348),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_AMP_EQ] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1348),
    [anon_sym_PIPE] = ACTIONS(1350),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_DASH] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(1350),
    [anon_sym_GT_GT_GT] = ACTIONS(1350),
    [anon_sym_EQ] = ACTIONS(1352),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_BANG_EQ] = ACTIONS(1350),
    [anon_sym_GT_EQ] = ACTIONS(1346),
    [sym_super] = ACTIONS(277),
    [anon_sym_CARET_EQ] = ACTIONS(1348),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_PIPE_EQ] = ACTIONS(1348),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_DASH_EQ] = ACTIONS(1348),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1346),
    [anon_sym_PERCENT] = ACTIONS(1350),
    [anon_sym_LT_LT_EQ] = ACTIONS(1348),
    [anon_sym_as] = ACTIONS(1350),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(1346),
    [anon_sym_instanceof] = ACTIONS(1350),
    [sym_this] = ACTIONS(1356),
    [anon_sym_yield] = ACTIONS(513),
    [sym_true] = ACTIONS(1356),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_STAR_STAR] = ACTIONS(1350),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1348),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS_PLUS] = ACTIONS(1346),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1346),
    [sym_false] = ACTIONS(1356),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1348),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(1350),
    [anon_sym_LBRACE] = ACTIONS(1350),
    [anon_sym_AMP_AMP] = ACTIONS(1346),
    [anon_sym_LT_EQ] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1346),
    [sym_null] = ACTIONS(1356),
    [anon_sym_GT] = ACTIONS(1350),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_STAR_EQ] = ACTIONS(1348),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_EQ_GT] = ACTIONS(5686),
    [anon_sym_AMP] = ACTIONS(1350),
    [anon_sym_QMARK] = ACTIONS(1346),
    [anon_sym_PIPE_PIPE] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_EQ_EQ] = ACTIONS(1350),
    [anon_sym_LT] = ACTIONS(1350),
    [sym_number] = ACTIONS(1368),
    [anon_sym_SLASH] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1348),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(1356),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_CARET] = ACTIONS(1350),
    [anon_sym_PLUS] = ACTIONS(1350),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_GT_GT] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1346),
    [anon_sym_await] = ACTIONS(525),
  },
  [2584] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(844),
    [sym_formal_parameters] = STATE(845),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(5970),
    [sym_false] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(5972),
    [anon_sym_symbol] = ACTIONS(5972),
    [anon_sym_number] = ACTIONS(5972),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5972),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5972),
    [anon_sym_private] = ACTIONS(5972),
    [anon_sym_boolean] = ACTIONS(5972),
    [anon_sym_static] = ACTIONS(5972),
    [anon_sym_public] = ACTIONS(5972),
    [anon_sym_get] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(5976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [sym_number] = ACTIONS(4398),
    [sym_true] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5972),
    [anon_sym_string] = ACTIONS(5972),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_DOT] = ACTIONS(4392),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_set] = ACTIONS(5972),
    [anon_sym_type] = ACTIONS(5972),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5972),
    [anon_sym_namespace] = ACTIONS(5978),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2585] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1729),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2586] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2587] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(2657),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2657),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2588] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2589] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2590] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3130),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2591] = {
    [sym_arrow_function] = STATE(1310),
    [sym_await_expression] = STATE(1854),
    [sym_member_expression] = STATE(1315),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(1854),
    [sym_meta_property] = STATE(1310),
    [sym__expression] = STATE(1854),
    [sym_function] = STATE(1316),
    [sym_import] = STATE(1310),
    [sym_call_expression] = STATE(1854),
    [sym_subscript_expression] = STATE(1315),
    [sym__call_signature] = STATE(2502),
    [sym_ternary_expression] = STATE(1854),
    [sym_string] = STATE(1310),
    [sym_template_string] = STATE(1310),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(1854),
    [sym_object] = STATE(1317),
    [sym_type_assertion] = STATE(1854),
    [sym_generator_function] = STATE(1310),
    [sym_new_expression] = STATE(1310),
    [sym_assignment_expression] = STATE(1854),
    [sym_augmented_assignment_expression] = STATE(1854),
    [sym_binary_expression] = STATE(1854),
    [sym_unary_expression] = STATE(1854),
    [sym_regex] = STATE(1310),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1315),
    [sym_non_null_expression] = STATE(1854),
    [sym_as_expression] = STATE(1854),
    [sym_array] = STATE(1318),
    [sym_internal_module] = STATE(1854),
    [sym_class] = STATE(1310),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [sym_identifier] = ACTIONS(5970),
    [sym_false] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_await] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(5972),
    [anon_sym_symbol] = ACTIONS(5972),
    [anon_sym_number] = ACTIONS(5972),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5972),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(5974),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(4390),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5972),
    [anon_sym_private] = ACTIONS(5972),
    [anon_sym_boolean] = ACTIONS(5972),
    [anon_sym_static] = ACTIONS(5972),
    [anon_sym_public] = ACTIONS(5972),
    [anon_sym_get] = ACTIONS(5972),
    [anon_sym_async] = ACTIONS(5976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(4390),
    [sym_number] = ACTIONS(4398),
    [sym_true] = ACTIONS(4390),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5972),
    [anon_sym_string] = ACTIONS(5972),
    [anon_sym_function] = ACTIONS(315),
    [anon_sym_DOT] = ACTIONS(4392),
    [sym_undefined] = ACTIONS(4390),
    [anon_sym_set] = ACTIONS(5972),
    [anon_sym_type] = ACTIONS(5972),
    [anon_sym_new] = ACTIONS(5575),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5972),
    [anon_sym_namespace] = ACTIONS(5978),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2592] = {
    [sym_await_expression] = STATE(2598),
    [sym_type_predicate] = STATE(236),
    [sym__number] = STATE(222),
    [sym_update_expression] = STATE(2598),
    [sym_object_type] = STATE(236),
    [sym_meta_property] = STATE(2598),
    [sym_function_type] = STATE(240),
    [sym__expression] = STATE(2598),
    [sym_nested_identifier] = STATE(237),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2598),
    [sym_call_expression] = STATE(2598),
    [sym_type_query] = STATE(236),
    [sym_existential_type] = STATE(236),
    [sym_ternary_expression] = STATE(2598),
    [sym_template_string] = STATE(2598),
    [sym_yield_expression] = STATE(2598),
    [sym_type_assertion] = STATE(2598),
    [sym_new_expression] = STATE(2598),
    [sym__primary_type] = STATE(236),
    [sym_assignment_expression] = STATE(2598),
    [sym_binary_expression] = STATE(2598),
    [sym_predefined_type] = STATE(236),
    [sym_union_type] = STATE(240),
    [sym_parenthesized_expression] = STATE(2618),
    [sym_array] = STATE(2619),
    [sym_as_expression] = STATE(2598),
    [sym_internal_module] = STATE(2598),
    [sym_arrow_function] = STATE(2598),
    [sym_generic_type] = STATE(236),
    [sym_member_expression] = STATE(2618),
    [sym_literal_type] = STATE(236),
    [sym_type_arguments] = STATE(2412),
    [sym_intersection_type] = STATE(240),
    [sym_nested_type_identifier] = STATE(238),
    [sym__call_signature] = STATE(2502),
    [sym__type] = STATE(240),
    [sym_subscript_expression] = STATE(2618),
    [sym_index_type_query] = STATE(236),
    [sym_flow_maybe_type] = STATE(236),
    [sym_string] = STATE(1427),
    [sym_type_parameters] = STATE(587),
    [sym_decorator] = STATE(63),
    [sym_array_type] = STATE(236),
    [sym_formal_parameters] = STATE(588),
    [sym_object] = STATE(2620),
    [sym_generator_function] = STATE(2598),
    [sym_constructor_type] = STATE(240),
    [sym_lookup_type] = STATE(236),
    [sym_augmented_assignment_expression] = STATE(2598),
    [sym_parenthesized_type] = STATE(236),
    [sym_unary_expression] = STATE(2598),
    [sym_regex] = STATE(2598),
    [sym_tuple_type] = STATE(236),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_non_null_expression] = STATE(2598),
    [sym_class] = STATE(2598),
    [anon_sym_await] = ACTIONS(5553),
    [sym_identifier] = ACTIONS(5980),
    [sym_false] = ACTIONS(4306),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5559),
    [anon_sym_symbol] = ACTIONS(5982),
    [anon_sym_number] = ACTIONS(5982),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(5559),
    [anon_sym_typeof] = ACTIONS(5984),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_keyof] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(4310),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_void] = ACTIONS(5988),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(2442),
    [sym_null] = ACTIONS(5744),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(5982),
    [anon_sym_private] = ACTIONS(5559),
    [anon_sym_boolean] = ACTIONS(5982),
    [anon_sym_static] = ACTIONS(5559),
    [anon_sym_public] = ACTIONS(5559),
    [anon_sym_get] = ACTIONS(5559),
    [anon_sym_async] = ACTIONS(5567),
    [anon_sym_LBRACE_PIPE] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_delete] = ACTIONS(5561),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(5569),
    [sym_this] = ACTIONS(4304),
    [sym_number] = ACTIONS(4312),
    [sym_true] = ACTIONS(4306),
    [anon_sym_yield] = ACTIONS(5573),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(5559),
    [anon_sym_string] = ACTIONS(5982),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(5744),
    [anon_sym_set] = ACTIONS(5559),
    [anon_sym_type] = ACTIONS(5559),
    [anon_sym_new] = ACTIONS(5990),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(5559),
    [anon_sym_namespace] = ACTIONS(5577),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_TILDE] = ACTIONS(5579),
    [anon_sym_PLUS_PLUS] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(5579),
  },
  [2593] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1733),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2594] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1739),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5994),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1739),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2595] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1763),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5996),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1763),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2596] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1765),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(5998),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1765),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2597] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6000),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2598] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2599] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2600] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(6002),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2601] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(6002),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2602] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2603] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(2591),
    [anon_sym_COMMA] = ACTIONS(2589),
    [anon_sym_LT_LT] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2589),
    [anon_sym_GT_GT_GT] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2591),
    [anon_sym_BANG_EQ] = ACTIONS(2591),
    [anon_sym_LT_EQ] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(2589),
    [anon_sym_GT] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_PERCENT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2589),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(2591),
    [anon_sym_instanceof] = ACTIONS(2589),
    [anon_sym_LT] = ACTIONS(6002),
    [anon_sym_SLASH] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(2589),
    [anon_sym_STAR_STAR] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2591),
    [anon_sym_GT_GT] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(2591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2604] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(2655),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6005),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2655),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2605] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(2667),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6007),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2667),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2606] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(3799),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3799),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2607] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(725),
  },
  [2608] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2609] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(798),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6014),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(798),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2610] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(723),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_LT_LT] = ACTIONS(723),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(723),
    [anon_sym_GT_GT_GT] = ACTIONS(723),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(723),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(723),
    [anon_sym_LBRACE_PIPE] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_instanceof] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(6011),
    [anon_sym_SLASH] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(723),
    [anon_sym_STAR_STAR] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2611] = {
    [sym_arguments] = STATE(1272),
    [sym_template_string] = STATE(1272),
    [sym_type_arguments] = STATE(1802),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [anon_sym_PIPE] = ACTIONS(5895),
    [anon_sym_COMMA] = ACTIONS(1442),
    [anon_sym_LT_LT] = ACTIONS(5897),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_LBRACE] = ACTIONS(6016),
    [anon_sym_AMP_AMP] = ACTIONS(5901),
    [anon_sym_GT_GT_GT] = ACTIONS(5897),
    [anon_sym_DASH] = ACTIONS(5899),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5893),
    [anon_sym_LPAREN] = ACTIONS(687),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1442),
    [anon_sym_as] = ACTIONS(906),
    [anon_sym_PIPE_PIPE] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(908),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_instanceof] = ACTIONS(5893),
    [anon_sym_LT] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(912),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_STAR_STAR] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5899),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(908),
    [anon_sym_in] = ACTIONS(5907),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG] = ACTIONS(916),
  },
  [2612] = {
    [sym_decorator] = STATE(63),
    [aux_sym_export_statement_repeat1] = STATE(292),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(6018),
    [sym_comment] = ACTIONS(3),
  },
  [2613] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2405),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2614] = {
    [sym_formal_parameters] = STATE(61),
    [sym_type_parameters] = STATE(60),
    [sym__call_signature] = STATE(2406),
    [anon_sym_LPAREN] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(337),
  },
  [2615] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
  },
  [2616] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1396),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2617] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(1394),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(109),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(109),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2618] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PERCENT_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_AMP_EQ] = ACTIONS(5676),
    [anon_sym_PLUS_EQ] = ACTIONS(5676),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(113),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(113),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_CARET_EQ] = ACTIONS(5676),
    [anon_sym_STAR_EQ] = ACTIONS(5676),
    [anon_sym_PIPE_EQ] = ACTIONS(5676),
    [anon_sym_DASH_EQ] = ACTIONS(5676),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(113),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_LT_LT_EQ] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT_EQ] = ACTIONS(5676),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(113),
    [anon_sym_STAR_STAR] = ACTIONS(113),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2619] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6020),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2620] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(109),
    [anon_sym_LT_LT] = ACTIONS(109),
    [anon_sym_STAR] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_AMP_AMP] = ACTIONS(109),
    [anon_sym_GT_GT_GT] = ACTIONS(109),
    [anon_sym_DASH] = ACTIONS(113),
    [anon_sym_BANG_EQ] = ACTIONS(113),
    [anon_sym_LT_EQ] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_GT_EQ] = ACTIONS(109),
    [anon_sym_EQ] = ACTIONS(6022),
    [anon_sym_GT] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(109),
    [anon_sym_QMARK] = ACTIONS(109),
    [anon_sym_LBRACE_PIPE] = ACTIONS(109),
    [anon_sym_as] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_DASH_DASH] = ACTIONS(109),
    [anon_sym_EQ_EQ] = ACTIONS(113),
    [anon_sym_instanceof] = ACTIONS(109),
    [anon_sym_LT] = ACTIONS(113),
    [anon_sym_SLASH] = ACTIONS(113),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_CARET] = ACTIONS(109),
    [anon_sym_STAR_STAR] = ACTIONS(109),
    [anon_sym_PLUS] = ACTIONS(113),
    [anon_sym_GT_GT] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(109),
    [anon_sym_in] = ACTIONS(113),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(109),
    [anon_sym_BANG] = ACTIONS(113),
  },
  [2621] = {
    [anon_sym_class] = ACTIONS(6024),
    [sym_comment] = ACTIONS(3),
  },
  [2622] = {
    [sym_await_expression] = STATE(51),
    [sym_update_expression] = STATE(51),
    [sym_meta_property] = STATE(51),
    [sym__expression] = STATE(51),
    [sym_function] = STATE(52),
    [sym_import] = STATE(51),
    [sym_call_expression] = STATE(51),
    [sym_ternary_expression] = STATE(51),
    [sym_template_string] = STATE(51),
    [sym_yield_expression] = STATE(51),
    [sym_type_assertion] = STATE(51),
    [sym_new_expression] = STATE(51),
    [sym_assignment_expression] = STATE(51),
    [sym_lexical_declaration] = STATE(2541),
    [sym_binary_expression] = STATE(51),
    [sym_parenthesized_expression] = STATE(382),
    [sym_array] = STATE(385),
    [sym_as_expression] = STATE(51),
    [sym_internal_module] = STATE(51),
    [sym_arrow_function] = STATE(51),
    [sym_member_expression] = STATE(382),
    [sym_type_arguments] = STATE(56),
    [sym_sequence_expression] = STATE(57),
    [sym__call_signature] = STATE(58),
    [sym_subscript_expression] = STATE(382),
    [sym_expression_statement] = STATE(2541),
    [sym_string] = STATE(51),
    [sym_type_parameters] = STATE(60),
    [sym_decorator] = STATE(63),
    [sym_formal_parameters] = STATE(61),
    [sym_object] = STATE(384),
    [sym_generator_function] = STATE(51),
    [sym_variable_declaration] = STATE(2541),
    [sym_augmented_assignment_expression] = STATE(51),
    [sym_unary_expression] = STATE(51),
    [sym_regex] = STATE(51),
    [sym_empty_statement] = STATE(2541),
    [aux_sym_export_statement_repeat1] = STATE(92),
    [sym_non_null_expression] = STATE(51),
    [sym_class] = STATE(51),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(856),
    [anon_sym_const] = ACTIONS(858),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(854),
    [anon_sym_static] = ACTIONS(854),
    [anon_sym_get] = ACTIONS(854),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(39),
    [anon_sym_protected] = ACTIONS(854),
    [anon_sym_set] = ACTIONS(854),
    [anon_sym_type] = ACTIONS(854),
    [anon_sym_import] = ACTIONS(155),
    [anon_sym_namespace] = ACTIONS(860),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_DQUOTE] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(59),
    [sym_false] = ACTIONS(39),
    [anon_sym_SEMI] = ACTIONS(61),
    [anon_sym_module] = ACTIONS(854),
    [anon_sym_number] = ACTIONS(854),
    [anon_sym_class] = ACTIONS(159),
    [anon_sym_declare] = ACTIONS(854),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(73),
    [sym_null] = ACTIONS(39),
    [anon_sym_any] = ACTIONS(854),
    [anon_sym_boolean] = ACTIONS(854),
    [anon_sym_async] = ACTIONS(862),
    [anon_sym_public] = ACTIONS(854),
    [anon_sym_var] = ACTIONS(864),
    [anon_sym_SQUOTE] = ACTIONS(83),
    [anon_sym_LT] = ACTIONS(87),
    [sym_number] = ACTIONS(89),
    [anon_sym_SLASH] = ACTIONS(91),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(854),
    [anon_sym_function] = ACTIONS(167),
    [sym_undefined] = ACTIONS(39),
    [anon_sym_new] = ACTIONS(97),
    [anon_sym_let] = ACTIONS(858),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_await] = ACTIONS(107),
  },
  [2623] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(6026),
  },
  [2624] = {
    [sym_identifier] = ACTIONS(6028),
    [anon_sym_STAR] = ACTIONS(6030),
    [sym_comment] = ACTIONS(3),
  },
  [2625] = {
    [sym_arrow_function] = STATE(2548),
    [sym_await_expression] = STATE(2548),
    [sym_member_expression] = STATE(2615),
    [sym_type_arguments] = STATE(2581),
    [sym_update_expression] = STATE(2548),
    [sym_meta_property] = STATE(2548),
    [sym__expression] = STATE(2548),
    [sym_function] = STATE(1250),
    [sym_import] = STATE(2548),
    [sym_call_expression] = STATE(2548),
    [sym_subscript_expression] = STATE(2615),
    [sym__call_signature] = STATE(2454),
    [sym_ternary_expression] = STATE(2548),
    [sym_string] = STATE(2548),
    [sym_template_string] = STATE(2548),
    [sym_decorator] = STATE(63),
    [sym_type_parameters] = STATE(60),
    [sym_formal_parameters] = STATE(61),
    [sym_yield_expression] = STATE(2548),
    [sym_object] = STATE(2617),
    [sym_type_assertion] = STATE(2548),
    [sym_generator_function] = STATE(2548),
    [sym_new_expression] = STATE(2548),
    [sym_assignment_expression] = STATE(2548),
    [sym_augmented_assignment_expression] = STATE(2548),
    [sym_binary_expression] = STATE(2548),
    [sym_unary_expression] = STATE(2548),
    [sym_regex] = STATE(2548),
    [aux_sym_export_statement_repeat1] = STATE(2236),
    [sym_parenthesized_expression] = STATE(2615),
    [sym_non_null_expression] = STATE(2548),
    [sym_as_expression] = STATE(2548),
    [sym_array] = STATE(2616),
    [sym_internal_module] = STATE(2548),
    [sym_class] = STATE(2548),
    [anon_sym_await] = ACTIONS(525),
    [sym_identifier] = ACTIONS(1362),
    [sym_false] = ACTIONS(6032),
    [anon_sym_LBRACK] = ACTIONS(295),
    [anon_sym_BQUOTE] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_symbol] = ACTIONS(1354),
    [anon_sym_number] = ACTIONS(1354),
    [anon_sym_class] = ACTIONS(297),
    [anon_sym_declare] = ACTIONS(1354),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(301),
    [anon_sym_void] = ACTIONS(1364),
    [anon_sym_LPAREN] = ACTIONS(303),
    [sym_null] = ACTIONS(6032),
    [sym_super] = ACTIONS(277),
    [anon_sym_any] = ACTIONS(1354),
    [anon_sym_private] = ACTIONS(1354),
    [anon_sym_boolean] = ACTIONS(1354),
    [anon_sym_static] = ACTIONS(1354),
    [anon_sym_public] = ACTIONS(1354),
    [anon_sym_get] = ACTIONS(1354),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_SQUOTE] = ACTIONS(309),
    [anon_sym_DASH_DASH] = ACTIONS(509),
    [sym_this] = ACTIONS(6032),
    [sym_number] = ACTIONS(6034),
    [sym_true] = ACTIONS(6032),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(87),
    [anon_sym_protected] = ACTIONS(1354),
    [anon_sym_string] = ACTIONS(1354),
    [anon_sym_function] = ACTIONS(315),
    [sym_undefined] = ACTIONS(6032),
    [anon_sym_set] = ACTIONS(1354),
    [anon_sym_type] = ACTIONS(1354),
    [anon_sym_new] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(287),
    [anon_sym_export] = ACTIONS(1354),
    [anon_sym_namespace] = ACTIONS(1366),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(509),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_BANG] = ACTIONS(519),
  },
  [2626] = {
    [aux_sym_extends_clause_repeat1] = STATE(2551),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2035),
    [anon_sym_COMMA] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5905),
  },
  [2627] = {
    [aux_sym_extends_clause_repeat1] = STATE(2551),
    [sym_type_arguments] = STATE(539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2035),
    [anon_sym_LT] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5905),
  },
  [2628] = {
    [sym_identifier] = ACTIONS(6036),
    [anon_sym_STAR] = ACTIONS(6038),
    [sym_comment] = ACTIONS(3),
  },
  [2629] = {
    [sym_identifier] = ACTIONS(6040),
    [sym_comment] = ACTIONS(3),
  },
  [2630] = {
    [sym_identifier] = ACTIONS(6042),
    [sym_comment] = ACTIONS(3),
  },
  [2631] = {
    [sym_identifier] = ACTIONS(6044),
    [sym_comment] = ACTIONS(3),
  },
  [2632] = {
    [sym_identifier] = ACTIONS(6046),
    [sym_comment] = ACTIONS(3),
  },
  [2633] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(6048),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(7),
  [17] = {.count = 1, .reusable = false}, SHIFT(8),
  [19] = {.count = 1, .reusable = false}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = false}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, SHIFT(15),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(18),
  [39] = {.count = 1, .reusable = false}, SHIFT(51),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = false}, SHIFT(20),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = true}, SHIFT(25),
  [55] = {.count = 1, .reusable = true}, SHIFT(26),
  [57] = {.count = 1, .reusable = false}, SHIFT(27),
  [59] = {.count = 1, .reusable = true}, SHIFT(28),
  [61] = {.count = 1, .reusable = true}, SHIFT(29),
  [63] = {.count = 1, .reusable = false}, SHIFT(30),
  [65] = {.count = 1, .reusable = false}, SHIFT(31),
  [67] = {.count = 1, .reusable = false}, SHIFT(32),
  [69] = {.count = 1, .reusable = true}, SHIFT(33),
  [71] = {.count = 1, .reusable = false}, SHIFT(34),
  [73] = {.count = 1, .reusable = true}, SHIFT(35),
  [75] = {.count = 1, .reusable = false}, SHIFT(36),
  [77] = {.count = 1, .reusable = false}, SHIFT(37),
  [79] = {.count = 1, .reusable = true}, SHIFT(38),
  [81] = {.count = 1, .reusable = false}, SHIFT(39),
  [83] = {.count = 1, .reusable = true}, SHIFT(40),
  [85] = {.count = 1, .reusable = false}, SHIFT(41),
  [87] = {.count = 1, .reusable = true}, SHIFT(42),
  [89] = {.count = 1, .reusable = true}, SHIFT(51),
  [91] = {.count = 1, .reusable = false}, SHIFT(43),
  [93] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [95] = {.count = 1, .reusable = false}, SHIFT(44),
  [97] = {.count = 1, .reusable = false}, SHIFT(45),
  [99] = {.count = 1, .reusable = false}, SHIFT(46),
  [101] = {.count = 1, .reusable = false}, SHIFT(47),
  [103] = {.count = 1, .reusable = false}, SHIFT(48),
  [105] = {.count = 1, .reusable = false}, SHIFT(49),
  [107] = {.count = 1, .reusable = false}, SHIFT(50),
  [109] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [111] = {.count = 1, .reusable = true}, SHIFT(67),
  [113] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [115] = {.count = 1, .reusable = false}, SHIFT(69),
  [117] = {.count = 1, .reusable = true}, SHIFT(68),
  [119] = {.count = 1, .reusable = true}, SHIFT(70),
  [121] = {.count = 1, .reusable = true}, SHIFT(66),
  [123] = {.count = 1, .reusable = true}, SHIFT(71),
  [125] = {.count = 1, .reusable = true}, SHIFT(72),
  [127] = {.count = 1, .reusable = true}, SHIFT(73),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [133] = {.count = 1, .reusable = true}, SHIFT(76),
  [135] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [137] = {.count = 1, .reusable = false}, SHIFT(77),
  [139] = {.count = 1, .reusable = true}, SHIFT(78),
  [141] = {.count = 1, .reusable = true}, SHIFT(75),
  [143] = {.count = 1, .reusable = false}, SHIFT(80),
  [145] = {.count = 1, .reusable = false}, SHIFT(79),
  [147] = {.count = 1, .reusable = false}, SHIFT(82),
  [149] = {.count = 1, .reusable = false}, SHIFT(83),
  [151] = {.count = 1, .reusable = false}, SHIFT(86),
  [153] = {.count = 1, .reusable = false}, SHIFT(91),
  [155] = {.count = 1, .reusable = false}, SHIFT(89),
  [157] = {.count = 1, .reusable = false}, SHIFT(90),
  [159] = {.count = 1, .reusable = false}, SHIFT(84),
  [161] = {.count = 1, .reusable = true}, SHIFT(85),
  [163] = {.count = 1, .reusable = false}, SHIFT(87),
  [165] = {.count = 1, .reusable = true}, SHIFT(91),
  [167] = {.count = 1, .reusable = false}, SHIFT(88),
  [169] = {.count = 1, .reusable = false}, SHIFT(93),
  [171] = {.count = 1, .reusable = false}, SHIFT(78),
  [173] = {.count = 1, .reusable = false}, SHIFT(26),
  [175] = {.count = 1, .reusable = false}, SHIFT(42),
  [177] = {.count = 1, .reusable = true}, SHIFT(93),
  [179] = {.count = 1, .reusable = true}, SHIFT(94),
  [181] = {.count = 1, .reusable = true}, SHIFT(95),
  [183] = {.count = 1, .reusable = false}, SHIFT(96),
  [185] = {.count = 1, .reusable = false}, SHIFT(97),
  [187] = {.count = 1, .reusable = true}, SHIFT(101),
  [189] = {.count = 1, .reusable = true}, SHIFT(103),
  [191] = {.count = 1, .reusable = false}, SHIFT(102),
  [193] = {.count = 1, .reusable = true}, SHIFT(106),
  [195] = {.count = 1, .reusable = false}, SHIFT(108),
  [197] = {.count = 1, .reusable = true}, SHIFT(108),
  [199] = {.count = 1, .reusable = true}, SHIFT(109),
  [201] = {.count = 1, .reusable = true}, SHIFT(110),
  [203] = {.count = 1, .reusable = true}, SHIFT(111),
  [205] = {.count = 1, .reusable = true}, SHIFT(112),
  [207] = {.count = 1, .reusable = false}, SHIFT(113),
  [209] = {.count = 1, .reusable = true}, SHIFT(113),
  [211] = {.count = 1, .reusable = true}, SHIFT(114),
  [213] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [215] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [217] = {.count = 1, .reusable = false}, SHIFT(116),
  [219] = {.count = 1, .reusable = false}, SHIFT(117),
  [221] = {.count = 1, .reusable = true}, SHIFT(117),
  [223] = {.count = 1, .reusable = false}, SHIFT(119),
  [225] = {.count = 1, .reusable = true}, SHIFT(119),
  [227] = {.count = 1, .reusable = true}, SHIFT(120),
  [229] = {.count = 1, .reusable = false}, SHIFT(121),
  [231] = {.count = 1, .reusable = true}, REDUCE(sym_import, 1),
  [233] = {.count = 1, .reusable = false}, SHIFT(122),
  [235] = {.count = 1, .reusable = false}, REDUCE(sym_import, 1),
  [237] = {.count = 1, .reusable = false}, SHIFT(124),
  [239] = {.count = 1, .reusable = false}, SHIFT(123),
  [241] = {.count = 1, .reusable = true}, SHIFT(125),
  [243] = {.count = 1, .reusable = false}, SHIFT(129),
  [245] = {.count = 1, .reusable = true}, SHIFT(1787),
  [247] = {.count = 1, .reusable = true}, SHIFT(1790),
  [249] = {.count = 1, .reusable = false}, SHIFT(133),
  [251] = {.count = 1, .reusable = true}, SHIFT(133),
  [253] = {.count = 1, .reusable = false}, SHIFT(132),
  [255] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [257] = {.count = 1, .reusable = false}, SHIFT(134),
  [259] = {.count = 1, .reusable = true}, SHIFT(134),
  [261] = {.count = 1, .reusable = true}, SHIFT(135),
  [263] = {.count = 1, .reusable = true}, SHIFT(136),
  [265] = {.count = 1, .reusable = false}, SHIFT(1264),
  [267] = {.count = 1, .reusable = true}, SHIFT(1784),
  [269] = {.count = 1, .reusable = false}, SHIFT(1265),
  [271] = {.count = 1, .reusable = true}, SHIFT(139),
  [273] = {.count = 1, .reusable = false}, SHIFT(1785),
  [275] = {.count = 1, .reusable = false}, SHIFT(1266),
  [277] = {.count = 1, .reusable = false}, SHIFT(1244),
  [279] = {.count = 1, .reusable = false}, SHIFT(1245),
  [281] = {.count = 1, .reusable = true}, SHIFT(1246),
  [283] = {.count = 1, .reusable = false}, SHIFT(141),
  [285] = {.count = 1, .reusable = false}, SHIFT(1247),
  [287] = {.count = 1, .reusable = false}, SHIFT(1268),
  [289] = {.count = 1, .reusable = false}, SHIFT(1269),
  [291] = {.count = 1, .reusable = true}, SHIFT(2054),
  [293] = {.count = 1, .reusable = true}, SHIFT(1248),
  [295] = {.count = 1, .reusable = true}, SHIFT(1788),
  [297] = {.count = 1, .reusable = false}, SHIFT(1798),
  [299] = {.count = 1, .reusable = true}, SHIFT(138),
  [301] = {.count = 1, .reusable = true}, SHIFT(1799),
  [303] = {.count = 1, .reusable = true}, SHIFT(2212),
  [305] = {.count = 1, .reusable = true}, SHIFT(140),
  [307] = {.count = 1, .reusable = false}, SHIFT(1267),
  [309] = {.count = 1, .reusable = true}, SHIFT(2056),
  [311] = {.count = 1, .reusable = true}, SHIFT(141),
  [313] = {.count = 1, .reusable = false}, SHIFT(2216),
  [315] = {.count = 1, .reusable = false}, SHIFT(2233),
  [317] = {.count = 1, .reusable = false}, SHIFT(1791),
  [319] = {.count = 1, .reusable = false}, SHIFT(1249),
  [321] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [323] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [325] = {.count = 1, .reusable = false}, SHIFT(1276),
  [327] = {.count = 1, .reusable = true}, SHIFT(2137),
  [329] = {.count = 1, .reusable = true}, SHIFT(2139),
  [331] = {.count = 1, .reusable = false}, SHIFT(145),
  [333] = {.count = 1, .reusable = false}, SHIFT(147),
  [335] = {.count = 1, .reusable = false}, SHIFT(146),
  [337] = {.count = 1, .reusable = true}, SHIFT(148),
  [339] = {.count = 1, .reusable = true}, SHIFT(149),
  [341] = {.count = 1, .reusable = true}, SHIFT(158),
  [343] = {.count = 1, .reusable = true}, SHIFT(10),
  [345] = {.count = 1, .reusable = true}, SHIFT(13),
  [347] = {.count = 1, .reusable = true}, SHIFT(14),
  [349] = {.count = 1, .reusable = true}, SHIFT(21),
  [351] = {.count = 1, .reusable = true}, SHIFT(161),
  [353] = {.count = 1, .reusable = true}, SHIFT(162),
  [355] = {.count = 1, .reusable = true}, SHIFT(163),
  [357] = {.count = 1, .reusable = true}, SHIFT(155),
  [359] = {.count = 1, .reusable = true}, SHIFT(156),
  [361] = {.count = 1, .reusable = true}, SHIFT(157),
  [363] = {.count = 1, .reusable = true}, SHIFT(159),
  [365] = {.count = 1, .reusable = true}, SHIFT(37),
  [367] = {.count = 1, .reusable = true}, SHIFT(160),
  [369] = {.count = 1, .reusable = true}, SHIFT(46),
  [371] = {.count = 1, .reusable = false}, SHIFT(166),
  [373] = {.count = 1, .reusable = false}, SHIFT(167),
  [375] = {.count = 1, .reusable = true}, SHIFT(168),
  [377] = {.count = 1, .reusable = true}, SHIFT(169),
  [379] = {.count = 1, .reusable = false}, SHIFT(170),
  [381] = {.count = 1, .reusable = false}, SHIFT(171),
  [383] = {.count = 1, .reusable = false}, SHIFT(172),
  [385] = {.count = 1, .reusable = false}, SHIFT(173),
  [387] = {.count = 1, .reusable = true}, SHIFT(174),
  [389] = {.count = 1, .reusable = false}, SHIFT(175),
  [391] = {.count = 1, .reusable = false}, SHIFT(176),
  [393] = {.count = 1, .reusable = false}, SHIFT(177),
  [395] = {.count = 1, .reusable = true}, SHIFT(178),
  [397] = {.count = 1, .reusable = false}, SHIFT(179),
  [399] = {.count = 1, .reusable = false}, SHIFT(180),
  [401] = {.count = 1, .reusable = false}, SHIFT(181),
  [403] = {.count = 1, .reusable = true}, SHIFT(182),
  [405] = {.count = 1, .reusable = false}, SHIFT(183),
  [407] = {.count = 1, .reusable = false}, SHIFT(192),
  [409] = {.count = 1, .reusable = false}, SHIFT(194),
  [411] = {.count = 1, .reusable = true}, SHIFT(2511),
  [413] = {.count = 1, .reusable = false}, SHIFT(196),
  [415] = {.count = 1, .reusable = false}, SHIFT(197),
  [417] = {.count = 1, .reusable = false}, SHIFT(200),
  [419] = {.count = 1, .reusable = false}, SHIFT(205),
  [421] = {.count = 1, .reusable = false}, SHIFT(193),
  [423] = {.count = 1, .reusable = false}, SHIFT(201),
  [425] = {.count = 1, .reusable = true}, SHIFT(195),
  [427] = {.count = 1, .reusable = false}, SHIFT(198),
  [429] = {.count = 1, .reusable = true}, SHIFT(199),
  [431] = {.count = 1, .reusable = true}, SHIFT(205),
  [433] = {.count = 1, .reusable = false}, SHIFT(210),
  [435] = {.count = 1, .reusable = false}, SHIFT(211),
  [437] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(212),
  [440] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(148),
  [443] = {.count = 1, .reusable = false}, SHIFT(213),
  [445] = {.count = 1, .reusable = true}, SHIFT(96),
  [447] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [449] = {.count = 1, .reusable = false}, SHIFT(218),
  [451] = {.count = 1, .reusable = true}, SHIFT(218),
  [453] = {.count = 1, .reusable = true}, SHIFT(219),
  [455] = {.count = 1, .reusable = false}, SHIFT(221),
  [457] = {.count = 1, .reusable = false}, SHIFT(222),
  [459] = {.count = 1, .reusable = true}, SHIFT(223),
  [461] = {.count = 1, .reusable = true}, SHIFT(224),
  [463] = {.count = 1, .reusable = true}, SHIFT(225),
  [465] = {.count = 1, .reusable = true}, SHIFT(226),
  [467] = {.count = 1, .reusable = false}, SHIFT(227),
  [469] = {.count = 1, .reusable = false}, SHIFT(236),
  [471] = {.count = 1, .reusable = false}, SHIFT(228),
  [473] = {.count = 1, .reusable = true}, SHIFT(229),
  [475] = {.count = 1, .reusable = true}, SHIFT(230),
  [477] = {.count = 1, .reusable = false}, SHIFT(231),
  [479] = {.count = 1, .reusable = true}, SHIFT(222),
  [481] = {.count = 1, .reusable = false}, SHIFT(224),
  [483] = {.count = 1, .reusable = false}, SHIFT(232),
  [485] = {.count = 1, .reusable = true}, SHIFT(233),
  [487] = {.count = 1, .reusable = true}, SHIFT(234),
  [489] = {.count = 1, .reusable = false}, SHIFT(242),
  [491] = {.count = 1, .reusable = true}, SHIFT(243),
  [493] = {.count = 1, .reusable = true}, SHIFT(212),
  [495] = {.count = 1, .reusable = true}, SHIFT(244),
  [497] = {.count = 1, .reusable = false}, SHIFT(246),
  [499] = {.count = 1, .reusable = false}, SHIFT(249),
  [501] = {.count = 1, .reusable = false}, SHIFT(2383),
  [503] = {.count = 1, .reusable = false}, SHIFT(250),
  [505] = {.count = 1, .reusable = false}, SHIFT(2026),
  [507] = {.count = 1, .reusable = false}, SHIFT(2574),
  [509] = {.count = 1, .reusable = true}, SHIFT(2575),
  [511] = {.count = 1, .reusable = false}, SHIFT(247),
  [513] = {.count = 1, .reusable = false}, SHIFT(2576),
  [515] = {.count = 1, .reusable = false}, SHIFT(248),
  [517] = {.count = 1, .reusable = false}, SHIFT(252),
  [519] = {.count = 1, .reusable = true}, SHIFT(2577),
  [521] = {.count = 1, .reusable = false}, SHIFT(251),
  [523] = {.count = 1, .reusable = true}, SHIFT(247),
  [525] = {.count = 1, .reusable = false}, SHIFT(2578),
  [527] = {.count = 1, .reusable = false}, SHIFT(259),
  [529] = {.count = 1, .reusable = false}, SHIFT(261),
  [531] = {.count = 1, .reusable = true}, SHIFT(262),
  [533] = {.count = 1, .reusable = false}, SHIFT(263),
  [535] = {.count = 1, .reusable = true}, SHIFT(258),
  [537] = {.count = 1, .reusable = true}, SHIFT(260),
  [539] = {.count = 1, .reusable = false}, SHIFT(2200),
  [541] = {.count = 1, .reusable = false}, SHIFT(2201),
  [543] = {.count = 1, .reusable = false}, SHIFT(2202),
  [545] = {.count = 1, .reusable = false}, SHIFT(2206),
  [547] = {.count = 1, .reusable = false}, SHIFT(2621),
  [549] = {.count = 1, .reusable = false}, SHIFT(2207),
  [551] = {.count = 1, .reusable = false}, SHIFT(1786),
  [553] = {.count = 1, .reusable = false}, SHIFT(2208),
  [555] = {.count = 1, .reusable = false}, SHIFT(2209),
  [557] = {.count = 1, .reusable = false}, SHIFT(2210),
  [559] = {.count = 1, .reusable = false}, SHIFT(2211),
  [561] = {.count = 1, .reusable = true}, SHIFT(1789),
  [563] = {.count = 1, .reusable = false}, SHIFT(2213),
  [565] = {.count = 1, .reusable = false}, SHIFT(2215),
  [567] = {.count = 1, .reusable = false}, SHIFT(2518),
  [569] = {.count = 1, .reusable = false}, SHIFT(2218),
  [571] = {.count = 1, .reusable = false}, SHIFT(2219),
  [573] = {.count = 1, .reusable = false}, SHIFT(268),
  [575] = {.count = 1, .reusable = true}, SHIFT(268),
  [577] = {.count = 1, .reusable = true}, SHIFT(269),
  [579] = {.count = 1, .reusable = true}, SHIFT(270),
  [581] = {.count = 1, .reusable = false}, SHIFT(271),
  [583] = {.count = 1, .reusable = true}, SHIFT(275),
  [585] = {.count = 1, .reusable = true}, SHIFT(272),
  [587] = {.count = 1, .reusable = false}, SHIFT(273),
  [589] = {.count = 1, .reusable = false}, SHIFT(272),
  [591] = {.count = 1, .reusable = true}, SHIFT(274),
  [593] = {.count = 1, .reusable = false}, SHIFT(270),
  [595] = {.count = 1, .reusable = false}, SHIFT(274),
  [597] = {.count = 1, .reusable = true}, SHIFT(276),
  [599] = {.count = 1, .reusable = true}, SHIFT(271),
  [601] = {.count = 1, .reusable = true}, SHIFT(277),
  [603] = {.count = 1, .reusable = true}, SHIFT(278),
  [605] = {.count = 1, .reusable = false}, SHIFT(279),
  [607] = {.count = 1, .reusable = true}, SHIFT(280),
  [609] = {.count = 1, .reusable = false}, SHIFT(281),
  [611] = {.count = 1, .reusable = false}, SHIFT(282),
  [613] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [615] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [617] = {.count = 1, .reusable = false}, SHIFT(283),
  [619] = {.count = 1, .reusable = true}, SHIFT(283),
  [621] = {.count = 1, .reusable = true}, SHIFT(284),
  [623] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [625] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2),
  [627] = {.count = 1, .reusable = true}, SHIFT(286),
  [629] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 3),
  [631] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 3),
  [633] = {.count = 1, .reusable = false}, SHIFT(289),
  [635] = {.count = 1, .reusable = true}, SHIFT(290),
  [637] = {.count = 1, .reusable = true}, SHIFT(291),
  [639] = {.count = 1, .reusable = false}, SHIFT(294),
  [641] = {.count = 1, .reusable = true}, SHIFT(2055),
  [643] = {.count = 1, .reusable = true}, SHIFT(294),
  [645] = {.count = 1, .reusable = false}, SHIFT(295),
  [647] = {.count = 1, .reusable = true}, SHIFT(295),
  [649] = {.count = 1, .reusable = false}, SHIFT(297),
  [651] = {.count = 1, .reusable = true}, SHIFT(297),
  [653] = {.count = 1, .reusable = true}, SHIFT(298),
  [655] = {.count = 1, .reusable = false}, SHIFT(300),
  [657] = {.count = 1, .reusable = true}, SHIFT(300),
  [659] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [661] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [663] = {.count = 1, .reusable = true}, SHIFT(301),
  [665] = {.count = 1, .reusable = true}, SHIFT(302),
  [667] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [669] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [671] = {.count = 1, .reusable = false}, SHIFT(304),
  [673] = {.count = 1, .reusable = true}, SHIFT(304),
  [675] = {.count = 1, .reusable = false}, SHIFT(305),
  [677] = {.count = 1, .reusable = true}, SHIFT(305),
  [679] = {.count = 1, .reusable = false}, SHIFT(306),
  [681] = {.count = 1, .reusable = true}, SHIFT(306),
  [683] = {.count = 1, .reusable = true}, SHIFT(307),
  [685] = {.count = 1, .reusable = true}, SHIFT(308),
  [687] = {.count = 1, .reusable = true}, SHIFT(1801),
  [689] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2, .production_id = 4),
  [691] = {.count = 1, .reusable = true}, SHIFT(310),
  [693] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [695] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [697] = {.count = 1, .reusable = false}, SHIFT(312),
  [699] = {.count = 1, .reusable = false}, SHIFT(313),
  [701] = {.count = 1, .reusable = true}, SHIFT(1289),
  [703] = {.count = 1, .reusable = false}, SHIFT(314),
  [705] = {.count = 1, .reusable = false}, SHIFT(315),
  [707] = {.count = 1, .reusable = false}, SHIFT(317),
  [709] = {.count = 1, .reusable = true}, SHIFT(318),
  [711] = {.count = 1, .reusable = false}, SHIFT(316),
  [713] = {.count = 1, .reusable = true}, SHIFT(186),
  [715] = {.count = 1, .reusable = false}, SHIFT(321),
  [717] = {.count = 1, .reusable = true}, SHIFT(322),
  [719] = {.count = 1, .reusable = true}, SHIFT(323),
  [721] = {.count = 1, .reusable = false}, SHIFT(1585),
  [723] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [725] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5),
  [727] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(279),
  [730] = {.count = 1, .reusable = true}, SHIFT(324),
  [732] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [734] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [736] = {.count = 1, .reusable = true}, SHIFT(325),
  [738] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 6),
  [740] = {.count = 1, .reusable = true}, SHIFT(326),
  [742] = {.count = 1, .reusable = true}, SHIFT(1336),
  [744] = {.count = 1, .reusable = true}, SHIFT(329),
  [746] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 7),
  [748] = {.count = 1, .reusable = true}, SHIFT(333),
  [750] = {.count = 1, .reusable = true}, SHIFT(332),
  [752] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1, .production_id = 8),
  [754] = {.count = 1, .reusable = false}, SHIFT(338),
  [756] = {.count = 1, .reusable = true}, SHIFT(338),
  [758] = {.count = 1, .reusable = false}, SHIFT(339),
  [760] = {.count = 1, .reusable = false}, SHIFT(341),
  [762] = {.count = 1, .reusable = true}, SHIFT(340),
  [764] = {.count = 1, .reusable = true}, SHIFT(341),
  [766] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [768] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2, .production_id = 9),
  [770] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [772] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [774] = {.count = 1, .reusable = true}, SHIFT(345),
  [776] = {.count = 1, .reusable = true}, SHIFT(2528),
  [778] = {.count = 1, .reusable = true}, SHIFT(349),
  [780] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [782] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [784] = {.count = 1, .reusable = true}, SHIFT(351),
  [786] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [788] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 5),
  [790] = {.count = 1, .reusable = false}, SHIFT(1834),
  [792] = {.count = 1, .reusable = true}, SHIFT(1834),
  [794] = {.count = 1, .reusable = false}, SHIFT(353),
  [796] = {.count = 1, .reusable = true}, SHIFT(353),
  [798] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [800] = {.count = 1, .reusable = true}, SHIFT(354),
  [802] = {.count = 1, .reusable = true}, SHIFT(355),
  [804] = {.count = 1, .reusable = true}, SHIFT(356),
  [806] = {.count = 1, .reusable = true}, SHIFT(359),
  [808] = {.count = 1, .reusable = true}, SHIFT(358),
  [810] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [812] = {.count = 1, .reusable = true}, SHIFT(124),
  [814] = {.count = 1, .reusable = true}, SHIFT(360),
  [816] = {.count = 1, .reusable = true}, SHIFT(363),
  [818] = {.count = 1, .reusable = false}, SHIFT(364),
  [820] = {.count = 1, .reusable = true}, SHIFT(365),
  [822] = {.count = 1, .reusable = false}, SHIFT(366),
  [824] = {.count = 1, .reusable = true}, SHIFT(367),
  [826] = {.count = 1, .reusable = true}, SHIFT(369),
  [828] = {.count = 1, .reusable = true}, SHIFT(370),
  [830] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1, .production_id = 6),
  [832] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1, .production_id = 6),
  [834] = {.count = 1, .reusable = false}, SHIFT(371),
  [836] = {.count = 1, .reusable = true}, SHIFT(1841),
  [838] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2, .production_id = 10),
  [840] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2, .production_id = 10),
  [842] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [844] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [846] = {.count = 1, .reusable = false}, SHIFT(374),
  [848] = {.count = 1, .reusable = true}, SHIFT(374),
  [850] = {.count = 1, .reusable = false}, SHIFT(373),
  [852] = {.count = 1, .reusable = false}, SHIFT(375),
  [854] = {.count = 1, .reusable = false}, SHIFT(376),
  [856] = {.count = 1, .reusable = false}, SHIFT(377),
  [858] = {.count = 1, .reusable = false}, SHIFT(378),
  [860] = {.count = 1, .reusable = false}, SHIFT(381),
  [862] = {.count = 1, .reusable = false}, SHIFT(379),
  [864] = {.count = 1, .reusable = false}, SHIFT(380),
  [866] = {.count = 1, .reusable = true}, SHIFT(386),
  [868] = {.count = 1, .reusable = false}, SHIFT(389),
  [870] = {.count = 1, .reusable = true}, SHIFT(389),
  [872] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [874] = {.count = 1, .reusable = false}, SHIFT(390),
  [876] = {.count = 1, .reusable = true}, SHIFT(390),
  [878] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [880] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [882] = {.count = 1, .reusable = true}, SHIFT(1322),
  [884] = {.count = 1, .reusable = true}, SHIFT(2239),
  [886] = {.count = 1, .reusable = false}, SHIFT(1323),
  [888] = {.count = 1, .reusable = true}, SHIFT(1324),
  [890] = {.count = 1, .reusable = false}, SHIFT(1325),
  [892] = {.count = 1, .reusable = false}, SHIFT(1324),
  [894] = {.count = 1, .reusable = true}, SHIFT(1326),
  [896] = {.count = 1, .reusable = false}, SHIFT(1322),
  [898] = {.count = 1, .reusable = true}, SHIFT(392),
  [900] = {.count = 1, .reusable = false}, SHIFT(1326),
  [902] = {.count = 1, .reusable = true}, SHIFT(2273),
  [904] = {.count = 1, .reusable = true}, SHIFT(1323),
  [906] = {.count = 1, .reusable = true}, SHIFT(1857),
  [908] = {.count = 1, .reusable = true}, SHIFT(1328),
  [910] = {.count = 1, .reusable = false}, SHIFT(1329),
  [912] = {.count = 1, .reusable = true}, SHIFT(1795),
  [914] = {.count = 1, .reusable = true}, SHIFT(1330),
  [916] = {.count = 1, .reusable = false}, SHIFT(1331),
  [918] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2, .production_id = 10),
  [920] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2, .production_id = 10),
  [922] = {.count = 1, .reusable = false}, SHIFT(2336),
  [924] = {.count = 1, .reusable = false}, SHIFT(395),
  [926] = {.count = 1, .reusable = false}, SHIFT(397),
  [928] = {.count = 1, .reusable = false}, SHIFT(2345),
  [930] = {.count = 1, .reusable = false}, SHIFT(2332),
  [932] = {.count = 1, .reusable = false}, SHIFT(2453),
  [934] = {.count = 1, .reusable = false}, SHIFT(2346),
  [936] = {.count = 1, .reusable = false}, SHIFT(2347),
  [938] = {.count = 1, .reusable = true}, SHIFT(2333),
  [940] = {.count = 1, .reusable = true}, SHIFT(397),
  [942] = {.count = 1, .reusable = false}, SHIFT(2334),
  [944] = {.count = 1, .reusable = false}, SHIFT(2390),
  [946] = {.count = 1, .reusable = false}, SHIFT(2057),
  [948] = {.count = 1, .reusable = false}, SHIFT(2348),
  [950] = {.count = 1, .reusable = true}, SHIFT(2335),
  [952] = {.count = 1, .reusable = true}, SHIFT(145),
  [954] = {.count = 1, .reusable = true}, SHIFT(146),
  [956] = {.count = 1, .reusable = true}, SHIFT(2060),
  [958] = {.count = 1, .reusable = true}, SHIFT(403),
  [960] = {.count = 1, .reusable = false}, SHIFT(405),
  [962] = {.count = 1, .reusable = true}, SHIFT(407),
  [964] = {.count = 1, .reusable = true}, SHIFT(409),
  [966] = {.count = 1, .reusable = false}, SHIFT(406),
  [968] = {.count = 1, .reusable = false}, SHIFT(412),
  [970] = {.count = 1, .reusable = false}, SHIFT(413),
  [972] = {.count = 1, .reusable = false}, SHIFT(404),
  [974] = {.count = 1, .reusable = true}, SHIFT(408),
  [976] = {.count = 1, .reusable = true}, SHIFT(2178),
  [978] = {.count = 1, .reusable = true}, SHIFT(418),
  [980] = {.count = 1, .reusable = false}, SHIFT(410),
  [982] = {.count = 1, .reusable = false}, SHIFT(411),
  [984] = {.count = 1, .reusable = true}, SHIFT(2177),
  [986] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [988] = {.count = 1, .reusable = true}, REDUCE(sym_class, 2, .production_id = 11),
  [990] = {.count = 1, .reusable = false}, REDUCE(sym_class, 2, .production_id = 11),
  [992] = {.count = 1, .reusable = true}, SHIFT(1276),
  [994] = {.count = 1, .reusable = true}, SHIFT(423),
  [996] = {.count = 1, .reusable = true}, SHIFT(424),
  [998] = {.count = 1, .reusable = true}, SHIFT(426),
  [1000] = {.count = 1, .reusable = true}, SHIFT(427),
  [1002] = {.count = 1, .reusable = true}, SHIFT(428),
  [1004] = {.count = 1, .reusable = true}, SHIFT(121),
  [1006] = {.count = 1, .reusable = true}, SHIFT(429),
  [1008] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [1010] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [1012] = {.count = 1, .reusable = true}, SHIFT(430),
  [1014] = {.count = 1, .reusable = false}, SHIFT(432),
  [1016] = {.count = 1, .reusable = true}, SHIFT(431),
  [1018] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(68),
  [1021] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1024] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1027] = {.count = 1, .reusable = false}, SHIFT(434),
  [1029] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1032] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12),
  [1035] = {.count = 1, .reusable = false}, SHIFT(436),
  [1037] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [1039] = {.count = 1, .reusable = false}, SHIFT(438),
  [1041] = {.count = 1, .reusable = false}, SHIFT(439),
  [1043] = {.count = 1, .reusable = false}, SHIFT(437),
  [1045] = {.count = 1, .reusable = false}, SHIFT(435),
  [1047] = {.count = 1, .reusable = false}, SHIFT(1374),
  [1049] = {.count = 1, .reusable = true}, SHIFT(441),
  [1051] = {.count = 1, .reusable = true}, SHIFT(442),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [1055] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [1057] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(443),
  [1060] = {.count = 1, .reusable = false}, SHIFT(445),
  [1062] = {.count = 1, .reusable = false}, SHIFT(446),
  [1064] = {.count = 1, .reusable = false}, SHIFT(444),
  [1066] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(441),
  [1069] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1071] = {.count = 1, .reusable = true}, SHIFT(447),
  [1073] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1075] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1077] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1079] = {.count = 1, .reusable = true}, SHIFT(443),
  [1081] = {.count = 1, .reusable = false}, SHIFT(448),
  [1083] = {.count = 1, .reusable = true}, SHIFT(448),
  [1085] = {.count = 1, .reusable = false}, SHIFT(450),
  [1087] = {.count = 1, .reusable = false}, SHIFT(451),
  [1089] = {.count = 1, .reusable = false}, SHIFT(449),
  [1091] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(212),
  [1095] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 12), SHIFT(148),
  [1099] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1102] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [1107] = {.count = 1, .reusable = false}, SHIFT(452),
  [1109] = {.count = 1, .reusable = true}, SHIFT(453),
  [1111] = {.count = 1, .reusable = false}, SHIFT(455),
  [1113] = {.count = 1, .reusable = true}, SHIFT(456),
  [1115] = {.count = 1, .reusable = true}, SHIFT(457),
  [1117] = {.count = 1, .reusable = true}, SHIFT(459),
  [1119] = {.count = 1, .reusable = false}, SHIFT(460),
  [1121] = {.count = 1, .reusable = false}, SHIFT(462),
  [1123] = {.count = 1, .reusable = true}, SHIFT(463),
  [1125] = {.count = 1, .reusable = true}, SHIFT(1258),
  [1127] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1),
  [1130] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1), SHIFT(1259),
  [1133] = {.count = 1, .reusable = true}, SHIFT(1257),
  [1135] = {.count = 1, .reusable = false}, SHIFT(465),
  [1137] = {.count = 1, .reusable = false}, SHIFT(466),
  [1139] = {.count = 1, .reusable = true}, SHIFT(1262),
  [1141] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1),
  [1144] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 1), SHIFT(1263),
  [1147] = {.count = 1, .reusable = true}, SHIFT(1261),
  [1149] = {.count = 1, .reusable = true}, SHIFT(1797),
  [1151] = {.count = 1, .reusable = true}, SHIFT(469),
  [1153] = {.count = 1, .reusable = false}, SHIFT(1271),
  [1155] = {.count = 1, .reusable = false}, SHIFT(1797),
  [1157] = {.count = 1, .reusable = false}, SHIFT(1248),
  [1159] = {.count = 1, .reusable = true}, SHIFT(1271),
  [1161] = {.count = 1, .reusable = false}, SHIFT(1835),
  [1163] = {.count = 1, .reusable = false}, SHIFT(1836),
  [1165] = {.count = 1, .reusable = false}, SHIFT(2279),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [1169] = {.count = 1, .reusable = false}, REDUCE(sym__parameter_name, 1),
  [1171] = {.count = 1, .reusable = false}, SHIFT(1667),
  [1173] = {.count = 1, .reusable = true}, SHIFT(471),
  [1175] = {.count = 1, .reusable = true}, SHIFT(470),
  [1177] = {.count = 1, .reusable = true}, SHIFT(1354),
  [1179] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [1181] = {.count = 1, .reusable = true}, SHIFT(473),
  [1183] = {.count = 1, .reusable = true}, SHIFT(476),
  [1185] = {.count = 1, .reusable = true}, SHIFT(1327),
  [1187] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 13),
  [1190] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 13), SHIFT(1338),
  [1193] = {.count = 1, .reusable = false}, SHIFT(478),
  [1195] = {.count = 1, .reusable = false}, SHIFT(203),
  [1197] = {.count = 1, .reusable = false}, SHIFT(479),
  [1199] = {.count = 1, .reusable = false}, SHIFT(1872),
  [1201] = {.count = 1, .reusable = false}, SHIFT(480),
  [1203] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 14),
  [1206] = {.count = 2, .reusable = false}, REDUCE(sym__parameter_name, 1, .production_id = 14), SHIFT(1332),
  [1209] = {.count = 1, .reusable = true}, SHIFT(484),
  [1211] = {.count = 1, .reusable = true}, SHIFT(485),
  [1213] = {.count = 1, .reusable = true}, SHIFT(487),
  [1215] = {.count = 1, .reusable = true}, SHIFT(488),
  [1217] = {.count = 1, .reusable = true}, SHIFT(490),
  [1219] = {.count = 1, .reusable = true}, SHIFT(491),
  [1221] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [1223] = {.count = 1, .reusable = false}, SHIFT(494),
  [1225] = {.count = 1, .reusable = true}, SHIFT(494),
  [1227] = {.count = 1, .reusable = true}, SHIFT(495),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1231] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2, .production_id = 11),
  [1233] = {.count = 1, .reusable = false}, SHIFT(496),
  [1235] = {.count = 1, .reusable = false}, SHIFT(497),
  [1237] = {.count = 1, .reusable = true}, SHIFT(500),
  [1239] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [1241] = {.count = 1, .reusable = true}, SHIFT(501),
  [1243] = {.count = 1, .reusable = true}, SHIFT(502),
  [1245] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15), REDUCE(sym_type_parameter, 1, .production_id = 15),
  [1248] = {.count = 1, .reusable = true}, SHIFT(102),
  [1250] = {.count = 1, .reusable = true}, SHIFT(503),
  [1252] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [1254] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [1256] = {.count = 1, .reusable = true}, SHIFT(507),
  [1258] = {.count = 1, .reusable = false}, SHIFT(508),
  [1260] = {.count = 1, .reusable = true}, SHIFT(509),
  [1262] = {.count = 1, .reusable = true}, SHIFT(510),
  [1264] = {.count = 1, .reusable = true}, SHIFT(1300),
  [1266] = {.count = 1, .reusable = false}, SHIFT(513),
  [1268] = {.count = 1, .reusable = false}, SHIFT(511),
  [1270] = {.count = 1, .reusable = false}, SHIFT(512),
  [1272] = {.count = 1, .reusable = true}, SHIFT(514),
  [1274] = {.count = 1, .reusable = true}, SHIFT(521),
  [1276] = {.count = 1, .reusable = false}, SHIFT(515),
  [1278] = {.count = 1, .reusable = false}, SHIFT(516),
  [1280] = {.count = 1, .reusable = false}, SHIFT(517),
  [1282] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [1284] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [1286] = {.count = 1, .reusable = true}, SHIFT(524),
  [1288] = {.count = 1, .reusable = true}, SHIFT(525),
  [1290] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [1292] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [1294] = {.count = 1, .reusable = true}, SHIFT(526),
  [1296] = {.count = 1, .reusable = false}, SHIFT(531),
  [1298] = {.count = 1, .reusable = false}, SHIFT(532),
  [1300] = {.count = 1, .reusable = false}, SHIFT(534),
  [1302] = {.count = 1, .reusable = true}, SHIFT(530),
  [1304] = {.count = 1, .reusable = false}, SHIFT(533),
  [1306] = {.count = 1, .reusable = true}, SHIFT(537),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [1310] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [1312] = {.count = 1, .reusable = true}, SHIFT(538),
  [1314] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [1316] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [1318] = {.count = 1, .reusable = true}, SHIFT(541),
  [1320] = {.count = 1, .reusable = true}, SHIFT(540),
  [1322] = {.count = 1, .reusable = true}, SHIFT(544),
  [1324] = {.count = 1, .reusable = true}, SHIFT(543),
  [1326] = {.count = 1, .reusable = true}, SHIFT(545),
  [1328] = {.count = 1, .reusable = true}, SHIFT(546),
  [1330] = {.count = 1, .reusable = false}, SHIFT(549),
  [1332] = {.count = 1, .reusable = true}, SHIFT(551),
  [1334] = {.count = 1, .reusable = true}, SHIFT(2065),
  [1336] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [1338] = {.count = 1, .reusable = true}, SHIFT(2339),
  [1340] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 16),
  [1342] = {.count = 1, .reusable = false}, SHIFT(2340),
  [1344] = {.count = 1, .reusable = true}, SHIFT(555),
  [1346] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 17),
  [1348] = {.count = 1, .reusable = true}, SHIFT(2342),
  [1350] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 17),
  [1352] = {.count = 1, .reusable = false}, SHIFT(2343),
  [1354] = {.count = 1, .reusable = false}, SHIFT(2420),
  [1356] = {.count = 1, .reusable = false}, SHIFT(2350),
  [1358] = {.count = 1, .reusable = false}, SHIFT(2422),
  [1360] = {.count = 1, .reusable = false}, SHIFT(2384),
  [1362] = {.count = 1, .reusable = false}, SHIFT(2344),
  [1364] = {.count = 1, .reusable = false}, SHIFT(2421),
  [1366] = {.count = 1, .reusable = false}, SHIFT(2423),
  [1368] = {.count = 1, .reusable = true}, SHIFT(2350),
  [1370] = {.count = 1, .reusable = true}, SHIFT(2360),
  [1372] = {.count = 1, .reusable = false}, SHIFT(2361),
  [1374] = {.count = 1, .reusable = true}, SHIFT(2362),
  [1376] = {.count = 1, .reusable = false}, SHIFT(2363),
  [1378] = {.count = 1, .reusable = false}, SHIFT(2362),
  [1380] = {.count = 1, .reusable = true}, SHIFT(2364),
  [1382] = {.count = 1, .reusable = false}, SHIFT(2360),
  [1384] = {.count = 1, .reusable = false}, SHIFT(2364),
  [1386] = {.count = 1, .reusable = true}, SHIFT(2399),
  [1388] = {.count = 1, .reusable = true}, SHIFT(2361),
  [1390] = {.count = 1, .reusable = false}, SHIFT(2027),
  [1392] = {.count = 1, .reusable = true}, SHIFT(2365),
  [1394] = {.count = 1, .reusable = false}, SHIFT(2368),
  [1396] = {.count = 1, .reusable = false}, SHIFT(2366),
  [1398] = {.count = 1, .reusable = true}, SHIFT(559),
  [1400] = {.count = 1, .reusable = true}, SHIFT(560),
  [1402] = {.count = 1, .reusable = false}, SHIFT(562),
  [1404] = {.count = 1, .reusable = false}, SHIFT(2229),
  [1406] = {.count = 1, .reusable = false}, SHIFT(2230),
  [1408] = {.count = 1, .reusable = false}, SHIFT(2512),
  [1410] = {.count = 1, .reusable = false}, SHIFT(2231),
  [1412] = {.count = 1, .reusable = false}, SHIFT(2513),
  [1414] = {.count = 1, .reusable = true}, SHIFT(2514),
  [1416] = {.count = 1, .reusable = false}, SHIFT(563),
  [1418] = {.count = 1, .reusable = false}, SHIFT(2515),
  [1420] = {.count = 1, .reusable = false}, SHIFT(2234),
  [1422] = {.count = 1, .reusable = true}, SHIFT(2517),
  [1424] = {.count = 1, .reusable = false}, SHIFT(2232),
  [1426] = {.count = 1, .reusable = true}, SHIFT(563),
  [1428] = {.count = 1, .reusable = false}, SHIFT(2519),
  [1430] = {.count = 1, .reusable = false}, SHIFT(2520),
  [1432] = {.count = 1, .reusable = true}, SHIFT(564),
  [1434] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2, .production_id = 18),
  [1436] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2, .production_id = 18),
  [1438] = {.count = 1, .reusable = true}, SHIFT(565),
  [1440] = {.count = 1, .reusable = true}, SHIFT(566),
  [1442] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [1444] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1446] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1448] = {.count = 1, .reusable = false}, SHIFT(568),
  [1450] = {.count = 1, .reusable = true}, SHIFT(568),
  [1452] = {.count = 1, .reusable = false}, SHIFT(569),
  [1454] = {.count = 1, .reusable = true}, SHIFT(569),
  [1456] = {.count = 1, .reusable = false}, SHIFT(570),
  [1458] = {.count = 1, .reusable = true}, SHIFT(570),
  [1460] = {.count = 1, .reusable = false}, SHIFT(571),
  [1462] = {.count = 1, .reusable = true}, SHIFT(571),
  [1464] = {.count = 1, .reusable = false}, SHIFT(572),
  [1466] = {.count = 1, .reusable = true}, SHIFT(572),
  [1468] = {.count = 1, .reusable = false}, SHIFT(574),
  [1470] = {.count = 1, .reusable = true}, SHIFT(574),
  [1472] = {.count = 1, .reusable = false}, SHIFT(575),
  [1474] = {.count = 1, .reusable = true}, SHIFT(575),
  [1476] = {.count = 1, .reusable = false}, SHIFT(1356),
  [1478] = {.count = 1, .reusable = false}, SHIFT(1301),
  [1480] = {.count = 1, .reusable = true}, SHIFT(2253),
  [1482] = {.count = 1, .reusable = false}, SHIFT(1304),
  [1484] = {.count = 1, .reusable = false}, SHIFT(1845),
  [1486] = {.count = 1, .reusable = false}, SHIFT(1847),
  [1488] = {.count = 1, .reusable = true}, SHIFT(1846),
  [1490] = {.count = 1, .reusable = true}, SHIFT(1305),
  [1492] = {.count = 1, .reusable = false}, SHIFT(1843),
  [1494] = {.count = 1, .reusable = true}, SHIFT(1306),
  [1496] = {.count = 1, .reusable = true}, SHIFT(2255),
  [1498] = {.count = 1, .reusable = true}, SHIFT(1843),
  [1500] = {.count = 1, .reusable = true}, SHIFT(1303),
  [1502] = {.count = 1, .reusable = true}, SHIFT(1302),
  [1504] = {.count = 1, .reusable = false}, SHIFT(1307),
  [1506] = {.count = 1, .reusable = true}, SHIFT(1301),
  [1508] = {.count = 1, .reusable = false}, SHIFT(2254),
  [1510] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [1512] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2, .production_id = 19),
  [1514] = {.count = 1, .reusable = false}, SHIFT(578),
  [1516] = {.count = 1, .reusable = false}, SHIFT(580),
  [1518] = {.count = 1, .reusable = false}, SHIFT(582),
  [1520] = {.count = 1, .reusable = false}, SHIFT(583),
  [1522] = {.count = 1, .reusable = false}, SHIFT(585),
  [1524] = {.count = 1, .reusable = false}, SHIFT(579),
  [1526] = {.count = 1, .reusable = true}, SHIFT(1401),
  [1528] = {.count = 1, .reusable = false}, SHIFT(581),
  [1530] = {.count = 1, .reusable = false}, SHIFT(1909),
  [1532] = {.count = 1, .reusable = true}, SHIFT(584),
  [1534] = {.count = 1, .reusable = true}, SHIFT(579),
  [1536] = {.count = 1, .reusable = false}, SHIFT(586),
  [1538] = {.count = 1, .reusable = false}, SHIFT(589),
  [1540] = {.count = 1, .reusable = true}, SHIFT(589),
  [1542] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [1544] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [1546] = {.count = 1, .reusable = false}, SHIFT(590),
  [1548] = {.count = 1, .reusable = true}, SHIFT(590),
  [1550] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [1552] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [1554] = {.count = 1, .reusable = false}, SHIFT(592),
  [1556] = {.count = 1, .reusable = true}, SHIFT(592),
  [1558] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20),
  [1560] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 21),
  [1562] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1565] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1568] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1571] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1577] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1580] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1583] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1589] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1592] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1595] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1597] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1600] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [1602] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1605] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1608] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1614] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1617] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [1620] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1623] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1626] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1629] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1632] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1635] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1638] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1644] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1647] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1650] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1653] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1656] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1659] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1665] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1671] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1674] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(39),
  [1680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(40),
  [1683] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [1686] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [1692] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [1695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [1698] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [1701] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [1704] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [1707] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(48),
  [1710] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(49),
  [1713] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [1716] = {.count = 1, .reusable = false}, SHIFT(595),
  [1718] = {.count = 1, .reusable = true}, SHIFT(595),
  [1720] = {.count = 1, .reusable = true}, SHIFT(596),
  [1722] = {.count = 1, .reusable = false}, SHIFT(598),
  [1724] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [1726] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(6),
  [1729] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [1731] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 23),
  [1733] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [1735] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [1737] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 25),
  [1739] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [1741] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [1743] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 26),
  [1745] = {.count = 1, .reusable = true}, SHIFT(601),
  [1747] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [1749] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [1751] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(71),
  [1754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(302),
  [1757] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [1759] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [1761] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 27),
  [1763] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 28),
  [1765] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 28),
  [1767] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 29),
  [1769] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 29),
  [1771] = {.count = 1, .reusable = true}, SHIFT(602),
  [1773] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 30),
  [1775] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 30),
  [1777] = {.count = 1, .reusable = true}, SHIFT(603),
  [1779] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2, .production_id = 9),
  [1781] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2, .production_id = 9),
  [1783] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12),
  [1785] = {.count = 1, .reusable = true}, SHIFT(607),
  [1787] = {.count = 1, .reusable = true}, SHIFT(608),
  [1789] = {.count = 1, .reusable = true}, SHIFT(609),
  [1791] = {.count = 1, .reusable = true}, SHIFT(610),
  [1793] = {.count = 1, .reusable = true}, SHIFT(611),
  [1795] = {.count = 1, .reusable = true}, SHIFT(613),
  [1797] = {.count = 1, .reusable = false}, SHIFT(614),
  [1799] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1801] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1803] = {.count = 1, .reusable = false}, SHIFT(615),
  [1805] = {.count = 1, .reusable = true}, SHIFT(615),
  [1807] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 32),
  [1809] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 33),
  [1811] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 34),
  [1813] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 35),
  [1815] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [1817] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [1819] = {.count = 1, .reusable = true}, SHIFT(620),
  [1821] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 36),
  [1823] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 37),
  [1825] = {.count = 1, .reusable = true}, SHIFT(623),
  [1827] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15),
  [1829] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [1831] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [1833] = {.count = 1, .reusable = true}, SHIFT(624),
  [1835] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3, .production_id = 38),
  [1837] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3, .production_id = 38),
  [1839] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [1841] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [1843] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 39),
  [1845] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 39),
  [1847] = {.count = 1, .reusable = true}, SHIFT(629),
  [1849] = {.count = 1, .reusable = true}, SHIFT(630),
  [1851] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3, .production_id = 40),
  [1853] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3, .production_id = 40),
  [1855] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1857] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1859] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3, .production_id = 41),
  [1861] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3, .production_id = 41),
  [1863] = {.count = 1, .reusable = false}, SHIFT(632),
  [1865] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 3),
  [1867] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [1869] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [1871] = {.count = 1, .reusable = true}, SHIFT(2141),
  [1873] = {.count = 1, .reusable = false}, SHIFT(1599),
  [1875] = {.count = 1, .reusable = false}, SHIFT(1590),
  [1877] = {.count = 1, .reusable = true}, SHIFT(2394),
  [1879] = {.count = 1, .reusable = false}, SHIFT(1593),
  [1881] = {.count = 1, .reusable = false}, SHIFT(2067),
  [1883] = {.count = 1, .reusable = false}, SHIFT(2069),
  [1885] = {.count = 1, .reusable = true}, SHIFT(2068),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1594),
  [1889] = {.count = 1, .reusable = false}, SHIFT(2066),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1595),
  [1893] = {.count = 1, .reusable = true}, SHIFT(2396),
  [1895] = {.count = 1, .reusable = true}, SHIFT(2066),
  [1897] = {.count = 1, .reusable = true}, SHIFT(1592),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1591),
  [1901] = {.count = 1, .reusable = false}, SHIFT(1596),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1590),
  [1905] = {.count = 1, .reusable = false}, SHIFT(2395),
  [1907] = {.count = 1, .reusable = true}, SHIFT(637),
  [1909] = {.count = 1, .reusable = false}, SHIFT(640),
  [1911] = {.count = 1, .reusable = false}, SHIFT(639),
  [1913] = {.count = 1, .reusable = true}, SHIFT(641),
  [1915] = {.count = 1, .reusable = true}, SHIFT(642),
  [1917] = {.count = 1, .reusable = true}, SHIFT(644),
  [1919] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1, .production_id = 6),
  [1921] = {.count = 1, .reusable = true}, SHIFT(645),
  [1923] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [1925] = {.count = 1, .reusable = true}, SHIFT(646),
  [1927] = {.count = 1, .reusable = true}, SHIFT(647),
  [1929] = {.count = 1, .reusable = true}, SHIFT(648),
  [1931] = {.count = 1, .reusable = true}, SHIFT(649),
  [1933] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [1935] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [1937] = {.count = 1, .reusable = true}, SHIFT(652),
  [1939] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2, .production_id = 42),
  [1941] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2, .production_id = 42),
  [1943] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1945] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1947] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(374),
  [1950] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(374),
  [1953] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1955] = {.count = 1, .reusable = true}, SHIFT(653),
  [1957] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(653),
  [1960] = {.count = 1, .reusable = true}, SHIFT(654),
  [1962] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(654),
  [1965] = {.count = 1, .reusable = false}, SHIFT(654),
  [1967] = {.count = 1, .reusable = false}, SHIFT(655),
  [1969] = {.count = 1, .reusable = false}, SHIFT(1854),
  [1971] = {.count = 1, .reusable = false}, SHIFT(656),
  [1973] = {.count = 1, .reusable = false}, SHIFT(657),
  [1975] = {.count = 1, .reusable = false}, SHIFT(658),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1854),
  [1979] = {.count = 1, .reusable = false}, SHIFT(659),
  [1981] = {.count = 1, .reusable = true}, SHIFT(664),
  [1983] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(664),
  [1986] = {.count = 1, .reusable = true}, SHIFT(665),
  [1988] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(665),
  [1991] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1993] = {.count = 1, .reusable = false}, SHIFT(1365),
  [1995] = {.count = 1, .reusable = false}, SHIFT(1366),
  [1997] = {.count = 1, .reusable = false}, SHIFT(666),
  [1999] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1368),
  [2003] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 3, .production_id = 43),
  [2005] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 3, .production_id = 43),
  [2007] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [2009] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [2011] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [2013] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [2015] = {.count = 1, .reusable = true}, SHIFT(668),
  [2017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(139),
  [2020] = {.count = 1, .reusable = true}, SHIFT(2414),
  [2022] = {.count = 1, .reusable = true}, SHIFT(669),
  [2024] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2, .production_id = 44),
  [2026] = {.count = 1, .reusable = false}, SHIFT(2415),
  [2028] = {.count = 1, .reusable = true}, SHIFT(2338),
  [2030] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(102),
  [2033] = {.count = 1, .reusable = true}, SHIFT(670),
  [2035] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [2037] = {.count = 1, .reusable = true}, SHIFT(2434),
  [2039] = {.count = 1, .reusable = false}, SHIFT(2435),
  [2041] = {.count = 1, .reusable = true}, SHIFT(2436),
  [2043] = {.count = 1, .reusable = false}, SHIFT(2437),
  [2045] = {.count = 1, .reusable = true}, SHIFT(2438),
  [2047] = {.count = 1, .reusable = false}, SHIFT(2436),
  [2049] = {.count = 1, .reusable = false}, SHIFT(2434),
  [2051] = {.count = 1, .reusable = false}, SHIFT(2438),
  [2053] = {.count = 1, .reusable = true}, SHIFT(2465),
  [2055] = {.count = 1, .reusable = true}, SHIFT(2435),
  [2057] = {.count = 1, .reusable = false}, SHIFT(2114),
  [2059] = {.count = 1, .reusable = true}, SHIFT(2439),
  [2061] = {.count = 1, .reusable = true}, SHIFT(673),
  [2063] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [2065] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 39),
  [2067] = {.count = 1, .reusable = true}, SHIFT(675),
  [2069] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 3, .production_id = 39),
  [2071] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 3, .production_id = 39),
  [2073] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 39),
  [2075] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 15),
  [2077] = {.count = 1, .reusable = true}, SHIFT(679),
  [2079] = {.count = 1, .reusable = false}, SHIFT(680),
  [2081] = {.count = 1, .reusable = false}, SHIFT(681),
  [2083] = {.count = 1, .reusable = false}, SHIFT(682),
  [2085] = {.count = 1, .reusable = false}, SHIFT(685),
  [2087] = {.count = 1, .reusable = false}, SHIFT(684),
  [2089] = {.count = 1, .reusable = false}, SHIFT(683),
  [2091] = {.count = 1, .reusable = true}, SHIFT(685),
  [2093] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [2095] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [2097] = {.count = 1, .reusable = false}, SHIFT(687),
  [2099] = {.count = 1, .reusable = true}, SHIFT(2289),
  [2101] = {.count = 1, .reusable = true}, SHIFT(690),
  [2103] = {.count = 1, .reusable = true}, SHIFT(689),
  [2105] = {.count = 1, .reusable = false}, SHIFT(688),
  [2107] = {.count = 1, .reusable = false}, SHIFT(691),
  [2109] = {.count = 1, .reusable = false}, SHIFT(693),
  [2111] = {.count = 1, .reusable = true}, SHIFT(694),
  [2113] = {.count = 1, .reusable = true}, SHIFT(692),
  [2115] = {.count = 1, .reusable = false}, SHIFT(1457),
  [2117] = {.count = 1, .reusable = false}, SHIFT(695),
  [2119] = {.count = 1, .reusable = true}, SHIFT(696),
  [2121] = {.count = 1, .reusable = true}, SHIFT(697),
  [2123] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2125] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2127] = {.count = 1, .reusable = false}, SHIFT(701),
  [2129] = {.count = 1, .reusable = false}, SHIFT(700),
  [2131] = {.count = 1, .reusable = false}, SHIFT(699),
  [2133] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1, .production_id = 6),
  [2135] = {.count = 1, .reusable = true}, SHIFT(702),
  [2137] = {.count = 1, .reusable = true}, SHIFT(703),
  [2139] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2141] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 45),
  [2143] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 45),
  [2145] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 46),
  [2147] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 46),
  [2149] = {.count = 1, .reusable = true}, SHIFT(708),
  [2151] = {.count = 1, .reusable = true}, SHIFT(2180),
  [2153] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2155] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2157] = {.count = 1, .reusable = true}, SHIFT(712),
  [2159] = {.count = 1, .reusable = true}, SHIFT(713),
  [2161] = {.count = 1, .reusable = true}, SHIFT(715),
  [2163] = {.count = 1, .reusable = true}, SHIFT(716),
  [2165] = {.count = 1, .reusable = true}, SHIFT(717),
  [2167] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 47),
  [2169] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 47),
  [2171] = {.count = 1, .reusable = false}, SHIFT(718),
  [2173] = {.count = 1, .reusable = true}, SHIFT(718),
  [2175] = {.count = 1, .reusable = true}, SHIFT(719),
  [2177] = {.count = 1, .reusable = false}, SHIFT(720),
  [2179] = {.count = 1, .reusable = true}, SHIFT(720),
  [2181] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 47),
  [2183] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [2185] = {.count = 1, .reusable = false}, SHIFT(1949),
  [2187] = {.count = 1, .reusable = true}, SHIFT(1949),
  [2189] = {.count = 1, .reusable = true}, SHIFT(721),
  [2191] = {.count = 1, .reusable = true}, SHIFT(723),
  [2193] = {.count = 1, .reusable = false}, SHIFT(724),
  [2195] = {.count = 1, .reusable = true}, SHIFT(725),
  [2197] = {.count = 1, .reusable = false}, SHIFT(726),
  [2199] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [2201] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [2203] = {.count = 1, .reusable = true}, SHIFT(727),
  [2205] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [2207] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [2209] = {.count = 1, .reusable = true}, SHIFT(728),
  [2211] = {.count = 1, .reusable = false}, SHIFT(729),
  [2213] = {.count = 1, .reusable = true}, SHIFT(729),
  [2215] = {.count = 1, .reusable = false}, SHIFT(730),
  [2217] = {.count = 1, .reusable = true}, SHIFT(730),
  [2219] = {.count = 1, .reusable = true}, SHIFT(733),
  [2221] = {.count = 1, .reusable = false}, SHIFT(734),
  [2223] = {.count = 1, .reusable = true}, SHIFT(734),
  [2225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(168),
  [2228] = {.count = 1, .reusable = false}, SHIFT(735),
  [2230] = {.count = 1, .reusable = true}, SHIFT(737),
  [2232] = {.count = 1, .reusable = true}, SHIFT(738),
  [2234] = {.count = 1, .reusable = true}, SHIFT(736),
  [2236] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3, .production_id = 48),
  [2238] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3, .production_id = 48),
  [2240] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 4),
  [2242] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2),
  [2244] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 49),
  [2246] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 2, .production_id = 50),
  [2248] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [2250] = {.count = 1, .reusable = true}, SHIFT(741),
  [2252] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [2254] = {.count = 1, .reusable = true}, SHIFT(744),
  [2256] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [2258] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 51),
  [2260] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [2262] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2264] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2266] = {.count = 1, .reusable = true}, SHIFT(749),
  [2268] = {.count = 1, .reusable = false}, SHIFT(750),
  [2270] = {.count = 1, .reusable = false}, SHIFT(751),
  [2272] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1),
  [2274] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 13),
  [2276] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 14),
  [2278] = {.count = 1, .reusable = false}, SHIFT(756),
  [2280] = {.count = 1, .reusable = true}, SHIFT(756),
  [2282] = {.count = 1, .reusable = false}, SHIFT(758),
  [2284] = {.count = 1, .reusable = true}, SHIFT(758),
  [2286] = {.count = 1, .reusable = true}, SHIFT(760),
  [2288] = {.count = 1, .reusable = false}, SHIFT(764),
  [2290] = {.count = 1, .reusable = true}, SHIFT(764),
  [2292] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2294] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2296] = {.count = 1, .reusable = true}, SHIFT(765),
  [2298] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3, .production_id = 52),
  [2300] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3, .production_id = 52),
  [2302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(494),
  [2305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(494),
  [2308] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [2310] = {.count = 1, .reusable = true}, SHIFT(766),
  [2312] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 53),
  [2314] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 53),
  [2316] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3, .production_id = 54),
  [2318] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3, .production_id = 54),
  [2320] = {.count = 1, .reusable = true}, SHIFT(772),
  [2322] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 15),
  [2324] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2326] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2328] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2330] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2332] = {.count = 1, .reusable = true}, SHIFT(776),
  [2334] = {.count = 1, .reusable = true}, SHIFT(778),
  [2336] = {.count = 1, .reusable = false}, SHIFT(777),
  [2338] = {.count = 1, .reusable = false}, SHIFT(780),
  [2340] = {.count = 1, .reusable = false}, SHIFT(1478),
  [2342] = {.count = 1, .reusable = true}, SHIFT(781),
  [2344] = {.count = 1, .reusable = false}, SHIFT(779),
  [2346] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2348] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2350] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2352] = {.count = 1, .reusable = true}, SHIFT(2392),
  [2354] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2356] = {.count = 1, .reusable = true}, SHIFT(2265),
  [2358] = {.count = 1, .reusable = true}, SHIFT(784),
  [2360] = {.count = 1, .reusable = true}, SHIFT(2203),
  [2362] = {.count = 1, .reusable = true}, SHIFT(2623),
  [2364] = {.count = 1, .reusable = true}, SHIFT(2214),
  [2366] = {.count = 1, .reusable = true}, SHIFT(2204),
  [2368] = {.count = 1, .reusable = true}, SHIFT(2266),
  [2370] = {.count = 1, .reusable = true}, SHIFT(2205),
  [2372] = {.count = 1, .reusable = false}, SHIFT(2538),
  [2374] = {.count = 1, .reusable = true}, SHIFT(2529),
  [2376] = {.count = 1, .reusable = true}, SHIFT(2516),
  [2378] = {.count = 1, .reusable = true}, SHIFT(2530),
  [2380] = {.count = 1, .reusable = true}, SHIFT(2217),
  [2382] = {.count = 1, .reusable = true}, SHIFT(2531),
  [2384] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2386] = {.count = 1, .reusable = true}, SHIFT(785),
  [2388] = {.count = 1, .reusable = true}, SHIFT(786),
  [2390] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2392] = {.count = 1, .reusable = false}, SHIFT(788),
  [2394] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1, .production_id = 6),
  [2396] = {.count = 1, .reusable = true}, SHIFT(789),
  [2398] = {.count = 1, .reusable = true}, SHIFT(792),
  [2400] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2402] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2404] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2406] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2408] = {.count = 1, .reusable = false}, SHIFT(1885),
  [2410] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2412] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2414] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 44),
  [2416] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 44),
  [2418] = {.count = 1, .reusable = false}, SHIFT(502),
  [2420] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2422] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2424] = {.count = 1, .reusable = true}, SHIFT(794),
  [2426] = {.count = 1, .reusable = false}, SHIFT(1624),
  [2428] = {.count = 1, .reusable = false}, SHIFT(1626),
  [2430] = {.count = 1, .reusable = false}, SHIFT(2044),
  [2432] = {.count = 1, .reusable = false}, SHIFT(1627),
  [2434] = {.count = 1, .reusable = false}, SHIFT(1628),
  [2436] = {.count = 1, .reusable = false}, SHIFT(1625),
  [2438] = {.count = 1, .reusable = false}, SHIFT(2043),
  [2440] = {.count = 1, .reusable = false}, SHIFT(2157),
  [2442] = {.count = 1, .reusable = true}, SHIFT(1925),
  [2444] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2446] = {.count = 1, .reusable = false}, SHIFT(1808),
  [2448] = {.count = 1, .reusable = true}, SHIFT(1625),
  [2450] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2452] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 1),
  [2454] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2457] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2460] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2462] = {.count = 1, .reusable = true}, SHIFT(796),
  [2464] = {.count = 1, .reusable = true}, SHIFT(797),
  [2466] = {.count = 1, .reusable = true}, SHIFT(2544),
  [2468] = {.count = 1, .reusable = false}, SHIFT(1352),
  [2470] = {.count = 1, .reusable = false}, SHIFT(798),
  [2472] = {.count = 1, .reusable = false}, SHIFT(800),
  [2474] = {.count = 1, .reusable = true}, SHIFT(801),
  [2476] = {.count = 1, .reusable = false}, SHIFT(799),
  [2478] = {.count = 1, .reusable = true}, SHIFT(805),
  [2480] = {.count = 1, .reusable = false}, SHIFT(802),
  [2482] = {.count = 1, .reusable = false}, SHIFT(803),
  [2484] = {.count = 2, .reusable = true}, REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [2487] = {.count = 1, .reusable = true}, SHIFT(806),
  [2489] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2491] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2493] = {.count = 1, .reusable = true}, SHIFT(808),
  [2495] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2497] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2499] = {.count = 1, .reusable = true}, SHIFT(810),
  [2501] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [2503] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [2505] = {.count = 1, .reusable = true}, SHIFT(812),
  [2507] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2509] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2511] = {.count = 1, .reusable = true}, SHIFT(816),
  [2513] = {.count = 1, .reusable = true}, SHIFT(818),
  [2515] = {.count = 1, .reusable = true}, SHIFT(820),
  [2517] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .production_id = 55),
  [2519] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .production_id = 55),
  [2521] = {.count = 1, .reusable = false}, SHIFT(821),
  [2523] = {.count = 1, .reusable = true}, SHIFT(822),
  [2525] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3, .production_id = 56),
  [2527] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3, .production_id = 56),
  [2529] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [2531] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 57),
  [2533] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [2535] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [2537] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [2539] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 58),
  [2541] = {.count = 1, .reusable = true}, SHIFT(829),
  [2543] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [2545] = {.count = 1, .reusable = true}, SHIFT(830),
  [2547] = {.count = 1, .reusable = true}, SHIFT(831),
  [2549] = {.count = 1, .reusable = true}, SHIFT(832),
  [2551] = {.count = 1, .reusable = true}, SHIFT(2268),
  [2553] = {.count = 1, .reusable = true}, SHIFT(834),
  [2555] = {.count = 1, .reusable = false}, SHIFT(2269),
  [2557] = {.count = 1, .reusable = true}, SHIFT(2270),
  [2559] = {.count = 1, .reusable = false}, SHIFT(2271),
  [2561] = {.count = 1, .reusable = false}, SHIFT(2270),
  [2563] = {.count = 1, .reusable = true}, SHIFT(2272),
  [2565] = {.count = 1, .reusable = false}, SHIFT(2268),
  [2567] = {.count = 1, .reusable = false}, SHIFT(2272),
  [2569] = {.count = 1, .reusable = true}, SHIFT(2625),
  [2571] = {.count = 1, .reusable = true}, SHIFT(2269),
  [2573] = {.count = 1, .reusable = false}, SHIFT(1858),
  [2575] = {.count = 1, .reusable = true}, SHIFT(2274),
  [2577] = {.count = 1, .reusable = true}, SHIFT(835),
  [2579] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2581] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2583] = {.count = 1, .reusable = true}, SHIFT(2241),
  [2585] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3, .production_id = 59),
  [2587] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3, .production_id = 59),
  [2589] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3, .production_id = 60),
  [2591] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60),
  [2593] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(279),
  [2596] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3, .production_id = 24),
  [2598] = {.count = 1, .reusable = true}, SHIFT(837),
  [2600] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [2602] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [2604] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2607] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [2610] = {.count = 1, .reusable = true}, SHIFT(1947),
  [2612] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2615] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2618] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2621] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2624] = {.count = 1, .reusable = false}, SHIFT(838),
  [2626] = {.count = 1, .reusable = true}, SHIFT(839),
  [2628] = {.count = 1, .reusable = false}, SHIFT(840),
  [2630] = {.count = 1, .reusable = false}, SHIFT(841),
  [2632] = {.count = 1, .reusable = false}, SHIFT(2128),
  [2634] = {.count = 1, .reusable = false}, SHIFT(842),
  [2636] = {.count = 1, .reusable = false}, SHIFT(843),
  [2638] = {.count = 1, .reusable = false}, SHIFT(1749),
  [2640] = {.count = 1, .reusable = false}, SHIFT(2127),
  [2642] = {.count = 1, .reusable = false}, SHIFT(2188),
  [2644] = {.count = 1, .reusable = true}, SHIFT(1749),
  [2646] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [2649] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1),
  [2652] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(537),
  [2655] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [2657] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 62),
  [2659] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 62),
  [2661] = {.count = 1, .reusable = true}, REDUCE(sym__call_signature, 3, .production_id = 63),
  [2663] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [2665] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [2667] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [2669] = {.count = 1, .reusable = false}, SHIFT(847),
  [2671] = {.count = 1, .reusable = true}, SHIFT(847),
  [2673] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3, .production_id = 65),
  [2675] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3, .production_id = 65),
  [2677] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [2679] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 29),
  [2681] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 29),
  [2683] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [2685] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 26),
  [2687] = {.count = 1, .reusable = false}, SHIFT(857),
  [2689] = {.count = 1, .reusable = true}, SHIFT(857),
  [2691] = {.count = 1, .reusable = false}, SHIFT(858),
  [2693] = {.count = 1, .reusable = true}, SHIFT(858),
  [2695] = {.count = 1, .reusable = false}, SHIFT(859),
  [2697] = {.count = 1, .reusable = true}, SHIFT(859),
  [2699] = {.count = 1, .reusable = true}, SHIFT(861),
  [2701] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2, .production_id = 66),
  [2703] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 67),
  [2705] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4, .production_id = 68),
  [2707] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4, .production_id = 68),
  [2709] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 69),
  [2711] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2713] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2715] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2717] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(332),
  [2720] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 70),
  [2722] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4, .production_id = 71),
  [2724] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4, .production_id = 71),
  [2726] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [2728] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [2730] = {.count = 1, .reusable = true}, SHIFT(867),
  [2732] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 72),
  [2734] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 72),
  [2736] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 73),
  [2738] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 73),
  [2740] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2742] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2744] = {.count = 1, .reusable = true}, SHIFT(870),
  [2746] = {.count = 1, .reusable = true}, SHIFT(869),
  [2748] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 74),
  [2750] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 74),
  [2752] = {.count = 1, .reusable = true}, SHIFT(877),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1621),
  [2756] = {.count = 1, .reusable = true}, SHIFT(1622),
  [2758] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [2760] = {.count = 1, .reusable = true}, SHIFT(879),
  [2762] = {.count = 1, .reusable = true}, SHIFT(880),
  [2764] = {.count = 1, .reusable = true}, SHIFT(371),
  [2766] = {.count = 1, .reusable = true}, SHIFT(639),
  [2768] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2772] = {.count = 1, .reusable = true}, SHIFT(881),
  [2774] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [2776] = {.count = 1, .reusable = true}, SHIFT(882),
  [2778] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2, .production_id = 75),
  [2780] = {.count = 1, .reusable = true}, SHIFT(883),
  [2782] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [2784] = {.count = 1, .reusable = true}, SHIFT(884),
  [2786] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 76),
  [2788] = {.count = 1, .reusable = true}, SHIFT(886),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2, .production_id = 77),
  [2792] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [2794] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [2796] = {.count = 1, .reusable = false}, SHIFT(889),
  [2798] = {.count = 1, .reusable = true}, SHIFT(889),
  [2800] = {.count = 1, .reusable = false}, SHIFT(891),
  [2802] = {.count = 1, .reusable = true}, SHIFT(891),
  [2804] = {.count = 1, .reusable = false}, SHIFT(892),
  [2806] = {.count = 1, .reusable = true}, SHIFT(893),
  [2808] = {.count = 1, .reusable = true}, SHIFT(2413),
  [2810] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(893),
  [2813] = {.count = 1, .reusable = true}, SHIFT(894),
  [2815] = {.count = 1, .reusable = true}, SHIFT(2416),
  [2817] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(894),
  [2820] = {.count = 1, .reusable = false}, SHIFT(2577),
  [2822] = {.count = 1, .reusable = false}, SHIFT(894),
  [2824] = {.count = 1, .reusable = false}, SHIFT(2455),
  [2826] = {.count = 1, .reusable = false}, SHIFT(2456),
  [2828] = {.count = 1, .reusable = false}, SHIFT(895),
  [2830] = {.count = 1, .reusable = true}, SHIFT(896),
  [2832] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(896),
  [2835] = {.count = 1, .reusable = false}, SHIFT(897),
  [2837] = {.count = 1, .reusable = true}, SHIFT(898),
  [2839] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(898),
  [2842] = {.count = 1, .reusable = false}, SHIFT(901),
  [2844] = {.count = 1, .reusable = true}, SHIFT(899),
  [2846] = {.count = 1, .reusable = true}, SHIFT(901),
  [2848] = {.count = 1, .reusable = false}, SHIFT(903),
  [2850] = {.count = 1, .reusable = true}, SHIFT(903),
  [2852] = {.count = 1, .reusable = false}, SHIFT(905),
  [2854] = {.count = 1, .reusable = true}, SHIFT(905),
  [2856] = {.count = 1, .reusable = false}, SHIFT(906),
  [2858] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 4, .production_id = 78),
  [2860] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 4, .production_id = 78),
  [2862] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [2864] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [2866] = {.count = 1, .reusable = false}, SHIFT(909),
  [2868] = {.count = 1, .reusable = false}, SHIFT(911),
  [2870] = {.count = 1, .reusable = true}, SHIFT(911),
  [2872] = {.count = 1, .reusable = true}, SHIFT(913),
  [2874] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3, .production_id = 44),
  [2876] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [2878] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [2880] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 39),
  [2882] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 39),
  [2884] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 72),
  [2886] = {.count = 1, .reusable = true}, SHIFT(915),
  [2888] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 72),
  [2890] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 72),
  [2892] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 72),
  [2894] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 73),
  [2896] = {.count = 1, .reusable = true}, SHIFT(916),
  [2898] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [2900] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [2902] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 73),
  [2904] = {.count = 1, .reusable = true}, SHIFT(918),
  [2906] = {.count = 1, .reusable = true}, SHIFT(920),
  [2908] = {.count = 1, .reusable = false}, SHIFT(921),
  [2910] = {.count = 1, .reusable = true}, SHIFT(922),
  [2912] = {.count = 1, .reusable = true}, SHIFT(923),
  [2914] = {.count = 1, .reusable = true}, SHIFT(924),
  [2916] = {.count = 1, .reusable = true}, SHIFT(925),
  [2918] = {.count = 1, .reusable = true}, SHIFT(926),
  [2920] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 75),
  [2922] = {.count = 1, .reusable = true}, SHIFT(927),
  [2924] = {.count = 1, .reusable = true}, SHIFT(928),
  [2926] = {.count = 1, .reusable = true}, SHIFT(932),
  [2928] = {.count = 1, .reusable = true}, SHIFT(934),
  [2930] = {.count = 1, .reusable = false}, SHIFT(933),
  [2932] = {.count = 1, .reusable = true}, SHIFT(935),
  [2934] = {.count = 1, .reusable = false}, SHIFT(1519),
  [2936] = {.count = 1, .reusable = false}, SHIFT(936),
  [2938] = {.count = 1, .reusable = true}, SHIFT(937),
  [2940] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2942] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2944] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [2946] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [2948] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(407),
  [2951] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(405),
  [2954] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2511),
  [2957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(409),
  [2960] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(406),
  [2963] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(413),
  [2966] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(404),
  [2969] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(412),
  [2972] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2178),
  [2975] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(418),
  [2978] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(410),
  [2981] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(411),
  [2984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2177),
  [2987] = {.count = 1, .reusable = false}, SHIFT(938),
  [2989] = {.count = 1, .reusable = false}, SHIFT(939),
  [2991] = {.count = 1, .reusable = false}, SHIFT(940),
  [2993] = {.count = 1, .reusable = true}, SHIFT(942),
  [2995] = {.count = 1, .reusable = true}, SHIFT(941),
  [2997] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 6),
  [2999] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2, .production_id = 79),
  [3001] = {.count = 1, .reusable = true}, SHIFT(2183),
  [3003] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 32),
  [3005] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2, .production_id = 33),
  [3007] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 80),
  [3009] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 80),
  [3011] = {.count = 1, .reusable = true}, SHIFT(947),
  [3013] = {.count = 1, .reusable = true}, SHIFT(952),
  [3015] = {.count = 1, .reusable = true}, SHIFT(2193),
  [3017] = {.count = 1, .reusable = true}, SHIFT(640),
  [3019] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 81), REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [3022] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 81),
  [3024] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 47),
  [3026] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 47),
  [3028] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 81), REDUCE(sym_assignment_expression, 3, .production_id = 28),
  [3031] = {.count = 1, .reusable = true}, SHIFT(960),
  [3033] = {.count = 1, .reusable = true}, SHIFT(962),
  [3035] = {.count = 1, .reusable = false}, SHIFT(963),
  [3037] = {.count = 1, .reusable = true}, SHIFT(964),
  [3039] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3042] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [3045] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [3047] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [3049] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [3051] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 61), REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [3054] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 61),
  [3056] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 82),
  [3058] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3, .production_id = 83),
  [3060] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 4),
  [3062] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 4),
  [3064] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [3067] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 3, .production_id = 64),
  [3069] = {.count = 1, .reusable = false}, SHIFT(966),
  [3071] = {.count = 1, .reusable = false}, SHIFT(968),
  [3073] = {.count = 1, .reusable = true}, SHIFT(968),
  [3075] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [3077] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [3079] = {.count = 1, .reusable = true}, SHIFT(969),
  [3081] = {.count = 1, .reusable = true}, SHIFT(970),
  [3083] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [3085] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [3087] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [3089] = {.count = 1, .reusable = true}, SHIFT(973),
  [3091] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22), SHIFT_REPEAT(974),
  [3094] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 22),
  [3096] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 84),
  [3098] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [3100] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 84),
  [3102] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [3104] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [3106] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 85),
  [3108] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3),
  [3110] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 86),
  [3112] = {.count = 1, .reusable = true}, REDUCE(sym__parameter_name, 3, .production_id = 87),
  [3114] = {.count = 1, .reusable = true}, SHIFT(976),
  [3116] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 88),
  [3118] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 88),
  [3120] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 89),
  [3122] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 89),
  [3124] = {.count = 1, .reusable = true}, SHIFT(977),
  [3126] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 90),
  [3128] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 90),
  [3130] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 91),
  [3132] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 91),
  [3134] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [3136] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [3138] = {.count = 1, .reusable = true}, SHIFT(981),
  [3140] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [3142] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2, .production_id = 11),
  [3144] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [3146] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2, .production_id = 11),
  [3148] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 92),
  [3150] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 92),
  [3152] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [3154] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [3156] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 93),
  [3158] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 93),
  [3160] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [3162] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [3164] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 15),
  [3166] = {.count = 1, .reusable = true}, SHIFT(984),
  [3168] = {.count = 1, .reusable = true}, SHIFT(985),
  [3170] = {.count = 1, .reusable = true}, SHIFT(987),
  [3172] = {.count = 1, .reusable = true}, SHIFT(989),
  [3174] = {.count = 1, .reusable = false}, SHIFT(990),
  [3176] = {.count = 1, .reusable = false}, SHIFT(992),
  [3178] = {.count = 1, .reusable = true}, SHIFT(993),
  [3180] = {.count = 1, .reusable = true}, SHIFT(991),
  [3182] = {.count = 1, .reusable = false}, SHIFT(1531),
  [3184] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 75),
  [3186] = {.count = 1, .reusable = true}, SHIFT(994),
  [3188] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [3190] = {.count = 1, .reusable = true}, SHIFT(1917),
  [3192] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [3194] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [3196] = {.count = 1, .reusable = false}, SHIFT(1000),
  [3198] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 6),
  [3200] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2, .production_id = 33),
  [3202] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [3204] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1003),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1005),
  [3210] = {.count = 1, .reusable = false}, SHIFT(2552),
  [3212] = {.count = 1, .reusable = false}, SHIFT(2079),
  [3214] = {.count = 1, .reusable = false}, SHIFT(2553),
  [3216] = {.count = 1, .reusable = false}, SHIFT(2554),
  [3218] = {.count = 1, .reusable = false}, SHIFT(2555),
  [3220] = {.count = 1, .reusable = true}, SHIFT(2079),
  [3222] = {.count = 1, .reusable = false}, SHIFT(2556),
  [3224] = {.count = 1, .reusable = false}, SHIFT(1380),
  [3226] = {.count = 1, .reusable = false}, SHIFT(1381),
  [3228] = {.count = 1, .reusable = false}, SHIFT(1006),
  [3230] = {.count = 1, .reusable = false}, SHIFT(1008),
  [3232] = {.count = 1, .reusable = false}, SHIFT(1007),
  [3234] = {.count = 1, .reusable = false}, SHIFT(1009),
  [3236] = {.count = 1, .reusable = true}, SHIFT(2558),
  [3238] = {.count = 1, .reusable = false}, SHIFT(2378),
  [3240] = {.count = 1, .reusable = true}, SHIFT(2310),
  [3242] = {.count = 1, .reusable = false}, SHIFT(2559),
  [3244] = {.count = 1, .reusable = false}, SHIFT(2557),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1011),
  [3248] = {.count = 1, .reusable = false}, SHIFT(1010),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1012),
  [3252] = {.count = 1, .reusable = false}, SHIFT(1013),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1014),
  [3256] = {.count = 1, .reusable = true}, SHIFT(1015),
  [3258] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [3260] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [3262] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [3264] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [3266] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [3268] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [3270] = {.count = 1, .reusable = true}, SHIFT(1016),
  [3272] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [3274] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [3276] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [3278] = {.count = 1, .reusable = true}, SHIFT(1017),
  [3280] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1018),
  [3283] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [3285] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [3287] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [3289] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [3291] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [3293] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [3295] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [3297] = {.count = 1, .reusable = true}, SHIFT(1019),
  [3299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(673),
  [3302] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4, .production_id = 94),
  [3304] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4, .production_id = 94),
  [3306] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4, .production_id = 95),
  [3308] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4, .production_id = 95),
  [3310] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4, .production_id = 96),
  [3312] = {.count = 1, .reusable = true}, SHIFT(1021),
  [3314] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 4, .production_id = 96),
  [3316] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 4, .production_id = 96),
  [3318] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4, .production_id = 96),
  [3320] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4, .production_id = 90),
  [3322] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4, .production_id = 90),
  [3324] = {.count = 1, .reusable = false}, SHIFT(1023),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1024),
  [3328] = {.count = 1, .reusable = true}, SHIFT(1025),
  [3330] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 97),
  [3332] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 97),
  [3334] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [3336] = {.count = 1, .reusable = true}, SHIFT(1026),
  [3338] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 98),
  [3340] = {.count = 1, .reusable = true}, SHIFT(1028),
  [3342] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4, .production_id = 99),
  [3344] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4, .production_id = 99),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1030),
  [3348] = {.count = 1, .reusable = true}, SHIFT(1031),
  [3350] = {.count = 1, .reusable = false}, SHIFT(1032),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1032),
  [3354] = {.count = 1, .reusable = true}, SHIFT(1033),
  [3356] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1, .production_id = 15),
  [3360] = {.count = 1, .reusable = true}, SHIFT(2194),
  [3362] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__parameter_name, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3366] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__parameter_name, 1), REDUCE(sym__primary_type, 1),
  [3370] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(794),
  [3373] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(820),
  [3376] = {.count = 1, .reusable = true}, SHIFT(1035),
  [3378] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 100),
  [3380] = {.count = 1, .reusable = true}, SHIFT(1036),
  [3382] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 4, .production_id = 100),
  [3384] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 4, .production_id = 100),
  [3386] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 100),
  [3388] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 101),
  [3390] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 101),
  [3392] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 102),
  [3394] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 102),
  [3396] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3398] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3400] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [3402] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 103),
  [3404] = {.count = 1, .reusable = true}, SHIFT(1048),
  [3406] = {.count = 1, .reusable = true}, SHIFT(1049),
  [3408] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [3410] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [3412] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2, .production_id = 51),
  [3414] = {.count = 1, .reusable = true}, SHIFT(1051),
  [3416] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 104),
  [3418] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 104),
  [3420] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 105),
  [3422] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 105),
  [3424] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 106),
  [3426] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 106),
  [3428] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 107),
  [3430] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 107),
  [3432] = {.count = 1, .reusable = true}, SHIFT(1054),
  [3434] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [3436] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [3438] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5, .production_id = 108),
  [3440] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5, .production_id = 108),
  [3442] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3, .production_id = 109),
  [3444] = {.count = 1, .reusable = true}, SHIFT(1056),
  [3446] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 76),
  [3448] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 76),
  [3450] = {.count = 1, .reusable = true}, SHIFT(1057),
  [3452] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(1058),
  [3455] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [3457] = {.count = 1, .reusable = true}, SHIFT(1059),
  [3459] = {.count = 1, .reusable = true}, SHIFT(1060),
  [3461] = {.count = 1, .reusable = false}, SHIFT(1061),
  [3463] = {.count = 1, .reusable = true}, SHIFT(1061),
  [3465] = {.count = 1, .reusable = false}, SHIFT(1063),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1063),
  [3469] = {.count = 1, .reusable = false}, SHIFT(1065),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1065),
  [3473] = {.count = 1, .reusable = false}, SHIFT(1066),
  [3475] = {.count = 1, .reusable = true}, SHIFT(1066),
  [3477] = {.count = 1, .reusable = false}, SHIFT(1068),
  [3479] = {.count = 1, .reusable = true}, SHIFT(1068),
  [3481] = {.count = 1, .reusable = false}, SHIFT(1069),
  [3483] = {.count = 1, .reusable = true}, SHIFT(1069),
  [3485] = {.count = 1, .reusable = false}, SHIFT(1071),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1071),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1073),
  [3491] = {.count = 1, .reusable = true}, SHIFT(1074),
  [3493] = {.count = 1, .reusable = true}, SHIFT(1075),
  [3495] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 44),
  [3497] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3499] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3501] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 26), REDUCE(sym_nested_type_identifier, 3, .production_id = 93),
  [3504] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 26),
  [3507] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 26), REDUCE(sym_nested_type_identifier, 3, .production_id = 93),
  [3510] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(669),
  [3513] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 72),
  [3515] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 72),
  [3517] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [3519] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [3521] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 103),
  [3523] = {.count = 1, .reusable = true}, SHIFT(1076),
  [3525] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 103),
  [3527] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 103),
  [3529] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 103),
  [3531] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 95),
  [3533] = {.count = 1, .reusable = true}, SHIFT(227),
  [3535] = {.count = 1, .reusable = true}, SHIFT(1082),
  [3537] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 110),
  [3539] = {.count = 1, .reusable = true}, SHIFT(1084),
  [3541] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 75),
  [3543] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3, .production_id = 95),
  [3545] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 111),
  [3547] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 112),
  [3549] = {.count = 1, .reusable = true}, SHIFT(1091),
  [3551] = {.count = 1, .reusable = true}, SHIFT(1093),
  [3553] = {.count = 1, .reusable = true}, SHIFT(1095),
  [3555] = {.count = 1, .reusable = false}, SHIFT(1094),
  [3557] = {.count = 1, .reusable = true}, SHIFT(1096),
  [3559] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3561] = {.count = 1, .reusable = false}, SHIFT(1097),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1098),
  [3565] = {.count = 1, .reusable = true}, SHIFT(1099),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1100),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1101),
  [3571] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3, .production_id = 113),
  [3573] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 114),
  [3575] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 115),
  [3577] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3, .production_id = 67),
  [3579] = {.count = 1, .reusable = false}, SHIFT(1739),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3585] = {.count = 1, .reusable = true}, SHIFT(1842),
  [3587] = {.count = 1, .reusable = false}, SHIFT(2507),
  [3589] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 96),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1114),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1116),
  [3595] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [3597] = {.count = 1, .reusable = false}, SHIFT(1117),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1118),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1119),
  [3603] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [3605] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [3607] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [3609] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [3611] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [3613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(738),
  [3616] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(736),
  [3619] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3, .production_id = 117),
  [3621] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5, .production_id = 118),
  [3623] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 119),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1121),
  [3627] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5, .production_id = 120),
  [3629] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5, .production_id = 120),
  [3631] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5, .production_id = 121),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1122),
  [3635] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 121),
  [3637] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 121),
  [3639] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5, .production_id = 121),
  [3641] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [3643] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 122),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1124),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1125),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1126),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1127),
  [3653] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [3655] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1128),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1130),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1132),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1134),
  [3665] = {.count = 1, .reusable = false}, SHIFT(1133),
  [3667] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 110),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1135),
  [3671] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 75),
  [3673] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 112),
  [3675] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [3677] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [3679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2, .production_id = 123), SHIFT_REPEAT(1139),
  [3682] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2, .production_id = 123),
  [3684] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3686] = {.count = 1, .reusable = false}, SHIFT(1140),
  [3688] = {.count = 1, .reusable = true}, SHIFT(1141),
  [3690] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3, .production_id = 115),
  [3692] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [3694] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [3696] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [3698] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [3700] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 12), REDUCE(aux_sym_object_repeat1, 2, .production_id = 47),
  [3703] = {.count = 1, .reusable = false}, SHIFT(2381),
  [3705] = {.count = 1, .reusable = false}, SHIFT(2567),
  [3707] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3709] = {.count = 1, .reusable = true}, SHIFT(2566),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1144),
  [3713] = {.count = 1, .reusable = false}, SHIFT(1415),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3717] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3719] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1908),
  [3723] = {.count = 1, .reusable = false}, SHIFT(1773),
  [3725] = {.count = 1, .reusable = false}, SHIFT(2175),
  [3727] = {.count = 1, .reusable = false}, SHIFT(2176),
  [3729] = {.count = 1, .reusable = false}, SHIFT(1402),
  [3731] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3733] = {.count = 1, .reusable = true}, SHIFT(2092),
  [3735] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3739] = {.count = 1, .reusable = false}, SHIFT(2045),
  [3741] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [3743] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [3745] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [3747] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [3749] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [3751] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [3753] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [3755] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [3757] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 5, .production_id = 96),
  [3759] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 5, .production_id = 96),
  [3761] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5, .production_id = 121),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3765] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 5, .production_id = 121),
  [3767] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 5, .production_id = 121),
  [3769] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5, .production_id = 121),
  [3771] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3774] = {.count = 1, .reusable = false}, SHIFT(1259),
  [3776] = {.count = 1, .reusable = false}, SHIFT(1147),
  [3778] = {.count = 1, .reusable = true}, SHIFT(1147),
  [3780] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 98),
  [3782] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 98),
  [3784] = {.count = 1, .reusable = true}, SHIFT(1148),
  [3786] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1149),
  [3789] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [3791] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [3793] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [3795] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5, .production_id = 124),
  [3797] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5, .production_id = 124),
  [3799] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3803] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(1005),
  [3806] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [3808] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5, .production_id = 126),
  [3810] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 100),
  [3812] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 100),
  [3814] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 127),
  [3816] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3818] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [3820] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 127),
  [3822] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 127),
  [3824] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 128),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3828] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [3830] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 5, .production_id = 128),
  [3832] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 128),
  [3834] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 129),
  [3836] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 129),
  [3838] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [3840] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [3842] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1156),
  [3846] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1157),
  [3849] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 130),
  [3851] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 130),
  [3853] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 131),
  [3855] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 131),
  [3857] = {.count = 1, .reusable = true}, SHIFT(1158),
  [3859] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4, .production_id = 132),
  [3861] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 76),
  [3863] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 133),
  [3865] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 133),
  [3867] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 134),
  [3869] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 134),
  [3871] = {.count = 1, .reusable = true}, SHIFT(1159),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1160),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1161),
  [3877] = {.count = 1, .reusable = true}, SHIFT(1162),
  [3879] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [3881] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 135),
  [3883] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 136),
  [3885] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 136),
  [3887] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3889] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 5, .production_id = 137),
  [3891] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 103),
  [3893] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 103),
  [3895] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 138),
  [3897] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3899] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type_clause, 3, .production_id = 15),
  [3901] = {.count = 1, .reusable = true}, SHIFT(1165),
  [3903] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [3905] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 120),
  [3907] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 110),
  [3909] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 139),
  [3911] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 140),
  [3913] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4, .production_id = 138),
  [3915] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 141),
  [3917] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 142),
  [3919] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 143),
  [3921] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4, .production_id = 120),
  [3923] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1174),
  [3927] = {.count = 1, .reusable = true}, SHIFT(1176),
  [3929] = {.count = 1, .reusable = false}, SHIFT(1175),
  [3931] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 144),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1177),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1178),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1181),
  [3939] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4, .production_id = 145),
  [3941] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 146),
  [3943] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 146),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3949] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 147),
  [3951] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5, .production_id = 121),
  [3953] = {.count = 1, .reusable = true}, SHIFT(1188),
  [3955] = {.count = 1, .reusable = true}, SHIFT(1190),
  [3957] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3, .production_id = 66),
  [3959] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3, .production_id = 66),
  [3961] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [3963] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [3965] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6, .production_id = 148),
  [3967] = {.count = 1, .reusable = false}, REDUCE(sym_function_declaration, 6, .production_id = 121),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_function_declaration, 6, .production_id = 121),
  [3971] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 6, .production_id = 149),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1192),
  [3975] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 149),
  [3977] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 149),
  [3979] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 6, .production_id = 149),
  [3981] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [3983] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [3985] = {.count = 1, .reusable = true}, SHIFT(1196),
  [3987] = {.count = 1, .reusable = true}, SHIFT(1198),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1200),
  [3991] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 110),
  [3993] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 140),
  [3995] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 142),
  [3997] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1203),
  [4001] = {.count = 1, .reusable = false}, SHIFT(1202),
  [4003] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4, .production_id = 144),
  [4005] = {.count = 1, .reusable = true}, SHIFT(1204),
  [4007] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [4009] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [4011] = {.count = 1, .reusable = true}, SHIFT(1206),
  [4013] = {.count = 1, .reusable = false}, SHIFT(2382),
  [4015] = {.count = 1, .reusable = false}, SHIFT(2571),
  [4017] = {.count = 1, .reusable = true}, SHIFT(1207),
  [4019] = {.count = 1, .reusable = true}, SHIFT(2570),
  [4021] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 6, .production_id = 121),
  [4023] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 6, .production_id = 121),
  [4025] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 98),
  [4027] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 26),
  [4030] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [4032] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 127),
  [4034] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [4036] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 128),
  [4038] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 150),
  [4040] = {.count = 1, .reusable = true}, SHIFT(1208),
  [4042] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [4044] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 6, .production_id = 150),
  [4046] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 150),
  [4048] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [4050] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [4052] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [4054] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 151),
  [4056] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 151),
  [4058] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 152),
  [4060] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 152),
  [4062] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 153),
  [4064] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 153),
  [4066] = {.count = 1, .reusable = false}, REDUCE(sym__for_header, 6, .production_id = 154),
  [4068] = {.count = 1, .reusable = true}, REDUCE(sym__for_header, 6, .production_id = 154),
  [4070] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 155),
  [4072] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 155),
  [4074] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 156),
  [4076] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 157),
  [4078] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 158),
  [4080] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 159),
  [4082] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 160),
  [4084] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 156),
  [4086] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5, .production_id = 161),
  [4088] = {.count = 1, .reusable = true}, SHIFT(1213),
  [4090] = {.count = 1, .reusable = true}, SHIFT(1215),
  [4092] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 144),
  [4094] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 162),
  [4096] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5, .production_id = 163),
  [4098] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5, .production_id = 161),
  [4100] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4102] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6, .production_id = 149),
  [4104] = {.count = 1, .reusable = true}, SHIFT(1223),
  [4106] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4, .production_id = 66),
  [4108] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4, .production_id = 66),
  [4110] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function_declaration, 7, .production_id = 149),
  [4112] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function_declaration, 7, .production_id = 149),
  [4114] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [4116] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 165),
  [4118] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [4120] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 166),
  [4122] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5, .production_id = 167),
  [4124] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5, .production_id = 167),
  [4126] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6, .production_id = 168),
  [4128] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6, .production_id = 168),
  [4130] = {.count = 1, .reusable = true}, SHIFT(1226),
  [4132] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 158),
  [4134] = {.count = 1, .reusable = true}, SHIFT(1228),
  [4136] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 144),
  [4138] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5, .production_id = 163),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1230),
  [4142] = {.count = 1, .reusable = false}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [4144] = {.count = 1, .reusable = true}, REDUCE(sym_class_declaration, 7, .production_id = 150),
  [4146] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [4148] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 4),
  [4150] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 169),
  [4152] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 170),
  [4154] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6, .production_id = 171),
  [4156] = {.count = 1, .reusable = true}, SHIFT(1232),
  [4158] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 172),
  [4160] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 173),
  [4162] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6, .production_id = 174),
  [4164] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6, .production_id = 170),
  [4166] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4168] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1239),
  [4172] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6, .production_id = 173),
  [4174] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 177),
  [4176] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7, .production_id = 178),
  [4178] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7, .production_id = 179),
  [4180] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 180),
  [4182] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8, .production_id = 181),
  [4184] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8, .production_id = 182),
  [4186] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9, .production_id = 183),
  [4188] = {.count = 1, .reusable = false}, SHIFT(1273),
  [4190] = {.count = 1, .reusable = true}, SHIFT(1273),
  [4192] = {.count = 1, .reusable = false}, SHIFT(1274),
  [4194] = {.count = 1, .reusable = false}, SHIFT(1275),
  [4196] = {.count = 1, .reusable = true}, SHIFT(1275),
  [4198] = {.count = 1, .reusable = false}, SHIFT(1280),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1280),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1321),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1321),
  [4206] = {.count = 1, .reusable = false}, SHIFT(1332),
  [4208] = {.count = 1, .reusable = false}, SHIFT(1333),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1333),
  [4212] = {.count = 1, .reusable = false}, SHIFT(1338),
  [4214] = {.count = 1, .reusable = false}, SHIFT(1341),
  [4216] = {.count = 1, .reusable = true}, SHIFT(2138),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1341),
  [4220] = {.count = 1, .reusable = false}, SHIFT(1342),
  [4222] = {.count = 1, .reusable = true}, SHIFT(1342),
  [4224] = {.count = 1, .reusable = false}, SHIFT(1343),
  [4226] = {.count = 1, .reusable = true}, SHIFT(1343),
  [4228] = {.count = 1, .reusable = false}, SHIFT(1347),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1347),
  [4232] = {.count = 1, .reusable = false}, SHIFT(1348),
  [4234] = {.count = 1, .reusable = true}, SHIFT(1348),
  [4236] = {.count = 1, .reusable = false}, SHIFT(1349),
  [4238] = {.count = 1, .reusable = true}, SHIFT(1349),
  [4240] = {.count = 1, .reusable = false}, SHIFT(1263),
  [4242] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(1329),
  [4245] = {.count = 1, .reusable = false}, SHIFT(1361),
  [4247] = {.count = 1, .reusable = true}, SHIFT(1361),
  [4249] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4251] = {.count = 1, .reusable = true}, SHIFT(2400),
  [4253] = {.count = 1, .reusable = true}, SHIFT(1284),
  [4255] = {.count = 1, .reusable = true}, SHIFT(1815),
  [4257] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4259] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4261] = {.count = 1, .reusable = true}, SHIFT(1295),
  [4263] = {.count = 1, .reusable = true}, SHIFT(2294),
  [4265] = {.count = 1, .reusable = false}, SHIFT(1394),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4269] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2240),
  [4272] = {.count = 1, .reusable = false}, SHIFT(1417),
  [4274] = {.count = 1, .reusable = true}, SHIFT(1417),
  [4276] = {.count = 1, .reusable = false}, SHIFT(1418),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1418),
  [4280] = {.count = 1, .reusable = false}, SHIFT(1419),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1419),
  [4284] = {.count = 1, .reusable = false}, SHIFT(1420),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1420),
  [4288] = {.count = 1, .reusable = false}, SHIFT(1421),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1421),
  [4292] = {.count = 1, .reusable = false}, SHIFT(1423),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1423),
  [4296] = {.count = 1, .reusable = false}, SHIFT(1426),
  [4298] = {.count = 1, .reusable = false}, SHIFT(1428),
  [4300] = {.count = 1, .reusable = false}, SHIFT(1430),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1431),
  [4304] = {.count = 1, .reusable = false}, SHIFT(1432),
  [4306] = {.count = 1, .reusable = false}, SHIFT(1427),
  [4308] = {.count = 1, .reusable = false}, SHIFT(1429),
  [4310] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4312] = {.count = 1, .reusable = true}, SHIFT(1427),
  [4314] = {.count = 1, .reusable = false}, SHIFT(1435),
  [4316] = {.count = 1, .reusable = true}, SHIFT(1435),
  [4318] = {.count = 1, .reusable = false}, SHIFT(1436),
  [4320] = {.count = 1, .reusable = true}, SHIFT(1436),
  [4322] = {.count = 1, .reusable = false}, SHIFT(1438),
  [4324] = {.count = 1, .reusable = true}, SHIFT(1438),
  [4326] = {.count = 1, .reusable = false}, SHIFT(1441),
  [4328] = {.count = 1, .reusable = true}, SHIFT(1441),
  [4330] = {.count = 1, .reusable = true}, SHIFT(2302),
  [4332] = {.count = 1, .reusable = false}, SHIFT(1444),
  [4334] = {.count = 1, .reusable = true}, SHIFT(1444),
  [4336] = {.count = 1, .reusable = true}, SHIFT(1904),
  [4338] = {.count = 1, .reusable = true}, SHIFT(1392),
  [4340] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(2240),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1465),
  [4345] = {.count = 1, .reusable = false}, SHIFT(1469),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1469),
  [4349] = {.count = 1, .reusable = false}, SHIFT(1471),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1471),
  [4353] = {.count = 1, .reusable = false}, SHIFT(1474),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1474),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1604),
  [4359] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4361] = {.count = 1, .reusable = true}, SHIFT(2403),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4365] = {.count = 1, .reusable = true}, SHIFT(1777),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1611),
  [4369] = {.count = 1, .reusable = false}, SHIFT(1490),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1495),
  [4373] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(1329),
  [4376] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4378] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4380] = {.count = 1, .reusable = false}, SHIFT(1270),
  [4382] = {.count = 1, .reusable = true}, SHIFT(1499),
  [4384] = {.count = 1, .reusable = false}, SHIFT(1309),
  [4386] = {.count = 1, .reusable = false}, SHIFT(1311),
  [4388] = {.count = 1, .reusable = false}, SHIFT(1312),
  [4390] = {.count = 1, .reusable = false}, SHIFT(1310),
  [4392] = {.count = 1, .reusable = false}, SHIFT(1853),
  [4394] = {.count = 1, .reusable = false}, SHIFT(1314),
  [4396] = {.count = 1, .reusable = false}, SHIFT(1313),
  [4398] = {.count = 1, .reusable = true}, SHIFT(1310),
  [4400] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(1618),
  [4403] = {.count = 1, .reusable = false}, SHIFT(1622),
  [4405] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3, .production_id = 83),
  [4407] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 93),
  [4410] = {.count = 1, .reusable = false}, SHIFT(1408),
  [4412] = {.count = 1, .reusable = false}, SHIFT(1407),
  [4414] = {.count = 1, .reusable = false}, SHIFT(1542),
  [4416] = {.count = 1, .reusable = true}, SHIFT(1542),
  [4418] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4420] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 1, .production_id = 2), SHIFT(1640),
  [4423] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(1648),
  [4426] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 96),
  [4428] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4, .production_id = 116),
  [4430] = {.count = 2, .reusable = true}, REDUCE(sym__call_signature, 2, .production_id = 20), SHIFT(1658),
  [4433] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 147),
  [4435] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5, .production_id = 121),
  [4437] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 164),
  [4439] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6, .production_id = 149),
  [4441] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 175),
  [4443] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7, .production_id = 176),
  [4445] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 180),
  [4447] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8, .production_id = 181),
  [4449] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9, .production_id = 183),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1382),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2402),
  [4455] = {.count = 1, .reusable = false}, SHIFT(1610),
  [4457] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4459] = {.count = 1, .reusable = true}, SHIFT(2391),
  [4461] = {.count = 1, .reusable = true}, SHIFT(2341),
  [4463] = {.count = 1, .reusable = true}, SHIFT(1608),
  [4465] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1634),
  [4469] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4471] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4473] = {.count = 1, .reusable = false}, SHIFT(2354),
  [4475] = {.count = 1, .reusable = false}, SHIFT(2355),
  [4477] = {.count = 1, .reusable = false}, SHIFT(1598),
  [4479] = {.count = 1, .reusable = false}, SHIFT(2357),
  [4481] = {.count = 1, .reusable = false}, SHIFT(2358),
  [4483] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4485] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4487] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4489] = {.count = 1, .reusable = true}, SHIFT(1684),
  [4491] = {.count = 1, .reusable = false}, SHIFT(1680),
  [4493] = {.count = 1, .reusable = false}, SHIFT(1672),
  [4495] = {.count = 1, .reusable = true}, SHIFT(2460),
  [4497] = {.count = 1, .reusable = false}, SHIFT(1675),
  [4499] = {.count = 1, .reusable = false}, SHIFT(2146),
  [4501] = {.count = 1, .reusable = false}, SHIFT(2148),
  [4503] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1676),
  [4507] = {.count = 1, .reusable = false}, SHIFT(2145),
  [4509] = {.count = 1, .reusable = true}, SHIFT(2466),
  [4511] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4513] = {.count = 1, .reusable = true}, SHIFT(1673),
  [4515] = {.count = 1, .reusable = false}, SHIFT(1689),
  [4517] = {.count = 1, .reusable = true}, SHIFT(1672),
  [4519] = {.count = 1, .reusable = true}, SHIFT(1677),
  [4521] = {.count = 1, .reusable = true}, SHIFT(2462),
  [4523] = {.count = 1, .reusable = true}, SHIFT(1674),
  [4525] = {.count = 1, .reusable = false}, SHIFT(1678),
  [4527] = {.count = 1, .reusable = false}, SHIFT(2461),
  [4529] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4531] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2459),
  [4534] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4536] = {.count = 1, .reusable = true}, SHIFT(1687),
  [4538] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(2459),
  [4541] = {.count = 1, .reusable = true}, SHIFT(1755),
  [4543] = {.count = 1, .reusable = true}, SHIFT(2190),
  [4545] = {.count = 1, .reusable = false}, SHIFT(1701),
  [4547] = {.count = 1, .reusable = false}, SHIFT(1700),
  [4549] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4551] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(102),
  [4554] = {.count = 1, .reusable = false}, SHIFT(1744),
  [4556] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 15), SHIFT(102),
  [4559] = {.count = 1, .reusable = true}, SHIFT(1742),
  [4561] = {.count = 1, .reusable = true}, SHIFT(2222),
  [4563] = {.count = 1, .reusable = false}, SHIFT(2223),
  [4565] = {.count = 1, .reusable = true}, SHIFT(2221),
  [4567] = {.count = 1, .reusable = true}, SHIFT(2197),
  [4569] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4571] = {.count = 1, .reusable = false}, SHIFT(2226),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2224),
  [4575] = {.count = 1, .reusable = false}, SHIFT(2237),
  [4577] = {.count = 1, .reusable = false}, SHIFT(2517),
  [4579] = {.count = 1, .reusable = true}, SHIFT(2237),
  [4581] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4583] = {.count = 1, .reusable = true}, SHIFT(1769),
  [4585] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(2391),
  [4588] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1260),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1796),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1270),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4598] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4602] = {.count = 1, .reusable = false}, SHIFT(1279),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4606] = {.count = 1, .reusable = true}, SHIFT(1288),
  [4608] = {.count = 1, .reusable = false}, SHIFT(1840),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4612] = {.count = 1, .reusable = true}, SHIFT(1334),
  [4614] = {.count = 1, .reusable = true}, SHIFT(1344),
  [4616] = {.count = 1, .reusable = true}, SHIFT(1345),
  [4618] = {.count = 1, .reusable = true}, SHIFT(1350),
  [4620] = {.count = 1, .reusable = false}, SHIFT(1866),
  [4622] = {.count = 1, .reusable = true}, SHIFT(1812),
  [4624] = {.count = 1, .reusable = false}, SHIFT(1867),
  [4626] = {.count = 1, .reusable = false}, SHIFT(1868),
  [4628] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4630] = {.count = 1, .reusable = false}, SHIFT(1871),
  [4632] = {.count = 1, .reusable = true}, SHIFT(1353),
  [4634] = {.count = 1, .reusable = false}, SHIFT(1870),
  [4636] = {.count = 1, .reusable = true}, SHIFT(1355),
  [4638] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4640] = {.count = 1, .reusable = true}, SHIFT(1357),
  [4642] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4644] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4646] = {.count = 1, .reusable = false}, SHIFT(1363),
  [4648] = {.count = 1, .reusable = true}, SHIFT(1372),
  [4650] = {.count = 1, .reusable = true}, SHIFT(1375),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2196),
  [4654] = {.count = 1, .reusable = true}, SHIFT(1379),
  [4656] = {.count = 1, .reusable = true}, SHIFT(1383),
  [4658] = {.count = 1, .reusable = true}, SHIFT(1384),
  [4660] = {.count = 1, .reusable = true}, SHIFT(1385),
  [4662] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4664] = {.count = 1, .reusable = true}, SHIFT(1386),
  [4666] = {.count = 1, .reusable = true}, SHIFT(1387),
  [4668] = {.count = 1, .reusable = true}, SHIFT(1388),
  [4670] = {.count = 1, .reusable = true}, SHIFT(1389),
  [4672] = {.count = 1, .reusable = true}, SHIFT(1390),
  [4674] = {.count = 1, .reusable = true}, SHIFT(1391),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2295),
  [4678] = {.count = 1, .reusable = true}, SHIFT(1395),
  [4680] = {.count = 1, .reusable = true}, SHIFT(1397),
  [4682] = {.count = 1, .reusable = true}, SHIFT(1398),
  [4684] = {.count = 1, .reusable = true}, SHIFT(1399),
  [4686] = {.count = 1, .reusable = true}, SHIFT(1404),
  [4688] = {.count = 1, .reusable = true}, SHIFT(1406),
  [4690] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4692] = {.count = 1, .reusable = false}, SHIFT(1409),
  [4694] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4696] = {.count = 1, .reusable = true}, SHIFT(1412),
  [4698] = {.count = 1, .reusable = true}, SHIFT(1416),
  [4700] = {.count = 1, .reusable = false}, SHIFT(1748),
  [4702] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4704] = {.count = 1, .reusable = false}, SHIFT(1750),
  [4706] = {.count = 1, .reusable = false}, SHIFT(2299),
  [4708] = {.count = 1, .reusable = false}, SHIFT(2300),
  [4710] = {.count = 1, .reusable = false}, SHIFT(1751),
  [4712] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4714] = {.count = 1, .reusable = false}, SHIFT(1752),
  [4716] = {.count = 1, .reusable = true}, SHIFT(1772),
  [4718] = {.count = 1, .reusable = false}, SHIFT(2301),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2264),
  [4722] = {.count = 1, .reusable = true}, SHIFT(2250),
  [4724] = {.count = 1, .reusable = true}, SHIFT(2251),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2624),
  [4728] = {.count = 1, .reusable = true}, SHIFT(2621),
  [4730] = {.count = 1, .reusable = true}, SHIFT(1816),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2633),
  [4734] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4736] = {.count = 1, .reusable = true}, SHIFT(1446),
  [4738] = {.count = 1, .reusable = true}, SHIFT(1447),
  [4740] = {.count = 1, .reusable = true}, SHIFT(1448),
  [4742] = {.count = 1, .reusable = true}, SHIFT(1451),
  [4744] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4746] = {.count = 1, .reusable = true}, SHIFT(1453),
  [4748] = {.count = 1, .reusable = true}, SHIFT(1454),
  [4750] = {.count = 1, .reusable = true}, SHIFT(1458),
  [4752] = {.count = 1, .reusable = true}, SHIFT(1461),
  [4754] = {.count = 1, .reusable = true}, SHIFT(1462),
  [4756] = {.count = 1, .reusable = true}, SHIFT(1463),
  [4758] = {.count = 1, .reusable = true}, SHIFT(1776),
  [4760] = {.count = 1, .reusable = true}, SHIFT(1466),
  [4762] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4764] = {.count = 1, .reusable = true}, SHIFT(1467),
  [4766] = {.count = 1, .reusable = true}, SHIFT(1475),
  [4768] = {.count = 1, .reusable = true}, SHIFT(1476),
  [4770] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4772] = {.count = 1, .reusable = true}, SHIFT(1479),
  [4774] = {.count = 1, .reusable = true}, SHIFT(1480),
  [4776] = {.count = 1, .reusable = true}, SHIFT(1481),
  [4778] = {.count = 1, .reusable = false}, SHIFT(2034),
  [4780] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4782] = {.count = 1, .reusable = false}, SHIFT(1970),
  [4784] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4786] = {.count = 1, .reusable = true}, SHIFT(1482),
  [4788] = {.count = 1, .reusable = false}, SHIFT(1971),
  [4790] = {.count = 1, .reusable = false}, SHIFT(1973),
  [4792] = {.count = 1, .reusable = true}, SHIFT(1483),
  [4794] = {.count = 1, .reusable = true}, SHIFT(1485),
  [4796] = {.count = 1, .reusable = true}, SHIFT(1488),
  [4798] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4800] = {.count = 1, .reusable = true}, SHIFT(1489),
  [4802] = {.count = 1, .reusable = true}, SHIFT(1496),
  [4804] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(1858),
  [4807] = {.count = 1, .reusable = true}, SHIFT(1497),
  [4809] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4811] = {.count = 1, .reusable = true}, SHIFT(1509),
  [4813] = {.count = 1, .reusable = true}, SHIFT(1511),
  [4815] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4817] = {.count = 1, .reusable = true}, SHIFT(1514),
  [4819] = {.count = 1, .reusable = true}, SHIFT(1515),
  [4821] = {.count = 1, .reusable = true}, SHIFT(1516),
  [4823] = {.count = 1, .reusable = true}, SHIFT(1518),
  [4825] = {.count = 1, .reusable = true}, SHIFT(1520),
  [4827] = {.count = 1, .reusable = true}, SHIFT(1491),
  [4829] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4831] = {.count = 1, .reusable = true}, SHIFT(1526),
  [4833] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4835] = {.count = 1, .reusable = true}, SHIFT(2003),
  [4837] = {.count = 1, .reusable = true}, SHIFT(1530),
  [4839] = {.count = 1, .reusable = true}, SHIFT(1532),
  [4841] = {.count = 1, .reusable = true}, SHIFT(1534),
  [4843] = {.count = 1, .reusable = true}, SHIFT(1535),
  [4845] = {.count = 1, .reusable = true}, SHIFT(1536),
  [4847] = {.count = 1, .reusable = true}, SHIFT(1540),
  [4849] = {.count = 1, .reusable = true}, SHIFT(1541),
  [4851] = {.count = 1, .reusable = true}, SHIFT(1544),
  [4853] = {.count = 1, .reusable = true}, SHIFT(1553),
  [4855] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4857] = {.count = 1, .reusable = true}, SHIFT(1555),
  [4859] = {.count = 1, .reusable = true}, SHIFT(1527),
  [4861] = {.count = 1, .reusable = true}, SHIFT(1538),
  [4863] = {.count = 1, .reusable = true}, SHIFT(1563),
  [4865] = {.count = 1, .reusable = true}, SHIFT(1566),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4869] = {.count = 1, .reusable = true}, SHIFT(1570),
  [4871] = {.count = 1, .reusable = true}, SHIFT(1574),
  [4873] = {.count = 1, .reusable = true}, SHIFT(1564),
  [4875] = {.count = 1, .reusable = true}, SHIFT(1569),
  [4877] = {.count = 1, .reusable = true}, SHIFT(1579),
  [4879] = {.count = 1, .reusable = true}, SHIFT(1578),
  [4881] = {.count = 1, .reusable = false}, SHIFT(1702),
  [4883] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4885] = {.count = 1, .reusable = false}, SHIFT(2375),
  [4887] = {.count = 1, .reusable = false}, SHIFT(1705),
  [4889] = {.count = 1, .reusable = false}, SHIFT(1706),
  [4891] = {.count = 1, .reusable = false}, SHIFT(1703),
  [4893] = {.count = 1, .reusable = false}, SHIFT(2374),
  [4895] = {.count = 1, .reusable = false}, SHIFT(2038),
  [4897] = {.count = 1, .reusable = true}, SHIFT(1703),
  [4899] = {.count = 1, .reusable = false}, SHIFT(2377),
  [4901] = {.count = 1, .reusable = true}, SHIFT(1709),
  [4903] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(2027),
  [4906] = {.count = 1, .reusable = false}, SHIFT(1650),
  [4908] = {.count = 1, .reusable = true}, SHIFT(1651),
  [4910] = {.count = 1, .reusable = false}, SHIFT(2059),
  [4912] = {.count = 1, .reusable = true}, SHIFT(2059),
  [4914] = {.count = 1, .reusable = false}, SHIFT(1588),
  [4916] = {.count = 1, .reusable = true}, SHIFT(1589),
  [4918] = {.count = 1, .reusable = false}, SHIFT(2064),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4922] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4924] = {.count = 1, .reusable = true}, SHIFT(1600),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4928] = {.count = 1, .reusable = false}, SHIFT(1602),
  [4930] = {.count = 1, .reusable = true}, SHIFT(1603),
  [4932] = {.count = 1, .reusable = true}, SHIFT(1605),
  [4934] = {.count = 1, .reusable = true}, SHIFT(1606),
  [4936] = {.count = 1, .reusable = true}, SHIFT(1607),
  [4938] = {.count = 1, .reusable = true}, SHIFT(1613),
  [4940] = {.count = 1, .reusable = true}, SHIFT(1614),
  [4942] = {.count = 1, .reusable = true}, SHIFT(1615),
  [4944] = {.count = 1, .reusable = true}, SHIFT(1618),
  [4946] = {.count = 1, .reusable = true}, SHIFT(1620),
  [4948] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4950] = {.count = 1, .reusable = false}, SHIFT(1623),
  [4952] = {.count = 1, .reusable = true}, SHIFT(1630),
  [4954] = {.count = 1, .reusable = true}, SHIFT(1631),
  [4956] = {.count = 1, .reusable = true}, SHIFT(1632),
  [4958] = {.count = 1, .reusable = true}, SHIFT(1633),
  [4960] = {.count = 1, .reusable = true}, SHIFT(1635),
  [4962] = {.count = 1, .reusable = true}, SHIFT(1636),
  [4964] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4966] = {.count = 1, .reusable = true}, SHIFT(1638),
  [4968] = {.count = 1, .reusable = true}, SHIFT(1639),
  [4970] = {.count = 1, .reusable = true}, SHIFT(1640),
  [4972] = {.count = 1, .reusable = true}, SHIFT(1641),
  [4974] = {.count = 1, .reusable = true}, SHIFT(1642),
  [4976] = {.count = 1, .reusable = true}, SHIFT(1644),
  [4978] = {.count = 1, .reusable = true}, SHIFT(1647),
  [4980] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4982] = {.count = 1, .reusable = true}, SHIFT(1648),
  [4984] = {.count = 1, .reusable = true}, SHIFT(1652),
  [4986] = {.count = 1, .reusable = true}, SHIFT(1653),
  [4988] = {.count = 1, .reusable = true}, SHIFT(1654),
  [4990] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4992] = {.count = 1, .reusable = true}, SHIFT(1655),
  [4994] = {.count = 1, .reusable = true}, SHIFT(1656),
  [4996] = {.count = 1, .reusable = true}, SHIFT(1658),
  [4998] = {.count = 1, .reusable = true}, SHIFT(1659),
  [5000] = {.count = 1, .reusable = true}, SHIFT(1660),
  [5002] = {.count = 1, .reusable = true}, SHIFT(1663),
  [5004] = {.count = 1, .reusable = true}, SHIFT(2113),
  [5006] = {.count = 1, .reusable = true}, SHIFT(1665),
  [5008] = {.count = 1, .reusable = true}, SHIFT(1666),
  [5010] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5012] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5014] = {.count = 1, .reusable = false}, SHIFT(2448),
  [5016] = {.count = 1, .reusable = false}, SHIFT(2449),
  [5018] = {.count = 1, .reusable = false}, SHIFT(2376),
  [5020] = {.count = 1, .reusable = false}, SHIFT(2122),
  [5022] = {.count = 1, .reusable = false}, SHIFT(1629),
  [5024] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(2114),
  [5027] = {.count = 1, .reusable = false}, SHIFT(1723),
  [5029] = {.count = 1, .reusable = true}, SHIFT(1724),
  [5031] = {.count = 1, .reusable = false}, SHIFT(2140),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5035] = {.count = 1, .reusable = false}, SHIFT(1670),
  [5037] = {.count = 1, .reusable = false}, SHIFT(1817),
  [5039] = {.count = 1, .reusable = false}, SHIFT(1818),
  [5041] = {.count = 1, .reusable = false}, SHIFT(1819),
  [5043] = {.count = 1, .reusable = false}, SHIFT(1820),
  [5045] = {.count = 1, .reusable = false}, SHIFT(1821),
  [5047] = {.count = 1, .reusable = false}, SHIFT(1822),
  [5049] = {.count = 1, .reusable = true}, SHIFT(1671),
  [5051] = {.count = 1, .reusable = false}, SHIFT(1823),
  [5053] = {.count = 1, .reusable = false}, SHIFT(1824),
  [5055] = {.count = 1, .reusable = false}, SHIFT(1825),
  [5057] = {.count = 1, .reusable = false}, SHIFT(1826),
  [5059] = {.count = 1, .reusable = false}, SHIFT(1827),
  [5061] = {.count = 1, .reusable = false}, SHIFT(1828),
  [5063] = {.count = 1, .reusable = false}, SHIFT(2143),
  [5065] = {.count = 1, .reusable = true}, SHIFT(2143),
  [5067] = {.count = 1, .reusable = false}, SHIFT(1682),
  [5069] = {.count = 1, .reusable = true}, SHIFT(1683),
  [5071] = {.count = 1, .reusable = true}, SHIFT(2037),
  [5073] = {.count = 1, .reusable = true}, SHIFT(1686),
  [5075] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5077] = {.count = 1, .reusable = true}, SHIFT(1690),
  [5079] = {.count = 1, .reusable = true}, SHIFT(1692),
  [5081] = {.count = 1, .reusable = true}, SHIFT(1693),
  [5083] = {.count = 1, .reusable = true}, SHIFT(1694),
  [5085] = {.count = 1, .reusable = true}, SHIFT(1697),
  [5087] = {.count = 1, .reusable = true}, SHIFT(1699),
  [5089] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5091] = {.count = 1, .reusable = true}, SHIFT(1707),
  [5093] = {.count = 1, .reusable = true}, SHIFT(1708),
  [5095] = {.count = 1, .reusable = true}, SHIFT(1710),
  [5097] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5099] = {.count = 1, .reusable = true}, SHIFT(1712),
  [5101] = {.count = 1, .reusable = true}, SHIFT(1713),
  [5103] = {.count = 1, .reusable = true}, SHIFT(1714),
  [5105] = {.count = 1, .reusable = true}, SHIFT(1715),
  [5107] = {.count = 1, .reusable = true}, SHIFT(1716),
  [5109] = {.count = 1, .reusable = true}, SHIFT(1718),
  [5111] = {.count = 1, .reusable = true}, SHIFT(1721),
  [5113] = {.count = 1, .reusable = true}, SHIFT(2170),
  [5115] = {.count = 1, .reusable = true}, SHIFT(1722),
  [5117] = {.count = 1, .reusable = true}, SHIFT(1725),
  [5119] = {.count = 1, .reusable = true}, SHIFT(2171),
  [5121] = {.count = 1, .reusable = true}, SHIFT(1726),
  [5123] = {.count = 1, .reusable = true}, SHIFT(1727),
  [5125] = {.count = 1, .reusable = true}, SHIFT(1729),
  [5127] = {.count = 1, .reusable = true}, SHIFT(1730),
  [5129] = {.count = 1, .reusable = true}, SHIFT(1731),
  [5131] = {.count = 1, .reusable = true}, SHIFT(1733),
  [5133] = {.count = 1, .reusable = true}, SHIFT(2174),
  [5135] = {.count = 1, .reusable = true}, SHIFT(1735),
  [5137] = {.count = 1, .reusable = true}, SHIFT(1736),
  [5139] = {.count = 1, .reusable = false}, SHIFT(1761),
  [5141] = {.count = 1, .reusable = true}, SHIFT(1762),
  [5143] = {.count = 1, .reusable = false}, SHIFT(2179),
  [5145] = {.count = 1, .reusable = true}, SHIFT(2179),
  [5147] = {.count = 1, .reusable = false}, SHIFT(1737),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2182),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2182),
  [5153] = {.count = 1, .reusable = false}, SHIFT(1740),
  [5155] = {.count = 1, .reusable = true}, SHIFT(1741),
  [5157] = {.count = 1, .reusable = true}, SHIFT(1685),
  [5159] = {.count = 1, .reusable = true}, SHIFT(1743),
  [5161] = {.count = 1, .reusable = true}, SHIFT(1745),
  [5163] = {.count = 1, .reusable = true}, SHIFT(1753),
  [5165] = {.count = 1, .reusable = true}, SHIFT(1754),
  [5167] = {.count = 1, .reusable = true}, SHIFT(1757),
  [5169] = {.count = 1, .reusable = true}, SHIFT(1758),
  [5171] = {.count = 1, .reusable = true}, SHIFT(1760),
  [5173] = {.count = 1, .reusable = true}, SHIFT(1763),
  [5175] = {.count = 1, .reusable = true}, SHIFT(1765),
  [5177] = {.count = 1, .reusable = true}, SHIFT(1768),
  [5179] = {.count = 1, .reusable = true}, SHIFT(1770),
  [5181] = {.count = 1, .reusable = true}, SHIFT(1778),
  [5183] = {.count = 1, .reusable = true}, SHIFT(1779),
  [5185] = {.count = 1, .reusable = true}, SHIFT(1781),
  [5187] = {.count = 1, .reusable = true}, SHIFT(1782),
  [5189] = {.count = 1, .reusable = true}, SHIFT(1783),
  [5191] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5193] = {.count = 1, .reusable = true}, SHIFT(1803),
  [5195] = {.count = 1, .reusable = true}, SHIFT(1804),
  [5197] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5201] = {.count = 1, .reusable = false}, SHIFT(1811),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2249),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2063),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2535),
  [5209] = {.count = 1, .reusable = false}, SHIFT(1851),
  [5211] = {.count = 1, .reusable = true}, SHIFT(1859),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5215] = {.count = 1, .reusable = false}, SHIFT(1860),
  [5217] = {.count = 1, .reusable = true}, SHIFT(1860),
  [5219] = {.count = 1, .reusable = false}, SHIFT(1861),
  [5221] = {.count = 1, .reusable = true}, SHIFT(1861),
  [5223] = {.count = 1, .reusable = false}, SHIFT(1862),
  [5225] = {.count = 1, .reusable = true}, SHIFT(1862),
  [5227] = {.count = 1, .reusable = false}, SHIFT(1863),
  [5229] = {.count = 1, .reusable = true}, SHIFT(1863),
  [5231] = {.count = 1, .reusable = false}, SHIFT(1864),
  [5233] = {.count = 1, .reusable = true}, SHIFT(1864),
  [5235] = {.count = 1, .reusable = false}, SHIFT(1865),
  [5237] = {.count = 1, .reusable = true}, SHIFT(1865),
  [5239] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2, .production_id = 4),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2058),
  [5243] = {.count = 1, .reusable = false}, SHIFT(308),
  [5245] = {.count = 1, .reusable = false}, SHIFT(310),
  [5247] = {.count = 1, .reusable = false}, SHIFT(2533),
  [5249] = {.count = 1, .reusable = false}, SHIFT(2534),
  [5251] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5253] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5255] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(1858),
  [5258] = {.count = 1, .reusable = true}, SHIFT(1872),
  [5260] = {.count = 1, .reusable = true}, SHIFT(1873),
  [5262] = {.count = 1, .reusable = false}, SHIFT(1876),
  [5264] = {.count = 1, .reusable = true}, SHIFT(1876),
  [5266] = {.count = 1, .reusable = false}, SHIFT(1883),
  [5268] = {.count = 1, .reusable = true}, SHIFT(1883),
  [5270] = {.count = 1, .reusable = true}, SHIFT(1884),
  [5272] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5274] = {.count = 1, .reusable = true}, SHIFT(1892),
  [5276] = {.count = 1, .reusable = true}, SHIFT(1896),
  [5278] = {.count = 1, .reusable = false}, SHIFT(1918),
  [5280] = {.count = 1, .reusable = true}, SHIFT(1918),
  [5282] = {.count = 1, .reusable = true}, SHIFT(1919),
  [5284] = {.count = 1, .reusable = false}, SHIFT(1920),
  [5286] = {.count = 1, .reusable = true}, SHIFT(1920),
  [5288] = {.count = 1, .reusable = false}, SHIFT(1921),
  [5290] = {.count = 1, .reusable = true}, SHIFT(1921),
  [5292] = {.count = 1, .reusable = false}, SHIFT(1922),
  [5294] = {.count = 1, .reusable = true}, SHIFT(1922),
  [5296] = {.count = 1, .reusable = false}, SHIFT(1923),
  [5298] = {.count = 1, .reusable = true}, SHIFT(1923),
  [5300] = {.count = 1, .reusable = false}, SHIFT(1924),
  [5302] = {.count = 1, .reusable = true}, SHIFT(1924),
  [5304] = {.count = 1, .reusable = false}, SHIFT(1927),
  [5306] = {.count = 1, .reusable = true}, SHIFT(1927),
  [5308] = {.count = 1, .reusable = false}, SHIFT(1928),
  [5310] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5312] = {.count = 1, .reusable = false}, SHIFT(1929),
  [5314] = {.count = 1, .reusable = true}, SHIFT(1929),
  [5316] = {.count = 1, .reusable = false}, SHIFT(1930),
  [5318] = {.count = 1, .reusable = true}, SHIFT(1930),
  [5320] = {.count = 1, .reusable = false}, SHIFT(1931),
  [5322] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5326] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5328] = {.count = 1, .reusable = true}, SHIFT(1942),
  [5330] = {.count = 1, .reusable = true}, SHIFT(1951),
  [5332] = {.count = 1, .reusable = true}, SHIFT(1955),
  [5334] = {.count = 1, .reusable = true}, SHIFT(1956),
  [5336] = {.count = 1, .reusable = false}, SHIFT(1959),
  [5338] = {.count = 1, .reusable = true}, SHIFT(1959),
  [5340] = {.count = 1, .reusable = false}, SHIFT(1960),
  [5342] = {.count = 1, .reusable = true}, SHIFT(1960),
  [5344] = {.count = 1, .reusable = false}, SHIFT(1963),
  [5346] = {.count = 1, .reusable = true}, SHIFT(1963),
  [5348] = {.count = 1, .reusable = true}, SHIFT(1978),
  [5350] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5352] = {.count = 1, .reusable = false}, SHIFT(2235),
  [5354] = {.count = 1, .reusable = false}, SHIFT(2259),
  [5356] = {.count = 1, .reusable = false}, SHIFT(2260),
  [5358] = {.count = 1, .reusable = false}, SHIFT(2261),
  [5360] = {.count = 1, .reusable = false}, SHIFT(2262),
  [5362] = {.count = 1, .reusable = false}, SHIFT(2263),
  [5364] = {.count = 1, .reusable = false}, SHIFT(1980),
  [5366] = {.count = 1, .reusable = true}, SHIFT(1980),
  [5368] = {.count = 1, .reusable = true}, SHIFT(2316),
  [5370] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5372] = {.count = 1, .reusable = true}, SHIFT(1993),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5376] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5378] = {.count = 1, .reusable = false}, SHIFT(2005),
  [5380] = {.count = 1, .reusable = true}, SHIFT(2005),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2195),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2011),
  [5386] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5392] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5394] = {.count = 1, .reusable = false}, SHIFT(2419),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2425),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5400] = {.count = 1, .reusable = false}, SHIFT(2426),
  [5402] = {.count = 1, .reusable = false}, SHIFT(2427),
  [5404] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2427),
  [5408] = {.count = 1, .reusable = false}, SHIFT(2428),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5412] = {.count = 1, .reusable = false}, SHIFT(2433),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5416] = {.count = 1, .reusable = false}, SHIFT(2028),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2028),
  [5420] = {.count = 1, .reusable = false}, SHIFT(2029),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2029),
  [5424] = {.count = 1, .reusable = false}, SHIFT(2030),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2030),
  [5428] = {.count = 1, .reusable = false}, SHIFT(2031),
  [5430] = {.count = 1, .reusable = true}, SHIFT(2031),
  [5432] = {.count = 1, .reusable = false}, SHIFT(2032),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2032),
  [5436] = {.count = 1, .reusable = false}, SHIFT(2033),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2033),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5442] = {.count = 1, .reusable = false}, SHIFT(2418),
  [5444] = {.count = 1, .reusable = false}, SHIFT(2386),
  [5446] = {.count = 1, .reusable = false}, SHIFT(2387),
  [5448] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2027),
  [5451] = {.count = 1, .reusable = false}, SHIFT(2036),
  [5453] = {.count = 1, .reusable = true}, SHIFT(2036),
  [5455] = {.count = 1, .reusable = true}, SHIFT(2038),
  [5457] = {.count = 1, .reusable = false}, SHIFT(2039),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2039),
  [5461] = {.count = 1, .reusable = false}, SHIFT(2040),
  [5463] = {.count = 1, .reusable = true}, SHIFT(2040),
  [5465] = {.count = 1, .reusable = false}, SHIFT(2041),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2041),
  [5469] = {.count = 1, .reusable = false}, SHIFT(2042),
  [5471] = {.count = 1, .reusable = true}, SHIFT(2042),
  [5473] = {.count = 1, .reusable = false}, SHIFT(2046),
  [5475] = {.count = 1, .reusable = true}, SHIFT(2046),
  [5477] = {.count = 1, .reusable = false}, SHIFT(2047),
  [5479] = {.count = 1, .reusable = true}, SHIFT(2047),
  [5481] = {.count = 1, .reusable = false}, SHIFT(2048),
  [5483] = {.count = 1, .reusable = true}, SHIFT(2048),
  [5485] = {.count = 1, .reusable = false}, SHIFT(2049),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2049),
  [5489] = {.count = 1, .reusable = false}, SHIFT(2050),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2050),
  [5493] = {.count = 1, .reusable = false}, SHIFT(2051),
  [5495] = {.count = 1, .reusable = true}, SHIFT(2051),
  [5497] = {.count = 1, .reusable = false}, SHIFT(2052),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2052),
  [5501] = {.count = 1, .reusable = false}, SHIFT(2380),
  [5503] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5505] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5507] = {.count = 1, .reusable = false}, SHIFT(2430),
  [5509] = {.count = 1, .reusable = false}, SHIFT(2356),
  [5511] = {.count = 1, .reusable = false}, SHIFT(2432),
  [5513] = {.count = 1, .reusable = false}, SHIFT(2431),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5517] = {.count = 1, .reusable = false}, SHIFT(2053),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2053),
  [5521] = {.count = 1, .reusable = true}, SHIFT(2173),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5525] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5529] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5533] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5537] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2072),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2078),
  [5543] = {.count = 1, .reusable = true}, SHIFT(2080),
  [5545] = {.count = 1, .reusable = false}, SHIFT(2389),
  [5547] = {.count = 1, .reusable = true}, SHIFT(2389),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2095),
  [5551] = {.count = 1, .reusable = true}, SHIFT(2098),
  [5553] = {.count = 1, .reusable = false}, SHIFT(2411),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5557] = {.count = 1, .reusable = false}, SHIFT(2608),
  [5559] = {.count = 1, .reusable = false}, SHIFT(2476),
  [5561] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5565] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5567] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5571] = {.count = 1, .reusable = true}, SHIFT(2608),
  [5573] = {.count = 1, .reusable = false}, SHIFT(2409),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2591),
  [5577] = {.count = 1, .reusable = false}, SHIFT(2479),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5581] = {.count = 1, .reusable = false}, SHIFT(2480),
  [5583] = {.count = 1, .reusable = false}, SHIFT(2609),
  [5585] = {.count = 1, .reusable = false}, SHIFT(2410),
  [5587] = {.count = 1, .reusable = false}, SHIFT(1799),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2609),
  [5591] = {.count = 1, .reusable = false}, SHIFT(2610),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5595] = {.count = 1, .reusable = false}, SHIFT(2611),
  [5597] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5599] = {.count = 1, .reusable = false}, SHIFT(2115),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2115),
  [5603] = {.count = 1, .reusable = false}, SHIFT(2116),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2116),
  [5607] = {.count = 1, .reusable = false}, SHIFT(2117),
  [5609] = {.count = 1, .reusable = true}, SHIFT(2117),
  [5611] = {.count = 1, .reusable = false}, SHIFT(2118),
  [5613] = {.count = 1, .reusable = true}, SHIFT(2118),
  [5615] = {.count = 1, .reusable = false}, SHIFT(2119),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2119),
  [5619] = {.count = 1, .reusable = false}, SHIFT(2120),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2120),
  [5623] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2114),
  [5626] = {.count = 1, .reusable = false}, SHIFT(2121),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2121),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2122),
  [5632] = {.count = 1, .reusable = false}, SHIFT(2123),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2123),
  [5636] = {.count = 1, .reusable = false}, SHIFT(2124),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2124),
  [5640] = {.count = 1, .reusable = false}, SHIFT(2125),
  [5642] = {.count = 1, .reusable = true}, SHIFT(2125),
  [5644] = {.count = 1, .reusable = false}, SHIFT(2126),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2126),
  [5648] = {.count = 1, .reusable = false}, SHIFT(2129),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2129),
  [5652] = {.count = 1, .reusable = false}, SHIFT(2130),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2130),
  [5656] = {.count = 1, .reusable = false}, SHIFT(2131),
  [5658] = {.count = 1, .reusable = true}, SHIFT(2131),
  [5660] = {.count = 1, .reusable = false}, SHIFT(2132),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2132),
  [5664] = {.count = 1, .reusable = false}, SHIFT(2133),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2133),
  [5668] = {.count = 1, .reusable = false}, SHIFT(2134),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2134),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2135),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2135),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5678] = {.count = 1, .reusable = false}, SHIFT(2471),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5684] = {.count = 1, .reusable = false}, SHIFT(2474),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2452),
  [5690] = {.count = 1, .reusable = false}, SHIFT(2424),
  [5692] = {.count = 1, .reusable = false}, SHIFT(2136),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2136),
  [5696] = {.count = 1, .reusable = true}, SHIFT(2424),
  [5698] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5700] = {.count = 1, .reusable = true}, SHIFT(2443),
  [5702] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5704] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5706] = {.count = 1, .reusable = true}, SHIFT(2451),
  [5708] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5710] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5712] = {.count = 1, .reusable = false}, SHIFT(2585),
  [5714] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5716] = {.count = 1, .reusable = false}, SHIFT(2593),
  [5718] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5720] = {.count = 1, .reusable = false}, SHIFT(2594),
  [5722] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5724] = {.count = 1, .reusable = false}, SHIFT(2586),
  [5726] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5728] = {.count = 1, .reusable = false}, SHIFT(2595),
  [5730] = {.count = 1, .reusable = true}, SHIFT(2595),
  [5732] = {.count = 1, .reusable = false}, SHIFT(2596),
  [5734] = {.count = 1, .reusable = true}, SHIFT(2596),
  [5736] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5738] = {.count = 1, .reusable = false}, SHIFT(2504),
  [5740] = {.count = 1, .reusable = false}, SHIFT(2597),
  [5742] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5744] = {.count = 1, .reusable = false}, SHIFT(2598),
  [5746] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5748] = {.count = 1, .reusable = false}, SHIFT(2599),
  [5750] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5752] = {.count = 1, .reusable = false}, SHIFT(2600),
  [5754] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5756] = {.count = 1, .reusable = false}, SHIFT(2601),
  [5758] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5760] = {.count = 1, .reusable = false}, SHIFT(2602),
  [5762] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5764] = {.count = 1, .reusable = false}, SHIFT(2603),
  [5766] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5768] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5770] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5772] = {.count = 1, .reusable = false}, SHIFT(2587),
  [5774] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5776] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5778] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5780] = {.count = 1, .reusable = false}, SHIFT(2588),
  [5782] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5784] = {.count = 1, .reusable = false}, SHIFT(2589),
  [5786] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5788] = {.count = 1, .reusable = false}, SHIFT(2590),
  [5790] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5792] = {.count = 1, .reusable = false}, SHIFT(2500),
  [5794] = {.count = 1, .reusable = false}, SHIFT(2607),
  [5796] = {.count = 1, .reusable = false}, SHIFT(2606),
  [5798] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5800] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5802] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5804] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5806] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5808] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5810] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5812] = {.count = 1, .reusable = false}, SHIFT(2506),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5816] = {.count = 1, .reusable = false}, SHIFT(2228),
  [5818] = {.count = 1, .reusable = false}, SHIFT(2227),
  [5820] = {.count = 1, .reusable = true}, SHIFT(2235),
  [5822] = {.count = 1, .reusable = false}, SHIFT(2242),
  [5824] = {.count = 1, .reusable = false}, SHIFT(2243),
  [5826] = {.count = 1, .reusable = true}, SHIFT(2243),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5830] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2258),
  [5836] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5838] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5842] = {.count = 1, .reusable = false}, SHIFT(2275),
  [5844] = {.count = 1, .reusable = true}, SHIFT(2276),
  [5846] = {.count = 1, .reusable = false}, SHIFT(2277),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2283),
  [5850] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5852] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5854] = {.count = 1, .reusable = false}, SHIFT(2543),
  [5856] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5858] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2631),
  [5862] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2287),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5868] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2291),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2292),
  [5874] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5878] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5882] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22),
  [5884] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 22), SHIFT_REPEAT(2511),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5889] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5891] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2, .production_id = 44),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5895] = {.count = 1, .reusable = false}, SHIFT(2486),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5899] = {.count = 1, .reusable = false}, SHIFT(2488),
  [5901] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5903] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5905] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [5907] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5909] = {.count = 1, .reusable = false}, SHIFT(2489),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2509),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5915] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5917] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2632),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5927] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5929] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5931] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5933] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3, .production_id = 44),
  [5935] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5937] = {.count = 1, .reusable = false}, SHIFT(2565),
  [5939] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 44),
  [5941] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(2549),
  [5944] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5946] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5948] = {.count = 1, .reusable = false}, SHIFT(2572),
  [5950] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5952] = {.count = 1, .reusable = false}, SHIFT(2351),
  [5954] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5956] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5958] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5960] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5962] = {.count = 1, .reusable = false}, SHIFT(2359),
  [5964] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5966] = {.count = 1, .reusable = false}, SHIFT(2440),
  [5968] = {.count = 1, .reusable = false}, SHIFT(2442),
  [5970] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5972] = {.count = 1, .reusable = false}, SHIFT(2482),
  [5974] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5976] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5978] = {.count = 1, .reusable = false}, SHIFT(2484),
  [5980] = {.count = 1, .reusable = false}, SHIFT(2446),
  [5982] = {.count = 1, .reusable = false}, SHIFT(2447),
  [5984] = {.count = 1, .reusable = false}, SHIFT(2497),
  [5986] = {.count = 1, .reusable = false}, SHIFT(2498),
  [5988] = {.count = 1, .reusable = false}, SHIFT(2450),
  [5990] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5992] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 24),
  [5994] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 24),
  [5996] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 28),
  [5998] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 28),
  [6000] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 3),
  [6002] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3, .production_id = 60), SHIFT(2592),
  [6005] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 61),
  [6007] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [6009] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5, .production_id = 125),
  [6011] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2, .production_id = 5), SHIFT(2592),
  [6014] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [6016] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [6018] = {.count = 1, .reusable = true}, SHIFT(2401),
  [6020] = {.count = 1, .reusable = false}, SHIFT(2491),
  [6022] = {.count = 1, .reusable = false}, SHIFT(2493),
  [6024] = {.count = 1, .reusable = true}, SHIFT(2526),
  [6026] = {.count = 1, .reusable = true}, SHIFT(2545),
  [6028] = {.count = 1, .reusable = true}, SHIFT(2546),
  [6030] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6032] = {.count = 1, .reusable = false}, SHIFT(2548),
  [6034] = {.count = 1, .reusable = true}, SHIFT(2548),
  [6036] = {.count = 1, .reusable = true}, SHIFT(2560),
  [6038] = {.count = 1, .reusable = true}, SHIFT(2630),
  [6040] = {.count = 1, .reusable = true}, SHIFT(2561),
  [6042] = {.count = 1, .reusable = true}, SHIFT(2568),
  [6044] = {.count = 1, .reusable = true}, SHIFT(2613),
  [6046] = {.count = 1, .reusable = true}, SHIFT(2614),
  [6048] = {.count = 1, .reusable = true}, SHIFT(2628),
};

void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
